/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.Aether");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");

dojo.require("com.ibm.bpm.social.util.baseTextDirection.BidiTextBox");

dojo.declare(
	"com.ibm.bpm.social.Aether",
	[dijit._Widget, dijit._Templated],
	{
	
    templateString: "",
	
    templatePath: dojo.moduleUrl("com.ibm.bpm.social", "templates/Aether.html"),
	
	containerDivId : "aether",
	
    message: null,
	
	img_src: dojo.moduleUrl("dojo", "resources/blank.gif"),

	eventParam: null,

    timeout: 5000,
	
    timer: null,
		
	_container: null,
	
	positionOptions: ['top-left', 'top-center', 'top-right', 'bottom-left', 'bottom-center', 'bottom-right'],
	
	position: null,
	
	width: null,
	
	fade: true,
	
	displayCloseIcon: false,
	
	constructor: function(params){
		
		dojo.mixin(this, params);
		
		if(!this.position) this.position = 'center';
		
		this.createContainer();
			
	},
	
	createContainer: function(){
		if(dojo.byId(this.containerDivId)){
			this.container = dojo.byId(this.containerDivId);
			this.container.className = 'social-portal-notification '+this.position;
		} else {
			this.container = dojo.create('div', {
				'id': this.containerDivId,
				'class': 'social-portal-notification '+this.position
			}, dojo.body());
		}
	},
	
	createIconImage:function(){
		var image = document.createElement('img');
		image.src = this.img_src;
		dojo.addClass(image, "bpm-social-generic-system-avatar");
		this.icon.appendChild(image);
		
		if(this.eventParam){
			try{
				if(this.eventParam.process.instance.comment.author.id){
					dojo.addClass(image, "bpm-social-default-avatar-medium");
					dojo.removeClass(image, "bpm-social-generic-system-avatar");
					image.src = com.ibm.bpm.social.util.common.Util.getUserAvatarURL(this.eventParam.process.instance.comment.author.id);
				}
			} catch(e){}

		}

	},
	
    postCreate: function() {
		dojo.style(this.domNode, 'opacity', 0);
		dojo.place(this.domNode, this.container);
		dojo.anim(this.domNode, {opacity: 1}, 250);
		
		if(this.width){
			dojo.style(this.domNode, 'width', this.width + 'px');
		}

		if(this.displayCloseIcon===false){
			dojo.style(this.closeIcon, 'display', 'none');
		}
		
		if(this.img_src)	{
			this.createIconImage();
		}
		
		if(this.fade===true){
			this.setTimer();
		}
	},
	
	setTimer: function() {
		this.timer = setTimeout(dojo.hitch(this, 'close'), this.timeout);
	},
	
	_doMouseOver: function(e){
		clearInterval(this.timer);
		dojo.addClass(this.domNode, 'hover');
	}, 
	
	_doMouseOut:function(e){
		dojo.removeClass(this.domNode, 'hover');
		this.setTimer();
	},
	
	_doClick: function(e){
		/*
		if(this.displayCloseIcon===false){
			//Only close the notification on a message click if the close icon is not displayed
			this.close();
		}
		*/
	},

	_doIconMouseOver: function(e){
		dojo.addClass(this.closeIcon, 'hover');		
	},
	
	_doIconMouseOut: function(e){
		dojo.removeClass(this.closeIcon, 'hover');
	},
	
	_doIconClick: function(e){
		this.close();
	},
	
	fireEvent:function(){
		//	parent defined
		console.debug("This function needs to be implemented by the parent.");
	},

	_handleActionClick:function(event){		
		this.fireEvent(event.target.id,this.eventParam);
	},

	close: function(){
		dojo.anim(this.domNode,{opacity: 0}, 500, null, dojo.hitch(this, 'remove'));
	},
	
	remove: function(){
		dojo.anim(this.domNode,{height: 0, margin: 0}, 250, null, dojo.partial(dojo.destroy, this.domNode));
		//TODO Look at destroying container if last notification
	}
	
});