/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011, 2012. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.portal.DashboardDropdown");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.MenuSeparator");
dojo.require("com.ibm.bpm.social.widgets.common._RestWidget");
dojo.require("com.ibm.bpm.social.util.common.TaskRestHandler");
dojo.require("com.ibm.bpm.social.util.common.SystemRestHandler");

dojo.declare("com.ibm.bpm.social.portal.DashboardDropdown", [com.ibm.bpm.social.widgets.common._RestWidget,
                                                             dijit._Widget,
                                                             dijit._Templated], {

  templateString: "<div class=\"dashboard-dropdown\"/>",
  topic: "com.ibm.bpm.social.portal.DashboardDropdown.menuItemSelected",//only used inside this widget
  dropdownMenu: null,
  dropdownOpen: false,

  scoreboardMessageKeyMapping: {
    "scoreboard.MyPerf.name": "pmmyperformance",
    "scoreboard.MyTeamPerf.name": "pmmyteamperformance",
    "scoreboard.ProcPerf.name": "pmprocessperformance",
    "scoreboard.SLAView.name": "pmslaoverview",
    "Ad Hoc Reports": "adhocreports"
  },

  postCreate: function(){
    dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
    this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
    this.taskRestHandler = com.ibm.bpm.social.util.common.TaskRestHandler.getInstance();
    this.systemRestHandler = com.ibm.bpm.social.util.common.SystemRestHandler.getInstance();
    com.ibm.bpm.social.portal.DashboardDropdown.id = this.domNode.id;
    this._getExposedItems();
    var dashboardMenu = this._setMenuItems(com.ibm.bpm.social.portal.exposedItems["data"]);
    var node = dojo.byId("processPortalDashboardTabDropDownId");
    this.dropdownMenu = new com.ibm.bpm.social.portal.DropdownMenu({
      dropDown: dashboardMenu,
      dropDownContainer: this.domNode,
      _buttonNode: node,
      _popupStateNode: node,
      _aroundNode: node
    });
    this.dropdownMenu.startup();
    dojo.subscribe(this.topic, dojo.hitch(this, this.menuItemSelected));
    dojo.subscribe(this.topic, dojo.hitch(this, this.hide));
    this.dropdownMenu.loadDropDown();
    this.adjustDropdownStyle();

    this.connect(this.dropdownMenu.dropDownNode, "onblur", "hide");
    schuetza = this.dropdownMenu;
  },

  adjustDropdownStyle: function(){
    var node = dojo.byId("processPortalDashboardTabDropDownId_dropdown");
    if (node) {
      dojo.addClass(node, "processPortalDropDownMenu");
      dojo.addClass(node, "tundra");
    }
    // Move menu over to align with the left side of the gray column hover
    var nodes = dojo.query(".dijitMenuPopup");
    if (nodes && nodes[0]) {
      if (nodes[0]) {
        var attr = dojo.attr(nodes[0], "dijitpopupparent");
        if (attr && attr.indexOf("com_ibm_bpm_social_portal_DropdownMenu_") > -1) {
          if (document.body.dir != "rtl") {
            attr = dojo.style(nodes[0], "left");
            if (attr) {
              var num = parseInt(attr);
              if (num > 30) {
                num = num - 30;
                dojo.style(nodes[0], "left", num + "px");
                dojo.style(nodes[0], "top", "45px");
              }
            }
          }
          else {
            attr = dojo.style(nodes[0], "right");
            if (attr) {
              var num = parseInt(attr);
              if (num > 30) {
                num = num - 30;
                dojo.style(nodes[0], "right", num + "px");
                dojo.style(nodes[0], "left", "auto");
                dojo.style(nodes[0], "top", "45px");
              }
            }
          }
        }
      }
    }
  },

  _getExposedItems: function(){
    if (!com.ibm.bpm.social.portal.exposedItems) {
      com.ibm.bpm.social.portal.exposedItems = null;
      // dojo.xhrGet({
      // url: this.getProxyUrl()+"/rest/bpm/wle/v1/exposed",
      // handleAs: "json",
      // preventCache: true,
      // sync: true,
      // headers: {
      // "Content-Type": "application/json",
      // "Accept": "application/json"
      // },
      // load: function(data, xhrArgs){
      // com.ibm.bpm.social.portal.exposedItems = data;
      // }
      // });

      this.systemRestHandler.getExposedItems(function(data, xhrArgs){
        com.ibm.bpm.social.portal.exposedItems = data;
      }, dojo.hitch(this, this._onXhrErrors), false);
    }
  },

  _setMenuItems: function(data){
  
	//TEMPORARY
	//data["exposedItemsList"] = dojo.filter(data["exposedItemsList"], function(item){
	//	return item.display.indexOf("Process Performance")<0 && item.display.indexOf("Team Performance")<0; //TODO NLS-THIS
	//});
	//END TEMPORARY
	
    var dashboardMenu = new dijit.Menu();
    if (!com.ibm.bpm.social.portal.menuItems) {
      com.ibm.bpm.social.portal.menuItems = [];
      // 1. Add scoreboards
      //this._processMenuItems(data, dashboardMenu, "scoreboard");
      // 2. Add separator
      //dashboardMenu.addChild(new dijit.MenuSeparator());
      // 3. Add Dashboards
      this._processMenuItems(data, dashboardMenu, "dashboard");
      // 4. Add Ad Hoc Reports  - Changed to a newer dashboard, as it can be re-exposed by users at runtime
      //var display = "Ad Hoc Reports";
      //var runURL = window.location.protocol + "//" + window.location.host + "/portal/jsp/viewGeneratedReports.do";
      //this._addMenuItem(dashboardMenu, display, runURL);
    }
    return dashboardMenu;
  },

  _processMenuItems: function(data, dashboardMenu, typeArg){
    // If there is no tip but there are more than one snapshots then show the most recent snapshot.
    // If there is a tip then show it.
    // Disambiguate display names as needed.
    var items = [];
    var tipExistsForApp = {};
    var numDuplicateProcesses = {};
    var filteredItems = [];
    if(!data["exposedItemsList"]) {
      return;
    }
    // This loop collects data about the items. The data will enable us to decide which items to display and
    //   what the display name of an item should be.
    for ( var i = 0; i < data["exposedItemsList"].length; i++) {
      var item = data["exposedItemsList"][i];
      var itemMatchesType = false;
      if (typeArg == "scoreboard" && (item["type"] == "scoreboard")) {
        itemMatchesType = true;
      }
      else if (typeArg == "dashboard" && (item["type"] == "service" && item["subtype"] == "dashboard")) {
        itemMatchesType = true;
      }
      if (itemMatchesType) {
        filteredItems.push(item);
        //organize the items so we can tell if there are duplcates
        var itemID = item.itemID;
        var baseID = item.ID;
        // if the snapshotCreatedOn field doesn't exist, use ID
        var snapshotCreateDate = (item.snapshotCreatedOn) ? item.snapshotCreatedOn : baseID;

        if (typeof (tipExistsForApp[itemID]) == 'undefined') {
          tipExistsForApp[itemID] = {
            'tipExists': false,
            'baseID': baseID,
            'snapshotCreateDate': snapshotCreateDate
          };
        }
        if (item.tip) {
          tipExistsForApp[itemID].tipExists = true;
        }
        else {
          // save the most recent snapshot - if there is no tip, we will use the item with the highest ID as the tip
          if (tipExistsForApp[itemID].snapshotCreateDate < snapshotCreateDate) {
            tipExistsForApp[itemID].baseID = baseID;
            tipExistsForApp[itemID].snapshotCreateDate = snapshotCreateDate;
          }
        }
      }
    }
    // This loop determines if an item should be displayed -- it is displayed if it is a tip or if it is
    //   the most recent snapshot.  It also keeps track of duplicate names.
    for ( var i = 0; i < filteredItems.length; i++) {
      var item = filteredItems[i];
      var itemID = item.itemID;
      var baseID = item.ID;
      if ((tipExistsForApp[itemID].tipExists == true && item.tip == true) || tipExistsForApp[itemID].tipExists == false &&
        tipExistsForApp[itemID].baseID == baseID) {
        items.push(item);

        var title = item.display;
        // for scoreboards, use 'title' field if it exists
        if (item["type"] == "scoreboard" && (typeof item.title != "undefined" && item.title)) {
          title = item.title;
        }

        // track items by display name, so we can know if we need to disambiguate the display name
        //  we need to use itemID + snapshotID in order to distinguish between items
        var itemUniqueID = itemID + item.snapshotID;
        item["itemUniqueID"] = itemUniqueID;
        if (typeof (numDuplicateProcesses[title]) == 'undefined') {
          numDuplicateProcesses[title] = {
            'itemsArray': [item]
          }; // save the entire item
        }
        else {
          var idFound = false;
          for ( var j = 0; j < numDuplicateProcesses[title].itemsArray.length; j++) {
            if (itemUniqueID == numDuplicateProcesses[title].itemsArray[j].itemUniqueID) {
              idFound = true;
              break;
            }
          }

          if (!idFound) {
            numDuplicateProcesses[title].itemsArray.push(item);
          }
        }
      }
    }

    if (items && items.length > 0) {
      // This loop disambiguates names if necessary and adds items to the menu list.
      for ( var i = 0; i < items.length; i++) {
        var currentItem = items[i];
        var title = currentItem.display;
        // for scoreboards, use 'title' field if it exists
        if (item["type"] == "scoreboard" && (typeof currentItem.title != "undefined" && currentItem.title)) {
          title = currentItem.title;
        }
        var baseID = currentItem.ID;
        var itemID = currentItem.itemID;
        var appId = currentItem.processAppID;
        var itemUniqueID = currentItem["itemUniqueID"];
        //decide whether any additional identifying information should be displayed
        if (numDuplicateProcesses[title].itemsArray.length > 1) {
          //    Loop over items with the same title. If the items are in the same Process App/Toolkit but in a different track (also called branch or workspace)
          //    then add the branch name
          var useBranchName = false;
          var getTaskTemplate = false;
          for ( var x = 0; x < numDuplicateProcesses[title].itemsArray.length; x++) {
            // don't compare an item to itself!
            var arrayItem = numDuplicateProcesses[title].itemsArray[x];
            if (itemUniqueID != arrayItem.itemUniqueID) {
              if (itemID == arrayItem.itemID && appId == arrayItem.processAppID && currentItem.tip == true &&
                arrayItem.tip == true) {
                useBranchName = true;
              }
              else if (itemID != arrayItem.itemID && appId != arrayItem.processAppID) {
                getTaskTemplate = true;
              }
            }
          }
          if (useBranchName) {
            // disambiguate using branchName (if branchName doesn't exist - i.e., isn't even in the object -  or if it is null, use snapshotName)
            //  (we don't need to call REST for this information)
            var branchName =
              (typeof currentItem.branchName != "undefined" && currentItem.branchName) ? currentItem.branchName
                : currentItem.snapshotName;
            title = title + " (" + branchName + ")";
          }
          else if (getTaskTemplate) {
            // need to get more information for disambiguation
            this.taskTemplData = "";
			var myself=this;
			var async=false;
            this.taskRestHandler.getTaskTemplateDetails(baseID, function(data, xhrArgs){
              myself.taskTemplData = data;
            }, dojo.hitch(this, this._onXhrErrors), async);

            // this might be a process app or a toolkit
            var name1 = (myself.taskTemplData.processAppName) ? myself.taskTemplData.processAppName : myself.taskTemplData.topLevelToolkitName;
            title = title + " (" + name1 + ")";
          }
        }
        this._addMenuItem(dashboardMenu, title, currentItem["runURL"]);
      }
    }
  },

  _addMenuItem: function(dashboardMenu, display, runURL){
    if (display && runURL) {
      display = this._getDisplayName(display);
      var item = new dijit.MenuItem({
        label: display,
        onClick: this._menuItemClick,
        onKeyDown: this._menuKeyDown
      });
      dashboardMenu.addChild(item);
      com.ibm.bpm.social.portal.menuItems.push({
        "display": display,
        "id": item.id,
        "runURL": runURL
      });
    }
  },

  _onXhrErrors: function(data, xhrArgs){
    console.debug(["DashboardDropdown experienced an error.",
                   data,
                   xhrArgs]);
  },

  _getDisplayName: function(displayName){
    var msgKey = this.scoreboardMessageKeyMapping[displayName];
    if (msgKey && this.messages[msgKey]) {
      displayName = this.messages[msgKey];
    }
    return displayName;
  },

  _menuItemClick: function(evt){
    dojo.publish("com.ibm.bpm.social.portal.DashboardDropdown.menuItemSelected", [{
      display: evt.target.innerHTML,
      itemID: evt.currentTarget.id
    }]);
  },

  _menuKeyDown: function(evt){
    var keypressed = evt.charCode ? evt.charCode : evt.keyCode;
    if (keypressed == dojo.keys.ENTER || keypressed == dojo.keys.SPACE) {
      var target = evt.target;
      if (dojo.isIE) {
        target = evt.target.childNodes[1];
      }
      else {
        target = evt.target.childNodes[3];
      }
      dojo.publish("com.ibm.bpm.social.portal.DashboardDropdown.menuItemSelected", [{
        display: target.innerHTML,
        itemID: evt.currentTarget.id
      }]);
      return;
    }
  },

  menuItemSelected: function(msg){
    for ( var i in com.ibm.bpm.social.portal.menuItems) {
      var currentItem = com.ibm.bpm.social.portal.menuItems[i];
      if (msg.itemID == currentItem.id) {
        dojo.publish(com.ibm.bpm.social.portal.Topics.SHOW_DASHBOARD, [{
          runURL: currentItem.runURL,
          display: currentItem.display
        }]);
        break;
      }
    }
  },

  show: function(){
    if (this.dropdownMenu) {
      this.dropdownMenu.loadDropDown();
    }
    this.adjustDropdownStyle();
    this.dropdownOpen = true;
  },

  hide: function(){
    if (this.dropdownMenu) {
      this.dropdownMenu.closeDropDown(false);
    }
    this.dropdownOpen = false;
  },

  destroy: function(){
    if (this.dropdownMenu) {
      if (this.dropdownMenu.destroyRecursive) {
        this.dropdownMenu.destroyRecursive();
      }
      else if (this.dropdownMenu.destroy) {
        this.dropdownMenu.destroy();
      }
    }
    dojo.unsubscribe(this.topic);
    this.inherited(arguments);
  }

});

dojo.provide("com.ibm.bpm.social.portal.DropdownMenu");
dojo.require("dijit._Container");
dojo.require("dijit._HasDropDown");
dojo.require("dijit._Widget");
dojo.declare("com.ibm.bpm.social.portal.DropdownMenu", [dijit._Container,
                                                        dijit._HasDropDown,
                                                        dijit._Widget], {
  // summary:
  //		A menu drop down
  //
  // example:
  // |	<button dojoType="dijit.form.DropDownButton" label="Hello world">
  // |		<div dojotype="dijit.Menu">...</div>
  // |	</button>
  //
  // example:
  // |	var button1 = new dijit.form.DropDownButton({ label: "hi", dropDown: new dijit.Menu(...) });
  // |	dojo.body().appendChild(button1);
  //


  templateString: "",

  startup: function(){
    if (this._started) {
      return;
    }
    // the child widget from srcNodeRef is the dropdown widget.  Insert it in the page DOM,
    // make it invisible, and store a reference to pass to the popup code.
    if (!this.dropDown && this.dropDownContainer) {
      var dropDownNode = dojo.query("[widgetId]", this.dropDownContainer)[0];
      this.dropDown = dijit.byNode(dropDownNode);
      delete this.dropDownContainer;
    }
    if (this.dropDown) {
      dijit.popup.hide(this.dropDown);
    }


    this.inherited(arguments);
  },

  isLoaded: function(){
    // Returns whether or not we are loaded - if our dropdown has an href,
    // then we want to check that.
    var dropDown = this.dropDown;
    return (!!dropDown && (!dropDown.href || dropDown.isLoaded));
  },

  loadDropDown: function(){
    // Loads our dropdown
    var dropDown = this.dropDown;
    if (!dropDown) {
      return;
    }
    if (!this.isLoaded()) {
      var handler = dojo.connect(dropDown, "onLoad", this, function(){
        dojo.disconnect(handler);
        this.openDropDown();
        dropDown.focus();
      });
      dropDown.refresh();
    }
    else {
      this.openDropDown();
      dropDown.focus();
    }
  },

  isFocusable: function(){
    // Overridden so that focus is handled by the _HasDropDown mixin, not by
    // the _FormWidget mixin.
    return this.inherited(arguments) && !this._mouseDown;
  },

  focus: function(/*String*/position){
    // summary:
    //		Focuses this widget to according to position, if specified,
    //		otherwise on arrow node
    // position:
    //		"start" or "end"
    if (!this.disabled) {
      dijit.focus(position == "start" ? this.titleNode : this._popupStateNode);
    }
  }
});
