/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011, 2012. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/


window.bspaceSupportedLocales = "en,ar,cs,da,de,el,es,fi,fr,he,hu,it,ja,ko,nb,nl,no,pl,pt,pt-br,ro,ru,sk,sv,tr,zh,zh-tw";

dojo.require("dijit.layout.ContentPane");
dojo.require("com.ibm.bpm.social.portal.PageHandler");

/* Ensure that the dojo.locale is set to one of the supported locales to avoid errors */
function normalizeDojoLocale(){
  var loc = dojo.locale;
  var tmp = (',' + window.bspaceSupportedLocales).split(',');
  if (dojo.indexOf(tmp, loc) == -1) {
    if (loc.length > 2) {
      // check for language only version of current locale
      loc = loc.substring(0, 2);
      if (dojo.indexOf(tmp, loc) == -1) {
        // locale not found, use "en" as the default
        loc = 'en';
      }
    }
    else {
      // locale not found, use "en" as the default
      loc = 'en';
    }
  }
  dojo.locale = loc;
}

/*
 *	Note: IW is not in this list, as Mashups expects HE as the Hebrew locale abbreviation.  The user's preference will
 *	store IW as the preference for the user's preferred locale, for compatibility with Process Designer.
 *	The Process Portal theme will replace 'iw' with 'he' when it is encountered.
 */

if (!ppConfig) {
  var ppConfig = {
	portalContextRoot: window.endpointURLObject.processPortal,
	notificationContextRoot: window.endpointURLObject.processPortalNotification,
    portalContextRootJS: window.endpointURLObject.processPortalJS,
	notificationContextRootJS: window.endpointURLObject.processPortalNotificationJS
  };
}

var jspRootUri = ppConfig.portalContextRootJS + "/jsp/socialPortal/";
var pageMenu = null;
var userMenu = null;
var messages = null;

var locale = dojo.locale;
if ((locale.length > 2) && (locale.charAt(2) == '-')) {
  locale = locale.substring(0, 2) + '_' + locale.substring(3).toUpperCase();
}
document.documentElement.setAttribute('lang', locale);
document.documentElement.setAttribute('xml:lang', locale);
if ((locale == 'ar') || (locale == 'iw') || (locale == 'he') || (locale.substring(0, 2) == 'ar'))  {
  document.body.setAttribute('dir', 'rtl');
  dojo.addClass(document.body, "processPortal");
}


function systemInitOnLoad(){
  dojo.require("dojo.i18n");

  /** ** Retrieve custom locales, if defined *** */
  var customLocales = window.availableLocales;

  if (typeof (customLocales) != "undefined") {
    window.bspaceSupportedLocales = customLocales.replace("ROOT", "en").replace(" ", "");
  }

  // Ensure 'en' is in the list
  if (dojo.indexOf(window.bspaceSupportedLocales.split(","), "en") == -1) {
    window.bspaceSupportedLocales += ",en";
  }

  // PT is currently not listed in the available.locales list but it is supported.
  if (dojo.indexOf(window.bspaceSupportedLocales.split(","), "pt") == -1) {
    window.bspaceSupportedLocales += ",pt";
  }

  // Ensure 'en' is listed first in the list
  customLocales = window.bspaceSupportedLocales.split(",").sort();
  var enLoc = dojo.indexOf(customLocales, "en");
  customLocales.splice(enLoc, 1);
  customLocales.unshift("en");

  window.bspaceSupportedLocales = customLocales.join(",");
  /** ** End retrieve custom locales, if defined *** */


  normalizeDojoLocale();
  dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
  messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");

  var goToSpacesLink = dojo.byId("processPortalGoToSpacesLink");
  if (goToSpacesLink) {
    dojo.attr(goToSpacesLink, "title", messages.goToSpaces);
    dojo.attr(goToSpacesLink, "alt", messages.goToSpaces); //a11y
  }
  var help = dojo.byId("processPortalHelp");
  dojo.attr(help, "title", messages.bannerHelp);
  dojo.attr(help, "alt", messages.bannerHelp); //a11y
  if (dojo.hasClass(document.body, "dijit_a11y")) {
    help.innerHTML = "?";
    dojo.addClass(help, "processPortalIconA11y");
    if (goToSpacesLink) {
      goToSpacesLink.innerHTML = "&#9784";
      dojo.addClass(goToSpacesLink, "processPortalIconA11y");
    }
  }
  var urlIcon = dojo.byId("processPortalUrl");
  dojo.attr(urlIcon, "title", messages.showLink);
  dojo.attr(urlIcon, "alt", messages.showLink); //a11y
  if (dojo.hasClass(document.body, "dijit_a11y")) {
    urlIcon.innerHTML = "&#8734;";
    dojo.addClass(urlIcon, "processPortalIconA11y");
  }


  // set WAI labels for tabs
  dijit.setWaiState(dojo.byId("workPage"), "label", messages["workTab"]);
  dijit.setWaiState(dojo.byId("dashboardPage"), "label", messages["dashboardsTab"]);

  // hack for dojo dijit._editor.RichText.value textarea to not violate RPT scnas
  var rt = dojo.byId("dijit._editor.RichText.value");
  if (rt) {
    dijit.setWaiState(rt, "hidden", "true");
  }


  // Get the variable which states the environment we are in (bspace/advanced/standard)
  if (com.ibm.bspace.configuration.env != "bpm_adv") {
    try {
      dojo.byId("processPortalGoToSpacesLink").style.display = "none";
    }
    catch (e) {}
  }

  //read the coach trace setting from the config and set a cookie
  var coachTrace = window.coach.client.debugTrace;
  if (!!coachTrace && coachTrace != "null") {
    coachTrace = "&coachDebugTrace=" + coachTrace;
  }
  else {
    coachTrace = "";
  }
  dojo.cookie("com_ibm_bpm_coach_debug_logger", coachTrace, {});

  var h;
  if (dojo.isIE) {
    h = document.documentElement.offsetHeight - 90;
  }
  else {
    h = window.innerHeight - 90;
  }
  dojo.query(".processPortalContent").style("height", h + "px");

  var pageHandler = com.ibm.bpm.social.portal.PageHandler.getInstance();
  // set default landing page from user profile 
  pageHandler.showStartPage();

// This seems to be dead code since nobody publishes this event 
//  // Subscribe page switch request event
//  dojo.subscribe("com.ibm.bpm.socialPortal.RequestPageTabSwitchEvent", function(message){
//    var switchToPage = message.switchTo;
//    if (!!switchToPage) {
//      if (switchToPage == 'workPage') {
//        pageHandler.selectWorkTab();
//      }
//      else if (switchToPage == 'dashboardPage') {
//        pageHandler.selectDashboardsTab();
//      }
//    }
//  });


}

dojo.addOnLoad(systemInitOnLoad);


com.ibm.bpm.logout = function logout(){

  // disconnect from cometd server before logging out	
  window.logoutInProgress = true;
  if (!(dojo.isSafari && navigator.userAgent.match(/iPad/i))) { // If not Safari and iPad, allow CometD
    dojox.cometd.disconnect();
  }
  
  
  //remove the cookie WASReqURL by setting it expired
  var d = new Date();
  d.setTime(d.getTime() - 10000);
  window.document.cookie = "WASReqURL=/ProcessPortal; expires=" + d.toGMTString() + ";";

  dojo.require("dojo.cookie");
  dojo.cookie("com_ibm_bpm_bspace_logout", "true", {
    expires: 5,
    path: "/ProcessPortal/"
  });

  // also remove the restartDashboardCookie
  dojo.cookie("restartDashboardCookie", null, {expires: -1, path:'/'});

  // check for customized logout code
  if (window.customLogoutFunction) {
    try {
      window.customLogoutFunction();
    }
    catch (e) {
      // ignore exceptions and continue logout
    }
  }
  
  // Defect 161628 -- Dashboards can be erroneously resumed across login sessions 
  // because we do not log out of teamworks.
  dojo.xhrGet({
    sync: true,
    url: window.endpointURLObject.teamworks +"/ibm_security_logout?logout=Logout",
      handleAs: "text",
      load: function(data){},
      error: function(error){}
  });

  /*@ignore@*/
  // location.href = "/ProcessPortal/ibm_security_logout?logout=Logout&logoutExitPage=login.jsp";
  var form = document.createElement('form');
  form.action = window.endpointURLObject.processPortalJS +"/ibm_security_logout";
  form.method = "POST";
  var logout = document.createElement('input');
  logout.name = 'logout';
  logout.type = 'hidden';
  logout.value = 'Logout';
  form.appendChild(logout);
  var logoutExitPage = document.createElement('input');
  logoutExitPage.name = 'logoutExitPage';
  logoutExitPage.type = 'hidden';
  logoutExitPage.value = 'login.jsp';
  if (portalConfigLogoutExitPage && (portalConfigLogoutExitPage != 'login.jsp') && (portalConfigLogoutExitPage != 'null')) {
  	logoutExitPage.value = 'customLogoutRedirect.jsp';
  }
  form.appendChild(logoutExitPage);
  document.body.appendChild(form);
  form.submit();
  
  /*@end@*/
};


var profile = null;
var userid = null;
var taskid = null;


function checkForJavascriptVoid(event){
  var rc = true;
  if (dojo.isIE) {
    var node = event.srcElement;
    while (node && rc) {
      if (node.href && node.nodeName && (node.nodeName.toLowerCase() == 'a') &&
        (node.href.toLowerCase().indexOf('javascript:void') != -1)) {
        rc = false;
      }
      node = node.parentNode;
    }
  }
  return rc;
}

function theme_customLogoutFunction(){
  //Destroy the WorkViewContainer
  var c = dijit.byId("content");
  if (c && c.destroyRecursive) {
    c.destroyRecursive();
  }

  // clean up the PageHandler
  if (com.ibm.bpm.social.portal.PageHandler._instance) {
    com.ibm.bpm.social.portal.PageHandler._instance.destroy();
  }

  dojo.cookie("com_ibm_bpm_portal_unload", "true", {
    secure: true,
    expires: 1,
    path: "/mum/"
  });
}
window.customLogoutFunction = theme_customLogoutFunction;
dojo.connect(window, "onunload", theme_customLogoutFunction);

dojo.require("dojo.cookie");
dojo.cookie("com_ibm_bpm_portal_unload", null, {
  secure: true,
  expires: -1
});


var goToSpacesDialog = null;
function showGoToSpaces(evt){
  if (!goToSpacesDialog) {
    dojo.require("com.ibm.bpm.social.widgets.dialogs.GoToSpacesDialog");
    goToSpacesDialog = new com.ibm.bpm.social.widgets.dialogs.GoToSpacesDialog();
  }

  goToSpacesDialog.show();
}


var userDropdown = null;
function showUserDropdown(event){
  if (!userDropdown) {
    var div = document.createElement("div");
    dojo.byId("processPortalUserDropdownId").appendChild(div);
    userDropdown = new com.ibm.bpm.social.portal.UserDropdown({}, div);
  }
  userDropdown.toggle();
}


/* resizeDashboardIframe: Resizes the dashboard page's iframe to be 100% 
the height of its content.  If height is undefined, the iFrame will be sized to the window size.*/
function resizeDashboardIframe(height){
  try {
   	window.lastResizeDashboardIframeHeight = height;
    var scoreboardFrameVar = document.getElementById("scoreboardFrame");
    if (scoreboardFrameVar) {
      var windowHeight = dojo.isIE ? document.documentElement.clientHeight : window.innerHeight;
      windowHeight = Math.max(220, windowHeight - 75);
      var heightToUse = Math.max(windowHeight, height);
      dojo.style(scoreboardFrameVar, "height", heightToUse + "px");
      if (navigator.userAgent.indexOf("iPad") > -1) {
        var portalContent = document.getElementById("processPortalContent");
        if (portalContent) {
          dojo.style(portalContent, "height", heightToUse + "px");
          dojo.style(portalContent, "-webkit-overflow-scrolling", "touch");
          dojo.style(portalContent, "overflow", "scroll");
        }
      }
      setTimeout(function(){
        window.scrollTo(0, 0);
      }, 100);
    }
  }
  catch (err) {
    window.status = err.message;
  }
}

dojo.connect(window,'onresize',function() {
	if (window.lastResizeDashboardIframeHeight) {
		window.resizeDashboardIframe(window.lastResizeDashboardIframeHeight);
	}
});
