// SimpleMarkupUtils.js
//BEGIN COPYRIGHT
//*************************************************************************
//
// Licensed Materials - Property of IBM
// 5725-C94
// (C) Copyright IBM Corporation 2011, 2012. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
//*************************************************************************
//END COPYRIGHT
dojo.provide("com.ibm.bpm.social.util.common.SimpleMarkupUtils");

com.ibm.bpm.social.util.common.SimpleMarkupUtils._supportedTags = ["span","b"];

com.ibm.bpm.social.util.common.SimpleMarkupUtils.createSimpleMarkup = function(markup){
	var result = '';
	if(markup !== undefined && markup !== null) {
		var temp = '';
		var quote = '';
		var tag = false;
		var i = 0;
		while (i < markup.length) {
			var c = markup.charAt(i);
			switch (c) {
			case '<':
				if (quote) {
					temp = temp + c;
				} else {
					result = result + com.ibm.bpm.social.util.common.SimpleMarkupUtils._sanitize(temp);
					temp = c;
					tag = true;
				}
				break;
			case '>':
				temp = temp + c;
				if (tag && !quote) {
					result = result + com.ibm.bpm.social.util.common.SimpleMarkupUtils._checkTag(temp);
					temp = '';
					tag = false;
				}
				break;
			case '\'':
			case '\"':
				temp = temp + c;
				if (quote && (quote == c)) {
					quote = '';
				} else if (tag && !quote) {
					quote = c;
				}
				break;
			case '\\':
				temp = temp + c;
				i++;
				if (i < markup.length) {
					c = markup.charAt(i);
					temp = temp + c;
				}
				break;
			default:
				temp = temp + c;
			break;
			}
			i++;
		}
		if (temp) {
			result = result + com.ibm.bpm.social.util.common.SimpleMarkupUtils._sanitize(temp); 
		}
	}
	return result;
};

com.ibm.bpm.social.util.common.SimpleMarkupUtils._checkTag = function(tag) {
	var supported = false;
	var lc = tag.toLowerCase();
	for (i=0; i<com.ibm.bpm.social.util.common.SimpleMarkupUtils._supportedTags.length; i++) {
		var test = com.ibm.bpm.social.util.common.SimpleMarkupUtils._supportedTags[i];
		if (lc.indexOf('<'+test+' ') == 0) {
			supported = true;
			var tmp = document.createElement('div');
			tmp.innerHTML = tag + '</'+test+'>';
			tag = ('<'+test+' ');
			if (tmp.firstChild.className) {
				tag = tag + 'class="'+tmp.firstChild.className+'" ' + ' ';
			}
			if (tmp.firstChild.objid) {
				tag = tag + 'objid="'+tmp.firstChild.objid+'" ' + ' ';
			}
			tag = tag + '>';			
			delete tmp;
		}
		else if (lc.indexOf('<'+test+'>') == 0) {
			supported = true;
		}
		else if (lc.indexOf('<'+test+'/>') == 0) {
			supported = true;
		}
		else if (lc.indexOf('</'+test+' ') == 0) {
			supported = true;
		}
		else if (lc.indexOf('</'+test+'>') == 0) {
			supported = true;
		}
	}
	if (!supported) {
		tag = com.ibm.bpm.social.util.common.SimpleMarkupUtils._sanitize(tag);
	}	
	return tag;
}

com.ibm.bpm.social.util.common.SimpleMarkupUtils._sanitize = function(markup) {
	var div = document.createElement('div');
	var textNode = document.createTextNode(markup);
	div.appendChild(textNode);
	return div.innerHTML;
}
