// SystemRestHandler.js
// BEGIN COPYRIGHT
// *************************************************************************
//
// Licensed Materials - Property of IBM
// 5725-C96
// Copyright IBM Corporation 2011. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// *************************************************************************
// END COPYRIGHT

dojo.provide("com.ibm.bpm.social.util.common.SystemRestHandler");

dojo.require("dojo.string");

dojo.require("com.ibm.bpm.social.util.common.RestHandler");
dojo.require("com.ibm.bpm.social.util.common.Log");

dojo.declare("com.ibm.bpm.social.util.common.SystemRestHandler", com.ibm.bpm.social.util.common.RestHandler, {

  constructor: function constructor_OtherRestHandler(params){},
  
  /**
   *
   * @param load
   * @param error
   * @param async
   * @param systemID
   * @returns {void} nothing
   */
  getExposedItems: function getExposedItems_OtherRestHandler(load, error, async, systemID) {
	var url = "/exposed";
	
	url = this.addSystemID(url, systemID);
	
	this.performRequest("get", {
		url: url,
		sync: !async,
		load: load,
		error: error
	});
  },
  
  
  statics: {
    _instance: null,

    _createInstance: function _createInstance_OtherRestHandler(params){
      if (this._instance === null) {
        this._instance = new com.ibm.bpm.social.util.common.SystemRestHandler();
        com.ibm.bpm.social.util.common.Log.logObject(1, params, "params: ");
        // TODO handle params, e.g. 
//          this._instance.setIWidget(iWidget);
//          this._instance.setUrl("prefix", this.getServiceURLRoot());
//          this._instance.setUrl("userImageServicePrefix", this.getServiceEndpoint("userImageServiceUrlRoot"));
//          this._instance.vmmPrefix = this.getServiceEndpoint("vmmServiceUrlRoot");
      }
      else {
        // programming error
        var error = new Error("RestHandler instance has already been initialized!");
        com.ibm.bpm.social.util.common.Log.consoleError(error.message);
        throw error;
      }
      return this._instance;
    },

    _getInstance: function _getInstance_SystemRestHandler(){
      if (this._instance === null) {
        // TODO for now return default handler
        this._instance = new com.ibm.bpm.social.util.common.SystemRestHandler();
//        // programming error
//        var error = new Error("RestHandler instance must be initialized using 'createInstance'!");
//        com.ibm.bpm.social.util.common.Log.consoleError(error.message);
//        throw error;
      }
      return this._instance;
    }
  }
});

com.ibm.bpm.social.util.common.SystemRestHandler.createInstance = function(params){
  return com.ibm.bpm.social.util.common.SystemRestHandler.prototype.statics._createInstance();
};

com.ibm.bpm.social.util.common.SystemRestHandler.getInstance = function(){
  return com.ibm.bpm.social.util.common.SystemRestHandler.prototype.statics._getInstance();
};