dojo.provide("com.ibm.bpm.social.util.ui.userchooser.models.AbstractModel");

dojo.require("com.ibm.bpm.social.util.ui.userchooser.util.RestClient");

dojo.declare( "com.ibm.bpm.social.util.ui.userchooser.models.AbstractModel", null,
{
  constructor: function()
  {
    //this._log("constructor()");
  },
  
  
  /**
   * Searchs some repository for searchText value and returns the specified page.
   * <p>
   * Subclasses may override.
   * 
   * @return {cn,userID}[]
   */
  query: function( /*String*/ searchText, /*int*/ offset, /*int*/ size ) /*{cn,userID}[]*/
  {
    return [];
  },
  
  
  /**
   * Here can return some initial suggestion, not necessarily bsacked up by VMM.
   * e.g., [{cn:"One",userID:1}, {cn:"Two",userID:2}, {cn:"Three",userID:3}]
   * <p>
   * Subclasses may override.
   * 
   * @param size The maximum number of suggestions.
   * @return {cn,userID}[]
   */
  getInitialSuggestions: function( /*int*/ size ) /*{cn,userID}[]*/
  {
    return [];
  },

  
  _removeWildcards: function( /*String*/ s ) /*String*/
  {
    var cleaned = new String();
    for(var i=0; i<s.length; i++) 
    {
      var c = s.charAt(i);
      if (c!="*")
      {
        cleaned += c;
      }
    }
    return cleaned;
  },  


  _log: function( message )
  {
    console.log( "AbstractModel: " + message );
  }  
}
);
