/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011, 2012. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.bpm.social.util.ui.userchooser.models.BPMModel");

dojo.require("com.ibm.bpm.social.util.ui.userchooser.models.AbstractModel");
dojo.require("com.ibm.bpm.social.util.ui.userchooser.util.RestClient");

dojo.declare( "com.ibm.bpm.social.util.ui.userchooser.models.BPMModel", com.ibm.bpm.social.util.ui.userchooser.models.AbstractModel,
{
  _tasksIds: null,
  _initialSuggestions: null,
  
  constructor: function( /*{bpmServiceRoot: String, includeGroups: boolean, includeUsers: boolean}*/ params )
  {
    //this._log("constructor()");
    this._includeGroups = params.includeGroups ? (params.includeGroups == true) : false;	// Default false
    this._includeUsers = (params.includeUsers != null && params.includeUsers != undefined) 
    							? (params.includeUsers == true) 
    							: true;	// Default true
    this._restClient = new com.ibm.bpm.social.util.ui.userchooser.util.RestClient(params.bpmServiceRoot, null);
  },
  
  
  query: function( /*String*/ searchText, /*int*/ offset, /*int*/ size, /*int*/ assignTaskidFilter, /*int*/ collabTaskidFilter, /*boolean*/ namesonly ) /*{cn,userID}[]*/
  {
    return this._restClient.searchBPMByName( searchText, offset, size, this._includeGroups, this._includeUsers, assignTaskidFilter, collabTaskidFilter, namesonly );
  },
  
  getInitialSuggestions: function( /*int*/ size, /*int*/ assignTaskidFilter, /*int*/ collabTaskidFilter, /*boolean*/ namesonly  ) /*{cn,userID}[]*/
  {
	if (!this._initialSuggestions) {
		this._initialSuggestions = new Object();
	}
	var key = size + "_" + assignTaskidFilter + "_" + collabTaskidFilter;
	if (!this._initialSuggestions[key]) {
		this._initialSuggestions[key] = this._restClient.searchBPMByName( "*", 0, size, this._includeGroups, this._includeUsers, assignTaskidFilter, collabTaskidFilter, namesonly );	
	}
	var rc = new Array();
	for (var i=0; i<this._initialSuggestions[key].length; i++) {
		rc[i] = this._initialSuggestions[key][i];
	}
	return rc;
  },

  _log: function( message )
  {
    console.log( "BPMModel: " + message );
  }  
}
);
