dojo.provide("com.ibm.bpm.social.util.ui.userchooser.models.OCFakeModel");

dojo.require("com.ibm.bpm.social.util.ui.userchooser.models.AbstractModel");

//
// Simple model that "invents" matches in the desired window.
//
dojo.declare( "com.ibm.bpm.social.util.ui.userchooser.models.OCFakeModel", com.ibm.bpm.social.util.ui.userchooser.models.AbstractModel,
{
  _MAX_ITEMS: 10000,
  
  
  /**
   * @param searchText A not nullable and possible empty string.
   * @param offset A not nullable integer >=0.
   * @param size A not nullable integer >=0.
   * @return The items that verify the query (filter in this case) and that fall in the specified pagination window.
   */
  query: function( /*String*/ searchText, /*int*/ offset, /*int*/ size ) /*{cn,userID}[]*/
  {
    // Remove wildcards
    searchText = this._removeWildcards(searchText).toUpperCase();

    // Filter.
    var matcher = function(x) 
    {
      return (x && x.cn) ? (x.cn.toUpperCase().indexOf(searchText) != -1) : false;
    }
    
    // Invent data.
    var filtered = this._getItems( offset, size, matcher );

    return filtered;
  },
  
  
  _getItems: function( /*int*/ offset, /*int*/ size, matcher ) /*{cn,userID}[]*/
  {
    // Define default values.
    if (!size)
    {
      size = 30;
    }
    if (!offset)
    {
      offset = 0;
    }
    
    var options = [];
    var matchedIndex = 0;
    for (i=0; options.length<size && i<this._MAX_ITEMS; i++)
    {
      var item = {cn:i + "_FakeUser", userID:i};
      //this._log("Testing " + dojo.toJson(item));
      if( matcher(item) )
      {
        //this._log("  Matched");
        if ( matchedIndex >= offset )
        {
          //this._log("  In window");
          options.push(item);
        }
        matchedIndex++;
      }
    }
    
    return options;
  },

  
  _log: function( message )
  {
    console.log( "OCFakeModel: " + message );
  }  
}
);
