/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011, 2012. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.widgets.ActionDropDownMenu");

dojo.require("dijit.Menu");

dojo.declare(
	"com.ibm.bpm.social.widgets.ActionDropDownMenu",
	[dijit.Menu],
	{

    /**
     * Override _scheduleOpen to allow positioning of popup below the
     * anchor in same place each time.
     */
        _scheduleOpen: function(/*DomNode?*/ target, /*DomNode?*/ iframe, /*Object?*/ coords){
            // summary:
            //		Set timer to display myself.  Using a timer rather than displaying immediately solves
            //		two problems:
            //
            //		1. IE: without the delay, focus work in "open" causes the system
            //		context menu to appear in spite of stopEvent.
            //
            //		2. Avoid double-shows on linux, where shift-F10 generates an oncontextmenu event
            //		even after a dojo.stopEvent(e).  (Shift-F10 on windows doesn't generate the
            //		oncontextmenu event.)

            var c = dojo.position(target);
            if (document.body.dir !== "rtl") {
                coords = {
                    x: c.x+1,
                    y: c.y+17,
                    h: c.h,
                    w: c.w
                };
            } else {
                coords = {
                    x: c.x+15,
                    y: c.y+17,
                    h: c.h,
                    w: c.w
                };
            }
            if(!this._openTimer){
                this._openTimer = setTimeout(dojo.hitch(this, function(){
                    delete this._openTimer;
                    this._openMyself({
                        target: target,
                        iframe: iframe,
                        coords: coords
                    });
                }), 1);
            }
        }
});
