/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011, 2012. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.widgets.details.InstanceDetails");

dojo.require("dijit._Templated");

dojo.require("com.ibm.bpm.social.widgets.common._RestWidget");

dojo.require("dijit.Menu");

dojo.require("dijit.form.Button");

dojo.require("com.ibm.bpm.social.portal.Topics");

dojo.require("com.ibm.bpm.social.widgets.details.TaskDetailsListItem");

dojo.require("com.ibm.bpm.social.widgets.dialogs.ChangeDueDateDialog");

dojo.require("com.ibm.bpm.social.widgets.dialogs.AuditHistoryDialog");

dojo.require("com.ibm.bpm.social.widgets.dialogs.CriticalPathDialog");

dojo.require("com.ibm.bpm.social.widgets.task.list.TaskRow");

dojo.require("com.ibm.bpm.social.util.common.Util");

dojo.require("com.ibm.bpm.social.util.common.ProcessRestHandler");
dojo.require("com.ibm.bpm.social.util.common.SocialRestHandler");
dojo.require("com.ibm.bpm.social.util.baseTextDirection.BidiTextBox");

dojo.declare("com.ibm.bpm.social.widgets.details.InstanceDetails", [com.ibm.bpm.social.widgets.common._RestWidget,
                                                                    dijit._Templated], {

  templateString: "",
  templatePath: dojo.moduleUrl("com.ibm.bpm.social.widgets.details", "templates/InstanceDetails.html"),
  sidebar: false,
  instanceId: null,
  followed: false,
  fullWidth: 0,
  instanceData: null,
  counter: 0,
  handle: null,
  taskDetailsItems : null,

  //Enclosed dijit widgets
  menu: null,
  dropdownButton: null,
  processActionsAvailable: false,
  taskDetailsListItems: null,

  //JSP URLs
  //auditTrailUrl: "/portal/jsp/processAudit.do?bpdInstanceId={iid}",
  //criticalPathUrl: "/portal/jsp/criticalPath.do?cpType=2&bpdInstanceId={iid}",
  instanceDataUrl: window.endpointURLObject.bpmRest +"/v1/process/{piid}?parts=header%7Cdata",
  instanceFollowingUrl: window.endpointURLObject.bpmRest +"/v1/social/instance/{piid}/following",

  postCreate: function(){
    this.taskDetailsItems = new Array();
    dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
    this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
    dojo.requireLocalization("com.ibm.bpm.social", "bpmTask");
    this._nlsResources = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmTask");
    
	this.ie8message.innerHTML = this._nlsResources.ie8message;
	this.ie8messageIcon.src = dojo.moduleUrl("dojo", "resources/blank.gif");
	
    dojo.attr(this.instanceDetailsDiv, "aria-label", this.messages.details);

    this.socialRestHandler = com.ibm.bpm.social.util.common.SocialRestHandler.getInstance();
    this.processRestHandler = com.ibm.bpm.social.util.common.ProcessRestHandler.getInstance();

    this.followedAnchor.title = this.messages.notFollowing;

    this.diagramLinkImg.src = dojo.moduleUrl("dojo", "resources/blank.gif");
    // RPT: Image alt text must not be redundant with adjacent link text
    // this.diagramLinkImg.alt = this.messages.viewProcessDiagram;  

    if (this.sidebar) {
      dojo.addClass(this.domNode, 'sidebar');
      dojo.place(this.followedAnchor, this.instanceName, "before");
    }

    dojo.subscribe(com.ibm.bpm.social.portal.Topics.PROCESS_ACTIONS_AVAILABLE, dojo.hitch(this,
      this._processActionsAvailable));

    if (this.instanceId != null) {
      this._getInstanceDetails();
    }

    //Add Instance Due Date to header with optional overdue icon
    this.dueDateLabel.innerHTML = this.messages.due.replace("${date}", "");
    this.dueDateLabel.id = 'dueDateLabel_' + this.get("id");
    this.dueDateValue['aria-labelledby'] = 'dueDateLabel_' + this.get("id");

    this.dueDateOverdue.src = dojo.moduleUrl("dojo", "resources/blank.gif");
    this.dueDateOverdue.alt = this.messages.overdue;

  },

  refresh: function(obj){
    if (!(obj.instanceId)) {
      return;
    }
    this.instanceId = obj.instanceId;
    this.processActionsAvailable = false;
    this._clearTaskDetailsItems();
    this._getInstanceDetails();
  },
  
  _clearTaskDetailsItems: function() {
		dojo.forEach(this.taskDetailsItems , function(ti){
			if(ti.destroy){
				ti.destroy();
			}
		});
		// Do not destroy the task details items several times.
		this.taskDetailsItems  = new Array();		
  },

  _getInstanceDetails: function(){

    this.processRestHandler.getProcess(this.instanceId, dojo.hitch(this, "_loadInstanceDetails"), dojo.hitch(this,
      "_xhrErrors"), true, "header%7Cdata");
  },

  _loadInstanceDetails: function(data, xhrArgs){

    this.instanceData = data;

    //Apply styles
    this.fullWidth = dojo.style(this.domNode, "width") - 20;
    if (!this.sidebar) {
      //dojo.style(this.headerWrapper, "width", this.fullWidth+"px"); //Account for 100% width with padding
      dojo.style(this.instanceName, "maxWidth", Math.max(0, (this.fullWidth - 70)) + "px"); //Buffer for long instance names
    }

    dojo.connect(window, "onresize", this, dojo.hitch(this, function(){
      this.fullWidth = dojo.style(this.domNode, "width") - 20;
      if (!this.sidebar) {
        //dojo.style(this.headerWrapper, "width", this.fullWidth+"px"); //Account for 100% width with padding
        dojo.style(this.instanceName, "maxWidth", Math.max(0, (this.fullWidth - 70)) + "px"); //Buffer for long instance names
      }
    }));

    //Update header information
    var text = com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.applyUCCToText(data.name);
    this.instanceName.innerHTML = text;
    this.instanceName.title = text;

    if (typeof data.dueDate != "undefined" && data.dueDate != null) {
      this.dueDateValue.innerHTML = this._determineDueDate(data.dueDate);
      if (this.dueDateValue.innerHTML == this.messages.today || this.dueDateValue.innerHTML == this.messages.yesterday ||
        this.dueDateValue.innerHTML == this.messages.tomorrow) {
        this.dueDateValue.title = com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatDate(data.dueDate, {
          formatLength: "long"
        });
      }

      var now = new Date();
      var due = dojo.date.stamp.fromISOString(data.dueDate);

      if (dojo.date.compare(now, due) >= 0) {
        dojo.addClass(this.domNode, "overdue");
      }
      else {
        dojo.removeClass(this.domNode, "overdue");
      }
    }
    else {
      this.dueDateValue.innerHTML = "";
    }

    this._getInstanceFollowed();

    //Update business data information
    if (data.businessData) {

      dojo.empty(this.bizDataWrapper);

      var btdpref = com.ibm.bpm.social.util.common.Util.getBTDUserPreference();
      for ( var item in data.businessData) {
        var value = data.businessData[item].value;
        if (typeof data.businessData[item].value != "undefined" && data.businessData[item].value !== null &&
          data.businessData[item].value !== "") {
          var bd = dojo.create("div", {
            "class": "bizDataItem",
            "wairole": "label",//RPT violation: Elements that use a 'role' must reference a valid WAI-ARIA role
            "tabindex": "0"
          }, this.bizDataWrapper);
          this._setBidiLangDir(bd);
          var title = "";
          if (data.businessData[item].alias) {
            title = data.businessData[item].alias.toLowerCase();
          }
          else if (data.businessData[item].name) {
            title = data.businessData[item].name;
          }

          var span = dojo.create("span", {
            "class": "bizDataItemLabel",
            innerHTML: data.businessData[item].label,
            "wairole": "label",//RPT violation: Elements that use a 'role' must reference a valid WAI-ARIA role
            "title": title
          }, bd);
          this._setDirAttribute(btdpref, data.businessData[item].label, span);
          span = null;
          dojo.create("span", {
            "class": "bizDataItemSeparator",
            innerHTML: this.messages.colon_separator
          }, bd);
          var formattedValue = value;
          var type = data.businessData[item].type;
          var applyBTD = false;
          switch (type) {
            case com.ibm.bpm.social.widgets.task.list.TaskRow.BD_DATE_TYPE :
            case com.ibm.bpm.social.widgets.task.list.TaskRow.BD_TIME_TYPE :
              formattedValue = com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatDate(value);
              applyBTD = true;
              break;
            case com.ibm.bpm.social.widgets.task.list.TaskRow.BD_DECIMAL_TYPE :
            case com.ibm.bpm.social.widgets.task.list.TaskRow.BD_INTEGER_TYPE :
              formattedValue = com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatNumber(value);
              break;
            case com.ibm.bpm.social.widgets.task.list.TaskRow.BD_BOOLEAN_TYPE :
              formattedValue =
                (value ? this._nlsResources["task-row-details-boolean-true"]
                  : this._nlsResources["task-row-details-boolean-false"]);
              break;
            default:
              formattedValue = null;
              var valueParts = value.toString().split("\n");
              for ( var i = 0; i < valueParts.length; i++) {
                if (i == 0) {
                  dojo.create("span", {
                    innerHTML: "&nbsp;"
                  }, bd);
                }
                var span = document.createElement("span");
                span.innerHTML = valueParts[i];
                this._setDirAttribute(btdpref, valueParts[i], span);
                bd.appendChild(span);
                if (i + 1 != valueParts.length) {
                  bd.appendChild(document.createElement("br"));
                }
                span = null;
              }
              break;
          }
          if (formattedValue != null) {
            dojo.create("span", {
              innerHTML: "&nbsp;"
            }, bd);
            var span = dojo.create("span", {
              "class": "bizDataItemValue",
              "title": formattedValue,
              "innerHTML": formattedValue
            }, bd);
            if (applyBTD) {
              this._setDirAttribute(btdpref, formattedValue, span);
            }
            span = null;
          }
        }
      }
    }

    //Update process diagram link
    // RPT: Image alt text must not be redundant with adjacent link text
    // this.diagramLinkImg.alt = this.messages.viewProcessDiagram;
    this.diagramLinkText.innerHTML = this.messages.viewProcessDiagram;

    //Update task details list
    if (data.tasks) {

      // Delete all children (widgets and nodes) of this.taskDetailsList 
      while (this.taskDetailsList.firstChild) {
        var cList = this.taskDetailsList.firstChild;
        while (cList.firstChild) {
          var cTaskDetails = cList.firstChild;
          var cTaskDetailsWidget = dijit.byId(cTaskDetails.id);
          if (cTaskDetailsWidget && cTaskDetailsWidget.destroy) {
            cTaskDetailsWidget.destroy();
          }
          else {
            cList.removeChild(cTaskDetails);
            delete cTaskDetails;
          }
        }
        this.taskDetailsList.removeChild(cList);
        delete cList;
      }

      //Sort tasks in reverse order by dueDate
      data.tasks.sort(function(a, b){
        var ad = new Date(a.dueTime);
        var bd = new Date(b.dueTime);
        return bd - ad;
      });

      this.taskDetailsHeader.innerHTML = this.messages.tasks;
      this.taskDetailsHeader.id = "taskDetailsHeader_" + this.get("id");
      this.taskDetailsList['aria-labelledby'] = "taskDetailsHeader_" + this.get("id");
      dojo.attr(this.taskDetailsWrapper, "aria-labelledby", this.taskDetailsHeader.id);

	  var onlineTrackingItems = [];
	  
      if(!this.taskDetailsListItems) {
          this.taskDetailsListItems = new Array();
      } else {
        for(var i=0; i < this.taskDetailsListItems.length; i++) {
          this.taskDetailsListItems[i].destroy();
        }
        this.taskDetailsListItems = new Array();
      }
      for ( var item in data.tasks) {
        var describedby = "";
        var li = dojo.create("li", {}, this.taskDetailsList);

        var tdli = new com.ibm.bpm.social.widgets.details.TaskDetailsListItem({
          taskId: data.tasks[item].tkiid,
          taskName: data.tasks[item].name,
          taskDisplayName: data.tasks[item].displayName,
          taskAssignee: data.tasks[item].assignedTo,
          taskAssigneeDisplayName: data.tasks[item].assignedToDisplayName,
          taskOwner: data.tasks[item].owner,
          taskOwnerDisplayName: data.tasks[item].ownerDisplayName,
          taskStarted: data.tasks[item].startTime,
          taskCompleted: data.tasks[item].completionTime,
          taskDue: data.tasks[item].dueTime,
          taskStatus: data.tasks[item].status,
          sidebar: this.sidebar
        }, dojo.create("div", {}, li));
		
		var onlineTracking = tdli.getOnlineTracking();
		if (onlineTracking != null) {
			onlineTrackingItems.push(onlineTracking);
		}
		this.taskDetailsItems.push(tdli);

        this.taskDetailsListItems.push(tdli);
        describedby = describedby + "taskOwner_" + data.tasks[item].tkiid + " ";
        describedby = describedby + "taskStarted_" + data.tasks[item].tkiid + " ";
        describedby = describedby + "taskCompleted_" + data.tasks[item].tkiid + " ";
        describedby = describedby + "taskDue_" + data.tasks[item].tkiid;
        dojo.attr(tdli.domNode, "aria-describedby", describedby);
      }
	  
	  if (onlineTrackingItems.length > 0) {
		dojox.cometd.batch(function() {
			for(var i = 0; i < onlineTrackingItems.length; i++) {
				// Subscribe to appropriate channels
				onlineTrackingItems[i].activate();
			}
		});
	  }
    }

    if (!this.sidebar) {
      //Only show actions drop down when viewed in Instance Details page and not Task Completion sidebar.
      this._updateActionsDropdown();
    }

  },

  /*
   * Determine whether to show due date, Today, Tomorrow, or Yesterday.
   * Same pattern as used by TasksListController.js::_addCategories with less outcomes 
   */

  _determineDueDate: function(d){

    var result = com.ibm.bpm.social.util.common.Util.formatDate(d);
    var now = new Date();
    var endToday = new Date(now);
    endToday.setHours(23, 59, 59, 0);
    var endTom = dojo.date.add(endToday, "day", 1);

    var startToday = new Date(now);
    startToday.setHours(0, 0, 0, 0);

    var startYest = dojo.date.add(now, "day", -1);
    startYest.setHours(0, 0, 0, 0);

    var due = dojo.date.stamp.fromISOString(d);

    if (dojo.date.compare(now, due) >= 0) {
      dojo.addClass(this.domNode, "overdue");
    }
    else {
      dojo.removeClass(this.domNode, "overdue");
    }

    /*
    console.debug("***Check for Today;")
    console.debug("dojo.date.compare(due, startToday) >= 0: ",dojo.date.compare(due, startToday) >= 0);
    console.debug("dojo.date.compare(endToday, due) > 0: ",dojo.date.compare(endToday, due) > 0 );
    
    console.debug("***Check for Tomorrow");
    console.debug("dojo.date.compare(due, endToday) >= 0: ", dojo.date.compare(due, endToday) >= 0);
    console.debug("dojo.date.compare(endTom, due) > 0: ",dojo.date.compare(endTom, due) > 0);
    
    console.debug("***Check for Yesterday");
    console.debug("dojo.date.compare(due, startYest) >= 0: ",dojo.date.compare(due, startYest) >= 0);
    console.debug("dojo.date.compare(startToday, due) > 0: ", dojo.date.compare(startToday, due) > 0);
    */

    if (dojo.date.compare(due, startToday) >= 0 && dojo.date.compare(endToday, due) > 0) {
      result = this.messages.today;
    }
    else if (dojo.date.compare(due, endToday) >= 0 && dojo.date.compare(endTom, due) > 0) {
      result = this.messages.tomorrow;
    }
    else if (dojo.date.compare(due, startYest) >= 0 && dojo.date.compare(startToday, due) > 0) {
      result = this.messages.yesterday;
    }

    return result;
  },

  /*
  _formatDate: function(str){
    var date,d1,t1;
    
    str = str.replace("Z", ".000+0000");
    date = com.ibm.bpm.social.util.common.Util.getDateFromString(str);
    
    d1 = dojo.date.locale.format(date, {formatLength: "long", selector: "date"});
    t1 = dojo.date.locale.format(date, {formatLength: "short", selector: "time"});

    return d1; //d1+" "+t1
  },
  */

  _updateActionsDropdown: function(){

    var _dd = com.ibm.bpm.social.widgets.ActionDropDownHelper.getInstance();

    this.menu = _dd.createDropDown(this.dropdownWrapper);

    _dd.addProcessActions(this.menu, this.instanceData, {
      'modifyInstance': dojo.hitch(this, this._launchChangeDueDateDialog),
      'viewProcessDiagram': dojo.hitch(this, this._viewProcessDiagram)
    }, /* dialog = */false, /* omitViewInstance = */true, /* omitProcessDiagram = */true);

  },

  _processActionsAvailable: function(data){
    if ((data.standardActions && data.standardActions.length > 0) || (data.actions && data.actions.length > 0)) {
      if (this.processActionsAvailable == false) {
        if (data.standardActions != null &&
          this.sidebar == false &&
          (dojo.indexOf(data.standardActions, "ACTION_CHANGE_INSTANCE_DUEDATE") > -1 ||
            dojo.indexOf(data.standardActions, "ACTION_VIEW_PROCESS_AUDIT") > -1 || dojo.indexOf(data.standardActions,
            "ACTION_CHANGE_CRITICAL_PATH") > -1)) {
          com.ibm.bspace.common.util.ui.Helper.wrapElement(this.dropdownWrapper);
          dojo.style(this.dropdownWrapper, "display", "block");
        }

        if (data.standardActions != null && dojo.indexOf(data.standardActions, "ACTION_VIEW_PROCESS_DIAGRAM") > -1) {
          dojo.style(this.diagramLinkWrapper, "display", "block");
        }
        this.processActionsAvailable = true;
      }
    }
  },

  _launchChangeDueDateDialog: function(){
    var cddd = new com.ibm.bpm.social.widgets.dialogs.ChangeDueDateDialog({
      "instanceId": this.instanceData.piid,
      "dueDate": this.instanceData.dueDate,
      "callback": dojo.hitch(this, this._setInstanceData)
    }, dojo.create("div"));
    cddd.show();
  },

  /*
   * Callback method to update local instanceData variable with result of changeDueDate REST call.
   */
  _setInstanceData: function(data){
    if (typeof (data) == "undefined" || typeof (data.piid) == "undefined") {
      data = com.ibm.bpm.social.util.common.Util.getInstanceData({
        instanceId: this.instanceId,
        header: true,
        skipCache: true,
        updateTaskData: true
      });

      var t, a;
      for ( var i = 0; i < data.tasks.length; i++) {
        t = data.tasks[i];
        a = (t.assignedToDisplayName ? t.assignedToDisplayName : t.assignedTo);
        dojo.publish(com.ibm.bpm.social.portal.Topics.TASK_UPDATED + "." + t.tkiid, [{
          dueDateTime: t.dueTime,
          priority: t.priority,
          assignee: a,
          skipCache: false
        }]);
      }
    }

    this.instanceData = data;
    this.dueDateValue.innerHTML = this._determineDueDate(this.instanceData.dueDate);

    if (this.dueDateValue.innerHTML == this.messages.today || this.dueDateValue.innerHTML == this.messages.yesterday ||
      this.dueDateValue.innerHTML == this.messages.tomorrow) {
      this.dueDateValue.title = dojo.date.locale.format(dojo.date.stamp.fromISOString(this.instanceData.dueDate), {
        formatLength: "long"
      });
    }
  },

  _getInstanceFollowed: function(){

    this.socialRestHandler.isFollowingInstance(this.instanceId, dojo.hitch(this, function(data, xhrArgs){
      this._updateFollowedUI(data.followed);
      this.followed = data.followed;
    }), dojo.hitch(this, "_xhrErrors"), true);
  },

  _setInstanceFollowed: function(followed){

    var load = dojo.hitch(this, function(data, xhrArgs){
      this._updateFollowedUI(data.followed);
      dojo.publish(com.ibm.bpm.social.portal.Topics.REFRESH_FOLLOW_LIST, [{}]);
    });
    var error = dojo.hitch(this, "_xhrErrors");

    if (followed) {
      this.socialRestHandler.followInstance(this.instanceId, load, error, true);
    }
    else {
      this.socialRestHandler.unfollowInstance(this.instanceId, load, error, true);
    }

  },

  _updateFollowedUI: function(followed){
    if (followed) {
      dojo.removeClass(this.followedAnchor, 'bpm-social-unfollowed-star');
      dojo.addClass(this.followedAnchor, 'bpm-social-followed-star');
      //this.followedAnchor.alt = this.messages.followed;
      this.followedAnchor.title = this.messages.followed;
      dojo.attr(this.followAltText, "innerHTML", "&#9733;");
    }
    else {
      dojo.removeClass(this.followedAnchor, 'bpm-social-followed-star');
      dojo.addClass(this.followedAnchor, 'bpm-social-unfollowed-star');
      //this.followedAnchor.alt = this.messages.notFollowed;
      this.followedAnchor.title = this.messages.notFollowed;
      dojo.attr(this.followAltText, "innerHTML", "&#9734;");
    }
  },

  _onFollowedClick: function(e){
    if (this.followed) {
      this.followed = false;
      this.followedAnchor.setAttribute("aria-pressed", "false");
    }
    else {
      this.followed = true;
      this.followedAnchor.setAttribute("aria-pressed", "true");
    }
    this._setInstanceFollowed(this.followed);
  },

  _onFollowedKeyPress: function(e){
    console.warn(e);
    if (e.keyCode == dojo.keys.ENTER) {
      this._onFollowedClick(e);
      dojo.stopEvent(e);
    }
  },

  _viewProcessDiagram: function(e){

    /** ** BEGIN Loading Process Diagram-specific modules *** */
    /*
    try{
      dojo.registerModulePath('ibm_ilog.diagram', '/ProcessPortal/layers/'+socialversion+'/ibm_ilog/diagram');
      dojo["require"]("ibm_ilog.diagram.ibm_ilog_diagram_base"); //Alternate syntax used to avoid dojo build detection
    } catch (e) { 
      console.warn(e);
      dojo.registerModulePath('ibm_ilog.diagram', '/WebViewer/widgets/ibm_ilog/diagram');
    }
    
    try{
      dojo.registerModulePath('com.ibm.bpm.wpd', '/ProcessPortal/layers/'+socialversion+'/com/ibm/bpm/wpd'); //Needed, in addition to /com/ibm/bpm, for img & css files
      dojo["require"]("com.ibm.bpm.wpd_base"); //Alternate syntax used to avoid dojo build detection
    } catch (e) { 
      console.warn(e);
      dojo.registerModulePath('com.ibm.bpm.wpd', '/WebViewer/widgets/com/ibm/bpm/wpd');
    }
    
    try{
      dojo["require"]("com.ibm.bpm.social_diagram"); //Alternate syntax used to avoid dojo build detection
    } catch (e) { 
      console.warn(e);
      dojo.registerModulePath('com.ibm.bpm.social', '/ProcessPortal/com/ibm/bpm/social');
    }
    */
    /** ** END Loading Process Diagram-specific modules *** */

    this._viewProcessDiagram_loaded(e);
  },

  _viewProcessDiagram_loaded: function(e){

	var tmpHistory = null;
	if (dojo.isIE < 9) {
	  	tmpHistory = com.ibm.bpm.social.util.common.Util._portalHashHistory;
	 	com.ibm.bpm.social.util.common.Util._portalHashHistory = new Array();
	}
	
    /**
     * This will not fire an "open diagram" action, but will close all necessary popups before opening the
     * diagram. *
     */
    dojo.publish(com.ibm.bpm.social.portal.Topics.OPEN_PROCESS_DIAGRAM, [{
      "instanceId": this.instanceId
    }]);

    dojo.require("com.ibm.bpm.social.widgets.dialogs.ProcessDiagramDialog");
    var pdd = new com.ibm.bpm.social.widgets.dialogs.ProcessDiagramDialog({
      "instanceId": this.instanceId,
      "title": this.instanceData.processTemplateName,
      "subTitle": this.instanceData.name
    }, dojo.create("div"));
    pdd.show();

	if (tmpHistory) {
		var h = tmpHistory.pop();
		com.ibm.bpm.social.util.common.Util._portalHashHistory = tmpHistory;
		tmpHistory = null;
		window.setTimeout(function() {
			com.ibm.bpm.social.util.common.Util.setCurrentHash(h);
		}, 250);
	}
	    
  },

  _onInstanceClick: function(e){
    if (this.sidebar) {
      dojo.publish(com.ibm.bpm.social.portal.Topics.SHOW_PROCESS_INSTANCE, [{
        'instanceId': this.instanceId
      }]);
    }
  },

  _xhrErrors: function(xhrArgs, data){
    console.error(xhrArgs, data);
  },

  /**
   * Determine the base text direction dir attribute for a string based on user preference. Set the dir to
   * either rtl or ltr. Do nothing if pref is default.
   */
  _setDirAttribute: function(btdpref, str, node){
    if (btdpref != "default") {
      var dir = "";
      if (btdpref == "ltr" || btdpref == "rtl") {
        dir = btdpref;
      }
      else {
        dir = com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.resolveTextDirection("", str);
      }
      if (dir != "") {
        node.dir = dir;
        //console.log("InstanceDetails _setDirAttribute str: "+str+", dir: "+dir+", node: "+node);
      }
    }
  },

  _setBidiLangDir: function(node){
    if (document.body.dir == "rtl") {
      node.dir = "rtl";
    }
  },

  destroy: function(){
    this._clearTaskDetailsItems();
    if (this.menu != null && this.menu.destroy) {
	  
      this.menu.destroy();
      this.menu = null;
    }

    if (this.taskDetailsListItems) {
        for(var i=0; i < this.taskDetailsListItems.length; i++) {
          this.taskDetailsListItems[i].destroy();
        }
        this.taskDetailsListItems = null;
    }
    this.inherited(arguments);
  }

});
