/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.widgets.diagram.ActivityDetailsDropDownButton");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");

dojo.require("dijit.TooltipDialog");
dojo.require("dijit.form.DropDownButton");

dojo.require("com.ibm.bpm.social.widgets.diagram.ActivityDetailsTooltip");

dojo.declare(
	"com.ibm.bpm.social.widgets.diagram.ActivityDetailsDropDownButton",
	[dijit._Widget, dijit._Templated, dijit.form.DropDownButton],
	{

	label: '',
	tasks: [],
	displayDropDown: true,
	
    postCreate: function() {
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		
		this.activityDetails = new com.ibm.bpm.social.widgets.diagram.ActivityDetailsTooltip({
			'tasks': this.tasks
		});
		
		this.dropDown = new dijit.TooltipDialog({
            'content': this.activityDetails.domNode,
            'class': 'bpm-social-participants-activity-tooltip'
        });
		
    	this.label = '';
 
    	this.inherited(arguments);
    	
    	dojo.addClass(this.domNode, 'bpm-social-participants-activity');

        dijit.setWaiRole(this.dropDown.containerNode,"role","presentation");//fix RPT violation
    	
    	if(this.displayDropDown){
			this.openDropDown();
		}
	},
	
	openDropDown: function(){
		this.inherited(arguments);        
		
		this.activityDetails.getExperts();
        this.activityDetails.header.focus();


	},
	
	closeDropDown: function(foo, force){
		if(force==true){
			this.inherited(arguments);
		}
	},
	
	destroy: function() {
		if(this.activityDetails && this.activityDetails.destroy){
			this.activityDetails.destroy();
		}
		this.inherited(arguments);
	}

});