/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011,2013. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.widgets.diagram.ActivityDetailsTooltip");

dojo.require("dijit._Templated");

dojo.require("com.ibm.bpm.social.widgets.common._RestWidget");

dojo.require("com.ibm.bpm.social.widgets.experts.ExpertTile");

dojo.require("com.ibm.bpm.social.util.common.Util");

dojo.require("com.ibm.bpm.social.util.common.SocialRestHandler");

dojo.require("com.ibm.bpm.social.widgets.common.BizCard");
dojo.require("com.ibm.bpm.social.util.ui.Avatar");

dojo.require("com.ibm.bpm.social.util.baseTextDirection.BidiTextBox");

dojo.declare(
	"com.ibm.bpm.social.widgets.diagram.ActivityDetailsTooltip",
	[com.ibm.bpm.social.widgets.common._RestWidget, dijit._Templated],
	{
	
    templateString: "",
	templatePath: dojo.moduleUrl("com.ibm.bpm.social.widgets.diagram", "templates/ActivityDetailsTooltip.html"),
	
	tasks: [],
	taskInstances: [],
	currentTaskIndex: 0,
	
	currentMaxIndex: 3,
	currentMinIndex: 0,
	
	livenames: null,	
	expertTiles: [],
	
    postCreate: function() {
    	this.inherited(arguments);
		this.taskInstances = [];
    	
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.messages = dojo.i18n.getLocalization('com.ibm.bpm.social', 'bpmSocial');
		
		this.socialRestHandler = com.ibm.bpm.social.util.common.SocialRestHandler.getInstance();
		
		this.expertsTitle.innerHTML = this.messages.activityExpertsTitle;
		
		this.startDateLabel.innerHTML = this.messages.startDate+":";
		this.ownerLabel.innerHTML = this.messages.owner;
		
		this.noExperts_header.innerHTML = this.messages.noExperts_AutoHeader;
		
        dojo.attr(this.wrapper,"aria-label",this.messages.activity_details_counter_label);

    		this.previousImg.src = dojo.moduleUrl("com.ibm.bpm.social", "img/blank.gif");
    		this.nextImg.src = dojo.moduleUrl("com.ibm.bpm.social", "img/blank.gif");
    	  this._avatar = new com.ibm.bpm.social.util.ui.Avatar({}, this.avatarContainer);

//        if (dojo.hasClass(document.body,"dijit_a11y")) {
//            this.ownerImg.src = dojo.moduleUrl("com.ibm.bpm.social", "img/Avatar_30x30.png");
//        }

        this.nextImg.alt = this.messages.next_button_label;
        dijit.setWaiRole(this.nextImg,"button");
        this.previousImg.alt = this.messages.previous_button_label;
        dijit.setWaiRole(this.previousImg,"button");

		if(this.tasks.length==1){
			dojo.addClass(this.container, 'singleUser');
			dojo.empty(this.wrapper);
		} else {
            dojo.attr(this.wrapper,"tabindex","0");
            if (dojo.hasClass(document.body,"dijit_a11y")) {
                this.previousImg.src = dojo.moduleUrl("com.ibm.bpm.social", "img/Chevron_gray_left.png");
                this.nextImg.src = dojo.moduleUrl("com.ibm.bpm.social", "img/Chevron_gray_right.png");
                //this.ownerImg.src = dojo.moduleUrl("com.ibm.bpm.social", "img/Avatar_30x30.png");
            }
			for(var idx = 0; idx < this.tasks.length; idx++){
				var t = dojo.create('a', {
					'class': 'task-instance',
					'onclick': dojo.hitch(this, this._taskInstanceSelected),
					'index': idx+1,
					'href': 'javascript:void(0)',
					'innerHTML': idx+1
				}, this.counter);
				if(idx==0){
					dojo.addClass(t, 'current');
                    dijit.setWaiState(t,"disabled","true");
				}
				this.taskInstances.push(t);
			}
            this._disablePreviousOrNext(this.previous,this.previousImg,true);            
			
			/*
			if(this.tasks.length < this.currentMaxIndex){
				dojo.addClass(this.next, 'disabled');
			}
			*/
		}
		
		this._setTaskDetails(this.tasks[this.currentTaskIndex]);
		
		setTimeout(dojo.hitch(this, function(){
			this._checkForCounterScroll(0);
		}), 100)
	},
	
	_updateTaskDetails: function(){
		dojo.query('a.task-instance.current', this.domNode).forEach(function(node){
            dojo.removeClass(node,'current');
            dijit.setWaiState(node,"disabled","false");
        });	
		dojo.query('a.task-instance[index='+(this.currentTaskIndex+1)+']', this.domNode).forEach(function(node){
            dojo.addClass(node,'current');
            dijit.setWaiState(node,"disabled","true");
        });	

		
		dojo.fx.chain([
		    dojo.animateProperty({
		    	node: this.content,
		        duration: 300,
		        properties: {
		        	color: {
		        		start: "black",
		            	end: "white"
		            }
		        },
		        onBegin: dojo.hitch(this, function(){
		        	com.ibm.bpm.social.widgets.common.BizCard._hideTooltip();
		        }),
		        onEnd: dojo.hitch(this, function(){
		        	this._setTaskDetails(this.tasks[this.currentTaskIndex]);
		        })
		    }),
		    dojo.animateProperty({
		        node: this.content,
		        duration: 300,
		        properties: {
		            color: {
		            	start: "white",
		            	end: "black"
		            }
		        }
		    })
		]).play();
	},
	
	_setTaskDetails: function(t){
		
		this.dueEndDateLabel.innerHTML = (t.completionTime==null ? this.messages.dueDate : this.messages.endDate)+":";
 	   
		this.header.innerHTML = t.name;
		this.header.title = t.name;

        com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(this.header);
        
        this._applyStylingForBTD(this.header);
		
        this.startDateField.innerHTML = com.ibm.bpm.social.util.common.Util.formatDate(t.startTime);
        
		this.dueEndDateField.innerHTML = com.ibm.bpm.social.util.common.Util.formatDate(t.completionTime==null ? t.dueTime : t.completionTime);
        
		var user = null;
		if(t.owner){
			user = com.ibm.bpm.social.util.common.Util.getUser(t.owner);
			this.ownerField.innerHTML = user.fullName;
      this._avatar.setUser(user, " bpm-social-default-avatar-small", true);
      this._avatar.setCSSClass("owner-visible");
			dojo.style(this.ownerLabel, "visibility", "visible");
			dojo.style(this.ownerField, "visibility", "visible");
			dojo.query(".owner-text-wrapper", this.domNode).removeClass("no-owner");
		} else if(t.assignedToDisplayName){
			this.ownerField.innerHTML = t.assignedToDisplayName;
			this._avatar.setCSSClass("owner-hidden");
			dojo.style(this.ownerLabel, "visibility", "hidden");
			dojo.style(this.ownerField, "visibility", "visible");
			dojo.query(".owner-text-wrapper", this.domNode).addClass("no-owner");
		} else {
      this._avatar.setCSSClass("owner-hidden");
			dojo.style(this.ownerLabel, "visibility", "hidden");
			dojo.style(this.ownerField, "visibility", "hidden");
			dojo.query(".owner-text-wrapper", this.domNode).addClass("no-owner");
		}

		// Set the BTD off the ownerField before adding the business card integration
		com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(this.ownerField);
		this._applyStylingForBTD(this.ownerField);
		if(user!=null){
			/** Business Card integration **/
			//com.ibm.bpm.social.widgets.common.BizCard.unwrapImage(this.ownerImg); //fixes defect 93774
			com.ibm.bpm.social.widgets.common.BizCard.wrapElement(this.ownerField, user);
			//com.ibm.bpm.social.widgets.common.BizCard.wrapImage(this.ownerImg, user);
			/** End Business Card integration **/
		}
        
    },

	/*
	 * Called indirectly from the surrounding TooltipDialog onShow Event
	 */
	getExperts: function(){
		this.socialRestHandler.getExpertsForTask(this.tasks[this.currentTaskIndex].tkiid, 
			dojo.hitch(this, "_appendExpertsToTooltip"),
			dojo.hitch(this, "_onXhrErrors"), false);
	},
	
	_appendExpertsToTooltip: function(data, xhrArgs){
        var userProfileObj = com.ibm.bpm.socialportal.GlobalAssets.getUserProfile();        
        var currentUserId = userProfileObj.userID;
		var ee = null;
		if(data.systemIdentifiedUsers.length==0){
			dojo.style(this.noExperts, "display", "block");
			return;
		}
        var expertsCt = 0;
		for(var idx = 0; idx < data.systemIdentifiedUsers.length; idx++){
            //Do not show if the expert matches the current user.
            //We only show 6, but REST might return 7.
            if (currentUserId != data.systemIdentifiedUsers[idx]["userID"]) {
			data.systemIdentifiedUsers[idx]['taskId'] = this.tasks[this.currentTaskIndex].tkiid;
			data.systemIdentifiedUsers[idx]['includeTaskDetails'] = true;
			ee = new com.ibm.bpm.social.widgets.experts.ExpertTile(data.systemIdentifiedUsers[idx]);
			this.grid.appendChild(ee.domNode);
			this.expertTiles.push(ee);
                expertsCt++;
                if (expertsCt == 6) {
                    break;
                }
            }
		}
		
		var position=null;
		if (!!ee) {
			position = dojo.position(ee.domNode);
		}
		if (position == null || position.w <= 206) { // Check to see if the size of the experts node is larger than expected size
			if(expertsCt <= 2){
				dojo.addClass(this.grid, "singleRow");
			} else if(expertsCt <= 4){
				dojo.addClass(this.grid, "doubleRow");
			} else if(expertsCt <= 6){
				dojo.addClass(this.grid, "tripleRow");
			} else {
				dojo.addClass(this.grid, "tripleRow");
				dojo.addClass(this.grid, "scrollExperts");
			}
		} else { // width of the experts element > than specified width so only have 1 entry per row
			if(expertsCt <= 1){
				dojo.addClass(this.grid, "singleRow");
			} else if(expertsCt <= 2){
				dojo.addClass(this.grid, "doubleRow");
			} else if(expertsCt <= 3){
				dojo.addClass(this.grid, "tripleRow");
			} else {
				dojo.addClass(this.grid, "tripleRow");
				dojo.addClass(this.grid, "scrollExperts");
			}
		}
	},
	
	_onXhrErrors: function(data,xhrArgs) {
		// TODO: how do we show errors?
		console.error(data, xhrArgs);
	},
	
	_taskInstanceSelected: function(e){
		
		var oldIdx = this.currentTaskIndex;
		
		this.currentTaskIndex = e.target.getAttribute('index')-1;
		
		var scrollDir = (this.tasks.length < this.currentMaxIndex ? 0 : this.currentTaskIndex - oldIdx);
		
		this._checkForCounterScroll(scrollDir);
		
		this._updateTaskDetails();
	},
	
	_clickPrevious: function(e){
        dojo.stopEvent(e);
		
		if(dojo.hasClass(this.previous,'disabled')){
			return;
		}
        this._disablePreviousOrNext(this.next,this.nextImg,false);
		
		this.currentTaskIndex--;
		if(this.currentTaskIndex < 0){
			this.currentTaskIndex = 0;
		}
		
		if(this.currentTaskIndex==0){
            this._disablePreviousOrNext(this.previous,this.previousImg,true);
		}
		this._checkForCounterScroll(-1);
		this._updateTaskDetails();

	},
	
	_clickNext: function(e){
        dojo.stopEvent(e);
		
		if(dojo.hasClass(this.next, 'disabled')){
			return;
		}
        this._disablePreviousOrNext(this.previous,this.previousImg,false);
		
		this.currentTaskIndex++;
		if(this.currentTaskIndex > this.tasks.length-1){
			this.currentTaskIndex = this.tasks.length - 1;
		}
		
		if(this.currentTaskIndex==this.tasks.length - 1){
            this._disablePreviousOrNext(this.next,this.nextImg,true);
		}
		this._checkForCounterScroll(1);
		this._updateTaskDetails();
	},
	
	_checkForCounterScroll: function(dir) {
		/*if(dir==0){
			this._checkPreviousNextState();
			return;
		}*/
		
		//scroll to the correct page number
		var scrollToIndex = this.currentTaskIndex;
		if(this.currentTaskIndex == this.taskInstances.length-1) {
			scrollToIndex--;
		}
		else if(this.currentTaskIndex == 0) {
			scrollToIndex++;
		}
		var pageLink = this.taskInstances[scrollToIndex];
        if (!pageLink) {
            return;
        }
        
		var scrollAmt = 25 - pageLink.offsetLeft;
		if(this.currentTaskIndex == 0) {
			scrollAmt--; //forces the ipad to refresh, fixes defact 91836
		}
		dojo.query(this.counter).style('left', ""+scrollAmt+"px");
		
		//get the adjacent numbers
		var leftmost = (scrollToIndex-2 >= 0) ? this.taskInstances[scrollToIndex-2] : null;
		var leftish = (scrollToIndex-1 >= 0) ? this.taskInstances[scrollToIndex-1] : null;
		var center = this.taskInstances[scrollToIndex];
		var rightish = (scrollToIndex+1 < this.taskInstances.length) ? this.taskInstances[scrollToIndex+1] : null;
		var rightmost = (scrollToIndex+2 < this.taskInstances.length) ? this.taskInstances[scrollToIndex+2] : null;
		
		//hide anything that would get cut-off by the arrow buttons
		if(leftmost != null) {
			dojo.style(leftmost, "visibility", "hidden");
		}
		if(leftish != null) {
			dojo.style(leftish, "visibility", "");
		}
		dojo.style(center, "visibility", "");
		if(rightish != null) {
			dojo.style(rightish, "visibility", "");
		}
		if(rightmost != null) {
			dojo.style(rightmost, "visibility", "hidden");
		}
		/*
		var lclCounter = dojo.query(this.counter);
		
		//For some reason the pixels here are just a little off (by 1/2 a pixel)
		//so adjusting the pixel movements by one does not fix the issue of the
		//numbers scrolling out of visibility.  What is even stranger, the ipads
		//numbers scroll into invisibility the opposite direction.  Here I adjust
		//the scrolling every other time to adjust for this movement, and the 
		//numbers stay where they should.
		//Defect 93772
		var scrollOffset;
		if(this.currentTaskIndex < 10) {
			scrollOffset = 12;
		} else {
			scrollOffset = 18;
			if(com.ibm.bpm.social.util.common.Util.isIPad || dojo.isIE) {
				scrollOffset--;
				//every 10 times or so
				if((this.currentTaskIndex % 10) == 0) {
					scrollOffset++;
				}
			} else if((this.currentTaskIndex % 2) > 0) {
				scrollOffset++;
			}
		}
		
		//var scrollOffset = (this.currentTaskIndex < 10 ? 12 : 18); //Used to determine if we need a big scroll or smaller
		
		var curLeft = parseInt(lclCounter.style('left'));
		
		var offset;
		if(dir > 0) {
			if(this.currentTaskIndex >= this.currentMaxIndex){
				offset = (dir * -1 * scrollOffset) + curLeft;
				lclCounter.style('left', offset+'px');
				if(this.currentMaxIndex < this.tasks.length){
					this.currentMaxIndex += dir;
					this.currentMinIndex += dir;
				}
			}
		} else if(dir < 0){
			if(this.currentTaskIndex <= this.currentMaxIndex){
				offset = ((dir * -1 * scrollOffset) + curLeft);
				if(offset > 0) { 
					offset = 0;
				}
				lclCounter.style('left', offset+'px');
				
				if(this.currentMinIndex > 0){
					this.currentMaxIndex += dir;
					this.currentMinIndex += dir;
				}
			}
		}*/
		this._checkPreviousNextState();
	},
	
	_checkPreviousNextState: function(){
		if(this.currentTaskIndex == this.tasks.length-1){
			if(!dojo.hasClass(this.next, 'disabled')){
                this._disablePreviousOrNext(this.next,this.nextImg,true);
			}
		} else {
            this._disablePreviousOrNext(this.next,this.nextImg,false);
		}
			
		if(this.currentTaskIndex == 0){
			if(!dojo.hasClass(this.previous, 'disabled')){
                this._disablePreviousOrNext(this.previous,this.previousImg,true);
			}
		} else {
            this._disablePreviousOrNext(this.previous,this.previousImg,false);
		}
	},

    _disablePreviousOrNext: function(span,img,disable) {
         if (disable) {
             dojo.addClass(span, 'disabled');
             dijit.setWaiState(img,"disabled","true");
             dojo.attr(img,"tabindex","-1");
		} else {
             dojo.removeClass(span, 'disabled');
             dijit.setWaiState(img,"disabled","false");
             dojo.attr(img,"tabindex","0");
         }
	},
	
	_applyStylingForBTD: function(node) {
		var isDocLanguageRTL = ("rtl" == document.body.getAttribute('dir'));
		
		if (isDocLanguageRTL)
			dojo.style(node, "textAlign", "right");
		else
			dojo.style(node, "textAlign", "left");
	},
				
	destroy: function() {
		if(this.expertTiles && this.expertTiles.length>0){
			for(var idx = 0; idx < this.expertTiles; idx++){
				if(this.expertTiles[idx].destroy){
					this.expertTiles[idx].destroy();
				}				
			}
			this.expertTiles = {};
		}			
    if (this._avatar) {
      this._avatar.destroy();
      this._avatar = null;
    }
		this.inherited(arguments);
	}

});
