/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.widgets.diagram.ActivityOwnerDropDownButton");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");

dojo.require("dijit.TooltipDialog");
dojo.require("dijit.form.DropDownButton");

dojo.require("com.ibm.bpm.social.widgets.diagram.ActivityOwnerTooltip");

dojo.require("com.ibm.bpm.social.util.common.Util");

dojo.require("com.ibm.bpm.social.widgets.common.BizCard");

dojo.declare(
	"com.ibm.bpm.social.widgets.diagram.ActivityOwnerDropDownButton",
	[dijit._Widget, dijit._Templated, dijit.form.DropDownButton],
	{

	label: '',
	activityOwner: null,	
	livenames: null,	
	currentUser: null,
	avgHours: 0,
	completed: 0,
	userImageSize: 24,
	popupUserImageSize: 48,
	container: null,
	
    postCreate: function() {
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		
    	var data = {
    			'fullName': this.currentUser.fullName,
    			'userName': this.currentUser.userName,
    			'displayName': this.currentUser.fullName,
    			'title': this.currentUser.userPreferences['Title'],
    			'taskEmailAddress': this.currentUser.userPreferences['Task Email Address'],
    			'phoneNumber': this.currentUser.userPreferences['Phone Number'],
    			'avgHours': this.avgHours,
    			'completed': this.completed,
    			'chatString': ''
       	};
    	    	
		if(com.ibm.bpm.social.widgets.common.BizCard.useDefaultCard()){
			this.activityOwner = new com.ibm.bpm.social.widgets.diagram.ActivityOwnerTooltip(data);
			this.dropDown = new dijit.TooltipDialog({
				'content': this.activityOwner.domNode,
				'class': 'bpm-social-participants-image-tooltip'
			});
			dojo.connect(this, 'onMouseEnter', this, 'openDropDown');
		}

    	this.label = '';
 
    	this.inherited(arguments);
    	
    	dojo.addClass(this.domNode, 'bpm-social-participants-image');

	    imgSrc = com.ibm.bpm.social.util.common.Util.getUserAvatarURL(this.currentUser.userName);

	    var props = {
       		'src': imgSrc,
       		'height': this.popupUserImageSize,
    		'width': this.popupUserImageSize,
    		'alt': this.currentUser.fullName
       	};

    	var textNode = dojo.query(".dijitButtonText", this.domNode)[0];
    	this.currentImage = dojo.create("img", props, textNode);

    	//if(!com.ibm.bpm.social.widgets.common.BizCard.useDefaultCard()){
    	//	dojo.connect(this, 'onClick', this, function(e){
    	//		if(this.container!=null && typeof(this.container.destroy)!='undefined'){
    	//			this.container.destroy();
    	//		}
    	//	});
    	//}

		/** Business Card integration **/
    	if(!com.ibm.bpm.social.widgets.common.BizCard.useDefaultCard()){
    		var user = com.ibm.bpm.social.util.common.Util.getUser(this.currentUser.userName);
    		com.ibm.bpm.social.widgets.common.BizCard.wrapImage(this.currentImage, user);
    	}
		/** End Business Card integration **/
    },
	
	openDropDown: function(){
		if(this.dropDown){
			if(this.container){
				//callback to parent container to close other dropdowns
				this.container.closeDropdowns();
			}
			this.inherited(arguments);
		}
	},
	
	isDropDownOpen: function(){
		return dojo.query('.dijitHasDropDownOpen', this.domNode).length > 0;
	},
	
	destroy: function() {
		if(this.activityOwner && this.activityOwner.destroy){
			this.activityOwner.destroy();
			this.activityOwner = null;
		}
		
		this.inherited('destroy',arguments);
	}

});