/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.widgets.diagram.MultipleActivityOwnerContainer");

dojo.require("dijit._Templated");

dojo.require("com.ibm.bpm.social.widgets.common._RestWidget");

dojo.require("com.ibm.bpm.social.util.common.Util");

dojo.require("com.ibm.bpm.social.util.common.SocialRestHandler");

dojo.require("com.ibm.bpm.social.widgets.diagram.ActivityOwnerDropDownButton");

dojo.declare(
	"com.ibm.bpm.social.widgets.diagram.MultipleActivityOwnerContainer",
	[com.ibm.bpm.social.widgets.common._RestWidget, dijit._Templated],
	{

	templateString: "",
	templatePath: dojo.moduleUrl("com.ibm.bpm.social.widgets.diagram", "templates/MultipleActivityOwnerContainer.html"),
	tasks: [],
	dropdowns: [],
	displayedUsers: {},
	displayedUsersCount: 0,
	displayDropDown: false,
	displayDropDownIndex: null,
	currentWidth: 0,
	cssSingleIconWidth: 57,
	//userDataUrl: "/ProcessPortal/api/rest/task/{tid}/userdata?username={username}",
	userDataUrl: window.endpointURLObject.bpmRest +"/v1/social/task/{tid}/userdata?username={username}",
	
    postCreate: function() {
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		this.socialRestHandler = com.ibm.bpm.social.util.common.SocialRestHandler.getInstance();
		
		this.displayedUsers = {};
		this.dropdowns = [];
		
		var currentUser, avgHours, completed;
		
		if(this.tasks.length==1){
			dojo.addClass(this.container, "singleUser");
			this.displayDropDown = true;
			this.displayDropDownIndex = 0;
		}
		
		for(var idx = 0; idx < this.tasks.length; idx++){
			
	    	currentUser = com.ibm.bpm.social.util.common.Util.getUser(this.tasks[idx].assignedTo,true);

	    	if(this.displayedUsers[currentUser.userName]){
	    		continue;
	    	} else {
	    		this.displayedUsers[currentUser.userName] = true;
	    		this.displayedUsersCount++;
	    	}
	    	
	    	avgHours = 0;
	    	completed = 0;
	    	
			this.socialRestHandler.getExpertUserData(this.tasks[idx].tkiid, currentUser.userName,
				function(data, xhrArgs) {
					avgHours = data.avgHours;
					completed = data.completed;
				}, "", false);
			
	   		//03. Create Dropdown Button (Image)
	   		 var button = new com.ibm.bpm.social.widgets.diagram.ActivityOwnerDropDownButton({
	   			'currentUser': currentUser,
	   			'avgHours': avgHours,
	   			'completed': completed,
	   			'container': this
	   		}, dojo.create("div", {}, this.innerScroll));
	   		 
	   		this.dropdowns.push(button);

	   		dojo.style(this.innerScroll, 'width', (this.displayedUsersCount * this.cssSingleIconWidth)+'px');
		}
		dojo.removeClass(this.container, "hidden");
		
		this.inherited('postCreate',arguments);
		
		if(this.displayDropDown){
			if(this.displayDropDownIndex && this.displayDropDownIndex < this.dropdowns.length){
				this.openDropDown(this.displayDropDownIndex);
			} else {
				this.openFirstDropDown();
			}
		}
	},
	
	openFirstDropDown: function(){
		this.openDropDown(0);
		
	},
	
	openDropDown: function(idx){
		if(idx < this.dropdowns.length){
			this.dropdowns[idx].openDropDown();
		}
	},

	getDropDowns: function(){
		return this.dropdowns;
	},
	
	closeDropdowns: function(){
		for(var idx = 0; idx < this.dropdowns.length; idx++){
			this.dropdowns[idx].closeDropDown();
		}
	},
	
	destroy: function() {
		if(this.dropdowns.length > 0){
			for(var idx = 0; idx < this.dropdowns.length; idx++){
				if(this.dropdowns[idx] && this.dropdowns[idx].destroy){
					this.dropdowns[idx].closeDropDown();
					this.dropdowns[idx].destroy();
				}
			}
		}
		this.inherited(arguments);
	}

});