/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011,2013. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.widgets.diagram.Participants");

dojo.require("dijit._Templated");

dojo.require("com.ibm.bpm.social.widgets.common._RestWidget");

dojo.require("dijit.TooltipDialog");

dojo.require("dijit.form.DropDownButton");

dojo.require("dijit.layout.BorderContainer");

dojo.require("dijit.layout.ContentPane");

dojo.require("dojo.cookie");

//BPMSocial Packages
dojo.require("com.ibm.bpm.social.Aether");

dojo.require("com.ibm.bpm.social.portal.Topics");

dojo.require("com.ibm.bpm.social.widgets.experts.ExpertTile");

dojo.require("com.ibm.bpm.social.widgets.diagram.ActivityDetailsDropDownButton");

dojo.require("com.ibm.bpm.social.widgets.diagram.MultipleActivityOwnerContainer");

dojo.require("com.ibm.bpm.social.util.common.Util");

dojo.require("com.ibm.bpm.social.util.common.TaskRestHandler");

//WebViewer Packages - Alternate syntax used to avoid dojo build detection
dojo["require"]("ibm_ilog.diagram.gfxlayout.CanvasLayout");

dojo["require"]("ibm_ilog.diagram.gfxlayout.GridLayout");

dojo["require"]("com.ibm.bpm.wpd.base.bootstrap");

dojo["require"]("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");

dojo["require"]("com.ibm.bpm.wpd.document.bpd.view.BPDViewer");

dojo["require"]("com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider");

dojo["require"]("com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider");

dojo.declare(
	"com.ibm.bpm.social.widgets.diagram.Participants",
	[com.ibm.bpm.social.widgets.common._RestWidget],
	{
	
	userid: null,
	taskid: null,
	instanceid: null,
	clickTargetNode: 1,
	clickTargetImage: 2,
	userImageSize: 20,
	popupUserImageSize: 48,
	livenames: {},
	expertsCache: {},  //Store responses from our /experts REST call, indexed by iid
	instDataCache: {}, //Store response from system /process REST call, indexed by iid
	userDataCache: {}, //Store responses from our /userdata REST call, indexed by userName
	provider: null,
	maoContainer: null,
	notificationCookieKey: 'com.ibm.bpm.social.Participants.NotificationViewed',
	
	serverSideImageRendering: (dojo.isIE <= 9 || com.ibm.bpm.social.util.common.Util.isIPad),
	
	lastClickedIsCounter: false,
	
	scrollHandlerInitialized: false,
	lastTransform: [],
	diagramHeight: 0,
	
	contextMenu: null,
	contextWrapper: null,
	contextButton: null,
	dropdownHelper: null,
	currentTask: null,
	actions: [],
	_lastMouseEvent: null,
	_lastSelectedNode: null,
	
	taskActionsUrl: window.endpointURLObject.bpmRest +"/v1/task/actions?taskIDs={tkiid}",
	
	criticalPathFlowIds: null,
		
    postCreate: function() {
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		
		this.taskRestHandler = com.ibm.bpm.social.util.common.TaskRestHandler.getInstance();
		
        dojo.style(this.domNode, "position", "relative");
        dojo.style(this.domNode, "height", "100%");
        dojo.style(this.domNode, "width", "100%");
		
        if (this.instanceid != null) {
    		this.instDataCache[this.instanceid] = com.ibm.bpm.social.util.common.Util.getInstanceData({'diagram': true, 'header': true, 'instanceId': this.instanceid, 'skipCache': true});
    		
            this.loadJsps();
            this.createDiagram();
            this.createFadingNotification();

            dojo.connect(this.domNode, 'onclick', this, function(e){
				if(this.nodeClicked==false && (this.maoContainer!=null || this.dropdownButton!=null) ){
					this._closeOverlays();
				} 
				this.nodeClicked = false;
			});
			
			this._initializeScrollHandler();
        }     
        
        if(dojo.isIE){
        	this.connect(this.domNode, "oncontextmenu", this.onContextMenu);
        }
	},
	
	resize: function(){
		
		if(this.view && this.view.resize){
			this.view.resize();
		}
		
	},

	loadJsps: function() {
		try {
			var httpRequest = new XMLHttpRequest();
			var url = window.endpointURLObject.processPortalSupportJS +"/jsp/diagrammerCss.jsp";
			httpRequest.open("GET", url, true);
			httpRequest.send();
		} catch (e) {
			console.error(e);
		}
	},

    createDiagram: function(){
           var project={};
           var state = "Portal";
           var style = "position: absolute; top: 0px; bottom: 0px; right:0px; left:0px; border:0px";
           
           // In IE align the diagram to the left, for some reason in IE RTL only (doesn't occur on other browsers) the diagram pane gets right shifted
           // In IE the diagram is actually an image with hotspots. In RTL the image is shifted but the hotspots aren't. Forcing the alignment left
           // address this
           if (dojo.isIE)
        	   style = style + "; text-align:left";
           
           var criticalPathFlowIds = new Array();
           if(this.criticalPathFlowIds!=null){
        	   criticalPathFlowIds = this.criticalPathFlowIds;
           }
           
           //dojo.registerModulePath("com.ibm.bpm.wpd", "/WebViewer/widgets/com/ibm/bpm/wpd");
           //dojo.registerModulePath("com.ibm.bpm.wpd.core.model.documenttype.providers", "/WebViewer/widgets/com/ibm/bpm/wpd/core/model/documenttype/providers");
           //dojo.registerModulePath("ibm_ilog.diagram", "/WebViewer/widgets/ibm_ilog/diagram");
           //dojo.require("dijit.layout.BorderContainer");
           //dojo.require("dijit.layout.ContentPane");
           //dojo.require('ibm_ilog.diagram.gfxlayout.CanvasLayout');
           //dojo.require("com.ibm.bpm.wpd.document.bpd.view.BPDViewer");           
           //dojo.require('ibm_ilog.diagram.gfxlayout.CanvasLayout');
           //dojo.require("com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider");

           var provider = new com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider();
           provider.config = {
                   onNodeContextMenu : dojo.hitch(this, this.createContextMenu),
                   onNodeMouseLeave : dojo.hitch(this, this.hideItem),
                   onNodeClick : dojo.hitch(this, this.showItem),
                   showExecutionPath : true,
                   showCurrentActivites : true,
                   showNote : true,
                   showColor : true,
                   showToolbarOnBreadCrumb: true,
                   showSearchOnToolBar: false,
                   criticalPathFlowIds: criticalPathFlowIds,
                   additionalDataHandlers: [dojo.hitch(this, this.getUserInformation)],
                   userBTD: com.ibm.bpm.social.util.common.Util.getBTDUserPreference()
           };
           
           //if(com.ibm.bpm.social.util.common.Util.isIPad){
        	   //provider.config.onNodeClick = provider.config.onNodeContextMenu; disable this to fix defect 121601
           //}
           
           this.provider = provider;
           var providers = [provider];
           // this is a div in the dom tree to which the webviewer component will be attached to by dojo 		
           var t = dojo.create("div", {}, this.domNode);
           
           // BreadcrumbView will instantiate both the breadcrumb and the bpd diagram view
           //dojo.require("com.ibm.bpm.wpd.base.bootstrap");
           var view =  com.ibm.bpm.wpd.base.createWebViewerComponenet("com.ibm.bpm.wpd.core.view.BreadcrumbView", project, style, t, state, providers);
           
           this.view = view;
           
           if(this.serverSideImageRendering){
        	   var userAvatars = this.getUserInformation(null, this.instanceid, this.instanceid);
				window.SocialPortalUserAvatars = userAvatars;
           }
           
           var params = {
                   instanceIds : this.instanceid,//instanceIds,
                   type : "ProcessInstanceType",
                   bpdId : this.instanceid,//The value from property name bpdId is only used as a key for caching,  
                                       // any unique value pass in would be fine. I do not pass the value from this property to server.                  
                   instanceName : "iBPMinstanceName"//window.parent.instanceName
               };

         // fire the open doc event to open the diagram and the breadcrumb
         //dojo.require("ibm_ilog.diagram.gfxlayout.GridLayout");
         //dojo.require("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");
         (new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent(params)).dispatch();

    },
    
    _initializeScrollHandler: function(){
    	if(!this.serverSideImageRendering){
  		
    		var mod = dojo.query('svg > g > g:first-child > rect'); //'svg > g > g:first-child > rect'

    		if(mod.length==0 && this.scrollHandlerInitialized==false){
    			setTimeout(dojo.hitch(this, this._initializeScrollHandler), 1000);
    			return;
    		}

    		if(mod.length==1){
    			mod = mod[0];
    			
    			this.diagramHeight = 0;
    			var lanes = this.instDataCache[this.instanceid].diagram.lanes;
    			for (var x = 0; x < lanes.length; x++){
    				this.diagramHeight += lanes[x].height;
    			}
    			
    			dojo.connect(mod, (!dojo.isMozilla ? "onmousewheel" : "DOMMouseScroll"),this, dojo.hitch(this, this.__onScrollHandler));	
    			
    			this.scrollHandlerInitialized = true;
    		}
    		
    		var mod = dojo.query('svg > g > g:nth-child(2)'); //'svg > g > g:nth-child(2)'

    		if(mod.length > 0){
    			mod = mod[0];    			
    			dojo.connect(mod, (!dojo.isMozilla ? "onmousewheel" : "DOMMouseScroll"),this, dojo.hitch(this, this.__onScrollHandler));
    		}
    	}
    },
    
    __onScrollHandler: function(e){
    	try{
			  var scroll = e[(!dojo.isMozilla ? "wheelDelta" : "detail")] * (!dojo.isMozilla ? 1 : -1);
			  
			  var trans; 			  
			  if(e.currentTarget.tagName=="rect"){
				  trans = this._parseTransform(e.target.parentElement.nextSibling.getAttribute("transform"));
			  } else if(e.currentTarget.tagName=="g"){
				  trans = this._parseTransform(e.currentTarget.getAttribute("transform"));
			  } else {
				  return;
			  }

			  //Prevent scrolling past the top of the diagram
			  if( scroll < 0 && (this.lastTransform.length==0 || trans[5]==0 || (this.lastTransform.length > 0 && (trans[5] - this.lastTransform[5]) < 0) ) ){
				  dojo.stopEvent(e);
			  }
			  
			  var ownerHeight;
			  if(dojo.isIE){
				  ownerHeight = e.target.ownerSVGElement.height.baseVal.value;
			  } else {
				  ownerHeight = e.target.ownerSVGElement.getAttribute("height");
				  if(ownerHeight){
					  try{
						  ownerHeight = ownerHeight.replace("px", "");
						  ownerHeight = parseFloat(ownerHeight);
					  } catch (e) {
						  ownerHeight = -1;
					  }
			  		}
			  }

			  //Prevent scrolling past the bottom of the diagram
			  if( scroll > 0 && (trans[5] + this.diagramHeight) > ownerHeight && ownerHeight > -1){
				  dojo.stopEvent(e);
			  }
			  this.lastTransform = trans;
		  } catch (error){
			  console.error("Diagram Scroll Handler exception: ",error);
		  }
    },
    
    _parseTransform: function(string){
    	//Parses an SVG string in the form of "matrix(1.00000000,0.00000000,0.00000000,1.00000000,0.00000000,40.00000000)"
    	var x;
    	var pattern = /\d*\.\d*/g;
    	if(dojo.isIE){
    		pattern = /\d*/g;
    	}
    	
    	var transform = [];
    	
    	var bits = string.match(pattern);
    	if(dojo.isIE){
    		var bits2 = [];
    		for(x = 0; x < bits.length; x++){
    			if(bits[x]!=""){
    				bits2.push(bits[x]);
    			}
    		}
    		bits = bits2; 
    	}
    	
    	var num = 0;
    	for(x = 0; x < bits.length; x++){
    		try{
    			num = parseFloat(bits[x]);
    			transform.push(num);
    		} catch(e){
    			transform.push(0);
    		}	
    	}
    	return transform;
    },
    
    getUserInformation: function(model, instanceIds, bpdId){
        // Make ajax call, make sure it is synchronized call.                                      
        // The load handler is the function 'yourCallBack'.
        // Each time user drill in a subprocess, the user data should be retrieved for that subprocess.
        // So here we need an ajax call to get information for that bpdId only. 
        // This function will be called by our component each time when user open a top level instance or drill in a subprocess. 
        // You need to write a jsp or rest handler to get the information each time
        // 
        // In summary, getUserInformation is a function registered with the docTypeProvider, 
        // it will be invoked each time when user drill in a subprocess or open a top level bpd instance.  
        // In getUserInformation, your code will need to retrieve the information from server based on bpdId and instanceId.
        // 
        // I guess you have the instanceIds. but I pass it anyway
        // The model is also passed to you. you do not need to update the model directly.
        // please pass the model to provider.updateModel(model, 'decorateNodeWithImage', params );
        //
        if (!instanceIds) {
          instanceIds = this.instanceid;
        }
        if(!this.instDataCache[instanceIds]){
      	  this.instDataCache[instanceIds] = com.ibm.bpm.social.util.common.Util.getInstanceData({'diagram': true, 'header': true, 'instanceId': instanceIds});
        }              
        var ud = this.getUserData(model, this.instDataCache[instanceIds]);
        
        if(model==null){
        	return ud;
        }
    },
    
    getUserData: function(model,data){
         var params = [];
         var previousFlowObjectID = null;
         var tasks = data.tasks;
         for (var ct in tasks) {
        	 var owner = tasks[ct]["owner"];
             var avatarURL, flowObjectID, userData;
             if (owner) {
                 avatarURL = com.ibm.bpm.social.util.common.Util.getUserAvatarURL(owner);
                 flowObjectID = tasks[ct]["flowObjectID"];
                 if (dojo.isIE == 9 || com.ibm.bpm.social.util.common.Util.isIPad) {
                     if (previousFlowObjectID == flowObjectID) {
                         params.pop();
                     }      
                     previousFlowObjectID = flowObjectID;
                 }
                 userData = {};
	             userData = { activityId: flowObjectID, imagePath: avatarURL };
	             params.push(userData);
             }
         }

       if(model!=null){
    	   this.provider.updateModel(model, 'decorateNodeWithImage', params );
       } else {
    	   return params;
       }
    },

    _extractClickData: function(node, e){
    	
    	//01. Clear previously created popups
		this._closeOverlays();

    	//02. Identify task object by clicked Node
		var nodeId = null;
		if(node.getData){
			var d = node.getData();
	    	nodeId = d.get('id')[0]; //"bpdid:5cd499bd441308ca:37d49876:12e27ee26e3:-67c6"	
		} else if (node.id) { //IE9
            nodeId = node.id;
        } else if (node.target) {            
			nodeId = node.target.getAttribute("name");
		}

        if (nodeId) {        
    	//TODO Possibly need to extract currently selected Instance ID if we are drilling down here
		var task = this.__getTaskObjectByNodeId(nodeId);
		
		var bb = {};
		if(this.serverSideImageRendering){
                var target = node.target ? node.target : e.target; //IE9 e.target
    			bb.x = target.offsetLeft;
    			bb.y = target.offsetTop + 25; //To account for the breadcrumb header
    			bb.width = target.offsetWidth;
    			bb.height = target.offsetHeight;
		} else {
			var diagram = node.viewer.ilogDiagrammer;
			bb = node.getBounds(diagram._graph);
			bb.y += 30; //To account for the breadcrumb header
		}
        }
		
		return { "node": nodeId, "task": task, "boundingBox": bb };
    },
    
    onContextMenu: function(e){ //Only invoked for an IE9-specific context menu
		if(window.currentDiagrammerNode!=null){
			this.createContextMenu(window.currentDiagrammerNode, e);
		}
    },
    
    // create a context menu for an active user task 
    createContextMenu: function(node, e) {

        if (!e) {
            console.log("Participants.createContextMenu event is null, returning.");
            return;
        }
		dojo.stopEvent(e);
    	this._lastMouseEvent = e;
    	this._lastSelectedNode = node;
    	
    	var click = this._extractClickData(node, e);
        if (!click.task) {
            console.log("Participants.createContextMenu click.task undefined, returning.");
            return;
        }

    	if(click.task.length==0){ //Task / Flow Object not found
    		console.log("Participants.createContextMenu::returning due to Task Flow Object not found");
    		return;
    	} /*else if(click.task[0].assignedToType!='user'){ //Task assigned to a group, which we don't display info for
    		console.log("showItem::returning due to non-user assignment");
    		return;
    	}*/
    	this.currentTask = click.task[0];

    	//1. create an invisible DIV at the point of the click
    	this._destroyMenu();
    	
    	if(this.contextWrapper!=null){
    		dojo.destroy(this.contextWrapper);
    	}
    	
		this.contextWrapper = dojo.create("div", { 
    		"style":{
    				"height": "2px",
    				"width": "2px",
    				"position": "absolute",
    				"top": (typeof(e)=="undefined" ? node.pageY : e.pageY)+"px",
    				"left": (typeof(e)=="undefined" ? node.pageX : e.pageX)+"px",
    				"zIndex": 990,
    				"display": "none",
    				"backgroundColor": "transparent"
    		}
    	}, dojo.body());

		if(com.ibm.bpm.social.util.common.Util.isIPad){
			var touchX = 0, touchY = 0;
			if(e.changedTouches.length > 0){
				touchX = e.changedTouches.item(0).pageX;
				touchY = e.changedTouches.item(0).pageY;
			}
			dojo.style(this.contextWrapper, "top", touchY+"px");
			dojo.style(this.contextWrapper, "left", touchX+"px");
		}
		
    	//2. create an actiondropdownhelper
    	if(this.dropdownHelper==null){
    		this.dropdownHelper = com.ibm.bpm.social.widgets.ActionDropDownHelper.getInstance();
    	}
		this.contextMenu = this.dropdownHelper.createDropDown(this.contextWrapper);
    	
    	//3. create and wrap the div with the new actionhandler for tasks
		this.taskRestHandler.getActionsForTask(click.task[0].tkiid, "",
			dojo.hitch(this, this._createContextMenu_onActionsResponse),
			dojo.hitch(this, function(data, xhrArgs) {
				console.error(data, xhrArgs);
			}), true);
    },
    
    _createContextMenu_onActionsResponse: function(data, xhrArgs){
    	for(var x = 0; x < data.tasks.length; x++){
    		if(data.tasks[x].tkiid==this.currentTask.tkiid){
    			this.actions[this.currentTask.tkiid] = data.tasks[x].actions; 
    			this._createContextMenu_withActions(data.tasks[x].actions);
    			break;
    		}
    	}
    },
    
    _createContextMenu_withActions: function(actions){
		if(actions==null && !com.ibm.bpm.social.util.common.Util.isIPad){
    		//Task not found in actions list
    		console.debug("Returning from createContextMenu due to Task Not Found");
    		return;
    	}
		
		if(actions==null){
			actions = {};
		}
    	
		var modifyTaskHandler = new com.ibm.bpm.social.widgets.task.util.ModifyTaskHandler({
          task: this.currentTask,
          availableActions: actions
        });
        this.connect(modifyTaskHandler, "onTaskModified", dojo.hitch(this, function(dueDateTime, priority, assignee){
        	
        	this._updateTaskProperties(this.currentTask.tkiid, dueDateTime, priority, assignee);
        	
        }));
		
        //
        // Create the menu and add the task actions
        //
        this.contextMenu = this.dropdownHelper._createDropDownForTask(this.contextWrapper, this.currentTask, actions, {
          modifyTask: function(){
            modifyTaskHandler.showDialog();
          },
          reassignBackToGroup: function(){
            modifyTaskHandler.reassignBackToGroup();
          },
          viewActivityDetails: dojo.hitch(this, function(){
        	this.showItem(this._lastSelectedNode, this._lastMouseEvent);
          })
        }, false /* no collaboration */, true /* omit instance link */);
        //
        // Add the process actions if necessary
        //
        if (this.contextMenu != null && typeof this.currentTask.piid === "string") {
        
          this.dropdownHelper.addProcessActions(this.contextMenu, this.instDataCache[this.currentTask.piid], {
            onCompletedCallback: function(){
              dojo.publish(com.ibm.bpm.social.portal.Topics.REFRESH_PROCESS_DIAGRAM);
            },
            onCanceledCallback: function(){
              dojo.publish(com.ibm.bpm.social.portal.Topics.REFRESH_PROCESS_DIAGRAM);
            },
			onMessageClosedCallback: function(){
              dojo.publish(com.ibm.bpm.social.portal.Topics.REFRESH_PROCESS_DIAGRAM);
			}
          }, true /* use ad-hoc dialogs */, true /* omit instance link */, true /* omit process diagram */, true /* omit critical path */);
        }
        if (this.contextMenu != null) {
          com.ibm.bspace.common.util.ui.Helper.wrapElement(this.contextWrapper);
          dojo.style(this.contextWrapper, "display", "block");
          
          this.connect(this.contextMenu, "onItemClick", this._hideMenuAnchor);
          this.connect(this.contextMenu, "onCancel", this._hideMenuAnchor);
        }
    	
    	//4. open the menu... (71306 - Wrap in a block to check that menu has valid children before opening (or replace "Loading..." with a "No available actions" item)
        this.contextMenu._openMyself({
        	target: this.contextWrapper,
        	coords: dojo.coords(this.contextWrapper)
        });
        this.contextMenu.focusFirstChild();
    },
    
    _updateTaskProperties: function(tkiid, dueDateTime, priority, assignee){
    	
    	dojo.publish(com.ibm.bpm.social.portal.Topics.TASK_UPDATED+"."+tkiid, [{dueDateTime: dueDateTime ,priority: priority, assignee: assignee}]);
    	
    },
    
    _hideMenuAnchor: function(){
    	if(this.contextWrapper!=null){
    		dojo.style(this.contextWrapper, "display", "none");
    	}
    },
    
    _destroyMenu: function(){
    	if (this.contextMenu!=null && this.contextMenu.destroy){
    		this.contextMenu.destroy();
    		com.ibm.bspace.common.util.ui.Helper.unwrapElementList(this.contextWrapper);
    		dojo.style(this.contextWrapper, "display", "none");
    		this.contextMenu = null;
		}
    },

    hideItem: function(node, e) {
    	//console.log("Test hideItem", node, e);
    },
    
    _closeOverlays: function(){
   	
    	if(this.dropdownButton && this.dropdownButton.destroy){
			this.dropdownButton.closeDropDown(null, true);
			this.dropdownButton.destroy();
    		this.dropdownButton = null;
    	}

		if(this.maoContainer && this.maoContainer.destroy){
			//TODO Close dropdown?
			this.maoContainer.destroy();
			this.maoContainer = null;
		}
		
    },

    showItem: function(node, e) {
		this.nodeClicked = true;
		
    	//00.  Close all previous overlays on a zoom
		if(node.viewer && node.viewer.zoomSlider){
			var connectId = dojo.connect(node.viewer.zoomSlider, 'onChange', this, function(evt){
				this._closeOverlays();
				dojo.disconnect(connectId);
			});
		}
    	
    	//00.  Close all previous overlays on a scroll
    	try{ 
    		//Connect to the 'DOMAttrModified' event of the <g> element that is getting moved horizontally or vertically when scroll is used
    		var mod = dojo.query('svg > g > g:nth-child(2)');
    		
    		if(mod.length==1){
    			mod = mod[0];
    			dojo.connect(mod,'DOMAttrModified', this,function(evt){
        			if(evt.attrName=='transform'){
        				this._closeOverlays();
        			}
        		});
    		}
    		
    	} catch (error) {
    		console.error(error);
    	}
    	
    	var click = this._extractClickData(node, e);
    	if(click.task.length==0){ //Task / Flow Object not found
    		console.log("showItem::returning due to Task Flow Object not found");
    		return;
    	} /*else if(click.task[0].assignedToType!='user'){ //Task assigned to a group, which we don't display info for
    		console.log("showItem::returning due to non-user assignment");
    		return;
    	}*/
 		
		//03. Perform action based on click target
    	/*
    	var tgt = this.clickTargetNode;
    	if(click.task[0].assignedToType=='user'){
    		tgt = this._determineClickTarget(node, e, click.boundingBox);
    	}
    	
    	switch(tgt){
    		case this.clickTargetNode:
    			this._handleNodeClick(node, e, click.task, click.boundingBox);
    			break;
    		case this.clickTargetImage:
    			this._handleImageClick(node, e, click.task, click.boundingBox);
    			break;
    	}*/
    	this._handleNodeClick(node, e, click.task, click.boundingBox);
    },

	destroy: function() {
		
		this._destroyMenu();
		
		if(this.view && this.view.destroyRecursive){
			this.view.destroyRecursive();
			this.view = null;
			try{	dojo.destroy("bpdEditor");	} catch(e){ }
		} 

		if(this.dropdownButton && this.dropdownButton.destroy){
			this.dropdownButton.destroy();
			this.dropdownButton = null;
		}			
			
		if(this.maoContainer && this.maoContainer.destroy){
			this.maoContainer.destroy();
			this.maoContainer = null;
		}
		
		this.inherited(arguments);
	},
	
	_determineClickTarget: function(node, evt, bb){
		var isDecorator = false;
		if(this.serverSideImageRendering) { //IE8
			//console.debug("_determineClickTarget for IE8...");
			this.lastClickedIsCounter = (node.target.getAttribute("counter")=="true");
			isDecorator = (node.target.getAttribute("clickTargetImage")=="true");
		} else if(dojo.isIE==9) { //IE9
			//console.debug("_determineClickTarget for IE9...");
			if(node._data.item.bpmn2TaskType=="UserTask"){
				var lcl = { 'x': bb.x, 'y': bb.y, 'height': bb.height, 'width': bb.width };
				lcl.y += (node._data.item.counter ? 15:0) + 45; //IE takes into account the header, whereas other browsers do not			
				this.lastClickedIsCounter = (typeof(node._data.item.counter)!="undefined");
				if (evt.pageX) {
					if ( (lcl.x < evt.pageX && evt.pageX < (lcl.x + 18) )  && ( lcl.y < evt.pageY && evt.pageY < (lcl.y + 18) ) ) {
						isDecorator = true;
					}
				}
			}
		} else { //FF, Safari
			//console.debug("_determineClickTarget for FF/Safari...");
			if(evt.target instanceof SVGImageElement){
				if(typeof(node._data.item.decorator)!="undefined"){
					var src = node._data.item.decorator[0];
					var tgt = evt.target.attributes.getNamedItem('xlink:href').nodeValue;
					if(src==tgt){
						isDecorator = true;                    
					}
				}
				this.lastClickedIsCounter = (typeof(node._data.item.counter)!="undefined");
			}
		}
		return (isDecorator ? this.clickTargetImage : this.clickTargetNode);
	},
	
	__getTaskObjectByNodeId: function(nodeId){
		var t = this.instDataCache[this.instanceid].tasks;
    	var taskObj = [];
    	for(var idx = 0; idx < t.length; idx++){
    		if(t[idx].flowObjectID==nodeId){
    			taskObj.push(t[idx]);
    		}
    	}
		return taskObj;
	},
	
	_handleNodeClick: function(node, e, taskObj, bb){
		//console.log("_handleNodeClick::entering...",node,e,taskObj,bb);
		
		var position = ["below"];
		
		//01. Determine location
		bb.x = bb.x + (bb.width/2) - 20;	//15px negative offset to account for
		//bb.y = bb.y + bb.height - 20;		//tooltip dropdown offset
		
		var dropdownHeight = 250; //Height + margins
		
		if(dojo.isIE){
			if(document.documentElement.offsetHeight - (bb.y + bb.height) < dropdownHeight){
				//Make sure enough room for dropdown
				//If not, move button to top of node
				bb.y = bb.y - 20;
				position = ["above"];
			} else {
				bb.y = bb.y + bb.height - 20;
			}
		} else {
			if( (window.innerHeight - bb.y - bb.height) < dropdownHeight ){
				//Make sure enough room for dropdown
				//If not, move button to top of node
				bb.y = bb.y - 20;
				position = ["above"];
			} else {
				bb.y = bb.y + bb.height - 20;
			}
		}
		
    	//02. Create dropdown
		this.dropdownButton = new com.ibm.bpm.social.widgets.diagram.ActivityDetailsDropDownButton({
			'tasks':taskObj,
			'style': "left:"+bb.x+"px; top:"+bb.y+"px;",
			'dropDownPosition': position
		}
		,dojo.create("div", {}, this.domNode)); //previously dojo.body() on IBPM
		
   	},

	_handleImageClick: function(node, e, taskObj, bb){
		//console.log("_handleImageClick::entering...",node,e,taskObj,bb);
    
		//01. Determine location
		bb.x = bb.x  - this.popupUserImageSize + 12;
		bb.y = bb.y  - this.popupUserImageSize + 10 + (this.lastClickedIsCounter==true ? ( (dojo.isIE < 9)?0:10):0);
		
    	//02. Create dropdown
		this.maoContainer = new com.ibm.bpm.social.widgets.diagram.MultipleActivityOwnerContainer({
			'tasks': taskObj,
			'style': "left:"+bb.x+"px; top:"+bb.y+"px;",
			'displayDropDown': true,
			'displayDropDownIndex': 0
		},dojo.create("div", {}, this.domNode));  //previously dojo.body() on IBPM
	},
		
	createFadingNotification: function(){
		//dojo.cookie(this.notificationCookieKey, "0", { 'expires': -1}); //NOTE: Delete for production
		if(!dojo.cookie(this.notificationCookieKey)){
			dojo.cookie(this.notificationCookieKey, "1", {'expires': 5});
			new com.ibm.bpm.social.Aether({
				'message': "<div>"+this.messages.participantsInfoText+"</div>",
				'position': 'top-center',
				'fade': true,
				'parent': this,
				'displayCloseIcon': true
			});
		}
	}
	
});