dojo.provide("com.ibm.bpm.social.widgets.dialogs.AuditHistoryDialog");

dojo.require("dijit._Templated");

dojo.require("dijit._Widget");

dojo.require("com.ibm.bpm.social.portal.Topics");

dojo.require("com.ibm.bspace.common.util.ui.FullScreenDialog");

dojo.declare("com.ibm.bpm.social.widgets.dialogs.AuditHistoryDialog", com.ibm.bspace.common.util.ui.FullScreenDialog, {

	templateString: "<div dojoAttachPoint='content'><iframe dojoAttachPoint='frame' src='#' /></div>",
	
	instanceId: null,
	
	instanceName: null,
	
	templateName: null,
	
	auditTrailUrl: window.endpointURLObject.processPortalSupport +"/jsp/processAudit.do?bpdInstanceId={iid}",

	proxyUrl: "",
	
	postMixInProperties: function(){
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		
		this.dialogParams.title = this.messages.auditHistoryWindowTitle.replace("${name}", this.templateName);
		
		this.dialogParams.subTitle = this.instanceName;
		
		this.dialogParams.closeButtonTooltip = this.messages.closeAuditHistoryTooltip;
		
		this.inherited(arguments);
	},
		
	show: function(){
        dojo.publish(com.ibm.bpm.social.portal.Topics.SHOW_DIALOG, [this.id]);

        this.frame.setAttribute('frameborder', '0');
		
		this.frame.src = this.proxyUrl +  this.auditTrailUrl.replace("{iid}", this.instanceId);
        this.frame.title =  this.dialogParams.title;//a11y
		
		this.inherited(arguments);
		
		this._sizeContentPane();
		
		dojo.style(this.frame, "width", "100%");
		dojo.style(this.frame, "margin", "0");
		dojo.style(this.frame, "padding", "0");
		dojo.style(this.frame, "position", "absolute");
		dojo.style(this.frame, "top", "0");
		dojo.style(this.frame, "bottom", "0");
		dojo.style(this.frame, "left", "0");
		dojo.style(this.frame, "right", "0");
		
		dojo.connect(this.popup, 'onHide', this, this.delayedDestroy);
		
		dojo.connect(window, 'onresize', this, this._sizeContentPane);

        dojo.connect(this.frame.contentWindow, "onkeypress", this, this._close);//accessibility

        setTimeout(this.frame.contentWindow.focus,1000);//a11y    
      },

      _close: function(e) {
           if (e.charOrCode == dojo.keys.ESCAPE) {
               this.popup.onCancel()
           }
      },
	
	_sizeContentPane: function(){
		var h = 0, w = 0;
		if(dojo.isIE){
			h = document.documentElement.offsetHeight;
			w = document.documentElement.offsetWidth;
		} else {
			h = window.innerHeight;
			w = window.innerWidth;
		}
        if (this.popup && this.popup.domNode) {
		    dojo.query(".dijitDialogPaneContent", this.popup.domNode).style("height", (h-50)+"px").style("width", w+"px"); //50px header height
        }

		if(dojo.isIE < 9){
			dojo.query(".fullScreenDialog").style("left", "0").style("top", "0").style("overflow", "hidden");
		}
		
		if(this.frame){
			dojo.style(this.frame, "height", (h-50)+"px");
            if (dojo.isFF > 19) {
                dojo.style(this.frame, "overflow", "hidden");
            }
		}
	},
	
	/*
	 * This method is used to destroy this.popup (our dijit.Dialog) after it's animation has finished.
	 * This is only invoked when the 'X' or Cancel button is pressed.
	 */
	delayedDestroy: function(){
		setTimeout(dojo.hitch(this, this.destroy), 1000);
	},

    destroy: function(){
        dojo.publish(com.ibm.bpm.social.portal.Topics.HIDE_DIALOG, [this.id]);
        this.inherited(arguments);
    }
	
});
