dojo.provide("com.ibm.bpm.social.widgets.dialogs.AvatarUploadDialog");

dojo.require("com.ibm.bspace.common.util.ui.Dialog");

dojo.registerModulePath("com.ibm.socialPortal.templates", window.endpointURLObject.processPortal +"/com/ibm/bpm/social/widgets/dialogs/templates");

dojo.declare("com.ibm.bpm.social.widgets.dialogs.AvatarUploadDialog", com.ibm.bspace.common.util.ui.Dialog, {
	templateString: dojo.cache("com.ibm.socialPortal.templates", "avatarUpload.html"),
	dialogParams: { style: ""},
	error: null,
	
	postMixInProperties: function(){
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.avatarUpdateMessages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		
		this.inherited(arguments);
	},
	
	postCreate: function() {
		var self = this;
		this.addButton("cancelButton", this.avatarUpdateMessages.cancel, "onCancel", self);
		this.addButton("saveButton", this.avatarUpdateMessages.ok, "onSave", self);
		this.avatarForm.action = window.endpointURLObject.bpmRestJS + "/v1/avatar/current";		
		this.avatarUploadLabel.innerHTML = this.avatarUpdateMessages.updateAvatarMessage;

		this.inherited(arguments);
	},

	onCancel: function() {
		this.hide();
	},	
	
	onSave: function() {
		var allowedExtenstions = [ ".jpg", ".jpeg", ".gif", ".png" ];
		var validFileType = false;
		var upload = dojo.byId("uploadAvatarFile");
		if (upload) {
			var fileName = upload.value.toLowerCase();
			for (var i=0; i<allowedExtenstions.length; i++) {
				if (fileName.indexOf(allowedExtenstions[i]) != -1) {
					validFileType = true;
					break;
				}
			}
			
			if (!validFileType && upload != "") {
				this.error = this.avatarUpdateMessages.invalidAvatarFileType;
				this.hide();
				dojo.publish("com.ibm.bpm.avatarUpload");
				return false;
			}
		}

		this.hide();

		dojo.require("dojo.io.iframe");
		var self = this;
		var td = dojo.io.iframe.send({
			url: window.endpointURLObject.bpmRestJS +"/v1/avatar/current",
			form: "avatarForm",
			method: "post",
			timeoutSeconds: 90,
			preventCache: true,			
			handleAs: "text",
			headers: {
				"Content-Encoding" : "UTF-8",
				"Content-Type": "text/html"
			},			
			load: function(data, ioArgs){
				var response = dojo.fromJson(data);
				if (response.status = "200") {
					self.error = null;
					var currUser = com.ibm.bpm.socialportal.GlobalAssets.getUserProfile().userName;
					com.ibm.bpm.social.util.common.Util.getUserAvatarURL(currUser,true);
				} else {
					self.error = self.avatarUpdateMessages.uploadError;
				}
				dojo.publish("com.ibm.bpm.avatarUpload");
			},							
			error: function (res,ioArgs) {
				self.error = self.avatarUpdateMessages.uploadError;
				dojo.publish("com.ibm.bpm.avatarUpload");
			}						
		});
	},
	
	show: function() {
		var fileInputNode = dojo.byId("uploadAvatarFile");
		if (fileInputNode) {
			fileInputNode.value = "";
		}
		this.error = null;
		this.inherited(arguments);
	}
});