dojo.provide("com.ibm.bpm.social.widgets.dialogs.ChangeDueDateDialog");

dojo.require("dojo.date.stamp");

dojo.require("dojo.date.locale");

dojo.require("dijit._Templated");

dojo.require("com.ibm.bpm.social.widgets.common._RestWidget");

dojo.require("dijit.Dialog");

dojo.require("dijit.form.DateTextBox");

dojo.require("dijit.form.TimeTextBox");

dojo.require("com.ibm.bspace.common.util.ui.Dialog");

dojo.require("com.ibm.bpm.social.portal.Topics");

dojo.require("com.ibm.bpm.social.widgets.task.util.DateTime");

dojo.require("com.ibm.bpm.social.util.common.TaskRestHandler");

dojo.require("com.ibm.bpm.social.util.common.ProcessRestHandler");

dojo.declare("com.ibm.bpm.social.widgets.dialogs.ChangeDueDateDialog", 	[com.ibm.bspace.common.util.ui.Dialog, com.ibm.bpm.social.widgets.common._RestWidget], {

	templatePath: dojo.moduleUrl("com.ibm.bpm.social.widgets.dialogs", "templates/ChangeDueDateDialog.html"),

	instanceId: null,
	
	taskId: null,
	
	dueDate: null,
	
	dateTimePicker: null,
	
	callback: null,
	
	connects: [],
	
	instanceUrl: window.endpointURLObject.bpmRest +"/v1/process/{id}?action=update&dueDate={date}&parts=header",

	taskUrl: window.endpointURLObject.bpmRest +"/v1/task/{id}?action=update&dueDate={date}&parts=none",
	
	postMixInProperties: function(){
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.changeDueDateDialogMessages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		
		this.dialogParams.title = this.changeDueDateDialogMessages.dueDateHeader;
		
		this.dialogParams.draggable = false;
		
		this.inherited(arguments);
	},
	
    postCreate: function() {
		this.taskRestHandler = com.ibm.bpm.social.util.common.TaskRestHandler.getInstance();
		this.processRestHandler = com.ibm.bpm.social.util.common.ProcessRestHandler.getInstance();
		
		this.subscript.innerHTML = this.changeDueDateDialogMessages.dueDateSubscript;
		this.label.innerHTML = this.changeDueDateDialogMessages.dueDate;
		
		this.dateTimePicker = new com.ibm.bpm.social.widgets.task.util.DateTime({
            dateTime: dojo.date.stamp.fromISOString(this.dueDate),         
            showNoLabels: true
        }, this.datepickerNode);
		this.connects.push(dojo.connect(this.dateTimePicker, "onChange", this, this._onChange));

		this.okButton.value = this.changeDueDateDialogMessages.ok;
		
		/* TODO
		Remove the following if/else once the following 3 lines have made it into theme.css (without lost update):
		.dijitRtl .processPortal .changeDueDateDialog .changeDueDateButtonBar input {
			float: left;
		}
		*/
		// Start delete
		if (document.body.dir == 'rtl') {
			dojo.style(this.okButton, "float", "left");
		}
		else {
			dojo.style(this.okButton, "float", "right");
		}
		// Stop delete
        
		this.inherited(arguments);

		com.ibm.bspace.common.util.ui.Button.setDisabled(this.okButton, true);
		this._onChange();
	},
	
    _onChange: function(){
      var valid = true;
      if (this.dateTimePicker) {
        valid = this.dateTimePicker.isValid();
      }
      com.ibm.bspace.common.util.ui.Button.setDisabled(this.okButton, !valid);
    },
	
	show: function(){
	    this.inherited(arguments);
		dojo.connect(this.popup, 'onHide', this, this.delayedDestroy);
	},
	
    hide: function(){
    	this.inherited(arguments);
		this.destroy();
    },

    _submit: function(arguments){
    	var val = false;
    	if(this.popup && this.popup.isValid){
    		val = this.popup.isValid();
    		if(val){
    			this._changeDueDate(arguments);
    		}
    	}
    },
    
    _changeDueDate: function(arguments){
    	var date = dojo.date.stamp.toISOString(this.dateTimePicker.getDateTime(), {zulu: true});
		
		if(this.instanceId != null) {
			params = {
				processID: this.instanceId,
				load: dojo.hitch(this, "_handleResponse"),
				error: dojo.hitch(this, "_onXhrErrors"),
				dueDate: date
			};
			this.processRestHandler.updateProcessProperties(params);
		} else if(this.taskId != null) {
			this.taskRestHandler.updateTaskProperties(this.taskId, dojo.hitch(this, "_handleResponse"),
				dojo.hitch(this, "_onXhrErrors"), "", date);
		} else {
			this.hide();
		}
    },

	_handleResponse: function(data, xhrArgs){
		var message = new com.ibm.bpm.social.Aether({
			'message': "<div>"+this.changeDueDateDialogMessages.changeDueDateSuccess+"</div>",
			'containerDivId':"messageNotificationDiv",
			'position': 'top-right',
			'fade': true,
			'parent': this,
			'displayCloseIcon': true
		});
		com.ibm.bpm.social.util.common.Util.currentInstanceData[this.instanceId] = data.data;
		
		if(this.callback!=null){
			this.callback(data.data);
		}
		
		dojo.publish(com.ibm.bpm.social.portal.Topics.INSTANCE_DUE_DATE_UPDATED+"."+this.instanceId, [data.data]);
		
		this.hide();
	},
	
	_onXhrErrors: function(data,xhrArgs) {
		var errMsg = "";
		if(xhrArgs && xhrArgs.xhr && typeof(xhrArgs.xhr.responseText)!='undefined') {
			var errMsg = "<div>"+dojo.fromJson(xhrArgs.xhr.responseText).Data.errorMessage+"</div>";
		}
		var message = new com.ibm.bpm.social.Aether({
			'message': "<div>"+this.changeDueDateDialogMessages.changeDueDateError+"</div>"+errMsg,
			'containerDivId':"messageNotificationDiv",
			'position': 'top-right',
			'fade': false,
			'parent': this,
			'displayCloseIcon': true
		});
	},
			
	destroy: function() {
		while (this.connects && this.connects.length > 1) {
	          dojo.disconnect(this.connects.pop());
	    }
		
		if(this.dateTimePicker!=null && this.dateTimePicker.destroy){
			this.dateTimePicker.destroy();
			this.dateTimePicker = null;
		}
		
		if(this.popup && this.popup.destroy){
			this.popup.destroy();	
		}
		
		this.inherited(arguments);
	},

	/*
	 * This method is used to destroy this.popup (our dijit.Dialog) after it's animation has finished.
	 * This is only invoked when the 'X' or Cancel button is pressed.
	 */
	delayedDestroy: function(){
		setTimeout(dojo.hitch(this, this.destroy), 1000);
	}
	
});
