dojo.provide("com.ibm.bpm.social.widgets.dialogs.ProcessDiagramDialog");

dojo.require("dijit._Templated");

dojo.require("dijit._Widget");

dojo.require("com.ibm.bpm.social.portal.Topics");

dojo.require("com.ibm.bspace.common.util.ui.FullScreenDialog");
dojo.require("com.ibm.bpm.social.util.baseTextDirection.BidiTextBox");

dojo.declare("com.ibm.bpm.social.widgets.dialogs.ProcessDiagramDialog", com.ibm.bspace.common.util.ui.FullScreenDialog, {

	templatePath: dojo.moduleUrl("com.ibm.bpm.social.widgets.dialogs", "templates/ProcessDiagramDialog.html"),
	
	instanceId: null,
	
	callback: null,
	
	diagram: null,
	
	criticalPathFlowIds: null,
	
	constructor: function(){
		/**** BEGIN Loading Process Diagram-specific modules ****/
		try{
			dojo.registerModulePath('ibm_ilog.diagram', ppConfig.portalContextRootJS+'/layers/'+socialversion+'/ibm_ilog/diagram');
			dojo["require"]("ibm_ilog.diagram.ibm_ilog_diagram_base"); //Alternate syntax used to avoid dojo build detection
		} catch (e) { 
			console.warn(e);
			dojo.registerModulePath('ibm_ilog.diagram', ppConfig.webviewerContextRootJS+'/widgets/ibm_ilog/diagram');
		}
		
		try{
			dojo.registerModulePath('com.ibm.bpm.wpd', ppConfig.portalContextRootJS+'/layers/'+socialversion+'/com/ibm/bpm/wpd'); //Needed, in addition to /com/ibm/bpm, for img & css files
			dojo["require"]("com.ibm.bpm.wpd_base"); //Alternate syntax used to avoid dojo build detection
		} catch (e) { 
			console.warn(e);
			dojo.registerModulePath('com.ibm.bpm.wpd', ppConfig.webviewerContextRootJS+'/widgets/com/ibm/bpm/wpd');
		}
		
		try{
			dojo["require"]("com.ibm.bpm.social_diagram"); //Alternate syntax used to avoid dojo build detection
		} catch (e) { 
			console.warn(e);
			dojo.registerModulePath('com.ibm.bpm.social', ppConfig.portalContextRootJS+'/com/ibm/bpm/social');
		}
		/**** END Loading Process Diagram-specific modules ****/
		
		//this.inherited(arguments); /* Removed because constructor is already called automatically via dojo */
	},
	
	postMixInProperties: function(){
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		
		this.dialogParams.closeButtonTooltip = this.messages.closeProcessDiagramTooltip;
		
		this.inherited(arguments);
	},	
		
	show: function(){
		
		this.inherited(arguments);
		//apply BTD to the title bar
		var titleBar = this.popup.titleBar;
		var titleDiv = this.popup.titleNode;
		var subTitleDiv;

		if(titleBar) {
			subTitleDiv = dojo.query(".dijitDialogSubtitle", titleBar)[0];
		}
		
		if(titleDiv) {
			com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(titleDiv);
		}

		if(subTitleDiv) {
			com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(subTitleDiv);
		}

		dojo.publish(com.ibm.bpm.social.portal.Topics.SHOW_DIALOG, [this.id]);

		this._sizeContent();

		dojo.style(this.wrapper, "width", "100%");
		dojo.style(this.wrapper, "margin", "0");
		dojo.style(this.wrapper, "padding", "0");
		dojo.style(this.wrapper, "position", "absolute");
		dojo.style(this.wrapper, "top", "0");
		dojo.style(this.wrapper, "bottom", "0");
		dojo.style(this.wrapper, "left", "0");
		dojo.style(this.wrapper, "right", "0");
		
		dojo["require"]("com.ibm.bpm.social.widgets.diagram.Participants");
		this.diagram = new com.ibm.bpm.social.widgets.diagram.Participants({
			instanceid: this.instanceId,
			criticalPathFlowIds: (this.criticalPathFlowIds!=null ? this.criticalPathFlowIds: [] )
		}, dojo.create("div", {}, this.wrapper));
		
		dojo.connect(this.popup, 'onHide', this, this.delayedDestroy);
		
		dojo.connect(window, 'onresize', this, this._sizeContent);
		
		dojo.subscribe(com.ibm.bpm.social.portal.Topics.CLOSE_PROCESS_DIAGRAM, dojo.hitch(this, this.delayedDestroy));
		this.refreshSubHandler = dojo.subscribe(com.ibm.bpm.social.portal.Topics.REFRESH_PROCESS_DIAGRAM, dojo.hitch(this, this.refresh));
		
		this.domNode.setAttribute("title", "");
	},
	
	refresh: function(){
		if(this.diagram){
			if(this.refreshSubHandler) {
				dojo.unsubscribe(this.refreshSubHandler);
			}
			this.diagram.destroy();
			this.diagram = null;
			setTimeout(dojo.hitch(this, this.show), 1500);
		}
	},
	
	_sizeContent: function(){
		var h = 0, w = 0;
		if(dojo.isIE){
			h = document.documentElement.offsetHeight;
			w = document.documentElement.offsetWidth;
		} else {
			h = window.innerHeight;
			w = window.innerWidth;
		}

		dojo.style(this.popup.domNode, "height", h+"px");
		dojo.style(this.popup.domNode, "width", w+"px");
		dojo.style(this.popup.domNode, "top", "0");
		dojo.style(this.popup.domNode, "left", "0");
		
		dojo.query(".dijitDialogPaneContent", this.popup.domNode).style("height", (h-50)+"px").style("width", w+"px").style("padding", "0"); //50px header height
		
		if(dojo.isIE < 9){
			dojo.query(".fullScreenDialog").style("left", "0").style("top", "0").style("overflow", "hidden");
			dojo.style(dojo.body(), "overflow", "hidden");
		}
		
		//dojo.style(this.domNode, "height", (h-50)+"px"); //35px header height + 15px padding
		//dojo.style(this.domNode, "width", (w)+"px"); //20px scrollbar?
		
		if(this.diagram && this.diagram.resize){
			this.diagram.resize();
		}
	},
	
	destroy: function() {
    	
		if(this.diagram && this.diagram.destroy){
			this.diagram.destroy();
			this.diagram = null;
		}
		
		this.inherited(arguments);
		
		if(dojo.isIE < 9){
			dojo.style(dojo.body(), "overflow", "auto");
		}
		
		if(this.popup && this.popup.destroy){
			this.popup.destroy();
		}

        dojo.publish(com.ibm.bpm.social.portal.Topics.HIDE_DIALOG, [this.id]);
	},
	
	/*
	 * This method is used to destroy this.popup (our dijit.Dialog) after it's animation has finished.
	 * This is only invoked when the 'X' or Cancel button is pressed.
	 */
	delayedDestroy: function(){
		this.diagram._closeOverlays();
		setTimeout(dojo.hitch(this, this.destroy), 1000);
	}
	
});