dojo.provide("com.ibm.bpm.social.widgets.dialogs.UserProfileDialog");

dojo.require("com.ibm.bspace.common.util.ui.Dialog");
dojo.require("com.ibm.bpm.social.util.baseTextDirection.BidiTextBox");

dojo.require("com.ibm.bpm.social.portal.Topics");

dojo.require("com.ibm.bpm.social.util.common.SocialRestHandler");

dojo.registerModulePath("com.ibm.socialPortal.templates", window.endpointURLObject.processPortalJS +"/com/ibm/bpm/social/widgets/dialogs/templates");

dojo.declare("com.ibm.bpm.social.widgets.dialogs.UserProfileDialog", com.ibm.bspace.common.util.ui.Dialog, {
	templateString: dojo.cache("com.ibm.socialPortal.templates", "userProfile.html"),
	avatarURL: null,
	avatarLoaded: false,
	dialogParams: { style: ""},
	connects: null,
	
	postMixInProperties: function(){
		dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.userProfileMessages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
		
		this.inherited(arguments);
	},	
	postCreate: function() {
		this.socialRestHandler = com.ibm.bpm.social.util.common.SocialRestHandler.getInstance();
		
		var self = this;
		this.addButton("updateButton", this.userProfileMessages.uploadAvatar, "onUpdate", self);
		
		this.changeAvatarLabel.innerHTML = this.userProfileMessages.changeAvatar;
		this.changeAvatarLabel.title = this.userProfileMessages.changeAvatarImage;
		this.removeAvatarLabel.innerHTML = this.userProfileMessages.removeAvatar;
		this.languageDropdownLabel.innerHTML = this.userProfileMessages.language;
        this.baseTextDirDropdownLabel.innerHTML = this.userProfileMessages.baseTextDir;
		this.calendarDropdownLabel.innerHTML = this.userProfileMessages.calendarType;

		// Portal Preferences section
		this.portalPreferencesLabel.innerHTML = this.userProfileMessages.portalPreferences;
		this.showConfirmationLabel.innerHTML = this.userProfileMessages.showConfirmation;		
		this.sendEmailLabel.innerHTML = this.userProfileMessages.sendEmail;
		this.sendConnectionsNotificationLabel.innerHTML = this.userProfileMessages.sendConnectionsNotification;
        this.userEmailInvalidMessage.innerHTML = this.userProfileMessages.invalidEmailAddress;
		this.autoFollowLabel.innerHTML = this.userProfileMessages.autoFollow;
		
		// Notification section
		this.notificationPreferencesLabel.innerHTML = this.userProfileMessages.notificationPreferences;
		this.assignToMeLabel.innerHTML = this.userProfileMessages.assignToMe;
		this.assignToGroupLabel.innerHTML = this.userProfileMessages.assignToGroup;
		this.mentionedLabel.innerHTML = this.userProfileMessages.mentioned;
		
		dojo.subscribe("com.ibm.bpm.avatarUpload", this, "fileUploaded");

		this.inherited(arguments);
		//Apply BTD to the userTitleEditField
		com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setInputElemBTD(this.userTitleEditField);
		
		//initialize variables to control whether the Send Connections Notificiations checkbox is disabled
		this._hasValidEmail = false;
		this._isConnectionsConfigured = false;
		this._checkConnectionsCheckboxConditions();
		
		// Add listeners to make the pen icon appear
		var penClass = "userProfileEditIcon";
		if(!this.connects) {
			this.connects = new Array();
		}

		var aConnect;
		aConnect = dojo.connect(this.userTitle, 'onmouseenter', this, function() { dojo.addClass(this.userTitleEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userTitle, 'onmouseleave', this, function() { dojo.removeClass(this.userTitleEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userTitleHint, 'onmouseenter', this, function() { dojo.addClass(this.userTitleEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userTitleHint, 'onmouseleave', this, function() { dojo.removeClass(this.userTitleEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userPhoneNumber, 'onmouseenter', this, function() { dojo.addClass(this.userPhoneNumberEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userPhoneNumber, 'onmouseleave', this, function() { dojo.removeClass(this.userPhoneNumberEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userPhoneNumberHint, 'onmouseenter', this, function() { dojo.addClass(this.userPhoneNumberEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userPhoneNumberHint, 'onmouseleave', this, function() { dojo.removeClass(this.userPhoneNumberEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userEmail, 'onmouseenter', this, function() { dojo.addClass(this.userEmailEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userEmail, 'onmouseleave', this, function() { dojo.removeClass(this.userEmailEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userEmailHint, 'onmouseenter', this, function() { dojo.addClass(this.userEmailEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.userEmailHint, 'onmouseleave', this, function() { dojo.removeClass(this.userEmailEditIcon, penClass); });
		this.connects.push(aConnect);

		aConnect = dojo.connect(this.languageDropdown, 'onchange', this, this._handleUserPrefLanguageChange);
		this.connects.push(aConnect);
		
		// Only do if IE is less than 10 as the text field will have a blue background (probably some IE bug) that no longer occurs in 10
		if (dojo.isIE && dojo.isIE <10) dojo.style(this.changeAvatarLabel, "color", "#ffffff");
	},
	
    changeAvatarByKeypress: function(e) {
         if (e.charOrCode == dojo.keys.ENTER) {
             this.changeAvatar();
         }
    },

	// Called when the Change link is clicked to trigger the file selection dialog
	changeAvatar: function() {
		dojo.require("com.ibm.bpm.social.widgets.dialogs.AvatarUploadDialog");
		if (!this.changeAvatarDialog) {
			this.changeAvatarDialog = new com.ibm.bpm.social.widgets.dialogs.AvatarUploadDialog();
		}
		this.changeAvatarDialog.show();
	},
	
	fileUploaded: function() {
		if (this.changeAvatarDialog && this.changeAvatarDialog.error) {
			
			this._displayAvatarError(this.changeAvatarDialog.error);
		} else {
            this._clearAvatarError();        
			this.loadAvatar();
		}
	},

    removeAvatarByKeypress: function(e) {
         if (e.charOrCode == dojo.keys.ENTER) {
             this.removeAvatar();
         }
    },

	removeAvatar: function() {
		this._clearAvatarError();
				
		if (this.avatarLoaded) {
			var self = this;

			this.socialRestHandler.deleteUserAvatar(function(data) {
					// Remove the imgage tag containing the avatar image
					var avatarImageNode = dojo.byId("avatarImage");
					if (avatarImageNode) {
						avatarImageNode.parentNode.removeChild(avatarImageNode);
					}
					this.avatarLoaded = false;
					self.toggleRemoveButton(false);
					self.toggleDefaultAvatar(true);
					
					var currUser = com.ibm.bpm.socialportal.GlobalAssets.getUserProfile().userName;
					com.ibm.bpm.social.util.common.Util.getUserAvatarURL(currUser,true);
					dojo.publish( com.ibm.bpm.social.portal.Topics.USER_PROFILE_CHANGED, [{"username": currUser}]);
					var scoreboardFrameVar = document.getElementById("scoreboardFrame");
					if (scoreboardFrameVar) {
						scoreboardFrameVar.contentWindow.postMessage('{"name": "USER_PROFILE_CHANGED", "username": "'+currUser+'"}','*');
					}
					
				}, function(error, ioargs) {
					console.log("REST call DELETING avatar image caused ERROR '" + error + "'");
				}, true);
		}
	},
	
	toggleRemoveButton: function(shouldShow) {
		if(!shouldShow) {
			this.removeAvatarLabel.style.visibility = "hidden";
			this.avatarDivider.style.visibility = "hidden";
		}
		else {
			this.removeAvatarLabel.style.visibility = "visible";
			this.avatarDivider.style.visibility = "visible";
		}
	},
	
	toggleDefaultAvatar: function(shouldShow) {
		if(!shouldShow) {
			dojo.addClass(this.userAvatar, "userAvatarDisabled");
		}
		else {
			dojo.removeClass(this.userAvatar, "userAvatarDisabled");
		}
	},
	
	loadAvatar: function() {
		var self = this;

		//REST call needed to determine if it's the default or not.
		var load = function(data){
			if(typeof(connectionsBridge)=="undefined" || !connectionsBridge.isAvatarCached(com.ibm.bpm.socialportal.GlobalAssets._userProfile.emailAddress)){
				dojo.style(self.changeAvatarLabel, "visibility", "visible");
				self.toggleRemoveButton(data.data.isDefault != "true");
				self.toggleDefaultAvatar(data.data.isDefault == "true");
			}
		};
		
		var error = function(error, ioargs){
			switch(ioargs.xhr.status){
				// In the case of a 404, assume no avatar is defined for this user and
				// don't treat as an error since the default avatar will be displayed.
				case 404:
					self.avatarLoaded = true;
					break;
				default:
					console.log("REST call loading avatar image caused ERROR '" + error + "'");
			}
		};
		
		this.socialRestHandler.getCurrentUserAvatar(load, error, true);
		
		//Everything else can be determined by URL automatically
		var imageElement = dojo.byId("avatarImage");
		if (!imageElement) {
			imageElement = document.createElement("img");
			imageElement.id = "avatarImage";
			self.userAvatar.insertBefore(imageElement, self.userAvatarError);
		}
		var currUser = com.ibm.bpm.socialportal.GlobalAssets.getUserProfile().userName;
		var avatar = com.ibm.bpm.social.util.common.Util.getUserAvatarURL(currUser);
		
		dojo.attr(imageElement, "src", avatar);

		// Added for accessibility 
		dojo.attr(imageElement, "tabindex", "0");
		var imageElementAriaLabel = this.userProfileMessages.avatar_image_label_default;
		if(this.removeAvatarLabel.style.visibility == "visible") {
			imageElementAriaLabel = this.userProfileMessages.avatar_image_label_custom;	
		}
		dojo.attr(imageElement, "alt", imageElementAriaLabel);
		
		if(typeof(connectionsBridge)!="undefined" && connectionsBridge.isAvatarCached(com.ibm.bpm.socialportal.GlobalAssets._userProfile.emailAddress)){
			dojo.style(this.changeAvatarLabel, "visibility", "hidden");
			dojo.style(this.avatarDivider, "visibility", "hidden");
			dojo.style(this.removeAvatarLabel, "visibility", "hidden");
		} 
		
		// Note: no error if  userAvatarImage is null, no avatar is defined for this user. 
		self.avatarLoaded = true;

		dojo.publish( com.ibm.bpm.social.portal.Topics.USER_PROFILE_CHANGED, [{"username": currUser}]);
		var scoreboardFrameVar = document.getElementById("scoreboardFrame");
		if (scoreboardFrameVar) {
			scoreboardFrameVar.contentWindow.postMessage('{"name": "USER_PROFILE_CHANGED", "username": "'+currUser+'"}','*');
		}
	},
	
	_displayAvatarError: function(errorMsg) {
		this.userAvatarError.innerHTML = errorMsg;
		var avatarImage = dojo.query("#avatarImage")[0];
		if(avatarImage) {
			avatarImage.style.display = "none"
		}
		this.userAvatarError.style.display = "";
	},
	
	_clearAvatarError: function() {
		this.userAvatarError.innerHTML = "";
		this.userAvatarError.style.display = "none";
		var avatarImage = dojo.query("#avatarImage")[0];
		if(avatarImage) {
			avatarImage.style.display = ""
		}
	},

	_clearEmailEditFieldError: function(email) {
        if (email == "") {
            this.userEmailInvalidMessage.style.display = "none";
            this._setHasValidEmail(false);
        } else {
            this._validateEmail(email);
        }	
	},

    _editFieldByKeypress: function(e) {
         if (e.charOrCode == dojo.keys.ENTER) {
             this._editField(e);
         }
    },

	_editField: function(e) {
		var targetId = e.currentTarget.id;
		if (targetId.indexOf("Hint") != -1) {
			dojo.byId(targetId).style.display = "none";
			targetId = targetId.replace("Hint", "");
		}	
	
		// Hide the edit icon if it is visibile
		dojo.byId(targetId + "EditIcon").style.display = "none";

		// Hide the displayed text and reveal the edit field
		var displayField = dojo.byId(targetId);
		var editField = dojo.byId(targetId + "EditField");
		editField.value = displayField.innerHTML;
		displayField.style.display = "none"
		dojo.byId(targetId + "Edit").style.display = "";
		editField.style.display = "";
		dijit.focus(editField);
	},
	_saveEditField: function(e) {
		var targetId = e.currentTarget.id;
	
		// Hide the edit field and reveal the text
		var editField = dojo.byId(targetId);
		
		editField.parentNode.style.display = "none";
		var displayFieldId = targetId.replace("EditField", "");
		var displayField = dojo.byId(displayFieldId);
		displayField.innerHTML = editField.value;
		
		var hintId = targetId.replace("EditField", "Hint");
		if (targetId == "userTitleEditField") {
			if (editField.value == "") {
				this.userTitleHint.style.display = "";
				dojo.byId(targetId.replace("EditField", "EditIcon")).style.display = "";
				displayField.style.display = "none";
			} else {
				this.userTitleHint.style.display = "none";
				displayField.style.display = "";
			}
			//Apply BTD to the userTitleEditField
			com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(this.userTitle);
		} else if (targetId == "userPhoneNumberEditField") {
			if (editField.value == "") {
				this.userPhoneNumberHint.style.display = "";
				dojo.byId(targetId.replace("EditField", "EditIcon")).style.display = "";
				displayField.style.display = "none";
			} else {
				this.userPhoneNumberHint.style.display = "none";
				displayField.style.display = "";
			}		
		} else if (targetId == "userEmailEditField") {
			if (editField.value == "") {
				this.userEmailHint.style.display = "";
				dojo.byId(targetId.replace("EditField", "EditIcon")).style.display = "";
				displayField.style.display = "none";
                dojo.byId("userEmailInvalidMessage").style.display = "none";
				this._setHasValidEmail(false);
			} else {
				this.userEmailHint.style.display = "none";
				displayField.style.display = "";
                this._validateEmail(editField.value);
			}
		} else {
			displayField.style.display = "";
		}
		editField.style.display = "none";
	},

    _validateEmail: function(email) {
         var emailRegEx = /^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i;
         if (email.search(emailRegEx) == -1) {
             this.userEmailInvalidMessage.style.display = "";
			this._setHasValidEmail(false);
         } else {
             this.userEmailInvalidMessage.style.display = "none";
			this._setHasValidEmail(true);
         }
    },

	_editFieldMouseover: function(e) {
		var editField = dojo.byId(e.currentTarget.id + "EditIcon");
		if (editField) {
			editField.style.display = "";
		}
	},
	_editFieldMouseout: function(e) {
		var editField = dojo.byId(e.currentTarget.id + "EditIcon");
		if (editField) {
			editField.style.display = "none";
		}		
	},

	_handleUserPrefLanguageChange: function() {
		// if the user profile language has changed to a RTL language,
		// make sure that the BTD Dropdown is shown
		var newOption = this.languageDropdown.options[this.languageDropdown.selectedIndex].value;
		if (newOption === 'ar' || newOption === 'he') {
			this._showBTDDropdown();
		} else {
			this._hideBTDDropdown();
		}
	},

	_setHasValidEmail: function(hasValidEmail) {
		this._hasValidEmail = hasValidEmail;
		this._checkConnectionsCheckboxConditions();
	},

	_setIsConnectionsConfigured: function(connectionsConfigured) {
		this._isConnectionsConfigured = connectionsConfigured;
		this._checkConnectionsCheckboxConditions();
	},

	_checkConnectionsCheckboxConditions: function() {
		if(!this._isConnectionsConfigured) {
			this._disableConnectionsCheckbox(this.userProfileMessages.sendConnectionsNotificationNoServer);
		}
		else {
			if(!this._hasValidEmail) {
				this._disableConnectionsCheckbox(this.userProfileMessages.sendConnectionsNotificationNoEmail);
			}
			else {
				this._enableConnectionsCheckbox();
			}
		}
	},

	_enableConnectionsCheckbox: function() {
		com.ibm.bspace.common.util.ui.CheckBox.setDisabled(this.sendConnectionsNotificationCheckbox, false);
		dojo.style(this.sendConnectionsNotificationError, "display", "none");
		this.sendConnectionsNotificationError.innerHTML = "";
	},

	_disableConnectionsCheckbox: function(reason) {
		com.ibm.bspace.common.util.ui.CheckBox.setDisabled(this.sendConnectionsNotificationCheckbox, true);
		dojo.style(this.sendConnectionsNotificationError, "display", "block");
		dojo.style(this.sendConnectionsNotificationError, "color", "#333"); //sorry for this!
		dojo.style(this.sendConnectionsNotificationError, "fontStyle", "italic");
		dojo.style(this.sendConnectionsNotificationError, "marginLeft", "2em");
		dojo.style(this.sendConnectionsNotificationError, "marginRight", "2em");
		this.sendConnectionsNotificationError.innerHTML = "" + reason;
	},
	
	/**
	 * If the logged in user isn't a member of tw_admins hide the checkbox for connection notifications (as it'll always be disabled for them).
	 * I might possibly be able to change the _disableConnectionsCheckbox to hide it, but maybe we'd still want to see it in certain cases
	 */
	_hideConnectionsNotification:function(memberships) {
		
		// Search for the admins groups, if we're a member of the tw_admins no need to continue
		for (var i=0; i<memberships.length;i++) {
			if ("tw_admins" == memberships[i])
				return;
		}
		
		// If the connections are configured no need to continue.
		if (this._isConnectionsConfigured)
			return;
		
		
		// Added a dojoAttachPoint to the option. I originally tried to hide the pieces inside, however it still left a one line whitespace.
		// Doing it on the option to tighten the view up
		// The connection isn't configured and the user isn't an admin. Hide the checkbox to send notifications
		dojo.style(this.sendConnectionsNotificationOption, "visibility", "hidden");
		dojo.style(this.sendConnectionsNotificationOption, "display", "none");


	},


	onUpdate: function() {
		// Gather the properties for the user from the dialog
		// For title, phone number, and address replace the hint with the empty string
		var userProfileFromDialog = {
			'Title': ((this.userTitle.innerHTML == this.userProfileMessages.jobTitle) ? "" : this.userTitle.innerHTML),
			'Phone Number': ((this.userPhoneNumber.innerHTML == this.userProfileMessages.phoneNumber) ? "" : this.userPhoneNumber.innerHTML),
			'Task Email Address': ((this.userEmail.innerHTML == this.userProfileMessages.emailAddress) ? "" : this.userEmail.innerHTML),
			'Locale': this.languageDropdown.options[this.languageDropdown.selectedIndex].value,
            'Base Text Direction': this.baseTextDirDropdown.options[this.baseTextDirDropdown.selectedIndex].value,
			'Calendar Type': this.calendarTypeDropdown.options[this.calendarTypeDropdown.selectedIndex].value,
			'Alert On Assign And Run': "" + this.showConfirmationCheckbox.checked,
			'Task Notification': "" + this.sendEmailCheckbox.checked,
			'Show Unfollow Messages': "" + this.autoFollowCheckbox.checked,
			'Portal Notification New Task To Me': "" + this.assignToMeCheckbox.checked,
			'Send Connections Notification On New Task': "" + this.sendConnectionsNotificationCheckbox.checked,
			'Portal Notification New Task To My Group': "" + this.assignToGroupCheckbox.checked,
			'Portal Notification Post Mention': "" + this.mentionedCheckbox.checked
		};	
		
		var localeChanged = false;
		for (var property in userProfileFromDialog) {
			if (this.originalUserProfile[property] != userProfileFromDialog[property]) {
				console.log("Updating user profile property '" + property + "' from '" + this.originalUserProfile[property] + "' to '" + userProfileFromDialog[property] + "'");
				com.ibm.bpm.socialportal.GlobalAssets.setUserPreference(property, userProfileFromDialog[property]);
				
				if (property == "Locale") {
					localeChanged = true;
				}
			}
		}
			
		this.hide();
		
		if (localeChanged) {
			// Reset the Base Text Direction to Contextual, so they aren't stuck in RTL if changing to a LTR language
			// Unless the User has changed their locale to a RTL language, in which case we want to save the new BTD preference
			if (userProfileFromDialog["Locale"] != 'ar' && userProfileFromDialog["Locale"] != 'he') {
				com.ibm.bpm.socialportal.GlobalAssets.setUserPreference('Base Text Direction', 'generalPreference.fields.baseTextDir.contextual');
			}

			dojo.require("com.ibm.bpm.social.widgets.dialogs.ErrorDialog");
			com.ibm.bpm.social.widgets.dialogs.ErrorDialog.showInfo(this.userProfileMessages.localeChangeWarning, function(){
				return;
			});
		}
	},

	_showBTDDropdown: function() {
		// shows the base text direction dropdown for RTL languages
		if (dojo.isIE) {
			dojo.style(this.baseTextDirDropdown, "display", "inline");			
			dojo.style(this.baseTextDirDropdownLabel, "display", "inline");
		} else {
			dojo.attr(this.baseTextDirDropdown, "hidden", false);
			dojo.attr(this.baseTextDirDropdownLabel, "hidden", false);
		}
	},

	_hideBTDDropdown: function() {
		// hides the base text direction dropdown for LTR languages
		if (dojo.isIE) {
			dojo.style(this.baseTextDirDropdown, "display", "none");			
			dojo.style(this.baseTextDirDropdownLabel, "display", "none");
		} else {
			dojo.attr(this.baseTextDirDropdown, "hidden", true);
			dojo.attr(this.baseTextDirDropdownLabel, "hidden", true);
		}			

		// change the styling so it doesn't look funny when these dropdowns are hidden
		dojo.attr(this.baseTextDirDropdown.parentNode, "style", "padding-top:0;padding-bottom:0");
	},
	
	refresh: function() {
		this._clearAvatarError();
	
		// Load the user profile from the GlobalAssets
		var userProfileObj = com.ibm.bpm.socialportal.GlobalAssets.getUserProfile();
		this.originalUserProfile = userProfileObj.userPreferences;
		// Set locale to the browser locale if blank so the locale change warning won't get displayed the first time you update.
		if (this.originalUserProfile['Locale'] == "") {
			this.originalUserProfile['Locale'] = dojo.locale;
		}
		
		// Load the user profile from the GlobalAssets
		this.userName.innerHTML = userProfileObj['fullName'];
		com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(this.userName);
		var title = userProfileObj.userPreferences['Title'];
		this.userTitle.innerHTML = title;
		com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(this.userTitle);
		this.userTitleHint.innerHTML = this.userProfileMessages.jobTitle;
		if (!title || title == "") {
			this.userTitleHint.style.display = "";
			this.userTitle.style.display = "none";
		} else {
			this.userTitleHint.style.display = "none";
			this.userTitle.style.display = "";
		}
		
		var phoneNumber = userProfileObj.userPreferences['Phone Number'];
		this.userPhoneNumber.innerHTML = phoneNumber;
		this.userPhoneNumberHint.innerHTML = this.userProfileMessages.phoneNumber;
		if (!phoneNumber || phoneNumber == "") {
			this.userPhoneNumberHint.style.display = "";
			this.userPhoneNumber.style.display = "none";
		} else {
			this.userPhoneNumberHint.style.display = "none";
			this.userPhoneNumber.style.display = "";
		}
		
		var email = userProfileObj.userPreferences['Task Email Address'];
		this.userEmail.innerHTML = email;
		this.userEmailHint.innerHTML = this.userProfileMessages.emailAddress;
		if (!email || email == "") {
			this.userEmailHint.style.display = "";
			this.userEmail.style.display = "none";
		} else {
			this.userEmailHint.style.display = "none";
			this.userEmail.style.display = "";
		}        
        this._clearEmailEditFieldError(email);

		var self = this;
		var supportedLocales = [];
		var languageStrings = [];
		var xhrArgs = {
			url: window.endpointURLObject.processPortalJS +"/jsp/socialPortal/getLocales.jsp?availableLocales=" + window.bspaceSupportedLocales + "&userLocale=" + userProfileObj.userPreferences['Locale'],
			handleAs: "json",
			headers: {
				"Accept": "application/json"
			},
			load: function(data){
				for (var p in data) {
					supportedLocales.push(p);
					languageStrings[p] = data[p];
				}
        if (self.languageDropdown.length == 0) {
    		for (var i=0; i<supportedLocales.length; i++) {
    			var localeString = languageStrings[supportedLocales[i]];
    			if (!localeString) {
    				localeString = supportedLocales[i];
    			}
    			self.languageDropdown.add(new Option(localeString, supportedLocales[i]));
    			if (userProfileObj.userPreferences['Locale'] == '') {
    				// If no locale is provided, default to the locale set in the browser
    				if (supportedLocales[i] == dojo.locale) {
    					self.languageDropdown.selectedIndex = i;
    				}
    			} else if (supportedLocales[i] == userProfileObj.userPreferences['Locale']) {
    				self.languageDropdown.selectedIndex = i;
    			}
    		}
        }
			},
			 error: function(error, ioargs){
				// In case of errors, return just the hardcoded list
				supportedLocales = window.bspaceSupportedLocales.replace(/he/,"iw").split(",");
				languageStrings = this.userProfileMessages;
			}
		};

		// Call the asynchronous xhrGet
		var deferred = dojo.xhrGet(xhrArgs);
        /*if (this.languageDropdown.length == 0) {
    		for (var i=0; i<supportedLocales.length; i++) {
    			var localeString = languageStrings[supportedLocales[i]];
    			if (!localeString) {
    				localeString = supportedLocales[i];
    			}
    			this.languageDropdown.add(new Option(localeString, supportedLocales[i]));
    			if (userProfileObj.userPreferences['Locale'] == '') {
    				// If no locale is provided, default to the locale set in the browser
    				if (supportedLocales[i] == dojo.locale) {
    					this.languageDropdown.selectedIndex = i;
    				}
    			} else if (supportedLocales[i] == userProfileObj.userPreferences['Locale']) {
    				this.languageDropdown.selectedIndex = i;
    			}
    		}
        }*/
		
		// Enable the Send Connections Notifications On New Task checkbox if connections is enabled (provided a valid e-mail address)
		var connURL = com.ibm.bpm.social.util.common.Util.getConnectionsURL();
		this._setIsConnectionsConfigured(typeof(connURL) != "undefined" && connURL != null && connURL.indexOf("connectionUserId=") > -1);
		
		// Load base text direction dropdown values and set selected index
		this.baseTextDirDropdown.selectedIndex = 0;
		var baseTextDirIndex = 0;
		this.baseTextDirDropdown.options.length = 0;
		for (var options in com.ibm.bpm.baseTextDir) {
			this.baseTextDirDropdown.add(new Option(com.ibm.bpm.baseTextDir[options], options));
			if (userProfileObj.userPreferences['Base Text Direction'] == '') {
				// If no base text direction is provided, default to Default
				if (options == "generalPreference.fields.baseTextDir.default") {
					this.baseTextDirDropdown.selectedIndex = baseTextDirIndex;
				}
			} else if (options == userProfileObj.userPreferences['Base Text Direction']) {
				this.baseTextDirDropdown.selectedIndex = baseTextDirIndex;
			}
			baseTextDirIndex++;
		}

		// Hide the BTD dropdown if not a RTL language
		var locale = userProfileObj.userPreferences['Locale'];
		if (locale === '') {
			locale = dojo.locale;
		}

		var browserLocale;
		if (dojo.isIE) {
			browserLocale = navigator.browserLanguage;
		} else {
			browserLocale = navigator.language;
		}

		if (locale.substring(0, 2) != 'ar' && locale != 'he' && browserLocale.substring(0, 2) != 'ar' && browserLocale != 'he') { 
			this._hideBTDDropdown();						
		} else {
			this._showBTDDropdown();					
		}


        // Load calendar dropdown values and set selected index
        this.calendarTypeDropdown.selectedIndex = 0;
        var calendarIndex = 0;
        this.calendarTypeDropdown.options.length = 0;
        for (var options in com.ibm.bpm.calendarTypes) {
            this.calendarTypeDropdown.add(new Option(com.ibm.bpm.calendarTypes[options], options));
            if (userProfileObj.userPreferences['Calendar Type'] == '') {
                // If no calendar type is provided, default to Gregorian
                if (options == "generalPreference.fields.calendarType.gregorian") {
                    this.calendarTypeDropdown.selectedIndex = calendarIndex;
                }
            } else if (options == userProfileObj.userPreferences['Calendar Type']) {
                this.calendarTypeDropdown.selectedIndex = calendarIndex;
            }
            calendarIndex++;
        }

		// Portal Preferences section
		com.ibm.bspace.common.util.ui.CheckBox.setChecked(this.showConfirmationCheckbox, (userProfileObj.userPreferences['Alert On Assign And Run'] == "true")?true:false);
		com.ibm.bspace.common.util.ui.CheckBox.setChecked(this.sendEmailCheckbox, (userProfileObj.userPreferences['Task Notification'] == "true")?true:false);
		com.ibm.bspace.common.util.ui.CheckBox.setChecked(this.sendConnectionsNotificationCheckbox, (userProfileObj.userPreferences['Send Connections Notification On New Task'] == "true")?true:false);
		com.ibm.bspace.common.util.ui.CheckBox.setChecked(this.autoFollowCheckbox, (userProfileObj.userPreferences['Show Unfollow Messages'] == "true")?true:false);
		
		// Notification section
		com.ibm.bspace.common.util.ui.CheckBox.setChecked(this.assignToMeCheckbox, (userProfileObj.userPreferences['Portal Notification New Task To Me'] == "true")?true:false);
		com.ibm.bspace.common.util.ui.CheckBox.setChecked(this.assignToGroupCheckbox, (userProfileObj.userPreferences['Portal Notification New Task To My Group'] == "true")?true:false);
		com.ibm.bspace.common.util.ui.CheckBox.setChecked(this.mentionedCheckbox, (userProfileObj.userPreferences['Portal Notification Post Mention'] == "true")?true:false);
		
		// The parameters to pass to xhrGet, the url, how to handle it, and the callbacks.
		if (!this.avatarLoaded) {
			this.loadAvatar();
		}
		
		this._hideConnectionsNotification(userProfileObj.memberships);
			
		return userProfileObj;
	},
	show: function() {
		this.avatarLoaded = false;	// Always reload the avatar when showing the dialog
		this.refresh();
		this.inherited(arguments);
		
		// Adjust spacing of Change and Remove links underneith the avatar if the strings are wider than the avatar image
		var avatarWidth = 105;
		var avatarOptionsContainer = dojo.query(".userAvatarOptions");
		if(avatarOptionsContainer && avatarOptionsContainer.length > 0) {
			//Hide if on Ipad
			if (dojo.isSafari && navigator.userAgent.indexOf('iPad') != -1) {
				avatarOptionsContainer[0].style.display = "none";
			} else {
				var avatarLinksNode = avatarOptionsContainer[0];
				/* Grab the options:
				 * [0] = userProfileChangeAvatar
				 * [1] = userProfileAvatarOptionsDivider
				 * [2] = userProfileAvatarOptionsNewLineMarker
				 * [3] = userProfileRemoveAvatar
				 * [4] = the nofloat float fix div
				 */
				var avatarOptions = dojo.query(".userAvatarOptions > *");
				
				//calculate how much extra space is left under the avatar with the options
				var changeWidth = dojo.style(avatarOptions[0], "width");
				var dividerWidth = dojo.style(avatarOptions[1], "width");
				var removeWidth = dojo.style(avatarOptions[3], "width");
				var totalWidth = changeWidth + dividerWidth + removeWidth;
				var extraSpace = avatarWidth - totalWidth;
				
				/* Determine if there is enough space to keep it all on one line and
				 * add the necessary padding to the divider, otherwise move remove to second 
				 * line and hide the divider if visible
				 */
				if(extraSpace > 6) {
					var dividerPadding = extraSpace / 2;
					dojo.style(avatarOptions[1], "padding", "0px " + dividerPadding + "px 0px " + dividerPadding + "px"); 
				} else {
					dojo.style(avatarOptions[2], "display", "block");
					if(dojo.style(avatarOptions[1], "visibility") == "visible") {
						dojo.style(avatarOptions[1], "display", "none");
					}	
				}
				
			}
		}
	},

	destroy: function() {
		//clean up the connects
		if(this.connects) {
			for(var i=0; i < this.connects.length; i++) {
				dojo.disconnect(this.connects[i]);
				this.connects[i] = null;
			}
			this.connects = null;
		}
		
		this.inherited(arguments);
	}
});
