/* 
   Licensed Materials - Property of IBM
   5725-C96
   Copyright IBM Corporation 2011,2013. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.bpm.social.widgets.experts.ExpertTile");

dojo.require("dijit._Templated");

dojo.require("dijit._Widget");

dojo.require("com.ibm.bpm.social.util.common.Util");
dojo.require("com.ibm.bpm.social.util.common.SocialRestHandler");
dojo.require("com.ibm.bpm.social.widgets.dialogs.InvitationDialog");
dojo.require("com.ibm.bpm.social.widgets.diagram.ActivityOwnerTooltip");
dojo.require("com.ibm.bpm.social.widgets.common.BizCard");
dojo.require("com.ibm.bpm.social.util.baseTextDirection.BidiTextBox");
dojo.require("com.ibm.bpm.social.util.ui.Avatar");
dojo.require( "dojo.number");

dojo.declare(
	"com.ibm.bpm.social.widgets.experts.ExpertTile",
	[dijit._Widget, dijit._Templated],
	{
	
    templateString: "",
	templatePath: dojo.moduleUrl("com.ibm.bpm.social.widgets.experts", "templates/ExpertTile.html"),
	completed: 0,
	avgHours: 0,
	workload: 0,
	userName: null,
	fullName: null,
	phoneNumber: null,
	email: null,
	imageUrl: null,
	taskId: null,
	livename: null,
	refresh: null,
	title: "",
	includeTaskDetails: false,
	sidebar: false,
	userDataUrl: window.endpointURLObject.bpmRest +"/v1/social/task/{tid}/userdata?username={username}",
	collaborate: false,
	
    postCreate: function() {
    	this.inherited(arguments);
    	
    	dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");

		this.socialRestHandler = com.ibm.bpm.social.util.common.SocialRestHandler.getInstance();
		
		this.mention.innerHTML = "@"+this.messages.expertsMention;
		this.gethelp.innerHTML = this.messages.expertsCollaborate;
		this.startchat.innerHTML = this.messages.expertsChat;
		
		this.name.innerHTML = this.fullName;
        com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(this.name);
		
		var curdate = new Date();
		var millisec = curdate.getTime();
		var nameId = "expertTile_name" + millisec;
		dojo.attr(this.name, "id", nameId);	
		dijit.setWaiState(this.mention, "describedby", nameId);
		dijit.setWaiState(this.gethelp, "describedby", nameId);
		dijit.setWaiState(this.startchat, "describedby", nameId);
		
		this.actionSeparator1.innerHTML = this.messages.expertsSeparator;
		this.actionSeparator2.innerHTML = this.messages.expertsSeparator;
		
		if (!this.sidebar) {
			this.mention.style.display = 'none';
			this.actionSeparator1.style.display = 'none';
		}
		
    	this._getUserData();
    	
    	this.domNode.title = "";
		
		if (!this.collaborate) {
			this.actionSeparator1.style.display = 'none';
			this.helpDiv.style.display = 'none';
		}
    	
		if(window.sametime && this.fullName){
			// the text-overflow:ellipsis style does not function properly
			// when there are span elements within the div, so clip the
			// text instead if we are using sametime
			this.name.style.textOverflow = 'clip';
			
			this.name.innerHTML = "";
			this.livename = window.sametime.LiveName({'userId': this.userName, 'disableClicks': true, 'disableHoverBizCard': true},dojo.create("span", null, this.name));
			this.livename.activate();
			
			this._updateStatus();
			this.refresh = setInterval(dojo.hitch(this, this._updateStatus), 2000);
		} else {
			dojo.style(this.chatDiv, "display", "none");
		}			   

		/** Business Card integration **/
		/** Default **/
		var node = this.name;
		var user = com.ibm.bpm.social.util.common.Util.getUser(this.userName);
		
		if(this.livename!=null){
			var nodes = dojo.query(".stproxy_liveNamePadding", this.name);
			if(nodes.length==1){
				node = nodes[0];
				var img = dojo.create("img", {
					"src": dojo.moduleUrl("dojo", "resources/blank.gif"),
					"class": "connectionsOverlayImage"
					},
					dojo.query(".stproxy_general", this.domNode)[0],
					"first");
				com.ibm.bpm.social.widgets.common.BizCard.wrapImage(img, user);
			}
		}
		com.ibm.bpm.social.widgets.common.BizCard.wrapElement(node, user);
		com.ibm.bpm.social.widgets.common.BizCard.wrapImage(dojo.query("img", this.img)[0], user);

		/** End Business Card integration **/
		
		this.avatar = new com.ibm.bpm.social.util.ui.Avatar({}, this.avatarContent);
		this.avatar.setUser(user, "bpm-social-default-avatar-medium", true);

		this._updateUserData();
		var data;
		var firstName = this.fullName.split(" ")[0]; 
        firstName = com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.applyUCCToText(firstName);
		if(this.includeTaskDetails){
			if(this.completed==0){
				this.taskDetails.innerHTML = this.messages.expertNoTaskData.replace("${user}", firstName);
			} else {
				data = {
					'userName': firstName,
					'average': this.avgHours,
					'completed': this.completed
				};
				//defect 149810 Fix Expert tooltip wording
				if(this.sidebar){
				   this.taskDetails.innerHTML = dojo.replace(this.messages.expertsTooltip, data, /\$\{([^\}]+)\}/g);
				} else {
				   this.taskDetails.innerHTML = dojo.replace(this.messages.expertsTooltip_short, data, /\$\{([^\}]+)\}/g);
				}
			}
            dojo.attr(this.taskDetails,"id","taskDetails_"+nameId);
            dijit.setWaiState(this.name,"describedby","taskDetails_"+nameId);
		}
	},
	  
	_showTooltip: function(){
		
		return;
		/*
		if(!com.ibm.bpm.social.widgets.common.BizCard.useDefaultCard()){
			** Do not show if Connections is enabled **
			return;
		}
		
		if (this.myTooltipDialog) {
			this.myTooltipDialog = null;
		}
		
		this._updateUserData();
		
		var firstName = this.fullName.split(" ")[0]; 
		
		var data = {
				'fullName': this.fullName,
				'userName': this.userName, 
				'avgHours': this.avgHours,
				'completed': this.completed,
				'displayName': this.fullName,
				'title': typeof(this.userData['Title'])!='undefined' ? 
						this.userData['Title'] : '',
				'taskEmailAddress': typeof(this.userData['Task Email Address'])!='undefined' ? 
						this.userData['Task Email Address'] : '',
				'phoneNumber': typeof(this.userData['Phone Number'])!='undefined' ? this.userData['Phone Number'] : '',
				'taskDetails': "",
				'chatString': '',
				'hr': "",
				'includeTaskDetails': false
		};
		
		this.activityOwner = new com.ibm.bpm.social.widgets.diagram.ActivityOwnerTooltip(data);
		
		this.myTooltipDialog = new dijit.TooltipDialog({
            content: this.activityOwner.domNode,
            onMouseLeave: function(){
                dijit.popup.close(this.myTooltipDialog);
            }
        });
		dijit.popup.open({
			popup: this.myTooltipDialog,
			around: dojo.byId('expert-avatar')
		});

		*/
		
	},
	
	_hideTooltip: function() {
		if (this.myTooltipDialog) {
			this.myTooltipDialog = null;
		}

	},
	
	//defect 149810 fix so that task completed is an integer and does not have decimal places
	_updateUserData: function() {
		var self = this;
		
		this.socialRestHandler.getExpertUserData(this.taskId, this.userName,
			function(data, xhrArgs) {
				if(data.avgHours < 1){
					self.avgHours = dojo.number.format( data.avgHours, {type: "decimal", pattern: "0.#", places: 1});
				} else {
					self.avgHours = dojo.number.format( data.avgHours, {places: 1 } );
				}
				self.completed = dojo.number.format( data.completed, {places: 0 } ); 
			}, "", false);
	},
	
	_getUserData: function(){
		var user = com.ibm.bpm.social.util.common.Util.getUser(this.userName);
		this.userData = user.userPreferences;
		if (!this.userData) {
			this.userData = new Object();
		}		
	},
	
	_updateStatus: function(){
		dojo.removeClass(this.domNode, "online");
		dojo.removeClass(this.domNode, "offline");
		
		if(this.livename){
			switch(this.livename.currentTextStyle){
				case "stproxy_liveNameAvailableText":
				case "stproxy_liveNameAwayText":
				case "stproxy_liveNameInMeetingText":
					dojo.addClass(this.domNode, "online");
					this.presenceStatus = "online";
					break;
				case "stproxy_liveNameOfflineText":
				case "stproxy_liveNameDndText":
				default:
					dojo.addClass(this.domNode, "offline");
					this.presenceStatus = "offline";
					break;
			}
		} else {
			dojo.style(this.chatDiv, "display", "none");
		}
		
		/** Business Card integration **/
		if(!com.ibm.bpm.social.widgets.common.BizCard.useDefaultCard() && this.livename!=null){
			/** Account for Sametime DOM structure, which can be delayed in being created due to network latency **/
			var nodes = dojo.query(".stproxy_liveNamePadding .hasHover", this.name);
			if(nodes.length==0){
				nodes = dojo.query(".stproxy_liveNamePadding", this.name);
				if(nodes.length==1){
					var user = com.ibm.bpm.social.util.common.Util.getUser(this.userName);
					com.ibm.bpm.social.widgets.common.BizCard.wrapElement(nodes[0], user); 
				}
			}
		}
		/** End Business Card integration **/
		
	},
	
	_handleGetHelp: function(e){
		var taskData = com.ibm.bpm.social.util.common.Util.getTaskData({"taskId": this.taskId});
		com.ibm.bpm.social.widgets.dialogs.InvitationDialog.showDialog(taskData, {
			userName: this.userName,
			fullName: this.fullName
		});		
		dojo.stopEvent(e);
	},
	
	_handleChat: function(e){
		if(this.livename && this.presenceStatus=="online"){
			this.livename.startChat();
		}
		dojo.stopEvent(e);
	},
	
	_getTaskCompletionView: function() {
		var node = this.domNode;
		while (node && !dojo.hasClass(node,'workViewCompletion')) {
			node = node.parentNode;
		}
		if (node == null) {
			node = dojo.query('.workViewCompletion')[0];
		}
		var taskCompletionView = dijit.byId(node.id);
		return taskCompletionView;
	},
	
	_handleMention: function(e){
		var taskCompletionView = this._getTaskCompletionView();
		if (taskCompletionView) {
			// switch to the stream tab
			taskCompletionView.sidebar.selectTab(1);
			// set focus to input box
			taskCompletionView.stream._handlePostInitialFocus();
			// tag user
			taskCompletionView.stream.tagUser(this.userName,this.fullName);
		}
		dojo.stopEvent(e);
	},
	
	_doMouseEnter: function(e){
		dojo.addClass(this.expert, 'hover');
	},
	
	_doMouseLeave: function(e){
		dojo.removeClass(this.expert, 'hover');
	},
	
	_onFocus: function() {
		dojo.addClass(this.domNode,'bpm-social-experts-focus');
	},
	
	_onBlur: function() {
		dojo.removeClass(this.domNode,'bpm-social-experts-focus');
	},
	
	_focusStart: function() {
		if (this.sidebar) {
			this.mention.focus();
		} else {
			this.gethelp.focus();
		}
	},
	
	_focusEnd: function() {
		if(this.livename){
			this.startchat.focus();
		} else {
			this.gethelp.focus();
		}
	},
	
	destroy: function() {
		if(this.refresh){
			clearInterval(this.refresh);
		}
		this._hideTooltip();
	    if (this.avatar) {
	        this.avatar.destroy();
	        this.avatar = null;
	    }
		this.inherited(arguments);
	}

});
