// ControllerConfig.js
// BEGIN COPYRIGHT
// *************************************************************************
//
// Licensed Materials - Property of IBM
// 5725-C96
// (C) Copyright IBM Corporation 2011, 2012. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// *************************************************************************
// END COPYRIGHT
dojo.provide("com.ibm.bpm.social.widgets.task.config.ControllerConfig");

dojo.require("com.ibm.bpm.social.widgets.task.config.FilterConfig");
dojo.require("com.ibm.bpm.social.widgets.task.config.ViewConfig");

dojo.require("com.ibm.bpm.social.widgets.task.util.Constants");

/**
 * ControllerConfig: Controller Settings for a Worktab sub-tab
 */
dojo.declare("com.ibm.bpm.social.widgets.task.config.ControllerConfig", null, {
  controllerId: null,
  viewConfig: null,
  filterConfigs: null,
  type: null,

  constructor: function constructor_ControllerConfig(controllerId, type, viewConfig, filterConfigs, selectedFilter){
    this.controllerId = controllerId;
    this.type = type;
    if (viewConfig) {
      this.viewConfig = viewConfig;
    }
    if (filterConfigs) {
      this.filterConfigs = filterConfigs;
    }
    if (selectedFilter) {
      this.selectedFilter = selectedFilter;
    }
    this.pageSize = 20;
  }
});

com.ibm.bpm.social.widgets.task.config.ControllerConfig.getMyTasksConfig =
  function(){
    var viewConfig = com.ibm.bpm.social.widgets.task.config.ViewConfig.getMyTasksConfig();

    return new com.ibm.bpm.social.widgets.task.config.ControllerConfig(viewConfig.id,
      com.ibm.bpm.social.widgets.task.util.Constants.TASK_TYPE,
      viewConfig,
      [com.ibm.bpm.social.widgets.task.config.FilterConfig.getFilterConfigOpenTasks(),
       com.ibm.bpm.social.widgets.task.config.FilterConfig.getFilterConfigCompletedTasks()],
      "openTasks");
  };

com.ibm.bpm.social.widgets.task.config.ControllerConfig.getCustomViewsConfig =
  function(){
    var viewConfig = com.ibm.bpm.social.widgets.task.config.ViewConfig.getCustomViewsConfig();

    return new com.ibm.bpm.social.widgets.task.config.ControllerConfig(viewConfig.id,
      com.ibm.bpm.social.widgets.task.util.Constants.TASK_TYPE,
      viewConfig,
      [com.ibm.bpm.social.widgets.task.config.FilterConfig.getFilterConfigCustomViews()],
      "customViews");
  };