// ViewConfig.js
//BEGIN COPYRIGHT
//*************************************************************************
//
// Licensed Materials - Property of IBM
// 5725-C96
// (C) Copyright IBM Corporation 2011, 2012. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
//*************************************************************************
//END COPYRIGHT 
dojo.provide("com.ibm.bpm.social.widgets.task.config.ViewConfig");


/**
 * View Config: Settings about the view content of a WorkTab sub tab
 */
dojo.declare("com.ibm.bpm.social.widgets.task.config.ViewConfig", null, {

  id: null,

  allowCollapseExpand: true, // or false

  viewType: "list", // or table

  queueName: "IBM.DEFAULTALLTASKSLIST_75",

  titleKey: null,

  selectedAttributes: null,

  tooltipKey: null,

  constructor: function constructor_ViewConfig(obj){
    dojo.safeMixin(this, obj);
  }

});

com.ibm.bpm.social.widgets.task.config.ViewConfig.getMyTasksConfig = function(){

  var viewConfig = new com.ibm.bpm.social.widgets.task.config.ViewConfig({
    id: com.ibm.bpm.social.widgets.task.config.ViewConfig.ID_MY_TASKS,
    viewType: "list",
    allowCollapseExpand: true,
    queueName: "IBM.DEFAULTALLTASKSLIST_75",
    titleKey: "task_myTasks",
    tooltipKey: "task_myTasks_tooltip",
    selectedAttributes: null
  });


  // TODO activate if ASSIGNED_TO_ROLE is available
  // "TKIID,TAD_DISPLAY_NAME,PRIORITY,DUE,PI_DISPLAY_NAME,OWNER,ASSIGNED_TO_ROLE_DISPLAY_NAME,STATE");

  return viewConfig;
};

com.ibm.bpm.social.widgets.task.config.ViewConfig.getCustomViewsConfig = function(){

  var viewConfig = new com.ibm.bpm.social.widgets.task.config.ViewConfig({
    id: com.ibm.bpm.social.widgets.task.config.ViewConfig.ID_SAVED_SEARCHES,
    viewType: "table",
    allowCollapseExpand: false,
    queueName: null,
    titleKey: "task_customViews",
    tooltipKey: "task_customViews_tooltip",
    selectedAttributes: null
  });
  return viewConfig;
};

com.ibm.bpm.social.widgets.task.config.ViewConfig.ID_MY_TASKS = "myTasks";
com.ibm.bpm.social.widgets.task.config.ViewConfig.ID_SAVED_SEARCHES = "SavedSearches";
