// PaginationBar.js
//BEGIN COPYRIGHT
//*************************************************************************
//
// Licensed Materials - Property of IBM
// 5725-C96
// (C) Copyright IBM Corporation 2011, 2012. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
//*************************************************************************
//END COPYRIGHT 
dojo.provide("com.ibm.bpm.social.widgets.task.list.PaginationBar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");

dojo.requireLocalization("com.ibm.bpm.social", "bpmTask");

dojo
  .declare(
    "com.ibm.bpm.social.widgets.task.list.PaginationBar",
    [dijit._Widget,
     dijit._Templated],
    {


      // ASZ: Please leave the &nbsp; in the paginationText as placeholder for the message. This is required for the height measuring
      templateString: '<div>\
        <div dojoAttachPoint="paginationText" class="bpm-task-pagination">&nbsp;</div>\
        <button dojoAttachPoint="paginationButton" id="taskListPaginationButton_${id}" type="button"></button>\
        </div>',

      count: null,

      globalCount: null,

      postCreate: function(){
        this._nlsResources = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmTask");
        this.paginationButton.innerHTML = this._nlsResources["task_show_more_button"];
        this.paginationButton.title = this._nlsResources["task_show_more_button_tooltip"];
        com.ibm.bspace.common.util.ui.Button.wrapElement(this.paginationButton);
        this.connect(this.paginationButton, "onclick", "_showMore");
      },

      destroy: function(){
        com.ibm.bspace.common.util.ui.Button.unwrapElement(this.paginationButton);
      },

      getPageSize: function getPageSize_PaginationBar(){
        if (this.count === null) {
          this.count = com.ibm.bpm.social.widgets.task.list.PaginationBar.MORE_COUNT;
        }
        return this.count;
      },

      _showMore: function _showMore_PaginationBar(){
        com.ibm.bspace.common.util.ui.Button.setDisabled(this.paginationButton, true);
        this.count = this.count * 2;
        this.onShowMore();
      },

      onShowMore: function onShowMore_PaginationBar(){},

      setLocalCount: function setLocalCount_PaginationBar(count, countLimitExceeded){
        this.localCount = count;
        this._updatePaginationText(countLimitExceeded);
      },

      getGlobalCount: function getGlobalCount_PaginationBar(){
        return this.globalCount;
      },

      setGlobalCount: function setGlobalCount_PaginationBar(count, countLimitExceeded){
        this.globalCount = count;
        this._updatePaginationText(countLimitExceeded);
      },

      showPaginationButton: function showPaginationButton_PaginationBar(show){
        if (show === false) {
          com.ibm.bpm.social.util.common.Log.log(2, "Hiding pagination button.");
          dojo.style(this.paginationButton, "display", "none");
        }
        else {
          // all other values, even the undefined case: in doubt, do not make user stuck
          com.ibm.bpm.social.util.common.Log.log(2, "Showing pagination button.");
          com.ibm.bspace.common.util.ui.Button.setDisabled(this.paginationButton, false);
          dojo.style(this.paginationButton, "display", "block");
        }
      },

      _updatePaginationText: function _updatePaginationText_PaginationBar(countLimitExceeded){
        // if one is not yet set do nothing
        if (typeof this.localCount == "number" && typeof this.globalCount == "number") {
          var nlsKey = "task_showing_x_of_y_results";
          if (countLimitExceeded && countLimitExceeded === true) {
            nlsKey = "task_showing_x_of_y_results_truncated";
          }
          var msg = dojo.string.substitute(this._nlsResources[nlsKey], {
            1: this.localCount,
            2: this.globalCount
          });

          this.paginationText.innerHTML = msg;
        }
      }
    });

com.ibm.bpm.social.widgets.task.list.PaginationBar.MORE_COUNT = 25;