// PropertyFormatter.js
// BEGIN COPYRIGHT
// *************************************************************************
//
// Licensed Materials - Property of IBM
// 5725-C94
// (C) Copyright IBM Corporation 2009, 2012. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// *************************************************************************
// END COPYRIGHT

// **************************************
//
// Version: 1.40 11/10/18 13:26:26
//
// **************************************

dojo.provide("com.ibm.bpm.social.widgets.task.util.PropertyFormatter");

dojo.require("dojo.i18n");
dojo.require("dojo.date.locale");
dojo.require("com.ibm.bpm.social.widgets.task.util.Constants");
dojo.requireLocalization("com.ibm.bpm.social", "bpmTask");
dojo.require("com.ibm.bpm.social.util.common.Log");
dojo.require("com.ibm.bpm.social.util.common.Util");
// TODO ??? dojo.require("com.ibm.bpm.social.widgets.task.util.SametimeService");

dojo
  .declare(
    "com.ibm.bpm.social.widgets.task.util.PropertyFormatter",
    null,
    {

      STATE_STATUS_MAP: {
//        "KEY_TASK_STATE_INACTIVE": "KEY_StateInActive",
//        "KEY_TASK_STATE_READY": "KEY_StateReady",
//        "KEY_TASK_STATE_RUNNING": "KEY_StateRunning",
//        "KEY_TASK_STATE_FINISHED": "KEY_StateSuccess",
//        "KEY_TASK_STATE_FAILED": "KEY_StateFailed",
//        "KEY_TASK_STATE_TERMINATED": "KEY_StateTerminated",
//        "KEY_TASK_STATE_CLAIMED": "KEY_StateRunning",
//        "KEY_TASK_STATE_EXPIRED": "KEY_StateFailed",
//        "KEY_TASK_STATE_FORWARDED": "KEY_StateForwarded",
//        "KEY_TASK_STATE_STARTED": "KEY_PreDraft", // For the details tab of a task template 
//        "KEY_TASK_STATE_STOPPED": "KEY_StateStopped", // For the details tab of a task template
//        "KEY_TASK_STATE_SUSPENDED_BY_PARENT": "KEY_StateSuspendedByParent", // WLE only
//        "KEY_ESCALATION_ACTIVATION_STATE_READY": "KEY_StateReady",
//        "KEY_ESCALATION_ACTIVATION_STATE_RUNNING": "KEY_StateRunning",
//        "KEY_ESCALATION_ACTIVATION_STATE_CLAIMED": "KEY_StateRunning",
//        "KEY_ESCALATION_ACTIVATION_STATE_WAITING_FOR_SUBTASK": "KEY_StateWaiting",
//        "KEY_ESCALATION_AT_LEAST_EXPECTED_STATE_CLAIMED": "KEY_StateRunning",
//        "KEY_ESCALATION_AT_LEAST_EXPECTED_STATE_ENDED": "KEY_StateFinished",
//        "KEY_ESCALATION_AT_LEAST_EXPECTED_STATE_SUBTASKS_COMPLETED": "KEY_ESCALATION_AT_LEAST_EXPECTED_STATE_SUBTASKS_COMPLETED"
      },

      ICON_MAP: {
//        TASK_STATE_INACTIVE: "taskStateInactive.gif",
//        TASK_STATE_READY: "taskStateReady.gif",
//        TASK_STATE_RUNNING: "taskSateRunning.gif",
//        TASK_STATE_FINISHED: "taskStateFinished.gif",
//        TASK_STATE_FAILED: "taskStateFailed.gif",
//        TASK_STATE_TERMINATED: "taskStateTerminated.gif",
//        TASK_STATE_CLAIMED: "taskSateRunning.gif",
//        TASK_STATE_EXPIRED: "taskStateFailed.gif",
//        TASK_STATE_FORWARDED: "taskStateForwarded.gif",
//        TASK_STATE_SUSPENDED_BY_PARENT: "processStateSuspended.gif",
//        TASK_KIND_ADMINISTRATIVE: "taskKindAdministrative.gif",
//        TASK_KIND_HUMAN: "taskKindHuman.gif",
//        TASK_KIND_ORIGINATING: "taskKindOriginating.gif",
//        TASK_KIND_PARTICIPATING: "taskKindParticipating.gif",
//        PROCESS_INSTANCE_STATE_DELETED: "processStateDeleted.gif",
//        PROCESS_INSTANCE_STATE_READY: "processStateReady.gif",
//        PROCESS_INSTANCE_STATE_RUNNING: "processStateRunning.gif",
//        PROCESS_INSTANCE_STATE_FINISHED: "processStateFinished.gif",
//        PROCESS_INSTANCE_STATE_COMPENSATING: "processStateCompensated.gif",
//        PROCESS_INSTANCE_STATE_FAILED: "processStateFailed.gif",
//        PROCESS_INSTANCE_STATE_TERMINATED: "processStateFailed.gif",
//        PROCESS_INSTANCE_STATE_COMPENSATED: "processStateCompensated.gif",
//        PROCESS_INSTANCE_STATE_TERMINATING: "processStateFailed.gif",
//        PROCESS_INSTANCE_STATE_FAILING: "processStateFailed.gif",
//        PROCESS_INSTANCE_STATE_INDOUBT: "processStateInDoubt.gif",
//        PROCESS_INSTANCE_STATE_SUSPENDED: "processStateSuspended.gif",
//        PROCESS_INSTANCE_STATE_COMPENSATION_FAILED: "processStateCompensationFailed.gif",
//        TASK_TEMPL_STATE_STARTED: "taskTemplStateStarted.gif",
//        TASK_TEMPL_STATE_STOPPED: "taskTemplStateStopped.gif",
//        ESCALATION_STATE_ESCALATED: "escalationStateEscalated.gif",
//        ESCALATION_STATE_INACTIVE: "escalationStateInactive.gif",
//        ESCALATION_STATE_SUBTASKS_COMPLETED: "escalationStateSubtasksCompleted.gif",
//        ESCALATION_STATE_SUPERFLUOUS: "escalationStateSuperfluous.gif",
//        ESCALATION_STATE_WAITING: "escalationStateWaiting.gif",
//        ESCALATION_ACTION_CREATE_EVENT: "escalationActionCreateEvent.gif",
//        ESCALATION_ACTION_CREATE_WORK_ITEM: "escalationActionGrantReadAccess.gif",
//        ESCALATION_ACTION_SEND_EMAIL: "escalationActionSendEMail.gif",
//        ESCALATION_ACTIVATION_STATE_READY: "taskStateReady.gif",
//        ESCALATION_ACTIVATION_STATE_RUNNING: "taskSateRunning.gif",
//        ESCALATION_ACTIVATION_STATE_CLAIMED: "taskSateRunning.gif",
//        ESCALATION_ACTIVATION_STATE_WAITING_FOR_SUBTASK: "waiting.gif",
//        ESCALATION_AT_LEAST_EXPECTED_STATE_CLAIMED: "taskSateRunning.gif",
//        ESCALATION_AT_LEAST_EXPECTED_STATE_ENDED: "taskStateFinished.gif",
//        ESCALATION_AT_LEAST_EXPECTED_STATE_SUBTASKS_COMPLETED: "escalationStateSubtasksCompleted.gif",
//        WORKBASKET_TYPE_GROUP: "workbasketTypeGroup.gif",
//        WORKBASKET_TYPE_INDIVIDUAL: "workbasketTypeIndividual.gif",
//        WORKBASKET_TYPE_TOPIC: "workbasketTypeTopic.gif",
//        WORKBASKET_TYPE_CLEARANCE: "workbasketTypeClearance.gif"
      },

      constructor: function(parameters){
        this._nlsResources = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmTask");

        if (parameters) {
          this._queueConfig = parameters.queueConfig;
          if (typeof parameters.attributesForQueryTableFunc != "undefined") {
            this._attributesForQueryTableFunc = parameters.attributesForQueryTableFunc;
          }
          if (parameters.config) {
            this._prioritySettings = parameters.config.priorities;
            this._type = parameters.config.type;
          }

          this._widgetId = parameters.widgetId;
        }
      },

      getIconFormatter: function(type){
        var self = this;
        switch (type) {
          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_BOOLEAN :
            return dojo.hitch(this, this.booleanIconFormatter);
            break;
          case "TASK.KIND" :
          case "TASK.STATE" :
          case "TASK_TEMPL.KIND" :
            return function(propertyValue){
              // non-trivial closure needed for type spezialization
              return self.genericIconFormatter("TASK", propertyValue);
            };
            break;
          case "PROCESS_INSTANCE.STATE" :
            return function(propertyValue){
              // non-trivial closure needed for type spezialization
              return self.genericIconFormatter("PROCESS_INSTANCE", propertyValue);
            };
            break;
          case "TASK_TEMPL.STATE" :
          case "PROCESS_TEMPLATE.STATE" :
            return function(propertyValue){
              // non-trivial closure needed for type spezialization
              return self.genericIconFormatter("TASK_TEMPL", propertyValue);
            };
            break;
          case "PROCESS_TEMPLATE.EXECUTION_MODE" :
            return function(propertyValue){
              if ("EXECUTION_MODE_LONG_RUNNING" == propertyValue) {
                return self.booleanIconFormatter(true);
              }
              else {
                return self.booleanIconFormatter(false);
              }
            };
            break;
//          case "ESCALATION.ACTION" :
//          case "ESCALATION.STATE" :
//          case "ESCALATION.ACTIVATION_STATE" :
//          case "ESCALATION.AT_LEAST_EXP_STATE" :
//          case "ESC_TEMPL.ACTION" :
//          case "ESC_TEMPL.ACTIVATION_STATE" :
//          case "ESC_TEMPL.AT_LEAST_EXP_STATE" :
//          return function(propertyValue){
//            // non-trivial closure needed for type spezialization
//            return self.genericIconFormatter("ESCALATION", propertyValue);
//          };
//          break;
          default:
            // Other types do not support an icon.
            break;
        }
        return null;
      },

      /**
       * Returns a hash {url: url, title: title}
       * 
       * @param {Object} type
       * @param {Object} displayName
       */
      getFormatter: function(type, verboseBoolean, displayName){
        var self = this;
        switch (type) {
          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_USER :
            // TODO ???
//        if (com.ibm.bpm.social.widgets.task.util.SametimeService.getInstance().isRunning()) {
//          return dojo.hitch(this, this.liveNameFormatter);
//        }
//        else {
            return null;
//        }
            break;
          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_DATE_CONFIG :
            return dojo.hitch(this, this.dateFormatter);
            break;
          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_TEXTCHECK_CONFIG :
            return dojo.hitch(this, this.textcheckFormatter);
            break;
          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_TEXT_CONFIG :
            return dojo.hitch(this, this.textFormatter);
            break;
          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_NUMBER_CONFIG :
          case "numericPriority" :
            return dojo.hitch(this, this.numberFormatter);
            break;
          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_PRIORITY_CONFIG :
          case "defaultPriority" :
            return dojo.hitch(this, this.priorityFormatter);
            break;
//          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_PENDING_CONFIG :
//            if (verboseBoolean !== false) {
//              return dojo.hitch(this, this.pendingVerboseFormatter);
//            }
//            else {
//              return dojo.hitch(this, this.pendingFormatter);
//            }
//            break;
          case com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_TYPE_BOOLEAN :
            return function(propertyValue){
              // non-trivial closure needed for display name specification
              var info = self.booleanIconFormatter(propertyValue);
              return self._createDomNode(info, displayName, verboseBoolean);
            };
            break;
          case "PROCESS_TEMPLATE.EXECUTION_MODE" :
            return function(propertyValue){
              var info = null;
              if ("EXECUTION_MODE_LONG_RUNNING" == propertyValue) {
                info = self.booleanIconFormatter(true);
              }
              else {
                info = self.booleanIconFormatter(false);
              }
              return self._createDomNode(info, displayName, verboseBoolean);
            };
            break;
          case "TASK.KIND" :
          case "TASK.STATE" :
          case "TASK_TEMPL.KIND" :
            return function(propertyValue){
              // non-trivial closure needed for type spezialization
              var info = self.genericIconFormatter("TASK", propertyValue);
              return self._createDomNode(info);
            };
            break;
//          case "TASK.IS_ESCALATED" :
//            if (verboseBoolean !== false) {
//              return dojo.hitch(this, this.escalatedVerboseFormatter);
//            }
//            else {
//              return dojo.hitch(this, this.escalatedFormatter);
//            }
//            break;
//          case "TASK.SUSPENDED" :
//            if (verboseBoolean !== false) {
//              return dojo.hitch(this, this.suspendedVerboseFormatter);
//            }
//            else {
//              return dojo.hitch(this, this.suspendedFormatter);
//            }
//            break;
          case "PROCESS_INSTANCE.STATE" :
            return function(propertyValue){
              // non-trivial closure needed for type spezialization
              var info = self.genericIconFormatter("PROCESS_INSTANCE", propertyValue);
              return self._createDomNode(info);
            };
            break;
          case "TASK_TEMPL.STATE" :
          case "PROCESS_TEMPLATE.STATE" :
            return function(propertyValue){
              // non-trivial closure needed for type spezialization
              var info = self.genericIconFormatter("TASK_TEMPL", propertyValue);
              return self._createDomNode(info);
            };
            break;
//          case "ESCALATION.ACTION" :
//          case "ESCALATION.STATE" :
//          case "ESCALATION.ACTIVATION_STATE" :
//          case "ESCALATION.AT_LEAST_EXP_STATE" :
//          case "ESC_TEMPL.ACTION" :
//          case "ESC_TEMPL.ACTIVATION_STATE" :
//          case "ESC_TEMPL.AT_LEAST_EXP_STATE" :
//            return function(propertyValue){
//              // non-trivial closure needed for type spezialization
//              var info = self.genericIconFormatter("ESCALATION", propertyValue);
//              return self._createDomNode(info);
//            };
//            break;
//          case "WORK_BASKET.TYPE" :
//            return function(propertyValue){
//              // non-trivial closure needed for type spezialization
//              var info = self.genericIconFormatter("WORKBASKET", propertyValue);
//              return self._createDomNode(info);
//            };
//            break;
          case "usergroup" :
            return dojo.hitch(this, this.userGroupFormatter);
          case "ASSIGNED_TO_ROLE" :
            return dojo.hitch(this, this.assigneeFormatter);
          case "ASSIGNED_TO_ROLE_DISPLAY_NAME" :
            return dojo.hitch(this, this.groupFormatter);
          case "ASSIGNED_TO_PARTICIPANT" :
            return dojo.hitch(this, this.participantFormatter);
          default:
            return null;
        }
        return null;
      },

      booleanIconFormatter: function(propertyValue){
        // TODO: rework css and images
        var url = null;
        var title = null;
        if (propertyValue) {
          url = dojo.moduleUrl("com.ibm.bpm.social.img", "booleantrue.gif");
          title = this._nlsResources["KEY_yes"];
        }
        else {
          url = dojo.moduleUrl("com.ibm.bpm.social.img", "booleanfalse.gif");
          title = this._nlsResources["KEY_no"];
        }
        return {
          url: url,
          title: title
        };
      },

      genericIconFormatter: function(type, propertyValue){
        //
        // Generic formatter that uses a closure function that accesses the type 
        // and a generic key format. Thereby no value to key mapping is necessary.
        //
//        var title = null;
//        var url = null;
//        var imageKey = null;
//        if (propertyValue && propertyValue != "") {
//          // Mapping between state and key is trivial
//          imageKey = type + "_" + propertyValue;
//          var key = "KEY_" + imageKey;
//          key = key.replace(/\./g, "_");
//          //
//          // Make sure that the same label is used for values that are not distinquished.
//          //
//          if (key != null &&
//            (key.indexOf("KEY_TASK_STATE") != -1 || key.indexOf("KEY_ESCALATION_ACTIVATION_STATE") != -1 || key
//              .indexOf("KEY_ESCALATION_AT_LEAST_EXPECTED_STATE") != -1)) {
//            key = this.STATE_STATUS_MAP[key];
//          }
//          else if (key != null && key.indexOf("PROCESS_INSTANCE_STATE") != -1) {
//            switch (key) {
//              case "KEY_PROCESS_INSTANCE_STATE_FAILED" :
//              case "KEY_PROCESS_INSTANCE_STATE_FAILING" :
//              case "KEY_PROCESS_INSTANCE_STATE_TERMINATED" :
//              case "KEY_PROCESS_INSTANCE_STATE_TERMINATING" :
//                key = "KEY_PROCESS_INSTANCE_STATE_FAILED";
//                break;
//              case "KEY_PROCESS_INSTANCE_STATE_COMPENSATING" :
//              case "KEY_PROCESS_INSTANCE_STATE_COMPENSATED" :
//                key = "KEY_PROCESS_INSTANCE_STATE_COMPENSATED";
//                break;
//            }
//          }
//          // Lookup value
//          title = this._nlsResources[key] ? this._nlsResources[key] : propertyValue;
//        }
//        //
//        // Check for image 
//        //         
//        if (imageKey != null) {
//          var imageName = this.ICON_MAP[imageKey];
//          if (imageName != null) {
//            url = dojo.moduleUrl("com.ibm.bpm.social.widgets.task.list.themes", "images/" + imageName);
//          }
//        }
//        if (url != null) {
//          return {
//            url: url,
//            title: title
//          };
//        }
//        else {
        // TODO: right now we do not have the mappings for the states, this use the propertyValue
        var title = propertyValue;
        return {
          title: title
        };
//        }
      },

      _createImage: function(url, title){
        var img = document.createElement("img");
        img.src = url;
        img.alt = title;
        img.style.verticalAlign = "middle";
        return img;
      },

      _createDomNode: function(info, displayName, verbose){
        var div = document.createElement("div");
        var title = info.title;
        if (typeof info.url != "undefined") {
          var img = this._createImage(info.url, title);
          div.appendChild(img);
          var text = title;
          if (typeof displayName != "undefined") {
            text = displayName;
          }
          if (typeof verbose == "undefined" || verbose) {
            var span = document.createElement("span");
            span.appendChild(document.createTextNode(text));
            span.style.verticalAlign = "middle";
            span.style.paddingLeft = "5px";
            span.style.paddingRight = "5px";
            div.appendChild(span);
          }
          else {
            img.style.display = "block";
            img.style.marginLeft = "auto";
            img.style.marginRight = "auto";
          }
          div.title = title;
        }
        else {
          div.appendChild(document.createTextNode(title));
        }
        return div;
      },

      dateFormatter: function(propertyValue){
        if (propertyValue) {
          var d = dojo.date.stamp.fromISOString(propertyValue);
          if (d == null) {
            this._checkProperties();
            return null;
          }
          else {
            propertyValue = dojo.date.locale.format(d, {
              formatLength: "short"
            });
          }
          var node = document.createElement("div");
          node.innerHTML = propertyValue;
          return node;
        }
        else {
          return null;
        }
      },

      userGroupFormatter: function(propertyValue){
        //make sure no code injection happens        
        if (propertyValue) {
          if (propertyValue.indexOf("cn=") == 0) {
            propertyValue = propertyValue.substring(3, propertyValue.indexOf(","));
          }
          propertyValue = com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatText(propertyValue);
        }
        var node = document.createElement("div");
        node.innerHTML = propertyValue;
        node.title = propertyValue;
        return node;
      },


      participantFormatter: function(assignedToRole){
        return this.assignedToRole(assignedToRole, false);
      },

      groupFormatter: function(assignedToRoleDisplayName, hideIcon){
        if (assignedToRoleDisplayName) {
          var node = document.createElement("div");
          if (hideIcon !== true) {
            var n2 = document.createElement("div");
            n2.className = "bpm-task-group bpm-social-group";
            node.appendChild(n2);
            var n3 = document.createElement("span");
            node.appendChild(n3);
            n3.innerHTML = assignedToRoleDisplayName;
            n3.title = assignedToRoleDisplayName;
          }
          else {
            node.innerHTML = assignedToRoleDisplayName;
            node.title = assignedToRoleDisplayName;
          }
          return node;
        }
      },

      assigneeFormatter: function(assignedToRole, hideIcon){
        if (assignedToRole) {
          // From Process Portal: determine group display name
          // Participant Names are in the form <PGName>_<'S'|'T'>_<PG-UUID>.<Snapshot-UUID>
          // So we are just using the last two '_'s to pull the PG name
          if (assignedToRole.match(".*_[TS]_[\\da-f-]+\\.[\\da-f-]+")) {
            var displayName = assignedToRole.substring(0, assignedToRole.lastIndexOf("_"));
            displayName = displayName.substring(0, displayName.lastIndexOf("_"));
            assignedToRole = displayName;
          }
          else {
            hideIcon = true;
          }
          var node = document.createElement("div");
          if (hideIcon !== true) {
            var n2 = document.createElement("div");
            n2.className = "bpm-task-group bpm-social-group";
            node.appendChild(n2);
            var n3 = document.createElement("span");
            node.appendChild(n3);
            n3.innerHTML = assignedToRole;
            n3.title = assignedToRole;
          }
          else {
            node.innerHTML = assignedToRole;
            node.title = assignedToRole;
          }
          return node;
        }
      },

      textFormatter: function(propertyValue){
        //make sure no code injection happens 

        // Remember title value, because it will not be interpreted as HTML.
        var titleValue = propertyValue;

        if (propertyValue) {
          propertyValue = com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatText(propertyValue);
        }
        var node = document.createElement("div");
        node.innerHTML = propertyValue;
        node.title = titleValue;
        return node;
      },

      // TODO ???
//      liveNameFormatter: function(userShortName){
//        var liveNameContainer = document.createElement("div");
//        liveNameContainer.innerHTML = userShortName;
//        com.ibm.bpm.social.widgets.task.util.SametimeService.getInstance().createLiveName(this._widgetId, liveNameContainer,
//          userShortName);
//        return liveNameContainer;
//      },

      textcheckFormatter: function(propertyValue){
        if (propertyValue) {
          // 	 (Dot). Match any character except newline or another 
          //   Unicode line terminator.  Global search, ignore case.
          propertyValue = propertyValue.toString().replace(/%htm(.*?)%/gi, this._nlsResources["KEY_TaskVariableReplace"]);
          propertyValue = propertyValue.toString().replace(/%bfm(.*?)%/gi, this._nlsResources["KEY_TaskVariableReplace"]);
          propertyValue = propertyValue.toString().replace(/%wf(.*?)%/gi, this._nlsResources["KEY_TaskVariableReplace"]);
          //make sure no code injection happens

          // Remember title value, because it will not be interpreted as HTML.
          var titleValue = propertyValue;

          propertyValue = com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatText(propertyValue);
          var node = document.createElement("div");
          node.innerHTML = propertyValue;
          node.title = titleValue;
          return node;
        }
        else {
          return null;
        }
      },

      numberFormatter: function(propertyValue){
        if (propertyValue !== null && propertyValue !== "") {
          var number = dojo.number.parse(propertyValue);
          if (number !== null && number != "NaN") {
            propertyValue = dojo.number.format(number);
          }
          else {
            this._checkProperties();
          }
          var node = document.createElement("div");
          dojo.addClass(node, "numericDataCell");
          node.innerHTML = propertyValue;
          return node;
        }
        else {
          return null;
        }
      },

      priorityFormatter: function(propertyValue){
        // TODO: rework function to use the new css classes
        if (propertyValue !== null && propertyValue !== "") {
          var node = null;
          if (this._prioritySettings == null) {
            node = document.createElement("div");
            node.innerHTML = propertyValue;
          }
          else if (this._prioritySettings.type == "priority") {
            // TODO : check for number
            var high = this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOHIGH_CONFIG];
            var low = this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOLOW_CONFIG];
            // find the priority range for the current value            
            if (low !== null && high !== null) {
              var cssClass = null;
              var titleKey = null;
              var tooltip = null;
              // high is greater then low
              if (high > low) {
                if (propertyValue >= high) {
                  // high
                  titleKey =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOHIGH_TITLEKEY_CONFIG]];
                  tooltip =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOHIGH_TITLEKEY_CONFIG] +
                      "Tooltip"];
                  cssClass = this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOHIGH_CSSLCASS_CONFIG];
                }
                else if (propertyValue > low) {
                  // medium
                  titleKey =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOMEDIUM_TITLEKEY_CONFIG]];
                  tooltip =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOMEDIUM_TITLEKEY_CONFIG] +
                      "Tooltip"];
                  cssClass =
                    this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOMEDIUM_CSSCLASS_CONFIG];
                }
                else {
                  // low
                  titleKey =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOLOW_TITLEKEY_CONFIG]];
                  tooltip =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOLOW_TITLEKEY_CONFIG] +
                      "Tooltip"];
                  cssClass = this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOLOW_CSSLCASS_CONFIG];
                }
              }
              else {
                // high is less or equal then low
                if (propertyValue <= high) {
                  // high
                  titleKey =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOHIGH_TITLEKEY_CONFIG]];
                  tooltip =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOHIGH_TITLEKEY_CONFIG] +
                      "Tooltip"];
                  cssClass = this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOHIGH_CSSLCASS_CONFIG];
                }
                else if (propertyValue < low) {
                  // medium
                  titleKey =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOMEDIUM_TITLEKEY_CONFIG]];
                  tooltip =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOMEDIUM_TITLEKEY_CONFIG] +
                      "Tooltip"];
                  cssClass =
                    this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOMEDIUM_CSSCLASS_CONFIG];
                }
                else {
                  // low
                  titleKey =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOLOW_TITLEKEY_CONFIG]];
                  tooltip =
                    this._nlsResources[this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOLOW_TITLEKEY_CONFIG] +
                      "Tooltip"];
                  cssClass = this._prioritySettings[com.ibm.bpm.social.widgets.task.util.Constants.PRIOLOW_CSSLCASS_CONFIG];
                }
              }

              // Map css class to priority icon.
              var imageName = null;
              switch (cssClass) {
                case "itemPriorityLow" :
                  imageName = "priority-low.gif";
                  break;
                case "itemPriorityMedium" :
                  imageName = "priority-medium.gif";
                  break;
                case "itemPriorityHigh" :
                  imageName = "priority-high.gif";
                  break;
              }

              if (imageName) {
                var url = dojo.moduleUrl("com.ibm.bpm.social.widgets.task.list.themes", "images/" + imageName);
                var info = {
                  url: url,
                  title: tooltip
                };
                node = this._createDomNode(info, titleKey, true);
                dojo.addClass(node, "itemVisualProperty");
              }
              else {
                node = document.createElement("div");
                node.innerHTML = propertyValue;
              }
            }
          }
          else if (this._prioritySettings.type == "defaultPriority") {
            var key = com.ibm.bpm.social.widgets.task.util.Constants.propertyKeyMapper(propertyValue);
            var titleKey = this._nlsResources["KEY_Prio" + key];
            var tooltip = this._nlsResources["KEY_Prio" + key + "Tooltip"];
            // var cssClass = "itemPriority" + key;
            var imageName = "priority-" + key.toLowerCase() + ".gif";

            if (this._prioritySettings.showImage === true) {
              info = {
                url: dojo.moduleUrl("com.ibm.bpm.social.widgets.task.list.themes", "images/" + imageName),
                title: tooltip
              };
              node = this._createDomNode(info, titleKey, true);
              dojo.addClass(node, "itemVisualProperty");
            }
            else {
              node = document.createElement("div");
              node.innerHTML = titleKey;
              node.title = tooltip;
            }
          }

          return node;
        }
        else {
          return null;
        }
      },

//      pendingFormatter: function(propertyValue){
//        if (propertyValue && propertyValue !== false) {
//          var info = this.booleanIconFormatter(propertyValue);
//          return this._createDomNode(info, "", false);
//        }
//        else {
//          return document.createElement("div");
//        }
//      },

//      pendingVerboseFormatter: function(propertyValue){
//        if (propertyValue && propertyValue !== false) {
//          var url = dojo.moduleUrl("com.ibm.bpm.social.widgets.task.list.themes", "images/waiting.gif");
//          var info = {
//            url: url,
//            title: this._nlsResources["KEY_waitingForSubtasks"]
//          };
//          var node = this._createDomNode(info, this._nlsResources["KEY_waitingForSubtasksFilter"], true);
//          dojo.addClass(node, "itemVisualProperty");
//          return node;
//        }
//        else {
//          return document.createElement("div");
//        }
//      },

//      escalatedFormatter: function(propertyValue){
//        if (propertyValue && propertyValue !== false) {
//          var info = this.booleanIconFormatter(propertyValue);
//          return this._createDomNode(info, "", false);
//        }
//        else {
//          return document.createElement("div");
//        }
//      },

//      escalatedVerboseFormatter: function(propertyValue){
//        if (propertyValue && propertyValue !== false) {
//          var url = dojo.moduleUrl("com.ibm.bpm.social.widgets.task.list.themes", "images/escalationStateEscalated.gif");
//          var info = {
//            url: url,
//            title: this._nlsResources["KEY_escalatedTask"]
//          };
//          var node = this._createDomNode(info, this._nlsResources["KEY_escalatedTaskFilter"], true);
//          dojo.addClass(node, "itemVisualProperty");
//          return node;
//        }
//        else {
//          return document.createElement("div");
//        }
//      },

//      suspendedFormatter: function(propertyValue){
//        if (propertyValue && propertyValue !== false) {
//          var info = this.booleanIconFormatter(propertyValue);
//          return this._createDomNode(info, "", false);
//        }
//        else {
//          return document.createElement("div");
//        }
//      },

//      suspendedVerboseFormatter: function(propertyValue){
//        if (propertyValue && propertyValue !== false) {
//          var url = dojo.moduleUrl("com.ibm.bpm.social.widgets.task.list.themes", "images/taskSuspended.gif");
//          var info = {
//            url: url,
//            title: this._nlsResources["KEY_suspendedTask"]
//          };
//          var node = this._createDomNode(info, this._nlsResources["KEY_suspendedTaskFilter"], true);
//          dojo.addClass(node, "itemVisualProperty");
//          return node;
//        }
//        else {
//          return document.createElement("div");
//        }
//      },

      _checkProperties: function(){
        com.ibm.bpm.social.util.common.Log.logEntry(2);
        if (!this._queueConfig || !this._attributesForQueryTableFunc) {
          com.ibm.bpm.social.util.common.Log.logError(1, "Either _queueConfig or ._attributesForQueryTableFunc not set");
          return;
        }
        var attributes = null;

        var processAppName = this._queueConfig.processAppName; // may be null, or undefined, or a valid String
        this._attributesForQueryTableFunc(this._type, this._queueConfig.getPlainQueueName(), processAppName,
          function(result){
            attributes = result;
          }, null, null, this._queueConfig.getDomain());
        if (attributes) {
          // check if the property is already in the list,
          // then it is a displayed property;      
          for ( var k in this._queueConfig.item[com.ibm.bpm.social.widgets.task.util.Constants.PROPERTIES_CONFIG]) {
            var found = false;
            var property = (this._queueConfig.item[com.ibm.bpm.social.widgets.task.util.Constants.PROPERTIES_CONFIG])[k];
            for ( var i in attributes.items) {
              var propertyMetaData = attributes.items[i];
              if ((property[com.ibm.bpm.social.widgets.task.util.Constants.PROPERTY_CONFIG] == propertyMetaData.name) &&
                (property.type == com.ibm.bpm.social.widgets.task.util.Constants.mapPropertyType(propertyMetaData)) &&
                (property.content == propertyMetaData.content)) {
                found = true;
              }
            }
            if (!found) {
              var queueName = this._queueConfig.getDisplayName();
              this._queueConfig.exception =
                {
                  type: "list",
                  messageKey: "KEY_queuesHasChanged" +
                    com.ibm.bpm.social.widgets.task.util.Constants.getEntityPostFix(this._type),
                  severity: "WARNING",
                  parameters: {
                    1: queueName,
                    2: property.title
                  }
                };
              // looks like it is necessary to throw an object
              // and not this._queueConfig.exception
              throw ({
                type: "list",
                messageKey: "KEY_queuesHasChanged" +
                  com.ibm.bpm.social.widgets.task.util.Constants.getEntityPostFix(this._type),
                severity: "WARNING",
                parameters: {
                  1: queueName,
                  2: property.title
                }
              });
            }
          }
        }
        com.ibm.bpm.social.util.common.Log.logExit(2);
      }
    });

com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatText =
  function(str){
    if (!str) {
      return str;
    }
    var result =
      str.toString().replace(/&/gm, "&amp;").replace(/</gm, "&lt;").replace(/>/gm, "&gt;").replace(/"/gm, "&quot;");
    return result;
  };

com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatTextForSQL = function(str){
  if (!str) {
    return str;
  }
  var result = str.toString().replace(/'/gm, "''");
  return result;
};

com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatDate = function(text, options){
  if (!options) {
      options = {formatLength: "short"};
  }
  var d = dojo.date.stamp.fromISOString(text);
  return com.ibm.bpm.social.util.common.Util.formatDateObject(d, options);
};

com.ibm.bpm.social.widgets.task.util.PropertyFormatter.formatNumber = function(number){
  return dojo.number.format(number);
};
