// TabConfiguration.js
//BEGIN COPYRIGHT
//*************************************************************************
//
// Licensed Materials - Property of IBM
// 5725-C96
// (C) Copyright IBM Corporation 2011. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
//*************************************************************************
//END COPYRIGHT 
dojo.provide("com.ibm.bpm.social.widgets.task.util.TabConfiguration");

dojo.require("com.ibm.bpm.social.util.common.Util");

/**
 * based on LightWeightTabConfiguration.js Version: 1.22 11/10/05 16:22:49
 * 
 * This class contains information for one tab of the com.ibm.bpm.social.widgets.task.util.TabContainer
 * 
 * This informations are used for generating a tab inside the lightweight tab container
 */
dojo.declare("com.ibm.bpm.social.widgets.task.util.TabConfiguration", null,
  {
    //name of the tab - display in the lightweight tab container
    tabName: "",
    //index of the tab - is used for creating a unique name inside the tab container - should be
    //unique for every tab of a tab container
    id: 0,
    //is the tab active - only active tabs will be created
    isActive: false,
    //position of the tab inside the tab container - is set during the creation of the tabs
    position: 0,
    //context for doing call back methods
    context: null,
    //name of the function inside the passed context that has to be called when the tab is loaded
    //has to be unique for the different tabs, because it is used as identifier for the content of the tab
    loadFunction: "",
    //text of the tool tip that is shown when the mouse over event for the tab is send
    tooltip: "",
    //id of the widget that contains the tab - this information is necessary for generating a unique id
    widgetID: "",
    //mark if the content of the current tab is shown
    //if no tab is marked for showing the content after open it - the content of the first tab is shown
    //else only one tab should be marked as open - if more than one tab is marked as the content of the last one will be shown
    contentIsShownAfterInit: false,

    // user defined properties for the tab
    custom: null,


    //the created tab (dom tree)
    tab: null,

    constructor: function constructor_TabConfiguration(tabName, id, isActive, context, loadFunction, tooltip, widgetID,
      custom){
      this.tabName = tabName;
      this.id = id;
      this.isActive = isActive;
      this.context = context;
      this.loadFunction = loadFunction;
      this.tooltip = tooltip;
      this.widgetID = widgetID;
      if (custom) {
        this.custom = custom;
      }

      if (com.ibm.bpm.social.util.common.Util.isIPad) {
        this.tooltip = null;
      }
    },

    setContentIsShownAfterInit: function setContentIsShownAfterInit_TabConfiguration(resetFlag){
      if (resetFlag === false) {
        this.contentIsShownAfterInit = false;
      }
      else {
        this.contentIsShownAfterInit = true;
      }
    },

    setPosition: function setPosition_TabConfiguration(position){
      this.position = position;
    }
  });
