/*
	Licensed Materials - Property of IBM
	5725-C96
	Copyright IBM Corp. 2008, 2011, 2012 All Rights Reserved.
	US Government Users Restricted Rights - Use, duplication or
	disclosure restricted by GSA ADP Schedule Contract with
	IBM Corp.
*/
/*
	Copyright (c) 2004-2012, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is an optimized version of Dojo, built for deployment and not for
	development. To get sources and documentation, please visit:

		http://dojotoolkit.org
*/

dojo.provide("com.ibm.bpm.wpd_base");
if(!dojo._hasResource["com.ibm.bpm.wpd.core.control.events.BaseEvent"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.control.events.BaseEvent"] = true;
dojo.provide("com.ibm.bpm.wpd.core.control.events.BaseEvent");

dojo.declare("com.ibm.bpm.wpd.core.control.events.BaseEvent", null, {
	
	constructor : function () {	
	},
	
	/**
	 * Dispatches the event by executing the corresponding command
	 * The event and command mapping is done based on naming convention
	 */
	dispatch : function() {
		/* Find the command to execute */
		var eventClassName = this.declaredClass;
		var commandClassName = eventClassName.replace(".events.", ".commands.");
		commandClassName = commandClassName.substring(0, commandClassName.lastIndexOf("Event")) + "Command";

		//console.debug("BaseEvent.dispatch(): commandClassName = %o, this = %o", commandClassName, this);
		try {
			dojo["require"](commandClassName);
			var cmdClass = dojo.getObject(commandClassName);
			var cmd = new cmdClass(this);
		} catch (err){
			//TODO If needed, we can check the FrontController to see if it is registered there
			var className = this.declaredClass;
			var methodName = "dispatch";
			var message = "Requiring " + commandClassName + " caught error" +
				'\nMessage: ' + err.message;
			com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError(className, methodName, message);	
		}
		
		try{
			//console.log("cmd=", cmd);
			console.debug( "in dispatch event: " + new Date().getTime());

			cmd.execute();
		}
		 catch (err){
			var className = this.declaredClass;
			var methodName = "dispatch";
			var viewerName;
			var message = "Executing " + commandClassName + " caught exception" +
				'\nMessage: ' + err.message;

			var loadingImg = dojo.byId("wpdLoadingImag");
			if (!!loadingImg) {
				loadingImg.style.display = "none";
			}

			com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError(className, methodName, message);
		}
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent"] = true;
dojo.provide("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");



/**
 * This event is used to trigger a OpenDocumentCommand
 * @param an object contains the following properties
 *
 * For viewing details of bpd, service......., and using drill in
 *      branchId or snapshotId
 *      documentId po id of the activity to be drilled in
 *      documentName
 *      
 * For viewing process instance
 * 		instanceId
 *      instanceName
 *      type: The type of the docTypeProvider to be used
 *      bpdId
 *      
 *      For drill in in process instance view
 *      instanceId
 *      type: The type of the docTypeProvider to be used
 *      branchId or snapshotId
 *      documentId po id of the activity to be drilled in
 *      documentName
 *      
 
 */
dojo.declare("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent", [com.ibm.bpm.wpd.core.control.events.BaseEvent], {
	//public variable
	params : null,
	additonalParams: null, 
	constructor : function (parameters, additonalParams) {
		this.params = parameters;
		this.additonalParams = additonalParams;
	}
});

}

if(!dojo._hasResource["dijit._base.manager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.manager"] = true;
dojo.provide("dijit._base.manager");


dojo.declare("dijit.WidgetSet", null, {
	// summary:
	//		A set of widgets indexed by id. A default instance of this class is
	//		available as `dijit.registry`
	//
	// example:
	//		Create a small list of widgets:
	//		|	var ws = new dijit.WidgetSet();
	//		|	ws.add(dijit.byId("one"));
	//		| 	ws.add(dijit.byId("two"));
	//		|	// destroy both:
	//		|	ws.forEach(function(w){ w.destroy(); });
	//
	// example:
	//		Using dijit.registry:
	//		|	dijit.registry.forEach(function(w){ /* do something */ });

	constructor: function(){
		this._hash = {};
		this.length = 0;
	},

	add: function(/*dijit._Widget*/ widget){
		// summary:
		//		Add a widget to this list. If a duplicate ID is detected, a error is thrown.
		//
		// widget: dijit._Widget
		//		Any dijit._Widget subclass.
		if(this._hash[widget.id]){
			throw new Error("Tried to register widget with id==" + widget.id + " but that id is already registered");
		}
		this._hash[widget.id] = widget;
		this.length++;
	},

	remove: function(/*String*/ id){
		// summary:
		//		Remove a widget from this WidgetSet. Does not destroy the widget; simply
		//		removes the reference.
		if(this._hash[id]){
			delete this._hash[id];
			this.length--;
		}
	},

	forEach: function(/*Function*/ func, /* Object? */thisObj){
		// summary:
		//		Call specified function for each widget in this set.
		//
		// func:
		//		A callback function to run for each item. Is passed the widget, the index
		//		in the iteration, and the full hash, similar to `dojo.forEach`.
		//
		// thisObj:
		//		An optional scope parameter
		//
		// example:
		//		Using the default `dijit.registry` instance:
		//		|	dijit.registry.forEach(function(widget){
		//		|		console.log(widget.declaredClass);
		//		|	});
		//
		// returns:
		//		Returns self, in order to allow for further chaining.

		thisObj = thisObj || dojo.global;
		var i = 0, id;
		for(id in this._hash){
			func.call(thisObj, this._hash[id], i++, this._hash);
		}
		return this;	// dijit.WidgetSet
	},

	filter: function(/*Function*/ filter, /* Object? */thisObj){
		// summary:
		//		Filter down this WidgetSet to a smaller new WidgetSet
		//		Works the same as `dojo.filter` and `dojo.NodeList.filter`
		//
		// filter:
		//		Callback function to test truthiness. Is passed the widget
		//		reference and the pseudo-index in the object.
		//
		// thisObj: Object?
		//		Option scope to use for the filter function.
		//
		// example:
		//		Arbitrary: select the odd widgets in this list
		//		|	dijit.registry.filter(function(w, i){
		//		|		return i % 2 == 0;
		//		|	}).forEach(function(w){ /* odd ones */ });

		thisObj = thisObj || dojo.global;
		var res = new dijit.WidgetSet(), i = 0, id;
		for(id in this._hash){
			var w = this._hash[id];
			if(filter.call(thisObj, w, i++, this._hash)){
				res.add(w);
			}
		}
		return res; // dijit.WidgetSet
	},

	byId: function(/*String*/ id){
		// summary:
		//		Find a widget in this list by it's id.
		// example:
		//		Test if an id is in a particular WidgetSet
		//		| var ws = new dijit.WidgetSet();
		//		| ws.add(dijit.byId("bar"));
		//		| var t = ws.byId("bar") // returns a widget
		//		| var x = ws.byId("foo"); // returns undefined

		return this._hash[id];	// dijit._Widget
	},

	byClass: function(/*String*/ cls){
		// summary:
		//		Reduce this widgetset to a new WidgetSet of a particular `declaredClass`
		//
		// cls: String
		//		The Class to scan for. Full dot-notated string.
		//
		// example:
		//		Find all `dijit.TitlePane`s in a page:
		//		|	dijit.registry.byClass("dijit.TitlePane").forEach(function(tp){ tp.close(); });

		var res = new dijit.WidgetSet(), id, widget;
		for(id in this._hash){
			widget = this._hash[id];
			if(widget.declaredClass == cls){
				res.add(widget);
			}
		 }
		 return res; // dijit.WidgetSet
},

	toArray: function(){
		// summary:
		//		Convert this WidgetSet into a true Array
		//
		// example:
		//		Work with the widget .domNodes in a real Array
		//		|	dojo.map(dijit.registry.toArray(), function(w){ return w.domNode; });

		var ar = [];
		for(var id in this._hash){
			ar.push(this._hash[id]);
		}
		return ar;	// dijit._Widget[]
},

	map: function(/* Function */func, /* Object? */thisObj){
		// summary:
		//		Create a new Array from this WidgetSet, following the same rules as `dojo.map`
		// example:
		//		|	var nodes = dijit.registry.map(function(w){ return w.domNode; });
		//
		// returns:
		//		A new array of the returned values.
		return dojo.map(this.toArray(), func, thisObj); // Array
	},

	every: function(func, thisObj){
		// summary:
		// 		A synthetic clone of `dojo.every` acting explicitly on this WidgetSet
		//
		// func: Function
		//		A callback function run for every widget in this list. Exits loop
		//		when the first false return is encountered.
		//
		// thisObj: Object?
		//		Optional scope parameter to use for the callback

		thisObj = thisObj || dojo.global;
		var x = 0, i;
		for(i in this._hash){
			if(!func.call(thisObj, this._hash[i], x++, this._hash)){
				return false; // Boolean
			}
		}
		return true; // Boolean
	},

	some: function(func, thisObj){
		// summary:
		// 		A synthetic clone of `dojo.some` acting explictly on this WidgetSet
		//
		// func: Function
		//		A callback function run for every widget in this list. Exits loop
		//		when the first true return is encountered.
		//
		// thisObj: Object?
		//		Optional scope parameter to use for the callback

		thisObj = thisObj || dojo.global;
		var x = 0, i;
		for(i in this._hash){
			if(func.call(thisObj, this._hash[i], x++, this._hash)){
				return true; // Boolean
			}
		}
		return false; // Boolean
	}

});

(function(){

	/*=====
	dijit.registry = {
		// summary:
		//		A list of widgets on a page.
		// description:
		//		Is an instance of `dijit.WidgetSet`
	};
	=====*/
	dijit.registry = new dijit.WidgetSet();

	var hash = dijit.registry._hash,
		attr = dojo.attr,
		hasAttr = dojo.hasAttr,
		style = dojo.style;

	dijit.byId = function(/*String|dijit._Widget*/ id){
		// summary:
		//		Returns a widget by it's id, or if passed a widget, no-op (like dojo.byId())
		return typeof id == "string" ? hash[id] : id; // dijit._Widget
	};

	var _widgetTypeCtr = {};
	dijit.getUniqueId = function(/*String*/widgetType){
		// summary:
		//		Generates a unique id for a given widgetType
	
		var id;
		do{
			id = widgetType + "_" +
				(widgetType in _widgetTypeCtr ?
					++_widgetTypeCtr[widgetType] : _widgetTypeCtr[widgetType] = 0);
		}while(hash[id]);
		return dijit._scopeName == "dijit" ? id : dijit._scopeName + "_" + id; // String
	};
	
	dijit.findWidgets = function(/*DomNode*/ root){
		// summary:
		//		Search subtree under root returning widgets found.
		//		Doesn't search for nested widgets (ie, widgets inside other widgets).
	
		var outAry = [];
	
		function getChildrenHelper(root){
			for(var node = root.firstChild; node; node = node.nextSibling){
				if(node.nodeType == 1){
					var widgetId = node.getAttribute("widgetId");
					if(widgetId){
						var widget = hash[widgetId];
						if(widget){	// may be null on page w/multiple dojo's loaded
							outAry.push(widget);
						}
					}else{
						getChildrenHelper(node);
					}
				}
			}
		}
	
		getChildrenHelper(root);
		return outAry;
	};
	
	dijit._destroyAll = function(){
		// summary:
		//		Code to destroy all widgets and do other cleanup on page unload
	
		// Clean up focus manager lingering references to widgets and nodes
		dijit._curFocus = null;
		dijit._prevFocus = null;
		dijit._activeStack = [];
	
		// Destroy all the widgets, top down
		dojo.forEach(dijit.findWidgets(dojo.body()), function(widget){
			// Avoid double destroy of widgets like Menu that are attached to <body>
			// even though they are logically children of other widgets.
			if(!widget._destroyed){
				if(widget.destroyRecursive){
					widget.destroyRecursive();
				}else if(widget.destroy){
					widget.destroy();
				}
			}
		});
	};
	
	if(dojo.isIE){
		// Only run _destroyAll() for IE because we think it's only necessary in that case,
		// and because it causes problems on FF.  See bug #3531 for details.
		dojo.addOnWindowUnload(function(){
			dijit._destroyAll();
		});
	}
	
	dijit.byNode = function(/*DOMNode*/ node){
		// summary:
		//		Returns the widget corresponding to the given DOMNode
		return hash[node.getAttribute("widgetId")]; // dijit._Widget
	};
	
	dijit.getEnclosingWidget = function(/*DOMNode*/ node){
		// summary:
		//		Returns the widget whose DOM tree contains the specified DOMNode, or null if
		//		the node is not contained within the DOM tree of any widget
		while(node){
			var id = node.getAttribute && node.getAttribute("widgetId");
			if(id){
				return hash[id];
			}
			node = node.parentNode;
		}
		return null;
	};

	var shown = (dijit._isElementShown = function(/*Element*/ elem){
		var s = style(elem);
		return (s.visibility != "hidden")
			&& (s.visibility != "collapsed")
			&& (s.display != "none")
			&& (attr(elem, "type") != "hidden");
	});
	
	dijit.hasDefaultTabStop = function(/*Element*/ elem){
		// summary:
		//		Tests if element is tab-navigable even without an explicit tabIndex setting
	
		// No explicit tabIndex setting, need to investigate node type
		switch(elem.nodeName.toLowerCase()){
			case "a":
				// An <a> w/out a tabindex is only navigable if it has an href
				return hasAttr(elem, "href");
			case "area":
			case "button":
			case "input":
			case "object":
			case "select":
			case "textarea":
				// These are navigable by default
				return true;
			case "iframe":
				// If it's an editor <iframe> then it's tab navigable.
				var body;
				try{
					// non-IE
					var contentDocument = elem.contentDocument;
					if("designMode" in contentDocument && contentDocument.designMode == "on"){
						return true;
					}
					body = contentDocument.body;
				}catch(e1){
					// contentWindow.document isn't accessible within IE7/8
					// if the iframe.src points to a foreign url and this
					// page contains an element, that could get focus
					try{
						body = elem.contentWindow.document.body;
					}catch(e2){
						return false;
					}
				}
				return body.contentEditable == 'true' || (body.firstChild && body.firstChild.contentEditable == 'true');
			default:
				return elem.contentEditable == 'true';
		}
	};
	
	var isTabNavigable = (dijit.isTabNavigable = function(/*Element*/ elem){
		// summary:
		//		Tests if an element is tab-navigable
	
		// TODO: convert (and rename method) to return effective tabIndex; will save time in _getTabNavigable()
		if(attr(elem, "disabled")){
			return false;
		}else if(hasAttr(elem, "tabIndex")){
			// Explicit tab index setting
			return attr(elem, "tabIndex") >= 0; // boolean
		}else{
			// No explicit tabIndex setting, so depends on node type
			return dijit.hasDefaultTabStop(elem);
		}
	});

	dijit._getTabNavigable = function(/*DOMNode*/ root){
		// summary:
		//		Finds descendants of the specified root node.
		//
		// description:
		//		Finds the following descendants of the specified root node:
		//		* the first tab-navigable element in document order
		//		  without a tabIndex or with tabIndex="0"
		//		* the last tab-navigable element in document order
		//		  without a tabIndex or with tabIndex="0"
		//		* the first element in document order with the lowest
		//		  positive tabIndex value
		//		* the last element in document order with the highest
		//		  positive tabIndex value
		var first, last, lowest, lowestTabindex, highest, highestTabindex, radioSelected = {};
		function radioName(node) {
			// If this element is part of a radio button group, return the name for that group.
			return node && node.tagName.toLowerCase() == "input" &&
				node.type && node.type.toLowerCase() == "radio" &&
				node.name && node.name.toLowerCase();
		}
		var walkTree = function(/*DOMNode*/parent){
			dojo.query("> *", parent).forEach(function(child){
				// Skip hidden elements, and also non-HTML elements (those in custom namespaces) in IE,
				// since show() invokes getAttribute("type"), which crash on VML nodes in IE.
				if((dojo.isIE <= 9 && child.scopeName !== "HTML") || !shown(child)){
					return;
				}

				if(isTabNavigable(child)){
					var tabindex = attr(child, "tabIndex");
					if(!hasAttr(child, "tabIndex") || tabindex == 0){
						if(!first){ first = child; }
						last = child;
					}else if(tabindex > 0){
						if(!lowest || tabindex < lowestTabindex){
							lowestTabindex = tabindex;
							lowest = child;
						}
						if(!highest || tabindex >= highestTabindex){
							highestTabindex = tabindex;
							highest = child;
						}
					}
					var rn = radioName(child);
					if(dojo.attr(child, "checked") && rn) {
						radioSelected[rn] = child;
					}
				}
				if(child.nodeName.toUpperCase() != 'SELECT'){
					walkTree(child);
				}
			});
		};
		if(shown(root)){ walkTree(root) }
		function rs(node) {
			// substitute checked radio button for unchecked one, if there is a checked one with the same name.
			return radioSelected[radioName(node)] || node;
		}
		return { first: rs(first), last: rs(last), lowest: rs(lowest), highest: rs(highest) };
	}
	dijit.getFirstInTabbingOrder = function(/*String|DOMNode*/ root){
		// summary:
		//		Finds the descendant of the specified root node
		//		that is first in the tabbing order
		var elems = dijit._getTabNavigable(dojo.byId(root));
		return elems.lowest ? elems.lowest : elems.first; // DomNode
	};
	
	dijit.getLastInTabbingOrder = function(/*String|DOMNode*/ root){
		// summary:
		//		Finds the descendant of the specified root node
		//		that is last in the tabbing order
		var elems = dijit._getTabNavigable(dojo.byId(root));
		return elems.last ? elems.last : elems.highest; // DomNode
	};
	
	/*=====
	dojo.mixin(dijit, {
		// defaultDuration: Integer
		//		The default animation speed (in ms) to use for all Dijit
		//		transitional animations, unless otherwise specified
		//		on a per-instance basis. Defaults to 200, overrided by
		//		`djConfig.defaultDuration`
		defaultDuration: 200
	});
	=====*/
	
	dijit.defaultDuration = dojo.config["defaultDuration"] || 200;

})();

}

if(!dojo._hasResource["dojo.Stateful"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.Stateful"] = true;
dojo.provide("dojo.Stateful");


dojo.declare("dojo.Stateful", null, {
	// summary:
	//		Base class for objects that provide named properties with optional getter/setter
	//		control and the ability to watch for property changes
	// example:
	//	|	var obj = new dojo.Stateful();
	//	|	obj.watch("foo", function(){
	//	|		console.log("foo changed to " + this.get("foo"));
	//	|	});
	//	|	obj.set("foo","bar");
	postscript: function(mixin){
		if(mixin){
			dojo.mixin(this, mixin);
		}
	},
	
	get: function(/*String*/name){
		// summary:
		//		Get a property on a Stateful instance.
		//	name:
		//		The property to get.
		// description:
		//		Get a named property on a Stateful object. The property may
		//		potentially be retrieved via a getter method in subclasses. In the base class
		// 		this just retrieves the object's property.
		// 		For example:
		//	|	stateful = new dojo.Stateful({foo: 3});
		//	|	stateful.get("foo") // returns 3
		//	|	stateful.foo // returns 3
		
		return this[name];
	},
	set: function(/*String*/name, /*Object*/value){
		// summary:
		//		Set a property on a Stateful instance
		//	name:
		//		The property to set.
		//	value:
		//		The value to set in the property.
		// description:
		//		Sets named properties on a stateful object and notifies any watchers of
		// 		the property. A programmatic setter may be defined in subclasses.
		// 		For example:
		//	|	stateful = new dojo.Stateful();
		//	|	stateful.watch(function(name, oldValue, value){
		//	|		// this will be called on the set below
		//	|	}
		//	|	stateful.set(foo, 5);
		//
		//	set() may also be called with a hash of name/value pairs, ex:
		//	|	myObj.set({
		//	|		foo: "Howdy",
		//	|		bar: 3
		//	|	})
		//	This is equivalent to calling set(foo, "Howdy") and set(bar, 3)
		if(typeof name === "object"){
			for(var x in name){
				this.set(x, name[x]);
			}
			return this;
		}
		var oldValue = this[name];
		this[name] = value;
		if(this._watchCallbacks){
			this._watchCallbacks(name, oldValue, value);
		}
		return this;
	},
	watch: function(/*String?*/name, /*Function*/callback){
		// summary:
		//		Watches a property for changes
		//	name:
		//		Indicates the property to watch. This is optional (the callback may be the
		// 		only parameter), and if omitted, all the properties will be watched
		// returns:
		//		An object handle for the watch. The unwatch method of this object
		// 		can be used to discontinue watching this property:
		//		|	var watchHandle = obj.watch("foo", callback);
		//		|	watchHandle.unwatch(); // callback won't be called now
		//	callback:
		//		The function to execute when the property changes. This will be called after
		//		the property has been changed. The callback will be called with the |this|
		//		set to the instance, the first argument as the name of the property, the
		// 		second argument as the old value and the third argument as the new value.
		
		var callbacks = this._watchCallbacks;
		if(!callbacks){
			var self = this;
			callbacks = this._watchCallbacks = function(name, oldValue, value, ignoreCatchall){
				var notify = function(propertyCallbacks){
					if(propertyCallbacks){
                        propertyCallbacks = propertyCallbacks.slice();
						for(var i = 0, l = propertyCallbacks.length; i < l; i++){
							try{
								propertyCallbacks[i].call(self, name, oldValue, value);
							}catch(e){
								console.error(e);
							}
						}
					}
				};
				notify(callbacks['_' + name]);
				if(!ignoreCatchall){
					notify(callbacks["*"]); // the catch-all
				}
			}; // we use a function instead of an object so it will be ignored by JSON conversion
		}
		if(!callback && typeof name === "function"){
			callback = name;
			name = "*";
		}else{
			// prepend with dash to prevent name conflicts with function (like "name" property)
			name = '_' + name;
		}
		var propertyCallbacks = callbacks[name];
		if(typeof propertyCallbacks !== "object"){
			propertyCallbacks = callbacks[name] = [];
		}
		propertyCallbacks.push(callback);
		return {
			unwatch: function(){
				propertyCallbacks.splice(dojo.indexOf(propertyCallbacks, callback), 1);
			}
		};
	}
	
});

}

if(!dojo._hasResource["dijit._WidgetBase"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._WidgetBase"] = true;
dojo.provide("dijit._WidgetBase");




(function(){

dojo.declare("dijit._WidgetBase", dojo.Stateful, {
	// summary:
	//		Future base class for all Dijit widgets.
	//		_Widget extends this class adding support for various features needed by desktop.

	// id: [const] String
	//		A unique, opaque ID string that can be assigned by users or by the
	//		system. If the developer passes an ID which is known not to be
	//		unique, the specified ID is ignored and the system-generated ID is
	//		used instead.
	id: "",

	// lang: [const] String
	//		Rarely used.  Overrides the default Dojo locale used to render this widget,
	//		as defined by the [HTML LANG](http://www.w3.org/TR/html401/struct/dirlang.html#adef-lang) attribute.
	//		Value must be among the list of locales specified during by the Dojo bootstrap,
	//		formatted according to [RFC 3066](http://www.ietf.org/rfc/rfc3066.txt) (like en-us).
	lang: "",

	// dir: [const] String
	//		Bi-directional support, as defined by the [HTML DIR](http://www.w3.org/TR/html401/struct/dirlang.html#adef-dir)
	//		attribute. Either left-to-right "ltr" or right-to-left "rtl".  If undefined, widgets renders in page's
	//		default direction.
	dir: "",

	// class: String
	//		HTML class attribute
	"class": "",

	// style: String||Object
	//		HTML style attributes as cssText string or name/value hash
	style: "",

	// title: String
	//		HTML title attribute.
	//
	//		For form widgets this specifies a tooltip to display when hovering over
	//		the widget (just like the native HTML title attribute).
	//
	//		For TitlePane or for when this widget is a child of a TabContainer, AccordionContainer,
	//		etc., it's used to specify the tab label, accordion pane title, etc.
	title: "",

	// tooltip: String
	//		When this widget's title attribute is used to for a tab label, accordion pane title, etc.,
	//		this specifies the tooltip to appear when the mouse is hovered over that text.
	tooltip: "",

	// baseClass: [protected] String
	//		Root CSS class of the widget (ex: dijitTextBox), used to construct CSS classes to indicate
	//		widget state.
	baseClass: "",

	// srcNodeRef: [readonly] DomNode
	//		pointer to original DOM node
	srcNodeRef: null,

	// domNode: [readonly] DomNode
	//		This is our visible representation of the widget! Other DOM
	//		Nodes may by assigned to other properties, usually through the
	//		template system's dojoAttachPoint syntax, but the domNode
	//		property is the canonical "top level" node in widget UI.
	domNode: null,

	// containerNode: [readonly] DomNode
	//		Designates where children of the source DOM node will be placed.
	//		"Children" in this case refers to both DOM nodes and widgets.
	//		For example, for myWidget:
	//
	//		|	<div dojoType=myWidget>
	//		|		<b> here's a plain DOM node
	//		|		<span dojoType=subWidget>and a widget</span>
	//		|		<i> and another plain DOM node </i>
	//		|	</div>
	//
	//		containerNode would point to:
	//
	//		|		<b> here's a plain DOM node
	//		|		<span dojoType=subWidget>and a widget</span>
	//		|		<i> and another plain DOM node </i>
	//
	//		In templated widgets, "containerNode" is set via a
	//		dojoAttachPoint assignment.
	//
	//		containerNode must be defined for any widget that accepts innerHTML
	//		(like ContentPane or BorderContainer or even Button), and conversely
	//		is null for widgets that don't, like TextBox.
	containerNode: null,

/*=====
	// _started: Boolean
	//		startup() has completed.
	_started: false,
=====*/

	// attributeMap: [protected] Object
	//		attributeMap sets up a "binding" between attributes (aka properties)
	//		of the widget and the widget's DOM.
	//		Changes to widget attributes listed in attributeMap will be
	//		reflected into the DOM.
	//
	//		For example, calling set('title', 'hello')
	//		on a TitlePane will automatically cause the TitlePane's DOM to update
	//		with the new title.
	//
	//		attributeMap is a hash where the key is an attribute of the widget,
	//		and the value reflects a binding to a:
	//
	//		- DOM node attribute
	// |		focus: {node: "focusNode", type: "attribute"}
	// 		Maps this.focus to this.focusNode.focus
	//
	//		- DOM node innerHTML
	//	|		title: { node: "titleNode", type: "innerHTML" }
	//		Maps this.title to this.titleNode.innerHTML
	//
	//		- DOM node innerText
	//	|		title: { node: "titleNode", type: "innerText" }
	//		Maps this.title to this.titleNode.innerText
	//
	//		- DOM node CSS class
	// |		myClass: { node: "domNode", type: "class" }
	//		Maps this.myClass to this.domNode.className
	//
	//		If the value is an array, then each element in the array matches one of the
	//		formats of the above list.
	//
	//		There are also some shorthands for backwards compatibility:
	//		- string --> { node: string, type: "attribute" }, for example:
	//	|	"focusNode" ---> { node: "focusNode", type: "attribute" }
	//		- "" --> { node: "domNode", type: "attribute" }
	attributeMap: {id:"", dir:"", lang:"", "class":"", style:"", title:""},

	// _blankGif: [protected] String
	//		Path to a blank 1x1 image.
	//		Used by <img> nodes in templates that really get their image via CSS background-image.
	_blankGif: (dojo.config.blankGif || dojo.moduleUrl("dojo", "resources/blank.gif")).toString(),

	//////////// INITIALIZATION METHODS ///////////////////////////////////////

	postscript: function(/*Object?*/params, /*DomNode|String*/srcNodeRef){
		// summary:
		//		Kicks off widget instantiation.  See create() for details.
		// tags:
		//		private
		this.create(params, srcNodeRef);
	},

	create: function(/*Object?*/params, /*DomNode|String?*/srcNodeRef){
		// summary:
		//		Kick off the life-cycle of a widget
		// params:
		//		Hash of initialization parameters for widget, including
		//		scalar values (like title, duration etc.) and functions,
		//		typically callbacks like onClick.
		// srcNodeRef:
		//		If a srcNodeRef (DOM node) is specified:
		//			- use srcNodeRef.innerHTML as my contents
		//			- if this is a behavioral widget then apply behavior
		//			  to that srcNodeRef
		//			- otherwise, replace srcNodeRef with my generated DOM
		//			  tree
		// description:
		//		Create calls a number of widget methods (postMixInProperties, buildRendering, postCreate,
		//		etc.), some of which of you'll want to override. See http://docs.dojocampus.org/dijit/_Widget
		//		for a discussion of the widget creation lifecycle.
		//
		//		Of course, adventurous developers could override create entirely, but this should
		//		only be done as a last resort.
		// tags:
		//		private

		// store pointer to original DOM tree
		this.srcNodeRef = dojo.byId(srcNodeRef);

		// For garbage collection.  An array of handles returned by Widget.connect()
		// Each handle returned from Widget.connect() is an array of handles from dojo.connect()
		this._connects = [];

		// For garbage collection.  An array of handles returned by Widget.subscribe()
		// The handle returned from Widget.subscribe() is the handle returned from dojo.subscribe()
		this._subscribes = [];

		// mix in our passed parameters
		if(this.srcNodeRef && (typeof this.srcNodeRef.id == "string")){ this.id = this.srcNodeRef.id; }
		if(params){
			this.params = params;
			dojo._mixin(this, params);
		}
		this.postMixInProperties();

		// generate an id for the widget if one wasn't specified
		// (be sure to do this before buildRendering() because that function might
		// expect the id to be there.)
		if(!this.id){
			this.id = dijit.getUniqueId(this.declaredClass.replace(/\./g,"_"));
		}
		dijit.registry.add(this);

		this.buildRendering();

		if(this.domNode){
			// Copy attributes listed in attributeMap into the [newly created] DOM for the widget.
			// Also calls custom setters for all attributes with custom setters.
			this._applyAttributes();

			// If srcNodeRef was specified, then swap out original srcNode for this widget's DOM tree.
			// For 2.0, move this after postCreate().  postCreate() shouldn't depend on the
			// widget being attached to the DOM since it isn't when a widget is created programmatically like
			// new MyWidget({}).   See #11635.
			var source = this.srcNodeRef;
			if(source && source.parentNode && this.domNode !== source){
				source.parentNode.replaceChild(this.domNode, source);
			}
		}

		if(this.domNode){
			// Note: for 2.0 may want to rename widgetId to dojo._scopeName + "_widgetId",
			// assuming that dojo._scopeName even exists in 2.0
			this.domNode.setAttribute("widgetId", this.id);
		}
		this.postCreate();

		// If srcNodeRef has been processed and removed from the DOM (e.g. TemplatedWidget) then delete it to allow GC.
		if(this.srcNodeRef && !this.srcNodeRef.parentNode){
			delete this.srcNodeRef;
		}

		this._created = true;
	},

	_applyAttributes: function(){
		// summary:
		//		Step during widget creation to copy all widget attributes to the
		//		DOM as per attributeMap and _setXXXAttr functions.
		// description:
		//		Skips over blank/false attribute values, unless they were explicitly specified
		//		as parameters to the widget, since those are the default anyway,
		//		and setting tabIndex="" is different than not setting tabIndex at all.
		//
		//		It processes the attributes in the attribute map first, and then
		//		it goes through and processes the attributes for the _setXXXAttr
		//		functions that have been specified
		// tags:
		//		private
		var condAttrApply = function(attr, scope){
			if((scope.params && attr in scope.params) || scope[attr]){
				scope.set(attr, scope[attr]);
			}
		};

		// Do the attributes in attributeMap
		for(var attr in this.attributeMap){
			condAttrApply(attr, this);
		}

		// And also any attributes with custom setters
		dojo.forEach(this._getSetterAttributes(), function(a){
			if(!(a in this.attributeMap)){
				condAttrApply(a, this);
			}
		}, this);
	},

	_getSetterAttributes: function(){
		// summary:
		//		Returns list of attributes with custom setters for this widget
		var ctor = this.constructor;
		if(!ctor._setterAttrs){
			var r = (ctor._setterAttrs = []),
				attrs,
				proto = ctor.prototype;
			for(var fxName in proto){
				if(dojo.isFunction(proto[fxName]) && (attrs = fxName.match(/^_set([a-zA-Z]*)Attr$/)) && attrs[1]){
					r.push(attrs[1].charAt(0).toLowerCase() + attrs[1].substr(1));
				}
			}
		}
		return ctor._setterAttrs;	// String[]
	},

	postMixInProperties: function(){
		// summary:
		//		Called after the parameters to the widget have been read-in,
		//		but before the widget template is instantiated. Especially
		//		useful to set properties that are referenced in the widget
		//		template.
		// tags:
		//		protected
	},

	buildRendering: function(){
		// summary:
		//		Construct the UI for this widget, setting this.domNode
		// description:
		//		Most widgets will mixin `dijit._Templated`, which implements this
		//		method.
		// tags:
		//		protected

		if(!this.domNode){
			// Create root node if it wasn't created by _Templated
			this.domNode = this.srcNodeRef || dojo.create('div');
		}

		// baseClass is a single class name or occasionally a space-separated list of names.
		// Add those classes to the DOMNode.  If RTL mode then also add with Rtl suffix.
		// TODO: make baseClass custom setter
		if(this.baseClass){
			var classes = this.baseClass.split(" ");
			if(!this.isLeftToRight()){
				classes = classes.concat( dojo.map(classes, function(name){ return name+"Rtl"; }));
			}
			dojo.addClass(this.domNode, classes);
		}
	},

	postCreate: function(){
		// summary:
		//		Processing after the DOM fragment is created
		// description:
		//		Called after the DOM fragment has been created, but not necessarily
		//		added to the document.  Do not include any operations which rely on
		//		node dimensions or placement.
		// tags:
		//		protected
	},

	startup: function(){
		// summary:
		//		Processing after the DOM fragment is added to the document
		// description:
		//		Called after a widget and its children have been created and added to the page,
		//		and all related widgets have finished their create() cycle, up through postCreate().
		//		This is useful for composite widgets that need to control or layout sub-widgets.
		//		Many layout widgets can use this as a wiring phase.
		this._started = true;
	},

	//////////// DESTROY FUNCTIONS ////////////////////////////////

	destroyRecursive: function(/*Boolean?*/ preserveDom){
		// summary:
		// 		Destroy this widget and its descendants
		// description:
		//		This is the generic "destructor" function that all widget users
		// 		should call to cleanly discard with a widget. Once a widget is
		// 		destroyed, it is removed from the manager object.
		// preserveDom:
		//		If true, this method will leave the original DOM structure
		//		alone of descendant Widgets. Note: This will NOT work with
		//		dijit._Templated widgets.

		this._beingDestroyed = true;
		this.destroyDescendants(preserveDom);
		this.destroy(preserveDom);
	},

	destroy: function(/*Boolean*/ preserveDom){
		// summary:
		// 		Destroy this widget, but not its descendants.
		//		This method will, however, destroy internal widgets such as those used within a template.
		// preserveDom: Boolean
		//		If true, this method will leave the original DOM structure alone.
		//		Note: This will not yet work with _Templated widgets

		this._beingDestroyed = true;
		this.uninitialize();
		var d = dojo,
			dfe = d.forEach,
			dun = d.unsubscribe;
		dfe(this._connects, function(array){
			dfe(array, d.disconnect);
		});
		dfe(this._subscribes, function(handle){
			dun(handle);
		});

		// destroy widgets created as part of template, etc.
		dfe(this._supportingWidgets || [], function(w){
			if(w.destroyRecursive){
				w.destroyRecursive();
			}else if(w.destroy){
				w.destroy();
			}
		});

		this.destroyRendering(preserveDom);
		dijit.registry.remove(this.id);
		this._destroyed = true;
	},

	destroyRendering: function(/*Boolean?*/ preserveDom){
		// summary:
		//		Destroys the DOM nodes associated with this widget
		// preserveDom:
		//		If true, this method will leave the original DOM structure alone
		//		during tear-down. Note: this will not work with _Templated
		//		widgets yet.
		// tags:
		//		protected

		if(this.bgIframe){
			this.bgIframe.destroy(preserveDom);
			delete this.bgIframe;
		}

		if(this.domNode){
			if(preserveDom){
				dojo.removeAttr(this.domNode, "widgetId");
			}else{
				dojo.destroy(this.domNode);
			}
			delete this.domNode;
		}

		if(this.srcNodeRef){
			if(!preserveDom){
				dojo.destroy(this.srcNodeRef);
			}
			delete this.srcNodeRef;
		}
	},

	destroyDescendants: function(/*Boolean?*/ preserveDom){
		// summary:
		//		Recursively destroy the children of this widget and their
		//		descendants.
		// preserveDom:
		//		If true, the preserveDom attribute is passed to all descendant
		//		widget's .destroy() method. Not for use with _Templated
		//		widgets.

		// get all direct descendants and destroy them recursively
		dojo.forEach(this.getChildren(), function(widget){
			if(widget.destroyRecursive){
				widget.destroyRecursive(preserveDom);
			}
		});
	},

	uninitialize: function(){
		// summary:
		//		Stub function. Override to implement custom widget tear-down
		//		behavior.
		// tags:
		//		protected
		return false;
	},

	////////////////// GET/SET, CUSTOM SETTERS, ETC. ///////////////////

	_setClassAttr: function(/*String*/ value){
		// summary:
		//		Custom setter for the CSS "class" attribute
		// tags:
		//		protected
		var mapNode = this[this.attributeMap["class"] || 'domNode'];
		dojo.replaceClass(mapNode, value, this["class"]);
		this._set("class", value);
	},

	_setStyleAttr: function(/*String||Object*/ value){
		// summary:
		//		Sets the style attribute of the widget according to value,
		//		which is either a hash like {height: "5px", width: "3px"}
		//		or a plain string
		// description:
		//		Determines which node to set the style on based on style setting
		//		in attributeMap.
		// tags:
		//		protected

		var mapNode = this[this.attributeMap.style || 'domNode'];

		// Note: technically we should revert any style setting made in a previous call
		// to his method, but that's difficult to keep track of.

		if(dojo.isObject(value)){
			dojo.style(mapNode, value);
		}else{
			if(mapNode.style.cssText){
				mapNode.style.cssText += "; " + value;
			}else{
				mapNode.style.cssText = value;
			}
		}

		this._set("style", value);
	},

	_attrToDom: function(/*String*/ attr, /*String*/ value){
		// summary:
		//		Reflect a widget attribute (title, tabIndex, duration etc.) to
		//		the widget DOM, as specified in attributeMap.
		//		Note some attributes like "type"
		//		cannot be processed this way as they are not mutable.
		//
		// tags:
		//		private

		var commands = this.attributeMap[attr];
		dojo.forEach(dojo.isArray(commands) ? commands : [commands], function(command){

			// Get target node and what we are doing to that node
			var mapNode = this[command.node || command || "domNode"];	// DOM node
			var type = command.type || "attribute";	// class, innerHTML, innerText, or attribute

			switch(type){
				case "attribute":
					if(dojo.isFunction(value)){ // functions execute in the context of the widget
						value = dojo.hitch(this, value);
					}

					// Get the name of the DOM node attribute; usually it's the same
					// as the name of the attribute in the widget (attr), but can be overridden.
					// Also maps handler names to lowercase, like onSubmit --> onsubmit
					var attrName = command.attribute ? command.attribute :
						(/^on[A-Z][a-zA-Z]*$/.test(attr) ? attr.toLowerCase() : attr);

					dojo.attr(mapNode, attrName, value);
					break;
				case "innerText":
					mapNode.innerHTML = "";
					mapNode.appendChild(dojo.doc.createTextNode(value));
					break;
				case "innerHTML":
					mapNode.innerHTML = value;
					break;
				case "class":
					dojo.replaceClass(mapNode, value, this[attr]);
					break;
			}
		}, this);
	},

	get: function(name){
		// summary:
		//		Get a property from a widget.
		//	name:
		//		The property to get.
		// description:
		//		Get a named property from a widget. The property may
		//		potentially be retrieved via a getter method. If no getter is defined, this
		// 		just retrieves the object's property.
		// 		For example, if the widget has a properties "foo"
		//		and "bar" and a method named "_getFooAttr", calling:
		//	|	myWidget.get("foo");
		//		would be equivalent to writing:
		//	|	widget._getFooAttr();
		//		and:
		//	|	myWidget.get("bar");
		//		would be equivalent to writing:
		//	|	widget.bar;
		var names = this._getAttrNames(name);
		return this[names.g] ? this[names.g]() : this[name];
	},
	
	set: function(name, value){
		// summary:
		//		Set a property on a widget
		//	name:
		//		The property to set.
		//	value:
		//		The value to set in the property.
		// description:
		//		Sets named properties on a widget which may potentially be handled by a
		// 		setter in the widget.
		// 		For example, if the widget has a properties "foo"
		//		and "bar" and a method named "_setFooAttr", calling:
		//	|	myWidget.set("foo", "Howdy!");
		//		would be equivalent to writing:
		//	|	widget._setFooAttr("Howdy!");
		//		and:
		//	|	myWidget.set("bar", 3);
		//		would be equivalent to writing:
		//	|	widget.bar = 3;
		//
		//	set() may also be called with a hash of name/value pairs, ex:
		//	|	myWidget.set({
		//	|		foo: "Howdy",
		//	|		bar: 3
		//	|	})
		//	This is equivalent to calling set(foo, "Howdy") and set(bar, 3)

		if(typeof name === "object"){
			for(var x in name){
				this.set(x, name[x]);
			}
			return this;
		}
		var names = this._getAttrNames(name);
		if(this[names.s]){
			// use the explicit setter
			var result = this[names.s].apply(this, Array.prototype.slice.call(arguments, 1));
		}else{
			// if param is specified as DOM node attribute, copy it
			if(name in this.attributeMap){
				this._attrToDom(name, value);
			}
			this._set(name, value);
		}
		return result || this;
	},
	
	_attrPairNames: {},		// shared between all widgets
	_getAttrNames: function(name){
		// summary:
		//		Helper function for get() and set().
		//		Caches attribute name values so we don't do the string ops every time.
		// tags:
		//		private

		var apn = this._attrPairNames;
		if(apn[name]){ return apn[name]; }
		var uc = name.charAt(0).toUpperCase() + name.substr(1);
		return (apn[name] = {
			n: name+"Node",
			s: "_set"+uc+"Attr",
			g: "_get"+uc+"Attr"
		});
	},

	_set: function(/*String*/ name, /*anything*/ value){
		// summary:
		//		Helper function to set new value for specified attribute, and call handlers
		//		registered with watch() if the value has changed.
		var oldValue = this[name];
		this[name] = value;
		if(this._watchCallbacks && this._created && value !== oldValue){
			this._watchCallbacks(name, oldValue, value);
		}
	},

	toString: function(){
		// summary:
		//		Returns a string that represents the widget
		// description:
		//		When a widget is cast to a string, this method will be used to generate the
		//		output. Currently, it does not implement any sort of reversible
		//		serialization.
		return '[Widget ' + this.declaredClass + ', ' + (this.id || 'NO ID') + ']'; // String
	},

	getDescendants: function(){
		// summary:
		//		Returns all the widgets contained by this, i.e., all widgets underneath this.containerNode.
		//		This method should generally be avoided as it returns widgets declared in templates, which are
		//		supposed to be internal/hidden, but it's left here for back-compat reasons.

		return this.containerNode ? dojo.query('[widgetId]', this.containerNode).map(dijit.byNode) : []; // dijit._Widget[]
	},

	getChildren: function(){
		// summary:
		//		Returns all the widgets contained by this, i.e., all widgets underneath this.containerNode.
		//		Does not return nested widgets, nor widgets that are part of this widget's template.
		return this.containerNode ? dijit.findWidgets(this.containerNode) : []; // dijit._Widget[]
	},

	connect: function(
			/*Object|null*/ obj,
			/*String|Function*/ event,
			/*String|Function*/ method){
		// summary:
		//		Connects specified obj/event to specified method of this object
		//		and registers for disconnect() on widget destroy.
		// description:
		//		Provide widget-specific analog to dojo.connect, except with the
		//		implicit use of this widget as the target object.
		//		Events connected with `this.connect` are disconnected upon
		//		destruction.
		// returns:
		//		A handle that can be passed to `disconnect` in order to disconnect before
		//		the widget is destroyed.
		// example:
		//	|	var btn = new dijit.form.Button();
		//	|	// when foo.bar() is called, call the listener we're going to
		//	|	// provide in the scope of btn
		//	|	btn.connect(foo, "bar", function(){
		//	|		console.debug(this.toString());
		//	|	});
		// tags:
		//		protected

		var handles = [dojo._connect(obj, event, this, method)];
		this._connects.push(handles);
		return handles;		// _Widget.Handle
	},

	disconnect: function(/* _Widget.Handle */ handles){
		// summary:
		//		Disconnects handle created by `connect`.
		//		Also removes handle from this widget's list of connects.
		// tags:
		//		protected
		for(var i=0; i<this._connects.length; i++){
			if(this._connects[i] == handles){
				dojo.forEach(handles, dojo.disconnect);
				this._connects.splice(i, 1);
				return;
			}
		}
	},

	subscribe: function(
			/*String*/ topic,
			/*String|Function*/ method){
		// summary:
		//		Subscribes to the specified topic and calls the specified method
		//		of this object and registers for unsubscribe() on widget destroy.
		// description:
		//		Provide widget-specific analog to dojo.subscribe, except with the
		//		implicit use of this widget as the target object.
		// example:
		//	|	var btn = new dijit.form.Button();
		//	|	// when /my/topic is published, this button changes its label to
		//	|   // be the parameter of the topic.
		//	|	btn.subscribe("/my/topic", function(v){
		//	|		this.set("label", v);
		//	|	});
		var handle = dojo.subscribe(topic, this, method);

		// return handles for Any widget that may need them
		this._subscribes.push(handle);
		return handle;
	},

	unsubscribe: function(/*Object*/ handle){
		// summary:
		//		Unsubscribes handle created by this.subscribe.
		//		Also removes handle from this widget's list of subscriptions
		for(var i=0; i<this._subscribes.length; i++){
			if(this._subscribes[i] == handle){
				dojo.unsubscribe(handle);
				this._subscribes.splice(i, 1);
				return;
			}
		}
	},

	isLeftToRight: function(){
		// summary:
		//		Return this widget's explicit or implicit orientation (true for LTR, false for RTL)
		// tags:
		//		protected
		return this.dir ? (this.dir == "ltr") : dojo._isBodyLtr(); //Boolean
	},

	placeAt: function(/* String|DomNode|_Widget */reference, /* String?|Int? */position){
		// summary:
		//		Place this widget's domNode reference somewhere in the DOM based
		//		on standard dojo.place conventions, or passing a Widget reference that
		//		contains and addChild member.
		//
		// description:
		//		A convenience function provided in all _Widgets, providing a simple
		//		shorthand mechanism to put an existing (or newly created) Widget
		//		somewhere in the dom, and allow chaining.
		//
		// reference:
		//		The String id of a domNode, a domNode reference, or a reference to a Widget posessing
		//		an addChild method.
		//
		// position:
		//		If passed a string or domNode reference, the position argument
		//		accepts a string just as dojo.place does, one of: "first", "last",
		//		"before", or "after".
		//
		//		If passed a _Widget reference, and that widget reference has an ".addChild" method,
		//		it will be called passing this widget instance into that method, supplying the optional
		//		position index passed.
		//
		// returns:
		//		dijit._Widget
		//		Provides a useful return of the newly created dijit._Widget instance so you
		//		can "chain" this function by instantiating, placing, then saving the return value
		//		to a variable.
		//
		// example:
		// | 	// create a Button with no srcNodeRef, and place it in the body:
		// | 	var button = new dijit.form.Button({ label:"click" }).placeAt(dojo.body());
		// | 	// now, 'button' is still the widget reference to the newly created button
		// | 	dojo.connect(button, "onClick", function(e){ console.log('click'); });
		//
		// example:
		// |	// create a button out of a node with id="src" and append it to id="wrapper":
		// | 	var button = new dijit.form.Button({},"src").placeAt("wrapper");
		//
		// example:
		// |	// place a new button as the first element of some div
		// |	var button = new dijit.form.Button({ label:"click" }).placeAt("wrapper","first");
		//
		// example:
		// |	// create a contentpane and add it to a TabContainer
		// |	var tc = dijit.byId("myTabs");
		// |	new dijit.layout.ContentPane({ href:"foo.html", title:"Wow!" }).placeAt(tc)

		if(reference.declaredClass && reference.addChild){
			reference.addChild(this, position);
		}else{
			dojo.place(this.domNode, reference, position);
		}
		return this;
	},

	defer: function(fcn, delay){
		// summary:
		//		Wrapper to setTimeout to avoid deferred functions executing
		//		after the originating widget has been destroyed.
		//		Returns an object handle with a remove method (that returns null) (replaces clearTimeout).
		// fcn: function reference
		// delay: Optional number (defaults to 0)
		// tags:
		//		protected.
		var timer = setTimeout(dojo.hitch(this, 
			function(){ 
				timer = null;
				if(!this._destroyed){ 
					dojo.hitch(this, fcn)(); 
	}
			}),
			delay || 0
		);
		return {
			remove:	function(){
					if(timer){
						clearTimeout(timer);
						timer = null;
					}
					return null; // so this works well: handle = handle.remove();
				}
		};
	}
});

})();

}

if(!dojo._hasResource["dojo.window"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.window"] = true;
dojo.provide("dojo.window");

dojo.getObject("window", true, dojo);

dojo.window.getBox = function(){
	// summary:
	//		Returns the dimensions and scroll position of the viewable area of a browser window

	var scrollRoot = (dojo.doc.compatMode == 'BackCompat') ? dojo.body() : dojo.doc.documentElement;

	// get scroll position
	var scroll = dojo._docScroll(); // scrollRoot.scrollTop/Left should work
	return { w: scrollRoot.clientWidth, h: scrollRoot.clientHeight, l: scroll.x, t: scroll.y };
};

dojo.window.get = function(doc){
	// summary:
	// 		Get window object associated with document doc

	// In some IE versions (at least 6.0), document.parentWindow does not return a
	// reference to the real window object (maybe a copy), so we must fix it as well
	// We use IE specific execScript to attach the real window reference to
	// document._parentWindow for later use
	if(dojo.isIE && window !== document.parentWindow){
		/*
		In IE 6, only the variable "window" can be used to connect events (others
		may be only copies).
		*/
		doc.parentWindow.execScript("document._parentWindow = window;", "Javascript");
		//to prevent memory leak, unset it after use
		//another possibility is to add an onUnload handler which seems overkill to me (liucougar)
		var win = doc._parentWindow;
		doc._parentWindow = null;
		return win;	//	Window
	}

	return doc.parentWindow || doc.defaultView;	//	Window
};

dojo.window.scrollIntoView = function(/*DomNode*/ node, /*Object?*/ pos){
	// summary:
	//		Scroll the passed node into view using minimal movement, if it is not already.
	
	// Don't rely on node.scrollIntoView working just because the function is there since
	// it forces the node to the page's bottom or top (and left or right in IE) without consideration for the minimal movement.
	// WebKit's node.scrollIntoViewIfNeeded doesn't work either for inner scrollbars in right-to-left mode
	// and when there's a fixed position scrollable element

	node = dojo.byId(node);
	var body, doc = node.ownerDocument || dojo.doc;

	// has() functions but without has() support
	if(!("rtl_adjust_position_for_verticalScrollBar" in dojo.window)){
		body = dojo.body();
		var	scrollable = dojo.create('div', {
				style: {overflow:'scroll', overflowX:'visible', direction:'rtl', visibility:'hidden', position:'absolute', left:'0', top:'0', width:'64px', height:'64px'}
			}, body, "last"),
			div = dojo.create('div', {
				style: {overflow:'hidden', direction:'ltr'}
			}, scrollable, "last");
		dojo.window.rtl_adjust_position_for_verticalScrollBar = dojo.position(div).x != 0;
		scrollable.removeChild(div);
		body.removeChild(scrollable);
	}

	if(!("position_fixed_support" in dojo.window)){
		// IE6, IE7+quirks, and some older mobile browsers don't support position:fixed
		body = dojo.body();
		var	outer = dojo.create('span', {
				style: {visibility:'hidden', position:'fixed', left:'1px', top:'1px'}
			}, body, "last"),
			inner = dojo.create('span', {
				style: {position:'fixed', left:'0', top:'0'}
			}, outer, "last");
		dojo.window.position_fixed_support = dojo.position(inner).x != dojo.position(outer).x;
		outer.removeChild(inner);
		body.removeChild(outer);
	}

	try{ // catch unexpected/unrecreatable errors (#7808) since we can recover using a semi-acceptable native method
		body = doc.body || doc.getElementsByTagName("body")[0];
		var	html = doc.documentElement || body.parentNode,
			isIE = dojo.isIE,
			isWK = dojo.isWebKit;
		// if an untested browser, then use the native method
		if(node == body || node == html){ return; }
		if(!(dojo.isMozilla || isIE || isWK || dojo.isOpera) && ("scrollIntoView" in node)){
			node.scrollIntoView(false); // short-circuit to native if possible
			return;
		}
		var backCompat = doc.compatMode == 'BackCompat',
			rootWidth = Math.min(body.clientWidth || html.clientWidth, html.clientWidth || body.clientWidth),
			rootHeight = Math.min(body.clientHeight || html.clientHeight, html.clientHeight || body.clientHeight),
			scrollRoot = (isWK || backCompat) ? body : html,
			nodePos = pos || dojo.position(node),
			el = node.parentNode,
			isFixed = function(el){
				return (isIE <= 6 || (isIE == 7 && backCompat))
					? false
					: (dojo.window.position_fixed_support && (dojo.style(el, 'position').toLowerCase() == "fixed"));
			};
		if(isFixed(node)){ return; } // nothing to do
		while(el){
			if(el == body){ el = scrollRoot; }
			var elPos = dojo.position(el),
				fixedPos = isFixed(el),
				rtl = dojo.getComputedStyle(el).direction.toLowerCase() == "rtl";
	
			if(el == scrollRoot){
				elPos.w = rootWidth; elPos.h = rootHeight;
				if(scrollRoot == html && isIE && rtl){ elPos.x += scrollRoot.offsetWidth-elPos.w; } // IE workaround where scrollbar causes negative x
				if(elPos.x < 0 || !isIE || isIE >= 9){ elPos.x = 0; } // older IE can have values > 0
				if(elPos.y < 0 || !isIE || isIE >= 9){ elPos.y = 0; }
			}else{
				var pb = dojo._getPadBorderExtents(el);
				elPos.w -= pb.w; elPos.h -= pb.h; elPos.x += pb.l; elPos.y += pb.t;
				var clientSize = el.clientWidth,
					scrollBarSize = elPos.w - clientSize;
				if(clientSize > 0 && scrollBarSize > 0){
					if(rtl && dojo.window.rtl_adjust_position_for_verticalScrollBar){
						elPos.x += scrollBarSize;
					}
					elPos.w = clientSize;
				}
				clientSize = el.clientHeight;
				scrollBarSize = elPos.h - clientSize;
				if(clientSize > 0 && scrollBarSize > 0){
					elPos.h = clientSize;
				}
			}
			if(fixedPos){ // bounded by viewport, not parents
				if(elPos.y < 0){
					elPos.h += elPos.y; elPos.y = 0;
				}
				if(elPos.x < 0){
					elPos.w += elPos.x; elPos.x = 0;
				}
				if(elPos.y + elPos.h > rootHeight){
					elPos.h = rootHeight - elPos.y;
				}
				if(elPos.x + elPos.w > rootWidth){
					elPos.w = rootWidth - elPos.x;
				}
			}
			// calculate overflow in all 4 directions
			var l = nodePos.x - elPos.x, // beyond left: < 0
//						t = nodePos.y - Math.max(elPos.y, 0), // beyond top: < 0
				t = nodePos.y - elPos.y, // beyond top: < 0
				r = l + nodePos.w - elPos.w, // beyond right: > 0
				bot = t + nodePos.h - elPos.h; // beyond bottom: > 0
			var s, old;
			if(r * l > 0 && (!!el.scrollLeft || el == scrollRoot || el.scrollWidth > el.offsetHeight)){
				s = Math[l < 0? "max" : "min"](l, r);
				if(rtl && ((isIE == 8 && !backCompat) || isIE >= 9)){ s = -s; }
				old = el.scrollLeft;
				el.scrollLeft += s;
				s = el.scrollLeft - old;
				nodePos.x -= s;
			}
			if(bot * t > 0 && (!!el.scrollTop || el == scrollRoot || el.scrollHeight > el.offsetHeight)){
				s = Math.ceil(Math[t < 0? "max" : "min"](t, bot));
				old = el.scrollTop;
				el.scrollTop += s;
				s = el.scrollTop - old;
				nodePos.y -= s;
			}
			el = (el != scrollRoot) && !fixedPos && el.parentNode;
		}
	}catch(error){
		console.error('scrollIntoView: ' + error);
		node.scrollIntoView(false);
	}
};

}

if(!dojo._hasResource["dijit._base.focus"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.focus"] = true;
dojo.provide("dijit._base.focus");




// summary:
//		These functions are used to query or set the focus and selection.
//
//		Also, they trace when widgets become activated/deactivated,
//		so that the widget can fire _onFocus/_onBlur events.
//		"Active" here means something similar to "focused", but
//		"focus" isn't quite the right word because we keep track of
//		a whole stack of "active" widgets.  Example: ComboButton --> Menu -->
//		MenuItem.  The onBlur event for ComboButton doesn't fire due to focusing
//		on the Menu or a MenuItem, since they are considered part of the
//		ComboButton widget.  It only happens when focus is shifted
//		somewhere completely different.

dojo.mixin(dijit, {
	// _curFocus: DomNode
	//		Currently focused item on screen
	_curFocus: null,

	// _prevFocus: DomNode
	//		Previously focused item on screen
	_prevFocus: null,

	isCollapsed: function(){
		// summary:
		//		Returns true if there is no text selected
		return dijit.getBookmark().isCollapsed;
	},

	getBookmark: function(){
		// summary:
		//		Retrieves a bookmark that can be used with moveToBookmark to return to the same range
		var bm, rg, tg, sel = dojo.doc.selection, cf = dijit._curFocus;

		if(dojo.global.getSelection){
			//W3C Range API for selections.
			sel = dojo.global.getSelection();
			if(sel){
				if(sel.isCollapsed){
					tg = cf? cf.tagName : "";
					if(tg){
						//Create a fake rangelike item to restore selections.
						tg = tg.toLowerCase();
						if(tg == "textarea" ||
								(tg == "input" && (!cf.type || cf.type.toLowerCase() == "text"))){
							sel = {
								start: cf.selectionStart,
								end: cf.selectionEnd,
								node: cf,
								pRange: true
							};
							return {isCollapsed: (sel.end <= sel.start), mark: sel}; //Object.
						}
					}
					bm = {isCollapsed:true};
					if(sel.rangeCount){
						bm.mark = sel.getRangeAt(0).cloneRange();
					}
				}else{
					rg = sel.getRangeAt(0);
					bm = {isCollapsed: false, mark: rg.cloneRange()};
				}
			}
		}else if(sel){
			// If the current focus was a input of some sort and no selection, don't bother saving
			// a native bookmark.  This is because it causes issues with dialog/page selection restore.
			// So, we need to create psuedo bookmarks to work with.
			tg = cf ? cf.tagName : "";
			tg = tg.toLowerCase();
			if(cf && tg && (tg == "button" || tg == "textarea" || tg == "input")){
				if(sel.type && sel.type.toLowerCase() == "none"){
					return {
						isCollapsed: true,
						mark: null
					}
				}else{
					rg = sel.createRange();
					return {
						isCollapsed: rg.text && rg.text.length?false:true,
						mark: {
							range: rg,
							pRange: true
						}
					};
				}
			}
			bm = {};

			//'IE' way for selections.
			try{
				// createRange() throws exception when dojo in iframe
				//and nothing selected, see #9632
				rg = sel.createRange();
				bm.isCollapsed = !(sel.type == 'Text' ? rg.htmlText.length : rg.length);
			}catch(e){
				bm.isCollapsed = true;
				return bm;
			}
			if(sel.type.toUpperCase() == 'CONTROL'){
				if(rg.length){
					bm.mark=[];
					var i=0,len=rg.length;
					while(i<len){
						bm.mark.push(rg.item(i++));
					}
				}else{
					bm.isCollapsed = true;
					bm.mark = null;
				}
			}else{
				bm.mark = rg.getBookmark();
			}
		}else{
			console.warn("No idea how to store the current selection for this browser!");
		}
		return bm; // Object
	},

	moveToBookmark: function(/*Object*/bookmark){
		// summary:
		//		Moves current selection to a bookmark
		// bookmark:
		//		This should be a returned object from dijit.getBookmark()

		var _doc = dojo.doc,
			mark = bookmark.mark;
		if(mark){
			if(dojo.global.getSelection){
				//W3C Rangi API (FF, WebKit, Opera, etc)
				var sel = dojo.global.getSelection();
				if(sel && sel.removeAllRanges){
					if(mark.pRange){
						var r = mark;
						var n = r.node;
						n.selectionStart = r.start;
						n.selectionEnd = r.end;
					}else{
						sel.removeAllRanges();
						sel.addRange(mark);
					}
				}else{
					console.warn("No idea how to restore selection for this browser!");
				}
			}else if(_doc.selection && mark){
				//'IE' way.
				var rg;
				if(mark.pRange){
					rg = mark.range;
				}else if(dojo.isArray(mark)){
					rg = _doc.body.createControlRange();
					//rg.addElement does not have call/apply method, so can not call it directly
					//rg is not available in "range.addElement(item)", so can't use that either
					dojo.forEach(mark, function(n){
						rg.addElement(n);
					});
				}else{
					rg = _doc.body.createTextRange();
					rg.moveToBookmark(mark);
				}
				rg.select();
			}
		}
	},

	getFocus: function(/*Widget?*/ menu, /*Window?*/ openedForWindow){
		// summary:
		//		Called as getFocus(), this returns an Object showing the current focus
		//		and selected text.
		//
		//		Called as getFocus(widget), where widget is a (widget representing) a button
		//		that was just pressed, it returns where focus was before that button
		//		was pressed.   (Pressing the button may have either shifted focus to the button,
		//		or removed focus altogether.)   In this case the selected text is not returned,
		//		since it can't be accurately determined.
		//
		// menu: dijit._Widget or {domNode: DomNode} structure
		//		The button that was just pressed.  If focus has disappeared or moved
		//		to this button, returns the previous focus.  In this case the bookmark
		//		information is already lost, and null is returned.
		//
		// openedForWindow:
		//		iframe in which menu was opened
		//
		// returns:
		//		A handle to restore focus/selection, to be passed to `dijit.focus`
		var node = !dijit._curFocus || (menu && dojo.isDescendant(dijit._curFocus, menu.domNode)) ? dijit._prevFocus : dijit._curFocus;
		return {
			node: node,
			bookmark: (node == dijit._curFocus) && dojo.withGlobal(openedForWindow || dojo.global, dijit.getBookmark),
			openedForWindow: openedForWindow
		}; // Object
	},

	focus: function(/*Object || DomNode */ handle){
		// summary:
		//		Sets the focused node and the selection according to argument.
		//		To set focus to an iframe's content, pass in the iframe itself.
		// handle:
		//		object returned by get(), or a DomNode

		if(!handle){ return; }

		var node = "node" in handle ? handle.node : handle,		// because handle is either DomNode or a composite object
			bookmark = handle.bookmark,
			openedForWindow = handle.openedForWindow,
			collapsed = bookmark ? bookmark.isCollapsed : false;

		// Set the focus
		// Note that for iframe's we need to use the <iframe> to follow the parentNode chain,
		// but we need to set focus to iframe.contentWindow
		if(node){
			var focusNode = (node.tagName.toLowerCase() == "iframe") ? node.contentWindow : node;
			if(focusNode && focusNode.focus){
				try{
					// Gecko throws sometimes if setting focus is impossible,
					// node not displayed or something like that
					focusNode.focus();
				}catch(e){/*quiet*/}
			}
			dijit._onFocusNode(node);
		}

		// set the selection
		// do not need to restore if current selection is not empty
		// (use keyboard to select a menu item) or if previous selection was collapsed
		// as it may cause focus shift (Esp in IE).
		if(bookmark && dojo.withGlobal(openedForWindow || dojo.global, dijit.isCollapsed) && !collapsed){
			if(openedForWindow){
				openedForWindow.focus();
			}
			try{
				dojo.withGlobal(openedForWindow || dojo.global, dijit.moveToBookmark, null, [bookmark]);
			}catch(e2){
				/*squelch IE internal error, see http://trac.dojotoolkit.org/ticket/1984 */
			}
		}
	},

	// _activeStack: dijit._Widget[]
	//		List of currently active widgets (focused widget and it's ancestors)
	_activeStack: [],

	registerIframe: function(/*DomNode*/ iframe){
		// summary:
		//		Registers listeners on the specified iframe so that any click
		//		or focus event on that iframe (or anything in it) is reported
		//		as a focus/click event on the <iframe> itself.
		// description:
		//		Currently only used by editor.
		// returns:
		//		Handle to pass to unregisterIframe()
		return dijit.registerWin(iframe.contentWindow, iframe);
	},

	unregisterIframe: function(/*Object*/ handle){
		// summary:
		//		Unregisters listeners on the specified iframe created by registerIframe.
		//		After calling be sure to delete or null out the handle itself.
		// handle:
		//		Handle returned by registerIframe()

		dijit.unregisterWin(handle);
	},

	registerWin: function(/*Window?*/targetWindow, /*DomNode?*/ effectiveNode){
		// summary:
		//		Registers listeners on the specified window (either the main
		//		window or an iframe's window) to detect when the user has clicked somewhere
		//		or focused somewhere.
		// description:
		//		Users should call registerIframe() instead of this method.
		// targetWindow:
		//		If specified this is the window associated with the iframe,
		//		i.e. iframe.contentWindow.
		// effectiveNode:
		//		If specified, report any focus events inside targetWindow as
		//		an event on effectiveNode, rather than on evt.target.
		// returns:
		//		Handle to pass to unregisterWin()

		// TODO: make this function private in 2.0; Editor/users should call registerIframe(),

		var mousedownListener = function(evt){
			dijit._justMouseDowned = true;
			setTimeout(function(){ dijit._justMouseDowned = false; }, 0);
			
			// workaround weird IE bug where the click is on an orphaned node
			// (first time clicking a Select/DropDownButton inside a TooltipDialog)
			if(dojo.isIE && evt && evt.srcElement && evt.srcElement.parentNode == null){
				return;
			}

			dijit._onTouchNode(effectiveNode || evt.target || evt.srcElement, "mouse");
		};
		//dojo.connect(targetWindow, "onscroll", ???);

		// Listen for blur and focus events on targetWindow's document.
		// IIRC, I'm using attachEvent() rather than dojo.connect() because focus/blur events don't bubble
		// through dojo.connect(), and also maybe to catch the focus events early, before onfocus handlers
		// fire.
		// Connect to <html> (rather than document) on IE to avoid memory leaks, but document on other browsers because
		// (at least for FF) the focus event doesn't fire on <html> or <body>.
		var doc = dojo.isIE ? targetWindow.document.documentElement : targetWindow.document;
		if(doc){
			if(dojo.isIE){
				targetWindow.document.body.attachEvent('onmousedown', mousedownListener);
				var activateListener = function(evt){
					// IE reports that nodes like <body> have gotten focus, even though they have tabIndex=-1,
					// Should consider those more like a mouse-click than a focus....
					if(evt.srcElement.tagName.toLowerCase() != "#document" &&
						dijit.isTabNavigable(evt.srcElement)){
						dijit._onFocusNode(effectiveNode || evt.srcElement);
					}else{
						dijit._onTouchNode(effectiveNode || evt.srcElement);
					}
				};
				doc.attachEvent('onactivate', activateListener);
				var deactivateListener =  function(evt){
					dijit._onBlurNode(effectiveNode || evt.srcElement);
				};
				doc.attachEvent('ondeactivate', deactivateListener);

				return function(){
					targetWindow.document.detachEvent('onmousedown', mousedownListener);
					doc.detachEvent('onactivate', activateListener);
					doc.detachEvent('ondeactivate', deactivateListener);
					doc = null;	// prevent memory leak (apparent circular reference via closure)
				};
			}else{
				doc.body.addEventListener('mousedown', mousedownListener, true);
				var focusListener = function(evt){
					dijit._onFocusNode(effectiveNode || evt.target);
				};
				doc.addEventListener('focus', focusListener, true);
				var blurListener = function(evt){
					dijit._onBlurNode(effectiveNode || evt.target);
				};
				doc.addEventListener('blur', blurListener, true);

				return function(){
					doc.body.removeEventListener('mousedown', mousedownListener, true);
					doc.removeEventListener('focus', focusListener, true);
					doc.removeEventListener('blur', blurListener, true);
					doc = null;	// prevent memory leak (apparent circular reference via closure)
				};
			}
		}
	},

	unregisterWin: function(/*Handle*/ handle){
		// summary:
		//		Unregisters listeners on the specified window (either the main
		//		window or an iframe's window) according to handle returned from registerWin().
		//		After calling be sure to delete or null out the handle itself.

		// Currently our handle is actually a function
		handle && handle();
	},

	_onBlurNode: function(/*DomNode*/ node){
		// summary:
		// 		Called when focus leaves a node.
		//		Usually ignored, _unless_ it *isn't* follwed by touching another node,
		//		which indicates that we tabbed off the last field on the page,
		//		in which case every widget is marked inactive
		dijit._prevFocus = dijit._curFocus;
		dijit._curFocus = null;

		if(dijit._justMouseDowned){
			// the mouse down caused a new widget to be marked as active; this blur event
			// is coming late, so ignore it.
			return;
		}

		// if the blur event isn't followed by a focus event then mark all widgets as inactive.
		if(dijit._clearActiveWidgetsTimer){
			clearTimeout(dijit._clearActiveWidgetsTimer);
		}
		dijit._clearActiveWidgetsTimer = setTimeout(function(){
			delete dijit._clearActiveWidgetsTimer;
			dijit._setStack([]);
			dijit._prevFocus = null;
		}, 100);
	},

	_onTouchNode: function(/*DomNode*/ node, /*String*/ by){
		// summary:
		//		Callback when node is focused or mouse-downed
		// node:
		//		The node that was touched.
		// by:
		//		"mouse" if the focus/touch was caused by a mouse down event

		// ignore the recent blurNode event
		if(dijit._clearActiveWidgetsTimer){
			clearTimeout(dijit._clearActiveWidgetsTimer);
			delete dijit._clearActiveWidgetsTimer;
		}

		// compute stack of active widgets (ex: ComboButton --> Menu --> MenuItem)
		var newStack=[];
		try{
			while(node){
				var popupParent = dojo.attr(node, "dijitPopupParent");
				if(popupParent){
					node=dijit.byId(popupParent).domNode;
				}else if(node.tagName && node.tagName.toLowerCase() == "body"){
					// is this the root of the document or just the root of an iframe?
					if(node === dojo.body()){
						// node is the root of the main document
						break;
					}
					// otherwise, find the iframe this node refers to (can't access it via parentNode,
					// need to do this trick instead). window.frameElement is supported in IE/FF/Webkit
					node=dojo.window.get(node.ownerDocument).frameElement;
				}else{
					// if this node is the root node of a widget, then add widget id to stack,
					// except ignore clicks on disabled widgets (actually focusing a disabled widget still works,
					// to support MenuItem)
					var id = node.getAttribute && node.getAttribute("widgetId"),
						widget = id && dijit.byId(id);
					if(widget && !(by == "mouse" && widget.get("disabled"))){
						newStack.unshift(id);
					}
					node=node.parentNode;
				}
			}
		}catch(e){ /* squelch */ }

		dijit._setStack(newStack, by);
	},

	_onFocusNode: function(/*DomNode*/ node){
		// summary:
		//		Callback when node is focused

		if(!node){
			return;
		}

		if(node.nodeType == 9){
			// Ignore focus events on the document itself.  This is here so that
			// (for example) clicking the up/down arrows of a spinner
			// (which don't get focus) won't cause that widget to blur. (FF issue)
			return;
		}

		dijit._onTouchNode(node);

		if(node == dijit._curFocus){ return; }
		if(dijit._curFocus){
			dijit._prevFocus = dijit._curFocus;
		}
		dijit._curFocus = node;
		dojo.publish("focusNode", [node]);
	},

	_setStack: function(/*String[]*/ newStack, /*String*/ by){
		// summary:
		//		The stack of active widgets has changed.  Send out appropriate events and records new stack.
		// newStack:
		//		array of widget id's, starting from the top (outermost) widget
		// by:
		//		"mouse" if the focus/touch was caused by a mouse down event

		var oldStack = dijit._activeStack;
		dijit._activeStack = newStack;

		// compare old stack to new stack to see how many elements they have in common
		for(var nCommon=0; nCommon<Math.min(oldStack.length, newStack.length); nCommon++){
			if(oldStack[nCommon] != newStack[nCommon]){
				break;
			}
		}

		var widget;
		// for all elements that have gone out of focus, send blur event
		for(var i=oldStack.length-1; i>=nCommon; i--){
			widget = dijit.byId(oldStack[i]);
			if(widget){
				widget._focused = false;
				widget.set("focused", false);
				widget._hasBeenBlurred = true;
				if(widget._onBlur){
					widget._onBlur(by);
				}
				dojo.publish("widgetBlur", [widget, by]);
			}
		}

		// for all element that have come into focus, send focus event
		for(i=nCommon; i<newStack.length; i++){
			widget = dijit.byId(newStack[i]);
			if(widget){
				widget._focused = true;
				widget.set("focused", true);
				if(widget._onFocus){
					widget._onFocus(by);
				}
				dojo.publish("widgetFocus", [widget, by]);
			}
		}
	}
});

// register top window and all the iframes it contains
dojo.addOnLoad(function(){
	var handle = dijit.registerWin(window);
	if(dojo.isIE){
		dojo.addOnWindowUnload(function(){
			dijit.unregisterWin(handle);
			handle = null;
		})
	}
});

}

if(!dojo._hasResource["dojo.AdapterRegistry"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.AdapterRegistry"] = true;
dojo.provide("dojo.AdapterRegistry");


dojo.AdapterRegistry = function(/*Boolean?*/ returnWrappers){
	//	summary:
	//		A registry to make contextual calling/searching easier.
	//	description:
	//		Objects of this class keep list of arrays in the form [name, check,
	//		wrap, directReturn] that are used to determine what the contextual
	//		result of a set of checked arguments is. All check/wrap functions
	//		in this registry should be of the same arity.
	//	example:
	//	|	// create a new registry
	//	|	var reg = new dojo.AdapterRegistry();
	//	|	reg.register("handleString",
	//	|		dojo.isString,
	//	|		function(str){
	//	|			// do something with the string here
	//	|		}
	//	|	);
	//	|	reg.register("handleArr",
	//	|		dojo.isArray,
	//	|		function(arr){
	//	|			// do something with the array here
	//	|		}
	//	|	);
	//	|
	//	|	// now we can pass reg.match() *either* an array or a string and
	//	|	// the value we pass will get handled by the right function
	//	|	reg.match("someValue"); // will call the first function
	//	|	reg.match(["someValue"]); // will call the second

	this.pairs = [];
	this.returnWrappers = returnWrappers || false; // Boolean
};

dojo.extend(dojo.AdapterRegistry, {
	register: function(/*String*/ name, /*Function*/ check, /*Function*/ wrap, /*Boolean?*/ directReturn, /*Boolean?*/ override){
		//	summary:
		//		register a check function to determine if the wrap function or
		//		object gets selected
		//	name:
		//		a way to identify this matcher.
		//	check:
		//		a function that arguments are passed to from the adapter's
		//		match() function.  The check function should return true if the
		//		given arguments are appropriate for the wrap function.
		//	directReturn:
		//		If directReturn is true, the value passed in for wrap will be
		//		returned instead of being called. Alternately, the
		//		AdapterRegistry can be set globally to "return not call" using
		//		the returnWrappers property. Either way, this behavior allows
		//		the registry to act as a "search" function instead of a
		//		function interception library.
		//	override:
		//		If override is given and true, the check function will be given
		//		highest priority. Otherwise, it will be the lowest priority
		//		adapter.
		this.pairs[((override) ? "unshift" : "push")]([name, check, wrap, directReturn]);
	},

	match: function(/* ... */){
		// summary:
		//		Find an adapter for the given arguments. If no suitable adapter
		//		is found, throws an exception. match() accepts any number of
		//		arguments, all of which are passed to all matching functions
		//		from the registered pairs.
		for(var i = 0; i < this.pairs.length; i++){
			var pair = this.pairs[i];
			if(pair[1].apply(this, arguments)){
				if((pair[3])||(this.returnWrappers)){
					return pair[2];
				}else{
					return pair[2].apply(this, arguments);
				}
			}
		}
		throw new Error("No match found");
	},

	unregister: function(name){
		// summary: Remove a named adapter from the registry

		// FIXME: this is kind of a dumb way to handle this. On a large
		// registry this will be slow-ish and we can use the name as a lookup
		// should we choose to trade memory for speed.
		for(var i = 0; i < this.pairs.length; i++){
			var pair = this.pairs[i];
			if(pair[0] == name){
				this.pairs.splice(i, 1);
				return true;
			}
		}
		return false;
	}
});

}

if(!dojo._hasResource["dijit._base.place"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.place"] = true;
dojo.provide("dijit._base.place");




dijit.getViewport = function(){
	// summary:
	//		Returns the dimensions and scroll position of the viewable area of a browser window

	return dojo.window.getBox();
};

/*=====
dijit.__Position = function(){
	// x: Integer
	//		horizontal coordinate in pixels, relative to document body
	// y: Integer
	//		vertical coordinate in pixels, relative to document body

	thix.x = x;
	this.y = y;
}
=====*/


dijit.placeOnScreen = function(
	/* DomNode */			node,
	/* dijit.__Position */	pos,
	/* String[] */			corners,
	/* dijit.__Position? */	padding){
	// summary:
	//		Positions one of the node's corners at specified position
	//		such that node is fully visible in viewport.
	// description:
	//		NOTE: node is assumed to be absolutely or relatively positioned.
	//	pos:
	//		Object like {x: 10, y: 20}
	//	corners:
	//		Array of Strings representing order to try corners in, like ["TR", "BL"].
	//		Possible values are:
	//			* "BL" - bottom left
	//			* "BR" - bottom right
	//			* "TL" - top left
	//			* "TR" - top right
	//	padding:
	//		set padding to put some buffer around the element you want to position.
	// example:
	//		Try to place node's top right corner at (10,20).
	//		If that makes node go (partially) off screen, then try placing
	//		bottom left corner at (10,20).
	//	|	placeOnScreen(node, {x: 10, y: 20}, ["TR", "BL"])

	var choices = dojo.map(corners, function(corner){
		var c = { corner: corner, pos: {x:pos.x,y:pos.y} };
		if(padding){
			c.pos.x += corner.charAt(1) == 'L' ? padding.x : -padding.x;
			c.pos.y += corner.charAt(0) == 'T' ? padding.y : -padding.y;
		}
		return c;
	});

	return dijit._place(node, choices);
}

dijit._place = function(/*DomNode*/ node, choices, layoutNode, /*Object*/ aroundNodeCoords){
	// summary:
	//		Given a list of spots to put node, put it at the first spot where it fits,
	//		of if it doesn't fit anywhere then the place with the least overflow
	// choices: Array
	//		Array of elements like: {corner: 'TL', pos: {x: 10, y: 20} }
	//		Above example says to put the top-left corner of the node at (10,20)
	// layoutNode: Function(node, aroundNodeCorner, nodeCorner, size)
	//		for things like tooltip, they are displayed differently (and have different dimensions)
	//		based on their orientation relative to the parent.   This adjusts the popup based on orientation.
	//		It also passes in the available size for the popup, which is useful for tooltips to
	//		tell them that their width is limited to a certain amount.   layoutNode() may return a value expressing
	//		how much the popup had to be modified to fit into the available space.   This is used to determine
	//		what the best placement is.
	// aroundNodeCoords: Object
	//		Size of aroundNode, ex: {w: 200, h: 50}

	// get {x: 10, y: 10, w: 100, h:100} type obj representing position of
	// viewport over document
	var view = dojo.window.getBox();

	// This won't work if the node is inside a <div style="position: relative">,
	// so reattach it to dojo.doc.body.   (Otherwise, the positioning will be wrong
	// and also it might get cutoff)
	if(!node.parentNode || String(node.parentNode.tagName).toLowerCase() != "body"){
		dojo.body().appendChild(node);
	}

	var best = null;
	dojo.some(choices, function(choice){
		var corner = choice.corner;
		var pos = choice.pos;
		var overflow = 0;

		// calculate amount of space available given specified position of node
		var spaceAvailable = {
			w: corner.charAt(1) == 'L' ? (view.l + view.w) - pos.x : pos.x - view.l,
			h: corner.charAt(1) == 'T' ? (view.t + view.h) - pos.y : pos.y - view.t
		};

		// configure node to be displayed in given position relative to button
		// (need to do this in order to get an accurate size for the node, because
		// a tooltip's size changes based on position, due to triangle)
		if(layoutNode){
			var res = layoutNode(node, choice.aroundCorner, corner, spaceAvailable, aroundNodeCoords);
			overflow = typeof res == "undefined" ? 0 : res;
		}

		// get node's size
		var style = node.style;
		var oldDisplay = style.display;
		var oldVis = style.visibility;
		style.visibility = "hidden";
		style.display = "";
		var mb = dojo.marginBox(node);
		style.display = oldDisplay;
		style.visibility = oldVis;

		// coordinates and size of node with specified corner placed at pos,
		// and clipped by viewport
		var startX = Math.max(view.l, corner.charAt(1) == 'L' ? pos.x : (pos.x - mb.w)),
			startY = Math.max(view.t, corner.charAt(0) == 'T' ? pos.y : (pos.y - mb.h)),
			endX = Math.min(view.l + view.w, corner.charAt(1) == 'L' ? (startX + mb.w) : pos.x),
			endY = Math.min(view.t + view.h, corner.charAt(0) == 'T' ? (startY + mb.h) : pos.y),
			width = endX - startX,
			height = endY - startY;

		overflow += (mb.w - width) + (mb.h - height);

		if(best == null || overflow < best.overflow){
			best = {
				corner: corner,
				aroundCorner: choice.aroundCorner,
				x: startX,
				y: startY,
				w: width,
				h: height,
				overflow: overflow,
				spaceAvailable: spaceAvailable
			};
		}
		
		return !overflow;
	});

	// In case the best position is not the last one we checked, need to call
	// layoutNode() again.
	if(best.overflow && layoutNode){
		layoutNode(node, best.aroundCorner, best.corner, best.spaceAvailable, aroundNodeCoords);
	}

	// And then position the node.   Do this last, after the layoutNode() above
	// has sized the node, due to browser quirks when the viewport is scrolled
	// (specifically that a Tooltip will shrink to fit as though the window was
	// scrolled to the left).
	//
	// In RTL mode, set style.right rather than style.left so in the common case,
	// window resizes move the popup along with the aroundNode.
	var l = dojo._isBodyLtr(),
		s = node.style;
	s.top = best.y + "px";
	s[l ? "left" : "right"] = (l ? best.x : view.w - best.x - best.w) + "px";
	s[l ? "right" : "left"] = "auto";       // needed for FF or else tooltip goes to far left

	return best;
}

dijit.placeOnScreenAroundNode = function(
	/* DomNode */		node,
	/* DomNode */		aroundNode,
	/* Object */		aroundCorners,
	/* Function? */		layoutNode){

	// summary:
	//		Position node adjacent or kitty-corner to aroundNode
	//		such that it's fully visible in viewport.
	//
	// description:
	//		Place node such that corner of node touches a corner of
	//		aroundNode, and that node is fully visible.
	//
	// aroundCorners:
	//		Ordered list of pairs of corners to try matching up.
	//		Each pair of corners is represented as a key/value in the hash,
	//		where the key corresponds to the aroundNode's corner, and
	//		the value corresponds to the node's corner:
	//
	//	|	{ aroundNodeCorner1: nodeCorner1, aroundNodeCorner2: nodeCorner2, ...}
	//
	//		The following strings are used to represent the four corners:
	//			* "BL" - bottom left
	//			* "BR" - bottom right
	//			* "TL" - top left
	//			* "TR" - top right
	//
	// layoutNode: Function(node, aroundNodeCorner, nodeCorner)
	//		For things like tooltip, they are displayed differently (and have different dimensions)
	//		based on their orientation relative to the parent.   This adjusts the popup based on orientation.
	//
	// example:
	//	|	dijit.placeOnScreenAroundNode(node, aroundNode, {'BL':'TL', 'TR':'BR'});
	//		This will try to position node such that node's top-left corner is at the same position
	//		as the bottom left corner of the aroundNode (ie, put node below
	//		aroundNode, with left edges aligned).  If that fails it will try to put
	// 		the bottom-right corner of node where the top right corner of aroundNode is
	//		(ie, put node above aroundNode, with right edges aligned)
	//

	// get coordinates of aroundNode
	aroundNode = dojo.byId(aroundNode);
	var aroundNodePos = dojo.position(aroundNode, true);

	// place the node around the calculated rectangle
	return dijit._placeOnScreenAroundRect(node,
		aroundNodePos.x, aroundNodePos.y, aroundNodePos.w, aroundNodePos.h,	// rectangle
		aroundCorners, layoutNode);
};

/*=====
dijit.__Rectangle = function(){
	// x: Integer
	//		horizontal offset in pixels, relative to document body
	// y: Integer
	//		vertical offset in pixels, relative to document body
	// width: Integer
	//		width in pixels
	// height: Integer
	//		height in pixels

	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
}
=====*/


dijit.placeOnScreenAroundRectangle = function(
	/* DomNode */			node,
	/* dijit.__Rectangle */	aroundRect,
	/* Object */			aroundCorners,
	/* Function */			layoutNode){

	// summary:
	//		Like dijit.placeOnScreenAroundNode(), except that the "around"
	//		parameter is an arbitrary rectangle on the screen (x, y, width, height)
	//		instead of a dom node.

	return dijit._placeOnScreenAroundRect(node,
		aroundRect.x, aroundRect.y, aroundRect.width, aroundRect.height,	// rectangle
		aroundCorners, layoutNode);
};

dijit._placeOnScreenAroundRect = function(
	/* DomNode */		node,
	/* Number */		x,
	/* Number */		y,
	/* Number */		width,
	/* Number */		height,
	/* Object */		aroundCorners,
	/* Function */		layoutNode){

	// summary:
	//		Like dijit.placeOnScreenAroundNode(), except it accepts coordinates
	//		of a rectangle to place node adjacent to.

	// TODO: combine with placeOnScreenAroundRectangle()

	// Generate list of possible positions for node
	var choices = [];
	for(var nodeCorner in aroundCorners){
		choices.push( {
			aroundCorner: nodeCorner,
			corner: aroundCorners[nodeCorner],
			pos: {
				x: x + (nodeCorner.charAt(1) == 'L' ? 0 : width),
				y: y + (nodeCorner.charAt(0) == 'T' ? 0 : height)
			}
		});
	}

	return dijit._place(node, choices, layoutNode, {w: width, h: height});
};

dijit.placementRegistry= new dojo.AdapterRegistry();
dijit.placementRegistry.register("node",
	function(n, x){
		return typeof x == "object" &&
			typeof x.offsetWidth != "undefined" && typeof x.offsetHeight != "undefined";
	},
	dijit.placeOnScreenAroundNode);
dijit.placementRegistry.register("rect",
	function(n, x){
		return typeof x == "object" &&
			"x" in x && "y" in x && "width" in x && "height" in x;
	},
	dijit.placeOnScreenAroundRectangle);

dijit.placeOnScreenAroundElement = function(
	/* DomNode */		node,
	/* Object */		aroundElement,
	/* Object */		aroundCorners,
	/* Function */		layoutNode){

	// summary:
	//		Like dijit.placeOnScreenAroundNode(), except it accepts an arbitrary object
	//		for the "around" argument and finds a proper processor to place a node.

	return dijit.placementRegistry.match.apply(dijit.placementRegistry, arguments);
};

dijit.getPopupAroundAlignment = function(/*Array*/ position, /*Boolean*/ leftToRight){
	// summary:
	//		Transforms the passed array of preferred positions into a format suitable for passing as the aroundCorners argument to dijit.placeOnScreenAroundElement.
	//
	// position: String[]
	//		This variable controls the position of the drop down.
	//		It's an array of strings with the following values:
	//
	//			* before: places drop down to the left of the target node/widget, or to the right in
	//			  the case of RTL scripts like Hebrew and Arabic
	//			* after: places drop down to the right of the target node/widget, or to the left in
	//			  the case of RTL scripts like Hebrew and Arabic
	//			* above: drop down goes above target node
	//			* below: drop down goes below target node
	//
	//		The list is positions is tried, in order, until a position is found where the drop down fits
	//		within the viewport.
	//
	// leftToRight: Boolean
	//		Whether the popup will be displaying in leftToRight mode.
	//
	var align = {};
	dojo.forEach(position, function(pos){
		switch(pos){
			case "after":
				align[leftToRight ? "BR" : "BL"] = leftToRight ? "BL" : "BR";
				break;
			case "before":
				align[leftToRight ? "BL" : "BR"] = leftToRight ? "BR" : "BL";
				break;
			case "below-alt":
				leftToRight = !leftToRight;
				// fall through
			case "below":
				// first try to align left borders, next try to align right borders (or reverse for RTL mode)
				align[leftToRight ? "BL" : "BR"] = leftToRight ? "TL" : "TR";
				align[leftToRight ? "BR" : "BL"] = leftToRight ? "TR" : "TL";
				break;
			case "above-alt":
				leftToRight = !leftToRight;
				// fall through
			case "above":
			default:
				// first try to align left borders, next try to align right borders (or reverse for RTL mode)
				align[leftToRight ? "TL" : "TR"] = leftToRight ? "BL" : "BR";
				align[leftToRight ? "TR" : "TL"] = leftToRight ? "BR" : "BL";
				break;
		}
	});
	return align;
};

}

if(!dojo._hasResource["dijit._base.window"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.window"] = true;
dojo.provide("dijit._base.window");



dijit.getDocumentWindow = function(doc){
	return dojo.window.get(doc);
};

}

if(!dojo._hasResource["dijit._base.popup"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.popup"] = true;
dojo.provide("dijit._base.popup");





/*=====
dijit.popup.__OpenArgs = function(){
	// popup: Widget
	//		widget to display
	// parent: Widget
	//		the button etc. that is displaying this popup
	// around: DomNode
	//		DOM node (typically a button); place popup relative to this node.  (Specify this *or* "x" and "y" parameters.)
	// x: Integer
	//		Absolute horizontal position (in pixels) to place node at.  (Specify this *or* "around" parameter.)
	// y: Integer
	//		Absolute vertical position (in pixels) to place node at.  (Specify this *or* "around" parameter.)
	// orient: Object|String
	//		When the around parameter is specified, orient should be an
	//		ordered list of tuples of the form (around-node-corner, popup-node-corner).
	//		dijit.popup.open() tries to position the popup according to each tuple in the list, in order,
	//		until the popup appears fully within the viewport.
	//
	//		The default value is {BL:'TL', TL:'BL'}, which represents a list of two tuples:
	//			1. (BL, TL)
	//			2. (TL, BL)
	//		where BL means "bottom left" and "TL" means "top left".
	//		So by default, it first tries putting the popup below the around node, left-aligning them,
	//		and then tries to put it above the around node, still left-aligning them.   Note that the
	//		default is horizontally reversed when in RTL mode.
	//
	//		When an (x,y) position is specified rather than an around node, orient is either
	//		"R" or "L".  R (for right) means that it tries to put the popup to the right of the mouse,
	//		specifically positioning the popup's top-right corner at the mouse position, and if that doesn't
	//		fit in the viewport, then it tries, in order, the bottom-right corner, the top left corner,
	//		and the top-right corner.
	// onCancel: Function
	//		callback when user has canceled the popup by
	//			1. hitting ESC or
	//			2. by using the popup widget's proprietary cancel mechanism (like a cancel button in a dialog);
	//			   i.e. whenever popupWidget.onCancel() is called, args.onCancel is called
	// onClose: Function
	//		callback whenever this popup is closed
	// onExecute: Function
	//		callback when user "executed" on the popup/sub-popup by selecting a menu choice, etc. (top menu only)
	// padding: dijit.__Position
	//		adding a buffer around the opening position. This is only useful when around is not set.
	this.popup = popup;
	this.parent = parent;
	this.around = around;
	this.x = x;
	this.y = y;
	this.orient = orient;
	this.onCancel = onCancel;
	this.onClose = onClose;
	this.onExecute = onExecute;
	this.padding = padding;
}
=====*/

dijit.popup = {
	// summary:
	//		This singleton is used to show/hide widgets as popups.

	// _stack: dijit._Widget[]
	//		Stack of currently popped up widgets.
	//		(someone opened _stack[0], and then it opened _stack[1], etc.)
	_stack: [],
	
	// _beginZIndex: Number
	//		Z-index of the first popup.   (If first popup opens other
	//		popups they get a higher z-index.)
	_beginZIndex: 1000,

	_idGen: 1,

	_createWrapper: function(/*Widget || DomNode*/ widget){
		// summary:
		//		Initialization for widgets that will be used as popups.
		//		Puts widget inside a wrapper DIV (if not already in one),
		//		and returns pointer to that wrapper DIV.

		var node = widget.domNode || widget,
			wrapper = widget.declaredClass ? widget._popupWrapper :
				node.parentNode && dojo.hasClass(node.parentNode, "dijitPopup") ? node.parentNode : null;

		if(!wrapper){
			// Create wrapper <div> for when this widget [in the future] will be used as a popup.
			// This is done early because of IE bugs where creating/moving DOM nodes causes focus
			// to go wonky, see tests/robot/Toolbar.html to reproduce
			wrapper = dojo.create("div",{
				"class":"dijitPopup",
				style:{ display: "none"},
				role: "presentation"
			}, dojo.body());
			wrapper.appendChild(node);

			var s = node.style;
			s.display = "";
			s.visibility = "";
			s.position = "";
			s.top = "0px";

			if(widget.declaredClass){		// TODO: in 2.0 change signature to always take widget, then remove if()
				widget._popupWrapper = wrapper;
				dojo.connect(widget, "destroy", function(){
					dojo.destroy(wrapper);
					delete widget._popupWrapper;
				});
			}
		}
		
		return wrapper;	// DOMNode
	},

	moveOffScreen: function(/*Widget || DomNode*/ widget){
		// summary:
		//		Moves the popup widget off-screen.
		//		Do not use this method to hide popups when not in use, because
		//		that will create an accessibility issue: the offscreen popup is
		//		still in the tabbing order.

		// Create wrapper if not already there
		var wrapper = this._createWrapper(widget);

		dojo.style(wrapper, {
			visibility: "hidden",
			top: "-9999px",		// prevent transient scrollbar causing misalign (#5776), and initial flash in upper left (#10111)
			display: ""
		});
	},

	hide: function(/*dijit._Widget*/ widget){
		// summary:
		//		Hide this popup widget (until it is ready to be shown).
		//		Initialization for widgets that will be used as popups
		//
		// 		Also puts widget inside a wrapper DIV (if not already in one)
		//
		//		If popup widget needs to layout it should
		//		do so when it is made visible, and popup._onShow() is called.

		// Create wrapper if not already there
		var wrapper = this._createWrapper(widget);

		dojo.style(wrapper, "display", "none");
	},
		
	getTopPopup: function(){
		// summary:
		//		Compute the closest ancestor popup that's *not* a child of another popup.
		//		Ex: For a TooltipDialog with a button that spawns a tree of menus, find the popup of the button.
		var stack = this._stack;
		for(var pi=stack.length-1; pi > 0 && stack[pi].parent === stack[pi-1].widget; pi--){
			/* do nothing, just trying to get right value for pi */
		}
		return stack[pi];
	},

	open: function(/*dijit.popup.__OpenArgs*/ args){
		// summary:
		//		Popup the widget at the specified position
		//
		// example:
		//		opening at the mouse position
		//		|		dijit.popup.open({popup: menuWidget, x: evt.pageX, y: evt.pageY});
		//
		// example:
		//		opening the widget as a dropdown
		//		|		dijit.popup.open({parent: this, popup: menuWidget, around: this.domNode, onClose: function(){...}});
		//
		//		Note that whatever widget called dijit.popup.open() should also listen to its own _onBlur callback
		//		(fired from _base/focus.js) to know that focus has moved somewhere else and thus the popup should be closed.

		var stack = this._stack,
			widget = args.popup,
			orient = args.orient || (
				(args.parent ? args.parent.isLeftToRight() : dojo._isBodyLtr()) ?
				{'BL':'TL', 'BR':'TR', 'TL':'BL', 'TR':'BR'} :
				{'BR':'TR', 'BL':'TL', 'TR':'BR', 'TL':'BL'}
			),
			around = args.around,
			id = (args.around && args.around.id) ? (args.around.id+"_dropdown") : ("popup_"+this._idGen++);

		// If we are opening a new popup that isn't a child of a currently opened popup, then
		// close currently opened popup(s).   This should happen automatically when the old popups
		// gets the _onBlur() event, except that the _onBlur() event isn't reliable on IE, see [22198].
		while(stack.length && (!args.parent || !dojo.isDescendant(args.parent.domNode, stack[stack.length-1].widget.domNode))){
			dijit.popup.close(stack[stack.length-1].widget);
		}

		// Get pointer to popup wrapper, and create wrapper if it doesn't exist
		var wrapper = this._createWrapper(widget);


		dojo.attr(wrapper, {
			id: id,
			style: {
				zIndex: this._beginZIndex + stack.length
			},
			"class": "dijitPopup " + (widget.baseClass || widget["class"] || "").split(" ")[0] +"Popup",
			dijitPopupParent: args.parent ? args.parent.id : ""
		});

		if(dojo.isIE || dojo.isMoz){
			if(!widget.bgIframe){
				// setting widget.bgIframe triggers cleanup in _Widget.destroy()
				widget.bgIframe = new dijit.BackgroundIframe(wrapper);
			}
		}

		// position the wrapper node and make it visible
		var best = around ?
			dijit.placeOnScreenAroundElement(wrapper, around, orient, widget.orient ? dojo.hitch(widget, "orient") : null) :
			dijit.placeOnScreen(wrapper, args, orient == 'R' ? ['TR','BR','TL','BL'] : ['TL','BL','TR','BR'], args.padding);

		wrapper.style.display = "";
		wrapper.style.visibility = "visible";
		widget.domNode.style.visibility = "visible";	// counteract effects from _HasDropDown

		var handlers = [];

		// provide default escape and tab key handling
		// (this will work for any widget, not just menu)
		handlers.push(dojo.connect(wrapper, "onkeypress", this, function(evt){
			if(evt.charOrCode == dojo.keys.ESCAPE && args.onCancel){
				dojo.stopEvent(evt);
				args.onCancel();
			}else if(evt.charOrCode === dojo.keys.TAB){
				dojo.stopEvent(evt);
				var topPopup = this.getTopPopup();
				if(topPopup && topPopup.onCancel){
					topPopup.onCancel();
				}
			}
		}));

		// watch for cancel/execute events on the popup and notify the caller
		// (for a menu, "execute" means clicking an item)
		if(widget.onCancel){
			handlers.push(dojo.connect(widget, "onCancel", args.onCancel));
		}

		handlers.push(dojo.connect(widget, widget.onExecute ? "onExecute" : "onChange", this, function(){
			var topPopup = this.getTopPopup();
			if(topPopup && topPopup.onExecute){
				topPopup.onExecute();
			}
		}));

		stack.push({
			widget: widget,
			parent: args.parent,
			onExecute: args.onExecute,
			onCancel: args.onCancel,
 			onClose: args.onClose,
			handlers: handlers
		});

		if(widget.onOpen){
			// TODO: in 2.0 standardize onShow() (used by StackContainer) and onOpen() (used here)
			widget.onOpen(best);
		}

		return best;
	},

	close: function(/*dijit._Widget?*/ popup){
		// summary:
		//		Close specified popup and any popups that it parented.
		//		If no popup is specified, closes all popups.

		var stack = this._stack;

		// Basically work backwards from the top of the stack closing popups
		// until we hit the specified popup, but IIRC there was some issue where closing
		// a popup would cause others to close too.  Thus if we are trying to close B in [A,B,C]
		// closing C might close B indirectly and then the while() condition will run where stack==[A]...
		// so the while condition is constructed defensively.
		while((popup && dojo.some(stack, function(elem){return elem.widget == popup;})) ||
			(!popup && stack.length)){
			var top = stack.pop(),
				widget = top.widget,
				onClose = top.onClose;

			if(widget.onClose){
				// TODO: in 2.0 standardize onHide() (used by StackContainer) and onClose() (used here)
				widget.onClose();
			}
			dojo.forEach(top.handlers, dojo.disconnect);

			// Hide the widget and it's wrapper unless it has already been destroyed in above onClose() etc.
			if(widget && widget.domNode){
				this.hide(widget);
			}
                        
			if(onClose){
				onClose();
			}
		}
	}
};

// TODO: remove dijit._frames, it isn't being used much, since popups never release their
// iframes (see [22236])
dijit._frames = new function(){
	// summary:
	//		cache of iframes

	var queue = [];

	this.pop = function(){
		var iframe;
		if(queue.length){
			iframe = queue.pop();
			iframe.style.display="";
		}else{
			if(dojo.isIE < 9){
				var burl = dojo.config["dojoBlankHtmlUrl"] || (dojo.moduleUrl("dojo", "resources/blank.html")+"") || "javascript:\"\"";
				var html="<iframe src='" + burl + "'"
					+ " style='position: absolute; left: 0px; top: 0px;"
					+ "z-index: -1; filter:Alpha(Opacity=\"0\");'>";
				iframe = dojo.doc.createElement(html);
			}else{
			 	iframe = dojo.create("iframe");
				iframe.src = 'javascript:""';
				iframe.className = "dijitBackgroundIframe";
				dojo.style(iframe, "opacity", 0.1);
			}
			iframe.tabIndex = -1; // Magic to prevent iframe from getting focus on tab keypress - as style didn't work.
			dijit.setWaiRole(iframe,"presentation");
		}
		return iframe;
	};

	this.push = function(iframe){
		iframe.style.display="none";
		queue.push(iframe);
	}
}();


dijit.BackgroundIframe = function(/*DomNode*/ node){
	// summary:
	//		For IE/FF z-index schenanigans. id attribute is required.
	//
	// description:
	//		new dijit.BackgroundIframe(node)
	//			Makes a background iframe as a child of node, that fills
	//			area (and position) of node

	if(!node.id){ throw new Error("no id"); }
	if(dojo.isIE || dojo.isMoz){
		var iframe = (this.iframe = dijit._frames.pop());
		node.appendChild(iframe);
		if(dojo.isIE<7 || dojo.isQuirks){
			this.resize(node);
			this._conn = dojo.connect(node, 'onresize', this, function(){
				this.resize(node);
			});
		}else{
			dojo.style(iframe, {
				width: '100%',
				height: '100%'
			});
		}
	}
};

dojo.extend(dijit.BackgroundIframe, {
	resize: function(node){
		// summary:
		// 		Resize the iframe so it's the same size as node.
		//		Needed on IE6 and IE/quirks because height:100% doesn't work right.
		if(this.iframe){
			dojo.style(this.iframe, {
				width: node.offsetWidth + 'px',
				height: node.offsetHeight + 'px'
			});
		}
	},
	destroy: function(){
		// summary:
		//		destroy the iframe
		if(this._conn){
			dojo.disconnect(this._conn);
			this._conn = null;
		}
		if(this.iframe){
			dijit._frames.push(this.iframe);
			delete this.iframe;
		}
	}
});

}

if(!dojo._hasResource["dijit._base.scroll"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.scroll"] = true;
dojo.provide("dijit._base.scroll");



dijit.scrollIntoView = function(/*DomNode*/ node, /*Object?*/ pos){
	// summary:
	//		Scroll the passed node into view, if it is not already.
	//		Deprecated, use `dojo.window.scrollIntoView` instead.
	
	dojo.window.scrollIntoView(node, pos);
};

}

if(!dojo._hasResource["dojo.uacss"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.uacss"] = true;
dojo.provide("dojo.uacss");


(function(){
	// summary:
	//		Applies pre-set CSS classes to the top-level HTML node, based on:
	// 			- browser (ex: dj_ie)
	//			- browser version (ex: dj_ie6)
	//			- box model (ex: dj_contentBox)
	//			- text direction (ex: dijitRtl)
	//
	//		In addition, browser, browser version, and box model are
	//		combined with an RTL flag when browser text is RTL.  ex: dj_ie-rtl.

	var d = dojo,
		html = d.doc.documentElement,
		ie = d.isIE,
		opera = d.isOpera,
		maj = Math.floor,
		ff = d.isFF,
		boxModel = d.boxModel.replace(/-/,''),

		classes = {
			dj_quirks: d.isQuirks,

			// NOTE: Opera not supported by dijit
			dj_opera: opera,

			dj_khtml: d.isKhtml,

			dj_webkit: d.isWebKit,
			dj_safari: d.isSafari,
			dj_chrome: d.isChrome,

			dj_gecko: d.isMozilla
		}; // no dojo unsupported browsers

	if(ie){
		classes["dj_ie"] = true;
		classes["dj_ie" + maj(ie)] = true;
		classes["dj_iequirks"] = d.isQuirks;
	}
	if(ff){
		classes["dj_ff" + maj(ff)] = true;
	}

	classes["dj_" + boxModel] = true;

	// apply browser, browser version, and box model class names
	var classStr = "";
	for(var clz in classes){
		if(classes[clz]){
			classStr += clz + " ";
		}
	}
	html.className = d.trim(html.className + " " + classStr);

	// If RTL mode, then add dj_rtl flag plus repeat existing classes with -rtl extension.
	// We can't run the code below until the <body> tag has loaded (so we can check for dir=rtl).
	// Unshift() is to run sniff code before the parser.
	dojo._loaders.unshift(function(){
		if(!dojo._isBodyLtr()){
			var rtlClassStr = "dj_rtl dijitRtl " + classStr.replace(/ /g, "-rtl ")
			html.className = d.trim(html.className + " " + rtlClassStr);
		}
	});
})();

}

if(!dojo._hasResource["dijit._base.sniff"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.sniff"] = true;
dojo.provide("dijit._base.sniff");



// summary:
//		Applies pre-set CSS classes to the top-level HTML node, see
//		`dojo.uacss` for details.
//
//		Simply doing a require on this module will
//		establish this CSS.  Modified version of Morris' CSS hack.

}

if(!dojo._hasResource["dijit._base.typematic"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.typematic"] = true;
dojo.provide("dijit._base.typematic");


dijit.typematic = {
	// summary:
	//		These functions are used to repetitively call a user specified callback
	//		method when a specific key or mouse click over a specific DOM node is
	//		held down for a specific amount of time.
	//		Only 1 such event is allowed to occur on the browser page at 1 time.

	_fireEventAndReload: function(){
		this._timer = null;
		this._callback(++this._count, this._node, this._evt);
		
		// Schedule next event, timer is at most minDelay (default 10ms) to avoid
		// browser overload (particularly avoiding starving DOH robot so it never gets to send a mouseup)
		this._currentTimeout = Math.max(
			this._currentTimeout < 0 ? this._initialDelay :
				(this._subsequentDelay > 1 ? this._subsequentDelay : Math.round(this._currentTimeout * this._subsequentDelay)),
			this._minDelay);
		this._timer = setTimeout(dojo.hitch(this, "_fireEventAndReload"), this._currentTimeout);
	},

	trigger: function(/*Event*/ evt, /*Object*/ _this, /*DOMNode*/ node, /*Function*/ callback, /*Object*/ obj, /*Number*/ subsequentDelay, /*Number*/ initialDelay, /*Number?*/ minDelay){
		// summary:
		//		Start a timed, repeating callback sequence.
		//		If already started, the function call is ignored.
		//		This method is not normally called by the user but can be
		//		when the normal listener code is insufficient.
		// evt:
		//		key or mouse event object to pass to the user callback
		// _this:
		//		pointer to the user's widget space.
		// node:
		//		the DOM node object to pass the the callback function
		// callback:
		//		function to call until the sequence is stopped called with 3 parameters:
		// count:
		//		integer representing number of repeated calls (0..n) with -1 indicating the iteration has stopped
		// node:
		//		the DOM node object passed in
		// evt:
		//		key or mouse event object
		// obj:
		//		user space object used to uniquely identify each typematic sequence
		// subsequentDelay (optional):
		//		if > 1, the number of milliseconds until the 3->n events occur
		//		or else the fractional time multiplier for the next event's delay, default=0.9
		// initialDelay (optional):
		//		the number of milliseconds until the 2nd event occurs, default=500ms
		// minDelay (optional):
		//		the maximum delay in milliseconds for event to fire, default=10ms
		if(obj != this._obj){
			this.stop();
			this._initialDelay = initialDelay || 500;
			this._subsequentDelay = subsequentDelay || 0.90;
			this._minDelay = minDelay || 10;
			this._obj = obj;
			this._evt = evt;
			this._node = node;
			this._currentTimeout = -1;
			this._count = -1;
			this._callback = dojo.hitch(_this, callback);
			this._fireEventAndReload();
			this._evt = dojo.mixin({faux: true}, evt);
		}
	},

	stop: function(){
		// summary:
		//		Stop an ongoing timed, repeating callback sequence.
		if(this._timer){
			clearTimeout(this._timer);
			this._timer = null;
		}
		if(this._obj){
			this._callback(-1, this._node, this._evt);
			this._obj = null;
		}
	},

	addKeyListener: function(/*DOMNode*/ node, /*Object*/ keyObject, /*Object*/ _this, /*Function*/ callback, /*Number*/ subsequentDelay, /*Number*/ initialDelay, /*Number?*/ minDelay){
		// summary:
		//		Start listening for a specific typematic key.
		//		See also the trigger method for other parameters.
		// keyObject:
		//		an object defining the key to listen for:
		// 		charOrCode:
		//			the printable character (string) or keyCode (number) to listen for.
		// 		keyCode:
		//			(deprecated - use charOrCode) the keyCode (number) to listen for (implies charCode = 0).
		// 		charCode:
		//			(deprecated - use charOrCode) the charCode (number) to listen for.
		// 		ctrlKey:
		//			desired ctrl key state to initiate the callback sequence:
		//			- pressed (true)
		//			- released (false)
		//			- either (unspecified)
		// 		altKey:
		//			same as ctrlKey but for the alt key
		// 		shiftKey:
		//			same as ctrlKey but for the shift key
		// returns:
		//		an array of dojo.connect handles
		if(keyObject.keyCode){
			keyObject.charOrCode = keyObject.keyCode;
			dojo.deprecated("keyCode attribute parameter for dijit.typematic.addKeyListener is deprecated. Use charOrCode instead.", "", "2.0");
		}else if(keyObject.charCode){
			keyObject.charOrCode = String.fromCharCode(keyObject.charCode);
			dojo.deprecated("charCode attribute parameter for dijit.typematic.addKeyListener is deprecated. Use charOrCode instead.", "", "2.0");
		}
		return [
			dojo.connect(node, "onkeypress", this, function(evt){
				if(evt.charOrCode == keyObject.charOrCode &&
				(keyObject.ctrlKey === undefined || keyObject.ctrlKey == evt.ctrlKey) &&
				(keyObject.altKey === undefined || keyObject.altKey == evt.altKey) &&
				(keyObject.metaKey === undefined || keyObject.metaKey == (evt.metaKey || false)) && // IE doesn't even set metaKey
				(keyObject.shiftKey === undefined || keyObject.shiftKey == evt.shiftKey)){
					dojo.stopEvent(evt);
					dijit.typematic.trigger(evt, _this, node, callback, keyObject, subsequentDelay, initialDelay, minDelay);
				}else if(dijit.typematic._obj == keyObject){
					dijit.typematic.stop();
				}
			}),
			dojo.connect(node, "onkeyup", this, function(evt){
				if(dijit.typematic._obj == keyObject){
					dijit.typematic.stop();
				}
			})
		];
	},

	addMouseListener: function(/*DOMNode*/ node, /*Object*/ _this, /*Function*/ callback, /*Number*/ subsequentDelay, /*Number*/ initialDelay, /*Number?*/ minDelay){
		// summary:
		//		Start listening for a typematic mouse click.
		//		See the trigger method for other parameters.
		// returns:
		//		an array of dojo.connect handles
		var dc = dojo.connect;
		return [
			dc(node, "mousedown", this, function(evt){
				dojo.stopEvent(evt);
				dijit.typematic.trigger(evt, _this, node, callback, node, subsequentDelay, initialDelay, minDelay);
			}),
			dc(node, "mouseup", this, function(evt){
				dojo.stopEvent(evt);
				dijit.typematic.stop();
			}),
			dc(node, "mouseout", this, function(evt){
				dojo.stopEvent(evt);
				dijit.typematic.stop();
			}),
			dc(node, "mousemove", this, function(evt){
				evt.preventDefault();
			}),
			dc(node, "dblclick", this, function(evt){
				dojo.stopEvent(evt);
				if(dojo.isIE < 9){
					dijit.typematic.trigger(evt, _this, node, callback, node, subsequentDelay, initialDelay, minDelay);
					setTimeout(dojo.hitch(this, dijit.typematic.stop), 50);
				}
			})
		];
	},

	addListener: function(/*Node*/ mouseNode, /*Node*/ keyNode, /*Object*/ keyObject, /*Object*/ _this, /*Function*/ callback, /*Number*/ subsequentDelay, /*Number*/ initialDelay, /*Number?*/ minDelay){
		// summary:
		//		Start listening for a specific typematic key and mouseclick.
		//		This is a thin wrapper to addKeyListener and addMouseListener.
		//		See the addMouseListener and addKeyListener methods for other parameters.
		// mouseNode:
		//		the DOM node object to listen on for mouse events.
		// keyNode:
		//		the DOM node object to listen on for key events.
		// returns:
		//		an array of dojo.connect handles
		return this.addKeyListener(keyNode, keyObject, _this, callback, subsequentDelay, initialDelay, minDelay).concat(
			this.addMouseListener(mouseNode, _this, callback, subsequentDelay, initialDelay, minDelay));
	}
};

}

if(!dojo._hasResource["dijit._base.wai"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.wai"] = true;
dojo.provide("dijit._base.wai");


dijit.wai = {
	onload: function(){
		// summary:
		//		Detects if we are in high-contrast mode or not

		// This must be a named function and not an anonymous
		// function, so that the widget parsing code can make sure it
		// registers its onload function after this function.
		// DO NOT USE "this" within this function.

		// create div for testing if high contrast mode is on or images are turned off
		var div = dojo.create("div",{
			id: "a11yTestNode",
			style:{
				cssText:'border: 1px solid;'
					+ 'border-color:red green;'
					+ 'position: absolute;'
					+ 'height: 5px;'
					+ 'top: -999px;'
					+ 'background-image: url("' + (dojo.config.blankGif || dojo.moduleUrl("dojo", "resources/blank.gif")) + '");'
			}
		}, dojo.body());

		// test it
		var cs = dojo.getComputedStyle(div);
		if(cs){
			var bkImg = cs.backgroundImage;
			var needsA11y = (cs.borderTopColor == cs.borderRightColor) || (bkImg != null && (bkImg == "none" || bkImg == "url(invalid-url:)" ));
			dojo[needsA11y ? "addClass" : "removeClass"](dojo.body(), "dijit_a11y");
			if(dojo.isIE){
				div.outerHTML = "";		// prevent mixed-content warning, see http://support.microsoft.com/kb/925014
			}else{
				dojo.body().removeChild(div);
			}
		}
	}
};

// Test if computer is in high contrast mode.
// Make sure the a11y test runs first, before widgets are instantiated.
if(dojo.isIE || dojo.isMoz){	// NOTE: checking in Safari messes things up
	dojo._loaders.unshift(dijit.wai.onload);
}

dojo.mixin(dijit, {
	hasWaiRole: function(/*Element*/ elem, /*String?*/ role){
		// summary:
		//		Determines if an element has a particular role.
		// returns:
		//		True if elem has the specific role attribute and false if not.
		// 		For backwards compatibility if role parameter not provided,
		// 		returns true if has a role
		var waiRole = this.getWaiRole(elem);
		return role ? (waiRole.indexOf(role) > -1) : (waiRole.length > 0);
	},

	getWaiRole: function(/*Element*/ elem){
		// summary:
		//		Gets the role for an element (which should be a wai role).
		// returns:
		//		The role of elem or an empty string if elem
		//		does not have a role.
		 return dojo.trim((dojo.attr(elem, "role") || "").replace("wairole:",""));
	},

	setWaiRole: function(/*Element*/ elem, /*String*/ role){
		// summary:
		//		Sets the role on an element.
		// description:
		//		Replace existing role attribute with new role.

			dojo.attr(elem, "role", role);
	},

	removeWaiRole: function(/*Element*/ elem, /*String*/ role){
		// summary:
		//		Removes the specified role from an element.
		// 		Removes role attribute if no specific role provided (for backwards compat.)

		var roleValue = dojo.attr(elem, "role");
		if(!roleValue){ return; }
		if(role){
			var t = dojo.trim((" " + roleValue + " ").replace(" " + role + " ", " "));
			dojo.attr(elem, "role", t);
		}else{
			elem.removeAttribute("role");
		}
	},

	hasWaiState: function(/*Element*/ elem, /*String*/ state){
		// summary:
		//		Determines if an element has a given state.
		// description:
		//		Checks for an attribute called "aria-"+state.
		// returns:
		//		true if elem has a value for the given state and
		//		false if it does not.

		return elem.hasAttribute ? elem.hasAttribute("aria-"+state) : !!elem.getAttribute("aria-"+state);
	},

	getWaiState: function(/*Element*/ elem, /*String*/ state){
		// summary:
		//		Gets the value of a state on an element.
		// description:
		//		Checks for an attribute called "aria-"+state.
		// returns:
		//		The value of the requested state on elem
		//		or an empty string if elem has no value for state.

		return elem.getAttribute("aria-"+state) || "";
	},

	setWaiState: function(/*Element*/ elem, /*String*/ state, /*String*/ value){
		// summary:
		//		Sets a state on an element.
		// description:
		//		Sets an attribute called "aria-"+state.

		elem.setAttribute("aria-"+state, value);
	},

	removeWaiState: function(/*Element*/ elem, /*String*/ state){
		// summary:
		//		Removes a state from an element.
		// description:
		//		Sets an attribute called "aria-"+state.

		elem.removeAttribute("aria-"+state);
	}
});

}

if(!dojo._hasResource["dijit._base"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base"] = true;
dojo.provide("dijit._base");












}

if(!dojo._hasResource["dijit._Widget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Widget"] = true;
dojo.provide("dijit._Widget");





////////////////// DEFERRED CONNECTS ///////////////////

// This code is to assist deferring dojo.connect() calls in widgets (connecting to events on the widgets'
// DOM nodes) until someone actually needs to monitor that event.
dojo.connect(dojo, "_connect",
	function(/*dijit._Widget*/ widget, /*String*/ event){
		if(widget && dojo.isFunction(widget._onConnect)){
			widget._onConnect(event);
		}
	});

dijit._connectOnUseEventHandler = function(/*Event*/ event){};

////////////////// ONDIJITCLICK SUPPORT ///////////////////

// Keep track of where the last keydown event was, to help avoid generating
// spurious ondijitclick events when:
// 1. focus is on a <button> or <a>
// 2. user presses then releases the ENTER key
// 3. onclick handler fires and shifts focus to another node, with an ondijitclick handler
// 4. onkeyup event fires, causing the ondijitclick handler to fire
dijit._lastKeyDownNode = null;
if(dojo.isIE){
	(function(){
		var keydownCallback = function(evt){
			dijit._lastKeyDownNode = evt.srcElement;
		};
		dojo.doc.attachEvent('onkeydown', keydownCallback);
		dojo.addOnWindowUnload(function(){
			dojo.doc.detachEvent('onkeydown', keydownCallback);
		});
	})();
}else{
	dojo.doc.addEventListener('keydown', function(evt){
		dijit._lastKeyDownNode = evt.target;
	}, true);
}

(function(){

dojo.declare("dijit._Widget", dijit._WidgetBase, {
	// summary:
	//		Base class for all Dijit widgets.
	//
	//		Extends _WidgetBase, adding support for:
	//			- deferred connections
	//				A call like dojo.connect(myWidget, "onMouseMove", func)
	//				will essentially do a dojo.connect(myWidget.domNode, "onMouseMove", func)
	//			- ondijitclick
	//				Support new dojoAttachEvent="ondijitclick: ..." that is triggered by a mouse click or a SPACE/ENTER keypress
	//			- focus related functions
	//				In particular, the onFocus()/onBlur() callbacks.   Driven internally by
	//				dijit/_base/focus.js.
	//			- deprecated methods
	//			- onShow(), onHide(), onClose()
	//
	//		Also, by loading code in dijit/_base, turns on:
	//			- browser sniffing (putting browser id like .dj_ie on <html> node)
	//			- high contrast mode sniffing (add .dijit_a11y class to <body> if machine is in high contrast mode)
	

	////////////////// DEFERRED CONNECTS ///////////////////

	// _deferredConnects: [protected] Object
	//		attributeMap addendum for event handlers that should be connected only on first use
	_deferredConnects: {
		onClick: "",
		onDblClick: "",
		onKeyDown: "",
		onKeyPress: "",
		onKeyUp: "",
		onMouseMove: "",
		onMouseDown: "",
		onMouseOut: "",
		onMouseOver: "",
		onMouseLeave: "",
		onMouseEnter: "",
		onMouseUp: ""
	},

	onClick: dijit._connectOnUseEventHandler,
	/*=====
	onClick: function(event){
		// summary:
		//		Connect to this function to receive notifications of mouse click events.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onDblClick: dijit._connectOnUseEventHandler,
	/*=====
	onDblClick: function(event){
		// summary:
		//		Connect to this function to receive notifications of mouse double click events.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onKeyDown: dijit._connectOnUseEventHandler,
	/*=====
	onKeyDown: function(event){
		// summary:
		//		Connect to this function to receive notifications of keys being pressed down.
		// event:
		//		key Event
		// tags:
		//		callback
	},
	=====*/
	onKeyPress: dijit._connectOnUseEventHandler,
	/*=====
	onKeyPress: function(event){
		// summary:
		//		Connect to this function to receive notifications of printable keys being typed.
		// event:
		//		key Event
		// tags:
		//		callback
	},
	=====*/
	onKeyUp: dijit._connectOnUseEventHandler,
	/*=====
	onKeyUp: function(event){
		// summary:
		//		Connect to this function to receive notifications of keys being released.
		// event:
		//		key Event
		// tags:
		//		callback
	},
	=====*/
	onMouseDown: dijit._connectOnUseEventHandler,
	/*=====
	onMouseDown: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse button is pressed down.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseMove: dijit._connectOnUseEventHandler,
	/*=====
	onMouseMove: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves over nodes contained within this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseOut: dijit._connectOnUseEventHandler,
	/*=====
	onMouseOut: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves off of nodes contained within this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseOver: dijit._connectOnUseEventHandler,
	/*=====
	onMouseOver: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves onto nodes contained within this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseLeave: dijit._connectOnUseEventHandler,
	/*=====
	onMouseLeave: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves off of this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseEnter: dijit._connectOnUseEventHandler,
	/*=====
	onMouseEnter: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves onto this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseUp: dijit._connectOnUseEventHandler,
	/*=====
	onMouseUp: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse button is released.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/

	create: function(/*Object?*/params, /*DomNode|String?*/srcNodeRef){
		// To avoid double-connects, remove entries from _deferredConnects
		// that have been setup manually by a subclass (ex, by dojoAttachEvent).
		// If a subclass has redefined a callback (ex: onClick) then assume it's being
		// connected to manually.
		this._deferredConnects = dojo.clone(this._deferredConnects);
		for(var attr in this.attributeMap){
			delete this._deferredConnects[attr]; // can't be in both attributeMap and _deferredConnects
		}
		for(attr in this._deferredConnects){
			if(this[attr] !== dijit._connectOnUseEventHandler){
				delete this._deferredConnects[attr];	// redefined, probably dojoAttachEvent exists
			}
		}

		this.inherited(arguments);

		if(this.domNode){
			// If the developer has specified a handler as a widget parameter
			// (ex: new Button({onClick: ...})
			// then naturally need to connect from DOM node to that handler immediately,
			for(attr in this.params){
				this._onConnect(attr);
			}
		}
	},

	_onConnect: function(/*String*/ event){
		// summary:
		//		Called when someone connects to one of my handlers.
		//		"Turn on" that handler if it isn't active yet.
		//
		//		This is also called for every single initialization parameter
		//		so need to do nothing for parameters like "id".
		// tags:
		//		private
		if(event in this._deferredConnects){
			var mapNode = this[this._deferredConnects[event] || 'domNode'];
			this.connect(mapNode, event.toLowerCase(), event);
			delete this._deferredConnects[event];
		}
	},

	////////////////// FOCUS RELATED ///////////////////
	// _onFocus() and _onBlur() are called by the focus manager

	// focused: [readonly] Boolean
	//		This widget or a widget it contains has focus, or is "active" because
	//		it was recently clicked.
	focused: false,

	isFocusable: function(){
		// summary:
		//		Return true if this widget can currently be focused
		//		and false if not
		return this.focus && (dojo.style(this.domNode, "display") != "none");
	},

	onFocus: function(){
		// summary:
		//		Called when the widget becomes "active" because
		//		it or a widget inside of it either has focus, or has recently
		//		been clicked.
		// tags:
		//		callback
	},

	onBlur: function(){
		// summary:
		//		Called when the widget stops being "active" because
		//		focus moved to something outside of it, or the user
		//		clicked somewhere outside of it, or the widget was
		//		hidden.
		// tags:
		//		callback
	},

	_onFocus: function(e){
		// summary:
		//		This is where widgets do processing for when they are active,
		//		such as changing CSS classes.  See onFocus() for more details.
		// tags:
		//		protected
		this.onFocus();
	},

	_onBlur: function(){
		// summary:
		//		This is where widgets do processing for when they stop being active,
		//		such as changing CSS classes.  See onBlur() for more details.
		// tags:
		//		protected
		this.onBlur();
	},

	////////////////// DEPRECATED METHODS ///////////////////

	setAttribute: function(/*String*/ attr, /*anything*/ value){
		// summary:
		//		Deprecated.  Use set() instead.
		// tags:
		//		deprecated
		dojo.deprecated(this.declaredClass+"::setAttribute(attr, value) is deprecated. Use set() instead.", "", "2.0");
		this.set(attr, value);
	},

	attr: function(/*String|Object*/name, /*Object?*/value){
		// summary:
		//		Set or get properties on a widget instance.
		//	name:
		//		The property to get or set. If an object is passed here and not
		//		a string, its keys are used as names of attributes to be set
		//		and the value of the object as values to set in the widget.
		//	value:
		//		Optional. If provided, attr() operates as a setter. If omitted,
		//		the current value of the named property is returned.
		// description:
		//		This method is deprecated, use get() or set() directly.

		// Print deprecation warning but only once per calling function
		if(dojo.config.isDebug){
			var alreadyCalledHash = arguments.callee._ach || (arguments.callee._ach = {}),
				caller = (arguments.callee.caller || "unknown caller").toString();
			if(!alreadyCalledHash[caller]){
				dojo.deprecated(this.declaredClass + "::attr() is deprecated. Use get() or set() instead, called from " +
				caller, "", "2.0");
				alreadyCalledHash[caller] = true;
			}
		}

		var args = arguments.length;
		if(args >= 2 || typeof name === "object"){ // setter
			return this.set.apply(this, arguments);
		}else{ // getter
			return this.get(name);
		}
	},
	
	////////////////// ONDIJITCLICK SUPPORT ///////////////////

	// nodesWithKeyClick: [private] String[]
	//		List of nodes that correctly handle click events via native browser support,
	//		and don't need dijit's help
	nodesWithKeyClick: ["input", "button"],

	connect: function(
			/*Object|null*/ obj,
			/*String|Function*/ event,
			/*String|Function*/ method){
		// summary:
		//		Connects specified obj/event to specified method of this object
		//		and registers for disconnect() on widget destroy.
		// description:
		//		Provide widget-specific analog to dojo.connect, except with the
		//		implicit use of this widget as the target object.
		//		This version of connect also provides a special "ondijitclick"
		//		event which triggers on a click or space or enter keyup.
		//		Events connected with `this.connect` are disconnected upon
		//		destruction.
		// returns:
		//		A handle that can be passed to `disconnect` in order to disconnect before
		//		the widget is destroyed.
		// example:
		//	|	var btn = new dijit.form.Button();
		//	|	// when foo.bar() is called, call the listener we're going to
		//	|	// provide in the scope of btn
		//	|	btn.connect(foo, "bar", function(){
		//	|		console.debug(this.toString());
		//	|	});
		// tags:
		//		protected

		var d = dojo,
			dc = d._connect,
			handles = this.inherited(arguments, [obj, event == "ondijitclick" ? "onclick" : event, method]);

		if(event == "ondijitclick"){
			// add key based click activation for unsupported nodes.
			// do all processing onkey up to prevent spurious clicks
			// for details see comments at top of this file where _lastKeyDownNode is defined
			if(d.indexOf(this.nodesWithKeyClick, obj.nodeName.toLowerCase()) == -1){ // is NOT input or button
				var m = d.hitch(this, method);
				handles.push(
					dc(obj, "onkeydown", this, function(e){
						//console.log(this.id + ": onkeydown, e.target = ", e.target, ", lastKeyDownNode was ", dijit._lastKeyDownNode, ", equality is ", (e.target === dijit._lastKeyDownNode));
						if((e.keyCode == d.keys.ENTER || e.keyCode == d.keys.SPACE) &&
							!e.ctrlKey && !e.shiftKey && !e.altKey && !e.metaKey){
							// needed on IE for when focus changes between keydown and keyup - otherwise dropdown menus do not work
							dijit._lastKeyDownNode = e.target;
							
							// Stop event to prevent scrolling on space key in IE.
							// But don't do this for _HasDropDown because it surpresses the onkeypress
							// event needed to open the drop down when the user presses the SPACE key.
							if(!("openDropDown" in this && obj == this._buttonNode)){
								e.preventDefault();
							}
						}
			 		}),
					dc(obj, "onkeyup", this, function(e){
						//console.log(this.id + ": onkeyup, e.target = ", e.target, ", lastKeyDownNode was ", dijit._lastKeyDownNode, ", equality is ", (e.target === dijit._lastKeyDownNode));
						if( (e.keyCode == d.keys.ENTER || e.keyCode == d.keys.SPACE) &&
							e.target == dijit._lastKeyDownNode &&	// === breaks greasemonkey
							!e.ctrlKey && !e.shiftKey && !e.altKey && !e.metaKey){
								//need reset here or have problems in FF when focus returns to trigger element after closing popup/alert
								dijit._lastKeyDownNode = null;
								return m(e);
						}
					})
				);
			}
		}

		return handles;		// _Widget.Handle
	},

	////////////////// MISCELLANEOUS METHODS ///////////////////

	_onShow: function(){
		// summary:
		//		Internal method called when this widget is made visible.
		//		See `onShow` for details.
		this.onShow();
	},

	onShow: function(){
		// summary:
		//		Called when this widget becomes the selected pane in a
		//		`dijit.layout.TabContainer`, `dijit.layout.StackContainer`,
		//		`dijit.layout.AccordionContainer`, etc.
		//
		//		Also called to indicate display of a `dijit.Dialog`, `dijit.TooltipDialog`, or `dijit.TitlePane`.
		// tags:
		//		callback
	},

	onHide: function(){
		// summary:
			//		Called when another widget becomes the selected pane in a
			//		`dijit.layout.TabContainer`, `dijit.layout.StackContainer`,
			//		`dijit.layout.AccordionContainer`, etc.
			//
			//		Also called to indicate hide of a `dijit.Dialog`, `dijit.TooltipDialog`, or `dijit.TitlePane`.
			// tags:
			//		callback
	},

	onClose: function(){
		// summary:
		//		Called when this widget is being displayed as a popup (ex: a Calendar popped
		//		up from a DateTextBox), and it is hidden.
		//		This is called from the dijit.popup code, and should not be called directly.
		//
		//		Also used as a parameter for children of `dijit.layout.StackContainer` or subclasses.
		//		Callback if a user tries to close the child.   Child will be closed if this function returns true.
		// tags:
		//		extension

		return true;		// Boolean
	}
});

})();

}

if(!dojo._hasResource["dojo.parser"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.parser"] = true;
dojo.provide("dojo.parser");



new Date("X"); // workaround for #11279, new Date("") == NaN

dojo.parser = new function(){
	// summary:
	//		The Dom/Widget parsing package

	var d = dojo;

	function val2type(/*Object*/ value){
		// summary:
		//		Returns name of type of given value.

		if(d.isString(value)){ return "string"; }
		if(typeof value == "number"){ return "number"; }
		if(typeof value == "boolean"){ return "boolean"; }
		if(d.isFunction(value)){ return "function"; }
		if(d.isArray(value)){ return "array"; } // typeof [] == "object"
		if(value instanceof Date) { return "date"; } // assume timestamp
		if(value instanceof d._Url){ return "url"; }
		return "object";
	}

	function str2obj(/*String*/ value, /*String*/ type){
		// summary:
		//		Convert given string value to given type
		switch(type){
			case "string":
				return value;
			case "number":
				return value.length ? Number(value) : NaN;
			case "boolean":
				// for checked/disabled value might be "" or "checked".	 interpret as true.
				return typeof value == "boolean" ? value : !(value.toLowerCase()=="false");
			case "function":
				if(d.isFunction(value)){
					// IE gives us a function, even when we say something like onClick="foo"
					// (in which case it gives us an invalid function "function(){ foo }").
					//	Therefore, convert to string
					value=value.toString();
					value=d.trim(value.substring(value.indexOf('{')+1, value.length-1));
				}
				try{
					if(value === "" || value.search(/[^\w\.]+/i) != -1){
						// The user has specified some text for a function like "return x+5"
						return new Function(value);
					}else{
						// The user has specified the name of a function like "myOnClick"
						// or a single word function "return"
						return d.getObject(value, false) || new Function(value);
					}
				}catch(e){ return new Function(); }
			case "array":
				return value ? value.split(/\s*,\s*/) : [];
			case "date":
				switch(value){
					case "": return new Date("");	// the NaN of dates
					case "now": return new Date();	// current date
					default: return d.date.stamp.fromISOString(value);
				}
			case "url":
				return d.baseUrl + value;
			default:
				return d.fromJson(value);
		}
	}

	var dummyClass = {}, instanceClasses = {
		// map from fully qualified name (like "dijit.Button") to structure like
		// { cls: dijit.Button, params: {label: "string", disabled: "boolean"} }
	};

	// Widgets like BorderContainer add properties to _Widget via dojo.extend().
	// If BorderContainer is loaded after _Widget's parameter list has been cached,
	// we need to refresh that parameter list (for _Widget and all widgets that extend _Widget).
	// TODO: remove this in 2.0, when we stop caching parameters.
	d.connect(d, "extend", function(){
		instanceClasses = {};
	});

	function getProtoInfo(cls, params){
		// cls: A prototype
		//		The prototype of the class to check props on
		// params: Object
		//		The parameters object to mix found parameters onto.
		for(var name in cls){
			if(name.charAt(0)=="_"){ continue; }	// skip internal properties
			if(name in dummyClass){ continue; }		// skip "constructor" and "toString"
			params[name] = val2type(cls[name]);
		}
		return params;
	}

	function getClassInfo(/*String*/ className, /*Boolean*/ skipParamsLookup){
		// summary:
		//		Maps a widget name string like "dijit.form.Button" to the widget constructor itself,
		//		and a list of that widget's parameters and their types
		// className:
		//		fully qualified name (like "dijit.form.Button")
		// returns:
		//		structure like
		//			{
		//				cls: dijit.Button,
		//				params: { label: "string", disabled: "boolean"}
		//			}

		var c = instanceClasses[className];
		if(!c){
			// get pointer to widget class
			var cls = d.getObject(className), params = null;
			if(!cls){ return null; }		// class not defined [yet]
			if(!skipParamsLookup){ // from fastpath, we don't need to lookup the attrs on the proto because they are explicit
				params = getProtoInfo(cls.prototype, {})
			}
			c = { cls: cls, params: params };
			
		}else if(!skipParamsLookup && !c.params){
			// if we're calling getClassInfo and have a cls proto, but no params info, scan that cls for params now
			// and update the pointer in instanceClasses[className]. This happens when a widget appears in another
			// widget's template which still uses dojoType, but an instance of the widget appears prior with a data-dojo-type,
			// skipping this lookup the first time.
			c.params = getProtoInfo(c.cls.prototype, {});
		}
		
		return c;
	}

	this._functionFromScript = function(script, attrData){
		// summary:
		//		Convert a <script type="dojo/method" args="a, b, c"> ... </script>
		//		into a function
		// script: DOMNode
		//		The <script> DOMNode
		// attrData: String
		//		For HTML5 compliance, searches for attrData + "args" (typically
		//		"data-dojo-args") instead of "args"
		var preamble = "";
		var suffix = "";
		var argsStr = (script.getAttribute(attrData + "args") || script.getAttribute("args"));
		if(argsStr){
			d.forEach(argsStr.split(/\s*,\s*/), function(part, idx){
				preamble += "var "+part+" = arguments["+idx+"]; ";
			});
		}
		var withStr = script.getAttribute("with");
		if(withStr && withStr.length){
			d.forEach(withStr.split(/\s*,\s*/), function(part){
				preamble += "with("+part+"){";
				suffix += "}";
			});
		}
		return new Function(preamble+script.innerHTML+suffix);
	};

	this.instantiate = function(/* Array */nodes, /* Object? */mixin, /* Object? */args){
		// summary:
		//		Takes array of nodes, and turns them into class instances and
		//		potentially calls a startup method to allow them to connect with
		//		any children.
		// nodes: Array
		//		Array of nodes or objects like
		//	|		{
		//	|			type: "dijit.form.Button",
		//	|			node: DOMNode,
		//	|			scripts: [ ... ],	// array of <script type="dojo/..."> children of node
		//	|			inherited: { ... }	// settings inherited from ancestors like dir, theme, etc.
		//	|		}
		// mixin: Object?
		//		An object that will be mixed in with each node in the array.
		//		Values in the mixin will override values in the node, if they
		//		exist.
		// args: Object?
		//		An object used to hold kwArgs for instantiation.
		//		See parse.args argument for details.

		var thelist = [],
		mixin = mixin||{};
		args = args||{};

		// TODO: for 2.0 default to data-dojo- regardless of scopeName (or maybe scopeName won't exist in 2.0)
		var attrName = (args.scope || d._scopeName) + "Type",	// typically "dojoType"
			attrData = "data-" + (args.scope || d._scopeName) + "-";	// typically "data-dojo-"

		d.forEach(nodes, function(obj){
			if(!obj){ return; }

			// Get pointers to DOMNode, dojoType string, and clsInfo (metadata about the dojoType), etc.
			var node, type, clsInfo, clazz, scripts, fastpath;
			if(obj.node){
				// new format of nodes[] array, object w/lots of properties pre-computed for me
				node = obj.node;
				type = obj.type;
				fastpath = obj.fastpath;
				clsInfo = obj.clsInfo || (type && getClassInfo(type, fastpath));
				clazz = clsInfo && clsInfo.cls;
				scripts = obj.scripts;
			}else{
				// old (backwards compatible) format of nodes[] array, simple array of DOMNodes. no fastpath/data-dojo-type support here.
				node = obj;
				type = attrName in mixin ? mixin[attrName] : node.getAttribute(attrName);
				clsInfo = type && getClassInfo(type);
				clazz = clsInfo && clsInfo.cls;
				scripts = (clazz && (clazz._noScript || clazz.prototype._noScript) ? [] :
							d.query("> script[type^='dojo/']", node));
			}
			if(!clsInfo){
				throw new Error("Could not load class '" + type);
			}

			// Setup hash to hold parameter settings for this widget.	Start with the parameter
			// settings inherited from ancestors ("dir" and "lang").
			// Inherited setting may later be overridden by explicit settings on node itself.
			var params = {};
				
			if(args.defaults){
				// settings for the document itself (or whatever subtree is being parsed)
				d._mixin(params, args.defaults);
			}
			if(obj.inherited){
				// settings from dir=rtl or lang=... on a node above this node
				d._mixin(params, obj.inherited);
			}
			
			// mix things found in data-dojo-props into the params
			if(fastpath){
				var extra = node.getAttribute(attrData + "props");
				if(extra && extra.length){
					try{
						extra = d.fromJson.call(args.propsThis, "{" + extra + "}");
						d._mixin(params, extra);
					}catch(e){
						// give the user a pointer to their invalid parameters. FIXME: can we kill this in production?
						throw new Error(e.toString() + " in data-dojo-props='" + extra + "'");
					}
				}

				// For the benefit of _Templated, check if node has data-dojo-attach-point/data-dojo-attach-event
				// and mix those in as though they were parameters
				var attachPoint = node.getAttribute(attrData + "attach-point");
				if(attachPoint){
					params.dojoAttachPoint = attachPoint;
				}
				var attachEvent = node.getAttribute(attrData + "attach-event");
				if(attachEvent){
					params.dojoAttachEvent = attachEvent;
				}
				dojo.mixin(params, mixin);
			}else{
				// FIXME: we need something like "deprecateOnce()" to throw dojo.deprecation for something.
				// remove this logic in 2.0
				// read parameters (ie, attributes) specified on DOMNode

				var attributes = node.attributes;

				// clsInfo.params lists expected params like {"checked": "boolean", "n": "number"}
				for(var name in clsInfo.params){
					var item = name in mixin ? { value:mixin[name], specified:true } : attributes.getNamedItem(name);
					if(!item || (!item.specified && (!dojo.isIE || name.toLowerCase()!="value"))){ continue; }
					var value = item.value;
					// Deal with IE quirks for 'class' and 'style'
					switch(name){
					case "class":
						value = "className" in mixin ? mixin.className : node.className;
						break;
					case "style":
						value = "style" in mixin ? mixin.style : (node.style && node.style.cssText); // FIXME: Opera?
					}
					var _type = clsInfo.params[name];
					if(typeof value == "string"){
						params[name] = str2obj(value, _type);
					}else{
						params[name] = value;
					}
				}
			}

			// Process <script type="dojo/*"> script tags
			// <script type="dojo/method" event="foo"> tags are added to params, and passed to
			// the widget on instantiation.
			// <script type="dojo/method"> tags (with no event) are executed after instantiation
			// <script type="dojo/connect" event="foo"> tags are dojo.connected after instantiation
			// note: dojo/* script tags cannot exist in self closing widgets, like <input />
			var connects = [],	// functions to connect after instantiation
				calls = [];		// functions to call after instantiation

			d.forEach(scripts, function(script){
				node.removeChild(script);
				// FIXME: drop event="" support in 2.0. use data-dojo-event="" instead
				var event = (script.getAttribute(attrData + "event") || script.getAttribute("event")),
					type = script.getAttribute("type"),
					nf = d.parser._functionFromScript(script, attrData);
				if(event){
					if(type == "dojo/connect"){
						connects.push({event: event, func: nf});
					}else{
						params[event] = nf;
					}
				}else{
					calls.push(nf);
				}
			});

			var markupFactory = clazz.markupFactory || clazz.prototype && clazz.prototype.markupFactory;
			// create the instance
			var instance = markupFactory ? markupFactory(params, node, clazz) : new clazz(params, node);
			thelist.push(instance);

			// map it to the JS namespace if that makes sense
			// FIXME: in 2.0, drop jsId support. use data-dojo-id instead
			var jsname = (node.getAttribute(attrData + "id") || node.getAttribute("jsId"));
			if(jsname){
				d.setObject(jsname, instance);
			}

			// process connections and startup functions
			d.forEach(connects, function(connect){
				d.connect(instance, connect.event, null, connect.func);
			});
			d.forEach(calls, function(func){
				func.call(instance);
			});
		});

		// Call startup on each top level instance if it makes sense (as for
		// widgets).  Parent widgets will recursively call startup on their
		// (non-top level) children
		if(!mixin._started){
			// TODO: for 2.0, when old instantiate() API is desupported, store parent-child
			// relationships in the nodes[] array so that no getParent() call is needed.
			// Note that will  require a parse() call from ContentPane setting a param that the
			// ContentPane is the parent widget (so that the parse doesn't call startup() on the
			// ContentPane's children)
			d.forEach(thelist, function(instance){
				if( !args.noStart && instance  &&
					dojo.isFunction(instance.startup) &&
					!instance._started &&
					(!instance.getParent || !instance.getParent())
				){
					instance.startup();
				}
			});
		}
		return thelist;
	};

	this.parse = function(rootNode, args){
		// summary:
		//		Scan the DOM for class instances, and instantiate them.
		//
		// description:
		//		Search specified node (or root node) recursively for class instances,
		//		and instantiate them. Searches for either data-dojo-type="Class" or
		//		dojoType="Class" where "Class" is a a fully qualified class name,
		//		like `dijit.form.Button`
		//
		//		Using `data-dojo-type`:
		//		Attributes using can be mixed into the parameters used to instantitate the
		//		Class by using a `data-dojo-props` attribute on the node being converted.
		//		`data-dojo-props` should be a string attribute to be converted from JSON.
		//
		//		Using `dojoType`:
		//		Attributes are read from the original domNode and converted to appropriate
		//		types by looking up the Class prototype values. This is the default behavior
		//		from Dojo 1.0 to Dojo 1.5. `dojoType` support is deprecated, and will
		//		go away in Dojo 2.0.
		//
		// rootNode: DomNode?
		//		A default starting root node from which to start the parsing. Can be
		//		omitted, defaulting to the entire document. If omitted, the `args`
		//		object can be passed in this place. If the `args` object has a
		//		`rootNode` member, that is used.
		//
		// args: Object
		//		a kwArgs object passed along to instantiate()
		//
		//			* noStart: Boolean?
		//				when set will prevent the parser from calling .startup()
		//				when locating the nodes.
		//			* rootNode: DomNode?
		//				identical to the function's `rootNode` argument, though
		//				allowed to be passed in via this `args object.
		//			* template: Boolean
		//				If true, ignores ContentPane's stopParser flag and parses contents inside of
		//				a ContentPane inside of a template.   This allows dojoAttachPoint on widgets/nodes
		//				nested inside the ContentPane to work.
		//			* inherited: Object
		//				Hash possibly containing dir and lang settings to be applied to
		//				parsed widgets, unless there's another setting on a sub-node that overrides
		//			* scope: String
		//				Root for attribute names to search for.   If scopeName is dojo,
		//				will search for data-dojo-type (or dojoType).   For backwards compatibility
		//				reasons defaults to dojo._scopeName (which is "dojo" except when
		//				multi-version support is used, when it will be something like dojo16, dojo20, etc.)
		//			* propsThis: Object
		//				If specified, "this" referenced from data-dojo-props will refer to propsThis.
		//				Intended for use from the widgets-in-template feature of `dijit._Templated`
		//
		// example:
		//		Parse all widgets on a page:
		//	|		dojo.parser.parse();
		//
		// example:
		//		Parse all classes within the node with id="foo"
		//	|		dojo.parser.parse(dojo.byId('foo'));
		//
		// example:
		//		Parse all classes in a page, but do not call .startup() on any
		//		child
		//	|		dojo.parser.parse({ noStart: true })
		//
		// example:
		//		Parse all classes in a node, but do not call .startup()
		//	|		dojo.parser.parse(someNode, { noStart:true });
		//	|		// or
		//	|		dojo.parser.parse({ noStart:true, rootNode: someNode });

		// determine the root node based on the passed arguments.
		var root;
		if(!args && rootNode && rootNode.rootNode){
			args = rootNode;
			root = args.rootNode;
		}else{
			root = rootNode;
		}
		root = root ? dojo.byId(root) : dojo.body();
		args = args || {};

		var attrName = (args.scope || d._scopeName) + "Type",		// typically "dojoType"
			attrData = "data-" + (args.scope || d._scopeName) + "-";	// typically "data-dojo-"

		function scan(parent, list){
			// summary:
			//		Parent is an Object representing a DOMNode, with or without a dojoType specified.
			//		Scan parent's children looking for nodes with dojoType specified, storing in list[].
			//		If parent has a dojoType, also collects <script type=dojo/*> children and stores in parent.scripts[].
			// parent: Object
			//		Object representing the parent node, like
			//	|	{
			//	|		node: DomNode,			// scan children of this node
			//	|		inherited: {dir: "rtl"},	// dir/lang setting inherited from above node
			//	|
			//	|		// attributes only set if node has dojoType specified
			//	|		scripts: [],			// empty array, put <script type=dojo/*> in here
			//	|		clsInfo: { cls: dijit.form.Button, ...}
			//	|	}
			// list: DomNode[]
			//		Output array of objects (same format as parent) representing nodes to be turned into widgets

			// Effective dir and lang settings on parent node, either set directly or inherited from grandparent
			var inherited = dojo.clone(parent.inherited);
			dojo.forEach(["dir", "lang"], function(name){
				// TODO: what if this is a widget and dir/lang are declared in data-dojo-props?
				var val = parent.node.getAttribute(name);
				if(val){
					inherited[name] = val;
				}
			});

			// if parent is a widget, then search for <script type=dojo/*> tags and put them in scripts[].
			var scripts = parent.clsInfo && !parent.clsInfo.cls.prototype._noScript ? parent.scripts : null;

			// unless parent is a widget with the stopParser flag set, continue search for dojoType, recursively
			var recurse = (!parent.clsInfo || !parent.clsInfo.cls.prototype.stopParser) || (args && args.template);

			// scan parent's children looking for dojoType and <script type=dojo/*>
			for(var child = parent.node.firstChild; child; child = child.nextSibling){
				if(child.nodeType == 1){
					// FIXME: desupport dojoType in 2.0. use data-dojo-type instead
					var type, html5 = recurse && child.getAttribute(attrData + "type");
					if(html5){
						type = html5;
					}else{
						// fallback to backward compatible mode, using dojoType. remove in 2.0
						type = recurse && child.getAttribute(attrName);
					}
					
					var fastpath = html5 == type;

					if(type){
						// if dojoType/data-dojo-type specified, add to output array of nodes to instantiate
						var params = {
							"type": type,
							fastpath: fastpath,
							clsInfo: getClassInfo(type, fastpath), // note: won't find classes declared via dojo.Declaration
							node: child,
							scripts: [], // <script> nodes that are parent's children
							inherited: inherited // dir & lang attributes inherited from parent
						};
						list.push(params);

						// Recurse, collecting <script type="dojo/..."> children, and also looking for
						// descendant nodes with dojoType specified (unless the widget has the stopParser flag),
						scan(params, list);
					}else if(scripts && child.nodeName.toLowerCase() == "script"){
						// if <script type="dojo/...">, save in scripts[]
						type = child.getAttribute("type");
						if (type && /^dojo\/\w/i.test(type)) {
							scripts.push(child);
						}
					}else if(recurse){
						// Recurse, looking for grandchild nodes with dojoType specified
						scan({
							node: child,
							inherited: inherited
						}, list);
					}
				}
			}
		}

		// Ignore bogus entries in inherited hash like {dir: ""}
		var inherited = {};
		if(args && args.inherited){
			for(var key in args.inherited){
				if(args.inherited[key]){ inherited[key] = args.inherited[key]; }
			}
		}

		// Make list of all nodes on page w/dojoType specified
		var list = [];
		scan({
			node: root,
			inherited: inherited
		}, list);

		// go build the object instances
		var mixin = args && args.template ? {template: true} : null;
		return this.instantiate(list, mixin, args); // Array
	};
}();

//Register the parser callback. It should be the first callback
//after the a11y test.

(function(){
	var parseRunner = function(){
		if(dojo.config.parseOnLoad){
			dojo.parser.parse();
		}
	};

	// FIXME: need to clobber cross-dependency!!
	if(dojo.getObject("dijit.wai.onload") === dojo._loaders[0]){
		dojo._loaders.splice(1, 0, parseRunner);
	}else{
		dojo._loaders.unshift(parseRunner);
	}
})();

}

if(!dojo._hasResource["dojo.cache"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.cache"] = true;
dojo.provide("dojo.cache");


/*=====
dojo.cache = {
	// summary:
	// 		A way to cache string content that is fetchable via `dojo.moduleUrl`.
};
=====*/

	var cache = {};
	dojo.cache = function(/*String||Object*/module, /*String*/url, /*String||Object?*/value){
		// summary:
		// 		A getter and setter for storing the string content associated with the
		// 		module and url arguments.
		// description:
		// 		module and url are used to call `dojo.moduleUrl()` to generate a module URL.
		// 		If value is specified, the cache value for the moduleUrl will be set to
		// 		that value. Otherwise, dojo.cache will fetch the moduleUrl and store it
		// 		in its internal cache and return that cached value for the URL. To clear
		// 		a cache value pass null for value. Since XMLHttpRequest (XHR) is used to fetch the
		// 		the URL contents, only modules on the same domain of the page can use this capability.
		// 		The build system can inline the cache values though, to allow for xdomain hosting.
		// module: String||Object
		// 		If a String, the module name to use for the base part of the URL, similar to module argument
		// 		to `dojo.moduleUrl`. If an Object, something that has a .toString() method that
		// 		generates a valid path for the cache item. For example, a dojo._Url object.
		// url: String
		// 		The rest of the path to append to the path derived from the module argument. If
		// 		module is an object, then this second argument should be the "value" argument instead.
		// value: String||Object?
		// 		If a String, the value to use in the cache for the module/url combination.
		// 		If an Object, it can have two properties: value and sanitize. The value property
		// 		should be the value to use in the cache, and sanitize can be set to true or false,
		// 		to indicate if XML declarations should be removed from the value and if the HTML
		// 		inside a body tag in the value should be extracted as the real value. The value argument
		// 		or the value property on the value argument are usually only used by the build system
		// 		as it inlines cache content.
		//	example:
		//		To ask dojo.cache to fetch content and store it in the cache (the dojo["cache"] style
		// 		of call is used to avoid an issue with the build system erroneously trying to intern
		// 		this example. To get the build system to intern your dojo.cache calls, use the
		// 		"dojo.cache" style of call):
		// 		|	//If template.html contains "<h1>Hello</h1>" that will be
		// 		|	//the value for the text variable.
		//		|	var text = dojo["cache"]("my.module", "template.html");
		//	example:
		//		To ask dojo.cache to fetch content and store it in the cache, and sanitize the input
		// 		 (the dojo["cache"] style of call is used to avoid an issue with the build system
		// 		erroneously trying to intern this example. To get the build system to intern your
		// 		dojo.cache calls, use the "dojo.cache" style of call):
		// 		|	//If template.html contains "<html><body><h1>Hello</h1></body></html>", the
		// 		|	//text variable will contain just "<h1>Hello</h1>".
		//		|	var text = dojo["cache"]("my.module", "template.html", {sanitize: true});
		//	example:
		//		Same example as previous, but demostrates how an object can be passed in as
		//		the first argument, then the value argument can then be the second argument.
		// 		|	//If template.html contains "<html><body><h1>Hello</h1></body></html>", the
		// 		|	//text variable will contain just "<h1>Hello</h1>".
		//		|	var text = dojo["cache"](new dojo._Url("my/module/template.html"), {sanitize: true});

		//Module could be a string, or an object that has a toString() method
		//that will return a useful path. If it is an object, then the "url" argument
		//will actually be the value argument.
		if(typeof module == "string"){
			var pathObj = dojo.moduleUrl(module, url);
		}else{
			pathObj = module;
			value = url;
		}
		var key = pathObj.toString();

		var val = value;
		if(value != undefined && !dojo.isString(value)){
			val = ("value" in value ? value.value : undefined);
		}

		var sanitize = value && value.sanitize ? true : false;

		if(typeof val == "string"){
			//We have a string, set cache value
			val = cache[key] = sanitize ? dojo.cache._sanitize(val) : val;
		}else if(val === null){
			//Remove cached value
			delete cache[key];
		}else{
			//Allow cache values to be empty strings. If key property does
			//not exist, fetch it.
			if(!(key in cache)){
				val = dojo._getText(key);
				cache[key] = sanitize ? dojo.cache._sanitize(val) : val;
			}
			val = cache[key];
		}
		return val; //String
	};

	dojo.cache._sanitize = function(/*String*/val){
		// summary:
		//		Strips <?xml ...?> declarations so that external SVG and XML
		// 		documents can be added to a document without worry. Also, if the string
		//		is an HTML document, only the part inside the body tag is returned.
		// description:
		// 		Copied from dijit._Templated._sanitizeTemplateString.
		if(val){
			val = val.replace(/^\s*<\?xml(\s)+version=[\'\"](\d)*.(\d)*[\'\"](\s)*\?>/im, "");
			var matches = val.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
			if(matches){
				val = matches[1];
			}
		}else{
			val = "";
		}
		return val; //String
	};

}

if(!dojo._hasResource["dijit._Templated"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Templated"] = true;
dojo.provide("dijit._Templated");






dojo.declare("dijit._Templated",
	null,
	{
		// summary:
		//		Mixin for widgets that are instantiated from a template

		// templateString: [protected] String
		//		A string that represents the widget template. Pre-empts the
		//		templatePath. In builds that have their strings "interned", the
		//		templatePath is converted to an inline templateString, thereby
		//		preventing a synchronous network call.
		//
		//		Use in conjunction with dojo.cache() to load from a file.
		templateString: null,

		// templatePath: [protected deprecated] String
		//		Path to template (HTML file) for this widget relative to dojo.baseUrl.
		//		Deprecated: use templateString with dojo.cache() instead.
		templatePath: null,

		// widgetsInTemplate: [protected] Boolean
		//		Should we parse the template to find widgets that might be
		//		declared in markup inside it?  False by default.
		widgetsInTemplate: false,

		// skipNodeCache: [protected] Boolean
		//		If using a cached widget template node poses issues for a
		//		particular widget class, it can set this property to ensure
		//		that its template is always re-built from a string
		_skipNodeCache: false,

		// _earlyTemplatedStartup: Boolean
		//		A fallback to preserve the 1.0 - 1.3 behavior of children in
		//		templates having their startup called before the parent widget
		//		fires postCreate. Defaults to 'false', causing child widgets to
		//		have their .startup() called immediately before a parent widget
		//		.startup(), but always after the parent .postCreate(). Set to
		//		'true' to re-enable to previous, arguably broken, behavior.
		_earlyTemplatedStartup: false,

/*=====
		// _attachPoints: [private] String[]
		//		List of widget attribute names associated with dojoAttachPoint=... in the
		//		template, ex: ["containerNode", "labelNode"]
 		_attachPoints: [],
 =====*/

/*=====
		// _attachEvents: [private] Handle[]
		//		List of connections associated with dojoAttachEvent=... in the
		//		template
 		_attachEvents: [],
 =====*/

		constructor: function(){
			this._attachPoints = [];
			this._attachEvents = [];
		},

		_stringRepl: function(tmpl){
			// summary:
			//		Does substitution of ${foo} type properties in template string
			// tags:
			//		private
			var className = this.declaredClass, _this = this;
			// Cache contains a string because we need to do property replacement
			// do the property replacement
			return dojo.string.substitute(tmpl, this, function(value, key){
				if(key.charAt(0) == '!'){ value = dojo.getObject(key.substr(1), false, _this); }
				if(typeof value == "undefined"){ throw new Error(className+" template:"+key); } // a debugging aide
				if(value == null){ return ""; }

				// Substitution keys beginning with ! will skip the transform step,
				// in case a user wishes to insert unescaped markup, e.g. ${!foo}
				return key.charAt(0) == "!" ? value :
					// Safer substitution, see heading "Attribute values" in
					// http://www.w3.org/TR/REC-html40/appendix/notes.html#h-B.3.2
					value.toString().replace(/"/g,"&quot;"); //TODO: add &amp? use encodeXML method?
			}, this);
		},

		buildRendering: function(){
			// summary:
			//		Construct the UI for this widget from a template, setting this.domNode.
			// tags:
			//		protected

			// Lookup cached version of template, and download to cache if it
			// isn't there already.  Returns either a DomNode or a string, depending on
			// whether or not the template contains ${foo} replacement parameters.
			var cached = dijit._Templated.getCachedTemplate(this.templatePath, this.templateString, this._skipNodeCache);

			var node;
			if(dojo.isString(cached)){
				node = dojo._toDom(this._stringRepl(cached));
				if(node.nodeType != 1){
					// Flag common problems such as templates with multiple top level nodes (nodeType == 11)
					throw new Error("Invalid template: " + cached);
				}
			}else{
				// if it's a node, all we have to do is clone it
				node = cached.cloneNode(true);
			}

			this.domNode = node;

			// Call down to _Widget.buildRendering() to get base classes assigned
			// TODO: change the baseClass assignment to attributeMap
			this.inherited(arguments);

			// recurse through the node, looking for, and attaching to, our
			// attachment points and events, which should be defined on the template node.
			this._attachTemplateNodes(node);

			if(this.widgetsInTemplate){
				// Store widgets that we need to start at a later point in time
				var cw = (this._startupWidgets = dojo.parser.parse(node, {
					noStart: !this._earlyTemplatedStartup,
					template: true,
					inherited: {dir: this.dir, lang: this.lang},
					propsThis: this,	// so data-dojo-props of widgets in the template can reference "this" to refer to me
					scope: "dojo"	// even in multi-version mode templates use dojoType/data-dojo-type
				}));

				this._supportingWidgets = dijit.findWidgets(node);

				this._attachTemplateNodes(cw, function(n,p){
					return n[p];
				});
			}

			this._fillContent(this.srcNodeRef);
		},

		_fillContent: function(/*DomNode*/ source){
			// summary:
			//		Relocate source contents to templated container node.
			//		this.containerNode must be able to receive children, or exceptions will be thrown.
			// tags:
			//		protected
			var dest = this.containerNode;
			if(source && dest){
				while(source.hasChildNodes()){
					dest.appendChild(source.firstChild);
				}
			}
		},

		_attachTemplateNodes: function(rootNode, getAttrFunc){
			// summary:
			//		Iterate through the template and attach functions and nodes accordingly.
			//		Alternately, if rootNode is an array of widgets, then will process dojoAttachPoint
			//		etc. for those widgets.
			// description:
			//		Map widget properties and functions to the handlers specified in
			//		the dom node and it's descendants. This function iterates over all
			//		nodes and looks for these properties:
			//			* dojoAttachPoint
			//			* dojoAttachEvent
			//			* waiRole
			//			* waiState
			// rootNode: DomNode|Array[Widgets]
			//		the node to search for properties. All children will be searched.
			// getAttrFunc: Function?
			//		a function which will be used to obtain property for a given
			//		DomNode/Widget
			// tags:
			//		private

			getAttrFunc = getAttrFunc || function(n,p){ return n.getAttribute(p); };

			var nodes = dojo.isArray(rootNode) ? rootNode : (rootNode.all || rootNode.getElementsByTagName("*"));
			var x = dojo.isArray(rootNode) ? 0 : -1;
			for(; x<nodes.length; x++){
				var baseNode = (x == -1) ? rootNode : nodes[x];
				if(this.widgetsInTemplate && (getAttrFunc(baseNode, "dojoType") || getAttrFunc(baseNode, "data-dojo-type"))){
					continue;
				}
				// Process dojoAttachPoint
				var attachPoint = getAttrFunc(baseNode, "dojoAttachPoint") || getAttrFunc(baseNode, "data-dojo-attach-point");
				if(attachPoint){
					var point, points = attachPoint.split(/\s*,\s*/);
					while((point = points.shift())){
						if(dojo.isArray(this[point])){
							this[point].push(baseNode);
						}else{
							this[point]=baseNode;
						}
						this._attachPoints.push(point);
					}
				}

				// Process dojoAttachEvent
				var attachEvent = getAttrFunc(baseNode, "dojoAttachEvent") || getAttrFunc(baseNode, "data-dojo-attach-event");;
				if(attachEvent){
					// NOTE: we want to support attributes that have the form
					// "domEvent: nativeEvent; ..."
					var event, events = attachEvent.split(/\s*,\s*/);
					var trim = dojo.trim;
					while((event = events.shift())){
						if(event){
							var thisFunc = null;
							if(event.indexOf(":") != -1){
								// oh, if only JS had tuple assignment
								var funcNameArr = event.split(":");
								event = trim(funcNameArr[0]);
								thisFunc = trim(funcNameArr[1]);
							}else{
								event = trim(event);
							}
							if(!thisFunc){
								thisFunc = event;
							}
							this._attachEvents.push(this.connect(baseNode, event, thisFunc));
						}
					}
				}

				// waiRole, waiState
				// TODO: remove this in 2.0, templates are now using role=... and aria-XXX=... attributes directicly
				var role = getAttrFunc(baseNode, "waiRole");
				if(role){
					dijit.setWaiRole(baseNode, role);
				}
				var values = getAttrFunc(baseNode, "waiState");
				if(values){
					dojo.forEach(values.split(/\s*,\s*/), function(stateValue){
						if(stateValue.indexOf('-') != -1){
							var pair = stateValue.split('-');
							dijit.setWaiState(baseNode, pair[0], pair[1]);
						}
					});
				}
			}
		},

		startup: function(){
			dojo.forEach(this._startupWidgets, function(w){
				if(w && !w._started && w.startup){
					w.startup();
				}
			});
			this.inherited(arguments);
		},

		destroyRendering: function(){
			// Delete all attach points to prevent IE6 memory leaks.
			dojo.forEach(this._attachPoints, function(point){
				delete this[point];
			}, this);
			this._attachPoints = [];

			// And same for event handlers
			dojo.forEach(this._attachEvents, this.disconnect, this);
			this._attachEvents = [];
			
			this.inherited(arguments);
		}
	}
);

// key is either templatePath or templateString; object is either string or DOM tree
dijit._Templated._templateCache = {};

dijit._Templated.getCachedTemplate = function(templatePath, templateString, alwaysUseString){
	// summary:
	//		Static method to get a template based on the templatePath or
	//		templateString key
	// templatePath: String||dojo.uri.Uri
	//		The URL to get the template from.
	// templateString: String?
	//		a string to use in lieu of fetching the template from a URL. Takes precedence
	//		over templatePath
	// returns: Mixed
	//		Either string (if there are ${} variables that need to be replaced) or just
	//		a DOM tree (if the node can be cloned directly)

	// is it already cached?
	var tmplts = dijit._Templated._templateCache;
	var key = templateString || templatePath;
	var cached = tmplts[key];
	if(cached){
		try{
			// if the cached value is an innerHTML string (no ownerDocument) or a DOM tree created within the current document, then use the current cached value
			if(!cached.ownerDocument || cached.ownerDocument == dojo.doc){
				// string or node of the same document
				return cached;
			}
		}catch(e){ /* squelch */ } // IE can throw an exception if cached.ownerDocument was reloaded
		dojo.destroy(cached);
	}

	// If necessary, load template string from template path
	if(!templateString){
		templateString = dojo.cache(templatePath, {sanitize: true});
	}
	templateString = dojo.string.trim(templateString);

	if(alwaysUseString || templateString.match(/\$\{([^\}]+)\}/g)){
		// there are variables in the template so all we can do is cache the string
		return (tmplts[key] = templateString); //String
	}else{
		// there are no variables in the template so we can cache the DOM tree
		var node = dojo._toDom(templateString);
		if(node.nodeType != 1){
			throw new Error("Invalid template: " + templateString);
		}
		return (tmplts[key] = node); //Node
	}
};

if(dojo.isIE){
	dojo.addOnWindowUnload(function(){
		var cache = dijit._Templated._templateCache;
		for(var key in cache){
			var value = cache[key];
			if(typeof value == "object"){ // value is either a string or a DOM node template
				dojo.destroy(value);
			}
			delete cache[key];
		}
	});
}

// These arguments can be specified for widgets which are used in templates.
// Since any widget can be specified as sub widgets in template, mix it
// into the base widget class.  (This is a hack, but it's effective.)
dojo.extend(dijit._Widget,{
	dojoAttachEvent: "",
	dojoAttachPoint: "",
	waiRole: "",
	waiState:""
});

}

if(!dojo._hasResource["dijit._Container"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Container"] = true;
dojo.provide("dijit._Container");


dojo.declare("dijit._Container",
	null,
	{
		// summary:
		//		Mixin for widgets that contain a set of widget children.
		// description:
		//		Use this mixin for widgets that needs to know about and
		//		keep track of their widget children. Suitable for widgets like BorderContainer
		//		and TabContainer which contain (only) a set of child widgets.
		//
		//		It's not suitable for widgets like ContentPane
		//		which contains mixed HTML (plain DOM nodes in addition to widgets),
		//		and where contained widgets are not necessarily directly below
		//		this.containerNode.   In that case calls like addChild(node, position)
		//		wouldn't make sense.

		// isContainer: [protected] Boolean
		//		Indicates that this widget acts as a "parent" to the descendant widgets.
		//		When the parent is started it will call startup() on the child widgets.
		//		See also `isLayoutContainer`.
		isContainer: true,

		buildRendering: function(){
			this.inherited(arguments);
			if(!this.containerNode){
				// all widgets with descendants must set containerNode
	 				this.containerNode = this.domNode;
			}
		},

		addChild: function(/*dijit._Widget*/ widget, /*int?*/ insertIndex){
			// summary:
			//		Makes the given widget a child of this widget.
			// description:
			//		Inserts specified child widget's dom node as a child of this widget's
			//		container node, and possibly does other processing (such as layout).

			var refNode = this.containerNode;
			if(insertIndex && typeof insertIndex == "number"){
				var children = this.getChildren();
				if(children && children.length >= insertIndex){
					refNode = children[insertIndex-1].domNode;
					insertIndex = "after";
				}
			}
			dojo.place(widget.domNode, refNode, insertIndex);

			// If I've been started but the child widget hasn't been started,
			// start it now.  Make sure to do this after widget has been
			// inserted into the DOM tree, so it can see that it's being controlled by me,
			// so it doesn't try to size itself.
			if(this._started && !widget._started){
				widget.startup();
			}
		},

		removeChild: function(/*Widget or int*/ widget){
			// summary:
			//		Removes the passed widget instance from this widget but does
			//		not destroy it.  You can also pass in an integer indicating
			//		the index within the container to remove

			if(typeof widget == "number"){
				widget = this.getChildren()[widget];
			}

			if(widget){
				var node = widget.domNode;
				if(node && node.parentNode){
					node.parentNode.removeChild(node); // detach but don't destroy
				}
			}
		},

		hasChildren: function(){
			// summary:
			//		Returns true if widget has children, i.e. if this.containerNode contains something.
			return this.getChildren().length > 0;	// Boolean
		},

		destroyDescendants: function(/*Boolean*/ preserveDom){
			// summary:
			//      Destroys all the widgets inside this.containerNode,
			//      but not this widget itself
			dojo.forEach(this.getChildren(), function(child){ child.destroyRecursive(preserveDom); });
		},

		_getSiblingOfChild: function(/*dijit._Widget*/ child, /*int*/ dir){
			// summary:
			//		Get the next or previous widget sibling of child
			// dir:
			//		if 1, get the next sibling
			//		if -1, get the previous sibling
			// tags:
			//      private
			var node = child.domNode,
				which = (dir>0 ? "nextSibling" : "previousSibling");
			do{
				node = node[which];
			}while(node && (node.nodeType != 1 || !dijit.byNode(node)));
			return node && dijit.byNode(node);	// dijit._Widget
		},

		getIndexOfChild: function(/*dijit._Widget*/ child){
			// summary:
			//		Gets the index of the child in this container or -1 if not found
			return dojo.indexOf(this.getChildren(), child);	// int
		},

		startup: function(){
			// summary:
			//		Called after all the widgets have been instantiated and their
			//		dom nodes have been inserted somewhere under dojo.doc.body.
			//
			//		Widgets should override this method to do any initialization
			//		dependent on other widgets existing, and then call
			//		this superclass method to finish things off.
			//
			//		startup() in subclasses shouldn't do anything
			//		size related because the size of the widget hasn't been set yet.

			if(this._started){ return; }

			// Startup all children of this widget
			dojo.forEach(this.getChildren(), function(child){ child.startup(); });

			this.inherited(arguments);
		}
	}
);

}

if(!dojo._hasResource["dijit._CssStateMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._CssStateMixin"] = true;
dojo.provide("dijit._CssStateMixin");


dojo.declare("dijit._CssStateMixin", [], {
	// summary:
	//		Mixin for widgets to set CSS classes on the widget DOM nodes depending on hover/mouse press/focus
	//		state changes, and also higher-level state changes such becoming disabled or selected.
	//
	// description:
	//		By mixing this class into your widget, and setting the this.baseClass attribute, it will automatically
	//		maintain CSS classes on the widget root node (this.domNode) depending on hover,
	//		active, focus, etc. state.   Ex: with a baseClass of dijitButton, it will apply the classes
	//		dijitButtonHovered and dijitButtonActive, as the user moves the mouse over the widget and clicks it.
	//
	//		It also sets CSS like dijitButtonDisabled based on widget semantic state.
	//
	//		By setting the cssStateNodes attribute, a widget can also track events on subnodes (like buttons
	//		within the widget).

	// cssStateNodes: [protected] Object
	//		List of sub-nodes within the widget that need CSS classes applied on mouse hover/press and focus
	//.
	//		Each entry in the hash is a an attachpoint names (like "upArrowButton") mapped to a CSS class names
	//		(like "dijitUpArrowButton"). Example:
	//	|		{
	//	|			"upArrowButton": "dijitUpArrowButton",
	//	|			"downArrowButton": "dijitDownArrowButton"
	//	|		}
	//		The above will set the CSS class dijitUpArrowButton to the this.upArrowButton DOMNode when it
	//		is hovered, etc.
	cssStateNodes: {},

	// hovering: [readonly] Boolean
	//		True if cursor is over this widget
	hovering: false,
	
	// active: [readonly] Boolean
	//		True if mouse was pressed while over this widget, and hasn't been released yet
	active: false,

	_applyAttributes: function(){
		// This code would typically be in postCreate(), but putting in _applyAttributes() for
		// performance: so the class changes happen before DOM is inserted into the document.
		// Change back to postCreate() in 2.0.  See #11635.

		this.inherited(arguments);

		// Automatically monitor mouse events (essentially :hover and :active) on this.domNode
		dojo.forEach(["onmouseenter", "onmouseleave", "onmousedown"], function(e){
			this.connect(this.domNode, e, "_cssMouseEvent");
		}, this);
		
		// Monitoring changes to disabled, readonly, etc. state, and update CSS class of root node
		dojo.forEach(["disabled", "readOnly", "checked", "selected", "focused", "state", "hovering", "active"], function(attr){
			this.watch(attr, dojo.hitch(this, "_setStateClass"));
		}, this);

		// Events on sub nodes within the widget
		for(var ap in this.cssStateNodes){
			this._trackMouseState(this[ap], this.cssStateNodes[ap]);
		}
		// Set state initially; there's probably no hover/active/focus state but widget might be
		// disabled/readonly/checked/selected so we want to set CSS classes for those conditions.
		this._setStateClass();
	},

	_cssMouseEvent: function(/*Event*/ event){
		// summary:
		//	Sets hovering and active properties depending on mouse state,
		//	which triggers _setStateClass() to set appropriate CSS classes for this.domNode.

		if(!this.disabled){
			switch(event.type){
				case "mouseenter":
				case "mouseover":	// generated on non-IE browsers even though we connected to mouseenter
					this._set("hovering", true);
					this._set("active", this._mouseDown);
					break;

				case "mouseleave":
				case "mouseout":	// generated on non-IE browsers even though we connected to mouseleave
					this._set("hovering", false);
					this._set("active", false);
					break;

				case "mousedown" :
					this._set("active", true);
					this._mouseDown = true;
					// Set a global event to handle mouseup, so it fires properly
					// even if the cursor leaves this.domNode before the mouse up event.
					// Alternately could set active=false on mouseout.
					var mouseUpConnector = this.connect(dojo.body(), "onmouseup", function(){
						this._mouseDown = false;
						this._set("active", false);
						this.disconnect(mouseUpConnector);
					});
					break;
			}
		}
	},

	_setStateClass: function(){
		// summary:
		//		Update the visual state of the widget by setting the css classes on this.domNode
		//		(or this.stateNode if defined) by combining this.baseClass with
		//		various suffixes that represent the current widget state(s).
		//
		// description:
		//		In the case where a widget has multiple
		//		states, it sets the class based on all possible
		//	 	combinations.  For example, an invalid form widget that is being hovered
		//		will be "dijitInput dijitInputInvalid dijitInputHover dijitInputInvalidHover".
		//
		//		The widget may have one or more of the following states, determined
		//		by this.state, this.checked, this.valid, and this.selected:
		//			- Error - ValidationTextBox sets this.state to "Error" if the current input value is invalid
		//			- Incomplete - ValidationTextBox sets this.state to "Incomplete" if the current input value is not finished yet
		//			- Checked - ex: a checkmark or a ToggleButton in a checked state, will have this.checked==true
		//			- Selected - ex: currently selected tab will have this.selected==true
		//
		//		In addition, it may have one or more of the following states,
		//		based on this.disabled and flags set in _onMouse (this.active, this.hovering) and from focus manager (this.focused):
		//			- Disabled	- if the widget is disabled
		//			- Active		- if the mouse (or space/enter key?) is being pressed down
		//			- Focused		- if the widget has focus
		//			- Hover		- if the mouse is over the widget

		// Compute new set of classes
		var newStateClasses = this.baseClass.split(" ");

		function multiply(modifier){
			newStateClasses = newStateClasses.concat(dojo.map(newStateClasses, function(c){ return c+modifier; }), "dijit"+modifier);
		}

		if(!this.isLeftToRight()){
			// For RTL mode we need to set an addition class like dijitTextBoxRtl.
			multiply("Rtl");
		}

		if(this.checked){
			multiply("Checked");
		}
		if(this.state){
			multiply(this.state);
		}
		if(this.selected){
			multiply("Selected");
		}

		if(this.disabled){
			multiply("Disabled");
		}else if(this.readOnly){
			multiply("ReadOnly");
		}else{
			if(this.active){
				multiply("Active");
			}else if(this.hovering){
				multiply("Hover");
			}
		}

		if(this._focused){
			multiply("Focused");
		}

		// Remove old state classes and add new ones.
		// For performance concerns we only write into domNode.className once.
		var tn = this.stateNode || this.domNode,
			classHash = {};	// set of all classes (state and otherwise) for node

		dojo.forEach(tn.className.split(" "), function(c){ classHash[c] = true; });

		if("_stateClasses" in this){
			dojo.forEach(this._stateClasses, function(c){ delete classHash[c]; });
		}

		dojo.forEach(newStateClasses, function(c){ classHash[c] = true; });

		var newClasses = [];
		for(var c in classHash){
			newClasses.push(c);
		}
		tn.className = newClasses.join(" ");

		this._stateClasses = newStateClasses;
	},

	_trackMouseState: function(/*DomNode*/ node, /*String*/ clazz){
		// summary:
		//		Track mouse/focus events on specified node and set CSS class on that node to indicate
		//		current state.   Usually not called directly, but via cssStateNodes attribute.
		// description:
		//		Given class=foo, will set the following CSS class on the node
		//			- fooActive: if the user is currently pressing down the mouse button while over the node
		//			- fooHover: if the user is hovering the mouse over the node, but not pressing down a button
		//			- fooFocus: if the node is focused
		//
		//		Note that it won't set any classes if the widget is disabled.
		// node: DomNode
		//		Should be a sub-node of the widget, not the top node (this.domNode), since the top node
		//		is handled specially and automatically just by mixing in this class.
		// clazz: String
		//		CSS class name (ex: dijitSliderUpArrow).

		// Current state of node (initially false)
		// NB: setting specifically to false because dojo.toggleClass() needs true boolean as third arg
		var hovering=false, active=false, focused=false;

		var self = this,
			cn = dojo.hitch(this, "connect", node);

		function setClass(){
			var disabled = ("disabled" in self && self.disabled) || ("readonly" in self && self.readonly);
			dojo.toggleClass(node, clazz+"Hover", hovering && !active && !disabled);
			dojo.toggleClass(node, clazz+"Active", active && !disabled);
			dojo.toggleClass(node, clazz+"Focused", focused && !disabled);
		}

		// Mouse
		cn("onmouseenter", function(){
			hovering = true;
			setClass();
		});
		cn("onmouseleave", function(){
			hovering = false;
			active = false;
			setClass();
		});
		cn("onmousedown", function(){
			active = true;
			setClass();
		});
		cn("onmouseup", function(){
			active = false;
			setClass();
		});

		// Focus
		cn("onfocus", function(){
			focused = true;
			setClass();
		});
		cn("onblur", function(){
			focused = false;
			setClass();
		});

		// Just in case widget is enabled/disabled while it has focus/hover/active state.
		// Maybe this is overkill.
		this.watch("disabled", setClass);
		this.watch("readOnly", setClass);
	}
});

}

if(!dojo._hasResource["dijit._Contained"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Contained"] = true;
dojo.provide("dijit._Contained");


dojo.declare("dijit._Contained",
		null,
		{
			// summary:
			//		Mixin for widgets that are children of a container widget
			//
			// example:
			// | 	// make a basic custom widget that knows about it's parents
			// |	dojo.declare("my.customClass",[dijit._Widget,dijit._Contained],{});

			getParent: function(){
				// summary:
				//		Returns the parent widget of this widget, assuming the parent
				//		specifies isContainer
				var parent = dijit.getEnclosingWidget(this.domNode.parentNode);
				return parent && parent.isContainer ? parent : null;
			},

			_getSibling: function(/*String*/ which){
				// summary:
				//      Returns next or previous sibling
				// which:
				//      Either "next" or "previous"
				// tags:
				//      private
				var node = this.domNode;
				do{
					node = node[which+"Sibling"];
				}while(node && node.nodeType != 1);
				return node && dijit.byNode(node);	// dijit._Widget
			},

			getPreviousSibling: function(){
				// summary:
				//		Returns null if this is the first child of the parent,
				//		otherwise returns the next element sibling to the "left".

				return this._getSibling("previous"); // dijit._Widget
			},

			getNextSibling: function(){
				// summary:
				//		Returns null if this is the last child of the parent,
				//		otherwise returns the next element sibling to the "right".

				return this._getSibling("next"); // dijit._Widget
			},

			getIndexInParent: function(){
				// summary:
				//		Returns the index of this widget within its container parent.
				//		It returns -1 if the parent does not exist, or if the parent
				//		is not a dijit._Container

				var p = this.getParent();
				if(!p || !p.getIndexOfChild){
					return -1; // int
				}
				return p.getIndexOfChild(this); // int
			}
		}
	);

}

if(!dojo._hasResource["dijit.layout._LayoutWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout._LayoutWidget"] = true;
dojo.provide("dijit.layout._LayoutWidget");





dojo.declare("dijit.layout._LayoutWidget",
	[dijit._Widget, dijit._Container, dijit._Contained],
	{
		// summary:
		//		Base class for a _Container widget which is responsible for laying out its children.
		//		Widgets which mixin this code must define layout() to manage placement and sizing of the children.

		// baseClass: [protected extension] String
		//		This class name is applied to the widget's domNode
		//		and also may be used to generate names for sub nodes,
		//		for example dijitTabContainer-content.
		baseClass: "dijitLayoutContainer",

		// isLayoutContainer: [protected] Boolean
		//		Indicates that this widget is going to call resize() on its
		//		children widgets, setting their size, when they become visible.
		isLayoutContainer: true,

		buildRendering: function(){
			this.inherited(arguments);
			dojo.addClass(this.domNode, "dijitContainer");
		},

		startup: function(){
			// summary:
			//		Called after all the widgets have been instantiated and their
			//		dom nodes have been inserted somewhere under dojo.doc.body.
			//
			//		Widgets should override this method to do any initialization
			//		dependent on other widgets existing, and then call
			//		this superclass method to finish things off.
			//
			//		startup() in subclasses shouldn't do anything
			//		size related because the size of the widget hasn't been set yet.

			if(this._started){ return; }

			// Need to call inherited first - so that child widgets get started
			// up correctly
			this.inherited(arguments);

			// If I am a not being controlled by a parent layout widget...
			var parent = this.getParent && this.getParent()
			if(!(parent && parent.isLayoutContainer)){
				// Do recursive sizing and layout of all my descendants
				// (passing in no argument to resize means that it has to glean the size itself)
				this.resize();

				// Since my parent isn't a layout container, and my style *may be* width=height=100%
				// or something similar (either set directly or via a CSS class),
				// monitor when my size changes so that I can re-layout.
				// For browsers where I can't directly monitor when my size changes,
				// monitor when the viewport changes size, which *may* indicate a size change for me.
				this.connect(dojo.isIE ? this.domNode : dojo.global, 'onresize', function(){
					// Using function(){} closure to ensure no arguments to resize.
					this.resize();
				});
			}
		},

		resize: function(changeSize, resultSize){
			// summary:
			//		Call this to resize a widget, or after its size has changed.
			// description:
			//		Change size mode:
			//			When changeSize is specified, changes the marginBox of this widget
			//			and forces it to relayout its contents accordingly.
			//			changeSize may specify height, width, or both.
			//
			//			If resultSize is specified it indicates the size the widget will
			//			become after changeSize has been applied.
			//
			//		Notification mode:
			//			When changeSize is null, indicates that the caller has already changed
			//			the size of the widget, or perhaps it changed because the browser
			//			window was resized.  Tells widget to relayout its contents accordingly.
			//
			//			If resultSize is also specified it indicates the size the widget has
			//			become.
			//
			//		In either mode, this method also:
			//			1. Sets this._borderBox and this._contentBox to the new size of
			//				the widget.  Queries the current domNode size if necessary.
			//			2. Calls layout() to resize contents (and maybe adjust child widgets).
			//
			// changeSize: Object?
			//		Sets the widget to this margin-box size and position.
			//		May include any/all of the following properties:
			//	|	{w: int, h: int, l: int, t: int}
			//
			// resultSize: Object?
			//		The margin-box size of this widget after applying changeSize (if
			//		changeSize is specified).  If caller knows this size and
			//		passes it in, we don't need to query the browser to get the size.
			//	|	{w: int, h: int}

			var node = this.domNode;

			// set margin box size, unless it wasn't specified, in which case use current size
			if(changeSize){
				dojo.marginBox(node, changeSize);

				// set offset of the node
				if(changeSize.t){ node.style.top = changeSize.t + "px"; }
				if(changeSize.l){ node.style.left = changeSize.l + "px"; }
			}

			// If either height or width wasn't specified by the user, then query node for it.
			// But note that setting the margin box and then immediately querying dimensions may return
			// inaccurate results, so try not to depend on it.
			var mb = resultSize || {};
			dojo.mixin(mb, changeSize || {});	// changeSize overrides resultSize
			if( !("h" in mb) || !("w" in mb) ){
				mb = dojo.mixin(dojo.marginBox(node), mb);	// just use dojo.marginBox() to fill in missing values
			}

			// Compute and save the size of my border box and content box
			// (w/out calling dojo.contentBox() since that may fail if size was recently set)
			var cs = dojo.getComputedStyle(node);
			var me = dojo._getMarginExtents(node, cs);
			var be = dojo._getBorderExtents(node, cs);
			var bb = (this._borderBox = {
				w: mb.w - (me.w + be.w),
				h: mb.h - (me.h + be.h)
			});
			var pe = dojo._getPadExtents(node, cs);
			this._contentBox = {
				l: dojo._toPixelValue(node, cs.paddingLeft),
				t: dojo._toPixelValue(node, cs.paddingTop),
				w: bb.w - pe.w,
				h: bb.h - pe.h
			};

			// Callback for widget to adjust size of its children
			this.layout();
		},

		layout: function(){
			// summary:
			//		Widgets override this method to size and position their contents/children.
			//		When this is called this._contentBox is guaranteed to be set (see resize()).
			//
			//		This is called after startup(), and also when the widget's size has been
			//		changed.
			// tags:
			//		protected extension
		},

		_setupChild: function(/*dijit._Widget*/child){
			// summary:
			//		Common setup for initial children and children which are added after startup
			// tags:
			//		protected extension

			var cls = this.baseClass + "-child "
				+ (child.baseClass ? this.baseClass + "-" + child.baseClass : "");
			dojo.addClass(child.domNode, cls);
		},

		addChild: function(/*dijit._Widget*/ child, /*Integer?*/ insertIndex){
			// Overrides _Container.addChild() to call _setupChild()
			this.inherited(arguments);
			if(this._started){
				this._setupChild(child);
			}
		},

		removeChild: function(/*dijit._Widget*/ child){
			// Overrides _Container.removeChild() to remove class added by _setupChild()
			var cls = this.baseClass + "-child"
					+ (child.baseClass ?
						" " + this.baseClass + "-" + child.baseClass : "");
			dojo.removeClass(child.domNode, cls);
			
			this.inherited(arguments);
		}
	}
);

dijit.layout.marginBox2contentBox = function(/*DomNode*/ node, /*Object*/ mb){
	// summary:
	//		Given the margin-box size of a node, return its content box size.
	//		Functions like dojo.contentBox() but is more reliable since it doesn't have
	//		to wait for the browser to compute sizes.
	var cs = dojo.getComputedStyle(node);
	var me = dojo._getMarginExtents(node, cs);
	var pb = dojo._getPadBorderExtents(node, cs);
	return {
		l: dojo._toPixelValue(node, cs.paddingLeft),
		t: dojo._toPixelValue(node, cs.paddingTop),
		w: mb.w - (me.w + pb.w),
		h: mb.h - (me.h + pb.h)
	};
};

(function(){
	var capitalize = function(word){
		return word.substring(0,1).toUpperCase() + word.substring(1);
	};

	var size = function(widget, dim){
		// size the child
		var newSize = widget.resize ? widget.resize(dim) : dojo.marginBox(widget.domNode, dim);

		// record child's size
		if(newSize){
			// if the child returned it's new size then use that
			dojo.mixin(widget, newSize);
		}else{
			// otherwise, call marginBox(), but favor our own numbers when we have them.
			// the browser lies sometimes
			dojo.mixin(widget, dojo.marginBox(widget.domNode));
			dojo.mixin(widget, dim);
		}
	};

	dijit.layout.layoutChildren = function(/*DomNode*/ container, /*Object*/ dim, /*Widget[]*/ children,
			/*String?*/ changedRegionId, /*Number?*/ changedRegionSize){
		// summary
		//		Layout a bunch of child dom nodes within a parent dom node
		// container:
		//		parent node
		// dim:
		//		{l, t, w, h} object specifying dimensions of container into which to place children
		// children:
		//		an array of Widgets or at least objects containing:
		//			* domNode: pointer to DOM node to position
		//			* region or layoutAlign: position to place DOM node
		//			* resize(): (optional) method to set size of node
		//			* id: (optional) Id of widgets, referenced from resize object, below.
		// changedRegionId:
		//		If specified, the slider for the region with the specified id has been dragged, and thus
		//		the region's height or width should be adjusted according to changedRegionSize
		// changedRegionSize:
		//		See changedRegionId.

		// copy dim because we are going to modify it
		dim = dojo.mixin({}, dim);

		dojo.addClass(container, "dijitLayoutContainer");

		// Move "client" elements to the end of the array for layout.  a11y dictates that the author
		// needs to be able to put them in the document in tab-order, but this algorithm requires that
		// client be last.    TODO: move these lines to LayoutContainer?   Unneeded other places I think.
		children = dojo.filter(children, function(item){ return item.region != "center" && item.layoutAlign != "client"; })
			.concat(dojo.filter(children, function(item){ return item.region == "center" || item.layoutAlign == "client"; }));

		// set positions/sizes
		dojo.forEach(children, function(child){
			var elm = child.domNode,
				pos = (child.region || child.layoutAlign);

			// set elem to upper left corner of unused space; may move it later
			var elmStyle = elm.style;
			elmStyle.left = dim.l+"px";
			elmStyle.top = dim.t+"px";
			elmStyle.position = "absolute";

			dojo.addClass(elm, "dijitAlign" + capitalize(pos));

			// Size adjustments to make to this child widget
			var sizeSetting = {};

			// Check for optional size adjustment due to splitter drag (height adjustment for top/bottom align
			// panes and width adjustment for left/right align panes.
			if(changedRegionId && changedRegionId == child.id){
				sizeSetting[child.region == "top" || child.region == "bottom" ? "h" : "w"] = changedRegionSize;
			}

			// set size && adjust record of remaining space.
			// note that setting the width of a <div> may affect its height.
			if(pos == "top" || pos == "bottom"){
				sizeSetting.w = dim.w;
				size(child, sizeSetting);
				dim.h -= child.h;
				if(pos == "top"){
					dim.t += child.h;
				}else{
					elmStyle.top = dim.t + dim.h + "px";
				}
			}else if(pos == "left" || pos == "right"){
				sizeSetting.h = dim.h;
				size(child, sizeSetting);
				dim.w -= child.w;
				if(pos == "left"){
					dim.l += child.w;
				}else{
					elmStyle.left = dim.l + dim.w + "px";
				}
			}else if(pos == "client" || pos == "center"){
				size(child, dim);
			}
		});
	};

})();

}

if(!dojo._hasResource["dojo.cookie"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.cookie"] = true;
dojo.provide("dojo.cookie");



/*=====
dojo.__cookieProps = function(){
	//	expires: Date|String|Number?
	//		If a number, the number of days from today at which the cookie
	//		will expire. If a date, the date past which the cookie will expire.
	//		If expires is in the past, the cookie will be deleted.
	//		If expires is omitted or is 0, the cookie will expire when the browser closes. << FIXME: 0 seems to disappear right away? FF3.
	//	path: String?
	//		The path to use for the cookie.
	//	domain: String?
	//		The domain to use for the cookie.
	//	secure: Boolean?
	//		Whether to only send the cookie on secure connections
	this.expires = expires;
	this.path = path;
	this.domain = domain;
	this.secure = secure;
}
=====*/


dojo.cookie = function(/*String*/name, /*String?*/value, /*dojo.__cookieProps?*/props){
	//	summary:
	//		Get or set a cookie.
	//	description:
	// 		If one argument is passed, returns the value of the cookie
	// 		For two or more arguments, acts as a setter.
	//	name:
	//		Name of the cookie
	//	value:
	//		Value for the cookie
	//	props:
	//		Properties for the cookie
	//	example:
	//		set a cookie with the JSON-serialized contents of an object which
	//		will expire 5 days from now:
	//	|	dojo.cookie("configObj", dojo.toJson(config), { expires: 5 });
	//
	//	example:
	//		de-serialize a cookie back into a JavaScript object:
	//	|	var config = dojo.fromJson(dojo.cookie("configObj"));
	//
	//	example:
	//		delete a cookie:
	//	|	dojo.cookie("configObj", null, {expires: -1});
	var c = document.cookie;
	if(arguments.length == 1){
		var matches = c.match(new RegExp("(?:^|; )" + dojo.regexp.escapeString(name) + "=([^;]*)"));
		return matches ? decodeURIComponent(matches[1]) : undefined; // String or undefined
	}else{
		props = props || {};
// FIXME: expires=0 seems to disappear right away, not on close? (FF3)  Change docs?
		var exp = props.expires;
		if(typeof exp == "number"){
			var d = new Date();
			d.setTime(d.getTime() + exp*24*60*60*1000);
			exp = props.expires = d;
		}
		if(exp && exp.toUTCString){ props.expires = exp.toUTCString(); }

		value = encodeURIComponent(value);
		var updatedCookie = name + "=" + value, propName;
		for(propName in props){
			updatedCookie += "; " + propName;
			var propValue = props[propName];
			if(propValue !== true){ updatedCookie += "=" + propValue; }
		}
		document.cookie = updatedCookie;
	}
};

dojo.cookie.isSupported = function(){
	//	summary:
	//		Use to determine if the current browser supports cookies or not.
	//
	//		Returns true if user allows cookies.
	//		Returns false if user doesn't allow cookies.

	if(!("cookieEnabled" in navigator)){
		this("__djCookieTest__", "CookiesAllowed");
		navigator.cookieEnabled = this("__djCookieTest__") == "CookiesAllowed";
		if(navigator.cookieEnabled){
			this("__djCookieTest__", "", {expires: -1});
		}
	}
	return navigator.cookieEnabled;
};

}

if(!dojo._hasResource["dijit.form._FormWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form._FormWidget"] = true;
dojo.provide("dijit.form._FormWidget");






dojo.declare("dijit.form._FormWidget", [dijit._Widget, dijit._Templated, dijit._CssStateMixin],
	{
	// summary:
	//		Base class for widgets corresponding to native HTML elements such as <checkbox> or <button>,
	//		which can be children of a <form> node or a `dijit.form.Form` widget.
	//
	// description:
	//		Represents a single HTML element.
	//		All these widgets should have these attributes just like native HTML input elements.
	//		You can set them during widget construction or afterwards, via `dijit._Widget.attr`.
	//
	//		They also share some common methods.

	// name: [const] String
	//		Name used when submitting form; same as "name" attribute or plain HTML elements
	name: "",

	// alt: String
	//		Corresponds to the native HTML <input> element's attribute.
	alt: "",

	// value: String
	//		Corresponds to the native HTML <input> element's attribute.
	value: "",

	// type: String
	//		Corresponds to the native HTML <input> element's attribute.
	type: "text",

	// tabIndex: Integer
	//		Order fields are traversed when user hits the tab key
	tabIndex: "0",

	// disabled: Boolean
	//		Should this widget respond to user input?
	//		In markup, this is specified as "disabled='disabled'", or just "disabled".
	disabled: false,

	// intermediateChanges: Boolean
	//		Fires onChange for each value change or only on demand
	intermediateChanges: false,

	// scrollOnFocus: Boolean
	//		On focus, should this widget scroll into view?
	scrollOnFocus: true,

	// These mixins assume that the focus node is an INPUT, as many but not all _FormWidgets are.
	attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
		value: "focusNode",
		id: "focusNode",
		tabIndex: "focusNode",
		alt: "focusNode",
		title: "focusNode"
	}),

	postMixInProperties: function(){
		// Setup name=foo string to be referenced from the template (but only if a name has been specified)
		// Unfortunately we can't use attributeMap to set the name due to IE limitations, see #8660
		// Regarding escaping, see heading "Attribute values" in
		// http://www.w3.org/TR/REC-html40/appendix/notes.html#h-B.3.2
		this.nameAttrSetting = this.name ? ('name="' + this.name.replace(/'/g, "&quot;") + '"') : '';
		this.inherited(arguments);
	},

	postCreate: function(){
		this.inherited(arguments);
		this.connect(this.domNode, "onmousedown", "_onMouseDown");
	},

	_setDisabledAttr: function(/*Boolean*/ value){
		this._set("disabled", value);
		dojo.attr(this.focusNode, 'disabled', value);
		if(this.valueNode){
			dojo.attr(this.valueNode, 'disabled', value);
		}
		dijit.setWaiState(this.focusNode, "disabled", value);

		if(value){
			// reset these, because after the domNode is disabled, we can no longer receive
			// mouse related events, see #4200
			this._set("hovering", false);
			this._set("active", false);

			// clear tab stop(s) on this widget's focusable node(s)  (ComboBox has two focusable nodes)
			var attachPointNames = "tabIndex" in this.attributeMap ? this.attributeMap.tabIndex : "focusNode";
			dojo.forEach(dojo.isArray(attachPointNames) ? attachPointNames : [attachPointNames], function(attachPointName){
				var node = this[attachPointName];
				// complex code because tabIndex=-1 on a <div> doesn't work on FF
				if(dojo.isWebKit || dijit.hasDefaultTabStop(node)){	// see #11064 about webkit bug
					node.setAttribute('tabIndex', "-1");
				}else{
					node.removeAttribute('tabIndex');
				}
			}, this);
		}else{
			if(this.tabIndex != ""){
				this.focusNode.setAttribute('tabIndex', this.tabIndex);
			}
		}
	},

	setDisabled: function(/*Boolean*/ disabled){
		// summary:
		//		Deprecated.  Use set('disabled', ...) instead.
		dojo.deprecated("setDisabled("+disabled+") is deprecated. Use set('disabled',"+disabled+") instead.", "", "2.0");
		this.set('disabled', disabled);
	},

	_onFocus: function(e){
		if(this.scrollOnFocus){
			dojo.window.scrollIntoView(this.domNode);
		}
		this.inherited(arguments);
	},

	isFocusable: function(){
		// summary:
		//		Tells if this widget is focusable or not.  Used internally by dijit.
		// tags:
		//		protected
		return !this.disabled && this.focusNode && (dojo.style(this.domNode, "display") != "none");
	},

	focus: function(){
		// summary:
		//		Put focus on this widget
		if(!this.disabled){
			dijit.focus(this.focusNode);
		}
	},

	compare: function(/*anything*/ val1, /*anything*/ val2){
		// summary:
		//		Compare 2 values (as returned by get('value') for this widget).
		// tags:
		//		protected
		if(typeof val1 == "number" && typeof val2 == "number"){
			return (isNaN(val1) && isNaN(val2)) ? 0 : val1 - val2;
		}else if(val1 > val2){
			return 1;
		}else if(val1 < val2){
			return -1;
		}else{
			return 0;
		}
	},

	onChange: function(newValue){
		// summary:
		//		Callback when this widget's value is changed.
		// tags:
		//		callback
	},

	// _onChangeActive: [private] Boolean
	//		Indicates that changes to the value should call onChange() callback.
	//		This is false during widget initialization, to avoid calling onChange()
	//		when the initial value is set.
	_onChangeActive: false,

	_handleOnChange: function(/*anything*/ newValue, /*Boolean?*/ priorityChange){
		// summary:
		//		Called when the value of the widget is set.  Calls onChange() if appropriate
		// newValue:
		//		the new value
		// priorityChange:
		//		For a slider, for example, dragging the slider is priorityChange==false,
		//		but on mouse up, it's priorityChange==true.  If intermediateChanges==false,
		//		onChange is only called form priorityChange=true events.
		// tags:
		//		private
		if(this._lastValueReported == undefined && (priorityChange === null || !this._onChangeActive)){
			// this block executes not for a change, but during initialization,
			// and is used to store away the original value (or for ToggleButton, the original checked state)
			this._resetValue = this._lastValueReported = newValue;
		}
		this._pendingOnChange = this._pendingOnChange
			|| (typeof newValue != typeof this._lastValueReported)
			|| (this.compare(newValue, this._lastValueReported) != 0);
		if((this.intermediateChanges || priorityChange || priorityChange === undefined) && this._pendingOnChange){
			this._lastValueReported = newValue;
			this._pendingOnChange = false;
			if(this._onChangeActive){
				if(this._onChangeHandle){
					clearTimeout(this._onChangeHandle);
				}
				// setTimout allows hidden value processing to run and
				// also the onChange handler can safely adjust focus, etc
				this._onChangeHandle = setTimeout(dojo.hitch(this,
					function(){
						this._onChangeHandle = null;
						this.onChange(newValue);
					}), 0); // try to collapse multiple onChange's fired faster than can be processed
			}
		}
	},

	create: function(){
		// Overrides _Widget.create()
		this.inherited(arguments);
		this._onChangeActive = true;
	},

	destroy: function(){
		if(this._onChangeHandle){ // destroy called before last onChange has fired
			clearTimeout(this._onChangeHandle);
			this.onChange(this._lastValueReported);
		}
		this.inherited(arguments);
	},

	setValue: function(/*String*/ value){
		// summary:
		//		Deprecated.  Use set('value', ...) instead.
		dojo.deprecated("dijit.form._FormWidget:setValue("+value+") is deprecated.  Use set('value',"+value+") instead.", "", "2.0");
		this.set('value', value);
	},

	getValue: function(){
		// summary:
		//		Deprecated.  Use get('value') instead.
		dojo.deprecated(this.declaredClass+"::getValue() is deprecated. Use get('value') instead.", "", "2.0");
		return this.get('value');
	},
	
	_onMouseDown: function(e){
		// If user clicks on the button, even if the mouse is released outside of it,
		// this button should get focus (to mimics native browser buttons).
		// This is also needed on chrome because otherwise buttons won't get focus at all,
		// which leads to bizarre focus restore on Dialog close etc.
		if(!e.ctrlKey && dojo.mouseButtons.isLeft(e) && this.isFocusable()){ // !e.ctrlKey to ignore right-click on mac
			// Set a global event to handle mouseup, so it fires properly
			// even if the cursor leaves this.domNode before the mouse up event.
			var mouseUpConnector = this.connect(dojo.body(), "onmouseup", function(){
				if (this.isFocusable()) {
					this.focus();
				}
				this.disconnect(mouseUpConnector);
			});
		}
	}
});

dojo.declare("dijit.form._FormValueWidget", dijit.form._FormWidget,
{
	// summary:
	//		Base class for widgets corresponding to native HTML elements such as <input> or <select> that have user changeable values.
	// description:
	//		Each _FormValueWidget represents a single input value, and has a (possibly hidden) <input> element,
	//		to which it serializes it's input value, so that form submission (either normal submission or via FormBind?)
	//		works as expected.

	// Don't attempt to mixin the 'type', 'name' attributes here programatically -- they must be declared
	// directly in the template as read by the parser in order to function. IE is known to specifically
	// require the 'name' attribute at element creation time.  See #8484, #8660.
	// TODO: unclear what that {value: ""} is for; FormWidget.attributeMap copies value to focusNode,
	// so maybe {value: ""} is so the value *doesn't* get copied to focusNode?
	// Seems like we really want value removed from attributeMap altogether
	// (although there's no easy way to do that now)

	// readOnly: Boolean
	//		Should this widget respond to user input?
	//		In markup, this is specified as "readOnly".
	//		Similar to disabled except readOnly form values are submitted.
	readOnly: false,

	attributeMap: dojo.delegate(dijit.form._FormWidget.prototype.attributeMap, {
		value: "",
		readOnly: "focusNode"
	}),

	_setReadOnlyAttr: function(/*Boolean*/ value){
		dojo.attr(this.focusNode, 'readOnly', value);
		dijit.setWaiState(this.focusNode, "readonly", value);
		this._set("readOnly", value);
	},

	postCreate: function(){
		this.inherited(arguments);

		if(dojo.isIE < 9 || (dojo.isIE && dojo.isQuirks)){ // IE won't stop the event with keypress
			this.connect(this.focusNode || this.domNode, "onkeydown", this._onKeyDown);
		}
		// Update our reset value if it hasn't yet been set (because this.set()
		// is only called when there *is* a value)
		if(this._resetValue === undefined){
			this._lastValueReported = this._resetValue = this.value;
		}
	},

	_setValueAttr: function(/*anything*/ newValue, /*Boolean?*/ priorityChange){
		// summary:
		//		Hook so set('value', value) works.
		// description:
		//		Sets the value of the widget.
		//		If the value has changed, then fire onChange event, unless priorityChange
		//		is specified as null (or false?)
		this._handleOnChange(newValue, priorityChange);
	},

	_handleOnChange: function(/*anything*/ newValue, /*Boolean?*/ priorityChange){
		// summary:
		//		Called when the value of the widget has changed.  Saves the new value in this.value,
		//		and calls onChange() if appropriate.   See _FormWidget._handleOnChange() for details.
		this._set("value", newValue);
		this.inherited(arguments);
	},

	undo: function(){
		// summary:
		//		Restore the value to the last value passed to onChange
		this._setValueAttr(this._lastValueReported, false);
	},

	reset: function(){
		// summary:
		//		Reset the widget's value to what it was at initialization time
		this._hasBeenBlurred = false;
		this._setValueAttr(this._resetValue, true);
	},

	_onKeyDown: function(e){
		if(e.keyCode == dojo.keys.ESCAPE && !(e.ctrlKey || e.altKey || e.metaKey)){
			var te;
			if(dojo.isIE){
				e.preventDefault(); // default behavior needs to be stopped here since keypress is too late
				te = document.createEventObject();
				te.keyCode = dojo.keys.ESCAPE;
				te.shiftKey = e.shiftKey;
				e.srcElement.fireEvent('onkeypress', te);
			}
		}
	},

	_layoutHackIE7: function(){
		// summary:
		//		Work around table sizing bugs on IE7 by forcing redraw

		if(dojo.isIE == 7){ // fix IE7 layout bug when the widget is scrolled out of sight
			var domNode = this.domNode;
			var parent = domNode.parentNode;
			var pingNode = domNode.firstChild || domNode; // target node most unlikely to have a custom filter
			var origFilter = pingNode.style.filter; // save custom filter, most likely nothing
			var _this = this;
			while(parent && parent.clientHeight == 0){ // search for parents that haven't rendered yet
				(function ping(){
					var disconnectHandle = _this.connect(parent, "onscroll",
						function(e){
							_this.disconnect(disconnectHandle); // only call once
							pingNode.style.filter = (new Date()).getMilliseconds(); // set to anything that's unique
							setTimeout(function(){ pingNode.style.filter = origFilter }, 0); // restore custom filter, if any
						}
					);
				})();
				parent = parent.parentNode;
			}
		}
	}
});

}

if(!dojo._hasResource["dijit._HasDropDown"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._HasDropDown"] = true;
dojo.provide("dijit._HasDropDown");



dojo.declare("dijit._HasDropDown",
	null,
	{
		// summary:
		//		Mixin for widgets that need drop down ability.

		// _buttonNode: [protected] DomNode
		//		The button/icon/node to click to display the drop down.
		//		Can be set via a dojoAttachPoint assignment.
		//		If missing, then either focusNode or domNode (if focusNode is also missing) will be used.
		_buttonNode: null,

		// _arrowWrapperNode: [protected] DomNode
		//		Will set CSS class dijitUpArrow, dijitDownArrow, dijitRightArrow etc. on this node depending
		//		on where the drop down is set to be positioned.
		//		Can be set via a dojoAttachPoint assignment.
		//		If missing, then _buttonNode will be used.
		_arrowWrapperNode: null,

		// _popupStateNode: [protected] DomNode
		//		The node to set the popupActive class on.
		//		Can be set via a dojoAttachPoint assignment.
		//		If missing, then focusNode or _buttonNode (if focusNode is missing) will be used.
		_popupStateNode: null,

		// _aroundNode: [protected] DomNode
		//		The node to display the popup around.
		//		Can be set via a dojoAttachPoint assignment.
		//		If missing, then domNode will be used.
		_aroundNode: null,

		// dropDown: [protected] Widget
		//		The widget to display as a popup.  This widget *must* be
		//		defined before the startup function is called.
		dropDown: null,

		// autoWidth: [protected] Boolean
		//		Set to true to make the drop down at least as wide as this
		//		widget.  Set to false if the drop down should just be its
		//		default width
		autoWidth: true,

		// forceWidth: [protected] Boolean
		//		Set to true to make the drop down exactly as wide as this
		//		widget.  Overrides autoWidth.
		forceWidth: false,

		// maxHeight: [protected] Integer
		//		The max height for our dropdown.
		//		Any dropdown taller than this will have scrollbars.
		//		Set to 0 for no max height, or -1 to limit height to available space in viewport
		maxHeight: 0,

		// dropDownPosition: [const] String[]
		//		This variable controls the position of the drop down.
		//		It's an array of strings with the following values:
		//
		//			* before: places drop down to the left of the target node/widget, or to the right in
		//			  the case of RTL scripts like Hebrew and Arabic
		//			* after: places drop down to the right of the target node/widget, or to the left in
		//			  the case of RTL scripts like Hebrew and Arabic
		//			* above: drop down goes above target node
		//			* below: drop down goes below target node
		//
		//		The list is positions is tried, in order, until a position is found where the drop down fits
		//		within the viewport.
		//
		dropDownPosition: ["below","above"],

		// _stopClickEvents: Boolean
		//		When set to false, the click events will not be stopped, in
		//		case you want to use them in your subwidget
		_stopClickEvents: true,

		_onDropDownMouseDown: function(/*Event*/ e){
			// summary:
			//		Callback when the user mousedown's on the arrow icon

			if(this.disabled || this.readOnly){ return; }

			// Prevent default to stop things like text selection, but don't stop propogation, so that:
			//		1. TimeTextBox etc. can focusthe <input> on mousedown
			//		2. dropDownButtonActive class applied by _CssStateMixin (on button depress)
			//		3. user defined onMouseDown handler fires
			e.preventDefault();

			this._docHandler = this.connect(dojo.doc, "onmouseup", "_onDropDownMouseUp");

			this.toggleDropDown();
		},

		_onDropDownMouseUp: function(/*Event?*/ e){
			// summary:
			//		Callback when the user lifts their mouse after mouse down on the arrow icon.
			//		If the drop is a simple menu and the mouse is over the menu, we execute it, otherwise, we focus our
			//		dropDown node.  If the event is missing, then we are not
			//		a mouseup event.
			//
			//		This is useful for the common mouse movement pattern
			//		with native browser <select> nodes:
			//			1. mouse down on the select node (probably on the arrow)
			//			2. move mouse to a menu item while holding down the mouse button
			//			3. mouse up.  this selects the menu item as though the user had clicked it.
			if(e && this._docHandler){
				this.disconnect(this._docHandler);
			}
			var dropDown = this.dropDown, overMenu = false;

			if(e && this._opened){
				// This code deals with the corner-case when the drop down covers the original widget,
				// because it's so large.  In that case mouse-up shouldn't select a value from the menu.
				// Find out if our target is somewhere in our dropdown widget,
				// but not over our _buttonNode (the clickable node)
				var c = dojo.position(this._buttonNode, true);
				if(!(e.pageX >= c.x && e.pageX <= c.x + c.w) ||
					!(e.pageY >= c.y && e.pageY <= c.y + c.h)){
					var t = e.target;
					while(t && !overMenu){
						if(dojo.hasClass(t, "dijitPopup")){
							overMenu = true;
						}else{
							t = t.parentNode;
						}
					}
					if(overMenu){
						t = e.target;
						if(dropDown.onItemClick){
							var menuItem;
							while(t && !(menuItem = dijit.byNode(t))){
								t = t.parentNode;
							}
							if(menuItem && menuItem.onClick && menuItem.getParent){
								menuItem.getParent().onItemClick(menuItem, e);
							}
						}
						return;
					}
				}
			}
			if(this._opened && dropDown.focus && dropDown.autoFocus !== false){
				// Focus the dropdown widget - do it on a delay so that we
				// don't steal our own focus.
				window.setTimeout(dojo.hitch(dropDown, "focus"), 1);
			}
		},

		_onDropDownClick: function(/*Event*/ e){
			// the drop down was already opened on mousedown/keydown; just need to call stopEvent()
			if(this._stopClickEvents){
				dojo.stopEvent(e);
			}
		},

		buildRendering: function(){
			this.inherited(arguments);

			this._buttonNode = this._buttonNode || this.focusNode || this.domNode;
			this._popupStateNode = this._popupStateNode || this.focusNode || this._buttonNode;

			// Add a class to the "dijitDownArrowButton" type class to _buttonNode so theme can set direction of arrow
			// based on where drop down will normally appear
			var defaultPos = {
					"after" : this.isLeftToRight() ? "Right" : "Left",
					"before" : this.isLeftToRight() ? "Left" : "Right",
					"above" : "Up",
					"below" : "Down",
					"left" : "Left",
					"right" : "Right"
			}[this.dropDownPosition[0]] || this.dropDownPosition[0] || "Down";
			dojo.addClass(this._arrowWrapperNode || this._buttonNode, "dijit" + defaultPos + "ArrowButton");
		},

		postCreate: function(){
			// summary:
			//		set up nodes and connect our mouse and keypress events

			this.inherited(arguments);

			this.connect(this._buttonNode, "onmousedown", "_onDropDownMouseDown");
			this.connect(this._buttonNode, "onclick", "_onDropDownClick");
			this.connect(this.focusNode, "onkeypress", "_onKey");
			this.connect(this.focusNode, "onkeyup", "_onKeyUp");
		},

		destroy: function(){
			if(this.dropDown){
				// Destroy the drop down, unless it's already been destroyed.  This can happen because
				// the drop down is a direct child of <body> even though it's logically my child.
				if(!this.dropDown._destroyed){
					this.dropDown.destroyRecursive();
				}
				delete this.dropDown;
			}
			this.inherited(arguments);
		},

		_onKey: function(/*Event*/ e){
			// summary:
			//		Callback when the user presses a key while focused on the button node

			if(this.disabled || this.readOnly){ return; }

			var d = this.dropDown, target = e.target;
			if(d && this._opened && d.handleKey){
				if(d.handleKey(e) === false){
					/* false return code means that the drop down handled the key */
					dojo.stopEvent(e);
					return;
				}
			}
			if(d && this._opened && e.charOrCode == dojo.keys.ESCAPE){
				this.closeDropDown();
				dojo.stopEvent(e);
			}else if(!this._opened &&
					(e.charOrCode == dojo.keys.DOWN_ARROW ||
						( (e.charOrCode == dojo.keys.ENTER || e.charOrCode == " ") &&
						  //ignore enter and space if the event is for a text input
						  ((target.tagName || "").toLowerCase() !== 'input' ||
						     (target.type && target.type.toLowerCase() !== 'text'))))){
				// Toggle the drop down, but wait until keyup so that the drop down doesn't
				// get a stray keyup event, or in the case of key-repeat (because user held
				// down key for too long), stray keydown events
				this._toggleOnKeyUp = true;
				dojo.stopEvent(e);
			}
		},

		_onKeyUp: function(){
			if(this._toggleOnKeyUp){
				delete this._toggleOnKeyUp;
				this.toggleDropDown();
				var d = this.dropDown;	// drop down may not exist until toggleDropDown() call
				if(d && d.focus){
					setTimeout(dojo.hitch(d, "focus"), 1);
				}
			}
		},

		_onBlur: function(){
			// summary:
			//		Called magically when focus has shifted away from this widget and it's dropdown

			// Don't focus on button if the user has explicitly focused on something else (happens
			// when user clicks another control causing the current popup to close)..
			// But if focus is inside of the drop down then reset focus to me, because IE doesn't like
			// it when you display:none a node with focus.
			var focusMe = dijit._curFocus && this.dropDown && dojo.isDescendant(dijit._curFocus, this.dropDown.domNode);

			this.closeDropDown(focusMe);

			this.inherited(arguments);
		},

		isLoaded: function(){
			// summary:
			//		Returns whether or not the dropdown is loaded.  This can
			//		be overridden in order to force a call to loadDropDown().
			// tags:
			//		protected

			return true;
		},

		loadDropDown: function(/* Function */ loadCallback){
			// summary:
			//		Loads the data for the dropdown, and at some point, calls
			//		the given callback.   This is basically a callback when the
			//		user presses the down arrow button to open the drop down.
			// tags:
			//		protected

			loadCallback();
		},

		toggleDropDown: function(){
			// summary:
			//		Callback when the user presses the down arrow button or presses
			//		the down arrow key to open/close the drop down.
			//		Toggle the drop-down widget; if it is up, close it, if not, open it
			// tags:
			//		protected

			if(this.disabled || this.readOnly){ return; }
			if(!this._opened){
				// If we aren't loaded, load it first so there isn't a flicker
				if(!this.isLoaded()){
					this.loadDropDown(dojo.hitch(this, "openDropDown"));
					return;
				}else{
					this.openDropDown();
				}
			}else{
				this.closeDropDown();
			}
		},

		openDropDown: function(){
			// summary:
			//		Opens the dropdown for this widget.   To be called only when this.dropDown
			//		has been created and is ready to display (ie, it's data is loaded).
			// returns:
			//		return value of dijit.popup.open()
			// tags:
			//		protected

			var dropDown = this.dropDown,
				ddNode = dropDown.domNode,
				aroundNode = this._aroundNode || this.domNode,
				self = this;

			// Prepare our popup's height and honor maxHeight if it exists.

			// TODO: isn't maxHeight dependent on the return value from dijit.popup.open(),
			// ie, dependent on how much space is available (BK)

			if(!this._preparedNode){
				this._preparedNode = true;
				// Check if we have explicitly set width and height on the dropdown widget dom node
				if(ddNode.style.width){
					this._explicitDDWidth = true;
				}
				if(ddNode.style.height){
					this._explicitDDHeight = true;
				}
			}

			// Code for resizing dropdown (height limitation, or increasing width to match my width)
			if(this.maxHeight || this.forceWidth || this.autoWidth){
				var myStyle = {
					display: "",
					visibility: "hidden"
				};
				if(!this._explicitDDWidth){
					myStyle.width = "";
				}
				if(!this._explicitDDHeight){
					myStyle.height = "";
				}
				dojo.style(ddNode, myStyle);
				
				// Figure out maximum height allowed (if there is a height restriction)
				var maxHeight = this.maxHeight;
				if(maxHeight == -1){
					// limit height to space available in viewport either above or below my domNode
					// (whichever side has more room)
					var viewport = dojo.window.getBox(),
						position = dojo.position(aroundNode, false);
					maxHeight = Math.floor(Math.max(position.y, viewport.h - (position.y + position.h)));
				}

				// Attach dropDown to DOM and make make visibility:hidden rather than display:none
				// so we call startup() and also get the size
				if(dropDown.startup && !dropDown._started){
					dropDown.startup();
				}

				dijit.popup.moveOffScreen(dropDown);
				// Get size of drop down, and determine if vertical scroll bar needed
				var mb = dojo._getMarginSize(ddNode);
				var overHeight = (maxHeight && mb.h > maxHeight);
				dojo.style(ddNode, {
					overflowX: "hidden",
					overflowY: overHeight ? "auto" : "hidden"
				});
				if(overHeight){
					mb.h = maxHeight;
					if("w" in mb){
						mb.w += 16;	// room for vertical scrollbar
					}
				}else{
					delete mb.h;
				}

				// Adjust dropdown width to match or be larger than my width
				if(this.forceWidth){
					mb.w = aroundNode.offsetWidth;
				}else if(this.autoWidth){
					mb.w = Math.max(mb.w, aroundNode.offsetWidth);
				}else{
					delete mb.w;
				}
				
				// And finally, resize the dropdown to calculated height and width
				if(dojo.isFunction(dropDown.resize)){
					dropDown.resize(mb);
				}else{
					dojo.marginBox(ddNode, mb);
				}
			}

			var retVal = dijit.popup.open({
				parent: this,
				popup: dropDown,
				around: aroundNode,
				orient: dijit.getPopupAroundAlignment((this.dropDownPosition && this.dropDownPosition.length) ? this.dropDownPosition : ["below"],this.isLeftToRight()),
				onExecute: function(){
					self.closeDropDown(true);
				},
				onCancel: function(){
					self.closeDropDown(true);
				},
				onClose: function(){
					dojo.attr(self._popupStateNode, "popupActive", false);
					dojo.removeClass(self._popupStateNode, "dijitHasDropDownOpen");
					self._opened = false;
				}
			});
			dojo.attr(this._popupStateNode, "popupActive", "true");
			dojo.addClass(self._popupStateNode, "dijitHasDropDownOpen");
			this._opened=true;

			// TODO: set this.checked and call setStateClass(), to affect button look while drop down is shown
			return retVal;
		},

		closeDropDown: function(/*Boolean*/ focus){
			// summary:
			//		Closes the drop down on this widget
			// focus:
			//		If true, refocuses the button widget
			// tags:
			//		protected

			if(this._opened){
				if(focus){ this.focus(); }
				dijit.popup.close(this.dropDown);
				this._opened = false;
			}
		}

	}
);

}

if(!dojo._hasResource["dijit.form.Button"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.Button"] = true;
dojo.provide("dijit.form.Button");





dojo.declare("dijit.form.Button",
	dijit.form._FormWidget,
	{
	// summary:
	//		Basically the same thing as a normal HTML button, but with special styling.
	// description:
	//		Buttons can display a label, an icon, or both.
	//		A label should always be specified (through innerHTML) or the label
	//		attribute.  It can be hidden via showLabel=false.
	// example:
	// |	<button dojoType="dijit.form.Button" onClick="...">Hello world</button>
	//
	// example:
	// |	var button1 = new dijit.form.Button({label: "hello world", onClick: foo});
	// |	dojo.body().appendChild(button1.domNode);

	// label: HTML String
	//		Text to display in button.
	//		If the label is hidden (showLabel=false) then and no title has
	//		been specified, then label is also set as title attribute of icon.
	label: "",

	// showLabel: Boolean
	//		Set this to true to hide the label text and display only the icon.
	//		(If showLabel=false then iconClass must be specified.)
	//		Especially useful for toolbars.
	//		If showLabel=true, the label will become the title (a.k.a. tooltip/hint) of the icon.
	//
	//		The exception case is for computers in high-contrast mode, where the label
	//		will still be displayed, since the icon doesn't appear.
	showLabel: true,

	// iconClass: String
	//		Class to apply to DOMNode in button to make it display an icon
	iconClass: "",

	// type: String
	//		Defines the type of button.  "button", "submit", or "reset".
	type: "button",

	baseClass: "dijitButton",

	templateString: dojo.cache("dijit.form", "templates/Button.html", "<span class=\"dijit dijitReset dijitInline\"\n\t><span class=\"dijitReset dijitInline dijitButtonNode\"\n\t\tdojoAttachEvent=\"ondijitclick:_onButtonClick\"\n\t\t><span class=\"dijitReset dijitStretch dijitButtonContents\"\n\t\t\tdojoAttachPoint=\"titleNode,focusNode\"\n\t\t\trole=\"button\" aria-labelledby=\"${id}_label\"\n\t\t\t><span class=\"dijitReset dijitInline dijitIcon\" dojoAttachPoint=\"iconNode\"></span\n\t\t\t><span class=\"dijitReset dijitToggleButtonIconChar\">&#x25CF;</span\n\t\t\t><span class=\"dijitReset dijitInline dijitButtonText\"\n\t\t\t\tid=\"${id}_label\"\n\t\t\t\tdojoAttachPoint=\"containerNode\"\n\t\t\t></span\n\t\t></span\n\t></span\n\t><input ${!nameAttrSetting} type=\"${type}\" value=\"${value}\" class=\"dijitOffScreen\" tabIndex=\"-1\"\n\t\tdojoAttachPoint=\"valueNode\"\n/></span>\n"),

	attributeMap: dojo.delegate(dijit.form._FormWidget.prototype.attributeMap, {
		value: "valueNode"
	}),

	_onClick: function(/*Event*/ e){
		// summary:
		//		Internal function to handle click actions
		if(this.disabled){
			return false;
		}
		this._clicked(); // widget click actions
		return this.onClick(e); // user click actions
	},

	_onButtonClick: function(/*Event*/ e){
		// summary:
		//		Handler when the user activates the button portion.
		if(this._onClick(e) === false){ // returning nothing is same as true
			e.preventDefault(); // needed for checkbox
		}else if(this.type == "submit" && !(this.valueNode||this.focusNode).form){ // see if a nonform widget needs to be signalled
			for(var node=this.domNode; node.parentNode/*#5935*/; node=node.parentNode){
				var widget=dijit.byNode(node);
				if(widget && typeof widget._onSubmit == "function"){
					widget._onSubmit(e);
					break;
				}
			}
		}else if(this.valueNode){
			this.valueNode.click();
			e.preventDefault(); // cancel BUTTON click and continue with hidden INPUT click
		}
	},

	buildRendering: function(){
		this.inherited(arguments);
		dojo.setSelectable(this.focusNode, false);
	},

	_fillContent: function(/*DomNode*/ source){
		// Overrides _Templated._fillContent().
		// If button label is specified as srcNodeRef.innerHTML rather than
		// this.params.label, handle it here.
		// TODO: remove the method in 2.0, parser will do it all for me
		if(source && (!this.params || !("label" in this.params))){
			this.set('label', source.innerHTML);
		}
	},

	_setShowLabelAttr: function(val){
		if(this.containerNode){
			dojo.toggleClass(this.containerNode, "dijitDisplayNone", !val);
		}
		this._set("showLabel", val);
	},

	onClick: function(/*Event*/ e){
		// summary:
		//		Callback for when button is clicked.
		//		If type="submit", return true to perform submit, or false to cancel it.
		// type:
		//		callback
		return true;		// Boolean
	},

	_clicked: function(/*Event*/ e){
		// summary:
		//		Internal overridable function for when the button is clicked
	},

	setLabel: function(/*String*/ content){
		// summary:
		//		Deprecated.  Use set('label', ...) instead.
		dojo.deprecated("dijit.form.Button.setLabel() is deprecated.  Use set('label', ...) instead.", "", "2.0");
		this.set("label", content);
	},

	_setLabelAttr: function(/*String*/ content){
		// summary:
		//		Hook for set('label', ...) to work.
		// description:
		//		Set the label (text) of the button; takes an HTML string.
		this._set("label", content);
		this.containerNode.innerHTML = content;
		if(this.showLabel == false && !this.params.title){
			this.titleNode.title = dojo.trim(this.containerNode.innerText || this.containerNode.textContent || '');
		}
	},

	_setIconClassAttr: function(/*String*/ val){
		// Custom method so that icon node is hidden when not in use, to avoid excess padding/margin
		// appearing around it (even if it's a 0x0 sized <img> node)

		var oldVal = this.iconClass || "dijitNoIcon",
			newVal = val || "dijitNoIcon";
		dojo.replaceClass(this.iconNode, newVal, oldVal);
		this._set("iconClass", val);
	}
});


dojo.declare("dijit.form.DropDownButton", [dijit.form.Button, dijit._Container, dijit._HasDropDown], {
	// summary:
	//		A button with a drop down
	//
	// example:
	// |	<button dojoType="dijit.form.DropDownButton" label="Hello world">
	// |		<div dojotype="dijit.Menu">...</div>
	// |	</button>
	//
	// example:
	// |	var button1 = new dijit.form.DropDownButton({ label: "hi", dropDown: new dijit.Menu(...) });
	// |	dojo.body().appendChild(button1);
	//

	baseClass : "dijitDropDownButton",

	templateString: dojo.cache("dijit.form", "templates/DropDownButton.html", "<span class=\"dijit dijitReset dijitInline\"\n\t><span class='dijitReset dijitInline dijitButtonNode'\n\t\tdojoAttachEvent=\"ondijitclick:_onButtonClick\" dojoAttachPoint=\"_buttonNode\"\n\t\t><span class=\"dijitReset dijitStretch dijitButtonContents\"\n\t\t\tdojoAttachPoint=\"focusNode,titleNode,_arrowWrapperNode\"\n\t\t\trole=\"button\" aria-haspopup=\"true\" aria-labelledby=\"${id}_label\"\n\t\t\t><span class=\"dijitReset dijitInline dijitIcon\"\n\t\t\t\tdojoAttachPoint=\"iconNode\"\n\t\t\t></span\n\t\t\t><span class=\"dijitReset dijitInline dijitButtonText\"\n\t\t\t\tdojoAttachPoint=\"containerNode,_popupStateNode\"\n\t\t\t\tid=\"${id}_label\"\n\t\t\t></span\n\t\t\t><span class=\"dijitReset dijitInline dijitArrowButtonInner\"></span\n\t\t\t><span class=\"dijitReset dijitInline dijitArrowButtonChar\">&#9660;</span\n\t\t></span\n\t></span\n\t><input ${!nameAttrSetting} type=\"${type}\" value=\"${value}\" class=\"dijitOffScreen\" tabIndex=\"-1\"\n\t\tdojoAttachPoint=\"valueNode\"\n/></span>\n"),

	_fillContent: function(){
		// Overrides Button._fillContent().
		//
		// My inner HTML contains both the button contents and a drop down widget, like
		// <DropDownButton>  <span>push me</span>  <Menu> ... </Menu> </DropDownButton>
		// The first node is assumed to be the button content. The widget is the popup.

		if(this.srcNodeRef){ // programatically created buttons might not define srcNodeRef
			//FIXME: figure out how to filter out the widget and use all remaining nodes as button
			//	content, not just nodes[0]
			var nodes = dojo.query("*", this.srcNodeRef);
			dijit.form.DropDownButton.superclass._fillContent.call(this, nodes[0]);

			// save pointer to srcNode so we can grab the drop down widget after it's instantiated
			this.dropDownContainer = this.srcNodeRef;
		}
	},

	startup: function(){
		if(this._started){ return; }

		// the child widget from srcNodeRef is the dropdown widget.  Insert it in the page DOM,
		// make it invisible, and store a reference to pass to the popup code.
		if(!this.dropDown && this.dropDownContainer){
			var dropDownNode = dojo.query("[widgetId]", this.dropDownContainer)[0];
			this.dropDown = dijit.byNode(dropDownNode);
			delete this.dropDownContainer;
		}
		if(this.dropDown){
			dijit.popup.hide(this.dropDown);
		}

		this.inherited(arguments);
	},

	isLoaded: function(){
		// Returns whether or not we are loaded - if our dropdown has an href,
		// then we want to check that.
		var dropDown = this.dropDown;
		return (!!dropDown && (!dropDown.href || dropDown.isLoaded));
	},

	loadDropDown: function(){
		// Loads our dropdown
		var dropDown = this.dropDown;
		if(!dropDown){ return; }
		if(!this.isLoaded()){
			var handler = dojo.connect(dropDown, "onLoad", this, function(){
				dojo.disconnect(handler);
				this.openDropDown();
			});
			dropDown.refresh();
		}else{
			this.openDropDown();
		}
	},

	isFocusable: function(){
		// Overridden so that focus is handled by the _HasDropDown mixin, not by
		// the _FormWidget mixin.
		return this.inherited(arguments) && !this._mouseDown;
	}
});

dojo.declare("dijit.form.ComboButton", dijit.form.DropDownButton, {
	// summary:
	//		A combination button and drop-down button.
	//		Users can click one side to "press" the button, or click an arrow
	//		icon to display the drop down.
	//
	// example:
	// |	<button dojoType="dijit.form.ComboButton" onClick="...">
	// |		<span>Hello world</span>
	// |		<div dojoType="dijit.Menu">...</div>
	// |	</button>
	//
	// example:
	// |	var button1 = new dijit.form.ComboButton({label: "hello world", onClick: foo, dropDown: "myMenu"});
	// |	dojo.body().appendChild(button1.domNode);
	//

	templateString: dojo.cache("dijit.form", "templates/ComboButton.html", "<table class=\"dijit dijitReset dijitInline dijitLeft\"\n\tcellspacing='0' cellpadding='0' role=\"presentation\"\n\t><tbody role=\"presentation\"><tr role=\"presentation\"\n\t\t><td class=\"dijitReset dijitStretch dijitButtonNode\" dojoAttachPoint=\"buttonNode\" dojoAttachEvent=\"ondijitclick:_onButtonClick,onkeypress:_onButtonKeyPress\"\n\t\t><div id=\"${id}_button\" class=\"dijitReset dijitButtonContents\"\n\t\t\tdojoAttachPoint=\"titleNode\"\n\t\t\trole=\"button\" aria-labelledby=\"${id}_label\"\n\t\t\t><div class=\"dijitReset dijitInline dijitIcon\" dojoAttachPoint=\"iconNode\" role=\"presentation\"></div\n\t\t\t><div class=\"dijitReset dijitInline dijitButtonText\" id=\"${id}_label\" dojoAttachPoint=\"containerNode\" role=\"presentation\"></div\n\t\t></div\n\t\t></td\n\t\t><td id=\"${id}_arrow\" class='dijitReset dijitRight dijitButtonNode dijitArrowButton'\n\t\t\tdojoAttachPoint=\"_popupStateNode,focusNode,_buttonNode\"\n\t\t\tdojoAttachEvent=\"onkeypress:_onArrowKeyPress\"\n\t\t\ttitle=\"${optionsTitle}\"\n\t\t\trole=\"button\" aria-haspopup=\"true\"\n\t\t\t><div class=\"dijitReset dijitArrowButtonInner\" role=\"presentation\"></div\n\t\t\t><div class=\"dijitReset dijitArrowButtonChar\" role=\"presentation\">&#9660;</div\n\t\t></td\n\t\t><td style=\"display:none !important;\"\n\t\t\t><input ${!nameAttrSetting} type=\"${type}\" value=\"${value}\" dojoAttachPoint=\"valueNode\"\n\t\t/></td></tr></tbody\n></table>\n"),

	attributeMap: dojo.mixin(dojo.clone(dijit.form.Button.prototype.attributeMap), {
		id: "",
		tabIndex: ["focusNode", "titleNode"],
		title: "titleNode"
	}),

	// optionsTitle: String
	//		Text that describes the options menu (accessibility)
	optionsTitle: "",

	baseClass: "dijitComboButton",

	// Set classes like dijitButtonContentsHover or dijitArrowButtonActive depending on
	// mouse action over specified node
	cssStateNodes: {
		"buttonNode": "dijitButtonNode",
		"titleNode": "dijitButtonContents",
		"_popupStateNode": "dijitDownArrowButton"
	},

	_focusedNode: null,

	_onButtonKeyPress: function(/*Event*/ evt){
		// summary:
		//		Handler for right arrow key when focus is on left part of button
		if(evt.charOrCode == dojo.keys[this.isLeftToRight() ? "RIGHT_ARROW" : "LEFT_ARROW"]){
			dijit.focus(this._popupStateNode);
			dojo.stopEvent(evt);
		}
	},

	_onArrowKeyPress: function(/*Event*/ evt){
		// summary:
		//		Handler for left arrow key when focus is on right part of button
		if(evt.charOrCode == dojo.keys[this.isLeftToRight() ? "LEFT_ARROW" : "RIGHT_ARROW"]){
			dijit.focus(this.titleNode);
			dojo.stopEvent(evt);
		}
	},
	
	focus: function(/*String*/ position){
		// summary:
		//		Focuses this widget to according to position, if specified,
		//		otherwise on arrow node
		// position:
		//		"start" or "end"
		if(!this.disabled){
			dijit.focus(position == "start" ? this.titleNode : this._popupStateNode);
		}
	}
});

dojo.declare("dijit.form.ToggleButton", dijit.form.Button, {
	// summary:
	//		A button that can be in two states (checked or not).
	//		Can be base class for things like tabs or checkbox or radio buttons

	baseClass: "dijitToggleButton",

	// checked: Boolean
	//		Corresponds to the native HTML <input> element's attribute.
	//		In markup, specified as "checked='checked'" or just "checked".
	//		True if the button is depressed, or the checkbox is checked,
	//		or the radio button is selected, etc.
	checked: false,

	attributeMap: dojo.mixin(dojo.clone(dijit.form.Button.prototype.attributeMap), {
		checked:"focusNode"
	}),

	_clicked: function(/*Event*/ evt){
		this.set('checked', !this.checked);
	},

	_setCheckedAttr: function(/*Boolean*/ value, /*Boolean?*/ priorityChange){
		this._set("checked", value);
		dojo.attr(this.focusNode || this.domNode, "checked", value);
		dijit.setWaiState(this.focusNode || this.domNode, "pressed", value);
		this._handleOnChange(value, priorityChange);
	},

	setChecked: function(/*Boolean*/ checked){
		// summary:
		//		Deprecated.  Use set('checked', true/false) instead.
		dojo.deprecated("setChecked("+checked+") is deprecated. Use set('checked',"+checked+") instead.", "", "2.0");
		this.set('checked', checked);
	},

	reset: function(){
		// summary:
		//		Reset the widget's value to what it was at initialization time

		this._hasBeenBlurred = false;

		// set checked state to original setting
		this.set('checked', this.params.checked || false);
	}
});

}

if(!dojo._hasResource["dijit.form.ToggleButton"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.ToggleButton"] = true;
dojo.provide("dijit.form.ToggleButton");




}

if(!dojo._hasResource["dijit.layout.StackController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.StackController"] = true;
dojo.provide("dijit.layout.StackController");







dojo.declare(
		"dijit.layout.StackController",
		[dijit._Widget, dijit._Templated, dijit._Container],
		{
			// summary:
			//		Set of buttons to select a page in a page list.
			// description:
			//		Monitors the specified StackContainer, and whenever a page is
			//		added, deleted, or selected, updates itself accordingly.

			templateString: "<span role='tablist' dojoAttachEvent='onkeypress' class='dijitStackController'></span>",

			// containerId: [const] String
			//		The id of the page container that I point to
			containerId: "",

			// buttonWidget: [const] String
			//		The name of the button widget to create to correspond to each page
			buttonWidget: "dijit.layout._StackButton",

			constructor: function(){
				this.pane2button = {};		// mapping from pane id to buttons
				this.pane2connects = {};	// mapping from pane id to this.connect() handles
				this.pane2watches = {};		// mapping from pane id to watch() handles
			},

			buildRendering: function(){
				this.inherited(arguments);
				dijit.setWaiRole(this.domNode, "tablist");	// TODO: unneeded?   it's in template above.
			},

			postCreate: function(){
				this.inherited(arguments);

				// Listen to notifications from StackContainer
				this.subscribe(this.containerId+"-startup", "onStartup");
				this.subscribe(this.containerId+"-addChild", "onAddChild");
				this.subscribe(this.containerId+"-removeChild", "onRemoveChild");
				this.subscribe(this.containerId+"-selectChild", "onSelectChild");
				this.subscribe(this.containerId+"-containerKeyPress", "onContainerKeyPress");
			},

			onStartup: function(/*Object*/ info){
				// summary:
				//		Called after StackContainer has finished initializing
				// tags:
				//		private
				dojo.forEach(info.children, this.onAddChild, this);
				if(info.selected){
					// Show button corresponding to selected pane (unless selected
					// is null because there are no panes)
					this.onSelectChild(info.selected);
				}
			},

			destroy: function(){
				for(var pane in this.pane2button){
					this.onRemoveChild(dijit.byId(pane));
				}
				this.inherited(arguments);
			},

			onAddChild: function(/*dijit._Widget*/ page, /*Integer?*/ insertIndex){
				// summary:
				//		Called whenever a page is added to the container.
				//		Create button corresponding to the page.
				// tags:
				//		private

				// create an instance of the button widget
				var cls = dojo.getObject(this.buttonWidget);
				var button = new cls({
					id: this.id + "_" + page.id,
					label: page.title,
					dir: page.dir,
					lang: page.lang,
					showLabel: page.showTitle,
					iconClass: page.iconClass,
					closeButton: page.closable,
					title: page.tooltip
				});
				dijit.setWaiState(button.focusNode,"selected", "false");


				// map from page attribute to corresponding tab button attribute
				var pageAttrList = ["title", "showTitle", "iconClass", "closable", "tooltip"],
					buttonAttrList = ["label", "showLabel", "iconClass", "closeButton", "title"];

				// watch() so events like page title changes are reflected in tab button
				this.pane2watches[page.id] = dojo.map(pageAttrList, function(pageAttr, idx){
					return page.watch(pageAttr, function(name, oldVal, newVal){
						button.set(buttonAttrList[idx], newVal);
					});
				});
					
				// connections so that clicking a tab button selects the corresponding page
				this.pane2connects[page.id] = [
					this.connect(button, 'onClick', dojo.hitch(this,"onButtonClick", page)),
					this.connect(button, 'onClickCloseButton', dojo.hitch(this,"onCloseButtonClick", page))
				];

				this.addChild(button, insertIndex);
				this.pane2button[page.id] = button;
				page.controlButton = button;	// this value might be overwritten if two tabs point to same container
				if(!this._currentChild){ // put the first child into the tab order
					button.focusNode.setAttribute("tabIndex", "0");
					dijit.setWaiState(button.focusNode, "selected", "true");
					this._currentChild = page;
				}
				// make sure all tabs have the same length
				if(!this.isLeftToRight() && dojo.isIE && this._rectifyRtlTabList){
					this._rectifyRtlTabList();
				}
			},

			onRemoveChild: function(/*dijit._Widget*/ page){
				// summary:
				//		Called whenever a page is removed from the container.
				//		Remove the button corresponding to the page.
				// tags:
				//		private

				if(this._currentChild === page){ this._currentChild = null; }

				// disconnect/unwatch connections/watches related to page being removed
				dojo.forEach(this.pane2connects[page.id], dojo.hitch(this, "disconnect"));
				delete this.pane2connects[page.id];
				dojo.forEach(this.pane2watches[page.id], function(w){ w.unwatch(); });
				delete this.pane2watches[page.id];

				var button = this.pane2button[page.id];
				if(button){
					this.removeChild(button);
					delete this.pane2button[page.id];
					button.destroy();
				}
				delete page.controlButton;
			},

			onSelectChild: function(/*dijit._Widget*/ page){
				// summary:
				//		Called when a page has been selected in the StackContainer, either by me or by another StackController
				// tags:
				//		private

				if(!page){ return; }

				if(this._currentChild){
					var oldButton=this.pane2button[this._currentChild.id];
					oldButton.set('checked', false);
					dijit.setWaiState(oldButton.focusNode, "selected", "false");
					oldButton.focusNode.setAttribute("tabIndex", "-1");
				}

				var newButton=this.pane2button[page.id];
				newButton.set('checked', true);
				dijit.setWaiState(newButton.focusNode, "selected", "true");
				this._currentChild = page;
				newButton.focusNode.setAttribute("tabIndex", "0");
				var container = dijit.byId(this.containerId);
				dijit.setWaiState(container.containerNode, "labelledby", newButton.id);
			},

			onButtonClick: function(/*dijit._Widget*/ page){
				// summary:
				//		Called whenever one of my child buttons is pressed in an attempt to select a page
				// tags:
				//		private

				var container = dijit.byId(this.containerId);
				container.selectChild(page);
			},

			onCloseButtonClick: function(/*dijit._Widget*/ page){
				// summary:
				//		Called whenever one of my child buttons [X] is pressed in an attempt to close a page
				// tags:
				//		private

				var container = dijit.byId(this.containerId);
				container.closeChild(page);
				if(this._currentChild){
					var b = this.pane2button[this._currentChild.id];
					if(b){
						dijit.focus(b.focusNode || b.domNode);
					}
				}
			},

			// TODO: this is a bit redundant with forward, back api in StackContainer
			adjacent: function(/*Boolean*/ forward){
				// summary:
				//		Helper for onkeypress to find next/previous button
				// tags:
				//		private

				if(!this.isLeftToRight() && (!this.tabPosition || /top|bottom/.test(this.tabPosition))){ forward = !forward; }
				// find currently focused button in children array
				var children = this.getChildren();
				var current = dojo.indexOf(children, this.pane2button[this._currentChild.id]);
				// pick next button to focus on
				var offset = forward ? 1 : children.length - 1;
				return children[ (current + offset) % children.length ]; // dijit._Widget
			},

			onkeypress: function(/*Event*/ e){
				// summary:
				//		Handle keystrokes on the page list, for advancing to next/previous button
				//		and closing the current page if the page is closable.
				// tags:
				//		private

				if(this.disabled || e.altKey ){ return; }
				var forward = null;
				if(e.ctrlKey || !e._djpage){
					var k = dojo.keys;
					switch(e.charOrCode){
						case k.LEFT_ARROW:
						case k.UP_ARROW:
							if(!e._djpage){ forward = false; }
							break;
						case k.PAGE_UP:
							if(e.ctrlKey){ forward = false; }
							break;
						case k.RIGHT_ARROW:
						case k.DOWN_ARROW:
							if(!e._djpage){ forward = true; }
							break;
						case k.PAGE_DOWN:
							if(e.ctrlKey){ forward = true; }
							break;
						case k.HOME:
						case k.END:
							var children = this.getChildren();
							if(children && children.length){
								children[e.charOrCode == k.HOME ? 0 : children.length-1].onClick();
							}
							dojo.stopEvent(e);
							break;
						case k.DELETE:
							if(this._currentChild.closable){
								this.onCloseButtonClick(this._currentChild);
							}
							dojo.stopEvent(e);
							break;
						default:
							if(e.ctrlKey){
								if(e.charOrCode === k.TAB){
									this.adjacent(!e.shiftKey).onClick();
									dojo.stopEvent(e);
								}else if(e.charOrCode == "w"){
									if(this._currentChild.closable){
										this.onCloseButtonClick(this._currentChild);
									}
									dojo.stopEvent(e); // avoid browser tab closing.
								}
							}
					}
					// handle next/previous page navigation (left/right arrow, etc.)
					if(forward !== null){
						this.adjacent(forward).onClick();
						dojo.stopEvent(e);
					}
				}
			},

			onContainerKeyPress: function(/*Object*/ info){
				// summary:
				//		Called when there was a keypress on the container
				// tags:
				//		private
				info.e._djpage = info.page;
				this.onkeypress(info.e);
			}
	});


dojo.declare("dijit.layout._StackButton",
		dijit.form.ToggleButton,
		{
		// summary:
		//		Internal widget used by StackContainer.
		// description:
		//		The button-like or tab-like object you click to select or delete a page
		// tags:
		//		private

		// Override _FormWidget.tabIndex.
		// StackContainer buttons are not in the tab order by default.
		// Probably we should be calling this.startupKeyNavChildren() instead.
		tabIndex: "-1",

		buildRendering: function(/*Event*/ evt){
			this.inherited(arguments);
			dijit.setWaiRole((this.focusNode || this.domNode), "tab");
		},

		onClick: function(/*Event*/ evt){
			// summary:
			//		This is for TabContainer where the tabs are <span> rather than button,
			//		so need to set focus explicitly (on some browsers)
			//		Note that you shouldn't override this method, but you can connect to it.
			dijit.focus(this.focusNode);

			// ... now let StackController catch the event and tell me what to do
		},

		onClickCloseButton: function(/*Event*/ evt){
			// summary:
			//		StackContainer connects to this function; if your widget contains a close button
			//		then clicking it should call this function.
			//		Note that you shouldn't override this method, but you can connect to it.
			evt.stopPropagation();
		}
	});

}

if(!dojo._hasResource["dijit.layout.StackContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.StackContainer"] = true;
dojo.provide("dijit.layout.StackContainer");







dojo.declare(
	"dijit.layout.StackContainer",
	dijit.layout._LayoutWidget,
	{
	// summary:
	//		A container that has multiple children, but shows only
	//		one child at a time
	//
	// description:
	//		A container for widgets (ContentPanes, for example) That displays
	//		only one Widget at a time.
	//
	//		Publishes topics [widgetId]-addChild, [widgetId]-removeChild, and [widgetId]-selectChild
	//
	//		Can be base class for container, Wizard, Show, etc.

	// doLayout: Boolean
	//		If true, change the size of my currently displayed child to match my size
	doLayout: true,

	// persist: Boolean
	//		Remembers the selected child across sessions
	persist: false,

	baseClass: "dijitStackContainer",

/*=====
	// selectedChildWidget: [readonly] dijit._Widget
	//		References the currently selected child widget, if any.
	//		Adjust selected child with selectChild() method.
	selectedChildWidget: null,
=====*/

	buildRendering: function(){
		this.inherited(arguments);
		dojo.addClass(this.domNode, "dijitLayoutContainer");
		dijit.setWaiRole(this.containerNode, "tabpanel");
	},

	postCreate: function(){
		this.inherited(arguments);
		this.connect(this.domNode, "onkeypress", this._onKeyPress);
	},

	startup: function(){
		if(this._started){ return; }

		var children = this.getChildren();

		// Setup each page panel to be initially hidden
		dojo.forEach(children, this._setupChild, this);

		// Figure out which child to initially display, defaulting to first one
		if(this.persist){
			this.selectedChildWidget = dijit.byId(dojo.cookie(this.id + "_selectedChild"));
		}else{
			dojo.some(children, function(child){
				if(child.selected){
					this.selectedChildWidget = child;
				}
				return child.selected;
			}, this);
		}
		var selected = this.selectedChildWidget;
		if(!selected && children[0]){
			selected = this.selectedChildWidget = children[0];
			selected.selected = true;
		}

		// Publish information about myself so any StackControllers can initialize.
		// This needs to happen before this.inherited(arguments) so that for
		// TabContainer, this._contentBox doesn't include the space for the tab labels.
		dojo.publish(this.id+"-startup", [{children: children, selected: selected}]);

		// Startup each child widget, and do initial layout like setting this._contentBox,
		// then calls this.resize() which does the initial sizing on the selected child.
		this.inherited(arguments);
	},

	resize: function(){
		// Resize is called when we are first made visible (it's called from startup()
		// if we are initially visible).   If this is the first time we've been made
		// visible then show our first child.
		if(!this._hasBeenShown){
			this._hasBeenShown = true;
			var selected = this.selectedChildWidget;
			if(selected){
				this._showChild(selected);
			}
		}
		this.inherited(arguments);
	},

	_setupChild: function(/*dijit._Widget*/ child){
		// Overrides _LayoutWidget._setupChild()

		this.inherited(arguments);

		dojo.replaceClass(child.domNode, "dijitHidden", "dijitVisible");

		// remove the title attribute so it doesn't show up when i hover
		// over a node
		child.domNode.title = "";
	},

	addChild: function(/*dijit._Widget*/ child, /*Integer?*/ insertIndex){
		// Overrides _Container.addChild() to do layout and publish events

		this.inherited(arguments);

		if(this._started){
			dojo.publish(this.id+"-addChild", [child, insertIndex]);

			// in case the tab titles have overflowed from one line to two lines
			// (or, if this if first child, from zero lines to one line)
			// TODO: w/ScrollingTabController this is no longer necessary, although
			// ScrollTabController.resize() does need to get called to show/hide
			// the navigation buttons as appropriate, but that's handled in ScrollingTabController.onAddChild()
			this.layout();

			// if this is the first child, then select it
			if(!this.selectedChildWidget){
				this.selectChild(child);
			}
		}
	},

	removeChild: function(/*dijit._Widget*/ page){
		// Overrides _Container.removeChild() to do layout and publish events

		this.inherited(arguments);

		if(this._started){
			// this will notify any tablists to remove a button; do this first because it may affect sizing
			dojo.publish(this.id + "-removeChild", [page]);
		}

		// If we are being destroyed than don't run the code below (to select another page), because we are deleting
		// every page one by one
		if(this._beingDestroyed){ return; }

		// Select new page to display, also updating TabController to show the respective tab.
		// Do this before layout call because it can affect the height of the TabController.
		if(this.selectedChildWidget === page){
			this.selectedChildWidget = undefined;
			if(this._started){
				var children = this.getChildren();
				if(children.length){
					this.selectChild(children[0]);
				}
			}
		}

		if(this._started){
			// In case the tab titles now take up one line instead of two lines
			// (note though that ScrollingTabController never overflows to multiple lines),
			// or the height has changed slightly because of addition/removal of tab which close icon
			this.layout();
		}
	},

	selectChild: function(/*dijit._Widget|String*/ page, /*Boolean*/ animate){
		// summary:
		//		Show the given widget (which must be one of my children)
		// page:
		//		Reference to child widget or id of child widget

		page = dijit.byId(page);

		if(this.selectedChildWidget != page){
			// Deselect old page and select new one
			var d = this._transition(page, this.selectedChildWidget, animate);
			this._set("selectedChildWidget", page);
			dojo.publish(this.id+"-selectChild", [page]);

			if(this.persist){
				dojo.cookie(this.id + "_selectedChild", this.selectedChildWidget.id);
			}
		}

		return d;		// If child has an href, promise that fires when the child's href finishes loading
	},

	_transition: function(/*dijit._Widget*/ newWidget, /*dijit._Widget*/ oldWidget, /*Boolean*/ animate){
		// summary:
		//		Hide the old widget and display the new widget.
		//		Subclasses should override this.
		// tags:
		//		protected extension
		if(oldWidget){
			this._hideChild(oldWidget);
		}
		var d = this._showChild(newWidget);

		// Size the new widget, in case this is the first time it's being shown,
		// or I have been resized since the last time it was shown.
		// Note that page must be visible for resizing to work.
		if(newWidget.resize){
			if(this.doLayout){
				newWidget.resize(this._containerContentBox || this._contentBox);
			}else{
				// the child should pick it's own size but we still need to call resize()
				// (with no arguments) to let the widget lay itself out
				newWidget.resize();
			}
		}

		return d;	// If child has an href, promise that fires when the child's href finishes loading
	},

	_adjacent: function(/*Boolean*/ forward){
		// summary:
		//		Gets the next/previous child widget in this container from the current selection.
		var children = this.getChildren();
		var index = dojo.indexOf(children, this.selectedChildWidget);
		index += forward ? 1 : children.length - 1;
		return children[ index % children.length ]; // dijit._Widget
	},

	forward: function(){
		// summary:
		//		Advance to next page.
		return this.selectChild(this._adjacent(true), true);
	},

	back: function(){
		// summary:
		//		Go back to previous page.
		return this.selectChild(this._adjacent(false), true);
	},

	_onKeyPress: function(e){
		dojo.publish(this.id+"-containerKeyPress", [{ e: e, page: this}]);
	},

	layout: function(){
		// Implement _LayoutWidget.layout() virtual method.
		if(this.doLayout && this.selectedChildWidget && this.selectedChildWidget.resize){
			this.selectedChildWidget.resize(this._containerContentBox || this._contentBox);
		}
	},

	_showChild: function(/*dijit._Widget*/ page){
		// summary:
		//		Show the specified child by changing it's CSS, and call _onShow()/onShow() so
		//		it can do any updates it needs regarding loading href's etc.
		// returns:
		//		Promise that fires when page has finished showing, or true if there's no href
		var children = this.getChildren();
		page.isFirstChild = (page == children[0]);
		page.isLastChild = (page == children[children.length-1]);
		page._set("selected", true);

		dojo.replaceClass(page.domNode, "dijitVisible", "dijitHidden");

		return page._onShow() || true;
	},

	_hideChild: function(/*dijit._Widget*/ page){
		// summary:
		//		Hide the specified child by changing it's CSS, and call _onHide() so
		//		it's notified.
		page._set("selected", false);
		dojo.replaceClass(page.domNode, "dijitHidden", "dijitVisible");

		page.onHide();
	},

	closeChild: function(/*dijit._Widget*/ page){
		// summary:
		//		Callback when user clicks the [X] to remove a page.
		//		If onClose() returns true then remove and destroy the child.
		// tags:
		//		private
		var remove = page.onClose(this, page);
		if(remove){
			this.removeChild(page);
			// makes sure we can clean up executeScripts in ContentPane onUnLoad
			page.destroyRecursive();
		}
	},

	destroyDescendants: function(/*Boolean*/ preserveDom){
		dojo.forEach(this.getChildren(), function(child){
			this.removeChild(child);
			child.destroyRecursive(preserveDom);
		}, this);
	}
});

// For back-compat, remove for 2.0


// These arguments can be specified for the children of a StackContainer.
// Since any widget can be specified as a StackContainer child, mix them
// into the base widget class.  (This is a hack, but it's effective.)
dojo.extend(dijit._Widget, {
	// selected: Boolean
	//		Parameter for children of `dijit.layout.StackContainer` or subclasses.
	//		Specifies that this widget should be the initially displayed pane.
	//		Note: to change the selected child use `dijit.layout.StackContainer.selectChild`
	selected: false,

	// closable: Boolean
	//		Parameter for children of `dijit.layout.StackContainer` or subclasses.
	//		True if user can close (destroy) this child, such as (for example) clicking the X on the tab.
	closable: false,

	// iconClass: String
	//		Parameter for children of `dijit.layout.StackContainer` or subclasses.
	//		CSS Class specifying icon to use in label associated with this pane.
	iconClass: "",

	// showTitle: Boolean
	//		Parameter for children of `dijit.layout.StackContainer` or subclasses.
	//		When true, display title of this widget as tab label etc., rather than just using
	//		icon specified in iconClass
	showTitle: true
});

}

if(!dojo._hasResource["dijit.layout._ContentPaneResizeMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout._ContentPaneResizeMixin"] = true;
dojo.provide("dijit.layout._ContentPaneResizeMixin");




dojo.declare("dijit.layout._ContentPaneResizeMixin", null, {
	// summary:
	//		Resize() functionality of ContentPane.   If there's a single layout widget
	//		child then it will call resize() with the same dimensions as the ContentPane.
	//		Otherwise just calls resize on each child.
	//
	//		Also implements basic startup() functionality, where starting the parent
	//		will start the children

	// doLayout: Boolean
	//		- false - don't adjust size of children
	//		- true - if there is a single visible child widget, set it's size to
	//				however big the ContentPane is
	doLayout: true,

	// isContainer: [protected] Boolean
	//		Indicates that this widget acts as a "parent" to the descendant widgets.
	//		When the parent is started it will call startup() on the child widgets.
	//		See also `isLayoutContainer`.
	isContainer: true,

	// isLayoutContainer: [protected] Boolean
	//		Indicates that this widget will call resize() on it's child widgets
	//		when they become visible.
	isLayoutContainer: true,

	_startChildren: function(){
		// summary:
		//		Call startup() on all children including non _Widget ones like dojo.dnd.Source objects

		// This starts all the widgets
		dojo.forEach(this.getChildren(), function(child){
			child.startup();
			child._started = true;
		});
	},

	startup: function(){
		// summary:
		//		See `dijit.layout._LayoutWidget.startup` for description.
		//		Although ContentPane doesn't extend _LayoutWidget, it does implement
		//		the same API.

		if(this._started){ return; }

		var parent = dijit._Contained.prototype.getParent.call(this);
		this._childOfLayoutWidget = parent && parent.isLayoutContainer;

		// I need to call resize() on my child/children (when I become visible), unless
		// I'm the child of a layout widget in which case my parent will call resize() on me and I'll do it then.
		this._needLayout = !this._childOfLayoutWidget;

		this.inherited(arguments);

		this._startChildren();

		if(this._isShown()){
			this._onShow();
		}

		if(!this._childOfLayoutWidget){
			// If my parent isn't a layout container, since my style *may be* width=height=100%
			// or something similar (either set directly or via a CSS class),
			// monitor when my size changes so that I can re-layout.
			// For browsers where I can't directly monitor when my size changes,
			// monitor when the viewport changes size, which *may* indicate a size change for me.
			this.connect(dojo.isIE ? this.domNode : dojo.global, 'onresize', function(){
				// Using function(){} closure to ensure no arguments to resize.
				this._needLayout = !this._childOfLayoutWidget;
				this.resize();
			});
		}
	},

	_checkIfSingleChild: function(){
		// summary:
		//		Test if we have exactly one visible widget as a child,
		//		and if so assume that we are a container for that widget,
		//		and should propagate startup() and resize() calls to it.
		//		Skips over things like data stores since they aren't visible.

		var childNodes = dojo.query("> *", this.containerNode).filter(function(node){
				return node.tagName !== "SCRIPT"; // or a regexp for hidden elements like script|area|map|etc..
			}),
			childWidgetNodes = childNodes.filter(function(node){
				return dojo.hasAttr(node, "data-dojo-type") || dojo.hasAttr(node, "dojoType") || dojo.hasAttr(node, "widgetId");
			}),
			candidateWidgets = dojo.filter(childWidgetNodes.map(dijit.byNode), function(widget){
				return widget && widget.domNode && widget.resize;
			});

		if(
			// all child nodes are widgets
			childNodes.length == childWidgetNodes.length &&

			// all but one are invisible (like dojo.data)
			candidateWidgets.length == 1
		){
			this._singleChild = candidateWidgets[0];
		}else{
			delete this._singleChild;
		}

		// So we can set overflow: hidden to avoid a safari bug w/scrollbars showing up (#9449)
		dojo.toggleClass(this.containerNode, this.baseClass + "SingleChild", !!this._singleChild);
	},

	resize: function(changeSize, resultSize){
		// summary:
		//		See `dijit.layout._LayoutWidget.resize` for description.
		//		Although ContentPane doesn't extend _LayoutWidget, it does implement
		//		the same API.

		// For the TabContainer --> BorderContainer --> ContentPane case, _onShow() is
		// never called, so resize() is our trigger to do the initial href download (see [20099]).
		// However, don't load href for closed TitlePanes.
		if(!this._wasShown && this.open !== false){
			this._onShow();
		}

		this._resizeCalled = true;

		this._scheduleLayout(changeSize, resultSize);
	},

	_scheduleLayout: function(changeSize, resultSize){
		// summary:
		//		Resize myself, and call resize() on each of my child layout widgets, either now
		//		(if I'm currently visible) or when I become visible
		if(this._isShown()){
			this._layout(changeSize, resultSize);
		}else{
			this._needLayout = true;
			this._changeSize = changeSize;
			this._resultSize = resultSize;
		}
	},

	_layout: function(changeSize, resultSize){
		// summary:
		//		Resize myself according to optional changeSize/resultSize parameters, like a layout widget.
		//		Also, since I am a Container widget, each of my children expects me to
		//		call resize() or layout() on them.
		//
		//		Should be called on initialization and also whenever we get new content
		//		(from an href, or from set('content', ...))... but deferred until
		//		the ContentPane is visible

		// Set margin box size, unless it wasn't specified, in which case use current size.
		if(changeSize){
			dojo.marginBox(this.domNode, changeSize);
		}

		// Compute content box size of containerNode in case we [later] need to size our single child.
		var cn = this.containerNode;
		if(cn === this.domNode){
			// If changeSize or resultSize was passed to this method and this.containerNode ==
			// this.domNode then we can compute the content-box size without querying the node,
			// which is more reliable (similar to LayoutWidget.resize) (see for example #9449).
			var mb = resultSize || {};
			dojo.mixin(mb, changeSize || {}); // changeSize overrides resultSize
			if(!("h" in mb) || !("w" in mb)){
				mb = dojo.mixin(dojo.marginBox(cn), mb); // just use dojo.marginBox() to fill in missing values
			}
			this._contentBox = dijit.layout.marginBox2contentBox(cn, mb);
		}else{
			this._contentBox = dojo.contentBox(cn);
		}

		this._layoutChildren();

		delete this._needLayout;
	},
	
	_layoutChildren: function(){
		// Call _checkIfSingleChild() again in case app has manually mucked w/the content
		// of the ContentPane (rather than changing it through the set("content", ...) API.
		if(this.doLayout){
			this._checkIfSingleChild();
		}

		if(this._singleChild && this._singleChild.resize){
			var cb = this._contentBox || dojo.contentBox(this.containerNode);

			// note: if widget has padding this._contentBox will have l and t set,
			// but don't pass them to resize() or it will doubly-offset the child
			this._singleChild.resize({w: cb.w, h: cb.h});
		}else{
			// All my child widgets are independently sized (rather than matching my size),
			// but I still need to call resize() on each child to make it layout.
			dojo.forEach(this.getChildren(), function(widget){
				if(widget.resize){
					widget.resize();
				}
			});
		}
	},

	_isShown: function(){
		// summary:
		//		Returns true if the content is currently shown.
		// description:
		//		If I am a child of a layout widget then it actually returns true if I've ever been visible,
		//		not whether I'm currently visible, since that's much faster than tracing up the DOM/widget
		//		tree every call, and at least solves the performance problem on page load by deferring loading
		//		hidden ContentPanes until they are first shown

		if(this._childOfLayoutWidget){
			// If we are TitlePane, etc - we return that only *IF* we've been resized
			if(this._resizeCalled && "open" in this){
				return this.open;
			}
			return this._resizeCalled;
		}else if("open" in this){
			return this.open;		// for TitlePane, etc.
		}else{
			var node = this.domNode, parent = this.domNode.parentNode;
			return (node.style.display != 'none') && (node.style.visibility != 'hidden') && !dojo.hasClass(node, "dijitHidden") &&
					parent && parent.style && (parent.style.display != 'none');
		}
	},

	_onShow: function(){
		// summary:
		//		Called when the ContentPane is made visible
		// description:
		//		For a plain ContentPane, this is called on initialization, from startup().
		//		If the ContentPane is a hidden pane of a TabContainer etc., then it's
		//		called whenever the pane is made visible.
		//
		//		Does layout/resize of child widget(s)

		if(this._needLayout){
			// If a layout has been scheduled for when we become visible, do it now
			this._layout(this._changeSize, this._resultSize);
		}

		this.inherited(arguments);

		// Need to keep track of whether ContentPane has been shown (which is different than
		// whether or not it's currently visible).
		this._wasShown = true;
	}
});

}

if(!dojo._hasResource["dojo.html"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.html"] = true;
dojo.provide("dojo.html");


dojo.getObject("html", true, dojo);

// the parser might be needed..
(function(){ // private scope, sort of a namespace

	// idCounter is incremented with each instantiation to allow asignment of a unique id for tracking, logging purposes
	var idCounter = 0,
		d = dojo;
	
	dojo.html._secureForInnerHtml = function(/*String*/ cont){
		// summary:
		//		removes !DOCTYPE and title elements from the html string.
		//
		//		khtml is picky about dom faults, you can't attach a style or <title> node as child of body
		//		must go into head, so we need to cut out those tags
		//	cont:
		//		An html string for insertion into the dom
		//
		return cont.replace(/(?:\s*<!DOCTYPE\s[^>]+>|<title[^>]*>[\s\S]*?<\/title>)/ig, ""); // String
	};

/*====
	dojo.html._emptyNode = function(node){
		// summary:
		//		removes all child nodes from the given node
		//	node: DOMNode
		//		the parent element
	};
=====*/
	dojo.html._emptyNode = dojo.empty;

	dojo.html._setNodeContent = function(/* DomNode */ node, /* String|DomNode|NodeList */ cont){
		// summary:
		//		inserts the given content into the given node
		//	node:
		//		the parent element
		//	content:
		//		the content to be set on the parent element.
		//		This can be an html string, a node reference or a NodeList, dojo.NodeList, Array or other enumerable list of nodes
		
		// always empty
		d.empty(node);

		if(cont) {
			if(typeof cont == "string") {
				cont = d._toDom(cont, node.ownerDocument);
			}
			if(!cont.nodeType && d.isArrayLike(cont)) {
				// handle as enumerable, but it may shrink as we enumerate it
				for(var startlen=cont.length, i=0; i<cont.length; i=startlen==cont.length ? i+1 : 0) {
					d.place( cont[i], node, "last");
				}
			} else {
				// pass nodes, documentFragments and unknowns through to dojo.place
				d.place(cont, node, "last");
			}
		}

		// return DomNode
		return node;
	};

	// we wrap up the content-setting operation in a object
	dojo.declare("dojo.html._ContentSetter", null,
		{
			// node: DomNode|String
			//		An node which will be the parent element that we set content into
			node: "",

			// content: String|DomNode|DomNode[]
			//		The content to be placed in the node. Can be an HTML string, a node reference, or a enumerable list of nodes
			content: "",
			
			// id: String?
			//		Usually only used internally, and auto-generated with each instance
			id: "",

			// cleanContent: Boolean
			//		Should the content be treated as a full html document,
			//		and the real content stripped of <html>, <body> wrapper before injection
			cleanContent: false,
			
			// extractContent: Boolean
			//		Should the content be treated as a full html document, and the real content stripped of <html>, <body> wrapper before injection
			extractContent: false,

			// parseContent: Boolean
			//		Should the node by passed to the parser after the new content is set
			parseContent: false,

			// parserScope: String
			//		Flag passed to parser.  Root for attribute names to search for.   If scopeName is dojo,
			//		will search for data-dojo-type (or dojoType).  For backwards compatibility
			//		reasons defaults to dojo._scopeName (which is "dojo" except when
			//		multi-version support is used, when it will be something like dojo16, dojo20, etc.)
			parserScope: dojo._scopeName,

			// startup: Boolean
			//		Start the child widgets after parsing them.   Only obeyed if parseContent is true.
			startup: true,
			
			// lifecyle methods
			constructor: function(/* Object */params, /* String|DomNode */node){
				//	summary:
				//		Provides a configurable, extensible object to wrap the setting on content on a node
				//		call the set() method to actually set the content..
 
				// the original params are mixed directly into the instance "this"
				dojo.mixin(this, params || {});

				// give precedence to params.node vs. the node argument
				// and ensure its a node, not an id string
				node = this.node = dojo.byId( this.node || node );
	
				if(!this.id){
					this.id = [
						"Setter",
						(node) ? node.id || node.tagName : "",
						idCounter++
					].join("_");
				}
			},
			set: function(/* String|DomNode|NodeList? */ cont, /* Object? */ params){
				// summary:
				//		front-end to the set-content sequence
				//	cont:
				//		An html string, node or enumerable list of nodes for insertion into the dom
				//		If not provided, the object's content property will be used
				if(undefined !== cont){
					this.content = cont;
				}
				// in the re-use scenario, set needs to be able to mixin new configuration
				if(params){
					this._mixin(params);
				}

				this.onBegin();
				this.setContent();
				this.onEnd();

				return this.node;
			},
			setContent: function(){
				// summary:
				//		sets the content on the node

				var node = this.node;
				if(!node) {
				    // can't proceed
					throw new Error(this.declaredClass + ": setContent given no node");
				}
				try{
					node = dojo.html._setNodeContent(node, this.content);
				}catch(e){
					// check if a domfault occurs when we are appending this.errorMessage
					// like for instance if domNode is a UL and we try append a DIV
	
					// FIXME: need to allow the user to provide a content error message string
					var errMess = this.onContentError(e);
					try{
						node.innerHTML = errMess;
					}catch(e){
						console.error('Fatal ' + this.declaredClass + '.setContent could not change content due to '+e.message, e);
					}
				}
				// always put back the node for the next method
				this.node = node; // DomNode
			},
			
			empty: function() {
				// summary
				//	cleanly empty out existing content

				// destroy any widgets from a previous run
				// NOTE: if you dont want this you'll need to empty
				// the parseResults array property yourself to avoid bad things happenning
				if(this.parseResults && this.parseResults.length) {
					dojo.forEach(this.parseResults, function(w) {
						if(w.destroy){
							w.destroy();
						}
					});
					delete this.parseResults;
				}
				// this is fast, but if you know its already empty or safe, you could
				// override empty to skip this step
				dojo.html._emptyNode(this.node);
			},
	
			onBegin: function(){
				// summary
				//		Called after instantiation, but before set();
				//		It allows modification of any of the object properties
				//		- including the node and content provided - before the set operation actually takes place
				//		This default implementation checks for cleanContent and extractContent flags to
				//		optionally pre-process html string content
				var cont = this.content;
	
				if(dojo.isString(cont)){
					if(this.cleanContent){
						cont = dojo.html._secureForInnerHtml(cont);
					}
  
					if(this.extractContent){
						var match = cont.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
						if(match){ cont = match[1]; }
					}
				}

				// clean out the node and any cruft associated with it - like widgets
				this.empty();
				
				this.content = cont;
				return this.node; /* DomNode */
			},
	
			onEnd: function(){
				// summary
				//		Called after set(), when the new content has been pushed into the node
				//		It provides an opportunity for post-processing before handing back the node to the caller
				//		This default implementation checks a parseContent flag to optionally run the dojo parser over the new content
				if(this.parseContent){
					// populates this.parseResults if you need those..
					this._parse();
				}
				return this.node; /* DomNode */
			},
	
			tearDown: function(){
				// summary
				//		manually reset the Setter instance if its being re-used for example for another set()
				// description
				//		tearDown() is not called automatically.
				//		In normal use, the Setter instance properties are simply allowed to fall out of scope
				//		but the tearDown method can be called to explicitly reset this instance.
				delete this.parseResults;
				delete this.node;
				delete this.content;
			},
  
			onContentError: function(err){
				return "Error occured setting content: " + err;
			},
			
			_mixin: function(params){
				// mix properties/methods into the instance
				// TODO: the intention with tearDown is to put the Setter's state
				// back to that of the original constructor (vs. deleting/resetting everything regardless of ctor params)
				// so we could do something here to move the original properties aside for later restoration
				var empty = {}, key;
				for(key in params){
					if(key in empty){ continue; }
					// TODO: here's our opportunity to mask the properties we dont consider configurable/overridable
					// .. but history shows we'll almost always guess wrong
					this[key] = params[key];
				}
			},
			_parse: function(){
				// summary:
				//		runs the dojo parser over the node contents, storing any results in this.parseResults
				//		Any errors resulting from parsing are passed to _onError for handling

				var rootNode = this.node;
				try{
					// store the results (widgets, whatever) for potential retrieval
					var inherited = {};
					dojo.forEach(["dir", "lang", "textDir"], function(name){
						if(this[name]){
							inherited[name] = this[name];
						}
					}, this);
					this.parseResults = dojo.parser.parse({
						rootNode: rootNode,
						noStart: !this.startup,
						inherited: inherited,
						scope: this.parserScope
					});
				}catch(e){
					this._onError('Content', e, "Error parsing in _ContentSetter#"+this.id);
				}
			},
  
			_onError: function(type, err, consoleText){
				// summary:
				//		shows user the string that is returned by on[type]Error
				//		overide/implement on[type]Error and return your own string to customize
				var errText = this['on' + type + 'Error'].call(this, err);
				if(consoleText){
					console.error(consoleText, err);
				}else if(errText){ // a empty string won't change current content
					dojo.html._setNodeContent(this.node, errText, true);
				}
			}
	}); // end dojo.declare()

	dojo.html.set = function(/* DomNode */ node, /* String|DomNode|NodeList */ cont, /* Object? */ params){
			// summary:
			//		inserts (replaces) the given content into the given node. dojo.place(cont, node, "only")
			//		may be a better choice for simple HTML insertion.
			// description:
			//		Unless you need to use the params capabilities of this method, you should use
			//		dojo.place(cont, node, "only"). dojo.place() has more robust support for injecting
			//		an HTML string into the DOM, but it only handles inserting an HTML string as DOM
			//		elements, or inserting a DOM node. dojo.place does not handle NodeList insertions
			//		or the other capabilities as defined by the params object for this method.
			//	node:
			//		the parent element that will receive the content
			//	cont:
			//		the content to be set on the parent element.
			//		This can be an html string, a node reference or a NodeList, dojo.NodeList, Array or other enumerable list of nodes
			//	params:
			//		Optional flags/properties to configure the content-setting. See dojo.html._ContentSetter
			//	example:
			//		A safe string/node/nodelist content replacement/injection with hooks for extension
			//		Example Usage:
			//		dojo.html.set(node, "some string");
			//		dojo.html.set(node, contentNode, {options});
			//		dojo.html.set(node, myNode.childNodes, {options});
		if(undefined == cont){
			console.warn("dojo.html.set: no cont argument provided, using empty string");
			cont = "";
		}
		if(!params){
			// simple and fast
			return dojo.html._setNodeContent(node, cont, true);
		}else{
			// more options but slower
			// note the arguments are reversed in order, to match the convention for instantiation via the parser
			var op = new dojo.html._ContentSetter(dojo.mixin(
					params,
					{ content: cont, node: node }
			));
			return op.set();
		}
	};
})();

}

if(!dojo._hasResource["dijit.layout.ContentPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.ContentPane"] = true;
dojo.provide("dijit.layout.ContentPane");







dojo.declare(
	"dijit.layout.ContentPane", [dijit._Widget, dijit.layout._ContentPaneResizeMixin],
{
	// summary:
	//		A widget containing an HTML fragment, specified inline
	//		or by uri.  Fragment may include widgets.
	//
	// description:
	//		This widget embeds a document fragment in the page, specified
	//		either by uri, javascript generated markup or DOM reference.
	//		Any widgets within this content are instantiated and managed,
	//		but laid out according to the HTML structure.  Unlike IFRAME,
	//		ContentPane embeds a document fragment as would be found
	//		inside the BODY tag of a full HTML document.  It should not
	//		contain the HTML, HEAD, or BODY tags.
	//		For more advanced functionality with scripts and
	//		stylesheets, see dojox.layout.ContentPane.  This widget may be
	//		used stand alone or as a base class for other widgets.
	//		ContentPane is useful as a child of other layout containers
	//		such as BorderContainer or TabContainer, but note that those
	//		widgets can contain any widget as a child.
	//
	// example:
	//		Some quick samples:
	//		To change the innerHTML: cp.set('content', '<b>new content</b>')
	//
	//		Or you can send it a NodeList: cp.set('content', dojo.query('div [class=selected]', userSelection))
	//
	//		To do an ajax update: cp.set('href', url)

	// href: String
	//		The href of the content that displays now.
	//		Set this at construction if you want to load data externally when the
	//		pane is shown.  (Set preload=true to load it immediately.)
	//		Changing href after creation doesn't have any effect; Use set('href', ...);
	href: "",

/*=====
	// content: String || DomNode || NodeList || dijit._Widget
	//		The innerHTML of the ContentPane.
	//		Note that the initialization parameter / argument to set("content", ...)
	//		can be a String, DomNode, Nodelist, or _Widget.
	content: "",
=====*/

	// extractContent: Boolean
	//		Extract visible content from inside of <body> .... </body>.
	//		I.e., strip <html> and <head> (and it's contents) from the href
	extractContent: false,

	// parseOnLoad: Boolean
	//		Parse content and create the widgets, if any.
	parseOnLoad: true,

	// parserScope: String
	//		Flag passed to parser.  Root for attribute names to search for.   If scopeName is dojo,
	//		will search for data-dojo-type (or dojoType).  For backwards compatibility
	//		reasons defaults to dojo._scopeName (which is "dojo" except when
	//		multi-version support is used, when it will be something like dojo16, dojo20, etc.)
	parserScope: dojo._scopeName,

	// preventCache: Boolean
	//		Prevent caching of data from href's by appending a timestamp to the href.
	preventCache: false,

	// preload: Boolean
	//		Force load of data on initialization even if pane is hidden.
	preload: false,

	// refreshOnShow: Boolean
	//		Refresh (re-download) content when pane goes from hidden to shown
	refreshOnShow: false,

	// loadingMessage: String
	//		Message that shows while downloading
	loadingMessage: "<span class='dijitContentPaneLoading'>${loadingState}</span>",

	// errorMessage: String
	//		Message that shows if an error occurs
	errorMessage: "<span class='dijitContentPaneError'>${errorState}</span>",

	// isLoaded: [readonly] Boolean
	//		True if the ContentPane has data in it, either specified
	//		during initialization (via href or inline content), or set
	//		via set('content', ...) / set('href', ...)
	//
	//		False if it doesn't have any content, or if ContentPane is
	//		still in the process of downloading href.
	isLoaded: false,

	baseClass: "dijitContentPane",

	// ioArgs: Object
	//		Parameters to pass to xhrGet() request, for example:
	// |	<div dojoType="dijit.layout.ContentPane" href="./bar" ioArgs="{timeout: 500}">
	ioArgs: {},

	// onLoadDeferred: [readonly] dojo.Deferred
	//		This is the `dojo.Deferred` returned by set('href', ...) and refresh().
	//		Calling onLoadDeferred.addCallback() or addErrback() registers your
	//		callback to be called only once, when the prior set('href', ...) call or
	//		the initial href parameter to the constructor finishes loading.
	//
	//		This is different than an onLoad() handler which gets called any time any href
	//		or content is loaded.
	onLoadDeferred: null,

	// Override _Widget's attributeMap because we don't want the title attribute (used to specify
	// tab labels) to be copied to ContentPane.domNode... otherwise a tooltip shows up over the
	// entire pane.
	attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
		title: []
	}),

	// Flag to parser that I'll parse my contents, so it shouldn't.
	stopParser: true,

	// template: [private] Boolean
	//		Flag from the parser that this ContentPane is inside a template
	//		so the contents are pre-parsed.
	// (TODO: this declaration can be commented out in 2.0)
	template: false,

	create: function(params, srcNodeRef){
		// Convert a srcNodeRef argument into a content parameter, so that the original contents are
		// processed in the same way as contents set via set("content", ...), calling the parser etc.
		// Avoid modifying original params object since that breaks NodeList instantiation, see #11906.
		if((!params || !params.template) && srcNodeRef && !("href" in params) && !("content" in params)){
			var df = dojo.doc.createDocumentFragment();
			srcNodeRef = dojo.byId(srcNodeRef)
			while(srcNodeRef.firstChild){
				df.appendChild(srcNodeRef.firstChild);
			}
			params = dojo.delegate(params, {content: df});
		}
		this.inherited(arguments, [params, srcNodeRef]);
	},

	postMixInProperties: function(){
		this.inherited(arguments);
		var messages = dojo.i18n.getLocalization("dijit", "loading", this.lang);
		this.loadingMessage = dojo.string.substitute(this.loadingMessage, messages);
		this.errorMessage = dojo.string.substitute(this.errorMessage, messages);
	},

	buildRendering: function(){
		this.inherited(arguments);

		// Since we have no template we need to set this.containerNode ourselves, to make getChildren() work.
		// For subclasses of ContentPane that do have a template, does nothing.
		if(!this.containerNode){
			this.containerNode = this.domNode;
		}

		// remove the title attribute so it doesn't show up when hovering
		// over a node  (TODO: remove in 2.0, no longer needed after #11490)
		this.domNode.title = "";

		if(!dojo.attr(this.domNode,"role")){
			dijit.setWaiRole(this.domNode, "group");
		}
	},

	_startChildren: function(){
		// summary:
		//		Call startup() on all children including non _Widget ones like dojo.dnd.Source objects

		// This starts all the widgets
		this.inherited(arguments);

		// And this catches stuff like dojo.dnd.Source
		if(this._contentSetter){
			dojo.forEach(this._contentSetter.parseResults, function(obj){
				if(!obj._started && !obj._destroyed && dojo.isFunction(obj.startup)){
					obj.startup();
					obj._started = true;
				}
			}, this);
		}
	},

	setHref: function(/*String|Uri*/ href){
		// summary:
		//		Deprecated.   Use set('href', ...) instead.
		dojo.deprecated("dijit.layout.ContentPane.setHref() is deprecated. Use set('href', ...) instead.", "", "2.0");
		return this.set("href", href);
	},
	_setHrefAttr: function(/*String|Uri*/ href){
		// summary:
		//		Hook so set("href", ...) works.
		// description:
		//		Reset the (external defined) content of this pane and replace with new url
		//		Note: It delays the download until widget is shown if preload is false.
		//	href:
		//		url to the page you want to get, must be within the same domain as your mainpage

		// Cancel any in-flight requests (a set('href', ...) will cancel any in-flight set('href', ...))
		this.cancel();

		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));
		this.onLoadDeferred.addCallback(dojo.hitch(this, "onLoad"));

		this._set("href", href);

		// _setHrefAttr() is called during creation and by the user, after creation.
		// Assuming preload == false, only in the second case do we actually load the URL;
		// otherwise it's done in startup(), and only if this widget is shown.
		if(this.preload || (this._created && this._isShown())){
			this._load();
		}else{
			// Set flag to indicate that href needs to be loaded the next time the
			// ContentPane is made visible
			this._hrefChanged = true;
		}

		return this.onLoadDeferred;		// dojo.Deferred
	},

	setContent: function(/*String|DomNode|Nodelist*/data){
		// summary:
		//		Deprecated.   Use set('content', ...) instead.
		dojo.deprecated("dijit.layout.ContentPane.setContent() is deprecated.  Use set('content', ...) instead.", "", "2.0");
		this.set("content", data);
	},
	_setContentAttr: function(/*String|DomNode|Nodelist*/data){
		// summary:
		//		Hook to make set("content", ...) work.
		//		Replaces old content with data content, include style classes from old content
		//	data:
		//		the new Content may be String, DomNode or NodeList
		//
		//		if data is a NodeList (or an array of nodes) nodes are copied
		//		so you can import nodes from another document implicitly

		// clear href so we can't run refresh and clear content
		// refresh should only work if we downloaded the content
		this._set("href", "");

		// Cancel any in-flight requests (a set('content', ...) will cancel any in-flight set('href', ...))
		this.cancel();

		// Even though user is just setting content directly, still need to define an onLoadDeferred
		// because the _onLoadHandler() handler is still getting called from setContent()
		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));
		if(this._created){
			// For back-compat reasons, call onLoad() for set('content', ...)
			// calls but not for content specified in srcNodeRef (ie: <div dojoType=ContentPane>...</div>)
			// or as initialization parameter (ie: new ContentPane({content: ...})
			this.onLoadDeferred.addCallback(dojo.hitch(this, "onLoad"));
		}

		this._setContent(data || "");

		this._isDownloaded = false; // mark that content is from a set('content') not a set('href')

		return this.onLoadDeferred; 	// dojo.Deferred
	},
	_getContentAttr: function(){
		// summary:
		//		Hook to make get("content") work
		return this.containerNode.innerHTML;
	},

	cancel: function(){
		// summary:
		//		Cancels an in-flight download of content
		if(this._xhrDfd && (this._xhrDfd.fired == -1)){
			this._xhrDfd.cancel();
		}
		delete this._xhrDfd; // garbage collect

		this.onLoadDeferred = null;
	},

	uninitialize: function(){
		if(this._beingDestroyed){
			this.cancel();
		}
		this.inherited(arguments);
	},

	destroyRecursive: function(/*Boolean*/ preserveDom){
		// summary:
		//		Destroy the ContentPane and its contents

		// if we have multiple controllers destroying us, bail after the first
		if(this._beingDestroyed){
			return;
		}
		this.inherited(arguments);
	},

	_onShow: function(){
		// summary:
		//		Called when the ContentPane is made visible
		// description:
		//		For a plain ContentPane, this is called on initialization, from startup().
		//		If the ContentPane is a hidden pane of a TabContainer etc., then it's
		//		called whenever the pane is made visible.
		//
		//		Does necessary processing, including href download and layout/resize of
		//		child widget(s)

		this.inherited(arguments);

		if(this.href){
			if(!this._xhrDfd && // if there's an href that isn't already being loaded
				(!this.isLoaded || this._hrefChanged || this.refreshOnShow)
			){
				return this.refresh();	// If child has an href, promise that fires when the load is complete
			}
		}
	},

	refresh: function(){
		// summary:
		//		[Re]download contents of href and display
		// description:
		//		1. cancels any currently in-flight requests
		//		2. posts "loading..." message
		//		3. sends XHR to download new data

		// Cancel possible prior in-flight request
		this.cancel();

		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));
		this.onLoadDeferred.addCallback(dojo.hitch(this, "onLoad"));
		this._load();
		return this.onLoadDeferred;		// If child has an href, promise that fires when refresh is complete
	},

	_load: function(){
		// summary:
		//		Load/reload the href specified in this.href

		// display loading message
		this._setContent(this.onDownloadStart(), true);

		var self = this;
		var getArgs = {
			preventCache: (this.preventCache || this.refreshOnShow),
			url: this.href,
			handleAs: "text"
		};
		if(dojo.isObject(this.ioArgs)){
			dojo.mixin(getArgs, this.ioArgs);
		}

		var hand = (this._xhrDfd = (this.ioMethod || dojo.xhrGet)(getArgs));

		hand.addCallback(function(html){
			try{
				self._isDownloaded = true;
				self._setContent(html, false);
				self.onDownloadEnd();
			}catch(err){
				self._onError('Content', err); // onContentError
			}
			delete self._xhrDfd;
			return html;
		});

		hand.addErrback(function(err){
			if(!hand.canceled){
				// show error message in the pane
				self._onError('Download', err); // onDownloadError
			}
			delete self._xhrDfd;
			return err;
		});

		// Remove flag saying that a load is needed
		delete this._hrefChanged;
	},

	_onLoadHandler: function(data){
		// summary:
		//		This is called whenever new content is being loaded
		this._set("isLoaded", true);
		try{
			this.onLoadDeferred.callback(data);
		}catch(e){
			console.error('Error '+this.widgetId+' running custom onLoad code: ' + e.message);
		}
	},

	_onUnloadHandler: function(){
		// summary:
		//		This is called whenever the content is being unloaded
		this._set("isLoaded", false);
		try{
			this.onUnload();
		}catch(e){
			console.error('Error '+this.widgetId+' running custom onUnload code: ' + e.message);
		}
	},

	destroyDescendants: function(){
		// summary:
		//		Destroy all the widgets inside the ContentPane and empty containerNode

		// Make sure we call onUnload (but only when the ContentPane has real content)
		if(this.isLoaded){
			this._onUnloadHandler();
		}

		// Even if this.isLoaded == false there might still be a "Loading..." message
		// to erase, so continue...

		// For historical reasons we need to delete all widgets under this.containerNode,
		// even ones that the user has created manually.
		var setter = this._contentSetter;
		dojo.forEach(this.getChildren(), function(widget){
			if(widget.destroyRecursive){
				widget.destroyRecursive();
			}
		});
		if(setter){
			// Most of the widgets in setter.parseResults have already been destroyed, but
			// things like Menu that have been moved to <body> haven't yet
			dojo.forEach(setter.parseResults, function(widget){
				if(widget.destroyRecursive && widget.domNode && widget.domNode.parentNode == dojo.body()){
					widget.destroyRecursive();
				}
			});
			delete setter.parseResults;
		}

		// And then clear away all the DOM nodes
		dojo.html._emptyNode(this.containerNode);

		// Delete any state information we have about current contents
		delete this._singleChild;
	},

	_setContent: function(/*String|DocumentFragment*/ cont, /*Boolean*/ isFakeContent){
		// summary:
		//		Insert the content into the container node

		// first get rid of child widgets
		this.destroyDescendants();

		// dojo.html.set will take care of the rest of the details
		// we provide an override for the error handling to ensure the widget gets the errors
		// configure the setter instance with only the relevant widget instance properties
		// NOTE: unless we hook into attr, or provide property setters for each property,
		// we need to re-configure the ContentSetter with each use
		var setter = this._contentSetter;
		if(! (setter && setter instanceof dojo.html._ContentSetter)){
			setter = this._contentSetter = new dojo.html._ContentSetter({
				node: this.containerNode,
				_onError: dojo.hitch(this, this._onError),
				onContentError: dojo.hitch(this, function(e){
					// fires if a domfault occurs when we are appending this.errorMessage
					// like for instance if domNode is a UL and we try append a DIV
					var errMess = this.onContentError(e);
					try{
						this.containerNode.innerHTML = errMess;
					}catch(e){
						console.error('Fatal '+this.id+' could not change content due to '+e.message, e);
					}
				})/*,
				_onError */
			});
		};

		var setterParams = dojo.mixin({
			cleanContent: this.cleanContent,
			extractContent: this.extractContent,
			parseContent: this.parseOnLoad,
			parserScope: this.parserScope,
			startup: false,
			dir: this.dir,
			lang: this.lang
		}, this._contentSetterParams || {});

		setter.set( (dojo.isObject(cont) && cont.domNode) ? cont.domNode : cont, setterParams );

		// setter params must be pulled afresh from the ContentPane each time
		delete this._contentSetterParams;

		if(this.doLayout){
			this._checkIfSingleChild();
		}

		if(!isFakeContent){
			if(this._started){
				// Startup each top level child widget (and they will start their children, recursively)
				this._startChildren();
	
				// Call resize() on each of my child layout widgets,
				// or resize() on my single child layout widget...
				// either now (if I'm currently visible) or when I become visible
				this._scheduleLayout();
			}

			this._onLoadHandler(cont);
		}
	},

	_onError: function(type, err, consoleText){
		this.onLoadDeferred.errback(err);

		// shows user the string that is returned by on[type]Error
		// override on[type]Error and return your own string to customize
		var errText = this['on' + type + 'Error'].call(this, err);
		if(consoleText){
			console.error(consoleText, err);
		}else if(errText){// a empty string won't change current content
			this._setContent(errText, true);
		}
	},

	// EVENT's, should be overide-able
	onLoad: function(data){
		// summary:
		//		Event hook, is called after everything is loaded and widgetified
		// tags:
		//		callback
	},

	onUnload: function(){
		// summary:
		//		Event hook, is called before old content is cleared
		// tags:
		//		callback
	},

	onDownloadStart: function(){
		// summary:
		//		Called before download starts.
		// description:
		//		The string returned by this function will be the html
		//		that tells the user we are loading something.
		//		Override with your own function if you want to change text.
		// tags:
		//		extension
		return this.loadingMessage;
	},

	onContentError: function(/*Error*/ error){
		// summary:
		//		Called on DOM faults, require faults etc. in content.
		//
		//		In order to display an error message in the pane, return
		//		the error message from this method, as an HTML string.
		//
		//		By default (if this method is not overriden), it returns
		//		nothing, so the error message is just printed to the console.
		// tags:
		//		extension
	},

	onDownloadError: function(/*Error*/ error){
		// summary:
		//		Called when download error occurs.
		//
		//		In order to display an error message in the pane, return
		//		the error message from this method, as an HTML string.
		//
		//		Default behavior (if this method is not overriden) is to display
		//		the error message inside the pane.
		// tags:
		//		extension
		return this.errorMessage;
	},

	onDownloadEnd: function(){
		// summary:
		//		Called when download is finished.
		// tags:
		//		callback
	}
});

}

if(!dojo._hasResource["dijit.layout.AccordionPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.AccordionPane"] = true;
dojo.provide("dijit.layout.AccordionPane");



dojo.declare("dijit.layout.AccordionPane", dijit.layout.ContentPane, {
	// summary:
	//		Deprecated widget.   Use `dijit.layout.ContentPane` instead.
	// tags:
	//		deprecated

	constructor: function(){
		dojo.deprecated("dijit.layout.AccordionPane deprecated, use ContentPane instead", "", "2.0");
	},

	onSelected: function(){
		// summary:
		//		called when this pane is selected
	}
});

}

if(!dojo._hasResource["dijit.layout.AccordionContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.AccordionContainer"] = true;
dojo.provide("dijit.layout.AccordionContainer");








//dojo.require("dijit.layout.AccordionPane ");	// for back compat, remove for 2.0

// Design notes:
//
// An AccordionContainer is a StackContainer, but each child (typically ContentPane)
// is wrapped in a _AccordionInnerContainer.   This is hidden from the caller.
//
// The resulting markup will look like:
//
//	<div class=dijitAccordionContainer>
//		<div class=dijitAccordionInnerContainer>	(one pane)
//				<div class=dijitAccordionTitle>		(title bar) ... </div>
//				<div class=dijtAccordionChildWrapper>   (content pane) </div>
//		</div>
//	</div>
//
// Normally the dijtAccordionChildWrapper is hidden for all but one child (the shown
// child), so the space for the content pane is all the title bars + the one dijtAccordionChildWrapper,
// which on claro has a 1px border plus a 2px bottom margin.
//
// During animation there are two dijtAccordionChildWrapper's shown, so we need
// to compensate for that.

dojo.declare(
	"dijit.layout.AccordionContainer",
	dijit.layout.StackContainer,
	{
		// summary:
		//		Holds a set of panes where every pane's title is visible, but only one pane's content is visible at a time,
		//		and switching between panes is visualized by sliding the other panes up/down.
		// example:
		//	| 	<div dojoType="dijit.layout.AccordionContainer">
		//	|		<div dojoType="dijit.layout.ContentPane" title="pane 1">
		//	|		</div>
		//	|		<div dojoType="dijit.layout.ContentPane" title="pane 2">
		//	|			<p>This is some text</p>
		//	|		</div>
		//	|	</div>

		// duration: Integer
		//		Amount of time (in ms) it takes to slide panes
		duration: dijit.defaultDuration,

		// buttonWidget: [const] String
		//		The name of the widget used to display the title of each pane
		buttonWidget: "dijit.layout._AccordionButton",

/*=====
		// _verticalSpace: Number
		//		Pixels of space available for the open pane
		//		(my content box size minus the cumulative size of all the title bars)
		_verticalSpace: 0,
=====*/
		baseClass: "dijitAccordionContainer",

		buildRendering: function(){
			this.inherited(arguments);
			this.domNode.style.overflow = "hidden";		// TODO: put this in dijit.css
			dijit.setWaiRole(this.domNode, "tablist");	// TODO: put this in template
		},

		startup: function(){
			if(this._started){ return; }
			this.inherited(arguments);
			if(this.selectedChildWidget){
				var style = this.selectedChildWidget.containerNode.style;
				style.display = "";
				style.overflow = "auto";
				this.selectedChildWidget._wrapperWidget.set("selected", true);
			}
		},

		layout: function(){
			// Implement _LayoutWidget.layout() virtual method.
			// Set the height of the open pane based on what room remains.

			var openPane = this.selectedChildWidget;
			
			if(!openPane){ return;}

			// space taken up by title, plus wrapper div (with border/margin) for open pane
			var wrapperDomNode = openPane._wrapperWidget.domNode,
				wrapperDomNodeMargin = dojo._getMarginExtents(wrapperDomNode),
				wrapperDomNodePadBorder = dojo._getPadBorderExtents(wrapperDomNode),
				wrapperContainerNode = openPane._wrapperWidget.containerNode,
				wrapperContainerNodeMargin = dojo._getMarginExtents(wrapperContainerNode),
				wrapperContainerNodePadBorder = dojo._getPadBorderExtents(wrapperContainerNode),
				mySize = this._contentBox;

			// get cumulative height of all the unselected title bars
			var totalCollapsedHeight = 0;
			dojo.forEach(this.getChildren(), function(child){
	            if(child != openPane){
					totalCollapsedHeight += dojo._getMarginSize(child._wrapperWidget.domNode).h;
				}
			});
			this._verticalSpace = mySize.h - totalCollapsedHeight - wrapperDomNodeMargin.h
			 	- wrapperDomNodePadBorder.h - wrapperContainerNodeMargin.h - wrapperContainerNodePadBorder.h
				- openPane._buttonWidget.getTitleHeight();

			// Memo size to make displayed child
			this._containerContentBox = {
				h: this._verticalSpace,
				w: this._contentBox.w - wrapperDomNodeMargin.w - wrapperDomNodePadBorder.w
					- wrapperContainerNodeMargin.w - wrapperContainerNodePadBorder.w
			};

			if(openPane){
				openPane.resize(this._containerContentBox);
			}
		},

		_setupChild: function(child){
			// Overrides _LayoutWidget._setupChild().
			// Put wrapper widget around the child widget, showing title

			child._wrapperWidget = new dijit.layout._AccordionInnerContainer({
				contentWidget: child,
				buttonWidget: this.buttonWidget,
				id: child.id + "_wrapper",
				dir: child.dir,
				lang: child.lang,
				parent: this
			});

			this.inherited(arguments);
		},

		addChild: function(/*dijit._Widget*/ child, /*Integer?*/ insertIndex){
			if(this._started){
				// Adding a child to a started Accordion is complicated because children have
				// wrapper widgets.  Default code path (calling this.inherited()) would add
				// the new child inside another child's wrapper.

				// First add in child as a direct child of this AccordionContainer
				dojo.place(child.domNode, this.containerNode, insertIndex);

				if(!child._started){
					child.startup();
				}
				
				// Then stick the wrapper widget around the child widget
				this._setupChild(child);

				// Code below copied from StackContainer
				dojo.publish(this.id+"-addChild", [child, insertIndex]);
				this.layout();
				if(!this.selectedChildWidget){
					this.selectChild(child);
				}
			}else{
				// We haven't been started yet so just add in the child widget directly,
				// and the wrapper will be created on startup()
				this.inherited(arguments);
			}
		},

		removeChild: function(child){
			// Overrides _LayoutWidget.removeChild().

			// Destroy wrapper widget first, before StackContainer.getChildren() call.
			// Replace wrapper widget with true child widget (ContentPane etc.).
			// This step only happens if the AccordionContainer has been started; otherwise there's no wrapper.
			if(child._wrapperWidget){
				dojo.place(child.domNode, child._wrapperWidget.domNode, "after");
				child._wrapperWidget.destroy();
				delete child._wrapperWidget;
			}

			dojo.removeClass(child.domNode, "dijitHidden");

			this.inherited(arguments);
		},

		getChildren: function(){
			// Overrides _Container.getChildren() to return content panes rather than internal AccordionInnerContainer panes
			return dojo.map(this.inherited(arguments), function(child){
				return child.declaredClass == "dijit.layout._AccordionInnerContainer" ? child.contentWidget : child;
			}, this);
		},

		destroy: function(){
			if(this._animation){
				this._animation.stop();
			}
			dojo.forEach(this.getChildren(), function(child){
				// If AccordionContainer has been started, then each child has a wrapper widget which
				// also needs to be destroyed.
				if(child._wrapperWidget){
					child._wrapperWidget.destroy();
				}else{
					child.destroyRecursive();
				}
			});
			this.inherited(arguments);
		},

		_showChild: function(child){
			// Override StackContainer._showChild() to set visibility of _wrapperWidget.containerNode
			child._wrapperWidget.containerNode.style.display="block";
			return this.inherited(arguments);
		},

		_hideChild: function(child){
			// Override StackContainer._showChild() to set visibility of _wrapperWidget.containerNode
			child._wrapperWidget.containerNode.style.display="none";
			this.inherited(arguments);
		},

		_transition: function(/*dijit._Widget?*/ newWidget, /*dijit._Widget?*/ oldWidget, /*Boolean*/ animate){
			// Overrides StackContainer._transition() to provide sliding of title bars etc.

			if(dojo.isIE < 8){
				// workaround animation bugs by not animating; not worth supporting animation for IE6 & 7
				animate = false;
			}

			if(this._animation){
				// there's an in-progress animation.  speedily end it so we can do the newly requested one
				this._animation.stop(true);
				delete this._animation;
			}

			var self = this;

			if(newWidget){
				newWidget._wrapperWidget.set("selected", true);

				var d = this._showChild(newWidget);	// prepare widget to be slid in

				// Size the new widget, in case this is the first time it's being shown,
				// or I have been resized since the last time it was shown.
				// Note that page must be visible for resizing to work.
				if(this.doLayout && newWidget.resize){
					newWidget.resize(this._containerContentBox);
				}
			}

			if(oldWidget){
				oldWidget._wrapperWidget.set("selected", false);
				if(!animate){
					this._hideChild(oldWidget);
				}
			}

			if(animate){
				var newContents = newWidget._wrapperWidget.containerNode,
					oldContents = oldWidget._wrapperWidget.containerNode;

				// During the animation we will be showing two dijitAccordionChildWrapper nodes at once,
				// which on claro takes up 4px extra space (compared to stable AccordionContainer).
				// Have to compensate for that by immediately shrinking the pane being closed.
				var wrapperContainerNode = newWidget._wrapperWidget.containerNode,
					wrapperContainerNodeMargin = dojo._getMarginExtents(wrapperContainerNode),
					wrapperContainerNodePadBorder = dojo._getPadBorderExtents(wrapperContainerNode),
					animationHeightOverhead = wrapperContainerNodeMargin.h + wrapperContainerNodePadBorder.h;

				oldContents.style.height = (self._verticalSpace - animationHeightOverhead) + "px";

				this._animation = new dojo.Animation({
					node: newContents,
					duration: this.duration,
					curve: [1, this._verticalSpace - animationHeightOverhead - 1],
					onAnimate: function(value){
						value = Math.floor(value);	// avoid fractional values
						newContents.style.height = value + "px";
						oldContents.style.height = (self._verticalSpace - animationHeightOverhead - value) + "px";
					},
					onEnd: function(){
						delete self._animation;
						newContents.style.height = "auto";
						oldWidget._wrapperWidget.containerNode.style.display = "none";
						oldContents.style.height = "auto";
						self._hideChild(oldWidget);
					}
				});
				this._animation.onStop = this._animation.onEnd;
				this._animation.play();
			}

			return d;	// If child has an href, promise that fires when the widget has finished loading
		},

		// note: we are treating the container as controller here
		_onKeyPress: function(/*Event*/ e, /*dijit._Widget*/ fromTitle){
			// summary:
			//		Handle keypress events
			// description:
			//		This is called from a handler on AccordionContainer.domNode
			//		(setup in StackContainer), and is also called directly from
			//		the click handler for accordion labels
			if(this.disabled || e.altKey || !(fromTitle || e.ctrlKey)){
				return;
			}
			var k = dojo.keys,
				c = e.charOrCode;
			if((fromTitle && (c == k.LEFT_ARROW || c == k.UP_ARROW)) ||
					(e.ctrlKey && c == k.PAGE_UP)){
				this._adjacent(false)._buttonWidget._onTitleClick();
				dojo.stopEvent(e);
			}else if((fromTitle && (c == k.RIGHT_ARROW || c == k.DOWN_ARROW)) ||
					(e.ctrlKey && (c == k.PAGE_DOWN || c == k.TAB))){
				this._adjacent(true)._buttonWidget._onTitleClick();
				dojo.stopEvent(e);
			}
		}
	}
);

dojo.declare("dijit.layout._AccordionInnerContainer",
	[dijit._Widget, dijit._CssStateMixin], {
		// summary:
		//		Internal widget placed as direct child of AccordionContainer.containerNode.
		//		When other widgets are added as children to an AccordionContainer they are wrapped in
		//		this widget.
		
/*=====
		// buttonWidget: String
		//		Name of class to use to instantiate title
		//		(Wish we didn't have a separate widget for just the title but maintaining it
		//		for backwards compatibility, is it worth it?)
		 buttonWidget: null,
=====*/

/*=====
		// contentWidget: dijit._Widget
		//		Pointer to the real child widget
	 	contentWidget: null,
=====*/

		baseClass: "dijitAccordionInnerContainer",

		// tell nested layout widget that we will take care of sizing
		isContainer: true,
		isLayoutContainer: true,

		buildRendering: function(){
			// Builds a template like:
			//	<div class=dijitAccordionInnerContainer>
			//		Button
			//		<div class=dijitAccordionChildWrapper>
			//			ContentPane
			//		</div>
			//	</div>

			// Create wrapper div, placed where the child is now
			this.domNode = dojo.place("<div class='" + this.baseClass + "'>", this.contentWidget.domNode, "after");
			
			// wrapper div's first child is the button widget (ie, the title bar)
			var child = this.contentWidget,
				cls = dojo.getObject(this.buttonWidget);
			this.button = child._buttonWidget = (new cls({
				contentWidget: child,
				label: child.title,
				title: child.tooltip,
				dir: child.dir,
				lang: child.lang,
				iconClass: child.iconClass,
				id: child.id + "_button",
				parent: this.parent
			})).placeAt(this.domNode);
			
			// and then the actual content widget (changing it from prior-sibling to last-child),
			// wrapped by a <div class=dijitAccordionChildWrapper>
			this.containerNode = dojo.place("<div class='dijitAccordionChildWrapper' style='display:none'>", this.domNode);
			dojo.place(this.contentWidget.domNode, this.containerNode);
		},

		postCreate: function(){
			this.inherited(arguments);

			// Map changes in content widget's title etc. to changes in the button
			var button = this.button;
			this._contentWidgetWatches = [
				this.contentWidget.watch('title', dojo.hitch(this, function(name, oldValue, newValue){
					button.set("label", newValue);
				})),
				this.contentWidget.watch('tooltip', dojo.hitch(this, function(name, oldValue, newValue){
					button.set("title", newValue);
				})),
				this.contentWidget.watch('iconClass', dojo.hitch(this, function(name, oldValue, newValue){
					button.set("iconClass", newValue);
				}))
			];
		},

		_setSelectedAttr: function(/*Boolean*/ isSelected){
			this._set("selected", isSelected);
			this.button.set("selected", isSelected);
			if(isSelected){
				var cw = this.contentWidget;
				if(cw.onSelected){ cw.onSelected(); }
			}
		},

		startup: function(){
			// Called by _Container.addChild()
			this.contentWidget.startup();
		},

		destroy: function(){
			this.button.destroyRecursive();

			dojo.forEach(this._contentWidgetWatches || [], function(w){ w.unwatch(); });

			delete this.contentWidget._buttonWidget;
			delete this.contentWidget._wrapperWidget;

			this.inherited(arguments);
		},
		
		destroyDescendants: function(){
			// since getChildren isn't working for me, have to code this manually
			this.contentWidget.destroyRecursive();
		}
});

dojo.declare("dijit.layout._AccordionButton",
	[dijit._Widget, dijit._Templated, dijit._CssStateMixin],
	{
	// summary:
	//		The title bar to click to open up an accordion pane.
	//		Internal widget used by AccordionContainer.
	// tags:
	//		private

	templateString: dojo.cache("dijit.layout", "templates/AccordionButton.html", "<div dojoAttachEvent='onclick:_onTitleClick' class='dijitAccordionTitle'>\n\t<div dojoAttachPoint='titleNode,focusNode' dojoAttachEvent='onkeypress:_onTitleKeyPress'\n\t\t\tclass='dijitAccordionTitleFocus' role=\"tab\" aria-expanded=\"false\"\n\t\t><span class='dijitInline dijitAccordionArrow' role=\"presentation\"></span\n\t\t><span class='arrowTextUp' role=\"presentation\">+</span\n\t\t><span class='arrowTextDown' role=\"presentation\">-</span\n\t\t><img src=\"${_blankGif}\" alt=\"\" class=\"dijitIcon\" dojoAttachPoint='iconNode' style=\"vertical-align: middle\" role=\"presentation\"/>\n\t\t<span role=\"presentation\" dojoAttachPoint='titleTextNode' class='dijitAccordionText'></span>\n\t</div>\n</div>\n"),
	attributeMap: dojo.mixin(dojo.clone(dijit.layout.ContentPane.prototype.attributeMap), {
		label: {node: "titleTextNode", type: "innerHTML" },
		title: {node: "titleTextNode", type: "attribute", attribute: "title"},
		iconClass: { node: "iconNode", type: "class" }
	}),

	baseClass: "dijitAccordionTitle",

	getParent: function(){
		// summary:
		//		Returns the AccordionContainer parent.
		// tags:
		//		private
		return this.parent;
	},

	buildRendering: function(){
		this.inherited(arguments);
		var titleTextNodeId = this.id.replace(' ','_');
		dojo.attr(this.titleTextNode, "id", titleTextNodeId+"_title");
		dijit.setWaiState(this.focusNode, "labelledby", dojo.attr(this.titleTextNode, "id"));
		dojo.setSelectable(this.domNode, false);
	},

	getTitleHeight: function(){
		// summary:
		//		Returns the height of the title dom node.
		return dojo._getMarginSize(this.domNode).h;	// Integer
	},

	// TODO: maybe the parent should set these methods directly rather than forcing the code
	// into the button widget?
	_onTitleClick: function(){
		// summary:
		//		Callback when someone clicks my title.
		var parent = this.getParent();
			parent.selectChild(this.contentWidget, true);
			dijit.focus(this.focusNode);
	},

	_onTitleKeyPress: function(/*Event*/ evt){
		return this.getParent()._onKeyPress(evt, this.contentWidget);
	},

	_setSelectedAttr: function(/*Boolean*/ isSelected){
		this._set("selected", isSelected);
		dijit.setWaiState(this.focusNode, "expanded", isSelected);
		dijit.setWaiState(this.focusNode, "selected", isSelected);
		this.focusNode.setAttribute("tabIndex", isSelected ? "0" : "-1");
	}
});

}

if(!dojo._hasResource["dijit.Tooltip"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Tooltip"] = true;
dojo.provide("dijit.Tooltip");




dojo.declare(
	"dijit._MasterTooltip",
	[dijit._Widget, dijit._Templated],
	{
		// summary:
		//		Internal widget that holds the actual tooltip markup,
		//		which occurs once per page.
		//		Called by Tooltip widgets which are just containers to hold
		//		the markup
		// tags:
		//		protected

		// duration: Integer
		//		Milliseconds to fade in/fade out
		duration: dijit.defaultDuration,

		templateString: dojo.cache("dijit", "templates/Tooltip.html", "<div class=\"dijitTooltip dijitTooltipLeft\" id=\"dojoTooltip\"\n\t><div class=\"dijitTooltipContainer dijitTooltipContents\" dojoAttachPoint=\"containerNode\" role='alert'></div\n\t><div class=\"dijitTooltipConnector\" dojoAttachPoint=\"connectorNode\"></div\n></div>\n"),

		postCreate: function(){
			dojo.body().appendChild(this.domNode);

			this.bgIframe = new dijit.BackgroundIframe(this.domNode);

			// Setup fade-in and fade-out functions.
			this.fadeIn = dojo.fadeIn({ node: this.domNode, duration: this.duration, onEnd: dojo.hitch(this, "_onShow") });
			this.fadeOut = dojo.fadeOut({ node: this.domNode, duration: this.duration, onEnd: dojo.hitch(this, "_onHide") });
		},

		show: function(/*String*/ innerHTML, /*DomNode*/ aroundNode, /*String[]?*/ position, /*Boolean*/ rtl){
			// summary:
			//		Display tooltip w/specified contents to right of specified node
			//		(To left if there's no space on the right, or if rtl == true)

			if(this.aroundNode && this.aroundNode === aroundNode){
				return;
			}

			// reset width; it may have been set by orient() on a previous tooltip show()
			this.domNode.width = "auto";

			if(this.fadeOut.status() == "playing"){
				// previous tooltip is being hidden; wait until the hide completes then show new one
				this._onDeck=arguments;
				return;
			}
			this.containerNode.innerHTML=innerHTML;

			var pos = dijit.placeOnScreenAroundElement(this.domNode, aroundNode, dijit.getPopupAroundAlignment((position && position.length) ? position : dijit.Tooltip.defaultPosition, !rtl), dojo.hitch(this, "orient"));

			// show it
			dojo.style(this.domNode, "opacity", 0);
			this.fadeIn.play();
			this.isShowingNow = true;
			this.aroundNode = aroundNode;
		},

		orient: function(/*DomNode*/ node, /*String*/ aroundCorner, /*String*/ tooltipCorner, /*Object*/ spaceAvailable, /*Object*/ aroundNodeCoords){
			// summary:
			//		Private function to set CSS for tooltip node based on which position it's in.
			//		This is called by the dijit popup code.   It will also reduce the tooltip's
			//		width to whatever width is available
			// tags:
			//		protected
			this.connectorNode.style.top = ""; //reset to default
			
			//Adjust the spaceAvailable width, without changing the spaceAvailable object
			var tooltipSpaceAvaliableWidth = spaceAvailable.w - this.connectorNode.offsetWidth;

			node.className = "dijitTooltip " +
				{
					"BL-TL": "dijitTooltipBelow dijitTooltipABLeft",
					"TL-BL": "dijitTooltipAbove dijitTooltipABLeft",
					"BR-TR": "dijitTooltipBelow dijitTooltipABRight",
					"TR-BR": "dijitTooltipAbove dijitTooltipABRight",
					"BR-BL": "dijitTooltipRight",
					"BL-BR": "dijitTooltipLeft"
				}[aroundCorner + "-" + tooltipCorner];
				
			// reduce tooltip's width to the amount of width available, so that it doesn't overflow screen
			this.domNode.style.width = "auto";
			var size = dojo.contentBox(this.domNode);
			
			var width = Math.min((Math.max(tooltipSpaceAvaliableWidth,1)), size.w);
			var widthWasReduced = width < size.w;
			
			this.domNode.style.width = width+"px";
						
			//Adjust width for tooltips that have a really long word or a nowrap setting
			if(widthWasReduced){
				this.containerNode.style.overflow = "auto"; //temp change to overflow to detect if our tooltip needs to be wider to support the content
				var scrollWidth = this.containerNode.scrollWidth;
				this.containerNode.style.overflow = "visible"; //change it back
				if(scrollWidth > width){
					scrollWidth = scrollWidth + dojo.style(this.domNode,"paddingLeft") + dojo.style(this.domNode,"paddingRight");
					this.domNode.style.width = scrollWidth + "px";
				}
			}
			
			// Reposition the tooltip connector.
			if(tooltipCorner.charAt(0) == 'B' && aroundCorner.charAt(0) == 'B'){
				var mb = dojo.marginBox(node);
				var tooltipConnectorHeight = this.connectorNode.offsetHeight;
				if(mb.h > spaceAvailable.h){
					// The tooltip starts at the top of the page and will extend past the aroundNode
					var aroundNodePlacement = spaceAvailable.h - (aroundNodeCoords.h / 2) - (tooltipConnectorHeight / 2);
					this.connectorNode.style.top = aroundNodePlacement + "px";
					this.connectorNode.style.bottom = "";
				}else{
					// Align center of connector with center of aroundNode, except don't let bottom
					// of connector extend below bottom of tooltip content, or top of connector
					// extend past top of tooltip content
					this.connectorNode.style.bottom = Math.min(
						Math.max(aroundNodeCoords.h/2 - tooltipConnectorHeight/2, 0),
						mb.h - tooltipConnectorHeight) + "px";
					this.connectorNode.style.top = "";
				}
			}else{
				// reset the tooltip back to the defaults
				this.connectorNode.style.top = "";
				this.connectorNode.style.bottom = "";
			}
			
			return Math.max(0, size.w - tooltipSpaceAvaliableWidth);
		},

		_onShow: function(){
			// summary:
			//		Called at end of fade-in operation
			// tags:
			//		protected
			if(dojo.isIE){
				// the arrow won't show up on a node w/an opacity filter
				this.domNode.style.filter="";
			}
		},

		hide: function(aroundNode){
			// summary:
			//		Hide the tooltip

			if(this._onDeck && this._onDeck[1] == aroundNode){
				// this hide request is for a show() that hasn't even started yet;
				// just cancel the pending show()
				this._onDeck=null;
			}else if(this.aroundNode === aroundNode){
				// this hide request is for the currently displayed tooltip
				this.fadeIn.stop();
				this.isShowingNow = false;
				this.aroundNode = null;
				this.fadeOut.play();
			}else{
				// just ignore the call, it's for a tooltip that has already been erased
			}
		},

		_onHide: function(){
			// summary:
			//		Called at end of fade-out operation
			// tags:
			//		protected

			this.domNode.style.cssText="";	// to position offscreen again
			this.containerNode.innerHTML="";
			if(this._onDeck){
				// a show request has been queued up; do it now
				this.show.apply(this, this._onDeck);
				this._onDeck=null;
			}
		}

	}
);

dijit.showTooltip = function(/*String*/ innerHTML, /*DomNode*/ aroundNode, /*String[]?*/ position, /*Boolean*/ rtl){
	// summary:
	//		Display tooltip w/specified contents in specified position.
	//		See description of dijit.Tooltip.defaultPosition for details on position parameter.
	//		If position is not specified then dijit.Tooltip.defaultPosition is used.
	if(!dijit._masterTT){ dijit._masterTT = new dijit._MasterTooltip(); }
	return dijit._masterTT.show(innerHTML, aroundNode, position, rtl);
};

dijit.hideTooltip = function(aroundNode){
	// summary:
	//		Hide the tooltip
	if(!dijit._masterTT){ dijit._masterTT = new dijit._MasterTooltip(); }
	return dijit._masterTT.hide(aroundNode);
};

dojo.declare(
	"dijit.Tooltip",
	dijit._Widget,
	{
		// summary:
		//		Pops up a tooltip (a help message) when you hover over a node.

		// label: String
		//		Text to display in the tooltip.
		//		Specified as innerHTML when creating the widget from markup.
		label: "",

		// showDelay: Integer
		//		Number of milliseconds to wait after hovering over/focusing on the object, before
		//		the tooltip is displayed.
		showDelay: 400,

		// connectId: String|String[]
		//		Id of domNode(s) to attach the tooltip to.
		//		When user hovers over specified dom node, the tooltip will appear.
		connectId: [],

		// position: String[]
		//		See description of `dijit.Tooltip.defaultPosition` for details on position parameter.
		position: [],

		_setConnectIdAttr: function(/*String*/ newId){
			// summary:
			//		Connect to node(s) (specified by id)

			// Remove connections to old nodes (if there are any)
			dojo.forEach(this._connections || [], function(nested){
				dojo.forEach(nested, dojo.hitch(this, "disconnect"));
			}, this);

			// Make connections to nodes in newIds.
			var ary = dojo.isArrayLike(newId) ? newId : (newId ? [newId] : []);
			this._connections = dojo.map(ary, function(id){
				var node = dojo.byId(id);
				return node ? [
					this.connect(node, "onmouseenter", "_onTargetMouseEnter"),
					this.connect(node, "onmouseleave", "_onTargetMouseLeave"),
					this.connect(node, "onfocus", "_onTargetFocus"),
					this.connect(node, "onblur", "_onTargetBlur")
				] : [];
			}, this);
	
			this._set("connectId", newId);

			this._connectIds = ary;	// save as array
		},

		addTarget: function(/*DOMNODE || String*/ node){
			// summary:
			//		Attach tooltip to specified node if it's not already connected

			// TODO: remove in 2.0 and just use set("connectId", ...) interface

			var id = node.id || node;
			if(dojo.indexOf(this._connectIds, id) == -1){
				this.set("connectId", this._connectIds.concat(id));
			}
		},

		removeTarget: function(/*DOMNODE || String*/ node){
			// summary:
			//		Detach tooltip from specified node

			// TODO: remove in 2.0 and just use set("connectId", ...) interface
			
			var id = node.id || node,	// map from DOMNode back to plain id string
				idx = dojo.indexOf(this._connectIds, id);
			if(idx >= 0){
				// remove id (modifies original this._connectIds but that's OK in this case)
				this._connectIds.splice(idx, 1);
				this.set("connectId", this._connectIds);
			}
		},

		buildRendering: function(){
			this.inherited(arguments);
			dojo.addClass(this.domNode,"dijitTooltipData");
		},

		startup: function(){
			this.inherited(arguments);

			// If this tooltip was created in a template, or for some other reason the specified connectId[s]
			// didn't exist during the widget's initialization, then connect now.
			var ids = this.connectId;
			dojo.forEach(dojo.isArrayLike(ids) ? ids : [ids], this.addTarget, this);
		},

		_onTargetMouseEnter: function(/*Event*/ e){
			// summary:
			//		Handler for mouseenter event on the target node
			// tags:
			//		private
			this._onHover(e);
		},

		_onTargetMouseLeave: function(/*Event*/ e){
			// summary:
			//		Handler for mouseleave event on the target node
			// tags:
			//		private
			this._onUnHover(e);
		},

		_onTargetFocus: function(/*Event*/ e){
			// summary:
			//		Handler for focus event on the target node
			// tags:
			//		private

			this._focus = true;
			this._onHover(e);
		},

		_onTargetBlur: function(/*Event*/ e){
			// summary:
			//		Handler for blur event on the target node
			// tags:
			//		private

			this._focus = false;
			this._onUnHover(e);
		},

		_onHover: function(/*Event*/ e){
			// summary:
			//		Despite the name of this method, it actually handles both hover and focus
			//		events on the target node, setting a timer to show the tooltip.
			// tags:
			//		private
			if(!this._showTimer){
				var target = e.target;
				this._showTimer = setTimeout(dojo.hitch(this, function(){this.open(target)}), this.showDelay);
			}
		},

		_onUnHover: function(/*Event*/ e){
			// summary:
			//		Despite the name of this method, it actually handles both mouseleave and blur
			//		events on the target node, hiding the tooltip.
			// tags:
			//		private

			// keep a tooltip open if the associated element still has focus (even though the
			// mouse moved away)
			if(this._focus){ return; }

			if(this._showTimer){
				clearTimeout(this._showTimer);
				delete this._showTimer;
			}
			this.close();
		},

		open: function(/*DomNode*/ target){
 			// summary:
			//		Display the tooltip; usually not called directly.
			// tags:
			//		private

			if(this._showTimer){
				clearTimeout(this._showTimer);
				delete this._showTimer;
			}
			dijit.showTooltip(this.label || this.domNode.innerHTML, target, this.position, !this.isLeftToRight());

			this._connectNode = target;
			this.onShow(target, this.position);
		},

		close: function(){
			// summary:
			//		Hide the tooltip or cancel timer for show of tooltip
			// tags:
			//		private

			if(this._connectNode){
				// if tooltip is currently shown
				dijit.hideTooltip(this._connectNode);
				delete this._connectNode;
				this.onHide();
			}
			if(this._showTimer){
				// if tooltip is scheduled to be shown (after a brief delay)
				clearTimeout(this._showTimer);
				delete this._showTimer;
			}
		},

		onShow: function(target, position){
			// summary:
			//		Called when the tooltip is shown
			// tags:
			//		callback
		},

		onHide: function(){
			// summary:
			//		Called when the tooltip is hidden
			// tags:
			//		callback
		},

		uninitialize: function(){
			this.close();
			this.inherited(arguments);
		}
	}
);

// dijit.Tooltip.defaultPosition: String[]
//		This variable controls the position of tooltips, if the position is not specified to
//		the Tooltip widget or *TextBox widget itself.  It's an array of strings with the following values:
//
//			* before: places tooltip to the left of the target node/widget, or to the right in
//			  the case of RTL scripts like Hebrew and Arabic
//			* after: places tooltip to the right of the target node/widget, or to the left in
//			  the case of RTL scripts like Hebrew and Arabic
//			* above: tooltip goes above target node
//			* below: tooltip goes below target node
//
//		The list is positions is tried, in order, until a position is found where the tooltip fits
//		within the viewport.
//
//		Be careful setting this parameter.  A value of "above" may work fine until the user scrolls
//		the screen so that there's no room above the target node.   Nodes with drop downs, like
//		DropDownButton or FilteringSelect, are especially problematic, in that you need to be sure
//		that the drop down and tooltip don't overlap, even when the viewport is scrolled so that there
//		is only room below (or above) the target node, but not both.
dijit.Tooltip.defaultPosition = ["after", "before"];

}

if(!dojo._hasResource["com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer"] = true;
dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer");

/**
 * Subclass of the AccordianContainer to customize it for our purpose
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer",
		[dijit.layout.AccordionContainer],
		{
	
		templateString : "<div style=\"\" dojoAttachPoint=\"containerNode\">" +
			"</div>",

		widgetsInTemplate : true,

		buttonWidget: "com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionButton",
		
		expandedSections:false,
		
		manualResizing: false,
	
		/**
		 * Build the view, subclass that of the parent but add scroll bars. The parent disables the scroll
		 * bars causing any data that falls outside the viewable area to be unreachable
		 */
		buildRendering: function(){
			this.inherited(arguments);
			//this.domNode.style.overflow = "auto";
		},
		
		paieSize: 0,
		
		defaultSectionSize:300,
	
		/**
		 * Overwrite the superclass implementation to customize for ourselves. Compute the value based on the number of assets within the section.
		 * We could potentially cap this to a max size in the future.
		 * The reason for overwritng is the susperclass behaves differently depending on the browser we are viewing from. In the case of IE
		 * it appears to always come back with a height of around 200 px. In FF it's appears to be based on the size of the smallest section
		 * in the accordion. So if we have one small section and numerous large sections it'll always allocate based ont he smallest (which is
		 * kind of useless)
		 */
		_getTargetHeight: function(/* Node */ node){
			// Slight difference in IE as we have to use images to create the rounded corners so the height per
			// section is a little more
			
			// In the case of the defualt section it'll be expanded before the children are added.
			if (node.childNodes.length == 0)
				return this.defaultSectionSize;
			
			if (this.expandedSections) {
				
				var assetItems = 0;
				var assetItemsRevisions = 0;
				
				if (node.childNodes.length == 1) {
					if (dojo.isIE) {
						assetItems = node.childNodes[0].childNodes.length * 35;
						for (var i=0;i<node.childNodes[0].childNodes.length; i++) {
							assetItemsRevisions = assetItemsRevisions + (node.childNodes[0].childNodes[i].childNodes.length * 30);
						}
						return assetItems+assetItemsRevisions;
					}

					assetItems = node.childNodes[0].childNodes.length * 35;
					for (var i=0;i<node.childNodes[0].childNodes.length; i++) {
						assetItemsRevisions = assetItemsRevisions + (node.childNodes[0].childNodes[i].childNodes.length * 30);
					}
					return assetItems+assetItemsRevisions;
				}
				
				assetItems = node.childNodes.length * 35;
				for (var i=0;i<node.childNodes.length; i++) {
					assetItemsRevisions = assetItemsRevisions + (node.childNodes[i].childNodes.length * 30);
				}
				return assetItems+assetItemsRevisions;
			}
			else {
				// Will do this for now, what I'd like to do is separates section to there own widget and set a size
				if (node.childNodes.length == 1) {
					
					if (node.childNodes[0].id.indexOf("ProcessAppsSection") != -1) {
						return this.processAppsSize(node.childNodes[0]);
					}
					
					// IE is padded due to using graphics for round edges
					if (dojo.isIE == 6)
						return node.childNodes[0].childNodes.length * 58.70;
					
					if (dojo.isIE) {
						//return node.childNodes[0].childNodes.length * 47;
						return node.childNodes[0].childNodes.length * 34;
					}
					
					// Safari doesn't seem to have growth pattern
					if (dojo.isSafari)
						return (node.childNodes[0].childNodes.length * 34) + 10;
					
					//other browsers
					return node.childNodes[0].childNodes.length * 39.06;
				}
				
				return node.childNodes.length * 35;
			}
		},
		
		processAppsSize: function(processApps) {
			if (dojo.isIE && this.paieSize > 0) {
				return this.paieSize;
			}
			
			var tempN = processApps;
			// 3 that don't bubble
			var defaultSize = 90;
			if (dojo.isIE == 6)
				defaultSize = 100;
			
			// Check to see if it have env vars
			if (processApps.children[0].style.display && processApps.children[0].style.display=="none") {
				defaultSize = defaultSize - 20;
			}
				

//			if (dojo.isIE == 6) {
//				// add the 4 non graphic sections and the 3 graphic sections
//				defaultSize = 112 + 140;
//			}

			// figure out the env vars;
			var pa = processApps.children[1].children.length;
			// figure out the toolkits
			var tk = processApps.children[3].children.length;
			
			var totalBubbled = pa + tk + 3;
			
			if (dojo.isIE) {
				if (dojo.isIE > 6)
					defaultSize = defaultSize + (totalBubbled * 33.5);
				else
					defaultSize = defaultSize + (totalBubbled * 48);
			}
			else {
				defaultSize = defaultSize + (totalBubbled * 32);
			}

			// In the case of IE cache it as for some reason it'll call this multiple times, but a child each time?
			if (dojo.isIE && (this.paieSize == 0)) {
				
				if (dojo.isIE == 7)
					defaultSize = defaultSize + 10;
				
				this.paieSize = defaultSize;
			}

			return defaultSize;
			
		},
		
		resizeSelectedPane: function(size) {
			
			// We are triggering a resize of the container. In IE the frameworks received multiple resize events which cause issues
			// Set a flag to prevent this events form being acted upon. 
			this.manualResizing = true;
			
			var openPane = this.selectedChildWidget;
			if(openPane){
				var mySize = this._contentBox;
				
				this._containerContentBox = {
						h: this._getTargetHeight(openPane.domNode) + size,
						w: mySize.w
				};
				openPane.resize(this._containerContentBox);
			}	
		},
		
		/**
		 * Transition is used to slide the accordion from one selected container to another. Override the superclass
		 * as the height isn't desirable in the case of a larger number of accordion sections
		 * @param newWidget: dijit._Widget - The accordion section that is about to be expanded
		 * @param oldWidget:dijit._Widget - The accordion section about to be collapsed
		 * @param animate:boolean - whether to provide an animiation when switching section, meaning a look of sliding from one
		 * section to the other
		 */
		_transition: function(newWidget, oldWidget, animate){
			
			this.manualResizing = false;
			
			if(dojo.isIE < 8){
				// workaround animation bugs by not animating; not worth supporting animation for IE6 & 7
				animate = false;
			}

			if(this._animation){
				// there's an in-progress animation.  speedily end it so we can do the newly requested one
				this._animation.stop(true);
				delete this._animation;
			}

			var self = this;

			if(newWidget){
				newWidget._wrapperWidget.set("selected", true);
				newWidget._wrapperWidget.button.setSelectedState(true);

				var d = this._showChild(newWidget);	// prepare widget to be slid in

				// Size the new widget, in case this is the first time it's being shown,
				// or I have been resized since the last time it was shown.
				// Note that page must be visible for resizing to work.
//				if(this.doLayout && newWidget.resize){
//					newWidget.resize(this._containerContentBox);
//				}
			}

			if(oldWidget){
				oldWidget._wrapperWidget.set("selected", false);
				oldWidget._wrapperWidget.button.setSelectedState(false);
				if(!animate){
					this._hideChild(oldWidget);
				}
			}

			if(animate){
				var newContents = newWidget._wrapperWidget.containerNode,
					oldContents = oldWidget._wrapperWidget.containerNode;

				// During the animation we will be showing two dijitAccordionChildWrapper nodes at once,
				// which on claro takes up 4px extra space (compared to stable AccordionContainer).
				// Have to compensate for that by immediately shrinking the pane being closed.
				var wrapperContainerNode = newWidget._wrapperWidget.containerNode,
					wrapperContainerNodeMargin = dojo._getMarginExtents(wrapperContainerNode),
					wrapperContainerNodePadBorder = dojo._getPadBorderExtents(wrapperContainerNode),
					animationHeightOverhead = wrapperContainerNodeMargin.h + wrapperContainerNodePadBorder.h;

				oldContents.style.height = (self._verticalSpace - animationHeightOverhead) + "px";

				var newWidgetHeight = this._getTargetHeight(newWidget.domNode);
				var oldWidgetHeight = this._getTargetHeight(oldWidget.domNode);
				this._animation = new dojo.Animation({
					node: newContents,
					duration: this.duration,
					curve: [1, this._verticalSpace - animationHeightOverhead - 1],
					onAnimate: function(value){
						value = Math.floor(value);	// avoid fractional values
						//newContents.style.height = value + "px";
						newContents.style.height = newWidgetHeight + "px";
						//oldContents.style.height = (self._verticalSpace - animationHeightOverhead - value) + "px";
						oldContents.style.height = oldWidgetHeight + "px";
					},
					onEnd: function(){
						delete self._animation;
						newContents.style.height = "auto";
						oldWidget._wrapperWidget.containerNode.style.display = "none";
						oldContents.style.height = "auto";
						self._hideChild(oldWidget);
					}
				});
				this._animation.onStop = this._animation.onEnd;
				this._animation.play();
			}

			return d;	// If child has an href, promise that fires when the widget has finished loading
		},
		
		/**
		 * Override the superclass to trigger it's title to be selected
		 * @param child
		 */
		_setupChild: function(child){
			this.inherited(arguments);
			if (child.selected)
				child._wrapperWidget.button.setSelectedState(true);
		},
		

		resize: function(changeSize, resultSize){
			// For now we're going to eat this if it's ie 6. For some reason in IE6 if you have more than a few sections in the accordion
			// this resize triggers an endless loop of resizing. Will need to pick apart this resize to see just what it's doing
			if (dojo.isIE && this.manualResizing)
				return;
			this.inherited(arguments);
		},
		
		/**
		 * Overwrite the supserclass to provide the correct size on the default section
		 */
		layout: function(){
			this.inherited(arguments);

			// Overwrite the initial size of the default pane to prevent cutoff
			var openPane = this.selectedChildWidget;
			if(openPane){
				var mySize = this._contentBox;

				this._containerContentBox = {
						h: this._getTargetHeight(openPane.domNode) + 10,
						w: mySize.w
				};
				openPane.resize(this._containerContentBox);
			}			
		},
		
		prepareAccordianForPrint: function() {
			var children = this.getChildren();
			for (var i=0;i<children.length;i++) {
				var newWidget = children[i];
				var d = this._showChild(newWidget);	// prepare widget to be slid in
			}
			
		}

});

/**
 * Subclass of AccordianButton to custom for our application
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionButton",
		[dijit.layout._AccordionButton],
		{

		templateString: //"<div dojoAttachEvent='onclick:_onTitleClick' class='bpmnAccordionTitle'>" +
			"<div dojoAttachPoint='titleNode,focusNode' dojoAttachEvent='onkeypress:_onTitleKeyPress, onclick:_onTitleClick' class='bpmnAccordionTitle' role=\"tab\" aria-expanded=\"false\">" +
			"<span class='dijitInline dijitAccordionArrow' role=\"presentation\"></span>" +
			"<img src=\"${_blankGif}\" alt=\"\" class=\"dijitIcon\" dojoAttachPoint='iconNode' style=\"vertical-align: middle;\" role=\"presentation\"/>" +
			"<span role=\"presentation\" dojoAttachPoint='titleTextNode' class='dijitAccordionText'></span>" +
			//"</div>" +
			"</div>",

		baseClass: "bpmnAccordionTitle",

		setSelectedState: function(/*Boolean*/ isSelected){
			this.selected = isSelected;
			// overwite the superclass behaviour for now, selected colour doesn't change
			dojo[(isSelected ? "addClass" : "removeClass")](this.titleNode,"bpmnAccordionSelectedTitle");
			dijit.setWaiState(this.focusNode, "expanded", isSelected);
			dijit.setWaiState(this.focusNode, "selected", isSelected);
			this.focusNode.setAttribute("tabIndex", isSelected ? "0" : "-1");
			var t = this.titleTextNode;
			
			if (this.titleTextNode.childNodes.length > 1) {
				if (isSelected) {
					this.titleTextNode.childNodes[1].style.visibility="visible";
					this.titleTextNode.childNodes[2].style.visibility="visible";
				}
				else  {
					this.titleTextNode.childNodes[1].style.visibility="hidden";
					this.titleTextNode.childNodes[2].style.visibility="hidden";
				}
			}
		}
});

}

if(!dojo._hasResource["dijit.form.CheckBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.CheckBox"] = true;
dojo.provide("dijit.form.CheckBox");



dojo.declare(
	"dijit.form.CheckBox",
	dijit.form.ToggleButton,
	{
		// summary:
		// 		Same as an HTML checkbox, but with fancy styling.
		//
		// description:
		//		User interacts with real html inputs.
		//		On onclick (which occurs by mouse click, space-bar, or
		//		using the arrow keys to switch the selected radio button),
		//		we update the state of the checkbox/radio.
		//
		//		There are two modes:
		//			1. High contrast mode
		//			2. Normal mode
		//
		//		In case 1, the regular html inputs are shown and used by the user.
		//		In case 2, the regular html inputs are invisible but still used by
		//		the user. They are turned quasi-invisible and overlay the background-image.

		templateString: dojo.cache("dijit.form", "templates/CheckBox.html", "<div class=\"dijit dijitReset dijitInline\" role=\"presentation\"\n\t><input\n\t \t${!nameAttrSetting} type=\"${type}\" ${checkedAttrSetting}\n\t\tclass=\"dijitReset dijitCheckBoxInput\"\n\t\tdojoAttachPoint=\"focusNode\"\n\t \tdojoAttachEvent=\"onclick:_onClick\"\n/></div>\n"),

		baseClass: "dijitCheckBox",

		// type: [private] String
		//		type attribute on <input> node.
		//		Overrides `dijit.form.Button.type`.  Users should not change this value.
		type: "checkbox",

		// value: String
		//		As an initialization parameter, equivalent to value field on normal checkbox
		//		(if checked, the value is passed as the value when form is submitted).
		//
		//		However, get('value') will return either the string or false depending on
		//		whether or not the checkbox is checked.
		//
		//		set('value', string) will check the checkbox and change the value to the
		//		specified string
		//
		//		set('value', boolean) will change the checked state.
		value: "on",

		// readOnly: Boolean
		//		Should this widget respond to user input?
		//		In markup, this is specified as "readOnly".
		//		Similar to disabled except readOnly form values are submitted.
		readOnly: false,
		
		// the attributeMap should inherit from dijit.form._FormWidget.prototype.attributeMap
		// instead of ToggleButton as the icon mapping has no meaning for a CheckBox
		attributeMap: dojo.delegate(dijit.form._FormWidget.prototype.attributeMap, {
			readOnly: "focusNode"
		}),

		_setReadOnlyAttr: function(/*Boolean*/ value){
			this._set("readOnly", value);
			dojo.attr(this.focusNode, 'readOnly', value);
			dijit.setWaiState(this.focusNode, "readonly", value);
		},

		_setValueAttr: function(/*String|Boolean*/ newValue, /*Boolean*/ priorityChange){
			// summary:
			//		Handler for value= attribute to constructor, and also calls to
			//		set('value', val).
			// description:
			//		During initialization, just saves as attribute to the <input type=checkbox>.
			//
			//		After initialization,
			//		when passed a boolean, controls whether or not the CheckBox is checked.
			//		If passed a string, changes the value attribute of the CheckBox (the one
			//		specified as "value" when the CheckBox was constructed (ex: <input
			//		dojoType="dijit.CheckBox" value="chicken">)
			if(typeof newValue == "string"){
				this._set("value", newValue);
				dojo.attr(this.focusNode, 'value', newValue);
				newValue = true;
			}
			if(this._created){
				this.set('checked', newValue, priorityChange);
			}
		},
		_getValueAttr: function(){
			// summary:
			//		Hook so get('value') works.
			// description:
			//		If the CheckBox is checked, returns the value attribute.
			//		Otherwise returns false.
			return (this.checked ? this.value : false);
		},

		// Override dijit.form.Button._setLabelAttr() since we don't even have a containerNode.
		// Normally users won't try to set label, except when CheckBox or RadioButton is the child of a dojox.layout.TabContainer
		_setLabelAttr: undefined,

		postMixInProperties: function(){
			if(this.value == ""){
				this.value = "on";
			}

			// Need to set initial checked state as part of template, so that form submit works.
			// dojo.attr(node, "checked", bool) doesn't work on IEuntil node has been attached
			// to <body>, see #8666
			this.checkedAttrSetting = this.checked ? "checked" : "";

			this.inherited(arguments);
		},

		 _fillContent: function(/*DomNode*/ source){
			// Override Button::_fillContent() since it doesn't make sense for CheckBox,
			// since CheckBox doesn't even have a container
		},

		reset: function(){
			// Override ToggleButton.reset()

			this._hasBeenBlurred = false;

			this.set('checked', this.params.checked || false);

			// Handle unlikely event that the <input type=checkbox> value attribute has changed
			this._set("value", this.params.value || "on");
			dojo.attr(this.focusNode, 'value', this.value);
		},

		_onFocus: function(){
			if(this.id){
				dojo.query("label[for='"+this.id+"']").addClass("dijitFocusedLabel");
			}
			this.inherited(arguments);
		},

		_onBlur: function(){
			if(this.id){
				dojo.query("label[for='"+this.id+"']").removeClass("dijitFocusedLabel");
			}
			this.inherited(arguments);
		},

		_onClick: function(/*Event*/ e){
			// summary:
			//		Internal function to handle click actions - need to check
			//		readOnly, since button no longer does that check.
			if(this.readOnly){
				dojo.stopEvent(e);
				return false;
			}
			return this.inherited(arguments);
		}
	}
);

dojo.declare(
	"dijit.form.RadioButton",
	dijit.form.CheckBox,
	{
		// summary:
		// 		Same as an HTML radio, but with fancy styling.

		type: "radio",
		baseClass: "dijitRadio",

		_setCheckedAttr: function(/*Boolean*/ value){
			// If I am being checked then have to deselect currently checked radio button
			this.inherited(arguments);
			if(!this._created){ return; }
			if(value){
				var _this = this;
				// search for radio buttons with the same name that need to be unchecked
				dojo.query("INPUT[type=radio]", this.focusNode.form || dojo.doc).forEach( // can't use name= since dojo.query doesn't support [] in the name
					function(inputNode){
						if(inputNode.name == _this.name && inputNode != _this.focusNode && inputNode.form == _this.focusNode.form){
							var widget = dijit.getEnclosingWidget(inputNode);
							if(widget && widget.checked){
								widget.set('checked', false);
							}
						}
					}
				);
			}
		},

		_clicked: function(/*Event*/ e){
			if(!this.checked){
				this.set('checked', true);
			}
		}
	}
);

}

if(!dojo._hasResource["dojox.html.ellipsis"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.html.ellipsis"] = true;
dojo.provide("dojox.html.ellipsis");

/*=====
dojox.html.ellipsis = {
	// summary: offers cross-browser support for text-overflow: ellipsis
	//
	// description: Add "dojoxEllipsis" on any node that you want to ellipsis-ize. In order to function properly,
	//	the node with the dojoxEllipsis class set on it should be a child of a node with a defined width.
	//	It should also be a block-level element (i.e. <div>) - it will not work on td elements.
	//	NOTE: When using the dojoxEllipsis class within tables, the table needs to have the table-layout: fixed style
}
=====*/

(function(d){
	if(d.isMoz){ //TODO: feature detect text-overflow in computed style?
		// The delay (in ms) to wait so that we don't keep querying when many
		// changes happen at once - set config "dojoxFFEllipsisDelay" if you
		// want a different value
		var delay = 1;
		if("dojoxFFEllipsisDelay" in d.config){
			delay = Number(d.config.dojoxFFEllipsisDelay);
			if(isNaN(delay)){
				delay = 1;
			}
		}
		try{
			var createXULEllipsis = (function(){
				// Create our stub XUL elements for cloning later
				// NOTE: this no longer works as of FF 4.0:
				// https://developer.mozilla.org/En/Firefox_4_for_developers#Remote_XUL_support_removed
				var sNS = 'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul';
				var xml = document.createElementNS(sNS, 'window');
				var label = document.createElementNS(sNS, 'description');
				label.setAttribute('crop', 'end');
				xml.appendChild(label);

				return function(/* Node */ n){
					// Summary:
					//		Given a node, it creates the XUL and sets its
					//		content so that it will have an ellipsis
					var x = xml.cloneNode(true);
					x.firstChild.setAttribute('value', n.textContent);
					n.innerHTML = '';
					n.appendChild(x);
				};
			})();
		}catch(e){}
		
		// Create our iframe elements for cloning later
		var create = d.create;
		var dd = d.doc;
		var dp = d.place;
		var iFrame = create("iframe", {className: "dojoxEllipsisIFrame",
					src: "javascript:'<html><head><script>if(\"loadFirebugConsole\" in window){window.loadFirebugConsole();}</script></head><body></body></html>'"});
		var rollRange = function(/* W3C Range */ r, /* int? */ cnt){
			// Summary:
			//		Rolls the given range back one character from the end
			//
			//	r: W3C Range
			//		The range to roll back
			//	cnt: int?
			//		An optional number of times to roll back (defaults 1)
			if(r.collapsed){
				// Do nothing - we are already collapsed
				return;
			}
			if(cnt > 0){
				do{
					rollRange(r);
					cnt--;
				}while(cnt);
				return;
			}
			if(r.endContainer.nodeType == 3 && r.endOffset > 0){
				r.setEnd(r.endContainer, r.endOffset - 1);
			}else if(r.endContainer.nodeType == 3){
				r.setEndBefore(r.endContainer);
				rollRange(r);
				return;
			}else if(r.endOffset && r.endContainer.childNodes.length >= r.endOffset){
				var nCont = r.endContainer.childNodes[r.endOffset - 1];
				if(nCont.nodeType == 3){
					r.setEnd(nCont, nCont.length - 1);
				}else if(nCont.childNodes.length){
					r.setEnd(nCont, nCont.childNodes.length);
					rollRange(r);
					return;
				}else{
					r.setEndBefore(nCont);
					rollRange(r);
					return;
				}
			}else{
				r.setEndBefore(r.endContainer);
				rollRange(r);
				return;
			}
		};
		var createIFrameEllipsis = function(/* Node */ n){
			// Summary:
			//		Given a node, it creates an iframe and and ellipsis div and
			//		sets up the connections so that they will work correctly.
			//		This function is used when createXULEllipsis is not able
			//		to be used (because there is markup within the node) - it's
			//		a bit slower, but does the trick
			var c = create("div", {className: "dojoxEllipsisContainer"});
			var e = create("div", {className: "dojoxEllipsisShown", style: {display: "none"}});
			n.parentNode.replaceChild(c, n);
			c.appendChild(n);
			c.appendChild(e);
			var i = iFrame.cloneNode(true);
			var ns = n.style;
			var es = e.style;
			var ranges;
			var resizeNode = function(){
				ns.display = "";
				es.display = "none";
				if(n.scrollWidth <= n.offsetWidth){ return; }
				var r = dd.createRange();
				r.selectNodeContents(n);
				ns.display = "none";
				es.display = "";
				var done = false;
				do{
					var numRolls = 1;
					dp(r.cloneContents(), e, "only");
					var sw = e.scrollWidth, ow = e.offsetWidth;
					done = (sw <= ow);
					var pct = (1 - ((ow * 1) / sw));
					if(pct > 0){
						numRolls = Math.max(Math.round(e.textContent.length * pct) - 1, 1);
					}
					rollRange(r, numRolls);
				}while(!r.collapsed && !done);
			};
			i.onload = function(){
				i.contentWindow.onresize = resizeNode;
				resizeNode();
			};
			c.appendChild(i);
		};

		// Function for updating the ellipsis
		var hc = d.hasClass;
		var doc = d.doc;
		var s, fn, opt;
		if(doc.querySelectorAll){
			s = doc;
			fn = "querySelectorAll";
			opt = ".dojoxEllipsis";
		}else if(doc.getElementsByClassName){
			s = doc;
			fn = "getElementsByClassName";
			opt = "dojoxEllipsis";
		}else{
			s = d;
			fn = "query";
			opt = ".dojoxEllipsis";
		}
		fx = function(){
			d.forEach(s[fn].apply(s, [opt]), function(n){
				if(!n || n._djx_ellipsis_done){ return; }
				n._djx_ellipsis_done = true;
				if(createXULEllipsis && n.textContent == n.innerHTML && !hc(n, "dojoxEllipsisSelectable")){
					// We can do the faster XUL version, instead of calculating
					createXULEllipsis(n);
				}else{
					createIFrameEllipsis(n);
				}
			});
		};
		
		d.addOnLoad(function(){
			// Apply our initial stuff
			var t = null;
			var c = null;
			var connFx = function(){
				if(c){
					// disconnect us - so we don't fire anymore
					d.disconnect(c);
					c = null;
				}
				if(t){ clearTimeout(t); }
				t = setTimeout(function(){
					t = null;
					fx();
					// Connect to the modified function so that we can catch
					// our next change
					c = d.connect(d.body(), "DOMSubtreeModified", connFx);
				}, delay);
			};
			connFx();
		});
	}
})(dojo);

}

if(!dojo._hasResource["com.ibm.bpm.wpd.util.BidiUtils"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.util.BidiUtils"] = true;
dojo.provide("com.ibm.bpm.wpd.util.BidiUtils");

/**
 * BidiUtils to include utilities to determine the Base Text Direction and return
 * the corresponding HTML direction setting.
 */

/**
 * Bidi constants
 */
var DEFAULT = 0;
var LTR = 1;
var RTL = 2;
var CONTEXTUAL = 3;

/**
 * Return true if a given ch is a Bidi character
 * @param ch
 * @returns {Boolean}
 */
com.ibm.bpm.wpd.util.BidiUtils.isBidiChar = function (ch){
	if (ch >= 0x05d0 && ch <= 0x065f ||
		ch >= 0x066a && ch <= 0x06ef ||
		ch >= 0x06fa && ch <= 0x07ff ||
		ch >= 0xfb1d && ch <= 0xfdff ||
		ch >= 0xfe70 && ch <= 0xfefc)
		return true;
	else
		return false;
};

/**
 * Return true if a given ch is a Latin character
 * @param ch
 * @returns {Boolean}
 */
com.ibm.bpm.wpd.util.BidiUtils.isLatinChar = function (ch){
    if((ch > 64 && ch < 91)||(ch > 96 && ch < 123))
        return true;
    else            
    	return false;    
};


/**
 * Check the direction for the given string
 * @param text
 * @return LTR or RTL
 */
com.ibm.bpm.wpd.util.BidiUtils.checkContextual = function (text){
	var len = text.length;
	for(var i = 0;i < len;i++)  {
		symbol = text.charCodeAt(i);
		if(this.isBidiChar(symbol))
			return RTL;
		else if(this.isLatinChar(symbol))
			return LTR;
	}
	return LTR;
};


/**
 * Check the direction for the given string
 * @param text
 * @return boolean
// */
//com.ibm.bpm.wpd.util.BidiUtils.isContextualRTL = function (text){
//	var contextualValue = this.checkContextual(text);
//	if (RTL==contextualValue)
//		return true;
//	return false;
//};

/**
 * Check if there is any character non-Latin
 * Called externally
 * @param text
 * @return boolean
 */
com.ibm.bpm.wpd.util.BidiUtils.hasNonLatinChar = function (text){
	var len = text.length;
	for(var i = 0;i < len;i++)  {
		symbol = text.charCodeAt(i);
		if(symbol!=32 && !this.isLatinChar(symbol)) 
			return true;
	}
	return false;
};


/**
 * Return the bidi direction value (LTR or RTL) based on the text and the preference.
 * @param text
 * @return LTR or RTL
 */
com.ibm.bpm.wpd.util.BidiUtils.getDir = function (text){
	// get context from the preference page: DEFAULT, LTR, RTL or CONTEXTUAL
	var btd = "default";

	// Check to see if the global has been created. The global is defined in the bootstrap, but depending on the component that
	// uses the base code the bootstrap might not have been invoked. As well check for localization type. It might be set differently
	// depending on the product using the base.
	if (dojo.global.BPM.WPD_ModelTypeProviderRegistry) {
		var dojoGlobal = dojo.global.BPM.WPD_ModelTypeProviderRegistry._docTypeProviderMap;
		if (dojoGlobal.ProcessInstanceType && dojoGlobal.ProcessInstanceType.config && dojoGlobal.ProcessInstanceType.config.userBTD) {
			btd = dojoGlobal.ProcessInstanceType.config.userBTD;	
		}
	}
	
	if (!btd) {
		var stateModel = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
		if (stateModel)
			btd = stateModel.getBTDPreference();
	}
	
	// parse the last part only
	if (!btd)
		btd = "default";
	var lastDot = btd.lastIndexOf('.');
	if (lastDot>=0 && lastDot<btd.length-1) {
		btd = btd.substring(lastDot+1);
	}
	if (btd=="default")
		dir = DEFAULT;
	else
	if (btd=="ltr")
		dir = LTR;
	else
	if (btd=="rtl")
		dir = RTL;
	else
	if (btd=="contextual" || btd == "ctx")
		dir = CONTEXTUAL;
	else
		dir = DEFAULT;
	if (dir==DEFAULT || dir==LTR)
		return LTR;
	else
	if (dir==RTL)
		return RTL;
	else {
		// assume check context
		return this.checkContextual(text);
	}
};

/**
 * Return the bidi direction string (ltr or rtl) based on the text and the preference.
 * @param text
 * @return "ltr" or "rtl"
 */
com.ibm.bpm.wpd.util.BidiUtils.getDirValue = function (text){
	var dir = this.getDir(text);
	if (dir==RTL)
		return "rtl";
	else
		return "ltr";
};


/**
 * Return the RTL text with the (), {} and [] in the right direction
 * @param text
 * @return String
 */
com.ibm.bpm.wpd.util.BidiUtils.getRTLTextWithBracket = function (text){
    var dummyEle = document.createElement("title");
    var result = "";
	for (var i=0; i<text.length; i++) {
		if (text[i]=='(' || text[i]=='{' || text[i]=='[') {
			result += "&#x202b;";
		}
		else
		if (text[i]==')' || text[i]=='}' || text[i]==']') {
			result += "&#x202c;";
		}
		result += text[i];
	}
	return result;
};

/**
 * Return the Calendar type based on the preference.
 * @return calendarPreference// "gregorian", "islamic", "hebrew"
 */
//com.ibm.bpm.wpd.util.BidiUtils.getCalendarType = function (){
//	// get context from the preference page: DEFAULT, LTR, RTL or CONTEXTUAL
//	return com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().getCalendarPreference();
//};

/**
 * Return the calendar date type value based on the calendar preference
 * @return calendar date time value
 */
//com.ibm.bpm.wpd.util.BidiUtils.getDateTimeValue = function(value) {
//	var calendarType = this.getCalendarType();
//	var dateFormat;
//	var timeFormat;
//    if (calendarType == "islamic") {
//        dateFormat = "MMMM d, yyyy h:mm:ss a";
//        timeFormat = "h:mm:ss a";
//        var dateHij = dojox.date.islamic.locale.parse(value, {datePattern: dateFormat, selector: "date"});
//        return dojox.date.islamic.locale.parse(dateHij, {datePattern: dateFormat, selector: "date"});
//    } 
//    else if (calendarType == "hebrew") {
//        dateFormat = "dd MMMM yyyy HH:mm:ss";
//        timeFormat = "HH:mm:ss";
//        return dojox.date.hebrew.locale.parse(value, {datePattern: dateFormat, selector: "date"});
//        return dojox.date.hebrew.locale.parse(dateHeb, {datePattern: dateFormat, selector: "date"});
//    }
//    return value;
//};

}

if(!dojo._hasResource["com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection"] = true;
dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection");







/**
 * Asset Process Apps Section Widget used to add the process apps section into the asset list
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection",	[ dijit._Widget, dijit._Templated ], {
	
	templateString:"<div>\n   <div style=\"clear: both;\" dojoAttachPoint='processAppsEnvVarsTitles'>\n      <div class=\"processAppsEnvVarsTitle\">${messages.ALPS_ENVIRONMENT_VARIABLES}</div>\n      <div class=\"processAppsEnvVarsTitle\">${messages.ALPS_DEFAULT}</div>\n      <div class=\"processAppsEnvVarsTitle\">${messages.ALPS_DEVELOPMENT}</div>\n      <div class=\"processAppsEnvVarsTitle\">${messages.ALPS_TEST}</div>\n      <div class=\"processAppsEnvVarsTitle\">${messages.ALPS_STAGE}</div>\n      <div class=\"processAppsEnvVarsTitleRight\">${messages.ALPS_Production}</div>\n   </div>\n   <div style=\"clear: both;\" dojoAttachPoint='processAppsEnvVars'></div>\n   <div class=\"processAppsCoachesTitle\">${messages.ALPS_TOOLKITS}</div>\n   <div dojoAttachPoint='processAppstoolkits'></div>\n   <div class=\"processAppsCoachesTitle\">${messages.ALPS_COACH_OVERRIDES}</div>\n   <div dojoAttachPoint='processAppsCoachesXSL' class=\"processAppsCoachesSection\">\n<!--   \t <div class=\"processAppsCoachesLeft\">${messages.ALPS_COACH_TRANS}</div>-->\n<!--     <div class=\"processAppsCoachesRight\" dojoAttachPoint='processAppsCoachesXSL'></div>-->\n   </div>\n   <div dojoAttachPoint='processAppsCoachesCSS' class=\"processAppsCoachesSection\">\n<!--      <div class=\"processAppsCoachesLeft\">${messages.ALPS_COACH_OVERRIDE_CSS}</div>-->\n<!--      <div class=\"processAppsCoachesRight\" dojoAttachPoint='processAppsCoachesCSS'></div>-->\n   </div>\n   <div style='width: 50%' class=\"processAppsCoachesTitle\">${messages.ALPS_BUSINESS_MONITOR_TRACKING}</div>\n   <div dojoAttachPoint='processAppMonitorCheckbox' class=\"processAppsCoachesSection\">\n<!--      <div class=\"processAppsCheckboxLabel\">${messages.ALPS_ENABLE_TRACKING}</div>-->\n<!--      <div  dojoType=\"dijit.form.CheckBox\" class='processAppsCheckBox' dojoAttachPoint='processAppMonitorCheckbox'></div>-->\n</div>\n",

	widgetsInTemplate : true,

	parent: null,
	processAppSetting:{},
	
	constructor: function() {
		
	},
	/**
	 * Insert the process app settings section.
	 * Investigate moving to it's separate widget
	 * @param sectionDiv
	 */
	postCreate: function() {
		this.insertPAEnvironmentVariables();
		this.insertToolkits();
		this.insertCoaches();
		this.insertBusinessMonitorTracking();
	},
	
	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListProcessAppsResources");
	},
	
	/**
	 * Insert the environment variables into the environment variables section
	 */
	insertPAEnvironmentVariables: function() {

		// hide section
		if (this.processAppSetting.envVars.length == 0) {
			this.processAppsEnvVarsTitles.style.visibility = 'hidden';
			this.processAppsEnvVarsTitles.style.display = 'none';
		}
		
		for (var i=0;i< this.processAppSetting.envVars.length;i++) {
			var environmentVariable = this.processAppSetting.envVars[i];
			var varDiv = document.createElement("div");
			
			var nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVarsDefault";
			var innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(environmentVariable.name);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = environmentVariable.name;

			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVars";
			var tempName = environmentVariable["default"];
			if (!tempName)
				tempName="";
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>20) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>", // Bidi support
		            	label: tempName,
			            position: ["above","below"]
		      	  	});
			}
			
			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVars";
			tempName = this.getAttributeValue(environmentVariable.varDefaults,"development");
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>20) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>", // Bidi support
		            	label: tempName,
			            position: ["above","below"]
		      	  	});
			}
			
			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVars";
			tempName = this.getAttributeValue(environmentVariable.varDefaults,"test");
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>20) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>", // Bidi support  
		            	label: tempName,   
			            position: ["above","below"]
		      	  	});
			}

			
			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVars";
			tempName = this.getAttributeValue(environmentVariable.varDefaults,"staging");
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>20) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>",  // Bidi support
		            	label: tempName, 
			            position: ["above","below"]
		      	  	});
			}

			
			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVarsRight";
			tempName = this.getAttributeValue(environmentVariable.varDefaults,"production");
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			innerNameDiv.style.paddingLeft = "4px";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>40) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>", // Bidi support
		            	label: tempName,
			            position: ["above","below"]
		      	  	});
			}
			
//			if (dojo.isIE) {
//				varDiv.style.backgroundColor = "white";
//				varDiv.style.height = "17px";
//				varDiv.style.clear = "both";
//				this.insertIERoundedBorder(this.processAppsEnvVars, varDiv);
//			}
//			else {
				this.processAppsEnvVars.appendChild(varDiv);
				varDiv.className = "processAppsEnvVarsItem";
//			}
		}
	},
	
	/**
	 * find the environment variable in the variable list. Env vars are listed as key/pairs
	 * @param attributes - Object the environment variable 
	 * @param key - String key to search for
	 * @returns
	 */
	getAttributeValue: function(attributes, key) {
		if (!attributes || attributes.length == 0)
			return "";
		
		for (var i=0;i<attributes.length;i++) {
			var att = attributes[i];
			if (att.type == key)
				return att.value;
		}
		
		return "";
	},
	
	/**
	 * Insert the toolkits into the toolkit section should they exist
	 */
	insertToolkits: function() {
		for (var i=0;i< this.processAppSetting.projDeps.length;i++) {
			
//			if(dojo.isIE) {
//				var toolkit = this.processAppSetting.projDeps[i];
//				var textDiv = document.createElement("div");
//				textDiv.innerHTML = toolkit.projectName + " (" + toolkit.snapshotName + ")";
//				//textDiv.style.backgroundColor = "rgb(247, 247, 247)";
//				textDiv.style.backgroundColor = "white";
//				
//				// Since IE is behind the times
//				this.insertIERoundedBorder(this.processAppstoolkits, textDiv);
//			}
//			else {
				var toolkit = this.processAppSetting.projDeps[i];
				var varDiv = document.createElement("div");
				this.processAppstoolkits.appendChild(varDiv);
				varDiv.className = "processAppsEnvVarsItem";
//				var dirProjectName =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(toolkit.projectName);  // Bidi support
//				var dirSnapshotName =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(toolkit.snapshotName);
//				varDiv.innerHTML = "<span dir='" + dirProjectName + "'>" + toolkit.projectName 
//					+ "</span> <span dir='" + dirSnapshotName + "'>(" + toolkit.snapshotName + ")</span>";
				varDiv.innerHTML = toolkit.projectName + "(" + toolkit.snapshotName + ")";
//			}
		}
	},
	
	insertIERoundedBorder: function(parentDiv, textDiv) {

		var mainDiv = document.createElement("div");
		mainDiv.className="alsgrowablecontainer";
		parentDiv.appendChild(mainDiv);

		// Add the top right image
		var topDiv = document.createElement("div");
		topDiv.className="alstop";
		var topSpan = document.createElement("span");
		topDiv.appendChild(topSpan);
		mainDiv.appendChild(topDiv);

		// Create the inner portion, we are in effect just wrapping our asset list section here
		var innerDiv = document.createElement("div");
		innerDiv.className = "alsright";
		mainDiv.appendChild(innerDiv);
		innerDiv.appendChild(textDiv);
		var bottomDiv = document.createElement("div");
		bottomDiv.className="alsbottom";
		var bottomSpan = document.createElement("span");
		bottomDiv.appendChild(bottomSpan);
		mainDiv.appendChild(bottomDiv);
	},
	
	/**
	 * Insert the coaches into the coaches section
	 */
	insertCoaches: function() {
		
		var coachXSLLeft = document.createElement("div");
		coachXSLLeft.className = 'processAppsCoachesLeft';
		coachXSLLeft.innerHTML = this.messages.ALPS_COACH_TRANS;
		
		var coachXSLRight = document.createElement("div");
		coachXSLRight.className = 'processAppsCoachesRight';
		
		if (this.processAppSetting.projDefaults.defaultXsl)
			coachXSLRight.innerHTML = this.processAppSetting.projDefaults.defaultXsl;
		else
			coachXSLRight.innerHTML = "";
		
//		if (dojo.isIE) {
//			this.processAppsCoachesXSL.className = "";
//			
//			var textDiv = document.createElement("div");
//			//textDiv.style.backgroundColor = "rgb(247, 247, 247)";
//			textDiv.style.backgroundColor = "white";
//			textDiv.style.height = "17px";
//			
//			//var innerDiv = document.createElement("div");
//			//innerDiv.style.height = "20px";
//			//innerDiv.appendChild(coachXSLLeft);
//			
//			textDiv.appendChild(coachXSLLeft);
//			textDiv.appendChild(coachXSLRight);
//			
//			this.insertIERoundedBorder(this.processAppsCoachesXSL, textDiv);
//		}
//		else {
			this.processAppsCoachesXSL.appendChild(coachXSLLeft);
			this.processAppsCoachesXSL.appendChild(coachXSLRight);
//		}
		
		
		coachXSLLeft = document.createElement("div");
		coachXSLLeft.className = 'processAppsCoachesLeft';
		coachXSLLeft.innerHTML = this.messages.ALPS_COACH_OVERRIDE_CSS;
		
		coachXSLRight = document.createElement("div");
		coachXSLRight.className = 'processAppsCoachesRight';
		if (this.processAppSetting.projDefaults.defaultCss)
			coachXSLRight.innerHTML = this.processAppSetting.projDefaults.defaultCss;
		else
			coachXSLRight.innerHTML = "";
		
//		if (dojo.isIE) {
//			this.processAppsCoachesCSS.className = "";
//			var textDiv = document.createElement("div");
//			//textDiv.style.backgroundColor = "rgb(247, 247, 247)";
//			textDiv.style.backgroundColor = "white";
//			textDiv.style.height = "17px";
//			
//			textDiv.appendChild(coachXSLLeft);
//			textDiv.appendChild(coachXSLRight);
//			
//			this.insertIERoundedBorder(this.processAppsCoachesCSS, textDiv);
//		}
//		else {
			this.processAppsCoachesCSS.appendChild(coachXSLLeft);
			this.processAppsCoachesCSS.appendChild(coachXSLRight);
//		}
	},
	
	/**
	 * Insert the business monitoring section
	 */
	insertBusinessMonitorTracking: function() {
//		this.processAppMonitorCheckbox.readOnly = true;
//		this.processAppMonitorCheckbox._setValueAttr(this.processAppSetting.projDefaults.isWbmEnabled,true);
//		
		
		var monitoringLeft = document.createElement("div");
		monitoringLeft.className = 'processAppsCheckboxLabel';
		monitoringLeft.innerHTML = this.messages.ALPS_ENABLE_TRACKING;
		
		var monitoringRight = new dijit.form.CheckBox({
	            name: "monitoringRight",
	            checked: this.processAppSetting.projDefaults.isWbmEnabled,
	            readOnly: true
	        });

//		if (dojo.isIE) {
//			this.processAppMonitorCheckbox.className = "";
//			var textDiv = document.createElement("div");
//			//textDiv.style.backgroundColor = "rgb(247, 247, 247)";
//			textDiv.style.backgroundColor = "white";
//			textDiv.style.height = "17px";
//			
//			textDiv.appendChild(monitoringLeft);
//			textDiv.appendChild(monitoringRight.domNode);
//			
//			this.insertIERoundedBorder(this.processAppMonitorCheckbox, textDiv);
//		}
//		else {
			this.processAppMonitorCheckbox.appendChild(monitoringLeft);
			this.processAppMonitorCheckbox.appendChild(monitoringRight.domNode);
//		}		
	}
});


}

if(!dojo._hasResource["com.ibm.bpm.wpd.util.Helper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.util.Helper"] = true;
dojo.provide("com.ibm.bpm.wpd.util.Helper");


com.ibm.bpm.wpd.util.Helper.text2htmlText = function(s)
{
	if(s ==null || s.length <= 0) 
		return s;

	s = s.replace(/&/g,"&amp;");
	s = s.replace(/>/g,"&gt;");
	s = s.replace(/</g,"&lt;");
	s = s.replace(/\"/g,"&quot;");
	s = s.replace(/'/g,"&#39;");
			   
	if (s.indexOf("&amp;amp;") != -1)
		s = s.replace("&amp;amp;","&amp;");
	
	return s;
}

com.ibm.bpm.wpd.util.Helper.text2htmlText_1 = function(s)
{
	if(s ==null || s.length <= 0) 
		return s;

	s = s.replace(/&/g,"&amp;");
	s = s.replace(/>/g,"&gt;");
	s = s.replace(/</g,"&lt;");
	s = s.replace(/\"/g,"&quot;");
	s = s.replace(/'/g,"&#39;");
	s = s.replace(/(\r\n|\n|\r)/gm,"");
			   
	if (s.indexOf("&amp;amp;") != -1)
		s = s.replace("&amp;amp;","&amp;");
	
	return s;
}

com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding = function(s) // add this method for rich text format supporting
{
	if(s == null || s.length <= 0) 
		return s;

//	s = s.replace(/&/g,"&amp;");
//	s = s.replace(/>/g,"&gt;");
//	s = s.replace(/</g,"&lt;");
//	s = s.replace(/\"/g,"&quot;");
	s = s.replace(/'/g,"&#39;");
			   
	if (s.indexOf("&amp;amp;") != -1)
		s = s.replace("&amp;amp;","&amp;");
	
	s = com.ibm.bpm.wpd.util.Helper.richTextFilter(s);
	
	return s;
}

com.ibm.bpm.wpd.util.Helper.richTextFilter = function(s) // add this method for rich text format supporting
{
	if(s == null || s.length <= 0) 
		return s;

	s = s.replace(/<br>/g, "");
	
	return s;
}

com.ibm.bpm.wpd.util.Helper.format = function( text )
{
	//check if there are two arguments in the arguments list
  	if ( arguments.length <= 1 )
  	{
 			//if there are not 2 or more arguments there's nothing to replace
        //just return the original text

        return text;

    }

    //decrement to move to the second argument in the array

    var tokenCount = arguments.length - 2;

    for( var token = 0; token <= tokenCount; token++ )

    {

        //iterate through the tokens and replace their placeholders from the original text in order

        text = text.replace( new RegExp( "\\{" + token + "\\}", "gi"),

                                                arguments[ token + 1 ] );

    }

    return text;

}

/**
 * Checks to see if the href matches that of the url
 */
com.ibm.bpm.wpd.util.Helper._checkStyleSheetForURL = function(styleSheet,url) {
	

	var found = false;
	try 
	{
		found = (styleSheet.href == url);
		if (!found && styleSheet.imports)
		{
			for (var i=0; !found && (i<styleSheet.imports.length); i++)
			{
				found = this._checkStyleSheetForURL(styleSheet.imports[i], url);
			}
		}
	} catch (err) {

	}
	return found;
};

/**
 * Checks to see if the style sheet defined by the given url is currently loaded
 */
com.ibm.bpm.wpd.util.Helper.isStyleSheetLoaded = function(url) {

	var loaded = false;
	for (var i=0; !loaded && (i<document.styleSheets.length); i++)
	{
 		loaded = this._checkStyleSheetForURL(document.styleSheets[i], url);
	}
	return loaded;
};

/**
 * Load the stylesheet for the given url if it hasn't already been loaded
 * @param url
 * @returns {Boolean}
 */
com.ibm.bpm.wpd.util.Helper.loadStyleSheet = function(url) {
	var loaded = false;
		
	var link = document.createElement('link');
	link.rel = 'stylesheet';
	link.href = url;
	link.type = 'text/css';
	link.media = 'screen';
	link.charset = 'utf-8';
	loaded = this.isStyleSheetLoaded(link.href);
	
	if (!loaded) {
		if (!dojo.isIE) {
			document.getElementsByTagName('head')[0].appendChild(link);
			loaded = true;
		}
		else {
			if (dojo.isIE)
			{
				// IE only allows 31 style sheets, fudge around to allow more
				var styleId = 'WebSphereBusinessSpaceStyleSheet';
				if (!document.getElementById(styleId))
				{
					var s = document.createElement('style');
					s.id = styleId;
					document.getElementsByTagName('head')[0].appendChild(s);
				}
				var sheet = null;
				for (var i=0; !sheet && (i<document.styleSheets.length); i++)
				{
					if (document.styleSheets[i].id == styleId)
					{
						sheet = document.styleSheets[i];
					}
				}
				if (sheet)
				{
					// check if room at depth of 1
					if (sheet.imports.length < 31)
					{
						sheet.addImport(url);
						loaded = true;
					}
					// check if room at depth of 2 (if not loaded yet)
					for (var j=0; !loaded && (j<sheet.imports.length); j++)
					{
						var child = sheet.imports[j];
						if (child.imports.length < 31)
						{
							child.addImport(url);
							loaded = true;
						}
					}
					// check if room at depth of 3 (if not loaded yet)
					for (var j=0; !loaded && (j<sheet.imports.length); j++)
					{
						var child = sheet.imports[j];
						for (var k=0; !loaded && (k<child.imports.length); k++)
						{
							var grandchild = child.imports[k];
							if (grandchild.imports.length < 31)
							{
								grandchild.addImport(url);
								loaded = true;
							}
						}
					}
				}
			}
		}
	}
	
	return loaded;
};

}

if(!dojo._hasResource["com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection"] = true;
dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection");








/**
 * Asset Widget used to add an asset to the asset list.
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection",	[ dijit._Widget, dijit._Templated ], {
			
		templateString : 
			"<div>" +
			  "<div class=\"assetListSectionItem\" dojoAttachPoint='mainAssetDiv' >" +
			    "<div>" +
			        "<img style=\"float: left; padding: 4px 3px;\" dojoAttachPoint='assetTwistyDiv' dojoAttachEvent=\"onclick: assetTwistyClicked\" src=" +  dojo.moduleUrl('com.ibm.bpm.wpd', 'images/assetview/als_collapsed.gif') + ">" +
			    "</div>" +
			    "<div>" +
			        "<img style=\"float: left; padding: 4px 3px;\" dojoAttachPoint='assetIconDiv' src=''>" +
			    "</div>" +
			    "<div class='assetListName' dojoAttachPoint='assetNameDiv' dojoAttachEvent=\"onclick: openAsset\"\>" +
			       "<div class='dojoxEllipsis' dojoAttachPoint='assetNameDivInner'></div>" +
			    "</div>" +
			    "<div class='assetListDescription' dojoAttachPoint='assetDescriptionDiv'>" +
			       "<div class='dojoxEllipsis' dojoAttachPoint='assetDescriptionDivInner'></div>" +
			    "</div>" +
			    "<div class='assetListModifiedBy' dojoAttachPoint='assetModifiedDiv'>" +
			       "<div class='dojoxEllipsis' dojoAttachPoint='assetModifiedDivInner'></div>" +
			    "</div>" +
			    "<div class=\"assetListTags\" dojoAttachPoint='assetTagsDiv'>" +
			    	"<div class='dojoxEllipsis' dojoAttachPoint='assetTagsDivInner'></div>" +
			    "</div>" +
			    "<div class=\"assetListRevisionSection\" dojoAttachPoint='assetRevisionDiv'>" +
			  "</div>" +
			"</div>",

		widgetsInTemplate : true,
		assetDescription:"",
		assetIcon: "",
		assetName: "",
		assetOwner: "",
		assetModifiedAt: "",
		assetpoId:"",
		assetTags: "",
		sectionName: "",
		numberOfRevisions:0,
		revisionsInitialized:false,
		
		constructor : function() {
		},
		
		/**
		 * Setup the resource bundles
		 */
		postMixInProperties: function()
		{
	        
			this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
		},
		
		/**
		 * Create and populate the widget
		 */
		postCreate: function() {
//			if (dojo.isIE) {
//				this.mainAssetDiv.className = 'assetListSectionItemIE';
//			}
				
			this.inherited(arguments);
			
			var aRevision = this.parent.histories[this.assetpoId];
			if (!aRevision) {
				this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_spacer.gif");
			}
			
			var formattedName = com.ibm.bpm.wpd.util.Helper.text2htmlText(this.assetName);
			this.assetNameDivInner.innerHTML = formattedName;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedName);
			if (dir=="rtl")
				this.assetNameDivInner.setAttribute("style","direction:rtl; text-align:left;");
			//this.assetNameDivInner.innerHTML = this.assetName;
			
			if (this.assetName.length > 30) {			
				new dijit.Tooltip ({
		      	      connectId: [this.assetNameDiv],
//		            	label: "<span dir = '" + dir + "'>" + formattedName + "</span>", // Bidi support
		            	label: formattedName,
			            position: ["above","below"]	
		      	  	});
			}

			
			//this.assetDescriptionDiv.innerHTML = this.assetDescription;
			if (this.assetDescription) {
				var formattedDescription = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.assetDescription);
				this.assetDescriptionDivInner.innerHTML = formattedDescription;
				dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedDescription);
				if (dir=="rtl")
					this.assetDescriptionDivInner.setAttribute("style","direction:rtl; text-align:left;");

				new dijit.Tooltip ({
	      	      connectId: [this.assetDescriptionDiv],
//	            	label: "<span dir = '" + dir + "'>" + formattedDescription + "</span>",  // Bidi support
	            	label: formattedDescription, 
		            position: ["above","below"]	
	      	  	});
			}
			
			
			this.assetIconDiv.src = this.assetIcon;
			this.assetModifiedDivInner.innerHTML = this.assetOwner + " " + this.formatDate(this.assetModifiedAt);
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.assetModifiedDivInner.innerHTML);
			if (dir=="rtl")
				this.assetModifiedDivInner.setAttribute("style","direction:rtl; text-align:left;");
			
			if (this.assetTags) {
				if (this.assetTags.length > 29)
					this.assetTagsDivInner.innerHTML = this.assetTags.substring(0,25) + " ...";
				else
					this.assetTagsDivInner.innerHTML = this.assetTags;

				new dijit.Tooltip ({
		       		connectId: [this.assetTagsDiv],
//		       		label: "<span dir = '" + dir + "'>" + this.assetTags + "</span>",  // Bidi support
		       		label: this.assetTags,  
		           	position: ["above","below"]	
		    	});
			}
			
		},

		/**
		 * Asset name was clicked, fire the document open event
		 */
		openAsset: function() {
			var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
	    	
	    	//var baseEvent = new com.ibm.bpm.wpd.core.control.events.BaseEvent();
	    	var params = {};
	    	params.documentId = this.assetpoId;
	    	params.documentName = this.assetName;
	    	params.assetType=this.sectionName;
	    	params.branchId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
	    	params.snapshotId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
	    	openDocEvent.params = params;
	    	openDocEvent.dispatch();
		},
		
		/**
		 * Revision twist was clicked, expand or collapse the section
		 */
		assetTwistyClicked: function() {
			
			var aRevision = this.parent.histories[this.assetpoId];
			if (!aRevision) {
				return;
			}
			
			if (!this.revisionsInitialized) {
				this.attachRevisions();
				this.revisionsInitialized = true;
			}

			if (this.assetRevisionDiv.style.visibility == 'visible') {
				this.parent.assetListAP.layout();
				this.assetRevisionDiv.style.visibility = 'hidden';
				this.assetRevisionDiv.style.display = 'none';
				this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_collapsed.gif");
			}
			else {
				this.parent.assetListAP.resizeSelectedPane((this.numberOfRevisions * 18) + 12);
				this.assetRevisionDiv.style.visibility = 'visible';
				this.assetRevisionDiv.style.display = 'block';
				this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_expanded.gif");
			}
		},
		
		attachRevisions: function(){
			// Ideally I'd like to do this on first expand
			var sectionDiv = this.assetRevisionDiv;
			var aRevision = this.parent.histories[this.assetpoId];
			
//			if (dojo.isIE) {
//				this.assetRevisionDiv.className ='assetListRevisionSectionIE';
//				// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//				// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//				// To make this slight tricky is we need to be able to grow the container
//				
//				// First define a growable container which will set the top left icon
//				var mainDiv = document.createElement("div");
//				mainDiv.className="revgrowablecontainer";
//				this.assetRevisionDiv.appendChild(mainDiv);
//				// Add the top right image
//				var topDiv = document.createElement("div");
//				topDiv.className="revtop";
//				var topSpan = document.createElement("span");
//				topDiv.appendChild(topSpan);
//				mainDiv.appendChild(topDiv);
//				// Create the inner portion, we are in effect just wrapping our asset list section here
//				sectionDiv = document.createElement("div");
//				sectionDiv.className = "revright";
//				mainDiv.appendChild(sectionDiv);
//
//				// Finally add the bottom image, starting at the left, then continue to the right
//				var bottomDiv = document.createElement("div");
//				bottomDiv.className="revbottom";
//				var bottomSpan = document.createElement("span");
//				bottomDiv.appendChild(bottomSpan);
//				mainDiv.appendChild(bottomDiv);
//			}
			if (aRevision) {
				var i = 0;
				if (aRevision.changes.length > 20)
					this.numberOfRevisions = 20;
				else
					this.numberOfRevisions = aRevision.changes.length;
				
				if (aRevision.changes.length > 20)
					i = aRevision.changes.length - 20;

	         	for (i;i < aRevision.changes.length;i++) {

	         		var aChange = aRevision.changes[i];
					var revisionDiv = document.createElement("div");
					sectionDiv.appendChild(revisionDiv);
					revisionDiv.className = "assetListRevision";
					revisionDiv.innerHTML = "<b>" + dojo.date.locale.format(new Date(aChange.modified_on)) + "</b> - " + com.ibm.bpm.wpd.util.Helper.format(this.messages.AL_REV_CHANGES,aChange.userName);
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(dojo.date.locale.format(new Date(aChange.modified_on)) + ' - ' 
							+ com.ibm.bpm.wpd.util.Helper.format(this.messages.AL_REV_CHANGES,aChange.userName));
					if (dir=="rtl")
						revisionDiv.setAttribute("style","direction:rtl; text-align:left;");
	         	}
			}
			else {
				this.numberOfRevisions = 1; // empty
				var revisionDiv = document.createElement("div");
				sectionDiv.appendChild(revisionDiv);
				revisionDiv.className = "assetListRevision";
			}
		},
		
		formatDate: function(date) {
			// there doesn't seem to be a good way of doing this, the formatting is pretty rigid. For some reason it'll also change the date order when
			// we use a short date
//			return dojo.date.locale.format(new Date(date),{selector: "date", formatLength: "long"}) +" "
//				dojo.date.locale.format(new Date(date),{selector: "time", formatLength: "short"});
			
			return dojo.date.locale.format(new Date(date));
			
		}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.assetlistview.view.AssetListView"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.assetlistview.view.AssetListView"] = true;
dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListView");















/**
 * EditorManager is used to control the open/close/show/hide/setModel of all
 * document editors
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListView", [ dijit._Widget, dijit._Templated ], {
	
	templateString : "<div style='height:100%;width:100%;min-width:1100px'>" +
		"<div dojoAttachPoint='assetListAttachPoint' dojoType='com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer' style='border:none'>" +
//		+ "style='height:100%;border:solid lightgray;border-width: 2px; width: 100%;'>" +     						
		"</div>" +
		"<div dojoAttachPoint='assetListFilteredAttachPoint' dojoType='com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer' style='border:none'>" +
//		+ "style='height:100%;border:solid lightgray;border-width: 2px;visibility:hidden; display:none; width: 100%;'>" +     						
		"</div>" +
		"</div>",

	assetListAP: null,
	widgetsInTemplate : true,
	appModel: {},
	_subscriptionHandles : null,
	histories: {},
	processAppSetting: {},
	orderedSections: {},
	usePrimaryAccoridion: true,

	
	constructor : function() {
		this.reloadAppModel();
		this.queryRevisions();
		this.queryProcessAppSettings();
	},

	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
		this.setupSectionArray();
	},

	postCreate : function() {
		
		var jss = this;
		this.searchListener = dojo.subscribe("com.ibm.bpm.wpd.search.view.search.performSearch", function(message) {
			var searchString = message.searchString;
			jss.search(searchString);
		});
		
		// It appears dojo wants to add a default child in certain browers, delete it
		if (this.assetListAttachPoint.getChildren().length>0) {
			var children = this.assetListAttachPoint.getChildren();
			for (var i=0;i<children.length; i++) {
				this.assetListAttachPoint.removeChild(children[i]);
			}
		}
			
		var accordion = this.populateContent(null);
		this.assetListAP = accordion;
		
		// We need to figure out the default size of the process apps as the accordian sets it before the data is added
		var size = this.getProcessAppsSectionSize();
		this.assetListAttachPoint.startup();
		this.assetListAttachPoint.defaultSectionSize = size;
		
		if (this.assetListFilteredAttachPoint) {
			this.assetListFilteredAttachPoint.startup();
			this.assetListFilteredAttachPoint.defaultSectionSize = size;
		}
	},
//	
	reloadAppModel: function() {
		// Really need a clone of the app model as we'll be modifying it
		var step1 = dojo.toJson(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppModel);
		this.setAssetModel(dojo.fromJson(step1));
		
	},
	
	/**
	 * Show the widget, perform the draw of the contents
	 */
	onShow : function() {
		if (this.usePrimaryAccoridion)
			this.assetListAttachPoint.resize();
		else
			this.assetListFilteredAttachPoint.resize();
	},
	
//	resize: function() {
//		this.inherited(arguments);
////		if ( this.assetListAP )
////			this.assetListAP.resize();
//		
//		this.assetListAttachPoint.resize();
//		
//		if (this.assetListFilteredAttachPoint)
//			this.assetListFilteredAttachPoint.resize();
//	},
//	
//
	/**
	 * Populate the widget's contents
	 */
	populateContent: function(defaultSectionName) {		
		
		//this.assetListAP = new dijit.layout.AccordionContainer({style:"height: 100%"}, this.assetListAttachPoint);

		// I have to hardcode size or the scroll bars will never appear
		// DOJO 1.4
		//this.assetListAP = new ALAccordionContainer({style:"height: 500px"}, this.assetListAttachPoint);
		//this.assetListAP.style.overflow = 'scroll';

		// DOJO 1.6
		var accordionWidget;

		if (this.usePrimaryAccoridion) {
			accordionWidget = this.assetListAttachPoint;
			this.usePrimaryAccoridion = false;
			
			// Display primary, hide secondary
			this.assetListAttachPoint.domNode.style.visibility = 'visible';
			this.assetListAttachPoint.domNode.style.display = 'block';

			this.assetListFilteredAttachPoint.domNode.style.visibility = 'hidden';
			this.assetListFilteredAttachPoint.domNode.style.display = 'none';
		}
		else {
			accordionWidget = this.assetListFilteredAttachPoint;
			this.usePrimaryAccoridion = true;

			// Display secondary, hide primary
			this.assetListAttachPoint.domNode.style.visibility = 'hidden';
			this.assetListAttachPoint.domNode.style.display = 'none';

			this.assetListFilteredAttachPoint.domNode.style.visibility = 'visible';
			this.assetListFilteredAttachPoint.domNode.style.display = 'block';
		}
		
		//accordionWidget.style.overflow = 'scroll';
		
		var processAppSection = this.insertAssetSection(accordionWidget, "Process App Settings", this.orderedSections["Process Apps Settings"], 0, false, true);
		//this.queryProcessAppSettings(processAppSection);
		
		var al = {
				parent: this,
				parentDiv: processAppSection,
				processAppSetting:this.processAppSetting
				};
		var as = new com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection(al);
		processAppSection.appendChild(as.domNode);
		
		var defaultSection = false;
		
		// We're coming in via a search, display 
		if (defaultSectionName)
			defaultSection = false;
		
		for (var asset in this.orderedSections) {
			var assetName = asset;

			// Determine is it's a composite section
			if (assetName == "Performance tracking") {
				this.insertAssetSectionForComposite(accordionWidget,assetName,this.orderedSections[assetName]);
				continue;
			}
			
			if(defaultSectionName && defaultSectionName==assetName)
				defaultSection = true;
			
			//alert(this.appModel._assets);
			var assetValue = this.appModel._assets[assetName];
			
			// Doesn't exist
			if (!assetValue)
				continue;
			
			// Create the section
			var accordianSection = this.insertAssetSection(accordionWidget, assetName, this.orderedSections[assetName], assetValue.length, true, defaultSection);
			
			// TODO Maybe remove
			// Added to speed up development, make the first section past the process apps view the default;
			if (defaultSection) {
				
				if (accordionWidget.selectedChildWidget)
					accordionWidget.selectChild(accordianSection.id);
					

				var newDiv = document.createElement("div");
				// figure out the min height
				// Ideally I'd like to set the height for each one based on it's items, however it looks like it'll take
				// the minimum height of all combined and use that. Since the default section is the first to open, let's
				// set it to the min height, will see if I can address elsewhere
//				if (defaultSection) {
//					//newDiv.style.minHeight=(60 * assetValue.length) + "px";
//					newDiv.style.height=(50 * assetValue.length) + "px";			
//				}
	
				accordianSection.appendChild(newDiv);
				for (var i=0;i< assetValue.length; i++) {
					this.insertAsset(assetValue[i],newDiv,this.orderedSections[assetName].icon,assetName);
				}
			}
			
			defaultSection = false;
			// TODO end remove
		}
		
		// Force a resize of the accordion. for some reason recent versions (since it was originally written
		// can cause the default section to shrink.
		accordionWidget.resize();
		return accordionWidget;
	},	
	
	
	insertAssetSectionForComposite: function(parentDiv, sectionName, assetInfo, status) {
		// this one is a little unique as we have to first see anything exists in the children
		var assetLength = this.getCompositeAssetLength(assetInfo, status);
		
		if (assetLength > 0)
			this.insertAssetSection(parentDiv, sectionName, assetInfo, assetLength, true, false, status);
		
	},
	
	getCompositeAssetLength: function(assetInfo, status) {
		var assetLength = 0;
		
		for (var asset in assetInfo.compound) {
			var t = this.appModel._assets[asset];
			if (t)
				assetLength = assetLength + t.length;
		}
		
		return assetLength;
	},

	
	getProcessAppsSectionSize: function() {
		var bubbledSections = 3; // 3 we know of
		
		// Figure out how many more we have
		if (this.processAppSetting.envVars)
			bubbledSections = bubbledSections + this.processAppSetting.envVars.length;
		
		if (this.processAppSetting.projDeps)
			bubbledSections = bubbledSections + this.processAppSetting.projDeps.length;
		
		var bubbleSectionSize = 0;
		// Right now we have 3 and they seem to be consistent across browsers
		var nonBubbleSectionSize = 90;
		if (dojo.isIE == 6)
			nonBubbleSectionSize = 100;
		
		if (dojo.isIE) {
			if (dojo.isIE > 6)
				bubbleSectionSize = bubbledSections * 33.5;
			else
				bubbleSectionSize = bubbledSections * 48;
		}
		else {
			bubbleSectionSize = bubbledSections * 32;
		}
		
		return bubbleSectionSize + nonBubbleSectionSize;

	},
	
	/**
	 * Insert an individual section. A section being an asset type. The function performs lazy initialize of the sections
	 * to allow the asset list to display quicker. The section is added on first expansion, for a section that contains
	 * roughly 200 assets this will add an additional 500 ms to expansion
	 * @param parentDiv - The accordion  itself
	 * @param sectionName - The name of the section which is defined in the POType
	 * @param assetsCount - Number of assets in this section
	 * @param includeHeadings - Set to true to include header titles to right of name
	 * @param defaultSection - Default section is initial expanded section
	 * @returns - The dom node for this section
	 */
	insertAssetSection: function(parentDiv, sectionName, assetInfo, assetsCount, includeHeadings, defaultSection, status) {
	
		var appModel = this.appModel;
		var ds = this;
		var sectionDiv = new dijit.layout.ContentPane( {
            onShow:function(){
            	
            	// Seems like a weird change, if status is set we know it's coming via the copy subclass. In this case we don't and to default
            	// any section but rather let dojo determine it
            	if (status)
            		defaultSection = false;
            	
            	if (!defaultSection && includeHeadings && sectionDiv.domNode.childNodes.length == 0) {            		
            		var newDiv = document.createElement("div");
            		sectionDiv.domNode.appendChild(newDiv);

            		if (assetInfo.compound) {
            			for (var asset in assetInfo.compound) {
	            			var assetValue = appModel._assets[asset];
	            			if(assetValue) {
			            		for (var i=0;i< assetValue.length; i++) {
				     				ds.insertAsset(assetValue[i],newDiv,assetInfo.compound[asset].icon,sectionName, status);
			            		}
	            			}
            			}
            		}
            		else {
                		var assetValue = appModel._assets[sectionName];
	            		for (var i=0;i< assetValue.length; i++) {
		     				ds.insertAsset(assetValue[i],newDiv,assetInfo.icon,sectionName, status);
	            		}
            		}
	            }
            } 
        }); 
		
		// Set the tagName to be the name of the section, will use for search to determine the last expandable section
		sectionDiv.tagName = sectionName;

		sectionDiv.className = "assistListSection";
		if (dojo.isIE < 8 ) {

			if (includeHeadings) {
				
				
				var titleSpan = "<span class='titleNameIE'>" +
				"<span style='float:left'>" + assetInfo.key + "</span>" +
				this.getCounterSpan(assetsCount) +
				"</span>";
				
				var titleDSpan = null;
				var titleLSpan = null;

				if (defaultSection) {
					titleDSpan = "<span class='titleDescriptionIE'>" + this.messages.AL_DESCRIPTION + "</span>";
					titleLSpan = "<span class='titleLastModifiedIE'>" + this.messages.AL_LAST_MODIFIED + "</span>";
				}
				else {
					titleDSpan = "<span class='titleDescriptionIE' style='visibility:hidden'>" + this.messages.AL_DESCRIPTION + "</span>";
					titleLSpan = "<span class='titleLastModifiedIE' style='visibility:hidden'>" + this.messages.AL_LAST_MODIFIED + "</span>";
				}
				
				sectionDiv.title = titleSpan + titleDSpan + titleLSpan;
			}
			else {
				sectionDiv.title = "<span class='titleNameIE'>" + assetInfo.key + "</span>";
			}
		}
		else {
			// Kind of a weird way of doing this. Create spans to respresent the title. The title is a title on a button
			if (includeHeadings) {				
				var titleSpan = "<span class='titleName'>" +
					"<span style='float:left'>" + assetInfo.key + "</span>" +
					this.getCounterSpan(assetsCount) +
					"</span>";
				
				var titleDSpan = null;
				var titleLSpan = null;
				
				if (defaultSection) {
					titleDSpan = "<span class='titleDescription'>" + this.messages.AL_DESCRIPTION + "</span>";
					titleLSpan = "<span class='titleLastModified'>" + this.messages.AL_LAST_MODIFIED + "</span>";
				}
				else {
					titleDSpan = "<span class='titleDescription' style='visibility:hidden'>" + this.messages.AL_DESCRIPTION + "</span>";
					titleLSpan = "<span class='titleLastModified' style='visibility:hidden'>" + this.messages.AL_LAST_MODIFIED + "</span>";
				}
				
				sectionDiv.title = titleSpan + titleDSpan + titleLSpan;
			}
			else {
				sectionDiv.title = "<span class='titleName'>" + assetInfo.key + "</span>";
			}
		}
		
		if (defaultSection)
			sectionDiv.selected = true;

		parentDiv.addChild(sectionDiv);
		
		return sectionDiv.domNode;

	},
	
	getCounterSpan: function(assetsCount) {
		
		// First assign a differnt width based on the number of digits, for IE subtract a few as we have to use images to get the rounded corner effect
		// We'll max of at 4 digit, if somebody have over 9999 items then they relaly need to consider refactoring their project
		var digitSize = 0;
		
		if (dojo.isIE) {
			if (assetsCount < 10)
				digitSize = 13;
			else if (assetsCount< 100 )
				digitSize = 22;
			else if (assetsCount< 1000)
				digitSize = 29;
			else
				digitSize = 38;
		}
		else {
			if (assetsCount < 10)
				digitSize = 20;
			else if (assetsCount< 100 )
				digitSize = 26;
			else if (assetsCount< 1000)
				digitSize = 33;
			else
				digitSize = 42;
		}
		
		// Now lets build our span
		if (dojo.isIE) {
//			var counterSpan = "<span class='growableTitleCounterL'>..</span>" +
//			"<span style='width:" + digitSize + "px;' class='growableTitleCounterIE'> " + assetsCount + "</span>" +
//			"<span class='growableTitleCounterR'>..</span>";
//			return counterSpan;
			
			var counterSpan = "<span class='growableTitleCounterR'>..</span>" +
			"<span style='width:" + digitSize + "px;' class='growableTitleCounterIE'> " + assetsCount + "</span>" +
			"<span class='growableTitleCounterL'>..</span>";
			return counterSpan;
		}
		

		var counterSpan =  "<span style='width:" + digitSize + "px;' class='growableTitleCounter'>" + assetsCount + "</span>";

		return counterSpan;
	},
	
	destroy: function(){
		dojo.unsubscribe(this.searchListener);
	},
	
	/**
	 * Search the asset list of the specified search string.
	 * We'll build based on a dual accordion container. For performance hide the original asset list and build a new asset list. Once build immediately
	 * display it and then destroy the original under the covers. 
	 * @param searchString - String to search. Zero length string resets to original list
	 */
	search: function(searchString) {
		var selectedSection = this.assetListAP.selectedChildWidget.tagName;
		
		// Lowercase the string for case insentive search
		searchString = searchString.toLowerCase();
		
		// Grab the full model
		this.reloadAppModel();
		
		if (searchString.length > 0) {
			var filteredAppModel = {};

			for (var asset in this.appModel._assets) {
				//Don't search these sections
				if (asset=="ProjectDefaults" || asset=="snapshotId")
					continue;
				var filteredAppModelSection = [];
				var tempSection = this.appModel._assets[asset];
				
				// The value at the attribute could be null. later one we do a check to see if the tempSection
				// contains a name field (as we might have more than assets coming back). In the case of viewing
				// a tip the value at snaphsot name will be null
				if (!tempSection)
					continue;
				
				for (var i=0;i<tempSection.length;i++) {
					var temp = tempSection[i];
					if (!temp.name)
						continue;
					
					if(temp.name.toLowerCase().indexOf(searchString) != -1) {
						filteredAppModelSection[filteredAppModelSection.length] = temp;
					}
					
					for (var j=0;j<temp.tags.length;j++) {
						if (temp.tags[j].toLowerCase().indexOf(searchString) != -1) {
							filteredAppModelSection[filteredAppModelSection.length] = temp;
							break;
						}
					}
				}
				
				// Something matched
				if (filteredAppModelSection.length > 0)
					filteredAppModel[asset] = filteredAppModelSection;
			}
			this.appModel._assets = filteredAppModel;
			com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._filteredProcessAppModel = this.appModel;
		}

		this.filteredAccordion = true;
		
		// Hide it and delete after the other is diplayed 
		this.assetListAP = this.populateContent(selectedSection);
		
		// Cleanup the old list
		var cleanup;
		if (this.usePrimaryAccoridion) {
			cleanup = this.assetListAttachPoint;
		}
		else {
			cleanup = this.assetListFilteredAttachPoint;
		}

		var children = cleanup.getChildren();
		for (var i=0;i<children.length; i++) {
			cleanup.removeChild(children[i]);
		}
		
	},

	setupSectionArray: function() {
		this.orderedSections = {};
		this.orderedSections["Process Apps Settings"] = {key:this.messages.AL_PROCESS_APPS_SETTINGS,icon:""};
		this.orderedSections["BPD"] = {key:this.messages.AL_BPD,icon:"processes-16.png"};
		this.orderedSections["Human Service"] = {key:this.messages.AL_HUMAN_SERVICES,icon:"human-service-16.png"};
		this.orderedSections["SCA Service"] = {key:this.messages.AL_ADVANCED_INTEGERATION_SERVICE,icon:"ais16_wle.png"};
		this.orderedSections["Integration Service"] = {key:this.messages.AL_INTEGRATION_SERVICES,icon: "integration-service-16.png"};
		this.orderedSections["Rule Service"] = {key:this.messages.AL_SERVICES,icon:"rule-service-16.png"};
		this.orderedSections["General System Service"] = {key:this.messages.AL_GENERAL_SYSTEM_SERVICES,icon:"general_service_16x16.png"};
		this.orderedSections["VariableType"] = {key:this.messages.AL_BUSINESS_OBJECTS,icon:"variable-type-16.png"};
		this.orderedSections["Participant"] = {key:this.messages.AL_PARTICIPANT_GROUP,icon:"user-group-16.png"};
		this.orderedSections["ExternalActivity"] = {key:this.messages.AL_EXTERNAL_ACTIVITIES,icon:"external_activity_16x16.png"};
		this.orderedSections["EPV"] = {key:this.messages.AL_EPV,icon:"epv-16.png"};
		
		var unique = {};
		this.orderedSections["Performance tracking"] = {key:this.messages.AL_PERFORMANCE_TRACKING,compound:unique};
		unique["TimingInterval"] = {key:this.messages.AL_TIMING_INTERVALS,icon:"timing-interval-16.png"};
		unique["TrackingGroup"] = {key:this.messages.AL_TRACKING_GROUPS,icon:"tracking-group-16.png"};
		unique["Metric"] = {key:this.messages.AL_KPI,icon:"key-performance-indicator-16.png"};
		unique["SLA"] = {key:this.messages.AL_SERVICE_LEVEL_AGREEMENT,icon:"service-level-agreement-16.png"};
		this.orderedSections["UCA"] = {key:this.messages.AL_UNDERCOVER_AGENTS,icon:"undercover-agent-16.png"};
		this.orderedSections["WebService"] = {key:this.messages.AL_WEB_SERVICES,icon:"web-service-16.png"};

	},
	
	/**
	 * Insert an asset into to the asset list
	 * @param asset - Asset to isnert
	 * @param parentDiv - Section div for the accordion section
	 * @param sectionName - Name of the current asset section
	 */
	insertAsset: function(asset, parentDiv, imageName, aSectionName) {
		
		var icon = imageName;
		
		// Special case handling for VariableType because icon changes with shared state
        if (aSectionName == "VariableType") {
            icon = this.getBOIcon(imageName, asset);
        }
        
        // Special case handling for UCA because icon changes depending on the eventType
        if (aSectionName == "UCA") {
            icon = this.getUCAIcon(imageName, asset);
        }
		
		//if (dojo.isIE > 6) {
//		if (dojo.isIE) {
//			// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//			// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//			// To make this slight tricky is we need to be able to grow the container
//			
//			// First define a growable container which will set the top left icon
//			var mainDiv = document.createElement("div");
//			mainDiv.className="alsgrowablecontainer";
//			parentDiv.appendChild(mainDiv);
//			
//			// Add the top right image
//			var topDiv = document.createElement("div");
//			topDiv.className="alstop";
//			var topSpan = document.createElement("span");
//			topDiv.appendChild(topSpan);
//			mainDiv.appendChild(topDiv);
//			// Create the inner portion, we are in effect just wrapping our asset list section here
//			var innerDiv = document.createElement("div");
//			innerDiv.className = "alsright";
//			mainDiv.appendChild(innerDiv);
//			
//			if (dojo.isIE == 6) {
//				// Gotta love 6
//				var ie6div = document.createElement("div");
//				ie6div.style.width = '100%';
//				//ie6div.style.backgroundColor = 'rgb(247, 247, 247)';
//				ie6div.style.backgroundColor = 'white';
//				
//				var al = {
//						parent: this,
//						assetName:asset.name,
//						assetDescription:asset.description,
//						assetOwner:asset.last_modified_by_userName,
//						assetModifiedAt:asset.last_modified, 
//						assetTags:asset.tags,
//						assetpoId:asset.poId,
//						sectionName:aSectionName,
//						assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
//						};
//				var as = new com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection(al);
//				ie6div.appendChild(as.domNode);
//				innerDiv.appendChild(ie6div);
//			}
//			else {
//				var al = {
//						parent: this,
//						assetName:asset.name,
//						assetDescription:asset.description,
//						assetOwner:asset.last_modified_by_userName,
//						assetModifiedAt:asset.last_modified, 
//						assetTags:asset.tags,
//						assetpoId:asset.poId,
//						sectionName:aSectionName,
//						assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
//						};
//				var as = new com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection(al);
//				innerDiv.appendChild(as.domNode);
//			}
//			
//			
//			
//			// Finally add the bottom image, starting at the left, then continue to the right
//			var bottomDiv = document.createElement("div");
//			bottomDiv.className="alsbottom";
//			var bottomSpan = document.createElement("span");
//			bottomDiv.appendChild(bottomSpan);
//			mainDiv.appendChild(bottomDiv);
//		}
//		else {
			var al = {
					parent: this,
					assetName:asset.name,
					assetDescription:asset.description,
					assetOwner:asset.last_modified_by_userName,
					assetModifiedAt:asset.last_modified, 
					assetTags:asset.tags,
					assetpoId:asset.poId,
					sectionName:aSectionName,
					assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + icon)
					};
			var as = new com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection(al);
			parentDiv.appendChild(as.domNode);
//		}
	},



	// Query Section
	queryRevisions : function(){
		
		if (dojo.global.BPM.WPD_useWLEServer){
		
			var sId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", "/v1/snapshot/" + sId + "/changehistory", dojo.hitch(this, function(response){
				this.histories = response.data.histories;
			}), dojo.hitch(this, function(response) {
				//alert("failure no revisions");
			}),null, true);
		}
		else {
		var xhrArgs = {
	                url: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/prototype/versionData.json",
	                sync: true,
	                handleAs: "json",
	                load: dojo.hitch(this, function(response) {
	                	this.histories = response.data.histories;
	                }),
	                error: dojo.hitch(this, function(response) {
	                	alert("failure 1 " + response);
	                })
	            };
	
	        //Call the synchronous xhrGet
	        dojo.xhrGet(xhrArgs);
		}

	},
	
	setAssetModel: function(anAssetModel) {
		this.appModel = anAssetModel;
	},
	
	//queryProcessAppSettings : function(processAppSection){
	queryProcessAppSettings : function(){
		if (dojo.global.BPM.WPD_useWLEServer){
			var sId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", "/v1/processAppSettings?snapshotId=" + sId, dojo.hitch(this, function(response){
				this.processAppSetting = response.data;
				
			}), dojo.hitch(this, function(response) {
				console.log("Asset List View",response);
				//alert("failure no settings");
			}), null, true);
		}
		else {
		var xhrArgs = {
	                url: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/prototype/processappsettting.json",
	                sync: true,
	                handleAs: "json",
	                load: dojo.hitch(this, function(response) {
	                	this.processAppSetting = response.data;
	                }),
	                error: dojo.hitch(this, function(response) {
	                	console.log("Asset List View",response);
	                	//alert("failure 1 " + response);
	                })
	            };
	
	        //Call the synchronous xhrGet
	        dojo.xhrGet(xhrArgs);
		}

	},
	
	getBOIcon : function(imageName, asset){
	    var icon = imageName;	    
        if (asset.shared) {	    
	        icon = "variable-type-shared-16.png";
	    }	    
	    return icon;    
	},
	
	getUCAIcon : function(imageName, asset){
	    var icon = imageName;
	    if(asset.eventType == "Message") {
	    	icon = "message_undercover_agent_16x16.png";
	    }
	    else if(asset.eventType == "Content") {
	    	icon = "content_undercover_agent_16x16.png";
	    }
	    else if(asset.eventType == "Timer") {
	    	icon = "timer_undercover_agent_16x16.png";
	    }
	    return icon;
	}
	
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.control.notification.Notification"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.control.notification.Notification"] = true;
dojo.provide("com.ibm.bpm.wpd.core.control.notification.Notification");

/**
 * This class represents a change made to a model and is used to communicate the change to
 * parties that are listening for model changes
 **/
dojo.declare("com.ibm.bpm.wpd.core.control.notification.Notification", [], {
	
//	/* The possible values for the change type */
//	SET:String = 1;
//	COLLECTION_ADD:String = 2;
//	COLLECTION_REMOVE:String = 3;
//	COLLECTION_UPDATE:String = 4;
// 	COLLECTION_REMOVE_ALL: String = 5;	
	
	changeType : null,
	parentObject : null,		// type: MObject
	attributeName : null,
	oldValue : null,
	newValue : null,
	affectedListPosition: -1,
	context: null,
	
	constructor : function(changeType, parentObject, attributeName, oldValue, newValue, affectedListPosition, context){
		this.changeType = changeType;
		this.parentObject = parentObject;
		this.attributeName = attributeName;
		this.oldValue = oldValue;
		this.newValue = newValue;
		if (affectedListPosition != null){
			this.affectedListPosition = affectedListPosition;
		}
		this.context = context;
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.model.MObject"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.model.MObject"] = true;
dojo.provide("com.ibm.bpm.wpd.core.model.MObject");



dojo.declare("com.ibm.bpm.wpd.core.model.MObject", null, {

	id: null,
	
	constructor : function(id){
		if (!id){
			this.id =  Math.random().toString();
		} else {
			this.id = id;
		}
	},
	
	getAttribute: function(attributeName) {
		return this[attributeName];
	},

	setAttribute: function(attributeName, newValue, ctx){
		//(changeType, parentObject, attributeName, oldValue, newValue, affectedListPosition, context){
		var n = new com.ibm.bpm.wpd.core.control.notification.Notification(1, this, attributeName, this[attributeName], newValue);
		n.context = ctx;
		this[attributeName] = newValue;
		
		/* Now dispatch the corresponding notification to any topic-based listeners */
		dojo.publish(this.declaredClass + "::" + n.attributeName, [n]);
		
		//The following 2 kinds of notification are not needed for now
		/* Publish an object-instance-based notification */
		//dojo.publish(this.id, [n]);
			
		/* Publish an object-instance-attribute based notification */
		//dojo.publish(this.id + "::" + n.attributeName, [n]);
		
		

	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.assetlistview.model.ProcessAppModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.assetlistview.model.ProcessAppModel"] = true;
dojo.provide("com.ibm.bpm.wpd.assetlistview.model.ProcessAppModel");




/**
 *
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.model.ProcessAppModel", [com.ibm.bpm.wpd.core.model.MObject], {
		
	// PO type ID
	LSW_PROCESS: 1,			// Service Process
	LSW_IC: 2,				// Integration Definition
	LSW_CONNECTOR: 3,		// Connector
	LSW_UCA: 4,					// Under-cover agent
	LSW_WEB_SERVICE: 7,		// Web Service
	LSW_REPORT: 11,			// Report
	LSW_CLASS: 12,			// Variable Type
	LSW_SCBD: 13,			// Scoredboard
	LSW_TRACKING_GROUP: 14,	// Tracking Group
	LSW_TIMING_INTERVAL: 15,// Timing Interval
	LSW_TRACKING_POINT: 16, // Tracking Point
	LSW_TRACKED_VARIABLE: 17, // Tracked variable
	LSW_LAYOUT: 20,			// Layout
	LSW_EPV: 21,			// Exposed Process Value
	LSW_GLOBAL: 22,			// Global variable
	LSW_PARTICIPANT: 24, 	// Participant
	LSW_BPD: 25, 			// Business Process Definition, Process
	LSW_SLA: 47,			// Service Level Agreement
	LSW_ENV_VAR_SET: 62, 	// Environemtn Variable
	LSW_PROJECT_DEFAULTS: 63, // Project Defaults
		
    _assets : null,
 
    constructor: function() {
	},
	
	setModel : function(data){
		this._assets = data;
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel"] = true;
dojo.provide("com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel");




/**
 * ViewState of a Viewer
 *  
 */
dojo.declare("com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel", [com.ibm.bpm.wpd.core.model.MObject], {
		
	_documentModel: null,	// type: josn object
   // _currentSelection : null,     We might need it
    
	
	type : null,            // type: String, the type of this view {AssetListView, BPDDocType, ServiceDocType...}
	branchOrSnapshotId: null, //branchId or snapshotId
    documentId: null,
    name : null,    
    
    constructor: function() {
		//this._currentSelection = [];
	},
	
//	setCurrentSelection : function(value){
//		this.setAttribute("_currentSelection", value);
//	},
//	
//	getCurrentSelection : function(){
//		return this._currentSelection;
//	},

	
	getDocumentModel : function (){
		return this._documentModel;
	},
	
	setDocumentModel : function(value){
		this._documentModel = value;
	}

});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.view.BaseViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.view.BaseViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.core.view.BaseViewer");







/**
 * BaseViewer
 */
dojo.declare("com.ibm.bpm.wpd.core.view.BaseViewer", [ dijit._WidgetBase,
		dijit._Templated ], {

	widgetsInTemplate : true,
	
	//The ViewStateModel for this viewer
	viewStateModel:null,
		
	constructor : function(args) {
		// dojo.safeMixin(this, args); //Use this when there are lots of them
		 this.viewStateModel = args.viewStateModel;
	},

	postCreate:function(){
		
		
	},
	
	/**
	 * Hide the shareLink
	 */
	_hideLink: function() {
		var shareTable = this._findDomNodeByTypeAndClassName("td", "shareLinkClass");
		if (shareTable) {
			shareTable.style.visibility = 'hidden';
		}
	},
	
	/**
	 * Show the shareLink
	 */
	_showLink: function() {
		var shareTable = this._findDomNodeByTypeAndClassName("td", "shareLinkClass");
		if (shareTable) {
			shareTable.style.visibility = 'visible';
		}
	},
	
	/**
	 * Search for the section and class defined
	 * @param tagName
	 * @param className
	 * @returns
	 */
	_findDomNodeByTypeAndClassName: function(tagName, className) {
		
		var rootNode = this.domNode;
		
		var aNode = dojo.query(tagName + "." + className, rootNode);
		if (!!aNode && aNode.length > 0) {
			return aNode[0];
		} else {
			return null;
		}
	},
	
	/**
	 * The viewer become visible
	 * Override this function if you have anything to do onshow
	 */
	onShow : function() {

		this._shareLinkEnablement();
	},
	
	/**
	 * Determine whether the share link should be diaplayed. For now we don't want to display the link is the view in being shown via the
	 * copy asset list (as the original idea was to show the asset in the asset list keyed on snapshot, what would copy mean). This will
	 * be called via the onShow on the viewer. This is called when the view is displayed. We are doing it here, as opposed to the port create
	 * because the view could be cached if it was already open. In this case the postCreate is not called (whereas onShow is always called). 
	 */
	_shareLinkEnablement: function() {
		
		// Look for the breadcrumb information in the global
		var breadcrumb = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadcrumb;
		
		// Not sure where we're coming from. Could be portal, leave the original behaviour
		if (!breadcrumb)
			return;
		
			
		var breadcrumbModels = breadcrumb._divToModel;
		var hideLabel = false;
		
		// Loop through the breadcrumb entries. If copyListModel type is in any of the breadcrumb entries we will hide the shareLink
		for (var breadcrumbKey in breadcrumbModels) {
			if ("copyListModel" == breadcrumbModels[breadcrumbKey].type) {
				hideLabel = true;
				break;
			}
		}
		
		if(hideLabel) {
			this._hideLink();
		}
		else
			this._showLink();
	},
	
	/**
	 * The viewer become invisible
	 * Override this function if you have anything to do here
	 */
	onHide: function(){
		
	},

	/**
	 * Set the viewStateModel for this viewer
	 * @param viewStateModel
	 */
	setViewStateModel : function(viewStateModel) {
		this.viewStateModel = viewStateModel;
	}
});


dojo.global.copyLinkTooltipDialog =null;

com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref = function(copyLinkHref, rootId) {
	
	var copyLinkTooltipDialogName =    "copyLinkTooltipDialog";
	var copyLinkConnectorName =        "copyLinkConnector";	
	var copyLinkTooltipFocusNodeName = "copyLinkTooltipFocusNode";
	var copyLinkTooltipContainerName = "copyLinkTooltipContainer";
	var containerNodeCopyLink = null;
	var domeNodeTooltipDialog = null;
	var connectorNodeCopyLink = null;	
	var href="";
	
	
	this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.base", "DocumentationViewerResources");
	
	/*
	 *  for proxy, IHS, etc. web server, URL will have no port
	 */
	
	if(copyLinkHref.port.length == 0){ 
		port = copyLinkHref.port;
	}else{
		port = ":" + copyLinkHref.port; 
	}
	
	
	// In the case of a subprocess we want to link to the root process as opposed to the subprocess. Add a optional variable
    // called rootId, if it's passed in use it otherwise default to the documentId global.
	// On a side note if might be safe to always have the view pass in it's doc id and snaphot/branch id. I'm not sure if the
	// global is always updated properly (maybe not in the case of drilldown)
	var docId = (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().getActiveViewStateModel()).documentId;
	if (rootId)
		docId = rootId;
	
	href= com.ibm.bpm.wpd.base.getEndPointAndContextRootForModuleKey(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_ASSET, com.ibm.bpm.wpd.base.wpdConstant.BPM_KEY_EXTERNAL_CLIENT) + "/" + docId
    + "?";

    //var branchId=(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()).branchId;
	// The branchId is never actually set, we work with an internal snapshotId, however the true branchId is stored in something called tipInfo
	// First check is tipInfo is set, if it is the user is browsing the current
	// Second check is the snapshotId is equal to the vsm brnachOrSnaphotId. If it's the same we know the viewer has opened something
	// in the current process app. If they are different. The the view has opened up a refernce element in another toolkit.
	// Third is they are the same then use the tipInfo in the branchId's place to get the proper link
	var branchId = null;
	if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().tipInfo 
		&& (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId 
		    == com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().getActiveViewStateModel().branchOrSnapshotId)) {
		branchId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().tipInfo;
	}

	// Use the active vsm. The branchOrSnapshot should always be the snapshot
    branchId ? href = href + "branchId=" +branchId:
    	href = href + "snapshotId=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().getActiveViewStateModel().branchOrSnapshotId;
       
    copyLinkHref.protocol= "javascript:";   /// disable opening copy link onclick even 
   

    /*
     *  Create TooltipDialog for copy link
     */
    var content= "<p ><strong>" + href +"</strong></p><p style=\"margin-bottom : 0em;\">" + this.messages.COPY_LINK_TOOLTIP_DIALOG + "</p>";
    
    if( !dojo.global.copyLinkTooltipDialog){
	    var _copyLinkToolTip = dojo.declare("_copyLinkToolTip",[dijit.TooltipDialog], {
			templateString: '<div role="presentation" tabIndex="-1">' +
							'	<div class="dijitTooltipContainer"  role ="presentation">' +		
							'		<div class ="dijitTooltipContents dijitTooltipFocusNode '+ 
							      copyLinkTooltipFocusNodeName + "\""+
							'  data-dojo-attach-point="containerNode" role="dialog"></div>' +
							'	</div>' +
							'	<div class="dijitTooltipConnector" role="presentation" data-dojo-attach-point="connectorNode" ></div>' +
							'</div>' 
		});
	    dojo.global.copyLinkTooltipDialog = new _copyLinkToolTip({
	        id: copyLinkTooltipDialogName
	        });
	    
	    containerNodeCopyLink = dojo.global.copyLinkTooltipDialog.containerNode.parentNode;
	    if(containerNodeCopyLink != null) {
	        dojo.attr(containerNodeCopyLink, "style", {background: "#FFC"});
	        dojo.attr(containerNodeCopyLink, "style", {fontsize:  "8pt"});
	        dojo.attr(containerNodeCopyLink, "style", {border:  "2px #C0C09F solid"});        
	        dojo.addClass(containerNodeCopyLink,copyLinkTooltipContainerName);
	    }
	    
	    domeNodeTooltipDialog = dojo.global.copyLinkTooltipDialog.domNode;
	    if( domeNodeTooltipDialog != null){        
	        dojo.addClass(domeNodeTooltipDialog,copyLinkTooltipDialogName);
	        dojo.attr( domeNodeTooltipDialog, "style", {width:  "500px"});
	        
	       
	    }
	    
	
	    connectorNodeCopyLink= dojo.global.copyLinkTooltipDialog.connectorNode;
	    if( connectorNodeCopyLink != null){      
	        dojo.attr(connectorNodeCopyLink, "style", {background: "url(" + com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/widgets/com/ibm/bpm/wpd/images/tooltiparrow.png) no-repeat top left"});
	        dojo.attr(connectorNodeCopyLink, "style", {width:  "26px"});
	        dojo.attr(connectorNodeCopyLink, "style", {height:  "15px"});	 
	    	dojo.addClass(connectorNodeCopyLink,copyLinkConnectorName);
	    }
    }
   
     /*
      *  Display TooltipDialog for copy link
     */
    
    dojo.connect(copyLinkHref, "onclick", function(){
    	
    	copyLinkHrefPosition = dojo.position(copyLinkHref,true); 
    	dojo.global.copyLinkTooltipDialog.containerNode.innerHTML = content; /// set TooltipDialog content
		dijit.popup.open({
             popup: dojo.global.copyLinkTooltipDialog,
             around: copyLinkHref
         });		
		
	  });  
    
    dojo.connect(copyLinkTooltipDialog, "onOpen", function(event){     ///  set connector location
    	 if(copyLinkHrefPosition.x==event.x){
    	   dojo.attr(connectorNodeCopyLink, "style", {left:  "15px"});
    	 }else{
    	   dojo.attr(connectorNodeCopyLink, "style", {right:  "15px"}); 
    	 }
	  }); 
    
    dojo.connect(copyLinkHref, "onmouseout", function(event){
    	
    	if(event.relatedTarget!= null ){
    	
    	if(((event.relatedTarget.className).indexOf(copyLinkTooltipDialogName)==-1) && 
    			((event.relatedTarget.className).indexOf(copyLinkConnectorName)==-1) &&
    			((event.relatedTarget.className).indexOf(copyLinkTooltipFocusNodeName)==-1)&&
    			((event.relatedTarget.className).indexOf(copyLinkTooltipContainerName)==-1)&&
    			((event.relatedTarget.innerText).indexOf(href)==-1))
    		
    			dijit.popup.close(copyLinkTooltipDialog); 
    	}
    	
	  });
    
 
    dojo.connect(copyLinkTooltipDialog, "onMouseLeave", function(){  	
    	dijit.popup.close(copyLinkTooltipDialog);
    	
	  }); 

};

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider", null, {

	docType:null,
	//editorClass:null,
	
	contructor : function () {
		this._initialize();
	},
	
	/**
	 * Return the document type
	 * Subclass must override this function
	 */
	getDocType: function(){
		return "commonModelDocType";
	},
	
	_initialize : function (){
		
	},
	
	/**
	 * Creates a ViewStateModel for document of this type
	 * @param data
	 * @returns {com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel}
	 */
	createViewStateModel : function (data){
		
		var esm = new com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel();
		this.setViewStateModel(esm);
		return esm;
	},

	setViewStateModel : function (model){
		this.viewStateModel = model;
	},
	
	/**
	 * Whether reuse existing viewer or instantiate a new viewer when open document of the same type
	 * @returns
	 */
	reuseViewer : function(){
		return true;
	},
	
	/**
	 * Create a viewer for document of this type
	 * Subclass must override this function
	 */
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.core.view.BaseViewer({viewStateModel:model}, parent);
	},
	
	
	/**
	 * Return the url to retrieve the details data for the document
	 * Subclass must override this function
	 * @param docId The document/po id
	 */
	getPORestPath: function(docId){
		//var url = "/v1/visual/processModel/" + docId + "?";
		//return url;
		throw new Error("Please implement function:getPORestPath in your docTypeProvider");
	},
	
	getRequestParams:function(properties){
		
		var params = {};
		params.action = "get";
		
		var docId = properties.documentId;		
		var branchId = properties.branchId;
		var snapshotId = properties.snapshotId;
		if (!properties.branchId && !properties.snapshotId){
			throw new Error("Neither branchId nor snapshot is provided");
		}		
		
		params.url = this.getPORestPath(docId);
		
		if (!!branchId){
			params.url = params.url + "branchId=" + branchId;
		}
		else{
			params.url = params.url + "snapshotId=" + snapshotId;
		}
		
		return params;
	},
	/**
	 * Return the file path to the icon used by this viewer
	 * Subclass must override this function
	 * @param size is the icon size
	 */
	getIconPath : function(size){
		throw new Error("Please implement function:getIconPath in your docTypeProvider");
	},
	
	/**
	 * Clean up work
	 */
	cleanup: function(){
		
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.assetlistview.model.AssetListModelTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.assetlistview.model.AssetListModelTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.assetlistview.model.AssetListModelTypeProvider");



dojo.declare("com.ibm.bpm.wpd.assetlistview.model.AssetListModelTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "assetListModel";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.assetlistview.view.AssetListView({}, parent);
	},
	
	createDataModel : function(data){
		var model = new com.ibm.bpm.wpd.assetlistview.model.ProcessAppModel();
		model.setModel(data);
		return model;
	},
	
	getPORestPath: function(docId){
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/snapshot-16.png";
		}
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.base.bootstrapLite"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.base.bootstrapLite"] = true;
dojo.provide("com.ibm.bpm.wpd.base.bootstrapLite");
	
com.ibm.bpm.wpd.base.wpdConstant = {}; 
com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST = "bpmrest.war";
com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_PROCESSPORTALSUPPORT = "process-portal-support.war";
com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER = "webviewer.war";
com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_REPOSITORY = "repository.war";
com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_PROCESSADMIN = "ProcessAdmin.war";
com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_ASSET = "bpmasset.war";
com.ibm.bpm.wpd.base.wpdConstant.BPM_KEY_EXTERNAL_CLIENT = "External";

com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule = function(moduleName){
	return !!bpm_endpoint_urls[moduleName] ? bpm_endpoint_urls[moduleName]: bpm_context_roots[moduleName];	
};


com.ibm.bpm.wpd.base.getEndPointAndContextRootForModuleKey = function(moduleName, key){
	var lookupKey = moduleName + ":" + key;	
	return bpm_endpoint_urls[lookupKey];
};
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.control.WpdRestHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.control.WpdRestHandler"] = true;
dojo.provide("com.ibm.bpm.wpd.core.control.WpdRestHandler");

/**
 */
dojo.declare("com.ibm.bpm.wpd.core.control.WpdRestHandler", null, {
	
	iContext: null,
	serviceURLRoot: null, //will hardcode some value here
	
	_outstandingRequest: null,
	
	/**
	 * Value is set from bootstrap.js
	 */
	constructor : function (iContext, serviceURLRoot) {
		this.iContext = iContext;
		this.serviceURLRoot = serviceURLRoot;
		this._outstandingRequest = {};
	},
	
	calculateRemoteRequestURL : function(pathURL, acceptType, webAppName) {
		var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_REPOSITORY) + "/repository/RemoteProcessDocService";  // servlet url
		var registrationId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId;
		url += "?registrationId=" + encodeURIComponent(registrationId);
		if(!!acceptType)
			url += "&acceptType=" + encodeURIComponent(acceptType);
		if(!!webAppName)
			url += "&webAppName=" + encodeURIComponent(webAppName);
		url += "&pathURL=" + encodeURIComponent(pathURL);
		return url;
	},
	
	
	performRequest: function(verb, url, loadFn, errorFn, headers, isSync, message, deferred, handleAsType, xMethodOverride, preventCache, timeoutValue) {
		var requestUrl = this.serviceURLRoot + url;
		if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId) {
			requestUrl = this.calculateRemoteRequestURL(url, null, com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST);
		}		
		this._performRequest(verb, requestUrl, loadFn, errorFn, headers, isSync, message, deferred, handleAsType, xMethodOverride, null, null, preventCache, timeoutValue);
	},

	performProxiedRequest: function(verb, serviceURLRoot, url, loadFn, errorFn, headers, isSync, message, deferred, handleAsType, xMethodOverride, user, password, timeoutValue) {
		var requestUrl = serviceURLRoot + url;
		this._performRequest(verb, requestUrl, loadFn, errorFn, headers, isSync, message, deferred, handleAsType, xMethodOverride, user, password, timeoutValue);
	},
	
	_performRequest: function(verb, requestUrl, loadFn, errorFn, headers, isSync, message, deferred, handleAsType, xMethodOverride, user, password, preventCache, timeoutValue) {		
		if(!!this.isOutstandingUrl(requestUrl)){
			return;
		}
		this._outstandingRequest[requestUrl] = true;
		
		var request = {};
		request.sync = !!isSync;
		
		request.load = function(response){
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().removeUrl(requestUrl);
			loadFn(response);
		};
		//request.url = this.iContext.io.rewriteURI(requestUrl);
		request.url = requestUrl;
		
		if(timeoutValue == undefined || timeoutValue == null){
			request.timeout = 1800000; //change this to 30 mins
		}
		else{
		   request.timeout = timeoutValue;  // 0 means infinite
		}
		
		if (!handleAsType) {
			request.handleAs = "json";
		} else {
			request.handleAs = handleAsType;
		}
		
		if (preventCache)
			request.preventCache = preventCache;

		//request.preventCache = true;
		if (errorFn) {
			request.error = function(response){
				com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().removeUrl(requestUrl);
				errorFn(response);
			};    	
		}
		if (headers) {
			request.headers = dojo.clone(headers);
		} else {
			request.headers = new Object();
		}
		
		if (!!xMethodOverride) {
			request.headers["X-Method-Override"] = xMethodOverride;
		}
		
		if (!!user){
			request.user = user;
		}
		
		if (!!password){
			request.password = password;
		}

		if (verb == "put" || verb == "rawPut"){
			request.mimetype = "text/json;charset=utf-8";
			request.putData = message;
		} else if (verb == "post" || verb == "rawPost") {
			request.mimetype = "text/json;charset=utf-8";
			request.postData = message;
		}
		
		request.headers["Accept"] = "application/json";

		if (verb == "get") {
			deferred = dojo.xhrGet(request);
		} else if (verb == "rawPost") {
			request.postData = message;
			dojo.rawXhrPost(request);
		} else if (verb == "post") {
			dojo.xhrPost(request);
		} else if (verb == "rawPut") {
			dojo.rawXhrPut(request);
		} else if (verb == "put") {
			dojo.xhrPut(request);
		} else if (verb == "delete") {
			dojo.xhrDelete(request);
		}
		
	},
	
	isOutstandingUrl:function(url){
		return !!this._outstandingRequest[url];
	},
	
	removeUrl:function(url){
		delete this._outstandingRequest[url];
	}
	
	
});




com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance = function() {
	// summary: 
	//	retrieve the singleton WpdRestHandler instance 
	//  It is initialized in bootstrap.js during start up 
	return dojo.global.BPM.WPD_RestHandler;
};
	

}

if(!dojo._hasResource["dojo.dnd.common"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.common"] = true;
dojo.provide("dojo.dnd.common");

dojo.getObject("dnd", true, dojo);

dojo.dnd.getCopyKeyState = dojo.isCopyKey;

dojo.dnd._uniqueId = 0;
dojo.dnd.getUniqueId = function(){
	// summary:
	//		returns a unique string for use with any DOM element
	var id;
	do{
		id = dojo._scopeName + "Unique" + (++dojo.dnd._uniqueId);
	}while(dojo.byId(id));
	return id;
};

dojo.dnd._empty = {};

dojo.dnd.isFormElement = function(/*Event*/ e){
	// summary:
	//		returns true if user clicked on a form element
	var t = e.target;
	if(t.nodeType == 3 /*TEXT_NODE*/){
		t = t.parentNode;
	}
	return " button textarea input select option ".indexOf(" " + t.tagName.toLowerCase() + " ") >= 0;	// Boolean
};

}

if(!dojo._hasResource["dojo.dnd.autoscroll"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.autoscroll"] = true;
dojo.provide("dojo.dnd.autoscroll");


dojo.getObject("dnd", true, dojo);

dojo.dnd.getViewport = dojo.window.getBox;

dojo.dnd.V_TRIGGER_AUTOSCROLL = 32;
dojo.dnd.H_TRIGGER_AUTOSCROLL = 32;

dojo.dnd.V_AUTOSCROLL_VALUE = 16;
dojo.dnd.H_AUTOSCROLL_VALUE = 16;

dojo.dnd.autoScroll = function(e){
	// summary:
	//		a handler for onmousemove event, which scrolls the window, if
	//		necesary
	// e: Event
	//		onmousemove event

	// FIXME: needs more docs!
	var v = dojo.window.getBox(), dx = 0, dy = 0;
	if(e.clientX < dojo.dnd.H_TRIGGER_AUTOSCROLL){
		dx = -dojo.dnd.H_AUTOSCROLL_VALUE;
	}else if(e.clientX > v.w - dojo.dnd.H_TRIGGER_AUTOSCROLL){
		dx = dojo.dnd.H_AUTOSCROLL_VALUE;
	}
	if(e.clientY < dojo.dnd.V_TRIGGER_AUTOSCROLL){
		dy = -dojo.dnd.V_AUTOSCROLL_VALUE;
	}else if(e.clientY > v.h - dojo.dnd.V_TRIGGER_AUTOSCROLL){
		dy = dojo.dnd.V_AUTOSCROLL_VALUE;
	}
	window.scrollBy(dx, dy);
};

dojo.dnd._validNodes = {"div": 1, "p": 1, "td": 1};
dojo.dnd._validOverflow = {"auto": 1, "scroll": 1};

dojo.dnd.autoScrollNodes = function(e){
	// summary:
	//		a handler for onmousemove event, which scrolls the first avaialble
	//		Dom element, it falls back to dojo.dnd.autoScroll()
	// e: Event
	//		onmousemove event

	// FIXME: needs more docs!
	for(var n = e.target; n;){
		if(n.nodeType == 1 && (n.tagName.toLowerCase() in dojo.dnd._validNodes)){
			var s = dojo.getComputedStyle(n);
			if(s.overflow.toLowerCase() in dojo.dnd._validOverflow){
				var b = dojo._getContentBox(n, s), t = dojo.position(n, true);
				//console.log(b.l, b.t, t.x, t.y, n.scrollLeft, n.scrollTop);
				var w = Math.min(dojo.dnd.H_TRIGGER_AUTOSCROLL, b.w / 2),
					h = Math.min(dojo.dnd.V_TRIGGER_AUTOSCROLL, b.h / 2),
					rx = e.pageX - t.x, ry = e.pageY - t.y, dx = 0, dy = 0;
				if(dojo.isWebKit || dojo.isOpera){
					// FIXME: this code should not be here, it should be taken into account
					// either by the event fixing code, or the dojo.position()
					// FIXME: this code doesn't work on Opera 9.5 Beta
					rx += dojo.body().scrollLeft;
					ry += dojo.body().scrollTop;
				}
				if(rx > 0 && rx < b.w){
					if(rx < w){
						dx = -w;
					}else if(rx > b.w - w){
						dx = w;
					}
				}
				//console.log("ry =", ry, "b.h =", b.h, "h =", h);
				if(ry > 0 && ry < b.h){
					if(ry < h){
						dy = -h;
					}else if(ry > b.h - h){
						dy = h;
					}
				}
				var oldLeft = n.scrollLeft, oldTop = n.scrollTop;
				n.scrollLeft = n.scrollLeft + dx;
				n.scrollTop  = n.scrollTop  + dy;
				if(oldLeft != n.scrollLeft || oldTop != n.scrollTop){ return; }
			}
		}
		try{
			n = n.parentNode;
		}catch(x){
			n = null;
		}
	}
	dojo.dnd.autoScroll(e);
};

}

if(!dojo._hasResource["dojo.dnd.Mover"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.Mover"] = true;
dojo.provide("dojo.dnd.Mover");




dojo.declare("dojo.dnd.Mover", null, {
	constructor: function(node, e, host){
		// summary:
		//		an object which makes a node follow the mouse, or touch-drag on touch devices.
		//		Used as a default mover, and as a base class for custom movers.
		// node: Node
		//		a node (or node's id) to be moved
		// e: Event
		//		a mouse event, which started the move;
		//		only pageX and pageY properties are used
		// host: Object?
		//		object which implements the functionality of the move,
		//	 	and defines proper events (onMoveStart and onMoveStop)
		this.node = dojo.byId(node);
		var pos = e.touches ? e.touches[0] : e;
		this.marginBox = {l: pos.pageX, t: pos.pageY};
		this.mouseButton = e.button;
		var h = (this.host = host), d = node.ownerDocument;
		this.events = [
			// At the start of a drag, onFirstMove is called, and then the following two
			// connects are disconnected
			dojo.connect(d, "onmousemove", this, "onFirstMove"),
			dojo.connect(d, "ontouchmove", this, "onFirstMove"),

			// These are called continually during the drag
			dojo.connect(d, "onmousemove", this, "onMouseMove"),
			dojo.connect(d, "ontouchmove", this, "onMouseMove"),

			// And these are called at the end of the drag
			dojo.connect(d, "onmouseup",   this, "onMouseUp"),
			dojo.connect(d, "ontouchend", this, "onMouseUp"),

			// cancel text selection and text dragging
			dojo.connect(d, "ondragstart",   dojo.stopEvent),
			dojo.connect(d.body, "onselectstart", dojo.stopEvent)
		];
		// notify that the move has started
		if(h && h.onMoveStart){
			h.onMoveStart(this);
		}
	},
	// mouse event processors
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove/ontouchmove
		// e: Event
		//		mouse/touch event
		dojo.dnd.autoScroll(e);
		var m = this.marginBox,
			pos = e.touches ? e.touches[0] : e;
		this.host.onMove(this, {l: m.l + pos.pageX, t: m.t + pos.pageY}, e);
		dojo.stopEvent(e);
	},
	onMouseUp: function(e){
		if(dojo.isWebKit && dojo.isMac && this.mouseButton == 2 ?
				e.button == 0 : this.mouseButton == e.button){ // TODO Should condition be met for touch devices, too?
			this.destroy();
		}
		dojo.stopEvent(e);
	},
	// utilities
	onFirstMove: function(e){
		// summary:
		//		makes the node absolute; it is meant to be called only once.
		// 		relative and absolutely positioned nodes are assumed to use pixel units
		var s = this.node.style, l, t, h = this.host;
		switch(s.position){
			case "relative":
			case "absolute":
				// assume that left and top values are in pixels already
				l = Math.round(parseFloat(s.left)) || 0;
				t = Math.round(parseFloat(s.top)) || 0;
				break;
			default:
				s.position = "absolute";	// enforcing the absolute mode
				var m = dojo.marginBox(this.node);
				// event.pageX/pageY (which we used to generate the initial
				// margin box) includes padding and margin set on the body.
				// However, setting the node's position to absolute and then
				// doing dojo.marginBox on it *doesn't* take that additional
				// space into account - so we need to subtract the combined
				// padding and margin.  We use getComputedStyle and
				// _getMarginBox/_getContentBox to avoid the extra lookup of
				// the computed style.
				var b = dojo.doc.body;
				var bs = dojo.getComputedStyle(b);
				var bm = dojo._getMarginBox(b, bs);
				var bc = dojo._getContentBox(b, bs);
				l = m.l - (bc.l - bm.l);
				t = m.t - (bc.t - bm.t);
				break;
		}
		this.marginBox.l = l - this.marginBox.l;
		this.marginBox.t = t - this.marginBox.t;
		if(h && h.onFirstMove){
			h.onFirstMove(this, e);
		}
		
		// Disconnect onmousemove and ontouchmove events that call this function
		dojo.disconnect(this.events.shift());
		dojo.disconnect(this.events.shift());
	},
	destroy: function(){
		// summary:
		//		stops the move, deletes all references, so the object can be garbage-collected
		dojo.forEach(this.events, dojo.disconnect);
		// undo global settings
		var h = this.host;
		if(h && h.onMoveStop){
			h.onMoveStop(this);
		}
		// destroy objects
		this.events = this.node = this.host = null;
	}
});

}

if(!dojo._hasResource["dojo.dnd.Moveable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.Moveable"] = true;
dojo.provide("dojo.dnd.Moveable");



/*=====
dojo.declare("dojo.dnd.__MoveableArgs", [], {
	// handle: Node||String
	//		A node (or node's id), which is used as a mouse handle.
	//		If omitted, the node itself is used as a handle.
	handle: null,

	// delay: Number
	//		delay move by this number of pixels
	delay: 0,

	// skip: Boolean
	//		skip move of form elements
	skip: false,

	// mover: Object
	//		a constructor of custom Mover
	mover: dojo.dnd.Mover
});
=====*/

dojo.declare("dojo.dnd.Moveable", null, {
	// object attributes (for markup)
	handle: "",
	delay: 0,
	skip: false,
	
	constructor: function(node, params){
		// summary:
		//		an object, which makes a node moveable
		// node: Node
		//		a node (or node's id) to be moved
		// params: dojo.dnd.__MoveableArgs?
		//		optional parameters
		this.node = dojo.byId(node);
		if(!params){ params = {}; }
		this.handle = params.handle ? dojo.byId(params.handle) : null;
		if(!this.handle){ this.handle = this.node; }
		this.delay = params.delay > 0 ? params.delay : 0;
		this.skip  = params.skip;
		this.mover = params.mover ? params.mover : dojo.dnd.Mover;
		this.events = [
			dojo.connect(this.handle, "onmousedown", this, "onMouseDown"),
			dojo.connect(this.handle, "ontouchstart", this, "onMouseDown"),
			// cancel text selection and text dragging
			dojo.connect(this.handle, "ondragstart",   this, "onSelectStart"),
			dojo.connect(this.handle, "onselectstart", this, "onSelectStart")
		];
	},

	// markup methods
	markupFactory: function(params, node){
		return new dojo.dnd.Moveable(node, params);
	},

	// methods
	destroy: function(){
		// summary:
		//		stops watching for possible move, deletes all references, so the object can be garbage-collected
		dojo.forEach(this.events, dojo.disconnect);
		this.events = this.node = this.handle = null;
	},
	
	// mouse event processors
	onMouseDown: function(e){
		// summary:
		//		event processor for onmousedown/ontouchstart, creates a Mover for the node
		// e: Event
		//		mouse/touch event
		if(this.skip && dojo.dnd.isFormElement(e)){ return; }
		if(this.delay){
			this.events.push(
				dojo.connect(this.handle, "onmousemove", this, "onMouseMove"),
				dojo.connect(this.handle, "ontouchmove", this, "onMouseMove"),
				dojo.connect(this.handle, "onmouseup", this, "onMouseUp"),
				dojo.connect(this.handle, "ontouchend", this, "onMouseUp")
			);
			var pos = e.touches ? e.touches[0] : e;
			this._lastX = pos.pageX;
			this._lastY = pos.pageY;
		}else{
			this.onDragDetected(e);
		}
		dojo.stopEvent(e);
	},
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove/ontouchmove, used only for delayed drags
		// e: Event
		//		mouse/touch event
		var pos = e.touches ? e.touches[0] : e;
		if(Math.abs(pos.pageX - this._lastX) > this.delay || Math.abs(pos.pageY - this._lastY) > this.delay){
			this.onMouseUp(e);
			this.onDragDetected(e);
		}
		dojo.stopEvent(e);
	},
	onMouseUp: function(e){
		// summary:
		//		event processor for onmouseup, used only for delayed drags
		// e: Event
		//		mouse event
		for(var i = 0; i < 2; ++i){
			dojo.disconnect(this.events.pop());
		}
		dojo.stopEvent(e);
	},
	onSelectStart: function(e){
		// summary:
		//		event processor for onselectevent and ondragevent
		// e: Event
		//		mouse event
		if(!this.skip || !dojo.dnd.isFormElement(e)){
			dojo.stopEvent(e);
		}
	},
	
	// local events
	onDragDetected: function(/* Event */ e){
		// summary:
		//		called when the drag is detected;
		//		responsible for creation of the mover
		new this.mover(this.node, e, this);
	},
	onMoveStart: function(/* dojo.dnd.Mover */ mover){
		// summary:
		//		called before every move operation
		dojo.publish("/dnd/move/start", [mover]);
		dojo.addClass(dojo.body(), "dojoMove");
		dojo.addClass(this.node, "dojoMoveItem");
	},
	onMoveStop: function(/* dojo.dnd.Mover */ mover){
		// summary:
		//		called after every move operation
		dojo.publish("/dnd/move/stop", [mover]);
		dojo.removeClass(dojo.body(), "dojoMove");
		dojo.removeClass(this.node, "dojoMoveItem");
	},
	onFirstMove: function(/* dojo.dnd.Mover */ mover, /* Event */ e){
		// summary:
		//		called during the very first move notification;
		//		can be used to initialize coordinates, can be overwritten.
		
		// default implementation does nothing
	},
	onMove: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop, /* Event */ e){
		// summary:
		//		called during every move notification;
		//		should actually move the node; can be overwritten.
		this.onMoving(mover, leftTop);
		var s = mover.node.style;
		s.left = leftTop.l + "px";
		s.top  = leftTop.t + "px";
		this.onMoved(mover, leftTop);
	},
	onMoving: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
		// summary:
		//		called before every incremental move; can be overwritten.
		
		// default implementation does nothing
	},
	onMoved: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
		// summary:
		//		called after every incremental move; can be overwritten.
		
		// default implementation does nothing
	}
});

}

if(!dojo._hasResource["dojo.dnd.move"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.move"] = true;
dojo.provide("dojo.dnd.move");




/*=====
dojo.declare("dojo.dnd.move.__constrainedMoveableArgs", [dojo.dnd.__MoveableArgs], {
	// constraints: Function
	//		Calculates a constraint box.
	//		It is called in a context of the moveable object.
	constraints: function(){},

	// within: Boolean
	//		restrict move within boundaries.
	within: false
});
=====*/

dojo.declare("dojo.dnd.move.constrainedMoveable", dojo.dnd.Moveable, {
	// object attributes (for markup)
	constraints: function(){},
	within: false,
	
	// markup methods
	markupFactory: function(params, node){
		return new dojo.dnd.move.constrainedMoveable(node, params);
	},

	constructor: function(node, params){
		// summary:
		//		an object that makes a node moveable
		// node: Node
		//		a node (or node's id) to be moved
		// params: dojo.dnd.move.__constrainedMoveableArgs?
		//		an optional object with additional parameters;
		//		the rest is passed to the base class
		if(!params){ params = {}; }
		this.constraints = params.constraints;
		this.within = params.within;
	},
	onFirstMove: function(/* dojo.dnd.Mover */ mover){
		// summary:
		//		called during the very first move notification;
		//		can be used to initialize coordinates, can be overwritten.
		var c = this.constraintBox = this.constraints.call(this, mover);
		c.r = c.l + c.w;
		c.b = c.t + c.h;
		if(this.within){
			var mb = dojo._getMarginSize(mover.node);
			c.r -= mb.w;
			c.b -= mb.h;
		}
	},
	onMove: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
		// summary:
		//		called during every move notification;
		//		should actually move the node; can be overwritten.
		var c = this.constraintBox, s = mover.node.style;
		this.onMoving(mover, leftTop);
		leftTop.l = leftTop.l < c.l ? c.l : c.r < leftTop.l ? c.r : leftTop.l;
		leftTop.t = leftTop.t < c.t ? c.t : c.b < leftTop.t ? c.b : leftTop.t;
		s.left = leftTop.l + "px";
		s.top  = leftTop.t + "px";
		this.onMoved(mover, leftTop);
	}
});

/*=====
dojo.declare("dojo.dnd.move.__boxConstrainedMoveableArgs", [dojo.dnd.move.__constrainedMoveableArgs], {
	// box: Object
	//		a constraint box
	box: {}
});
=====*/

dojo.declare("dojo.dnd.move.boxConstrainedMoveable", dojo.dnd.move.constrainedMoveable, {
	// box:
	//		object attributes (for markup)
	box: {},
	
	// markup methods
	markupFactory: function(params, node){
		return new dojo.dnd.move.boxConstrainedMoveable(node, params);
	},

	constructor: function(node, params){
		// summary:
		//		an object, which makes a node moveable
		// node: Node
		//		a node (or node's id) to be moved
		// params: dojo.dnd.move.__boxConstrainedMoveableArgs?
		//		an optional object with parameters
		var box = params && params.box;
		this.constraints = function(){ return box; };
	}
});

/*=====
dojo.declare("dojo.dnd.move.__parentConstrainedMoveableArgs", [dojo.dnd.move.__constrainedMoveableArgs], {
	// area: String
	//		A parent's area to restrict the move.
	//		Can be "margin", "border", "padding", or "content".
	area: ""
});
=====*/

dojo.declare("dojo.dnd.move.parentConstrainedMoveable", dojo.dnd.move.constrainedMoveable, {
	// area:
	//		object attributes (for markup)
	area: "content",

	// markup methods
	markupFactory: function(params, node){
		return new dojo.dnd.move.parentConstrainedMoveable(node, params);
	},

	constructor: function(node, params){
		// summary:
		//		an object, which makes a node moveable
		// node: Node
		//		a node (or node's id) to be moved
		// params: dojo.dnd.move.__parentConstrainedMoveableArgs?
		//		an optional object with parameters
		var area = params && params.area;
		this.constraints = function(){
			var n = this.node.parentNode,
				s = dojo.getComputedStyle(n),
				mb = dojo._getMarginBox(n, s);
			if(area == "margin"){
				return mb;	// Object
			}
			var t = dojo._getMarginExtents(n, s);
			mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
			if(area == "border"){
				return mb;	// Object
			}
			t = dojo._getBorderExtents(n, s);
			mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
			if(area == "padding"){
				return mb;	// Object
			}
			t = dojo._getPadExtents(n, s);
			mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
			return mb;	// Object
		};
	}
});

// patching functions one level up for compatibility

dojo.dnd.constrainedMover = dojo.dnd.move.constrainedMover;
dojo.dnd.boxConstrainedMover = dojo.dnd.move.boxConstrainedMover;
dojo.dnd.parentConstrainedMover = dojo.dnd.move.parentConstrainedMover;

}

if(!dojo._hasResource["dojo.dnd.TimedMoveable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.TimedMoveable"] = true;
dojo.provide("dojo.dnd.TimedMoveable");



/*=====
dojo.declare("dojo.dnd.__TimedMoveableArgs", [dojo.dnd.__MoveableArgs], {
	// timeout: Number
	//		delay move by this number of ms,
	//		accumulating position changes during the timeout
	timeout: 0
});
=====*/

(function(){
	// precalculate long expressions
	var oldOnMove = dojo.dnd.Moveable.prototype.onMove;
		
	dojo.declare("dojo.dnd.TimedMoveable", dojo.dnd.Moveable, {
		// summary:
		//		A specialized version of Moveable to support an FPS throttling.
		//		This class puts an upper restriction on FPS, which may reduce
		//		the CPU load. The additional parameter "timeout" regulates
		//		the delay before actually moving the moveable object.
		
		// object attributes (for markup)
		timeout: 40,	// in ms, 40ms corresponds to 25 fps
	
		constructor: function(node, params){
			// summary:
			//		an object that makes a node moveable with a timer
			// node: Node||String
			//		a node (or node's id) to be moved
			// params: dojo.dnd.__TimedMoveableArgs
			//		object with additional parameters.
			
			// sanitize parameters
			if(!params){ params = {}; }
			if(params.timeout && typeof params.timeout == "number" && params.timeout >= 0){
				this.timeout = params.timeout;
			}
		},
	
		// markup methods
		markupFactory: function(params, node){
			return new dojo.dnd.TimedMoveable(node, params);
		},
	
		onMoveStop: function(/* dojo.dnd.Mover */ mover){
			if(mover._timer){
				// stop timer
				clearTimeout(mover._timer)
				// reflect the last received position
				oldOnMove.call(this, mover, mover._leftTop)
			}
			dojo.dnd.Moveable.prototype.onMoveStop.apply(this, arguments);
		},
		onMove: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
			mover._leftTop = leftTop;
			if(!mover._timer){
				var _t = this;	// to avoid using dojo.hitch()
				mover._timer = setTimeout(function(){
					// we don't have any pending requests
					mover._timer = null;
					// reflect the last received position
					oldOnMove.call(_t, mover, mover._leftTop);
				}, this.timeout);
			}
		}
	});
})();

}

if(!dojo._hasResource["dojo.fx.Toggler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.fx.Toggler"] = true;
dojo.provide("dojo.fx.Toggler");


dojo.declare("dojo.fx.Toggler", null, {
	// summary:
	//		A simple `dojo.Animation` toggler API.
	//
	// description:
	//		class constructor for an animation toggler. It accepts a packed
	//		set of arguments about what type of animation to use in each
	//		direction, duration, etc. All available members are mixed into
	//		these animations from the constructor (for example, `node`,
	//		`showDuration`, `hideDuration`).
	//
	// example:
	//	|	var t = new dojo.fx.Toggler({
	//	|		node: "nodeId",
	//	|		showDuration: 500,
	//	|		// hideDuration will default to "200"
	//	|		showFunc: dojo.fx.wipeIn,
	//	|		// hideFunc will default to "fadeOut"
	//	|	});
	//	|	t.show(100); // delay showing for 100ms
	//	|	// ...time passes...
	//	|	t.hide();

	// node: DomNode
	//		the node to target for the showing and hiding animations
	node: null,

	// showFunc: Function
	//		The function that returns the `dojo.Animation` to show the node
	showFunc: dojo.fadeIn,

	// hideFunc: Function
	//		The function that returns the `dojo.Animation` to hide the node
	hideFunc: dojo.fadeOut,

	// showDuration:
	//		Time in milliseconds to run the show Animation
	showDuration: 200,

	// hideDuration:
	//		Time in milliseconds to run the hide Animation
	hideDuration: 200,

	// FIXME: need a policy for where the toggler should "be" the next
	// time show/hide are called if we're stopped somewhere in the
	// middle.
	// FIXME: also would be nice to specify individual showArgs/hideArgs mixed into
	// each animation individually.
	// FIXME: also would be nice to have events from the animations exposed/bridged

	/*=====
	_showArgs: null,
	_showAnim: null,

	_hideArgs: null,
	_hideAnim: null,

	_isShowing: false,
	_isHiding: false,
	=====*/

	constructor: function(args){
		var _t = this;

		dojo.mixin(_t, args);
		_t.node = args.node;
		_t._showArgs = dojo.mixin({}, args);
		_t._showArgs.node = _t.node;
		_t._showArgs.duration = _t.showDuration;
		_t.showAnim = _t.showFunc(_t._showArgs);

		_t._hideArgs = dojo.mixin({}, args);
		_t._hideArgs.node = _t.node;
		_t._hideArgs.duration = _t.hideDuration;
		_t.hideAnim = _t.hideFunc(_t._hideArgs);

		dojo.connect(_t.showAnim, "beforeBegin", dojo.hitch(_t.hideAnim, "stop", true));
		dojo.connect(_t.hideAnim, "beforeBegin", dojo.hitch(_t.showAnim, "stop", true));
	},

	show: function(delay){
		// summary: Toggle the node to showing
		// delay: Integer?
		//		Ammount of time to stall playing the show animation
		return this.showAnim.play(delay || 0);
	},

	hide: function(delay){
		// summary: Toggle the node to hidden
		// delay: Integer?
		//		Ammount of time to stall playing the hide animation
		return this.hideAnim.play(delay || 0);
	}
});

}

if(!dojo._hasResource["dojo.fx"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.fx"] = true;
dojo.provide("dojo.fx");



/*=====
dojo.fx = {
	// summary: Effects library on top of Base animations
};
=====*/
(function(){
	
	var d = dojo,
		_baseObj = {
			_fire: function(evt, args){
				if(this[evt]){
					this[evt].apply(this, args||[]);
				}
				return this;
			}
		};

	var _chain = function(animations){
		this._index = -1;
		this._animations = animations||[];
		this._current = this._onAnimateCtx = this._onEndCtx = null;

		this.duration = 0;
		d.forEach(this._animations, function(a){
			this.duration += a.duration;
			if(a.delay){ this.duration += a.delay; }
		}, this);
	};
	d.extend(_chain, {
		_onAnimate: function(){
			this._fire("onAnimate", arguments);
		},
		_onEnd: function(){
			d.disconnect(this._onAnimateCtx);
			d.disconnect(this._onEndCtx);
			this._onAnimateCtx = this._onEndCtx = null;
			if(this._index + 1 == this._animations.length){
				this._fire("onEnd");
			}else{
				// switch animations
				this._current = this._animations[++this._index];
				this._onAnimateCtx = d.connect(this._current, "onAnimate", this, "_onAnimate");
				this._onEndCtx = d.connect(this._current, "onEnd", this, "_onEnd");
				this._current.play(0, true);
			}
		},
		play: function(/*int?*/ delay, /*Boolean?*/ gotoStart){
			if(!this._current){ this._current = this._animations[this._index = 0]; }
			if(!gotoStart && this._current.status() == "playing"){ return this; }
			var beforeBegin = d.connect(this._current, "beforeBegin", this, function(){
					this._fire("beforeBegin");
				}),
				onBegin = d.connect(this._current, "onBegin", this, function(arg){
					this._fire("onBegin", arguments);
				}),
				onPlay = d.connect(this._current, "onPlay", this, function(arg){
					this._fire("onPlay", arguments);
					d.disconnect(beforeBegin);
					d.disconnect(onBegin);
					d.disconnect(onPlay);
				});
			if(this._onAnimateCtx){
				d.disconnect(this._onAnimateCtx);
			}
			this._onAnimateCtx = d.connect(this._current, "onAnimate", this, "_onAnimate");
			if(this._onEndCtx){
				d.disconnect(this._onEndCtx);
			}
			this._onEndCtx = d.connect(this._current, "onEnd", this, "_onEnd");
			this._current.play.apply(this._current, arguments);
			return this;
		},
		pause: function(){
			if(this._current){
				var e = d.connect(this._current, "onPause", this, function(arg){
						this._fire("onPause", arguments);
						d.disconnect(e);
					});
				this._current.pause();
			}
			return this;
		},
		gotoPercent: function(/*Decimal*/percent, /*Boolean?*/ andPlay){
			this.pause();
			var offset = this.duration * percent;
			this._current = null;
			d.some(this._animations, function(a){
				if(a.duration <= offset){
					this._current = a;
					return true;
				}
				offset -= a.duration;
				return false;
			});
			if(this._current){
				this._current.gotoPercent(offset / this._current.duration, andPlay);
			}
			return this;
		},
		stop: function(/*boolean?*/ gotoEnd){
			if(this._current){
				if(gotoEnd){
					for(; this._index + 1 < this._animations.length; ++this._index){
						this._animations[this._index].stop(true);
					}
					this._current = this._animations[this._index];
				}
				var e = d.connect(this._current, "onStop", this, function(arg){
						this._fire("onStop", arguments);
						d.disconnect(e);
					});
				this._current.stop();
			}
			return this;
		},
		status: function(){
			return this._current ? this._current.status() : "stopped";
		},
		destroy: function(){
			if(this._onAnimateCtx){ d.disconnect(this._onAnimateCtx); }
			if(this._onEndCtx){ d.disconnect(this._onEndCtx); }
		}
	});
	d.extend(_chain, _baseObj);

	dojo.fx.chain = function(/*dojo.Animation[]*/ animations){
		// summary:
		//		Chain a list of `dojo.Animation`s to run in sequence
		//
		// description:
		//		Return a `dojo.Animation` which will play all passed
		//		`dojo.Animation` instances in sequence, firing its own
		//		synthesized events simulating a single animation. (eg:
		//		onEnd of this animation means the end of the chain,
		//		not the individual animations within)
		//
		// example:
		//	Once `node` is faded out, fade in `otherNode`
		//	|	dojo.fx.chain([
		//	|		dojo.fadeIn({ node:node }),
		//	|		dojo.fadeOut({ node:otherNode })
		//	|	]).play();
		//
		return new _chain(animations) // dojo.Animation
	};

	var _combine = function(animations){
		this._animations = animations||[];
		this._connects = [];
		this._finished = 0;

		this.duration = 0;
		d.forEach(animations, function(a){
			var duration = a.duration;
			if(a.delay){ duration += a.delay; }
			if(this.duration < duration){ this.duration = duration; }
			this._connects.push(d.connect(a, "onEnd", this, "_onEnd"));
		}, this);
		
		this._pseudoAnimation = new d.Animation({curve: [0, 1], duration: this.duration});
		var self = this;
		d.forEach(["beforeBegin", "onBegin", "onPlay", "onAnimate", "onPause", "onStop", "onEnd"],
			function(evt){
				self._connects.push(d.connect(self._pseudoAnimation, evt,
					function(){ self._fire(evt, arguments); }
				));
			}
		);
	};
	d.extend(_combine, {
		_doAction: function(action, args){
			d.forEach(this._animations, function(a){
				a[action].apply(a, args);
			});
			return this;
		},
		_onEnd: function(){
			if(++this._finished > this._animations.length){
				this._fire("onEnd");
			}
		},
		_call: function(action, args){
			var t = this._pseudoAnimation;
			t[action].apply(t, args);
		},
		play: function(/*int?*/ delay, /*Boolean?*/ gotoStart){
			this._finished = 0;
			this._doAction("play", arguments);
			this._call("play", arguments);
			return this;
		},
		pause: function(){
			this._doAction("pause", arguments);
			this._call("pause", arguments);
			return this;
		},
		gotoPercent: function(/*Decimal*/percent, /*Boolean?*/ andPlay){
			var ms = this.duration * percent;
			d.forEach(this._animations, function(a){
				a.gotoPercent(a.duration < ms ? 1 : (ms / a.duration), andPlay);
			});
			this._call("gotoPercent", arguments);
			return this;
		},
		stop: function(/*boolean?*/ gotoEnd){
			this._doAction("stop", arguments);
			this._call("stop", arguments);
			return this;
		},
		status: function(){
			return this._pseudoAnimation.status();
		},
		destroy: function(){
			d.forEach(this._connects, dojo.disconnect);
		}
	});
	d.extend(_combine, _baseObj);

	dojo.fx.combine = function(/*dojo.Animation[]*/ animations){
		// summary:
		//		Combine a list of `dojo.Animation`s to run in parallel
		//
		// description:
		//		Combine an array of `dojo.Animation`s to run in parallel,
		//		providing a new `dojo.Animation` instance encompasing each
		//		animation, firing standard animation events.
		//
		// example:
		//	Fade out `node` while fading in `otherNode` simultaneously
		//	|	dojo.fx.combine([
		//	|		dojo.fadeIn({ node:node }),
		//	|		dojo.fadeOut({ node:otherNode })
		//	|	]).play();
		//
		// example:
		//	When the longest animation ends, execute a function:
		//	|	var anim = dojo.fx.combine([
		//	|		dojo.fadeIn({ node: n, duration:700 }),
		//	|		dojo.fadeOut({ node: otherNode, duration: 300 })
		//	|	]);
		//	|	dojo.connect(anim, "onEnd", function(){
		//	|		// overall animation is done.
		//	|	});
		//	|	anim.play(); // play the animation
		//
		return new _combine(animations); // dojo.Animation
	};

	dojo.fx.wipeIn = function(/*Object*/ args){
		// summary:
		//		Expand a node to it's natural height.
		//
		// description:
		//		Returns an animation that will expand the
		//		node defined in 'args' object from it's current height to
		//		it's natural height (with no scrollbar).
		//		Node must have no margin/border/padding.
		//
		// args: Object
		//		A hash-map of standard `dojo.Animation` constructor properties
		//		(such as easing: node: duration: and so on)
		//
		// example:
		//	|	dojo.fx.wipeIn({
		//	|		node:"someId"
		//	|	}).play()
		var node = args.node = d.byId(args.node), s = node.style, o;

		var anim = d.animateProperty(d.mixin({
			properties: {
				height: {
					// wrapped in functions so we wait till the last second to query (in case value has changed)
					start: function(){
						// start at current [computed] height, but use 1px rather than 0
						// because 0 causes IE to display the whole panel
						o = s.overflow;
						s.overflow = "hidden";
						if(s.visibility == "hidden" || s.display == "none"){
							s.height = "1px";
							s.display = "";
							s.visibility = "";
							return 1;
						}else{
							var height = d.style(node, "height");
							return Math.max(height, 1);
						}
					},
					end: function(){
						return node.scrollHeight;
					}
				}
			}
		}, args));

		d.connect(anim, "onEnd", function(){
			s.height = "auto";
			s.overflow = o;
		});

		return anim; // dojo.Animation
	};

	dojo.fx.wipeOut = function(/*Object*/ args){
		// summary:
		//		Shrink a node to nothing and hide it.
		//
		// description:
		//		Returns an animation that will shrink node defined in "args"
		//		from it's current height to 1px, and then hide it.
		//
		// args: Object
		//		A hash-map of standard `dojo.Animation` constructor properties
		//		(such as easing: node: duration: and so on)
		//
		// example:
		//	|	dojo.fx.wipeOut({ node:"someId" }).play()
		
		var node = args.node = d.byId(args.node), s = node.style, o;
		
		var anim = d.animateProperty(d.mixin({
			properties: {
				height: {
					end: 1 // 0 causes IE to display the whole panel
				}
			}
		}, args));

		d.connect(anim, "beforeBegin", function(){
			o = s.overflow;
			s.overflow = "hidden";
			s.display = "";
		});
		d.connect(anim, "onEnd", function(){
			s.overflow = o;
			s.height = "auto";
			s.display = "none";
		});

		return anim; // dojo.Animation
	};

	dojo.fx.slideTo = function(/*Object*/ args){
		// summary:
		//		Slide a node to a new top/left position
		//
		// description:
		//		Returns an animation that will slide "node"
		//		defined in args Object from its current position to
		//		the position defined by (args.left, args.top).
		//
		// args: Object
		//		A hash-map of standard `dojo.Animation` constructor properties
		//		(such as easing: node: duration: and so on). Special args members
		//		are `top` and `left`, which indicate the new position to slide to.
		//
		// example:
		//	|	dojo.fx.slideTo({ node: node, left:"40", top:"50", units:"px" }).play()

		var node = args.node = d.byId(args.node),
			top = null, left = null;

		var init = (function(n){
			return function(){
				var cs = d.getComputedStyle(n);
				var pos = cs.position;
				top = (pos == 'absolute' ? n.offsetTop : parseInt(cs.top) || 0);
				left = (pos == 'absolute' ? n.offsetLeft : parseInt(cs.left) || 0);
				if(pos != 'absolute' && pos != 'relative'){
					var ret = d.position(n, true);
					top = ret.y;
					left = ret.x;
					n.style.position="absolute";
					n.style.top=top+"px";
					n.style.left=left+"px";
				}
			};
		})(node);
		init();

		var anim = d.animateProperty(d.mixin({
			properties: {
				top: args.top || 0,
				left: args.left || 0
			}
		}, args));
		d.connect(anim, "beforeBegin", anim, init);

		return anim; // dojo.Animation
	};

})();

}

if(!dojo._hasResource["dijit.form._FormMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form._FormMixin"] = true;
dojo.provide("dijit.form._FormMixin");



dojo.declare("dijit.form._FormMixin", null, {
	// summary:
	//		Mixin for containers of form widgets (i.e. widgets that represent a single value
	//		and can be children of a <form> node or dijit.form.Form widget)
	// description:
	//		Can extract all the form widgets
	//		values and combine them into a single javascript object, or alternately
	//		take such an object and set the values for all the contained
	//		form widgets

/*=====
	// value: Object
	//		Name/value hash for each child widget with a name and value.
	//		Child widgets without names are not part of the hash.
	//
	//		If there are multiple child widgets w/the same name, value is an array,
	//		unless they are radio buttons in which case value is a scalar (since only
	//		one radio button can be checked at a time).
	//
	//		If a child widget's name is a dot separated list (like a.b.c.d), it's a nested structure.
	//
	//		Example:
	//	|	{ name: "John Smith", interests: ["sports", "movies"] }
=====*/

	// state: [readonly] String
	//		Will be "Error" if one or more of the child widgets has an invalid value,
	//		"Incomplete" if not all of the required child widgets are filled in.  Otherwise, "",
	//		which indicates that the form is ready to be submitted.
	state: "",

	//	TODO:
	//	* Repeater
	//	* better handling for arrays.  Often form elements have names with [] like
	//	* people[3].sex (for a list of people [{name: Bill, sex: M}, ...])
	//
	//

		reset: function(){
			dojo.forEach(this.getDescendants(), function(widget){
				if(widget.reset){
					widget.reset();
				}
			});
		},

		validate: function(){
			// summary:
			//		returns if the form is valid - same as isValid - but
			//		provides a few additional (ui-specific) features.
			//		1 - it will highlight any sub-widgets that are not
			//			valid
			//		2 - it will call focus() on the first invalid
			//			sub-widget
			var didFocus = false;
			return dojo.every(dojo.map(this.getDescendants(), function(widget){
				// Need to set this so that "required" widgets get their
				// state set.
				widget._hasBeenBlurred = true;
				var valid = widget.disabled || !widget.validate || widget.validate();
				if(!valid && !didFocus){
					// Set focus of the first non-valid widget
					dojo.window.scrollIntoView(widget.containerNode || widget.domNode);
					widget.focus();
					didFocus = true;
				}
	 			return valid;
	 		}), function(item){ return item; });
		},

		setValues: function(val){
			dojo.deprecated(this.declaredClass+"::setValues() is deprecated. Use set('value', val) instead.", "", "2.0");
			return this.set('value', val);
		},
		_setValueAttr: function(/*Object*/ obj){
			// summary:
			//		Fill in form values from according to an Object (in the format returned by get('value'))

			// generate map from name --> [list of widgets with that name]
			var map = { };
			dojo.forEach(this.getDescendants(), function(widget){
				if(!widget.name){ return; }
				var entry = map[widget.name] || (map[widget.name] = [] );
				entry.push(widget);
			});

			for(var name in map){
				if(!map.hasOwnProperty(name)){
					continue;
				}
				var widgets = map[name],						// array of widgets w/this name
					values = dojo.getObject(name, false, obj);	// list of values for those widgets

				if(values === undefined){
					continue;
				}
				if(!dojo.isArray(values)){
					values = [ values ];
				}
				if(typeof widgets[0].checked == 'boolean'){
					// for checkbox/radio, values is a list of which widgets should be checked
					dojo.forEach(widgets, function(w, i){
						w.set('value', dojo.indexOf(values, w.value) != -1);
					});
				}else if(widgets[0].multiple){
					// it takes an array (e.g. multi-select)
					widgets[0].set('value', values);
				}else{
					// otherwise, values is a list of values to be assigned sequentially to each widget
					dojo.forEach(widgets, function(w, i){
						w.set('value', values[i]);
					});
				}
			}

			/***
			 * 	TODO: code for plain input boxes (this shouldn't run for inputs that are part of widgets)

			dojo.forEach(this.containerNode.elements, function(element){
				if(element.name == ''){return};	// like "continue"
				var namePath = element.name.split(".");
				var myObj=obj;
				var name=namePath[namePath.length-1];
				for(var j=1,len2=namePath.length;j<len2;++j){
					var p=namePath[j - 1];
					// repeater support block
					var nameA=p.split("[");
					if(nameA.length > 1){
						if(typeof(myObj[nameA[0]]) == "undefined"){
							myObj[nameA[0]]=[ ];
						} // if

						nameIndex=parseInt(nameA[1]);
						if(typeof(myObj[nameA[0]][nameIndex]) == "undefined"){
							myObj[nameA[0]][nameIndex] = { };
						}
						myObj=myObj[nameA[0]][nameIndex];
						continue;
					} // repeater support ends

					if(typeof(myObj[p]) == "undefined"){
						myObj=undefined;
						break;
					};
					myObj=myObj[p];
				}

				if(typeof(myObj) == "undefined"){
					return;		// like "continue"
				}
				if(typeof(myObj[name]) == "undefined" && this.ignoreNullValues){
					return;		// like "continue"
				}

				// TODO: widget values (just call set('value', ...) on the widget)

				// TODO: maybe should call dojo.getNodeProp() instead
				switch(element.type){
					case "checkbox":
						element.checked = (name in myObj) &&
							dojo.some(myObj[name], function(val){ return val == element.value; });
						break;
					case "radio":
						element.checked = (name in myObj) && myObj[name] == element.value;
						break;
					case "select-multiple":
						element.selectedIndex=-1;
						dojo.forEach(element.options, function(option){
							option.selected = dojo.some(myObj[name], function(val){ return option.value == val; });
						});
						break;
					case "select-one":
						element.selectedIndex="0";
						dojo.forEach(element.options, function(option){
							option.selected = option.value == myObj[name];
						});
						break;
					case "hidden":
					case "text":
					case "textarea":
					case "password":
						element.value = myObj[name] || "";
						break;
				}
	  		});
	  		*/
			
			// Note: no need to call this._set("value", ...) as the child updates will trigger onChange events
			// which I am monitoring.
		},

		getValues: function(){
			dojo.deprecated(this.declaredClass+"::getValues() is deprecated. Use get('value') instead.", "", "2.0");
			return this.get('value');
		},
		_getValueAttr: function(){
			// summary:
			// 		Returns Object representing form values.   See description of `value` for details.
			// description:

			// The value is updated into this.value every time a child has an onChange event,
			// so in the common case this function could just return this.value.   However,
			// that wouldn't work when:
			//
			// 1. User presses return key to submit a form.  That doesn't fire an onchange event,
			// and even if it did it would come too late due to the setTimout(..., 0) in _handleOnChange()
			//
			// 2. app for some reason calls this.get("value") while the user is typing into a
			// form field.   Not sure if that case needs to be supported or not.

			// get widget values
			var obj = { };
			dojo.forEach(this.getDescendants(), function(widget){
				var name = widget.name;
				if(!name || widget.disabled){ return; }

				// Single value widget (checkbox, radio, or plain <input> type widget)
				var value = widget.get('value');

				// Store widget's value(s) as a scalar, except for checkboxes which are automatically arrays
				if(typeof widget.checked == 'boolean'){
					if(/Radio/.test(widget.declaredClass)){
						// radio button
						if(value !== false){
							dojo.setObject(name, value, obj);
						}else{
							// give radio widgets a default of null
							value = dojo.getObject(name, false, obj);
							if(value === undefined){
								dojo.setObject(name, null, obj);
							}
						}
					}else{
						// checkbox/toggle button
						var ary=dojo.getObject(name, false, obj);
						if(!ary){
							ary=[];
							dojo.setObject(name, ary, obj);
						}
						if(value !== false){
							ary.push(value);
						}
					}
				}else{
					var prev=dojo.getObject(name, false, obj);
					if(typeof prev != "undefined"){
						if(dojo.isArray(prev)){
							prev.push(value);
						}else{
							dojo.setObject(name, [prev, value], obj);
						}
					}else{
						// unique name
						dojo.setObject(name, value, obj);
					}
				}
			});

			/***
			 * code for plain input boxes (see also dojo.formToObject, can we use that instead of this code?
			 * but it doesn't understand [] notation, presumably)
			var obj = { };
			dojo.forEach(this.containerNode.elements, function(elm){
				if(!elm.name)	{
					return;		// like "continue"
				}
				var namePath = elm.name.split(".");
				var myObj=obj;
				var name=namePath[namePath.length-1];
				for(var j=1,len2=namePath.length;j<len2;++j){
					var nameIndex = null;
					var p=namePath[j - 1];
					var nameA=p.split("[");
					if(nameA.length > 1){
						if(typeof(myObj[nameA[0]]) == "undefined"){
							myObj[nameA[0]]=[ ];
						} // if
						nameIndex=parseInt(nameA[1]);
						if(typeof(myObj[nameA[0]][nameIndex]) == "undefined"){
							myObj[nameA[0]][nameIndex] = { };
						}
					} else if(typeof(myObj[nameA[0]]) == "undefined"){
						myObj[nameA[0]] = { }
					} // if

					if(nameA.length == 1){
						myObj=myObj[nameA[0]];
					} else{
						myObj=myObj[nameA[0]][nameIndex];
					} // if
				} // for

				if((elm.type != "select-multiple" && elm.type != "checkbox" && elm.type != "radio") || (elm.type == "radio" && elm.checked)){
					if(name == name.split("[")[0]){
						myObj[name]=elm.value;
					} else{
						// can not set value when there is no name
					}
				} else if(elm.type == "checkbox" && elm.checked){
					if(typeof(myObj[name]) == 'undefined'){
						myObj[name]=[ ];
					}
					myObj[name].push(elm.value);
				} else if(elm.type == "select-multiple"){
					if(typeof(myObj[name]) == 'undefined'){
						myObj[name]=[ ];
					}
					for(var jdx=0,len3=elm.options.length; jdx<len3; ++jdx){
						if(elm.options[jdx].selected){
							myObj[name].push(elm.options[jdx].value);
						}
					}
				} // if
				name=undefined;
			}); // forEach
			***/
			return obj;
		},

	 	isValid: function(){
	 		// summary:
	 		//		Returns true if all of the widgets are valid.
			//		Deprecated, will be removed in 2.0.  Use get("state") instead.

			return this.state == "";
		},

		onValidStateChange: function(isValid){
			// summary:
			//		Stub function to connect to if you want to do something
			//		(like disable/enable a submit button) when the valid
			//		state changes on the form as a whole.
			//
			//		Deprecated.  Will be removed in 2.0.  Use watch("state", ...) instead.
		},

		_getState: function(){
			// summary:
			//		Compute what this.state should be based on state of children
			var states = dojo.map(this._descendants, function(w){
				return w.get("state") || "";
			});

			return dojo.indexOf(states, "Error") >= 0 ? "Error" :
				dojo.indexOf(states, "Incomplete") >= 0 ? "Incomplete" : "";
		},

		disconnectChildren: function(){
			// summary:
			//		Remove connections to monitor changes to children's value, error state, and disabled state,
			//		in order to update Form.value and Form.state.
			dojo.forEach(this._childConnections || [], dojo.hitch(this, "disconnect"));
			dojo.forEach(this._childWatches || [], function(w){ w.unwatch(); });
		},

		connectChildren: function(/*Boolean*/ inStartup){
			// summary:
			//		Setup connections to monitor changes to children's value, error state, and disabled state,
			//		in order to update Form.value and Form.state.
			//
			//		You can call this function directly, ex. in the event that you
			//		programmatically add a widget to the form *after* the form has been
			//		initialized.

			var _this = this;

			// Remove old connections, if any
			this.disconnectChildren();

			this._descendants = this.getDescendants();

			// (Re)set this.value and this.state.   Send watch() notifications but not on startup.
			var set = inStartup ? function(name, val){ _this[name] = val; } : dojo.hitch(this, "_set");
			set("value", this.get("value"));
			set("state", this._getState());

			// Monitor changes to error state and disabled state in order to update
			// Form.state
			var conns = (this._childConnections = []),
				watches = (this._childWatches = []);
			dojo.forEach(dojo.filter(this._descendants,
				function(item){ return item.validate; }
			),
			function(widget){
				// We are interested in whenever the widget changes validity state - or
				// whenever the disabled attribute on that widget is changed.
				dojo.forEach(["state", "disabled"], function(attr){
					watches.push(widget.watch(attr, function(attr, oldVal, newVal){
						_this.set("state", _this._getState());
					}));
				});
			});

			// And monitor calls to child.onChange so we can update this.value
			var onChange = function(){
				// summary:
				//		Called when child's value or disabled state changes
				
				// Use setTimeout() to collapse value changes in multiple children into a single
				// update to my value.   Multiple updates will occur on:
				//	1. Form.set()
				//	2. Form.reset()
				//	3. user selecting a radio button (which will de-select another radio button,
				//		 causing two onChange events)
				if(_this._onChangeDelayTimer){
					clearTimeout(_this._onChangeDelayTimer);
				}
				_this._onChangeDelayTimer = setTimeout(function(){
					delete _this._onChangeDelayTimer;
					_this._set("value", _this.get("value"));
				}, 10);
			};
			dojo.forEach(
				dojo.filter(this._descendants, function(item){ return item.onChange; } ),
				function(widget){
					// When a child widget's value changes,
					// the efficient thing to do is to just update that one attribute in this.value,
					// but that gets a little complicated when a checkbox is checked/unchecked
					// since this.value["checkboxName"] contains an array of all the checkboxes w/the same name.
					// Doing simple thing for now.
					conns.push(_this.connect(widget, "onChange", onChange));

					// Disabling/enabling a child widget should remove it's value from this.value.
					// Again, this code could be more efficient, doing simple thing for now.
					watches.push(widget.watch("disabled", onChange));
				}
			);
		},

		startup: function(){
			this.inherited(arguments);

			// Initialize value and valid/invalid state tracking.  Needs to be done in startup()
			// so that children are initialized.
			this.connectChildren(true);

			// Make state change call onValidStateChange(), will be removed in 2.0
			this.watch("state", function(attr, oldVal, newVal){ this.onValidStateChange(newVal == ""); });
		},

		destroy: function(){
			this.disconnectChildren();
			this.inherited(arguments);
		}

	});

}

if(!dojo._hasResource["dijit._DialogMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._DialogMixin"] = true;
dojo.provide("dijit._DialogMixin");



dojo.declare("dijit._DialogMixin", null,
	{
		// summary:
		//		This provides functions useful to Dialog and TooltipDialog

		attributeMap: dijit._Widget.prototype.attributeMap,

		execute: function(/*Object*/ formContents){
			// summary:
			//		Callback when the user hits the submit button.
			//		Override this method to handle Dialog execution.
			// description:
			//		After the user has pressed the submit button, the Dialog
			//		first calls onExecute() to notify the container to hide the
			//		dialog and restore focus to wherever it used to be.
			//
			//		*Then* this method is called.
			// type:
			//		callback
		},

		onCancel: function(){
			// summary:
			//	    Called when user has pressed the Dialog's cancel button, to notify container.
			// description:
			//	    Developer shouldn't override or connect to this method;
			//		it's a private communication device between the TooltipDialog
			//		and the thing that opened it (ex: `dijit.form.DropDownButton`)
			// type:
			//		protected
		},

		onExecute: function(){
			// summary:
			//	    Called when user has pressed the dialog's OK button, to notify container.
			// description:
			//	    Developer shouldn't override or connect to this method;
			//		it's a private communication device between the TooltipDialog
			//		and the thing that opened it (ex: `dijit.form.DropDownButton`)
			// type:
			//		protected
		},

		_onSubmit: function(){
			// summary:
			//		Callback when user hits submit button
			// type:
			//		protected
			this.onExecute();	// notify container that we are about to execute
			this.execute(this.get('value'));
		},

		_getFocusItems: function(){
			// summary:
			//		Finds focusable items in dialog,
			//		and sets this._firstFocusItem and this._lastFocusItem
			// tags:
			//		protected

			var elems = dijit._getTabNavigable(this.containerNode);
			this._firstFocusItem = elems.lowest || elems.first || this.closeButtonNode || this.domNode;
			this._lastFocusItem = elems.last || elems.highest || this._firstFocusItem;
		}
	}
);

}

if(!dojo._hasResource["dijit.DialogUnderlay"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.DialogUnderlay"] = true;
dojo.provide("dijit.DialogUnderlay");





dojo.declare(
	"dijit.DialogUnderlay",
	[dijit._Widget, dijit._Templated],
	{
		// summary:
		//		The component that blocks the screen behind a `dijit.Dialog`
		//
		// description:
		// 		A component used to block input behind a `dijit.Dialog`. Only a single
		//		instance of this widget is created by `dijit.Dialog`, and saved as
		//		a reference to be shared between all Dialogs as `dijit._underlay`
		//
		//		The underlay itself can be styled based on and id:
		//	|	#myDialog_underlay { background-color:red; }
		//
		//		In the case of `dijit.Dialog`, this id is based on the id of the Dialog,
		//		suffixed with _underlay.

		// Template has two divs; outer div is used for fade-in/fade-out, and also to hold background iframe.
		// Inner div has opacity specified in CSS file.
		templateString: "<div class='dijitDialogUnderlayWrapper'><div class='dijitDialogUnderlay' dojoAttachPoint='node'></div></div>",

		// Parameters on creation or updatable later

		// dialogId: String
		//		Id of the dialog.... DialogUnderlay's id is based on this id
		dialogId: "",

		// class: String
		//		This class name is used on the DialogUnderlay node, in addition to dijitDialogUnderlay
		"class": "",

		attributeMap: { id: "domNode" },

		_setDialogIdAttr: function(id){
			dojo.attr(this.node, "id", id + "_underlay");
			this._set("dialogId", id);
		},

		_setClassAttr: function(clazz){
			this.node.className = "dijitDialogUnderlay " + clazz;
			this._set("class", clazz);
		},

		postCreate: function(){
			// summary:
			//		Append the underlay to the body
			dojo.body().appendChild(this.domNode);
		},

		layout: function(){
			// summary:
			//		Sets the background to the size of the viewport
			//
			// description:
			//		Sets the background to the size of the viewport (rather than the size
			//		of the document) since we need to cover the whole browser window, even
			//		if the document is only a few lines long.
			// tags:
			//		private

			var is = this.node.style,
				os = this.domNode.style;

			// hide the background temporarily, so that the background itself isn't
			// causing scrollbars to appear (might happen when user shrinks browser
			// window and then we are called to resize)
			os.display = "none";

			// then resize and show
			var viewport = dojo.window.getBox();
			os.top = viewport.t + "px";
			os.left = viewport.l + "px";
			is.width = viewport.w + "px";
			is.height = viewport.h + "px";
			os.display = "block";
		},

		show: function(){
			// summary:
			//		Show the dialog underlay
			this.domNode.style.display = "block";
			this.layout();
			this.bgIframe = new dijit.BackgroundIframe(this.domNode);
		},

		hide: function(){
			// summary:
			//		Hides the dialog underlay
			this.bgIframe.destroy();
			delete this.bgIframe;
			this.domNode.style.display = "none";
		}
	}
);

}

if(!dojo._hasResource["dijit.TooltipDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.TooltipDialog"] = true;
dojo.provide("dijit.TooltipDialog");






dojo.declare(
		"dijit.TooltipDialog",
		[dijit.layout.ContentPane, dijit._Templated, dijit.form._FormMixin, dijit._DialogMixin],
		{
			// summary:
			//		Pops up a dialog that appears like a Tooltip

			// title: String
			// 		Description of tooltip dialog (required for a11y)
			title: "",

			// doLayout: [protected] Boolean
			//		Don't change this parameter from the default value.
			//		This ContentPane parameter doesn't make sense for TooltipDialog, since TooltipDialog
			//		is never a child of a layout container, nor can you specify the size of
			//		TooltipDialog in order to control the size of an inner widget.
			doLayout: false,

			// autofocus: Boolean
			// 		A Toggle to modify the default focus behavior of a Dialog, which
			// 		is to focus on the first dialog element after opening the dialog.
			//		False will disable autofocusing. Default: true
			autofocus: true,

			// baseClass: [protected] String
			//		The root className to use for the various states of this widget
			baseClass: "dijitTooltipDialog",

			// _firstFocusItem: [private] [readonly] DomNode
			//		The pointer to the first focusable node in the dialog.
			//		Set by `dijit._DialogMixin._getFocusItems`.
			_firstFocusItem: null,

			// _lastFocusItem: [private] [readonly] DomNode
			//		The pointer to which node has focus prior to our dialog.
			//		Set by `dijit._DialogMixin._getFocusItems`.
			_lastFocusItem: null,

			templateString: dojo.cache("dijit", "templates/TooltipDialog.html", "<div role=\"presentation\" tabIndex=\"-1\">\n\t<div class=\"dijitTooltipContainer\" role=\"presentation\">\n\t\t<div class =\"dijitTooltipContents dijitTooltipFocusNode\" dojoAttachPoint=\"containerNode\" role=\"dialog\"></div>\n\t</div>\n\t<div class=\"dijitTooltipConnector\" role=\"presentation\"></div>\n</div>\n"),

			_setTitleAttr: function(/*String*/ title){
				this.containerNode.title = title;
				this._set("title", title)
			},

			postCreate: function(){
				this.inherited(arguments);
				this.connect(this.containerNode, "onkeypress", "_onKey");
			},

			orient: function(/*DomNode*/ node, /*String*/ aroundCorner, /*String*/ corner){
				// summary:
				//		Configure widget to be displayed in given position relative to the button.
				//		This is called from the dijit.popup code, and should not be called
				//		directly.
				// tags:
				//		protected
				var newC = "dijitTooltipAB" + (corner.charAt(1) == 'L' ? "Left" : "Right")
						+ " dijitTooltip"
						+ (corner.charAt(0) == 'T' ? "Below" : "Above");
				
				dojo.replaceClass(this.domNode, newC, this._currentOrientClass || "");
				this._currentOrientClass = newC;
			},

			focus: function(){
				// summary:
				//		Focus on first field
				this._getFocusItems(this.containerNode);
				dijit.focus(this._firstFocusItem);
			},

			onOpen: function(/*Object*/ pos){
				// summary:
				//		Called when dialog is displayed.
				//		This is called from the dijit.popup code, and should not be called directly.
				// tags:
				//		protected

				this.orient(this.domNode,pos.aroundCorner, pos.corner);
				this._onShow(); // lazy load trigger
			},

			onClose: function(){
				// summary:
				//		Called when dialog is hidden.
				//		This is called from the dijit.popup code, and should not be called directly.
				// tags:
				//		protected
				this.onHide();
			},

			_onKey: function(/*Event*/ evt){
				// summary:
				//		Handler for keyboard events
				// description:
				//		Keep keyboard focus in dialog; close dialog on escape key
				// tags:
				//		private

				var node = evt.target;
				var dk = dojo.keys;
				if(evt.charOrCode === dk.TAB){
					this._getFocusItems(this.containerNode);
				}
				var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
				if(evt.charOrCode == dk.ESCAPE){
					// Use setTimeout to avoid crash on IE, see #10396.
					setTimeout(dojo.hitch(this, "onCancel"), 0);
					dojo.stopEvent(evt);
				}else if(node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB){
					if(!singleFocusItem){
						dijit.focus(this._lastFocusItem); // send focus to last item in dialog
					}
					dojo.stopEvent(evt);
				}else if(node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey){
					if(!singleFocusItem){
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}else if(evt.charOrCode === dk.TAB){
					// we want the browser's default tab handling to move focus
					// but we don't want the tab to propagate upwards
					evt.stopPropagation();
				}
			}
		}
	);

}

if(!dojo._hasResource["dijit.Dialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Dialog"] = true;
dojo.provide("dijit.Dialog");















// dijit/TooltipDialog required for back-compat.  TODO: remove in 2.0

/*=====
dijit._underlay = function(kwArgs){
	// summary:
	//		A shared instance of a `dijit.DialogUnderlay`
	//
	// description:
	//		A shared instance of a `dijit.DialogUnderlay` created and
	//		used by `dijit.Dialog`, though never created until some Dialog
	//		or subclass thereof is shown.
};
=====*/
dojo.declare(
	"dijit._DialogBase",
	[dijit._Templated, dijit.form._FormMixin, dijit._DialogMixin, dijit._CssStateMixin],
	{
		// summary:
		//		A modal dialog Widget
		//
		// description:
		//		Pops up a modal dialog window, blocking access to the screen
		//		and also graying out the screen Dialog is extended from
		//		ContentPane so it supports all the same parameters (href, etc.)
		//
		// example:
		// |	<div dojoType="dijit.Dialog" href="test.html"></div>
		//
		// example:
		// |	var foo = new dijit.Dialog({ title: "test dialog", content: "test content" };
		// |	dojo.body().appendChild(foo.domNode);
		// |	foo.startup();

		templateString: dojo.cache("dijit", "templates/Dialog.html", "<div class=\"dijitDialog\" role=\"dialog\" aria-labelledby=\"${id}_title\">\n\t<div dojoAttachPoint=\"titleBar\" class=\"dijitDialogTitleBar\">\n\t<span dojoAttachPoint=\"titleNode\" class=\"dijitDialogTitle\" id=\"${id}_title\"></span>\n\t<span dojoAttachPoint=\"closeButtonNode\" class=\"dijitDialogCloseIcon\" dojoAttachEvent=\"ondijitclick: onCancel\" title=\"${buttonCancel}\" role=\"button\" tabIndex=\"-1\">\n\t\t<span dojoAttachPoint=\"closeText\" class=\"closeText\" title=\"${buttonCancel}\">x</span>\n\t</span>\n\t</div>\n\t\t<div dojoAttachPoint=\"containerNode\" class=\"dijitDialogPaneContent\"></div>\n</div>\n"),
		
		baseClass: "dijitDialog",
		
		cssStateNodes: {
			closeButtonNode: "dijitDialogCloseIcon"
		},

		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			title: [
				{ node: "titleNode", type: "innerHTML" },
				{ node: "titleBar", type: "attribute" }
			],
			"aria-describedby":""
		}),

		// open: [readonly] Boolean
		//		True if Dialog is currently displayed on screen.
		open: false,

		// duration: Integer
		//		The time in milliseconds it takes the dialog to fade in and out
		duration: dijit.defaultDuration,

		// refocus: Boolean
		// 		A Toggle to modify the default focus behavior of a Dialog, which
		// 		is to re-focus the element which had focus before being opened.
		//		False will disable refocusing. Default: true
		refocus: true,

		// autofocus: Boolean
		// 		A Toggle to modify the default focus behavior of a Dialog, which
		// 		is to focus on the first dialog element after opening the dialog.
		//		False will disable autofocusing. Default: true
		autofocus: true,

		// _firstFocusItem: [private readonly] DomNode
		//		The pointer to the first focusable node in the dialog.
		//		Set by `dijit._DialogMixin._getFocusItems`.
		_firstFocusItem: null,

		// _lastFocusItem: [private readonly] DomNode
		//		The pointer to which node has focus prior to our dialog.
		//		Set by `dijit._DialogMixin._getFocusItems`.
		_lastFocusItem: null,

		// doLayout: [protected] Boolean
		//		Don't change this parameter from the default value.
		//		This ContentPane parameter doesn't make sense for Dialog, since Dialog
		//		is never a child of a layout container, nor can you specify the size of
		//		Dialog in order to control the size of an inner widget.
		doLayout: false,

		// draggable: Boolean
		//		Toggles the moveable aspect of the Dialog. If true, Dialog
		//		can be dragged by it's title. If false it will remain centered
		//		in the viewport.
		draggable: true,

		//aria-describedby: String
		//		Allows the user to add an aria-describedby attribute onto the dialog.   The value should
		//		be the id of the container element of text that describes the dialog purpose (usually
		//		the first text in the dialog).
		//		<div dojoType="dijit.Dialog" aria-describedby="intro" .....>
		//			<div id="intro">Introductory text</div>
		//			<div>rest of dialog contents</div>
		//		</div>
		"aria-describedby":"",

		postMixInProperties: function(){
			var _nlsResources = dojo.i18n.getLocalization("dijit", "common");
			dojo.mixin(this, _nlsResources);
			this.inherited(arguments);
		},

		postCreate: function(){
			dojo.style(this.domNode, {
				display: "none",
				position:"absolute"
			});
			dojo.body().appendChild(this.domNode);

			this.inherited(arguments);

			this.connect(this, "onExecute", "hide");
			this.connect(this, "onCancel", "hide");
			this._modalconnects = [];
		},

		onLoad: function(){
			// summary:
			//		Called when data has been loaded from an href.
			//		Unlike most other callbacks, this function can be connected to (via `dojo.connect`)
			//		but should *not* be overridden.
			// tags:
			//		callback

			// when href is specified we need to reposition the dialog after the data is loaded
			// and find the focusable elements
			this._position();
			if(this.autofocus && dijit._DialogLevelManager.isTop(this)){
				this._getFocusItems(this.domNode);
				dijit.focus(this._firstFocusItem);
			}
			this.inherited(arguments);
		},

		_endDrag: function(){
			// summary:
			//		Called after dragging the Dialog. Saves the position of the dialog in the viewport
			//		and also adjust position to be fully within the viewport, so user doesn't lose access to handle
			// tags:
			//		private
			var nodePosition = dojo.position(this.domNode),
				viewport = dojo.window.getBox();
			nodePosition.y = Math.min(Math.max(nodePosition.y, 0), (viewport.h - nodePosition.h));
			nodePosition.x = Math.min(Math.max(nodePosition.x, 0), (viewport.w - nodePosition.w));
			this._relativePosition = nodePosition;
			this._position();
		},

		_setup: function(){
			// summary:
			//		Stuff we need to do before showing the Dialog for the first
			//		time (but we defer it until right beforehand, for
			//		performance reasons).
			// tags:
			//		private

			var node = this.domNode;

			if(this.titleBar && this.draggable){
				this._moveable = (dojo.isIE == 6) ?
					new dojo.dnd.TimedMoveable(node, { handle: this.titleBar }) :	// prevent overload, see #5285
					new dojo.dnd.Moveable(node, { handle: this.titleBar, timeout: 0 });
				this.connect(this._moveable, "onMoveStop", "_endDrag");
			}else{
				dojo.addClass(node,"dijitDialogFixed");
			}

			this.underlayAttrs = {
				dialogId: this.id,
				"class": dojo.map(this["class"].split(/\s/), function(s){ return s+"_underlay"; }).join(" ")
			};
		},

		_size: function(){
			// summary:
			// 		If necessary, shrink dialog contents so dialog fits in viewport
			// tags:
			//		private

			this._checkIfSingleChild();

			// If we resized the dialog contents earlier, reset them back to original size, so
			// that if the user later increases the viewport size, the dialog can display w/out a scrollbar.
			// Need to do this before the dojo.marginBox(this.domNode) call below.
			if(this._singleChild){
				if(this._singleChildOriginalStyle){
					this._singleChild.domNode.style.cssText = this._singleChildOriginalStyle;
				}
				delete this._singleChildOriginalStyle;
			}else{
				dojo.style(this.containerNode, {
					width:"auto",
					height:"auto"
				});
			}

			var mb = dojo._getMarginSize(this.domNode);
			var viewport = dojo.window.getBox();
			if(mb.w >= viewport.w || mb.h >= viewport.h){
				// Reduce size of dialog contents so that dialog fits in viewport

				var w = Math.min(mb.w, Math.floor(viewport.w * 0.75)),
					h = Math.min(mb.h, Math.floor(viewport.h * 0.75));

				if(this._singleChild && this._singleChild.resize){
					this._singleChildOriginalStyle = this._singleChild.domNode.style.cssText;
					this._singleChild.resize({w: w, h: h});
				}else{
					dojo.style(this.containerNode, {
						width: w + "px",
						height: h + "px",
						overflow: "auto",
						position: "relative"	// workaround IE bug moving scrollbar or dragging dialog
					});
				}
			}else{
				if(this._singleChild && this._singleChild.resize){
					this._singleChild.resize();
				}
			}
		},

		_position: function(){
			// summary:
			//		Position modal dialog in the viewport. If no relative offset
			//		in the viewport has been determined (by dragging, for instance),
			//		center the node. Otherwise, use the Dialog's stored relative offset,
			//		and position the node to top: left: values based on the viewport.
			// tags:
			//		private
			if(!dojo.hasClass(dojo.body(), "dojoMove")){	// don't do anything if called during auto-scroll
				var node = this.domNode,
					viewport = dojo.window.getBox(),
					p = this._relativePosition,
					bb = p ? null : dojo._getBorderBox(node),
					l = Math.floor(viewport.l + (p ? p.x : (viewport.w - bb.w) / 2)),
					t = Math.floor(viewport.t + (p ? p.y : (viewport.h - bb.h) / 2))
				;
				dojo.style(node,{
					left: l + "px",
					top: t + "px"
				});
			}
		},

		_onKey: function(/*Event*/ evt){
			// summary:
			//		Handles the keyboard events for accessibility reasons
			// tags:
			//		private

			if(evt.charOrCode){
				var dk = dojo.keys;
				var node = evt.target;
				if(evt.charOrCode === dk.TAB){
					this._getFocusItems(this.domNode);
				}
				var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
				// see if we are shift-tabbing from first focusable item on dialog
				if(node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB){
					if(!singleFocusItem){
						dijit.focus(this._lastFocusItem); // send focus to last item in dialog
					}
					dojo.stopEvent(evt);
				}else if(node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey){
					if(!singleFocusItem){
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}else{
					// see if the key is for the dialog
					while(node){
						if(node == this.domNode || dojo.hasClass(node, "dijitPopup")){
							if(evt.charOrCode == dk.ESCAPE){
								this.onCancel();
							}else{
								return; // just let it go
							}
						}
						node = node.parentNode;
					}
					// this key is for the disabled document window
					if(evt.charOrCode !== dk.TAB){ // allow tabbing into the dialog for a11y
						dojo.stopEvent(evt);
					// opera won't tab to a div
					}else if(!dojo.isOpera){
						try{
							this._firstFocusItem.focus();
						}catch(e){ /*squelch*/ }
					}
				}
			}
		},

		show: function(){
			// summary:
			//		Display the dialog
			// returns: dojo.Deferred
			//		Deferred object that resolves when the display animation is complete

			if(this.open){ return; }

			if(!this._started){
				this.startup();
			}

			// first time we show the dialog, there's some initialization stuff to do
			if(!this._alreadyInitialized){
				this._setup();
				this._alreadyInitialized=true;
			}

			if(this._fadeOutDeferred){
				this._fadeOutDeferred.cancel();
			}

			this._modalconnects.push(dojo.connect(window, "onscroll", this, "layout"));
			this._modalconnects.push(dojo.connect(window, "onresize", this, function(){
				// IE gives spurious resize events and can actually get stuck
				// in an infinite loop if we don't ignore them
				var viewport = dojo.window.getBox();
				if(!this._oldViewport ||
						viewport.h != this._oldViewport.h ||
						viewport.w != this._oldViewport.w){
					this.layout();
					this._oldViewport = viewport;
				}
			}));
			this._modalconnects.push(dojo.connect(this.domNode, "onkeypress", this, "_onKey"));

			dojo.style(this.domNode, {
				opacity:0,
				display:""
			});

			this._set("open", true);
			this._onShow(); // lazy load trigger

			this._size();
			this._position();

			// fade-in Animation object, setup below
			var fadeIn;

			this._fadeInDeferred = new dojo.Deferred(dojo.hitch(this, function(){
				fadeIn.stop();
				delete this._fadeInDeferred;
			}));

			fadeIn = dojo.fadeIn({
				node: this.domNode,
				duration: this.duration,
				beforeBegin: dojo.hitch(this, function(){
					dijit._DialogLevelManager.show(this, this.underlayAttrs);
				}),
				onEnd: dojo.hitch(this, function(){
					if(this.autofocus && dijit._DialogLevelManager.isTop(this)){
						// find focusable items each time dialog is shown since if dialog contains a widget the
						// first focusable items can change
						this._getFocusItems(this.domNode);
						dijit.focus(this._firstFocusItem);
					}
					this._fadeInDeferred.callback(true);
					delete this._fadeInDeferred;
				})
			}).play();
			
			return this._fadeInDeferred;
		},

		hide: function(){
			// summary:
			//		Hide the dialog
			// returns: dojo.Deferred
			//		Deferred object that resolves when the hide animation is complete

			// if we haven't been initialized yet then we aren't showing and we can just return
			if(!this._alreadyInitialized){
				return;
			}
			if(this._fadeInDeferred){
				this._fadeInDeferred.cancel();
			}

			// fade-in Animation object, setup below
			var fadeOut;

			this._fadeOutDeferred = new dojo.Deferred(dojo.hitch(this, function(){
				fadeOut.stop();
				delete this._fadeOutDeferred;
			}));

			fadeOut = dojo.fadeOut({
				node: this.domNode,
				duration: this.duration,
				onEnd: dojo.hitch(this, function(){
					this.domNode.style.display = "none";
					dijit._DialogLevelManager.hide(this);
					this.onHide();
					this._fadeOutDeferred.callback(true);
					delete this._fadeOutDeferred;
				})
			 }).play();

			if(this._scrollConnected){
				this._scrollConnected = false;
			}
			dojo.forEach(this._modalconnects, dojo.disconnect);
			this._modalconnects = [];

			if(this._relativePosition){
				delete this._relativePosition;
			}
			this._set("open", false);

			return this._fadeOutDeferred;
		},

		layout: function(){
			// summary:
			//		Position the Dialog and the underlay
			// tags:
			//		private
			if(this.domNode.style.display != "none"){
				if(dijit._underlay){	// avoid race condition during show()
					dijit._underlay.layout();
				}
				this._position();
			}
		},

		destroy: function(){
			if(this._fadeInDeferred){
				this._fadeInDeferred.cancel();
			}
			if(this._fadeOutDeferred){
				this._fadeOutDeferred.cancel();
			}
			if(this._moveable){
				this._moveable.destroy();
			}
			dojo.forEach(this._modalconnects, dojo.disconnect);

			dijit._DialogLevelManager.hide(this);

			this.inherited(arguments);
		}
	}
);

dojo.declare(
	"dijit.Dialog",
	[dijit.layout.ContentPane, dijit._DialogBase],
	{}
);

dijit._DialogLevelManager = {
	// summary:
	//		Controls the various active "levels" on the page, starting with the
	//		stuff initially visible on the page (at z-index 0), and then having an entry for
	//		each Dialog shown.

	show: function(/*dijit._Widget*/ dialog, /*Object*/ underlayAttrs){
		// summary:
		//		Call right before fade-in animation for new dialog.
		//		Saves current focus, displays/adjusts underlay for new dialog,
		//		and sets the z-index of the dialog itself.
		//
		//		New dialog will be displayed on top of all currently displayed dialogs.
		//
		//		Caller is responsible for setting focus in new dialog after the fade-in
		//		animation completes.

		var ds = dijit._dialogStack;

		// Save current focus
		ds[ds.length-1].focus = dijit.getFocus(dialog);

		// Display the underlay, or if already displayed then adjust for this new dialog
		var underlay = dijit._underlay;
		if(!underlay || underlay._destroyed){
			underlay = dijit._underlay = new dijit.DialogUnderlay(underlayAttrs);
		}else{
			underlay.set(dialog.underlayAttrs);
		}

		// Set z-index a bit above previous dialog
		var zIndex = ds[ds.length-1].dialog ? ds[ds.length-1].zIndex + 2 : 950;
		if(ds.length == 1){	// first dialog
			underlay.show();
		}
		dojo.style(dijit._underlay.domNode, 'zIndex', zIndex - 1);

		// Dialog
		dojo.style(dialog.domNode, 'zIndex', zIndex);

		ds.push({dialog: dialog, underlayAttrs: underlayAttrs, zIndex: zIndex});
	},

	hide: function(/*dijit._Widget*/ dialog){
		// summary:
		//		Called when the specified dialog is hidden/destroyed, after the fade-out
		//		animation ends, in order to reset page focus, fix the underlay, etc.
		//		If the specified dialog isn't open then does nothing.
		//
		//		Caller is responsible for either setting display:none on the dialog domNode,
		//		or calling dijit.popup.hide(), or removing it from the page DOM.

		var ds = dijit._dialogStack;

		if(ds[ds.length-1].dialog == dialog){
			// Removing the top (or only) dialog in the stack, return focus
			// to previous dialog

			ds.pop();

			var pd = ds[ds.length-1];	// the new active dialog (or the base page itself)

			// Adjust underlay
			if(ds.length == 1){
				// Returning to original page.
				// Hide the underlay, unless the underlay widget has already been destroyed
				// because we are being called during page unload (when all widgets are destroyed)
				if(!dijit._underlay._destroyed){
					dijit._underlay.hide();
				}
			}else{
				// Popping back to previous dialog, adjust underlay
				dojo.style(dijit._underlay.domNode, 'zIndex', pd.zIndex - 1);
				dijit._underlay.set(pd.underlayAttrs);
			}

			// Adjust focus
			if(dialog.refocus){
				// If we are returning control to a previous dialog but for some reason
				// that dialog didn't have a focused field, set focus to first focusable item.
				// This situation could happen if two dialogs appeared at nearly the same time,
				// since a dialog doesn't set it's focus until the fade-in is finished.
				var focus = pd.focus;
				if(!focus || (pd.dialog && !dojo.isDescendant(focus.node, pd.dialog.domNode))){
					pd.dialog._getFocusItems(pd.dialog.domNode);
					focus = pd.dialog._firstFocusItem;
				}
	
				try{
					dijit.focus(focus);
				}catch(e){
					/* focus() will fail if user opened the dialog by clicking a non-focusable element */
				}
			}
		}else{
			// Removing a dialog out of order (#9944, #10705).
			// Don't need to mess with underlay or z-index or anything.
			var idx = dojo.indexOf(dojo.map(ds, function(elem){return elem.dialog}), dialog);
			if(idx != -1){
				ds.splice(idx, 1);
			}
		}
	},

	isTop: function(/*dijit._Widget*/ dialog){
		// summary:
		//		Returns true if specified Dialog is the top in the task
		var ds = dijit._dialogStack;
		return ds[ds.length-1].dialog == dialog;
	}
};

// Stack representing the various active "levels" on the page, starting with the
// stuff initially visible on the page (at z-index 0), and then having an entry for
// each Dialog shown.
// Each element in stack has form {
//		dialog: dialogWidget,
//		focus: returnFromGetFocus(),
//		underlayAttrs: attributes to set on underlay (when this widget is active)
// }
dijit._dialogStack = [
	{dialog: null, focus: null, underlayAttrs: null}	// entry for stuff at z-index: 0
];

}

if(!dojo._hasResource["com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog"] = true;
dojo.provide("com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog");






dojo.declare("com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog", [dijit._Widget,dijit._Templated ], {
	
	templateString:"<div>\n<div id=\"wpdErrorDialog\" dojoType=\"dijit.Dialog\" style='width:450px; height:300px' dojoAttachPoint='dialogWindow' title=\"${_dialogMessages.errorDialogTitle}\">\n\n<div class=\"gwt-DialogBox\" >\n<table cellspacing=\"0\" cellpadding=\"0\" class=\"\">\n\t<tbody>\n\t\t<tr class=\"dialogTop\">\n\t\t\t<td class=\"dialogTopLeft\">\n\t\t\t<div class=\"dialogTopLeftInner\"></div>\n\t\t\t</td>\n\t\t\t<td class=\"dialogTopCenter\">\n\t\t\t<div class=\"dialogTopCenterInner\">\n\t\t\t<div class=\"Caption\">${_dialogMessages.errorDialogTitle}</div>\n\t\t\t</div>\n\t\t\t</td>\n\t\t\t<td class=\"dialogTopRight\">\n\t\t\t<div title=\"Close\" class=\"closer\" style=\"top: 36px; left: 435px;\" dojoAttachEvent=\"onclick:close\"></div>\n\t\t\t<div class=\"dialogTopRightInner\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t\t<tr class=\"dialogMiddle\">\n\t\t\t<td class=\"dialogMiddleLeft\">\n\t\t\t<div class=\"dialogMiddleLeftInner\"></div>\n\t\t\t</td>\n\t\t\t<td class=\"dialogMiddleCenter\">\n\t\t\t<div class=\"dialogMiddleCenterInner dialogContent\">\n\t\t\t<div class=\"abstractPopup\">\n\t\t\t\n\t\t\t\n\t\t\t\n\t\t\t<div class=\"white_content_deploy\">\n\t\t\t<div tabindex=\"0\" class=\"dummyFocusPanel\"></div>\n\t\t\t<div\n\t\t\t\tstyle=\"overflow: auto; position: relative; width: 400px; height: 200px;\"\n\t\t\t\tclass=\"inner_content\">\n\t\t\t<div>\n\t\t\t<div style=\"width: 375px; height: auto;\">\n\t\t\t<div class=\"gwt-HTML\">${_dialogMessages.contentMessage}</div>\n\t\t\t<table cellspacing=\"0\" cellpadding=\"0\"\n\t\t\t\tclass=\"gwt-DisclosurePanel gwt-DisclosurePanel-closed\"\n\t\t\t\tstyle=\"width: 100%;\">\n\t\t\t\t<tbody>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td align=\"left\" style=\"vertical-align: top;\">\n\t\t\t\t\t\t<table>\n\t\t\t\t\t\t\t<tbody>\n\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t<td align=\"center\" style=\"width: 16px;\">\n\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t<td style=\"cursor: pointer\" dojoAttachEvent=\"onclick:showErrorDetails\">${_dialogMessages.moreDetails}</td>\n\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</tbody>\n\t\t\t\t\t\t</table>\n\t\t\t\t\t </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td align=\"left\" style=\"vertical-align: top;\">\n\t\t\t\t\t\t<div dojoAttachPoint=\"errorDetails\"\n\t\t\t\t\t\t style=\"padding: 10px; overflow: hidden; display: none; height:300px; border: thin solid lightgrey;\">\t\t\t\t\t\t\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t</div>\t\t\t\t\t\t\t\n<!--\t\t\t\t\t\t<div style=\"padding: 0px; overflow: hidden; height: auto; width: auto;\"><input type=\"text\" tabindex=\"0\" class=\"gwt-TextBox gwt-TextBox-readonly content\" readonly=\"\" style=\"width: 100%; height: 300px;\"></div>-->\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</tbody>\n\t\t\t</table>\n\t\t\t</div>\n\t\t\t</div>\n\t\t\t</div>\n\t\t\t<div class=\"abstractPopupButtonPanel\">\n\t\t\t<div class=\"libraryButton\">\n\t\t\t<table cellspacing=\"0\" cellpadding=\"0\"\n\t\t\t\tstyle=\"border-collapse: collapse;\">\n\t\t\t\t<colgroup>\n\t\t\t\t\t<col>\n\t\t\t\t</colgroup>\n\t\t\t\t<tbody>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonLeft\">&nbsp;</td>\n\t\t\t\t\t\t<td class=\"middle\">\n\t\t\t\t\t\t<div dojoAttachEvent=\"onclick:close\" class=\"buttonText\">${_dialogMessages.closeMessage}</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t\t<td class=\"buttonRight\">&nbsp;</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</tbody>\n\t\t\t</table>\n\t\t\t</div>\n\t\t\t</div>\n\t\t\t</div>\n\t\t\t</div>\n\t\t\t</div>\n\t\t\t</td>\n\t\t\t<td class=\"dialogMiddleRight\">\n\t\t\t<div class=\"dialogMiddleRightInner\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t\t<tr class=\"dialogBottom\">\n\t\t\t<td class=\"dialogBottomLeft\">\n\t\t\t<div class=\"dialogBottomLeftInner\"></div>\n\t\t\t</td>\n\t\t\t<td class=\"dialogBottomCenter\">\n\t\t\t<div class=\"dialogBottomCenterInner\"></div>\n\t\t\t</td>\n\t\t\t<td class=\"dialogBottomRight\">\n\t\t\t<div class=\"dialogBottomRightInner\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t</tbody>\n</table>\n</div>\n</div>\n</div>\n",
	widgetsInTemplate: true, 
	error : null, 
	_dialogMessages : null,
   	/**
   	 * @param 
   	 */
	constructor : function(){
		this._dialogMessages = {};
	},
	
	postMixInProperties: function() {
		//Find message in wle messages
		this._dialogMessages.errorDialogTitle = wle_gwt_i18n_CommonMessages.errorDialogTitle;
		if (!this._dialogMessages.errorDialogTitle){
			this._dialogMessages.errorDialogTitle = "IBM BPM Error";
		}
		this._dialogMessages.contentMessage = wle_gwt_i18n_RepositoryMessages.releaseErrorOccurredMessage;
		if (!this._dialogMessages.contentMessage){
			this._dialogMessages.contentMessage = "";
		}
		this._dialogMessages.moreDetails = wle_gwt_i18n_CommonMessages.moreDetails;
		if (!this._dialogMessages.moreDetails){
			this._dialogMessages.moreDetails = "More Details...";
		}
		this._dialogMessages.closeMessage= wle_gwt_i18n_CommonMessages.errorCloseAllMessages;
		if (!this._dialogMessages.closeMessage){
			this._dialogMessages.closeMessage = "Close All Error Messages";
		}
	},
    
	show: function(error) {
		//TODO 2: make the style better: sort of working, except it is not draggable
		//either leave with it. Or remove the wle header, use dojo.dialog header and make radius work
		
		this.error = error;
		this.dialogWindow.containerNode.className="";
		//this.dialogWindow.baseClass = "compareDialog";
		this.dialogWindow.baseClass = "";
		//this.dialogWindow.titleBar.className = "compareDialogTitleBar";
		this.dialogWindow.titleBar.style.visibility = "hidden";
		this.dialogWindow.show();
	},
	
	/*
	 * When user click the More details twister
	 */
	showErrorDetails : function(){
		//TODO3
		//1. for the javascript error, need to format them better. the server side one is fine
		//2. Why the message dose not show up?
		
		if (this.errorDetails.style.display == "none"){
			this.errorDetails.style.display = "block";	
			this.errorDetails.innerHTML = this.error;
		}
		else{
			this.errorDetails.style.display = "none";	
			this.errorDetails.innerHTML = "";
		}
	},
	
	close: function() {
		this.dialogWindow.hide();
	}

});

com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog.showError = function(message){
	//find or create	
	var dialog = dijit.byId("wpdErrorDialog");
	if(!dialog){
		dialog = new com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog();
	}
	dialog.show(message);
};


}

if(!dojo._hasResource["com.ibm.bpm.wpd.base.errorhandling.WpdLogger"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.base.errorhandling.WpdLogger"] = true;
dojo.provide("com.ibm.bpm.wpd.base.errorhandling.WpdLogger");


com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError = function(classOrFileName, functionOrLineNumber, message, level){
	var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/service/v1/UITrace?traceLevel=SEVERE";
	var contentObj = {};
	contentObj.className = classOrFileName;
	contentObj.methodName = functionOrLineNumber;
	contentObj.message = message;
	var content = dojo.toJson(contentObj);
	var loadFn = function(response){
		//do nothing
	};
	
	var headers = { "Content-Type": "application/json"};
	//(verb, requestUrl, loadFn, errorFn, headers, isSync, message, deferred, handleAsType, xMethodOverride, user, password) {		
		try{
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance()._performRequest("post", url, loadFn, null, headers, false, content, null, 'json');
		}
		 catch (err){
		}

	if(!!level && level.toUpperCase() == "SEVERE"){
		com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog.showError(message);
	}	
	console.error(message);
};

com.ibm.bpm.wpd.base.errorhandling.WpdLogger.traceMessage = function(classOrFileName, functionOrLineNumber, message, level){
	
	var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/service/v1/UITrace?traceLevel=INFO";
	var content = {};
	content.className = classOrFileName;
	content.methodName = functionOrLineNumber;
	content.message = message;
	var loadFn = function(response){
		//do nothing
	};
	var headers = { "Content-Type": "application/json"};
	//verb, url, loadFn, errorFn, headers, isSync, message,
	try{
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("post", url, loadFn, null, null, false, content);
	}
	catch (err){
	}

};

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel"] = true;
dojo.provide("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel");




/**
 * Model contains view states for currently openned views
 * 			AssetListView
 * 			Instances of BaseViewer for different document type
 * Also store a reference to the currently visible ViewState
 */
dojo.declare("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel", [com.ibm.bpm.wpd.core.model.MObject], { 
	
	//constants : todo use statics
	ACTIVE_VIEWSTATEMODEL: "_activeViewStateModel",
	OPEN_VIEWSTATEMODELS: "_openViewStateModels",
	STATE_PROCESS_CENTER: "ProcessCenter",
	STATE_PORTAL: "Portal",
	STATE_INSPECTOR : "Inspector",
			
	_currentUser: null,				// type: User
	_openViewStateModels: null, 	// type: [ViewStateModel] 
	_activeViewStateModel: null,	// type: ViewStateModel
	_processAppModel: null,         // type: ProcessAppModel
	_filteredProcessAppModel: null,   // type: ProcessAppModel unpdated model based on applied filter
	_cachedViewStateModels : null,
	projectName:null,
	projectId:null,	
	
	snapshotName:null,
	snapshotId: null,
	
	branchId: null,
	branchName: null,
	
	breadCrumbName: null,
	breadCrumbImage: null,
	remoteId: null,
	showAssetListView : true,
	
	btdPreference: null,
	
	//instanceId: null,
	
	state: null,  //state in which the component is used. type:String processCenter/Portal/Inspector
	
	constructor : function(state) {
		this._openViewStateModels = [];
		this._cachedViewStateModels = [];
		this.state = state;
	},
	
	getActiveViewStateModel : function(){
		return this.getAttribute("_activeViewStateModel");
	},

	setActiveViewStateModel : function(value){
		this.setAttribute("_activeViewStateModel", value);
	},
	
	addCachedViewStateModel: function(vsm){
		this._cachedViewStateModels.push(vsm);
	},
	
	getOpenViewStateModels : function(){
		return this.getAttribute("_openViewStateModels");
	},
	
	addOpenViewStateModel : function(value){
		this.getOpenViewStateModels().push(value);
		
		
		//Dispatch the notification here just for trying new ways.
		//later will change _openViewStateModels to use MCollection, the notification will be generated by MCollection. Then I will change 
		//all the array notation[] to Mcollection.get for  accessing element
		
		
		//The notification is not needed anymore for a webViewer
		var index = this.getOpenViewStateModels().length - 1;
		var n = new com.ibm.bpm.wpd.core.control.notification.Notification(2, this, "_openViewStateModels", null, value, index); 
		dojo.publish(this.declaredClass + "::" + "_openViewStateModels", [n]);
	},
	
	findViewStateModelForModelType: function (type){
		var i;
		var esm;
		for (i=0; i<this._openViewStateModels.length; i++ ){
			esm = this._openViewStateModels[i];
			if (esm.type == type){
				return esm;
			}
		}
		return null;
	},
	
	findOpenViewStateModelForDocId: function(documentId, branchOrSnapshotId){
		return this._findViewStateModelForDocId(this._openViewStateModels, documentId, branchOrSnapshotId);
	},
	
	findCachedViewStateModelForDocId: function(documentId, branchOrSnapshotId){
		return this._findViewStateModelForDocId(this._cachedViewStateModels, documentId, branchOrSnapshotId);
	},
	
	removeCachedViewStateModel : function(vsm){
		var current, i;
		for (i=0; i<this._cachedViewStateModels.length; i++ ){
			current = this._cachedViewStateModels[i];
			if (current == vsm){
				this._cachedViewStateModels.splice(i, 1);
				return;
			}
		}
	},
	
	_findViewStateModelForDocId : function (list, documentId, branchOrSnapshotId){
		var i;
		var esm;
		for (i=0; i<list.length; i++ ){
			esm = list[i];
			if (!!esm.documentId && esm.documentId == documentId
					&& (!esm.branchOrSnapshotId || esm.branchOrSnapshotId == branchOrSnapshotId)){
				return esm;
			}
		}
		return null;
	},
	
	
	
	removeViewStateModelForDocId : function (documentId, branchOrSnapshotId){
		var i;
		var esm;
		for (i=0; i<this._openViewStateModels.length; i++ ){
			esm = this._openViewStateModels[i];
			if (!!esm.documentId && esm.documentId == documentId && esm.branchOrSnapshotId == branchOrSnapshotId){
			
				break;
			}
		}
		if (i >=0 && i<this._openViewStateModels.length){
			var value = this._openViewStateModels[i];
			//this._openViewStateModels.splice(i, 1);
			this._removeViewStateModel(value, i);
			//The notification is not needed anymore
			//var n = new com.ibm.bpm.wpd.core.control.notification.Notification(3, this, "_openViewStateModels", value, null, i); 
			//com.ibm.bpm.wpd.core.control.notification.NotificationManager.getInstance().registerNotification(n);
		}
	},
	
	_removeViewStateModel:function(vsm, index){
		this._openViewStateModels.splice(index, 1);
		var n = new com.ibm.bpm.wpd.core.control.notification.Notification(3, this, "_openViewStateModels", vsm, null, index);
		dojo.publish(this.declaredClass + "::" + "_openViewStateModels", [n]);
	},
	
	removeTrailingViewStateModel:function(activeVsm){
		var openViewStates = this.getOpenViewStateModels();
		var i;
		var vsm;
		for (i=openViewStates.length - 1; i>=0; i-- ){
			
			vsm = openViewStates[i];
			if(!activeVsm 
					|| vsm.documentId != activeVsm.documentId ||  vsm.branchOrSnapshotId != activeVsm.branchOrSnapshotId){
				//openViewStates.splice(i, 1);
				//var n = new com.ibm.bpm.wpd.core.control.notification.Notification(3, this, "_openViewStateModels", vsm, null, i); 
				//com.ibm.bpm.wpd.core.control.notification.NotificationManager.getInstance().registerNotification(n);
				this._removeViewStateModel(vsm, i);
			}
			else{
				break;
			}
		}
	},
	
	setProcessAppModel : function (assetModel, context) {
		this.setAttribute("_processAppModel", assetModel, context);
	},
	
	getProcessAppModel : function(){
		return this._processAppModel;
	},
	
	setFilteredProcessAppModel : function (assetModel, context) {
		this.setAttribute("_filteredProcessAppModel", assetModel, context);
	},
	
	getFilteredProcessAppModel : function(){
		return this._filteredProcessAppModel;
	},
	
	setBTDPreference : function (btdValue) {
		this.btdPreference = btdValue;
	},
	
	getBTDPreference : function(){
		return this.btdPreference;
	},
	
	setProjectInfor: function (app){
		if (!!app){
			this.projectId = app.projectId;
			this.projectName  = app.projectName;
			this.snapshotId = app.snapshotId;		
			this.snapshotName = app.snapshotName;
			this.branchId = app.branchId;
			this.branchName = app.branchName;
			if (!!app.breadCrumbName)
				this.breadCrumbName = app.breadCrumbName;
			if (!!app.breadCrumbImage)
				this.breadCrumbImage = app.breadCrumbImage;
			if (!!app.remoteId)
				this.remoteId = app.remoteId;
			if (app.showAssetListView == null)
				this.showAssetListView = true;
			else
				this.showAssetListView = app.showAssetListView;
		}
	}
	
});


com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance = function() {
	// summary: 
	//	retrieve the singleton ShellStateModel instance 
	//  It is initialized in bootstrap.js during start up 
	return dojo.global.BPM.WPD_ShellStateModel;
};

}

if(!dojo._hasResource["dojox.layout.ExpandoPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.layout.ExpandoPane"] = true;
dojo.provide("dojox.layout.ExpandoPane");
dojo.experimental("dojox.layout.ExpandoPane"); // just to show it can be done?





dojo.declare("dojox.layout.ExpandoPane",
	[dijit.layout.ContentPane, dijit._Templated, dijit._Contained, dijit._Container],
	{
	// summary: An experimental collapsing-pane for dijit.layout.BorderContainer
	//
	// description:
	//		Works just like a ContentPane inside of a borderContainer. Will expand/collapse on
	//		command, and supports having Layout Children as direct descendants
	//

	//maxHeight: "",
	//maxWidth: "",
	//splitter: false,
	attributeMap: dojo.delegate(dijit.layout.ContentPane.prototype.attributeMap, {
	        title: { node: "titleNode", type: "innerHTML" }
	}),
	
	templateString: dojo.cache("dojox.layout", "resources/ExpandoPane.html", "<div class=\"dojoxExpandoPane\">\n\t<div dojoAttachPoint=\"titleWrapper\" class=\"dojoxExpandoTitle\">\n\t\t<div class=\"dojoxExpandoIcon\" dojoAttachPoint=\"iconNode\" dojoAttachEvent=\"onclick:toggle\"><span class=\"a11yNode\">X</span></div>\t\t\t\n\t\t<span class=\"dojoxExpandoTitleNode\" dojoAttachPoint=\"titleNode\">${title}</span>\n\t</div>\n\t<div class=\"dojoxExpandoWrapper\" dojoAttachPoint=\"cwrapper\" dojoAttachEvent=\"ondblclick:_trap\">\n\t\t<div class=\"dojoxExpandoContent\" dojoAttachPoint=\"containerNode\"></div>\n\t</div>\n</div>\n"),

	// easeOut: String|Function
	//		easing function used to hide pane
	easeOut: "dojo._DefaultEasing",
	
	// easeIn: String|Function
	//		easing function use to show pane
	easeIn: "dojo._DefaultEasing",
	
	// duration: Integer
	//		duration to run show/hide animations
	duration: 420,

	// startExpanded: Boolean
	//		Does this widget start in an open (true) or closed (false) state
	startExpanded: true,

	// previewOpacity: Float
	//		A value from 0 .. 1 indicating the opacity to use on the container
	//		when only showing a preview
	previewOpacity: 0.75,
	
	// previewOnDblClick: Boolean
	//		If true, will override the default behavior of a double-click calling a full toggle.
	//		If false, a double-click will cause the preview to popup
	previewOnDblClick: false,

	baseClass: "dijitExpandoPane",

	postCreate: function(){
		this.inherited(arguments);
		this._animConnects = [];

		this._isHorizontal = true;
		
		if(dojo.isString(this.easeOut)){
			this.easeOut = dojo.getObject(this.easeOut);
		}
		if(dojo.isString(this.easeIn)){
			this.easeIn = dojo.getObject(this.easeIn);
		}
	
		var thisClass = "", rtl = !this.isLeftToRight();
		if(this.region){
			switch(this.region){
				case "trailing" :
				case "right" :
					thisClass = rtl ? "Left" : "Right";
					break;
				case "leading" :
				case "left" :
					thisClass = rtl ? "Right" : "Left";
					break;
				case "top" :
					thisClass = "Top";
					break;
				case "bottom" :
					thisClass = "Bottom";
					break;
			}
			dojo.addClass(this.domNode, "dojoxExpando" + thisClass);
			dojo.addClass(this.iconNode, "dojoxExpandoIcon" + thisClass);
			this._isHorizontal = /top|bottom/.test(this.region);
		}
		dojo.style(this.domNode, {
			overflow: "hidden",
			padding:0
		});
		
		this.connect(this.domNode, "ondblclick", this.previewOnDblClick ? "preview" : "toggle");
		
		if(this.previewOnDblClick){
			this.connect(this.getParent(), "_layoutChildren", dojo.hitch(this, function(){
				this._isonlypreview = false;
			}));
		}
		
	},
	
	_startupSizes: function(){
		
		this._container = this.getParent();
		this._closedSize = this._titleHeight = dojo.marginBox(this.titleWrapper).h;
		
		if(this.splitter){
			// find our splitter and tie into it's drag logic
			var myid = this.id;
			dijit.registry.filter(function(w){
				return w && w.child && w.child.id == myid;
			}).forEach(dojo.hitch(this,function(w){
				this.connect(w,"_stopDrag","_afterResize");
			}));
		}
		
		this._currentSize = dojo.contentBox(this.domNode);	// TODO: can compute this from passed in value to resize(), see _LayoutWidget for example
		this._showSize = this._currentSize[(this._isHorizontal ? "h" : "w")];
		this._setupAnims();

		if(this.startExpanded){
			this._showing = true;
		}else{
			this._showing = false;
			this._hideWrapper();
			this._hideAnim.gotoPercent(99,true);
		}
		
		this._hasSizes = true;
	},
	
	_afterResize: function(e){
		var tmp = this._currentSize;						// the old size
		this._currentSize = dojo.marginBox(this.domNode);	// the new size
		var n = this._currentSize[(this._isHorizontal ? "h" : "w")]
		if(n > this._titleHeight){
			if(!this._showing){
				this._showing = !this._showing;
				this._showEnd();
			}
			this._showSize = n;
			this._setupAnims();
		}else{
			this._showSize = tmp[(this._isHorizontal ? "h" : "w")];
			this._showing = false;
			this._hideWrapper();
			this._hideAnim.gotoPercent(89,true);
		}
		
	},
	
	_setupAnims: function(){
		// summary: Create the show and hide animations
		dojo.forEach(this._animConnects, dojo.disconnect);
		
		var _common = {
				node:this.domNode,
				duration:this.duration
			},
			isHorizontal = this._isHorizontal,
			showProps = {},
			hideProps = {},
			dimension = isHorizontal ? "height" : "width"
		;

		showProps[dimension] = {
			end: this._showSize
		};
		hideProps[dimension] = {
			end: this._closedSize
		};
		
		this._showAnim = dojo.animateProperty(dojo.mixin(_common,{
			easing:this.easeIn,
			properties: showProps
		}));
		this._hideAnim = dojo.animateProperty(dojo.mixin(_common,{
			easing:this.easeOut,
			properties: hideProps
		}));

		this._animConnects = [
			dojo.connect(this._showAnim, "onEnd", this, "_showEnd"),
			dojo.connect(this._hideAnim, "onEnd", this, "_hideEnd")
		];
	},
	
	preview: function(){
		// summary: Expand this pane in preview mode (does not affect surrounding layout)

		if(!this._showing){
			this._isonlypreview = !this._isonlypreview;
		}
		this.toggle();
	},

	toggle: function(){
		// summary: Toggle this pane's visibility
		if(this._showing){
			this._hideWrapper();
			this._showAnim && this._showAnim.stop();
			this._hideAnim.play();
		}else{
			this._hideAnim && this._hideAnim.stop();
			this._showAnim.play();
		}
		this._showing = !this._showing;
	},
	
	_hideWrapper: function(){
		// summary: Set the Expando state to "closed"
		dojo.addClass(this.domNode, "dojoxExpandoClosed");
		
		dojo.style(this.cwrapper,{
			visibility: "hidden",
			opacity: "0",
			overflow: "hidden"
		});
	},
	
	_showEnd: function(){
		// summary: Common animation onEnd code - "unclose"
		dojo.style(this.cwrapper, {
			opacity: 0,
			visibility:"visible"
		});
		dojo.anim(this.cwrapper, {
			opacity: this._isonlypreview ? this.previewOpacity : 1
		}, 227);
		dojo.removeClass(this.domNode, "dojoxExpandoClosed");
		if(!this._isonlypreview){
			setTimeout(dojo.hitch(this._container, "layout"), 15);
		}else{
			this._previewShowing = true;
			this.resize();
		}
	},
	
	_hideEnd: function(){
		// summary: Callback for the hide animation - "close"

		// every time we hide, reset the "only preview" state
		if(!this._isonlypreview){
			setTimeout(dojo.hitch(this._container, "layout"), 25);
		}else{
			this._previewShowing = false;
		}
		this._isonlypreview = false;
		
	},
	
	resize: function(/* Object? */newSize){
		// summary:
		//		we aren't a layout widget, but need to act like one:
		// newSize: Object
		//		The size object to resize to

		if(!this._hasSizes){ this._startupSizes(newSize); }
		
		// compute size of container (ie, size left over after title bar)
		var currentSize = dojo.marginBox(this.domNode);
		this._contentBox = {
			w: newSize && "w" in newSize ? newSize.w : currentSize.w,
			h: (newSize && "h" in newSize ? newSize.h : currentSize.h) - this._titleHeight
		};
		dojo.style(this.containerNode, "height", this._contentBox.h + "px");

		if(newSize){
			dojo.marginBox(this.domNode, newSize);
		}

		this._layoutChildren();
	},
	
	_trap: function(e){
		// summary: Trap stray events
		dojo.stopEvent(e);
	}

});

}

if(!dojo._hasResource["dojo.data.util.filter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.data.util.filter"] = true;
dojo.provide("dojo.data.util.filter");

dojo.getObject("data.util.filter", true, dojo);

dojo.data.util.filter.patternToRegExp = function(/*String*/pattern, /*boolean?*/ ignoreCase){
	//	summary:
	//		Helper function to convert a simple pattern to a regular expression for matching.
	//	description:
	//		Returns a regular expression object that conforms to the defined conversion rules.
	//		For example:
	//			ca*   -> /^ca.*$/
	//			*ca*  -> /^.*ca.*$/
	//			*c\*a*  -> /^.*c\*a.*$/
	//			*c\*a?*  -> /^.*c\*a..*$/
	//			and so on.
	//
	//	pattern: string
	//		A simple matching pattern to convert that follows basic rules:
	//			* Means match anything, so ca* means match anything starting with ca
	//			? Means match single character.  So, b?b will match to bob and bab, and so on.
	//      	\ is an escape character.  So for example, \* means do not treat * as a match, but literal character *.
	//				To use a \ as a character in the string, it must be escaped.  So in the pattern it should be
	//				represented by \\ to be treated as an ordinary \ character instead of an escape.
	//
	//	ignoreCase:
	//		An optional flag to indicate if the pattern matching should be treated as case-sensitive or not when comparing
	//		By default, it is assumed case sensitive.

	var rxp = "^";
	var c = null;
	for(var i = 0; i < pattern.length; i++){
		c = pattern.charAt(i);
		switch(c){
			case '\\':
				rxp += c;
				i++;
				rxp += pattern.charAt(i);
				break;
			case '*':
				rxp += ".*"; break;
			case '?':
				rxp += "."; break;
			case '$':
			case '^':
			case '/':
			case '+':
			case '.':
			case '|':
			case '(':
			case ')':
			case '{':
			case '}':
			case '[':
			case ']':
				rxp += "\\"; //fallthrough
			default:
				rxp += c;
		}
	}
	rxp += "$";
	if(ignoreCase){
		return new RegExp(rxp,"mi"); //RegExp
	}else{
		return new RegExp(rxp,"m"); //RegExp
	}
	
};

}

if(!dojo._hasResource["dojo.data.util.sorter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.data.util.sorter"] = true;
dojo.provide("dojo.data.util.sorter");

dojo.getObject("data.util.sorter", true, dojo);

dojo.data.util.sorter.basicComparator = function(	/*anything*/ a,
													/*anything*/ b){
	//	summary:
	//		Basic comparision function that compares if an item is greater or less than another item
	//	description:
	//		returns 1 if a > b, -1 if a < b, 0 if equal.
	//		'null' values (null, undefined) are treated as larger values so that they're pushed to the end of the list.
	//		And compared to each other, null is equivalent to undefined.
	
	//null is a problematic compare, so if null, we set to undefined.
	//Makes the check logic simple, compact, and consistent
	//And (null == undefined) === true, so the check later against null
	//works for undefined and is less bytes.
	var r = -1;
	if(a === null){
		a = undefined;
	}
	if(b === null){
		b = undefined;
	}
	if(a == b){
		r = 0;
	}else if(a > b || a == null){
		r = 1;
	}
	return r; //int {-1,0,1}
};

dojo.data.util.sorter.createSortFunction = function(	/* attributes array */sortSpec,
														/*dojo.data.core.Read*/ store){
	//	summary:
	//		Helper function to generate the sorting function based off the list of sort attributes.
	//	description:
	//		The sort function creation will look for a property on the store called 'comparatorMap'.  If it exists
	//		it will look in the mapping for comparisons function for the attributes.  If one is found, it will
	//		use it instead of the basic comparator, which is typically used for strings, ints, booleans, and dates.
	//		Returns the sorting function for this particular list of attributes and sorting directions.
	//
	//	sortSpec: array
	//		A JS object that array that defines out what attribute names to sort on and whether it should be descenting or asending.
	//		The objects should be formatted as follows:
	//		{
	//			attribute: "attributeName-string" || attribute,
	//			descending: true|false;   // Default is false.
	//		}
	//	store: object
	//		The datastore object to look up item values from.
	//
	var sortFunctions=[];

	function createSortFunction(attr, dir, comp, s){
		//Passing in comp and s (comparator and store), makes this
		//function much faster.
		return function(itemA, itemB){
			var a = s.getValue(itemA, attr);
			var b = s.getValue(itemB, attr);
			return dir * comp(a,b); //int
		};
	}
	var sortAttribute;
	var map = store.comparatorMap;
	var bc = dojo.data.util.sorter.basicComparator;
	for(var i = 0; i < sortSpec.length; i++){
		sortAttribute = sortSpec[i];
		var attr = sortAttribute.attribute;
		if(attr){
			var dir = (sortAttribute.descending) ? -1 : 1;
			var comp = bc;
			if(map){
				if(typeof attr !== "string" && ("toString" in attr)){
					 attr = attr.toString();
				}
				comp = map[attr] || bc;
			}
			sortFunctions.push(createSortFunction(attr,
				dir, comp, store));
		}
	}
	return function(rowA, rowB){
		var i=0;
		while(i < sortFunctions.length){
			var ret = sortFunctions[i++](rowA, rowB);
			if(ret !== 0){
				return ret;//int
			}
		}
		return 0; //int
	}; // Function
};

}

if(!dojo._hasResource["dojo.data.util.simpleFetch"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.data.util.simpleFetch"] = true;
dojo.provide("dojo.data.util.simpleFetch");


dojo.getObject("data.util.simpleFetch", true, dojo);

dojo.data.util.simpleFetch.fetch = function(/* Object? */ request){
	//	summary:
	//		The simpleFetch mixin is designed to serve as a set of function(s) that can
	//		be mixed into other datastore implementations to accelerate their development.
	//		The simpleFetch mixin should work well for any datastore that can respond to a _fetchItems()
	//		call by returning an array of all the found items that matched the query.  The simpleFetch mixin
	//		is not designed to work for datastores that respond to a fetch() call by incrementally
	//		loading items, or sequentially loading partial batches of the result
	//		set.  For datastores that mixin simpleFetch, simpleFetch
	//		implements a fetch method that automatically handles eight of the fetch()
	//		arguments -- onBegin, onItem, onComplete, onError, start, count, sort and scope
	//		The class mixing in simpleFetch should not implement fetch(),
	//		but should instead implement a _fetchItems() method.  The _fetchItems()
	//		method takes three arguments, the keywordArgs object that was passed
	//		to fetch(), a callback function to be called when the result array is
	//		available, and an error callback to be called if something goes wrong.
	//		The _fetchItems() method should ignore any keywordArgs parameters for
	//		start, count, onBegin, onItem, onComplete, onError, sort, and scope.
	//		The _fetchItems() method needs to correctly handle any other keywordArgs
	//		parameters, including the query parameter and any optional parameters
	//		(such as includeChildren).  The _fetchItems() method should create an array of
	//		result items and pass it to the fetchHandler along with the original request object
	//		-- or, the _fetchItems() method may, if it wants to, create an new request object
	//		with other specifics about the request that are specific to the datastore and pass
	//		that as the request object to the handler.
	//
	//		For more information on this specific function, see dojo.data.api.Read.fetch()
	request = request || {};
	if(!request.store){
		request.store = this;
	}
	var self = this;

	var _errorHandler = function(errorData, requestObject){
		if(requestObject.onError){
			var scope = requestObject.scope || dojo.global;
			requestObject.onError.call(scope, errorData, requestObject);
		}
	};

	var _fetchHandler = function(items, requestObject){
		var oldAbortFunction = requestObject.abort || null;
		var aborted = false;

		var startIndex = requestObject.start?requestObject.start:0;
		var endIndex = (requestObject.count && (requestObject.count !== Infinity))?(startIndex + requestObject.count):items.length;

		requestObject.abort = function(){
			aborted = true;
			if(oldAbortFunction){
				oldAbortFunction.call(requestObject);
			}
		};

		var scope = requestObject.scope || dojo.global;
		if(!requestObject.store){
			requestObject.store = self;
		}
		if(requestObject.onBegin){
			requestObject.onBegin.call(scope, items.length, requestObject);
		}
		if(requestObject.sort){
			items.sort(dojo.data.util.sorter.createSortFunction(requestObject.sort, self));
		}
		if(requestObject.onItem){
			for(var i = startIndex; (i < items.length) && (i < endIndex); ++i){
				var item = items[i];
				if(!aborted){
					requestObject.onItem.call(scope, item, requestObject);
				}
			}
		}
		if(requestObject.onComplete && !aborted){
			var subset = null;
			if(!requestObject.onItem){
				subset = items.slice(startIndex, endIndex);
			}
			requestObject.onComplete.call(scope, subset, requestObject);
		}
	};
	this._fetchItems(request, _fetchHandler, _errorHandler);
	return request;	// Object
};

}

if(!dojo._hasResource["dojo.data.ItemFileReadStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.data.ItemFileReadStore"] = true;
dojo.provide("dojo.data.ItemFileReadStore");





dojo.declare("dojo.data.ItemFileReadStore", null,{
	//	summary:
	//		The ItemFileReadStore implements the dojo.data.api.Read API and reads
	//		data from JSON files that have contents in this format --
	//		{ items: [
	//			{ name:'Kermit', color:'green', age:12, friends:['Gonzo', {_reference:{name:'Fozzie Bear'}}]},
	//			{ name:'Fozzie Bear', wears:['hat', 'tie']},
	//			{ name:'Miss Piggy', pets:'Foo-Foo'}
	//		]}
	//		Note that it can also contain an 'identifer' property that specified which attribute on the items
	//		in the array of items that acts as the unique identifier for that item.
	//
	constructor: function(/* Object */ keywordParameters){
		//	summary: constructor
		//	keywordParameters: {url: String}
		//	keywordParameters: {data: jsonObject}
		//	keywordParameters: {typeMap: object)
		//		The structure of the typeMap object is as follows:
		//		{
		//			type0: function || object,
		//			type1: function || object,
		//			...
		//			typeN: function || object
		//		}
		//		Where if it is a function, it is assumed to be an object constructor that takes the
		//		value of _value as the initialization parameters.  If it is an object, then it is assumed
		//		to be an object of general form:
		//		{
		//			type: function, //constructor.
		//			deserialize:	function(value) //The function that parses the value and constructs the object defined by type appropriately.
		//		}
	
		this._arrayOfAllItems = [];
		this._arrayOfTopLevelItems = [];
		this._loadFinished = false;
		this._jsonFileUrl = keywordParameters.url;
		this._ccUrl = keywordParameters.url;
		this.url = keywordParameters.url;
		this._jsonData = keywordParameters.data;
		this.data = null;
		this._datatypeMap = keywordParameters.typeMap || {};
		if(!this._datatypeMap['Date']){
			//If no default mapping for dates, then set this as default.
			//We use the dojo.date.stamp here because the ISO format is the 'dojo way'
			//of generically representing dates.
			this._datatypeMap['Date'] = {
											type: Date,
											deserialize: function(value){
												return dojo.date.stamp.fromISOString(value);
											}
										};
		}
		this._features = {'dojo.data.api.Read':true, 'dojo.data.api.Identity':true};
		this._itemsByIdentity = null;
		this._storeRefPropName = "_S"; // Default name for the store reference to attach to every item.
		this._itemNumPropName = "_0"; // Default Item Id for isItem to attach to every item.
		this._rootItemPropName = "_RI"; // Default Item Id for isItem to attach to every item.
		this._reverseRefMap = "_RRM"; // Default attribute for constructing a reverse reference map for use with reference integrity
		this._loadInProgress = false; //Got to track the initial load to prevent duelling loads of the dataset.
		this._queuedFetches = [];
		if(keywordParameters.urlPreventCache !== undefined){
			this.urlPreventCache = keywordParameters.urlPreventCache?true:false;
		}
		if(keywordParameters.hierarchical !== undefined){
			this.hierarchical = keywordParameters.hierarchical?true:false;
		}
		if(keywordParameters.clearOnClose){
			this.clearOnClose = true;
		}
		if("failOk" in keywordParameters){
			this.failOk = keywordParameters.failOk?true:false;
		}
	},
	
	url: "",	// use "" rather than undefined for the benefit of the parser (#3539)

	//Internal var, crossCheckUrl.  Used so that setting either url or _jsonFileUrl, can still trigger a reload
	//when clearOnClose and close is used.
	_ccUrl: "",

	data: null,	// define this so that the parser can populate it

	typeMap: null, //Define so parser can populate.
	
	//Parameter to allow users to specify if a close call should force a reload or not.
	//By default, it retains the old behavior of not clearing if close is called.  But
	//if set true, the store will be reset to default state.  Note that by doing this,
	//all item handles will become invalid and a new fetch must be issued.
	clearOnClose: false,

	//Parameter to allow specifying if preventCache should be passed to the xhrGet call or not when loading data from a url.
	//Note this does not mean the store calls the server on each fetch, only that the data load has preventCache set as an option.
	//Added for tracker: #6072
	urlPreventCache: false,
	
	//Parameter for specifying that it is OK for the xhrGet call to fail silently.
	failOk: false,

	//Parameter to indicate to process data from the url as hierarchical
	//(data items can contain other data items in js form).  Default is true
	//for backwards compatibility.  False means only root items are processed
	//as items, all child objects outside of type-mapped objects and those in
	//specific reference format, are left straight JS data objects.
	hierarchical: true,

	_assertIsItem: function(/* item */ item){
		//	summary:
		//		This function tests whether the item passed in is indeed an item in the store.
		//	item:
		//		The item to test for being contained by the store.
		if(!this.isItem(item)){
			throw new Error("dojo.data.ItemFileReadStore: Invalid item argument.");
		}
	},

	_assertIsAttribute: function(/* attribute-name-string */ attribute){
		//	summary:
		//		This function tests whether the item passed in is indeed a valid 'attribute' like type for the store.
		//	attribute:
		//		The attribute to test for being contained by the store.
		if(typeof attribute !== "string"){
			throw new Error("dojo.data.ItemFileReadStore: Invalid attribute argument.");
		}
	},

	getValue: function(	/* item */ item,
						/* attribute-name-string */ attribute,
						/* value? */ defaultValue){
		//	summary:
		//		See dojo.data.api.Read.getValue()
		var values = this.getValues(item, attribute);
		return (values.length > 0)?values[0]:defaultValue; // mixed
	},

	getValues: function(/* item */ item,
						/* attribute-name-string */ attribute){
		//	summary:
		//		See dojo.data.api.Read.getValues()

		this._assertIsItem(item);
		this._assertIsAttribute(attribute);
		// Clone it before returning.  refs: #10474
		return (item[attribute] || []).slice(0); // Array
	},

	getAttributes: function(/* item */ item){
		//	summary:
		//		See dojo.data.api.Read.getAttributes()
		this._assertIsItem(item);
		var attributes = [];
		for(var key in item){
			// Save off only the real item attributes, not the special id marks for O(1) isItem.
			if((key !== this._storeRefPropName) && (key !== this._itemNumPropName) && (key !== this._rootItemPropName) && (key !== this._reverseRefMap)){
				attributes.push(key);
			}
		}
		return attributes; // Array
	},

	hasAttribute: function(	/* item */ item,
							/* attribute-name-string */ attribute){
		//	summary:
		//		See dojo.data.api.Read.hasAttribute()
		this._assertIsItem(item);
		this._assertIsAttribute(attribute);
		return (attribute in item);
	},

	containsValue: function(/* item */ item,
							/* attribute-name-string */ attribute,
							/* anything */ value){
		//	summary:
		//		See dojo.data.api.Read.containsValue()
		var regexp = undefined;
		if(typeof value === "string"){
			regexp = dojo.data.util.filter.patternToRegExp(value, false);
		}
		return this._containsValue(item, attribute, value, regexp); //boolean.
	},

	_containsValue: function(	/* item */ item,
								/* attribute-name-string */ attribute,
								/* anything */ value,
								/* RegExp?*/ regexp){
		//	summary:
		//		Internal function for looking at the values contained by the item.
		//	description:
		//		Internal function for looking at the values contained by the item.  This
		//		function allows for denoting if the comparison should be case sensitive for
		//		strings or not (for handling filtering cases where string case should not matter)
		//
		//	item:
		//		The data item to examine for attribute values.
		//	attribute:
		//		The attribute to inspect.
		//	value:
		//		The value to match.
		//	regexp:
		//		Optional regular expression generated off value if value was of string type to handle wildcarding.
		//		If present and attribute values are string, then it can be used for comparison instead of 'value'
		return dojo.some(this.getValues(item, attribute), function(possibleValue){
			if(possibleValue !== null && !dojo.isObject(possibleValue) && regexp){
				if(possibleValue.toString().match(regexp)){
					return true; // Boolean
				}
			}else if(value === possibleValue){
				return true; // Boolean
			}
		});
	},

	isItem: function(/* anything */ something){
		//	summary:
		//		See dojo.data.api.Read.isItem()
		if(something && something[this._storeRefPropName] === this){
			if(this._arrayOfAllItems[something[this._itemNumPropName]] === something){
				return true;
			}
		}
		return false; // Boolean
	},

	isItemLoaded: function(/* anything */ something){
		//	summary:
		//		See dojo.data.api.Read.isItemLoaded()
		return this.isItem(something); //boolean
	},

	loadItem: function(/* object */ keywordArgs){
		//	summary:
		//		See dojo.data.api.Read.loadItem()
		this._assertIsItem(keywordArgs.item);
	},

	getFeatures: function(){
		//	summary:
		//		See dojo.data.api.Read.getFeatures()
		return this._features; //Object
	},

	getLabel: function(/* item */ item){
		//	summary:
		//		See dojo.data.api.Read.getLabel()
		if(this._labelAttr && this.isItem(item)){
			return this.getValue(item,this._labelAttr); //String
		}
		return undefined; //undefined
	},

	getLabelAttributes: function(/* item */ item){
		//	summary:
		//		See dojo.data.api.Read.getLabelAttributes()
		if(this._labelAttr){
			return [this._labelAttr]; //array
		}
		return null; //null
	},

	_fetchItems: function(	/* Object */ keywordArgs,
							/* Function */ findCallback,
							/* Function */ errorCallback){
		//	summary:
		//		See dojo.data.util.simpleFetch.fetch()
		var self = this,
		    filter = function(requestArgs, arrayOfItems){
			var items = [],
			    i, key;
			if(requestArgs.query){
				var value,
				    ignoreCase = requestArgs.queryOptions ? requestArgs.queryOptions.ignoreCase : false;

				//See if there are any string values that can be regexp parsed first to avoid multiple regexp gens on the
				//same value for each item examined.  Much more efficient.
				var regexpList = {};
				for(key in requestArgs.query){
					value = requestArgs.query[key];
					if(typeof value === "string"){
						regexpList[key] = dojo.data.util.filter.patternToRegExp(value, ignoreCase);
					}else if(value instanceof RegExp){
						regexpList[key] = value;
					}
				}
				for(i = 0; i < arrayOfItems.length; ++i){
					var match = true;
					var candidateItem = arrayOfItems[i];
					if(candidateItem === null){
						match = false;
					}else{
						for(key in requestArgs.query){
							value = requestArgs.query[key];
							if(!self._containsValue(candidateItem, key, value, regexpList[key])){
								match = false;
							}
						}
					}
					if(match){
						items.push(candidateItem);
					}
				}
				findCallback(items, requestArgs);
			}else{
				// We want a copy to pass back in case the parent wishes to sort the array.
				// We shouldn't allow resort of the internal list, so that multiple callers
				// can get lists and sort without affecting each other.  We also need to
				// filter out any null values that have been left as a result of deleteItem()
				// calls in ItemFileWriteStore.
				for(i = 0; i < arrayOfItems.length; ++i){
					var item = arrayOfItems[i];
					if(item !== null){
						items.push(item);
					}
				}
				findCallback(items, requestArgs);
			}
		};

		if(this._loadFinished){
			filter(keywordArgs, this._getItemsArray(keywordArgs.queryOptions));
		}else{
			//Do a check on the JsonFileUrl and crosscheck it.
			//If it doesn't match the cross-check, it needs to be updated
			//This allows for either url or _jsonFileUrl to he changed to
			//reset the store load location.  Done this way for backwards
			//compatibility.  People use _jsonFileUrl (even though officially
			//private.
			if(this._jsonFileUrl !== this._ccUrl){
				dojo.deprecated("dojo.data.ItemFileReadStore: ",
					"To change the url, set the url property of the store," +
					" not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0");
				this._ccUrl = this._jsonFileUrl;
				this.url = this._jsonFileUrl;
			}else if(this.url !== this._ccUrl){
				this._jsonFileUrl = this.url;
				this._ccUrl = this.url;
			}

			//See if there was any forced reset of data.
			if(this.data != null){
				this._jsonData = this.data;
				this.data = null;
			}

			if(this._jsonFileUrl){
				//If fetches come in before the loading has finished, but while
				//a load is in progress, we have to defer the fetching to be
				//invoked in the callback.
				if(this._loadInProgress){
					this._queuedFetches.push({args: keywordArgs, filter: filter});
				}else{
					this._loadInProgress = true;
					var getArgs = {
							url: self._jsonFileUrl,
							handleAs: "json-comment-optional",
							preventCache: this.urlPreventCache,
							failOk: this.failOk
						};
					var getHandler = dojo.xhrGet(getArgs);
					getHandler.addCallback(function(data){
						try{
							self._getItemsFromLoadedData(data);
							self._loadFinished = true;
							self._loadInProgress = false;
							
							filter(keywordArgs, self._getItemsArray(keywordArgs.queryOptions));
							self._handleQueuedFetches();
						}catch(e){
							self._loadFinished = true;
							self._loadInProgress = false;
							errorCallback(e, keywordArgs);
						}
					});
					getHandler.addErrback(function(error){
						self._loadInProgress = false;
						errorCallback(error, keywordArgs);
					});

					//Wire up the cancel to abort of the request
					//This call cancel on the deferred if it hasn't been called
					//yet and then will chain to the simple abort of the
					//simpleFetch keywordArgs
					var oldAbort = null;
					if(keywordArgs.abort){
						oldAbort = keywordArgs.abort;
					}
					keywordArgs.abort = function(){
						var df = getHandler;
						if(df && df.fired === -1){
							df.cancel();
							df = null;
						}
						if(oldAbort){
							oldAbort.call(keywordArgs);
						}
					};
				}
			}else if(this._jsonData){
				try{
					this._loadFinished = true;
					this._getItemsFromLoadedData(this._jsonData);
					this._jsonData = null;
					filter(keywordArgs, this._getItemsArray(keywordArgs.queryOptions));
				}catch(e){
					errorCallback(e, keywordArgs);
				}
			}else{
				errorCallback(new Error("dojo.data.ItemFileReadStore: No JSON source data was provided as either URL or a nested Javascript object."), keywordArgs);
			}
		}
	},

	_handleQueuedFetches: function(){
		//	summary:
		//		Internal function to execute delayed request in the store.
		//Execute any deferred fetches now.
		if(this._queuedFetches.length > 0){
			for(var i = 0; i < this._queuedFetches.length; i++){
				var fData = this._queuedFetches[i],
				    delayedQuery = fData.args,
				    delayedFilter = fData.filter;
				if(delayedFilter){
					delayedFilter(delayedQuery, this._getItemsArray(delayedQuery.queryOptions));
				}else{
					this.fetchItemByIdentity(delayedQuery);
				}
			}
			this._queuedFetches = [];
		}
	},

	_getItemsArray: function(/*object?*/queryOptions){
		//	summary:
		//		Internal function to determine which list of items to search over.
		//	queryOptions: The query options parameter, if any.
		if(queryOptions && queryOptions.deep){
			return this._arrayOfAllItems;
		}
		return this._arrayOfTopLevelItems;
	},

	close: function(/*dojo.data.api.Request || keywordArgs || null */ request){
		 //	summary:
		 //		See dojo.data.api.Read.close()
		 if(this.clearOnClose &&
			this._loadFinished &&
			!this._loadInProgress){
			 //Reset all internalsback to default state.  This will force a reload
			 //on next fetch.  This also checks that the data or url param was set
			 //so that the store knows it can get data.  Without one of those being set,
			 //the next fetch will trigger an error.

			 if(((this._jsonFileUrl == "" || this._jsonFileUrl == null) &&
				 (this.url == "" || this.url == null)
				) && this.data == null){
				 console.debug("dojo.data.ItemFileReadStore: WARNING!  Data reload " +
					" information has not been provided." +
					"  Please set 'url' or 'data' to the appropriate value before" +
					" the next fetch");
			 }
			 this._arrayOfAllItems = [];
			 this._arrayOfTopLevelItems = [];
			 this._loadFinished = false;
			 this._itemsByIdentity = null;
			 this._loadInProgress = false;
			 this._queuedFetches = [];
		 }
	},

	_getItemsFromLoadedData: function(/* Object */ dataObject){
		//	summary:
		//		Function to parse the loaded data into item format and build the internal items array.
		//	description:
		//		Function to parse the loaded data into item format and build the internal items array.
		//
		//	dataObject:
		//		The JS data object containing the raw data to convery into item format.
		//
		// 	returns: array
		//		Array of items in store item format.
		
		// First, we define a couple little utility functions...
		var addingArrays = false,
		    self = this;
		
		function valueIsAnItem(/* anything */ aValue){
			// summary:
			//		Given any sort of value that could be in the raw json data,
			//		return true if we should interpret the value as being an
			//		item itself, rather than a literal value or a reference.
			// example:
			// 	|	false == valueIsAnItem("Kermit");
			// 	|	false == valueIsAnItem(42);
			// 	|	false == valueIsAnItem(new Date());
			// 	|	false == valueIsAnItem({_type:'Date', _value:'1802-05-14'});
			// 	|	false == valueIsAnItem({_reference:'Kermit'});
			// 	|	true == valueIsAnItem({name:'Kermit', color:'green'});
			// 	|	true == valueIsAnItem({iggy:'pop'});
			// 	|	true == valueIsAnItem({foo:42});
			var isItem = (
				(aValue !== null) &&
				(typeof aValue === "object") &&
				(!dojo.isArray(aValue) || addingArrays) &&
				(!dojo.isFunction(aValue)) &&
				(aValue.constructor == Object || dojo.isArray(aValue)) &&
				(typeof aValue._reference === "undefined") &&
				(typeof aValue._type === "undefined") &&
				(typeof aValue._value === "undefined") &&
				self.hierarchical
			);
			return isItem;
		}
		
		function addItemAndSubItemsToArrayOfAllItems(/* Item */ anItem){
			self._arrayOfAllItems.push(anItem);
			for(var attribute in anItem){
				var valueForAttribute = anItem[attribute];
				if(valueForAttribute){
					if(dojo.isArray(valueForAttribute)){
						var valueArray = valueForAttribute;
						for(var k = 0; k < valueArray.length; ++k){
							var singleValue = valueArray[k];
							if(valueIsAnItem(singleValue)){
								addItemAndSubItemsToArrayOfAllItems(singleValue);
							}
						}
					}else{
						if(valueIsAnItem(valueForAttribute)){
							addItemAndSubItemsToArrayOfAllItems(valueForAttribute);
						}
					}
				}
			}
		}

		this._labelAttr = dataObject.label;

		// We need to do some transformations to convert the data structure
		// that we read from the file into a format that will be convenient
		// to work with in memory.

		// Step 1: Walk through the object hierarchy and build a list of all items
		var i,
		    item;
		this._arrayOfAllItems = [];
		this._arrayOfTopLevelItems = dataObject.items;

		for(i = 0; i < this._arrayOfTopLevelItems.length; ++i){
			item = this._arrayOfTopLevelItems[i];
			if(dojo.isArray(item)){
				addingArrays = true;
			}
			addItemAndSubItemsToArrayOfAllItems(item);
			item[this._rootItemPropName]=true;
		}

		// Step 2: Walk through all the attribute values of all the items,
		// and replace single values with arrays.  For example, we change this:
		//		{ name:'Miss Piggy', pets:'Foo-Foo'}
		// into this:
		//		{ name:['Miss Piggy'], pets:['Foo-Foo']}
		//
		// We also store the attribute names so we can validate our store
		// reference and item id special properties for the O(1) isItem
		var allAttributeNames = {},
		    key;

		for(i = 0; i < this._arrayOfAllItems.length; ++i){
			item = this._arrayOfAllItems[i];
			for(key in item){
				if(key !== this._rootItemPropName){
					var value = item[key];
					if(value !== null){
						if(!dojo.isArray(value)){
							item[key] = [value];
						}
					}else{
						item[key] = [null];
					}
				}
				allAttributeNames[key]=key;
			}
		}

		// Step 3: Build unique property names to use for the _storeRefPropName and _itemNumPropName
		// This should go really fast, it will generally never even run the loop.
		while(allAttributeNames[this._storeRefPropName]){
			this._storeRefPropName += "_";
		}
		while(allAttributeNames[this._itemNumPropName]){
			this._itemNumPropName += "_";
		}
		while(allAttributeNames[this._reverseRefMap]){
			this._reverseRefMap += "_";
		}

		// Step 4: Some data files specify an optional 'identifier', which is
		// the name of an attribute that holds the identity of each item.
		// If this data file specified an identifier attribute, then build a
		// hash table of items keyed by the identity of the items.
		var arrayOfValues;

		var identifier = dataObject.identifier;
		if(identifier){
			this._itemsByIdentity = {};
			this._features['dojo.data.api.Identity'] = identifier;
			for(i = 0; i < this._arrayOfAllItems.length; ++i){
				item = this._arrayOfAllItems[i];
				arrayOfValues = item[identifier];
				var identity = arrayOfValues[0];
				if(!Object.hasOwnProperty.call(this._itemsByIdentity, identity)){
					this._itemsByIdentity[identity] = item;
				}else{
					if(this._jsonFileUrl){
						throw new Error("dojo.data.ItemFileReadStore:  The json data as specified by: [" + this._jsonFileUrl + "] is malformed.  Items within the list have identifier: [" + identifier + "].  Value collided: [" + identity + "]");
					}else if(this._jsonData){
						throw new Error("dojo.data.ItemFileReadStore:  The json data provided by the creation arguments is malformed.  Items within the list have identifier: [" + identifier + "].  Value collided: [" + identity + "]");
					}
				}
			}
		}else{
			this._features['dojo.data.api.Identity'] = Number;
		}

		// Step 5: Walk through all the items, and set each item's properties
		// for _storeRefPropName and _itemNumPropName, so that store.isItem() will return true.
		for(i = 0; i < this._arrayOfAllItems.length; ++i){
			item = this._arrayOfAllItems[i];
			item[this._storeRefPropName] = this;
			item[this._itemNumPropName] = i;
		}

		// Step 6: We walk through all the attribute values of all the items,
		// looking for type/value literals and item-references.
		//
		// We replace item-references with pointers to items.  For example, we change:
		//		{ name:['Kermit'], friends:[{_reference:{name:'Miss Piggy'}}] }
		// into this:
		//		{ name:['Kermit'], friends:[miss_piggy] }
		// (where miss_piggy is the object representing the 'Miss Piggy' item).
		//
		// We replace type/value pairs with typed-literals.  For example, we change:
		//		{ name:['Nelson Mandela'], born:[{_type:'Date', _value:'1918-07-18'}] }
		// into this:
		//		{ name:['Kermit'], born:(new Date(1918, 6, 18)) }
		//
		// We also generate the associate map for all items for the O(1) isItem function.
		for(i = 0; i < this._arrayOfAllItems.length; ++i){
			item = this._arrayOfAllItems[i]; // example: { name:['Kermit'], friends:[{_reference:{name:'Miss Piggy'}}] }
			for(key in item){
				arrayOfValues = item[key]; // example: [{_reference:{name:'Miss Piggy'}}]
				for(var j = 0; j < arrayOfValues.length; ++j){
					value = arrayOfValues[j]; // example: {_reference:{name:'Miss Piggy'}}
					if(value !== null && typeof value == "object"){
						if(("_type" in value) && ("_value" in value)){
							var type = value._type; // examples: 'Date', 'Color', or 'ComplexNumber'
							var mappingObj = this._datatypeMap[type]; // examples: Date, dojo.Color, foo.math.ComplexNumber, {type: dojo.Color, deserialize(value){ return new dojo.Color(value)}}
							if(!mappingObj){
								throw new Error("dojo.data.ItemFileReadStore: in the typeMap constructor arg, no object class was specified for the datatype '" + type + "'");
							}else if(dojo.isFunction(mappingObj)){
								arrayOfValues[j] = new mappingObj(value._value);
							}else if(dojo.isFunction(mappingObj.deserialize)){
								arrayOfValues[j] = mappingObj.deserialize(value._value);
							}else{
								throw new Error("dojo.data.ItemFileReadStore: Value provided in typeMap was neither a constructor, nor a an object with a deserialize function");
							}
						}
						if(value._reference){
							var referenceDescription = value._reference; // example: {name:'Miss Piggy'}
							if(!dojo.isObject(referenceDescription)){
								// example: 'Miss Piggy'
								// from an item like: { name:['Kermit'], friends:[{_reference:'Miss Piggy'}]}
								arrayOfValues[j] = this._getItemByIdentity(referenceDescription);
							}else{
								// example: {name:'Miss Piggy'}
								// from an item like: { name:['Kermit'], friends:[{_reference:{name:'Miss Piggy'}}] }
								for(var k = 0; k < this._arrayOfAllItems.length; ++k){
									var candidateItem = this._arrayOfAllItems[k],
									    found = true;
									for(var refKey in referenceDescription){
										if(candidateItem[refKey] != referenceDescription[refKey]){
											found = false;
										}
									}
									if(found){
										arrayOfValues[j] = candidateItem;
									}
								}
							}
							if(this.referenceIntegrity){
								var refItem = arrayOfValues[j];
								if(this.isItem(refItem)){
									this._addReferenceToMap(refItem, item, key);
								}
							}
						}else if(this.isItem(value)){
							//It's a child item (not one referenced through _reference).
							//We need to treat this as a referenced item, so it can be cleaned up
							//in a write store easily.
							if(this.referenceIntegrity){
								this._addReferenceToMap(value, item, key);
							}
						}
					}
				}
			}
		}
	},

	_addReferenceToMap: function(/*item*/ refItem, /*item*/ parentItem, /*string*/ attribute){
		 //	summary:
		 //		Method to add an reference map entry for an item and attribute.
		 //	description:
		 //		Method to add an reference map entry for an item and attribute. 		 //
		 //	refItem:
		 //		The item that is referenced.
		 //	parentItem:
		 //		The item that holds the new reference to refItem.
		 //	attribute:
		 //		The attribute on parentItem that contains the new reference.
		 
		 //Stub function, does nothing.  Real processing is in ItemFileWriteStore.
	},

	getIdentity: function(/* item */ item){
		//	summary:
		//		See dojo.data.api.Identity.getIdentity()
		var identifier = this._features['dojo.data.api.Identity'];
		if(identifier === Number){
			return item[this._itemNumPropName]; // Number
		}else{
			var arrayOfValues = item[identifier];
			if(arrayOfValues){
				return arrayOfValues[0]; // Object || String
			}
		}
		return null; // null
	},

	fetchItemByIdentity: function(/* Object */ keywordArgs){
		//	summary:
		//		See dojo.data.api.Identity.fetchItemByIdentity()

		// Hasn't loaded yet, we have to trigger the load.
		var item,
		    scope;
		if(!this._loadFinished){
			var self = this;
			//Do a check on the JsonFileUrl and crosscheck it.
			//If it doesn't match the cross-check, it needs to be updated
			//This allows for either url or _jsonFileUrl to he changed to
			//reset the store load location.  Done this way for backwards
			//compatibility.  People use _jsonFileUrl (even though officially
			//private.
			if(this._jsonFileUrl !== this._ccUrl){
				dojo.deprecated("dojo.data.ItemFileReadStore: ",
					"To change the url, set the url property of the store," +
					" not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0");
				this._ccUrl = this._jsonFileUrl;
				this.url = this._jsonFileUrl;
			}else if(this.url !== this._ccUrl){
				this._jsonFileUrl = this.url;
				this._ccUrl = this.url;
			}
			
			//See if there was any forced reset of data.
			if(this.data != null && this._jsonData == null){
				this._jsonData = this.data;
				this.data = null;
			}

			if(this._jsonFileUrl){

				if(this._loadInProgress){
					this._queuedFetches.push({args: keywordArgs});
				}else{
					this._loadInProgress = true;
					var getArgs = {
							url: self._jsonFileUrl,
							handleAs: "json-comment-optional",
							preventCache: this.urlPreventCache,
							failOk: this.failOk
					};
					var getHandler = dojo.xhrGet(getArgs);
					getHandler.addCallback(function(data){
						var scope = keywordArgs.scope?keywordArgs.scope:dojo.global;
						try{
							self._getItemsFromLoadedData(data);
							self._loadFinished = true;
							self._loadInProgress = false;
							item = self._getItemByIdentity(keywordArgs.identity);
							if(keywordArgs.onItem){
								keywordArgs.onItem.call(scope, item);
							}
							self._handleQueuedFetches();
						}catch(error){
							self._loadInProgress = false;
							if(keywordArgs.onError){
								keywordArgs.onError.call(scope, error);
							}
						}
					});
					getHandler.addErrback(function(error){
						self._loadInProgress = false;
						if(keywordArgs.onError){
							var scope = keywordArgs.scope?keywordArgs.scope:dojo.global;
							keywordArgs.onError.call(scope, error);
						}
					});
				}

			}else if(this._jsonData){
				// Passed in data, no need to xhr.
				self._getItemsFromLoadedData(self._jsonData);
				self._jsonData = null;
				self._loadFinished = true;
				item = self._getItemByIdentity(keywordArgs.identity);
				if(keywordArgs.onItem){
					scope = keywordArgs.scope?keywordArgs.scope:dojo.global;
					keywordArgs.onItem.call(scope, item);
				}
			}
		}else{
			// Already loaded.  We can just look it up and call back.
			item = this._getItemByIdentity(keywordArgs.identity);
			if(keywordArgs.onItem){
				scope = keywordArgs.scope?keywordArgs.scope:dojo.global;
				keywordArgs.onItem.call(scope, item);
			}
		}
	},

	_getItemByIdentity: function(/* Object */ identity){
		//	summary:
		//		Internal function to look an item up by its identity map.
		var item = null;
		if(this._itemsByIdentity &&
		   Object.hasOwnProperty.call(this._itemsByIdentity, identity)){
			item = this._itemsByIdentity[identity];
		}else if (Object.hasOwnProperty.call(this._arrayOfAllItems, identity)){
			item = this._arrayOfAllItems[identity];
		}
		if(item === undefined){
			item = null;
		}
		return item; // Object
	},

	getIdentityAttributes: function(/* item */ item){
		//	summary:
		//		See dojo.data.api.Identity.getIdentityAttributes()
		 
		var identifier = this._features['dojo.data.api.Identity'];
		if(identifier === Number){
			// If (identifier === Number) it means getIdentity() just returns
			// an integer item-number for each item.  The dojo.data.api.Identity
			// spec says we need to return null if the identity is not composed
			// of attributes
			return null; // null
		}else{
			return [identifier]; // Array
		}
	},
	
	_forceLoad: function(){
		//	summary:
		//		Internal function to force a load of the store if it hasn't occurred yet.  This is required
		//		for specific functions to work properly.
		var self = this;
		//Do a check on the JsonFileUrl and crosscheck it.
		//If it doesn't match the cross-check, it needs to be updated
		//This allows for either url or _jsonFileUrl to he changed to
		//reset the store load location.  Done this way for backwards
		//compatibility.  People use _jsonFileUrl (even though officially
		//private.
		if(this._jsonFileUrl !== this._ccUrl){
			dojo.deprecated("dojo.data.ItemFileReadStore: ",
				"To change the url, set the url property of the store," +
				" not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0");
			this._ccUrl = this._jsonFileUrl;
			this.url = this._jsonFileUrl;
		}else if(this.url !== this._ccUrl){
			this._jsonFileUrl = this.url;
			this._ccUrl = this.url;
		}

		//See if there was any forced reset of data.
		if(this.data != null){
			this._jsonData = this.data;
			this.data = null;
		}

		if(this._jsonFileUrl){
				var getArgs = {
					url: this._jsonFileUrl,
					handleAs: "json-comment-optional",
					preventCache: this.urlPreventCache,
					failOk: this.failOk,
					sync: true
				};
			var getHandler = dojo.xhrGet(getArgs);
			getHandler.addCallback(function(data){
				try{
					//Check to be sure there wasn't another load going on concurrently
					//So we don't clobber data that comes in on it.  If there is a load going on
					//then do not save this data.  It will potentially clobber current data.
					//We mainly wanted to sync/wait here.
					//TODO:  Revisit the loading scheme of this store to improve multi-initial
					//request handling.
					if(self._loadInProgress !== true && !self._loadFinished){
						self._getItemsFromLoadedData(data);
						self._loadFinished = true;
					}else if(self._loadInProgress){
						//Okay, we hit an error state we can't recover from.  A forced load occurred
						//while an async load was occurring.  Since we cannot block at this point, the best
						//that can be managed is to throw an error.
						throw new Error("dojo.data.ItemFileReadStore:  Unable to perform a synchronous load, an async load is in progress.");
					}
				}catch(e){
					console.log(e);
					throw e;
				}
			});
			getHandler.addErrback(function(error){
				throw error;
			});
		}else if(this._jsonData){
			self._getItemsFromLoadedData(self._jsonData);
			self._jsonData = null;
			self._loadFinished = true;
		}
	}
});
//Mix in the simple fetch implementation to this class.
dojo.extend(dojo.data.ItemFileReadStore,dojo.data.util.simpleFetch);

}

if(!dojo._hasResource["dojo.data.ItemFileWriteStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.data.ItemFileWriteStore"] = true;
dojo.provide("dojo.data.ItemFileWriteStore");



dojo.declare("dojo.data.ItemFileWriteStore", dojo.data.ItemFileReadStore, {
	constructor: function(/* object */ keywordParameters){
		//	keywordParameters: {typeMap: object)
		//		The structure of the typeMap object is as follows:
		//		{
		//			type0: function || object,
		//			type1: function || object,
		//			...
		//			typeN: function || object
		//		}
		//		Where if it is a function, it is assumed to be an object constructor that takes the
		//		value of _value as the initialization parameters.  It is serialized assuming object.toString()
		//		serialization.  If it is an object, then it is assumed
		//		to be an object of general form:
		//		{
		//			type: function, //constructor.
		//			deserialize:	function(value) //The function that parses the value and constructs the object defined by type appropriately.
		//			serialize:	function(object) //The function that converts the object back into the proper file format form.
		//		}

		// ItemFileWriteStore extends ItemFileReadStore to implement these additional dojo.data APIs
		this._features['dojo.data.api.Write'] = true;
		this._features['dojo.data.api.Notification'] = true;
		
		// For keeping track of changes so that we can implement isDirty and revert
		this._pending = {
			_newItems:{},
			_modifiedItems:{},
			_deletedItems:{}
		};

		if(!this._datatypeMap['Date'].serialize){
			this._datatypeMap['Date'].serialize = function(obj){
				return dojo.date.stamp.toISOString(obj, {zulu:true});
			};
		}
		//Disable only if explicitly set to false.
		if(keywordParameters && (keywordParameters.referenceIntegrity === false)){
			this.referenceIntegrity = false;
		}

		// this._saveInProgress is set to true, briefly, from when save() is first called to when it completes
		this._saveInProgress = false;
	},

	referenceIntegrity: true, //Flag that defaultly enabled reference integrity tracking.  This way it can also be disabled pogrammatially or declaratively.

	_assert: function(/* boolean */ condition){
		if(!condition){
			throw new Error("assertion failed in ItemFileWriteStore");
		}
	},

	_getIdentifierAttribute: function(){
		var identifierAttribute = this.getFeatures()['dojo.data.api.Identity'];
		// this._assert((identifierAttribute === Number) || (dojo.isString(identifierAttribute)));
		return identifierAttribute;
	},
	
	
/* dojo.data.api.Write */

	newItem: function(/* Object? */ keywordArgs, /* Object? */ parentInfo){
		// summary: See dojo.data.api.Write.newItem()

		this._assert(!this._saveInProgress);

		if(!this._loadFinished){
			// We need to do this here so that we'll be able to find out what
			// identifierAttribute was specified in the data file.
			this._forceLoad();
		}

		if(typeof keywordArgs != "object" && typeof keywordArgs != "undefined"){
			throw new Error("newItem() was passed something other than an object");
		}
		var newIdentity = null;
		var identifierAttribute = this._getIdentifierAttribute();
		if(identifierAttribute === Number){
			newIdentity = this._arrayOfAllItems.length;
		}else{
			newIdentity = keywordArgs[identifierAttribute];
			if(typeof newIdentity === "undefined"){
				throw new Error("newItem() was not passed an identity for the new item");
			}
			if(dojo.isArray(newIdentity)){
				throw new Error("newItem() was not passed an single-valued identity");
			}
		}
		
		// make sure this identity is not already in use by another item, if identifiers were
		// defined in the file.  Otherwise it would be the item count,
		// which should always be unique in this case.
		if(this._itemsByIdentity){
			this._assert(typeof this._itemsByIdentity[newIdentity] === "undefined");
		}
		this._assert(typeof this._pending._newItems[newIdentity] === "undefined");
		this._assert(typeof this._pending._deletedItems[newIdentity] === "undefined");
		
		var newItem = {};
		newItem[this._storeRefPropName] = this;
		newItem[this._itemNumPropName] = this._arrayOfAllItems.length;
		if(this._itemsByIdentity){
			this._itemsByIdentity[newIdentity] = newItem;
			//We have to set the identifier now, otherwise we can't look it
			//up at calls to setValueorValues in parentInfo handling.
			newItem[identifierAttribute] = [newIdentity];
		}
		this._arrayOfAllItems.push(newItem);

		//We need to construct some data for the onNew call too...
		var pInfo = null;
		
		// Now we need to check to see where we want to assign this thingm if any.
		if(parentInfo && parentInfo.parent && parentInfo.attribute){
			pInfo = {
				item: parentInfo.parent,
				attribute: parentInfo.attribute,
				oldValue: undefined
			};

			//See if it is multi-valued or not and handle appropriately
			//Generally, all attributes are multi-valued for this store
			//So, we only need to append if there are already values present.
			var values = this.getValues(parentInfo.parent, parentInfo.attribute);
			if(values && values.length > 0){
				var tempValues = values.slice(0, values.length);
				if(values.length === 1){
					pInfo.oldValue = values[0];
				}else{
					pInfo.oldValue = values.slice(0, values.length);
				}
				tempValues.push(newItem);
				this._setValueOrValues(parentInfo.parent, parentInfo.attribute, tempValues, false);
				pInfo.newValue = this.getValues(parentInfo.parent, parentInfo.attribute);
			}else{
				this._setValueOrValues(parentInfo.parent, parentInfo.attribute, newItem, false);
				pInfo.newValue = newItem;
			}
		}else{
			//Toplevel item, add to both top list as well as all list.
			newItem[this._rootItemPropName]=true;
			this._arrayOfTopLevelItems.push(newItem);
		}
		
		this._pending._newItems[newIdentity] = newItem;
		
		//Clone over the properties to the new item
		for(var key in keywordArgs){
			if(key === this._storeRefPropName || key === this._itemNumPropName){
				// Bummer, the user is trying to do something like
				// newItem({_S:"foo"}).  Unfortunately, our superclass,
				// ItemFileReadStore, is already using _S in each of our items
				// to hold private info.  To avoid a naming collision, we
				// need to move all our private info to some other property
				// of all the items/objects.  So, we need to iterate over all
				// the items and do something like:
				//    item.__S = item._S;
				//    item._S = undefined;
				// But first we have to make sure the new "__S" variable is
				// not in use, which means we have to iterate over all the
				// items checking for that.
				throw new Error("encountered bug in ItemFileWriteStore.newItem");
			}
			var value = keywordArgs[key];
			if(!dojo.isArray(value)){
				value = [value];
			}
			newItem[key] = value;
			if(this.referenceIntegrity){
				for(var i = 0; i < value.length; i++){
					var val = value[i];
					if(this.isItem(val)){
						this._addReferenceToMap(val, newItem, key);
					}
				}
			}
		}
		this.onNew(newItem, pInfo); // dojo.data.api.Notification call
		return newItem; // item
	},
	
	_removeArrayElement: function(/* Array */ array, /* anything */ element){
		var index = dojo.indexOf(array, element);
		if(index != -1){
			array.splice(index, 1);
			return true;
		}
		return false;
	},
	
	deleteItem: function(/* item */ item){
		// summary: See dojo.data.api.Write.deleteItem()
		this._assert(!this._saveInProgress);
		this._assertIsItem(item);

		// Remove this item from the _arrayOfAllItems, but leave a null value in place
		// of the item, so as not to change the length of the array, so that in newItem()
		// we can still safely do: newIdentity = this._arrayOfAllItems.length;
		var indexInArrayOfAllItems = item[this._itemNumPropName];
		var identity = this.getIdentity(item);

		//If we have reference integrity on, we need to do reference cleanup for the deleted item
		if(this.referenceIntegrity){
			//First scan all the attributes of this items for references and clean them up in the map
			//As this item is going away, no need to track its references anymore.

			//Get the attributes list before we generate the backup so it
			//doesn't pollute the attributes list.
			var attributes = this.getAttributes(item);

			//Backup the map, we'll have to restore it potentially, in a revert.
			if(item[this._reverseRefMap]){
				item["backup_" + this._reverseRefMap] = dojo.clone(item[this._reverseRefMap]);
			}
			
			//TODO:  This causes a reversion problem.  This list won't be restored on revert since it is
			//attached to the 'value'. item, not ours.  Need to back tese up somehow too.
			//Maybe build a map of the backup of the entries and attach it to the deleted item to be restored
			//later.  Or just record them and call _addReferenceToMap on them in revert.
			dojo.forEach(attributes, function(attribute){
				dojo.forEach(this.getValues(item, attribute), function(value){
					if(this.isItem(value)){
						//We have to back up all the references we had to others so they can be restored on a revert.
						if(!item["backupRefs_" + this._reverseRefMap]){
							item["backupRefs_" + this._reverseRefMap] = [];
						}
						item["backupRefs_" + this._reverseRefMap].push({id: this.getIdentity(value), attr: attribute});
						this._removeReferenceFromMap(value, item, attribute);
					}
				}, this);
			}, this);

			//Next, see if we have references to this item, if we do, we have to clean them up too.
			var references = item[this._reverseRefMap];
			if(references){
				//Look through all the items noted as references to clean them up.
				for(var itemId in references){
					var containingItem = null;
					if(this._itemsByIdentity){
						containingItem = this._itemsByIdentity[itemId];
					}else{
						containingItem = this._arrayOfAllItems[itemId];
					}
					//We have a reference to a containing item, now we have to process the
					//attributes and clear all references to the item being deleted.
					if(containingItem){
						for(var attribute in references[itemId]){
							var oldValues = this.getValues(containingItem, attribute) || [];
							var newValues = dojo.filter(oldValues, function(possibleItem){
								return !(this.isItem(possibleItem) && this.getIdentity(possibleItem) == identity);
							}, this);
							//Remove the note of the reference to the item and set the values on the modified attribute.
							this._removeReferenceFromMap(item, containingItem, attribute);
							if(newValues.length < oldValues.length){
								this._setValueOrValues(containingItem, attribute, newValues, true);
							}
						}
					}
				}
			}
		}

		this._arrayOfAllItems[indexInArrayOfAllItems] = null;

		item[this._storeRefPropName] = null;
		if(this._itemsByIdentity){
			delete this._itemsByIdentity[identity];
		}
		this._pending._deletedItems[identity] = item;
		
		//Remove from the toplevel items, if necessary...
		if(item[this._rootItemPropName]){
			this._removeArrayElement(this._arrayOfTopLevelItems, item);
		}
		this.onDelete(item); // dojo.data.api.Notification call
		return true;
	},

	setValue: function(/* item */ item, /* attribute-name-string */ attribute, /* almost anything */ value){
		// summary: See dojo.data.api.Write.set()
		return this._setValueOrValues(item, attribute, value, true); // boolean
	},
	
	setValues: function(/* item */ item, /* attribute-name-string */ attribute, /* array */ values){
		// summary: See dojo.data.api.Write.setValues()
		return this._setValueOrValues(item, attribute, values, true); // boolean
	},
	
	unsetAttribute: function(/* item */ item, /* attribute-name-string */ attribute){
		// summary: See dojo.data.api.Write.unsetAttribute()
		return this._setValueOrValues(item, attribute, [], true);
	},
	
	_setValueOrValues: function(/* item */ item, /* attribute-name-string */ attribute, /* anything */ newValueOrValues, /*boolean?*/ callOnSet){
		this._assert(!this._saveInProgress);
		
		// Check for valid arguments
		this._assertIsItem(item);
		this._assert(dojo.isString(attribute));
		this._assert(typeof newValueOrValues !== "undefined");

		// Make sure the user isn't trying to change the item's identity
		var identifierAttribute = this._getIdentifierAttribute();
		if(attribute == identifierAttribute){
			throw new Error("ItemFileWriteStore does not have support for changing the value of an item's identifier.");
		}

		// To implement the Notification API, we need to make a note of what
		// the old attribute value was, so that we can pass that info when
		// we call the onSet method.
		var oldValueOrValues = this._getValueOrValues(item, attribute);

		var identity = this.getIdentity(item);
		if(!this._pending._modifiedItems[identity]){
			// Before we actually change the item, we make a copy of it to
			// record the original state, so that we'll be able to revert if
			// the revert method gets called.  If the item has already been
			// modified then there's no need to do this now, since we already
			// have a record of the original state.
			var copyOfItemState = {};
			for(var key in item){
				if((key === this._storeRefPropName) || (key === this._itemNumPropName) || (key === this._rootItemPropName)){
					copyOfItemState[key] = item[key];
				}else if(key === this._reverseRefMap){
					copyOfItemState[key] = dojo.clone(item[key]);
				}else{
					copyOfItemState[key] = item[key].slice(0, item[key].length);
				}
			}
			// Now mark the item as dirty, and save the copy of the original state
			this._pending._modifiedItems[identity] = copyOfItemState;
		}
		
		// Okay, now we can actually change this attribute on the item
		var success = false;
		
		if(dojo.isArray(newValueOrValues) && newValueOrValues.length === 0){
			
			// If we were passed an empty array as the value, that counts
			// as "unsetting" the attribute, so we need to remove this
			// attribute from the item.
			success = delete item[attribute];
			newValueOrValues = undefined; // used in the onSet Notification call below

			if(this.referenceIntegrity && oldValueOrValues){
				var oldValues = oldValueOrValues;
				if(!dojo.isArray(oldValues)){
					oldValues = [oldValues];
				}
				for(var i = 0; i < oldValues.length; i++){
					var value = oldValues[i];
					if(this.isItem(value)){
						this._removeReferenceFromMap(value, item, attribute);
					}
				}
			}
		}else{
			var newValueArray;
			if(dojo.isArray(newValueOrValues)){
				var newValues = newValueOrValues;
				// Unfortunately, it's not safe to just do this:
				//    newValueArray = newValues;
				// Instead, we need to copy the array, which slice() does very nicely.
				// This is so that our internal data structure won't
				// get corrupted if the user mucks with the values array *after*
				// calling setValues().
				newValueArray = newValueOrValues.slice(0, newValueOrValues.length);
			}else{
				newValueArray = [newValueOrValues];
			}

			//We need to handle reference integrity if this is on.
			//In the case of set, we need to see if references were added or removed
			//and update the reference tracking map accordingly.
			if(this.referenceIntegrity){
				if(oldValueOrValues){
					var oldValues = oldValueOrValues;
					if(!dojo.isArray(oldValues)){
						oldValues = [oldValues];
					}
					//Use an associative map to determine what was added/removed from the list.
					//Should be O(n) performant.  First look at all the old values and make a list of them
					//Then for any item not in the old list, we add it.  If it was already present, we remove it.
					//Then we pass over the map and any references left it it need to be removed (IE, no match in
					//the new values list).
					var map = {};
					dojo.forEach(oldValues, function(possibleItem){
						if(this.isItem(possibleItem)){
							var id = this.getIdentity(possibleItem);
							map[id.toString()] = true;
						}
					}, this);
					dojo.forEach(newValueArray, function(possibleItem){
						if(this.isItem(possibleItem)){
							var id = this.getIdentity(possibleItem);
							if(map[id.toString()]){
								delete map[id.toString()];
							}else{
								this._addReferenceToMap(possibleItem, item, attribute);
							}
						}
					}, this);
					for(var rId in map){
						var removedItem;
						if(this._itemsByIdentity){
							removedItem = this._itemsByIdentity[rId];
						}else{
							removedItem = this._arrayOfAllItems[rId];
						}
						this._removeReferenceFromMap(removedItem, item, attribute);
					}
				}else{
					//Everything is new (no old values) so we have to just
					//insert all the references, if any.
					for(var i = 0; i < newValueArray.length; i++){
						var value = newValueArray[i];
						if(this.isItem(value)){
							this._addReferenceToMap(value, item, attribute);
						}
					}
				}
			}
			item[attribute] = newValueArray;
			success = true;
		}

		// Now we make the dojo.data.api.Notification call
		if(callOnSet){
			this.onSet(item, attribute, oldValueOrValues, newValueOrValues);
		}
		return success; // boolean
	},

	_addReferenceToMap: function(/*item*/ refItem, /*item*/ parentItem, /*string*/ attribute){
		//	summary:
		//		Method to add an reference map entry for an item and attribute.
		//	description:
		//		Method to add an reference map entry for an item and attribute. 		 //
		//	refItem:
		//		The item that is referenced.
		//	parentItem:
		//		The item that holds the new reference to refItem.
		//	attribute:
		//		The attribute on parentItem that contains the new reference.
		 
		var parentId = this.getIdentity(parentItem);
		var references = refItem[this._reverseRefMap];

		if(!references){
			references = refItem[this._reverseRefMap] = {};
		}
		var itemRef = references[parentId];
		if(!itemRef){
			itemRef = references[parentId] = {};
		}
		itemRef[attribute] = true;
	},

	_removeReferenceFromMap: function(/* item */ refItem, /* item */ parentItem, /*strin*/ attribute){
		//	summary:
		//		Method to remove an reference map entry for an item and attribute.
		//	description:
		//		Method to remove an reference map entry for an item and attribute.  This will
		//		also perform cleanup on the map such that if there are no more references at all to
		//		the item, its reference object and entry are removed.
		//
		//	refItem:
		//		The item that is referenced.
		//	parentItem:
		//		The item holding a reference to refItem.
		//	attribute:
		//		The attribute on parentItem that contains the reference.
		var identity = this.getIdentity(parentItem);
		var references = refItem[this._reverseRefMap];
		var itemId;
		if(references){
			for(itemId in references){
				if(itemId == identity){
					delete references[itemId][attribute];
					if(this._isEmpty(references[itemId])){
						delete references[itemId];
					}
				}
			}
			if(this._isEmpty(references)){
				delete refItem[this._reverseRefMap];
			}
		}
	},

	_dumpReferenceMap: function(){
		//	summary:
		//		Function to dump the reverse reference map of all items in the store for debug purposes.
		//	description:
		//		Function to dump the reverse reference map of all items in the store for debug purposes.
		var i;
		for(i = 0; i < this._arrayOfAllItems.length; i++){
			var item = this._arrayOfAllItems[i];
			if(item && item[this._reverseRefMap]){
				console.log("Item: [" + this.getIdentity(item) + "] is referenced by: " + dojo.toJson(item[this._reverseRefMap]));
			}
		}
	},
	
	_getValueOrValues: function(/* item */ item, /* attribute-name-string */ attribute){
		var valueOrValues = undefined;
		if(this.hasAttribute(item, attribute)){
			var valueArray = this.getValues(item, attribute);
			if(valueArray.length == 1){
				valueOrValues = valueArray[0];
			}else{
				valueOrValues = valueArray;
			}
		}
		return valueOrValues;
	},
	
	_flatten: function(/* anything */ value){
		if(this.isItem(value)){
			var item = value;
			// Given an item, return an serializable object that provides a
			// reference to the item.
			// For example, given kermit:
			//    var kermit = store.newItem({id:2, name:"Kermit"});
			// we want to return
			//    {_reference:2}
			var identity = this.getIdentity(item);
			var referenceObject = {_reference: identity};
			return referenceObject;
		}else{
			if(typeof value === "object"){
				for(var type in this._datatypeMap){
					var typeMap = this._datatypeMap[type];
					if(dojo.isObject(typeMap) && !dojo.isFunction(typeMap)){
						if(value instanceof typeMap.type){
							if(!typeMap.serialize){
								throw new Error("ItemFileWriteStore:  No serializer defined for type mapping: [" + type + "]");
							}
							return {_type: type, _value: typeMap.serialize(value)};
						}
					} else if(value instanceof typeMap){
						//SImple mapping, therefore, return as a toString serialization.
						return {_type: type, _value: value.toString()};
					}
				}
			}
			return value;
		}
	},
	
	_getNewFileContentString: function(){
		// summary:
		//		Generate a string that can be saved to a file.
		//		The result should look similar to:
		//		http://trac.dojotoolkit.org/browser/dojo/trunk/tests/data/countries.json
		var serializableStructure = {};
		
		var identifierAttribute = this._getIdentifierAttribute();
		if(identifierAttribute !== Number){
			serializableStructure.identifier = identifierAttribute;
		}
		if(this._labelAttr){
			serializableStructure.label = this._labelAttr;
		}
		serializableStructure.items = [];
		for(var i = 0; i < this._arrayOfAllItems.length; ++i){
			var item = this._arrayOfAllItems[i];
			if(item !== null){
				var serializableItem = {};
				for(var key in item){
					if(key !== this._storeRefPropName && key !== this._itemNumPropName && key !== this._reverseRefMap && key !== this._rootItemPropName){
						var attribute = key;
						var valueArray = this.getValues(item, attribute);
						if(valueArray.length == 1){
							serializableItem[attribute] = this._flatten(valueArray[0]);
						}else{
							var serializableArray = [];
							for(var j = 0; j < valueArray.length; ++j){
								serializableArray.push(this._flatten(valueArray[j]));
								serializableItem[attribute] = serializableArray;
							}
						}
					}
				}
				serializableStructure.items.push(serializableItem);
			}
		}
		var prettyPrint = true;
		return dojo.toJson(serializableStructure, prettyPrint);
	},

	_isEmpty: function(something){
		//	summary:
		//		Function to determine if an array or object has no properties or values.
		//	something:
		//		The array or object to examine.
		var empty = true;
		if(dojo.isObject(something)){
			var i;
			for(i in something){
				empty = false;
				break;
			}
		}else if(dojo.isArray(something)){
			if(something.length > 0){
				empty = false;
			}
		}
		return empty; //boolean
	},
	
	save: function(/* object */ keywordArgs){
		// summary: See dojo.data.api.Write.save()
		this._assert(!this._saveInProgress);
		
		// this._saveInProgress is set to true, briefly, from when save is first called to when it completes
		this._saveInProgress = true;
		
		var self = this;
		var saveCompleteCallback = function(){
			self._pending = {
				_newItems:{},
				_modifiedItems:{},
				_deletedItems:{}
			};

			self._saveInProgress = false; // must come after this._pending is cleared, but before any callbacks
			if(keywordArgs && keywordArgs.onComplete){
				var scope = keywordArgs.scope || dojo.global;
				keywordArgs.onComplete.call(scope);
			}
		};
		var saveFailedCallback = function(err){
			self._saveInProgress = false;
			if(keywordArgs && keywordArgs.onError){
				var scope = keywordArgs.scope || dojo.global;
				keywordArgs.onError.call(scope, err);
			}
		};
		
		if(this._saveEverything){
			var newFileContentString = this._getNewFileContentString();
			this._saveEverything(saveCompleteCallback, saveFailedCallback, newFileContentString);
		}
		if(this._saveCustom){
			this._saveCustom(saveCompleteCallback, saveFailedCallback);
		}
		if(!this._saveEverything && !this._saveCustom){
			// Looks like there is no user-defined save-handler function.
			// That's fine, it just means the datastore is acting as a "mock-write"
			// store -- changes get saved in memory but don't get saved to disk.
			saveCompleteCallback();
		}
	},
	
	revert: function(){
		// summary: See dojo.data.api.Write.revert()
		this._assert(!this._saveInProgress);

		var identity;
		for(identity in this._pending._modifiedItems){
			// find the original item and the modified item that replaced it
			var copyOfItemState = this._pending._modifiedItems[identity];
			var modifiedItem = null;
			if(this._itemsByIdentity){
				modifiedItem = this._itemsByIdentity[identity];
			}else{
				modifiedItem = this._arrayOfAllItems[identity];
			}
	
			// Restore the original item into a full-fledged item again, we want to try to
			// keep the same object instance as if we don't it, causes bugs like #9022.
			copyOfItemState[this._storeRefPropName] = this;
			for(key in modifiedItem){
				delete modifiedItem[key];
			}
			dojo.mixin(modifiedItem, copyOfItemState);
		}
		var deletedItem;
		for(identity in this._pending._deletedItems){
			deletedItem = this._pending._deletedItems[identity];
			deletedItem[this._storeRefPropName] = this;
			var index = deletedItem[this._itemNumPropName];

			//Restore the reverse refererence map, if any.
			if(deletedItem["backup_" + this._reverseRefMap]){
				deletedItem[this._reverseRefMap] = deletedItem["backup_" + this._reverseRefMap];
				delete deletedItem["backup_" + this._reverseRefMap];
			}
			this._arrayOfAllItems[index] = deletedItem;
			if(this._itemsByIdentity){
				this._itemsByIdentity[identity] = deletedItem;
			}
			if(deletedItem[this._rootItemPropName]){
				this._arrayOfTopLevelItems.push(deletedItem);
			}
		}
		//We have to pass through it again and restore the reference maps after all the
		//undeletes have occurred.
		for(identity in this._pending._deletedItems){
			deletedItem = this._pending._deletedItems[identity];
			if(deletedItem["backupRefs_" + this._reverseRefMap]){
				dojo.forEach(deletedItem["backupRefs_" + this._reverseRefMap], function(reference){
					var refItem;
					if(this._itemsByIdentity){
						refItem = this._itemsByIdentity[reference.id];
					}else{
						refItem = this._arrayOfAllItems[reference.id];
					}
					this._addReferenceToMap(refItem, deletedItem, reference.attr);
				}, this);
				delete deletedItem["backupRefs_" + this._reverseRefMap];
			}
		}

		for(identity in this._pending._newItems){
			var newItem = this._pending._newItems[identity];
			newItem[this._storeRefPropName] = null;
			// null out the new item, but don't change the array index so
			// so we can keep using _arrayOfAllItems.length.
			this._arrayOfAllItems[newItem[this._itemNumPropName]] = null;
			if(newItem[this._rootItemPropName]){
				this._removeArrayElement(this._arrayOfTopLevelItems, newItem);
			}
			if(this._itemsByIdentity){
				delete this._itemsByIdentity[identity];
			}
		}

		this._pending = {
			_newItems:{},
			_modifiedItems:{},
			_deletedItems:{}
		};
		return true; // boolean
	},
	
	isDirty: function(/* item? */ item){
		// summary: See dojo.data.api.Write.isDirty()
		if(item){
			// return true if the item is dirty
			var identity = this.getIdentity(item);
			return new Boolean(this._pending._newItems[identity] ||
				this._pending._modifiedItems[identity] ||
				this._pending._deletedItems[identity]).valueOf(); // boolean
		}else{
			// return true if the store is dirty -- which means return true
			// if there are any new items, dirty items, or modified items
			if(!this._isEmpty(this._pending._newItems) ||
				!this._isEmpty(this._pending._modifiedItems) ||
				!this._isEmpty(this._pending._deletedItems)){
				return true;
			}
			return false; // boolean
		}
	},

/* dojo.data.api.Notification */

	onSet: function(/* item */ item,
					/*attribute-name-string*/ attribute,
					/*object | array*/ oldValue,
					/*object | array*/ newValue){
		// summary: See dojo.data.api.Notification.onSet()
		
		// No need to do anything. This method is here just so that the
		// client code can connect observers to it.
	},

	onNew: function(/* item */ newItem, /*object?*/ parentInfo){
		// summary: See dojo.data.api.Notification.onNew()
		
		// No need to do anything. This method is here just so that the
		// client code can connect observers to it.
	},

	onDelete: function(/* item */ deletedItem){
		// summary: See dojo.data.api.Notification.onDelete()
		
		// No need to do anything. This method is here just so that the
		// client code can connect observers to it.
	},

	close: function(/* object? */ request){
		 // summary:
		 //		Over-ride of base close function of ItemFileReadStore to add in check for store state.
		 // description:
		 //		Over-ride of base close function of ItemFileReadStore to add in check for store state.
		 //		If the store is still dirty (unsaved changes), then an error will be thrown instead of
		 //		clearing the internal state for reload from the url.

		 //Clear if not dirty ... or throw an error
		 if(this.clearOnClose){
			 if(!this.isDirty()){
				 this.inherited(arguments);
			 }else{
				 //Only throw an error if the store was dirty and we were loading from a url (cannot reload from url until state is saved).
				 throw new Error("dojo.data.ItemFileWriteStore: There are unsaved changes present in the store.  Please save or revert the changes before invoking close.");
			 }
		 }
	}
});

}

if(!dojo._hasResource["dijit._KeyNavContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._KeyNavContainer"] = true;
dojo.provide("dijit._KeyNavContainer");



dojo.declare("dijit._KeyNavContainer",
	dijit._Container,
	{

		// summary:
		//		A _Container with keyboard navigation of its children.
		// description:
		//		To use this mixin, call connectKeyNavHandlers() in
		//		postCreate() and call startupKeyNavChildren() in startup().
		//		It provides normalized keyboard and focusing code for Container
		//		widgets.
/*=====
		// focusedChild: [protected] Widget
		//		The currently focused child widget, or null if there isn't one
		focusedChild: null,
=====*/

		// tabIndex: Integer
		//		Tab index of the container; same as HTML tabIndex attribute.
		//		Note then when user tabs into the container, focus is immediately
		//		moved to the first item in the container.
		tabIndex: "0",

		_keyNavCodes: {},

		connectKeyNavHandlers: function(/*dojo.keys[]*/ prevKeyCodes, /*dojo.keys[]*/ nextKeyCodes){
			// summary:
			//		Call in postCreate() to attach the keyboard handlers
			//		to the container.
			// preKeyCodes: dojo.keys[]
			//		Key codes for navigating to the previous child.
			// nextKeyCodes: dojo.keys[]
			//		Key codes for navigating to the next child.
			// tags:
			//		protected

			var keyCodes = (this._keyNavCodes = {});
			var prev = dojo.hitch(this, this.focusPrev);
			var next = dojo.hitch(this, this.focusNext);
			dojo.forEach(prevKeyCodes, function(code){ keyCodes[code] = prev; });
			dojo.forEach(nextKeyCodes, function(code){ keyCodes[code] = next; });
			keyCodes[dojo.keys.HOME] = dojo.hitch(this, "focusFirstChild");
			keyCodes[dojo.keys.END] = dojo.hitch(this, "focusLastChild");
			this.connect(this.domNode, "onkeypress", "_onContainerKeypress");
			this.connect(this.domNode, "onfocus", "_onContainerFocus");
		},

		startupKeyNavChildren: function(){
			// summary:
			//		Call in startup() to set child tabindexes to -1
			// tags:
			//		protected
			dojo.forEach(this.getChildren(), dojo.hitch(this, "_startupChild"));
		},

		addChild: function(/*dijit._Widget*/ widget, /*int?*/ insertIndex){
			// summary:
			//		Add a child to our _Container
			dijit._KeyNavContainer.superclass.addChild.apply(this, arguments);
			this._startupChild(widget);
		},

		focus: function(){
			// summary:
			//		Default focus() implementation: focus the first child.
			this.focusFirstChild();
		},

		focusFirstChild: function(){
			// summary:
			//		Focus the first focusable child in the container.
			// tags:
			//		protected
			var child = this._getFirstFocusableChild();
			if(child){ // edge case: Menu could be empty or hidden
				this.focusChild(child);
			}
		},

		focusLastChild: function(){
			// summary:
			//		Focus the last focusable child in the container.
			// tags:
			//		protected
			var child = this._getLastFocusableChild();
			if(child){ // edge case: Menu could be empty or hidden
				this.focusChild(child);
			}
		},

		focusNext: function(){
			// summary:
			//		Focus the next widget
			// tags:
			//		protected
			var child = this._getNextFocusableChild(this.focusedChild, 1);
			this.focusChild(child);
		},

		focusPrev: function(){
			// summary:
			//		Focus the last focusable node in the previous widget
			//		(ex: go to the ComboButton icon section rather than button section)
			// tags:
			//		protected
			var child = this._getNextFocusableChild(this.focusedChild, -1);
			this.focusChild(child, true);
		},

		focusChild: function(/*dijit._Widget*/ widget, /*Boolean*/ last){
			// summary:
			//		Focus widget.
			// widget:
			//		Reference to container's child widget
			// last:
			//		If true and if widget has multiple focusable nodes, focus the
			//		last one instead of the first one
			// tags:
			//		protected
			
			if(this.focusedChild && widget !== this.focusedChild){
				this._onChildBlur(this.focusedChild);
			}
			widget.set("tabIndex", this.tabIndex);	// for IE focus outline to appear, must set tabIndex before focs
			widget.focus(last ? "end" : "start");
			this._set("focusedChild", widget);
		},

		_startupChild: function(/*dijit._Widget*/ widget){
			// summary:
			//		Setup for each child widget
			// description:
			//		Sets tabIndex=-1 on each child, so that the tab key will
			//		leave the container rather than visiting each child.
			// tags:
			//		private
			
			widget.set("tabIndex", "-1");
			
			this.connect(widget, "_onFocus", function(){
				// Set valid tabIndex so tabbing away from widget goes to right place, see #10272
				widget.set("tabIndex", this.tabIndex);
			});
			this.connect(widget, "_onBlur", function(){
				widget.set("tabIndex", "-1");
			});
		},

		_onContainerFocus: function(evt){
			// summary:
			//		Handler for when the container gets focus
			// description:
			//		Initially the container itself has a tabIndex, but when it gets
			//		focus, switch focus to first child...
			// tags:
			//		private

			// Note that we can't use _onFocus() because switching focus from the
			// _onFocus() handler confuses the focus.js code
			// (because it causes _onFocusNode() to be called recursively)

			// focus bubbles on Firefox,
			// so just make sure that focus has really gone to the container
			if(evt.target !== this.domNode){ return; }

			this.focusFirstChild();

			// and then set the container's tabIndex to -1,
			// (don't remove as that breaks Safari 4)
			// so that tab or shift-tab will go to the fields after/before
			// the container, rather than the container itself
			dojo.attr(this.domNode, "tabIndex", "-1");
		},

		_onBlur: function(evt){
			// When focus is moved away the container, and its descendant (popup) widgets,
			// then restore the container's tabIndex so that user can tab to it again.
			// Note that using _onBlur() so that this doesn't happen when focus is shifted
			// to one of my child widgets (typically a popup)
			if(this.tabIndex){
				dojo.attr(this.domNode, "tabIndex", this.tabIndex);
			}
			this.inherited(arguments);
		},

		_onContainerKeypress: function(evt){
			// summary:
			//		When a key is pressed, if it's an arrow key etc. then
			//		it's handled here.
			// tags:
			//		private
			if(evt.ctrlKey || evt.altKey){ return; }
			var func = this._keyNavCodes[evt.charOrCode];
			if(func){
				func();
				dojo.stopEvent(evt);
			}
		},

		_onChildBlur: function(/*dijit._Widget*/ widget){
			// summary:
			//		Called when focus leaves a child widget to go
			//		to a sibling widget.
			// tags:
			//		protected
		},

		_getFirstFocusableChild: function(){
			// summary:
			//		Returns first child that can be focused
			return this._getNextFocusableChild(null, 1);	// dijit._Widget
		},

		_getLastFocusableChild: function(){
			// summary:
			//		Returns last child that can be focused
			return this._getNextFocusableChild(null, -1);	// dijit._Widget
		},

		_getNextFocusableChild: function(child, dir){
			// summary:
			//		Returns the next or previous focusable child, compared
			//		to "child"
			// child: Widget
			//		The current widget
			// dir: Integer
			//		* 1 = after
			//		* -1 = before
			if(child){
				child = this._getSiblingOfChild(child, dir);
			}
			var children = this.getChildren();
			for(var i=0; i < children.length; i++){
				if(!child){
					child = children[(dir>0) ? 0 : (children.length-1)];
				}
				if(child.isFocusable()){
					return child;	// dijit._Widget
				}
				child = this._getSiblingOfChild(child, dir);
			}
			// no focusable child found
			return null;	// dijit._Widget
		}
	}
);

}

if(!dojo._hasResource["dijit.MenuItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.MenuItem"] = true;
dojo.provide("dijit.MenuItem");






dojo.declare("dijit.MenuItem",
		[dijit._Widget, dijit._Templated, dijit._Contained, dijit._CssStateMixin],
		{
		// summary:
		//		A line item in a Menu Widget

		// Make 3 columns
		// icon, label, and expand arrow (BiDi-dependent) indicating sub-menu
		templateString: dojo.cache("dijit", "templates/MenuItem.html", "<tr class=\"dijitReset dijitMenuItem\" dojoAttachPoint=\"focusNode\" role=\"menuitem\" tabIndex=\"-1\"\n\t\tdojoAttachEvent=\"onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick\">\n\t<td class=\"dijitReset dijitMenuItemIconCell\" role=\"presentation\">\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitIcon dijitMenuItemIcon\" dojoAttachPoint=\"iconNode\"/>\n\t</td>\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\" dojoAttachPoint=\"containerNode\"></td>\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" dojoAttachPoint=\"accelKeyNode\"></td>\n\t<td class=\"dijitReset dijitMenuArrowCell\" role=\"presentation\">\n\t\t<div dojoAttachPoint=\"arrowWrapper\" style=\"visibility: hidden\">\n\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuExpand\"/>\n\t\t\t<span class=\"dijitMenuExpandA11y\">+</span>\n\t\t</div>\n\t</td>\n</tr>\n"),

		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			label: { node: "containerNode", type: "innerHTML" },
			iconClass: { node: "iconNode", type: "class" }
		}),

		baseClass: "dijitMenuItem",

		// label: String
		//		Menu text
		label: '',

		// iconClass: String
		//		Class to apply to DOMNode to make it display an icon.
		iconClass: "",

		// accelKey: String
		//		Text for the accelerator (shortcut) key combination.
		//		Note that although Menu can display accelerator keys there
		//		is no infrastructure to actually catch and execute these
		//		accelerators.
		accelKey: "",

		// disabled: Boolean
		//		If true, the menu item is disabled.
		//		If false, the menu item is enabled.
		disabled: false,

		_fillContent: function(/*DomNode*/ source){
			// If button label is specified as srcNodeRef.innerHTML rather than
			// this.params.label, handle it here.
			if(source && !("label" in this.params)){
				this.set('label', source.innerHTML);
			}
		},

		buildRendering: function(){
			this.inherited(arguments);
			var label = this.id+"_text";
			dojo.attr(this.containerNode, "id", label);
			if(this.accelKeyNode){
				dojo.attr(this.accelKeyNode, "id", this.id + "_accel");
				label += " " + this.id + "_accel";
			}
			dijit.setWaiState(this.domNode, "labelledby", label);
			dojo.setSelectable(this.domNode, false);
		},

		_onHover: function(){
			// summary:
			//		Handler when mouse is moved onto menu item
			// tags:
			//		protected
			this.getParent().onItemHover(this);
		},

		_onUnhover: function(){
			// summary:
			//		Handler when mouse is moved off of menu item,
			//		possibly to a child menu, or maybe to a sibling
			//		menuitem or somewhere else entirely.
			// tags:
			//		protected

			// if we are unhovering the currently selected item
			// then unselect it
			this.getParent().onItemUnhover(this);

			// When menu is hidden (collapsed) due to clicking a MenuItem and having it execute,
			// FF and IE don't generate an onmouseout event for the MenuItem.
			// So, help out _CssStateMixin in this case.
			this._set("hovering", false);
		},

		_onClick: function(evt){
			// summary:
			//		Internal handler for click events on MenuItem.
			// tags:
			//		private
			this.getParent().onItemClick(this, evt);
			dojo.stopEvent(evt);
		},

		onClick: function(/*Event*/ evt){
			// summary:
			//		User defined function to handle clicks
			// tags:
			//		callback
		},

		focus: function(){
			// summary:
			//		Focus on this MenuItem
			try{
				if(dojo.isIE == 8){
					// needed for IE8 which won't scroll TR tags into view on focus yet calling scrollIntoView creates flicker (#10275)
					this.containerNode.focus();
				}
				dijit.focus(this.focusNode);
			}catch(e){
				// this throws on IE (at least) in some scenarios
			}
		},

		_onFocus: function(){
			// summary:
			//		This is called by the focus manager when focus
			//		goes to this MenuItem or a child menu.
			// tags:
			//		protected
			this._setSelected(true);
			this.getParent()._onItemFocus(this);

			this.inherited(arguments);
		},

		_setSelected: function(selected){
			// summary:
			//		Indicate that this node is the currently selected one
			// tags:
			//		private

			/***
			 * TODO: remove this method and calls to it, when _onBlur() is working for MenuItem.
			 * Currently _onBlur() gets called when focus is moved from the MenuItem to a child menu.
			 * That's not supposed to happen, but the problem is:
			 * In order to allow dijit.popup's getTopPopup() to work,a sub menu's popupParent
			 * points to the parent Menu, bypassing the parent MenuItem... thus the
			 * MenuItem is not in the chain of active widgets and gets a premature call to
			 * _onBlur()
			 */

			dojo.toggleClass(this.domNode, "dijitMenuItemSelected", selected);
		},

		setLabel: function(/*String*/ content){
			// summary:
			//		Deprecated.   Use set('label', ...) instead.
			// tags:
			//		deprecated
			dojo.deprecated("dijit.MenuItem.setLabel() is deprecated.  Use set('label', ...) instead.", "", "2.0");
			this.set("label", content);
		},

		setDisabled: function(/*Boolean*/ disabled){
			// summary:
			//		Deprecated.   Use set('disabled', bool) instead.
			// tags:
			//		deprecated
			dojo.deprecated("dijit.Menu.setDisabled() is deprecated.  Use set('disabled', bool) instead.", "", "2.0");
			this.set('disabled', disabled);
		},
		_setDisabledAttr: function(/*Boolean*/ value){
			// summary:
			//		Hook for attr('disabled', ...) to work.
			//		Enable or disable this menu item.

			dijit.setWaiState(this.focusNode, 'disabled', value ? 'true' : 'false');
			this._set("disabled", value);
		},
		_setAccelKeyAttr: function(/*String*/ value){
			// summary:
			//		Hook for attr('accelKey', ...) to work.
			//		Set accelKey on this menu item.

			this.accelKeyNode.style.display=value?"":"none";
			this.accelKeyNode.innerHTML=value;
			//have to use colSpan to make it work in IE
			dojo.attr(this.containerNode,'colSpan',value?"1":"2");
			
			this._set("accelKey", value);
		}
	});

}

if(!dojo._hasResource["dijit.PopupMenuItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.PopupMenuItem"] = true;
dojo.provide("dijit.PopupMenuItem");



dojo.declare("dijit.PopupMenuItem",
		dijit.MenuItem,
		{
		_fillContent: function(){
			// summary:
			//		When Menu is declared in markup, this code gets the menu label and
			//		the popup widget from the srcNodeRef.
			// description:
			//		srcNodeRefinnerHTML contains both the menu item text and a popup widget
			//		The first part holds the menu item text and the second part is the popup
			// example:
			// |	<div dojoType="dijit.PopupMenuItem">
			// |		<span>pick me</span>
			// |		<popup> ... </popup>
			// |	</div>
			// tags:
			//		protected

			if(this.srcNodeRef){
				var nodes = dojo.query("*", this.srcNodeRef);
				dijit.PopupMenuItem.superclass._fillContent.call(this, nodes[0]);

				// save pointer to srcNode so we can grab the drop down widget after it's instantiated
				this.dropDownContainer = this.srcNodeRef;
			}
		},

		startup: function(){
			if(this._started){ return; }
			this.inherited(arguments);

			// we didn't copy the dropdown widget from the this.srcNodeRef, so it's in no-man's
			// land now.  move it to dojo.doc.body.
			if(!this.popup){
				var node = dojo.query("[widgetId]", this.dropDownContainer)[0];
				this.popup = dijit.byNode(node);
			}
			dojo.body().appendChild(this.popup.domNode);
			this.popup.startup();

			this.popup.domNode.style.display="none";
			if(this.arrowWrapper){
				dojo.style(this.arrowWrapper, "visibility", "");
			}
			dijit.setWaiState(this.focusNode, "haspopup", "true");
		},

		destroyDescendants: function(){
			if(this.popup){
				// Destroy the popup, unless it's already been destroyed.  This can happen because
				// the popup is a direct child of <body> even though it's logically my child.
				if(!this.popup._destroyed){
					this.popup.destroyRecursive();
				}
				delete this.popup;
			}
			this.inherited(arguments);
		}
	});

}

if(!dojo._hasResource["dijit.CheckedMenuItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.CheckedMenuItem"] = true;
dojo.provide("dijit.CheckedMenuItem");



dojo.declare("dijit.CheckedMenuItem",
		dijit.MenuItem,
		{
		// summary:
		//		A checkbox-like menu item for toggling on and off

		templateString: dojo.cache("dijit", "templates/CheckedMenuItem.html", "<tr class=\"dijitReset dijitMenuItem\" dojoAttachPoint=\"focusNode\" role=\"menuitemcheckbox\" tabIndex=\"-1\"\n\t\tdojoAttachEvent=\"onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick\">\n\t<td class=\"dijitReset dijitMenuItemIconCell\" role=\"presentation\">\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon dijitCheckedMenuItemIcon\" dojoAttachPoint=\"iconNode\"/>\n\t\t<span class=\"dijitCheckedMenuItemIconChar\">&#10003;</span>\n\t</td>\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\" dojoAttachPoint=\"containerNode,labelNode\"></td>\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" dojoAttachPoint=\"accelKeyNode\"></td>\n\t<td class=\"dijitReset dijitMenuArrowCell\" role=\"presentation\">&nbsp;</td>\n</tr>\n"),

		// checked: Boolean
		//		Our checked state
		checked: false,
		_setCheckedAttr: function(/*Boolean*/ checked){
			// summary:
			//		Hook so attr('checked', bool) works.
			//		Sets the class and state for the check box.
			dojo.toggleClass(this.domNode, "dijitCheckedMenuItemChecked", checked);
			dijit.setWaiState(this.domNode, "checked", checked);
			this._set("checked", checked);
		},

		onChange: function(/*Boolean*/ checked){
			// summary:
			//		User defined function to handle check/uncheck events
			// tags:
			//		callback
		},

		_onClick: function(/*Event*/ e){
			// summary:
			//		Clicking this item just toggles its state
			// tags:
			//		private
			if(!this.disabled){
				this.set("checked", !this.checked);
				this.onChange(this.checked);
			}
			this.inherited(arguments);
		}
	});

}

if(!dojo._hasResource["dijit.MenuSeparator"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.MenuSeparator"] = true;
dojo.provide("dijit.MenuSeparator");





dojo.declare("dijit.MenuSeparator",
		[dijit._Widget, dijit._Templated, dijit._Contained],
		{
		// summary:
		//		A line between two menu items

		templateString: dojo.cache("dijit", "templates/MenuSeparator.html", "<tr class=\"dijitMenuSeparator\">\n\t<td class=\"dijitMenuSeparatorIconCell\">\n\t\t<div class=\"dijitMenuSeparatorTop\"></div>\n\t\t<div class=\"dijitMenuSeparatorBottom\"></div>\n\t</td>\n\t<td colspan=\"3\" class=\"dijitMenuSeparatorLabelCell\">\n\t\t<div class=\"dijitMenuSeparatorTop dijitMenuSeparatorLabel\"></div>\n\t\t<div class=\"dijitMenuSeparatorBottom\"></div>\n\t</td>\n</tr>\n"),

		buildRendering: function(){
			this.inherited(arguments);
			dojo.setSelectable(this.domNode, false);
		},

		isFocusable: function(){
			// summary:
			//		Override to always return false
			// tags:
			//		protected

			return false; // Boolean
		}
	});

}

if(!dojo._hasResource["dijit.Menu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Menu"] = true;
dojo.provide("dijit.Menu");










// "dijit/MenuItem", "dijit/PopupMenuItem", "dijit/CheckedMenuItem", "dijit/MenuSeparator" for Back-compat (TODO: remove in 2.0)

dojo.declare("dijit._MenuBase",
	[dijit._Widget, dijit._Templated, dijit._KeyNavContainer],
{
	// summary:
	//		Base class for Menu and MenuBar

	// parentMenu: [readonly] Widget
	//		pointer to menu that displayed me
	parentMenu: null,

	// popupDelay: Integer
	//		number of milliseconds before hovering (without clicking) causes the popup to automatically open.
	popupDelay: 500,

	startup: function(){
		if(this._started){ return; }

		dojo.forEach(this.getChildren(), function(child){ child.startup(); });
		this.startupKeyNavChildren();

		this.inherited(arguments);
	},

	onExecute: function(){
		// summary:
		//		Attach point for notification about when a menu item has been executed.
		//		This is an internal mechanism used for Menus to signal to their parent to
		//		close them, because they are about to execute the onClick handler.   In
		//		general developers should not attach to or override this method.
		// tags:
		//		protected
	},

	onCancel: function(/*Boolean*/ closeAll){
		// summary:
		//		Attach point for notification about when the user cancels the current menu
		//		This is an internal mechanism used for Menus to signal to their parent to
		//		close them.  In general developers should not attach to or override this method.
		// tags:
		//		protected
	},

	_moveToPopup: function(/*Event*/ evt){
		// summary:
		//		This handles the right arrow key (left arrow key on RTL systems),
		//		which will either open a submenu, or move to the next item in the
		//		ancestor MenuBar
		// tags:
		//		private

		if(this.focusedChild && this.focusedChild.popup && !this.focusedChild.disabled){
			this.focusedChild._onClick(evt);
		}else{
			var topMenu = this._getTopMenu();
			if(topMenu && topMenu._isMenuBar){
				topMenu.focusNext();
			}
		}
	},

	_onPopupHover: function(/*Event*/ evt){
		// summary:
		//		This handler is called when the mouse moves over the popup.
		// tags:
		//		private

		// if the mouse hovers over a menu popup that is in pending-close state,
		// then stop the close operation.
		// This can't be done in onItemHover since some popup targets don't have MenuItems (e.g. ColorPicker)
		if(this.currentPopup && this.currentPopup._pendingClose_timer){
			var parentMenu = this.currentPopup.parentMenu;
			// highlight the parent menu item pointing to this popup
			if(parentMenu.focusedChild){
				parentMenu.focusedChild._setSelected(false);
			}
			parentMenu.focusedChild = this.currentPopup.from_item;
			parentMenu.focusedChild._setSelected(true);
			// cancel the pending close
			this._stopPendingCloseTimer(this.currentPopup);
		}
	},

	onItemHover: function(/*MenuItem*/ item){
		// summary:
		//		Called when cursor is over a MenuItem.
		// tags:
		//		protected

		// Don't do anything unless user has "activated" the menu by:
		//		1) clicking it
		//		2) opening it from a parent menu (which automatically focuses it)
		if(this.isActive){
			this.focusChild(item);
			if(this.focusedChild.popup && !this.focusedChild.disabled && !this.hover_timer){
				this.hover_timer = setTimeout(dojo.hitch(this, "_openPopup"), this.popupDelay);
			}
		}
		// if the user is mixing mouse and keyboard navigation,
		// then the menu may not be active but a menu item has focus,
		// but it's not the item that the mouse just hovered over.
		// To avoid both keyboard and mouse selections, use the latest.
		if(this.focusedChild){
			this.focusChild(item);
		}
		this._hoveredChild = item;
	},

	_onChildBlur: function(item){
		// summary:
		//		Called when a child MenuItem becomes inactive because focus
		//		has been removed from the MenuItem *and* it's descendant menus.
		// tags:
		//		private
		this._stopPopupTimer();
		item._setSelected(false);
		// Close all popups that are open and descendants of this menu
		var itemPopup = item.popup;
		if(itemPopup){
			this._stopPendingCloseTimer(itemPopup);
			itemPopup._pendingClose_timer = setTimeout(function(){
				itemPopup._pendingClose_timer = null;
				if(itemPopup.parentMenu){
					itemPopup.parentMenu.currentPopup = null;
				}
				dijit.popup.close(itemPopup); // this calls onClose
			}, this.popupDelay);
		}
	},

	onItemUnhover: function(/*MenuItem*/ item){
		// summary:
		//		Callback fires when mouse exits a MenuItem
		// tags:
		//		protected

		if(this.isActive){
			this._stopPopupTimer();
		}
		if(this._hoveredChild == item){ this._hoveredChild = null; }
	},

	_stopPopupTimer: function(){
		// summary:
		//		Cancels the popup timer because the user has stop hovering
		//		on the MenuItem, etc.
		// tags:
		//		private
		if(this.hover_timer){
			clearTimeout(this.hover_timer);
			this.hover_timer = null;
		}
	},

	_stopPendingCloseTimer: function(/*dijit._Widget*/ popup){
		// summary:
		//		Cancels the pending-close timer because the close has been preempted
		// tags:
		//		private
		if(popup._pendingClose_timer){
			clearTimeout(popup._pendingClose_timer);
			popup._pendingClose_timer = null;
		}
	},

	_stopFocusTimer: function(){
		// summary:
		//		Cancels the pending-focus timer because the menu was closed before focus occured
		// tags:
		//		private
		if(this._focus_timer){
			clearTimeout(this._focus_timer);
			this._focus_timer = null;
		}
	},

	_getTopMenu: function(){
		// summary:
		//		Returns the top menu in this chain of Menus
		// tags:
		//		private
		for(var top=this; top.parentMenu; top=top.parentMenu);
		return top;
	},

	onItemClick: function(/*dijit._Widget*/ item, /*Event*/ evt){
		// summary:
		//		Handle clicks on an item.
		// tags:
		//		private

		// this can't be done in _onFocus since the _onFocus events occurs asynchronously
		if(typeof this.isShowingNow == 'undefined'){ // non-popup menu
			this._markActive();
		}

		this.focusChild(item);

		if(item.disabled){ return false; }

		if(item.popup){
			this._openPopup();
		}else{
			// before calling user defined handler, close hierarchy of menus
			// and restore focus to place it was when menu was opened
			this.onExecute();

			// user defined handler for click
			item.onClick(evt);
		}
	},

	_openPopup: function(){
		// summary:
		//		Open the popup to the side of/underneath the current menu item
		// tags:
		//		protected

		this._stopPopupTimer();
		var from_item = this.focusedChild;
		if(!from_item){ return; } // the focused child lost focus since the timer was started
		var popup = from_item.popup;
		if(popup.isShowingNow){ return; }
		if(this.currentPopup){
			this._stopPendingCloseTimer(this.currentPopup);
			dijit.popup.close(this.currentPopup);
		}
		popup.parentMenu = this;
		popup.from_item = from_item; // helps finding the parent item that should be focused for this popup
		var self = this;
		dijit.popup.open({
			parent: this,
			popup: popup,
			around: from_item.domNode,
			orient: this._orient || (this.isLeftToRight() ?
									{'TR': 'TL', 'TL': 'TR', 'BR': 'BL', 'BL': 'BR'} :
									{'TL': 'TR', 'TR': 'TL', 'BL': 'BR', 'BR': 'BL'}),
			onCancel: function(){ // called when the child menu is canceled
				// set isActive=false (_closeChild vs _cleanUp) so that subsequent hovering will NOT open child menus
				// which seems aligned with the UX of most applications (e.g. notepad, wordpad, paint shop pro)
				self.focusChild(from_item);	// put focus back on my node
				self._cleanUp();			// close the submenu (be sure this is done _after_ focus is moved)
				from_item._setSelected(true); // oops, _cleanUp() deselected the item
				self.focusedChild = from_item;	// and unset focusedChild
			},
			onExecute: dojo.hitch(this, "_cleanUp")
		});

		this.currentPopup = popup;
		// detect mouseovers to handle lazy mouse movements that temporarily focus other menu items
		popup.connect(popup.domNode, "onmouseenter", dojo.hitch(self, "_onPopupHover")); // cleaned up when the popped-up widget is destroyed on close

		if(popup.focus){
			// If user is opening the popup via keyboard (right arrow, or down arrow for MenuBar),
			// if the cursor happens to collide with the popup, it will generate an onmouseover event
			// even though the mouse wasn't moved.   Use a setTimeout() to call popup.focus so that
			// our focus() call overrides the onmouseover event, rather than vice-versa.  (#8742)
			popup._focus_timer = setTimeout(dojo.hitch(popup, function(){
				this._focus_timer = null;
				this.focus();
			}), 0);
		}
	},

	_markActive: function(){
		// summary:
		//              Mark this menu's state as active.
		//		Called when this Menu gets focus from:
		//			1) clicking it (mouse or via space/arrow key)
		//			2) being opened by a parent menu.
		//		This is not called just from mouse hover.
		//		Focusing a menu via TAB does NOT automatically set isActive
		//		since TAB is a navigation operation and not a selection one.
		//		For Windows apps, pressing the ALT key focuses the menubar
		//		menus (similar to TAB navigation) but the menu is not active
		//		(ie no dropdown) until an item is clicked.
		this.isActive = true;
		dojo.replaceClass(this.domNode, "dijitMenuActive", "dijitMenuPassive");
	},

	onOpen: function(/*Event*/ e){
		// summary:
		//		Callback when this menu is opened.
		//		This is called by the popup manager as notification that the menu
		//		was opened.
		// tags:
		//		private

		this.isShowingNow = true;
		this._markActive();
	},

	_markInactive: function(){
		// summary:
		//		Mark this menu's state as inactive.
		this.isActive = false; // don't do this in _onBlur since the state is pending-close until we get here
		dojo.replaceClass(this.domNode, "dijitMenuPassive", "dijitMenuActive");
	},

	onClose: function(){
		// summary:
		//		Callback when this menu is closed.
		//		This is called by the popup manager as notification that the menu
		//		was closed.
		// tags:
		//		private

		this._stopFocusTimer();
		this._markInactive();
		this.isShowingNow = false;
		this.parentMenu = null;
	},

	_closeChild: function(){
		// summary:
		//		Called when submenu is clicked or focus is lost.  Close hierarchy of menus.
		// tags:
		//		private
		this._stopPopupTimer();

		var fromItem = this.focusedChild && this.focusedChild.from_item;

		if(this.currentPopup){
			// If focus is on my child menu then move focus to me,
			// because IE doesn't like it when you display:none a node with focus
			if(dijit._curFocus && dojo.isDescendant(dijit._curFocus, this.currentPopup.domNode)){
				this.focusedChild.focusNode.focus();
			}
			// Close all popups that are open and descendants of this menu
			dijit.popup.close(this.currentPopup);
			this.currentPopup = null;
		}

		if(this.focusedChild){ // unhighlight the focused item
			this.focusedChild._setSelected(false);
			this.focusedChild._onUnhover();
			this.focusedChild = null;
		}
	},

	_onItemFocus: function(/*MenuItem*/ item){
		// summary:
		//		Called when child of this Menu gets focus from:
		//			1) clicking it
		//			2) tabbing into it
		//			3) being opened by a parent menu.
		//		This is not called just from mouse hover.
		if(this._hoveredChild && this._hoveredChild != item){
			this._hoveredChild._onUnhover(); // any previous mouse movement is trumped by focus selection
		}
	},

	_onBlur: function(){
		// summary:
		//		Called when focus is moved away from this Menu and it's submenus.
		// tags:
		//		protected
		this._cleanUp();
		this.inherited(arguments);
	},

	_cleanUp: function(){
		// summary:
		//		Called when the user is done with this menu.  Closes hierarchy of menus.
		// tags:
		//		private

		this._closeChild(); // don't call this.onClose since that's incorrect for MenuBar's that never close
		if(typeof this.isShowingNow == 'undefined'){ // non-popup menu doesn't call onClose
			this._markInactive();
		}
	}
});

dojo.declare("dijit.Menu",
	dijit._MenuBase,
	{
	// summary
	//		A context menu you can assign to multiple elements

	// TODO: most of the code in here is just for context menu (right-click menu)
	// support.  In retrospect that should have been a separate class (dijit.ContextMenu).
	// Split them for 2.0

	constructor: function(){
		this._bindings = [];
	},

	templateString: dojo.cache("dijit", "templates/Menu.html", "<table class=\"dijit dijitMenu dijitMenuPassive dijitReset dijitMenuTable\" role=\"menu\" tabIndex=\"${tabIndex}\" dojoAttachEvent=\"onkeypress:_onKeyPress\" cellspacing=\"0\">\n\t<tbody class=\"dijitReset\" dojoAttachPoint=\"containerNode\"></tbody>\n</table>\n"),

	baseClass: "dijitMenu",

	// targetNodeIds: [const] String[]
	//		Array of dom node ids of nodes to attach to.
	//		Fill this with nodeIds upon widget creation and it becomes context menu for those nodes.
	targetNodeIds: [],

	// contextMenuForWindow: [const] Boolean
	//		If true, right clicking anywhere on the window will cause this context menu to open.
	//		If false, must specify targetNodeIds.
	contextMenuForWindow: false,

	// leftClickToOpen: [const] Boolean
	//		If true, menu will open on left click instead of right click, similiar to a file menu.
	leftClickToOpen: false,

	// refocus: Boolean
	// 		When this menu closes, re-focus the element which had focus before it was opened.
	refocus: true,

	postCreate: function(){
		if(this.contextMenuForWindow){
			this.bindDomNode(dojo.body());
		}else{
			// TODO: should have _setTargetNodeIds() method to handle initialization and a possible
			// later set('targetNodeIds', ...) call.   There's also a problem that targetNodeIds[]
			// gets stale after calls to bindDomNode()/unBindDomNode() as it still is just the original list (see #9610)
			dojo.forEach(this.targetNodeIds, this.bindDomNode, this);
		}
		var k = dojo.keys, l = this.isLeftToRight();
		this._openSubMenuKey = l ? k.RIGHT_ARROW : k.LEFT_ARROW;
		this._closeSubMenuKey = l ? k.LEFT_ARROW : k.RIGHT_ARROW;
		this.connectKeyNavHandlers([k.UP_ARROW], [k.DOWN_ARROW]);
	},

	_onKeyPress: function(/*Event*/ evt){
		// summary:
		//		Handle keyboard based menu navigation.
		// tags:
		//		protected

		if(evt.ctrlKey || evt.altKey){ return; }

		switch(evt.charOrCode){
			case this._openSubMenuKey:
				this._moveToPopup(evt);
				dojo.stopEvent(evt);
				break;
			case this._closeSubMenuKey:
				if(this.parentMenu){
					if(this.parentMenu._isMenuBar){
						this.parentMenu.focusPrev();
					}else{
						this.onCancel(false);
					}
				}else{
					dojo.stopEvent(evt);
				}
				break;
		}
	},

	// thanks burstlib!
	_iframeContentWindow: function(/* HTMLIFrameElement */iframe_el){
		// summary:
		//		Returns the window reference of the passed iframe
		// tags:
		//		private
		var win = dojo.window.get(this._iframeContentDocument(iframe_el)) ||
			// Moz. TODO: is this available when defaultView isn't?
			this._iframeContentDocument(iframe_el)['__parent__'] ||
			(iframe_el.name && dojo.doc.frames[iframe_el.name]) || null;
		return win;	//	Window
	},

	_iframeContentDocument: function(/* HTMLIFrameElement */iframe_el){
		// summary:
		//		Returns a reference to the document object inside iframe_el
		// tags:
		//		protected
		var doc = iframe_el.contentDocument // W3
			|| (iframe_el.contentWindow && iframe_el.contentWindow.document) // IE
			|| (iframe_el.name && dojo.doc.frames[iframe_el.name] && dojo.doc.frames[iframe_el.name].document)
			|| null;
		return doc;	//	HTMLDocument
	},

	bindDomNode: function(/*String|DomNode*/ node){
		// summary:
		//		Attach menu to given node
		node = dojo.byId(node);

		var cn;	// Connect node

		// Support context menus on iframes.   Rather than binding to the iframe itself we need
		// to bind to the <body> node inside the iframe.
		if(node.tagName.toLowerCase() == "iframe"){
			var iframe = node,
				win = this._iframeContentWindow(iframe);
			cn = dojo.withGlobal(win, dojo.body);
		}else{
			
			// To capture these events at the top level, attach to <html>, not <body>.
			// Otherwise right-click context menu just doesn't work.
			cn = (node == dojo.body() ? dojo.doc.documentElement : node);
		}


		// "binding" is the object to track our connection to the node (ie, the parameter to bindDomNode())
		var binding = {
			node: node,
			iframe: iframe
		};

		// Save info about binding in _bindings[], and make node itself record index(+1) into
		// _bindings[] array.   Prefix w/_dijitMenu to avoid setting an attribute that may
		// start with a number, which fails on FF/safari.
		dojo.attr(node, "_dijitMenu" + this.id, this._bindings.push(binding));

		// Setup the connections to monitor click etc., unless we are connecting to an iframe which hasn't finished
		// loading yet, in which case we need to wait for the onload event first, and then connect
		// On linux Shift-F10 produces the oncontextmenu event, but on Windows it doesn't, so
		// we need to monitor keyboard events in addition to the oncontextmenu event.
		var doConnects = dojo.hitch(this, function(cn){
			return [
				// TODO: when leftClickToOpen is true then shouldn't space/enter key trigger the menu,
				// rather than shift-F10?
				dojo.connect(cn, this.leftClickToOpen ? "onclick" : "oncontextmenu", this, function(evt){
					// Schedule context menu to be opened unless it's already been scheduled from onkeydown handler
					dojo.stopEvent(evt);
					this._scheduleOpen(evt.target, iframe, {x: evt.pageX, y: evt.pageY});
				}),
				dojo.connect(cn, "onkeydown", this, function(evt){
					if(evt.shiftKey && evt.keyCode == dojo.keys.F10){
						dojo.stopEvent(evt);
						this._scheduleOpen(evt.target, iframe);	// no coords - open near target node
					}
				})
			];
		});
		binding.connects = cn ? doConnects(cn) : [];

		if(iframe){
			// Setup handler to [re]bind to the iframe when the contents are initially loaded,
			// and every time the contents change.
			// Need to do this b/c we are actually binding to the iframe's <body> node.
			// Note: can't use dojo.connect(), see #9609.

			binding.onloadHandler = dojo.hitch(this, function(){
				// want to remove old connections, but IE throws exceptions when trying to
				// access the <body> node because it's already gone, or at least in a state of limbo

				var win = this._iframeContentWindow(iframe);
					cn = dojo.withGlobal(win, dojo.body);
				binding.connects = doConnects(cn);
			});
			if(iframe.addEventListener){
				iframe.addEventListener("load", binding.onloadHandler, false);
			}else{
				iframe.attachEvent("onload", binding.onloadHandler);
			}
		}
	},

	unBindDomNode: function(/*String|DomNode*/ nodeName){
		// summary:
		//		Detach menu from given node

		var node;
		try{
			node = dojo.byId(nodeName);
		}catch(e){
			// On IE the dojo.byId() call will get an exception if the attach point was
			// the <body> node of an <iframe> that has since been reloaded (and thus the
			// <body> node is in a limbo state of destruction.
			return;
		}

		// node["_dijitMenu" + this.id] contains index(+1) into my _bindings[] array
		var attrName = "_dijitMenu" + this.id;
		if(node && dojo.hasAttr(node, attrName)){
			var bid = dojo.attr(node, attrName)-1, b = this._bindings[bid];
			dojo.forEach(b.connects, dojo.disconnect);

			// Remove listener for iframe onload events
			var iframe = b.iframe;
			if(iframe){
				if(iframe.removeEventListener){
					iframe.removeEventListener("load", b.onloadHandler, false);
				}else{
					iframe.detachEvent("onload", b.onloadHandler);
				}
			}

			dojo.removeAttr(node, attrName);
			delete this._bindings[bid];
		}
	},

	_scheduleOpen: function(/*DomNode?*/ target, /*DomNode?*/ iframe, /*Object?*/ coords){
		// summary:
		//		Set timer to display myself.  Using a timer rather than displaying immediately solves
		//		two problems:
		//
		//		1. IE: without the delay, focus work in "open" causes the system
		//		context menu to appear in spite of stopEvent.
		//
		//		2. Avoid double-shows on linux, where shift-F10 generates an oncontextmenu event
		//		even after a dojo.stopEvent(e).  (Shift-F10 on windows doesn't generate the
		//		oncontextmenu event.)

		if(!this._openTimer){
			this._openTimer = setTimeout(dojo.hitch(this, function(){
				delete this._openTimer;
				this._openMyself({
					target: target,
					iframe: iframe,
					coords: coords
				});
			}), 1);
		}
	},

	_openMyself: function(args){
		// summary:
		//		Internal function for opening myself when the user does a right-click or something similar.
		// args:
		//		This is an Object containing:
		//		* target:
		//			The node that is being clicked
		//		* iframe:
		//			If an <iframe> is being clicked, iframe points to that iframe
		//		* coords:
		//			Put menu at specified x/y position in viewport, or if iframe is
		//			specified, then relative to iframe.
		//
		//		_openMyself() formerly took the event object, and since various code references
		//		evt.target (after connecting to _openMyself()), using an Object for parameters
		//		(so that old code still works).

		var target = args.target,
			iframe = args.iframe,
			coords = args.coords;

		// Get coordinates to open menu, either at specified (mouse) position or (if triggered via keyboard)
		// then near the node the menu is assigned to.
		if(coords){
			if(iframe){
				// Specified coordinates are on <body> node of an <iframe>, convert to match main document
				var od = target.ownerDocument,
					ifc = dojo.position(iframe, true),
					win = this._iframeContentWindow(iframe),
					scroll = dojo.withGlobal(win, "_docScroll", dojo);
	
				var cs = dojo.getComputedStyle(iframe),
					tp = dojo._toPixelValue,
					left = (dojo.isIE && dojo.isQuirks ? 0 : tp(iframe, cs.paddingLeft)) + (dojo.isIE && dojo.isQuirks ? tp(iframe, cs.borderLeftWidth) : 0),
					top = (dojo.isIE && dojo.isQuirks ? 0 : tp(iframe, cs.paddingTop)) + (dojo.isIE && dojo.isQuirks ? tp(iframe, cs.borderTopWidth) : 0);

				coords.x += ifc.x + left - scroll.x;
				coords.y += ifc.y + top - scroll.y;
			}
		}else{
			coords = dojo.position(target, true);
			coords.x += 10;
			coords.y += 10;
		}

		var self=this;
		var savedFocus = dijit.getFocus(this);
		function closeAndRestoreFocus(){
			// user has clicked on a menu or popup
			if(self.refocus){
				dijit.focus(savedFocus);
			}
			dijit.popup.close(self);
		}
		dijit.popup.open({
			popup: this,
			x: coords.x,
			y: coords.y,
			onExecute: closeAndRestoreFocus,
			onCancel: closeAndRestoreFocus,
			orient: this.isLeftToRight() ? 'L' : 'R'
		});
		this.focus();

		this._onBlur = function(){
			this.inherited('_onBlur', arguments);
			// Usually the parent closes the child widget but if this is a context
			// menu then there is no parent
			dijit.popup.close(this);
			// don't try to restore focus; user has clicked another part of the screen
			// and set focus there
		};
	},

	uninitialize: function(){
 		dojo.forEach(this._bindings, function(b){ if(b){ this.unBindDomNode(b.node); } }, this);
 		this.inherited(arguments);
	}
}
);

}

if(!dojo._hasResource["dijit.form.HorizontalSlider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.HorizontalSlider"] = true;
dojo.provide("dijit.form.HorizontalSlider");







dojo.declare(
	"dijit.form.HorizontalSlider",
	[dijit.form._FormValueWidget, dijit._Container],
{
	// summary:
	//		A form widget that allows one to select a value with a horizontally draggable handle

	templateString: dojo.cache("dijit.form", "templates/HorizontalSlider.html", "<table class=\"dijit dijitReset dijitSlider dijitSliderH\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" rules=\"none\" dojoAttachEvent=\"onkeypress:_onKeyPress,onkeyup:_onKeyUp\"\n\trole=\"presentation\"\n\t><tr class=\"dijitReset\"\n\t\t><td class=\"dijitReset\" colspan=\"2\"></td\n\t\t><td dojoAttachPoint=\"topDecoration\" class=\"dijitReset dijitSliderDecoration dijitSliderDecorationT dijitSliderDecorationH\"></td\n\t\t><td class=\"dijitReset\" colspan=\"2\"></td\n\t></tr\n\t><tr class=\"dijitReset\"\n\t\t><td class=\"dijitReset dijitSliderButtonContainer dijitSliderButtonContainerH\"\n\t\t\t><div class=\"dijitSliderDecrementIconH\" style=\"display:none\" dojoAttachPoint=\"decrementButton\"><span class=\"dijitSliderButtonInner\">-</span></div\n\t\t></td\n\t\t><td class=\"dijitReset\"\n\t\t\t><div class=\"dijitSliderBar dijitSliderBumper dijitSliderBumperH dijitSliderLeftBumper\" dojoAttachEvent=\"onmousedown:_onClkDecBumper\"></div\n\t\t></td\n\t\t><td class=\"dijitReset\"\n\t\t\t><input dojoAttachPoint=\"valueNode\" type=\"hidden\" ${!nameAttrSetting}\n\t\t\t/><div class=\"dijitReset dijitSliderBarContainerH\" role=\"presentation\" dojoAttachPoint=\"sliderBarContainer\"\n\t\t\t\t><div role=\"presentation\" dojoAttachPoint=\"progressBar\" class=\"dijitSliderBar dijitSliderBarH dijitSliderProgressBar dijitSliderProgressBarH\" dojoAttachEvent=\"onmousedown:_onBarClick\"\n\t\t\t\t\t><div class=\"dijitSliderMoveable dijitSliderMoveableH\"\n\t\t\t\t\t\t><div dojoAttachPoint=\"sliderHandle,focusNode\" class=\"dijitSliderImageHandle dijitSliderImageHandleH\" dojoAttachEvent=\"onmousedown:_onHandleClick\" role=\"slider\" valuemin=\"${minimum}\" valuemax=\"${maximum}\"></div\n\t\t\t\t\t></div\n\t\t\t\t></div\n\t\t\t\t><div role=\"presentation\" dojoAttachPoint=\"remainingBar\" class=\"dijitSliderBar dijitSliderBarH dijitSliderRemainingBar dijitSliderRemainingBarH\" dojoAttachEvent=\"onmousedown:_onBarClick\"></div\n\t\t\t></div\n\t\t></td\n\t\t><td class=\"dijitReset\"\n\t\t\t><div class=\"dijitSliderBar dijitSliderBumper dijitSliderBumperH dijitSliderRightBumper\" dojoAttachEvent=\"onmousedown:_onClkIncBumper\"></div\n\t\t></td\n\t\t><td class=\"dijitReset dijitSliderButtonContainer dijitSliderButtonContainerH\"\n\t\t\t><div class=\"dijitSliderIncrementIconH\" style=\"display:none\" dojoAttachPoint=\"incrementButton\"><span class=\"dijitSliderButtonInner\">+</span></div\n\t\t></td\n\t></tr\n\t><tr class=\"dijitReset\"\n\t\t><td class=\"dijitReset\" colspan=\"2\"></td\n\t\t><td dojoAttachPoint=\"containerNode,bottomDecoration\" class=\"dijitReset dijitSliderDecoration dijitSliderDecorationB dijitSliderDecorationH\"></td\n\t\t><td class=\"dijitReset\" colspan=\"2\"></td\n\t></tr\n></table>\n"),

	// Overrides FormValueWidget.value to indicate numeric value
	value: 0,

	// showButtons: [const] Boolean
	//		Show increment/decrement buttons at the ends of the slider?
	showButtons: true,

	// minimum:: [const] Integer
	//		The minimum value the slider can be set to.
	minimum: 0,

	// maximum: [const] Integer
	//		The maximum value the slider can be set to.
	maximum: 100,

	// discreteValues: Integer
	//		If specified, indicates that the slider handle has only 'discreteValues' possible positions,
	//		and that after dragging the handle, it will snap to the nearest possible position.
	//		Thus, the slider has only 'discreteValues' possible values.
	//
	//		For example, if minimum=10, maxiumum=30, and discreteValues=3, then the slider handle has
	//		three possible positions, representing values 10, 20, or 30.
	//
	//		If discreteValues is not specified or if it's value is higher than the number of pixels
	//		in the slider bar, then the slider handle can be moved freely, and the slider's value will be
	//		computed/reported based on pixel position (in this case it will likely be fractional,
	//		such as 123.456789).
	discreteValues: Infinity,

	// pageIncrement: Integer
	//		If discreteValues is also specified, this indicates the amount of clicks (ie, snap positions)
	//		that the slider handle is moved via pageup/pagedown keys.
	//		If discreteValues is not specified, it indicates the number of pixels.
	pageIncrement: 2,

	// clickSelect: Boolean
	//		If clicking the slider bar changes the value or not
	clickSelect: true,

	// slideDuration: Number
	//		The time in ms to take to animate the slider handle from 0% to 100%,
	//		when clicking the slider bar to make the handle move.
	slideDuration: dijit.defaultDuration,

	// Flag to _Templated  (TODO: why is this here?  I see no widgets in the template.)
	widgetsInTemplate: true,

	attributeMap: dojo.delegate(dijit.form._FormWidget.prototype.attributeMap, {
		id: ""
	}),

	baseClass: "dijitSlider",

	// Apply CSS classes to up/down arrows and handle per mouse state
	cssStateNodes: {
		incrementButton: "dijitSliderIncrementButton",
		decrementButton: "dijitSliderDecrementButton",
		focusNode: "dijitSliderThumb"
	},

	_mousePixelCoord: "pageX",
	_pixelCount: "w",
	_startingPixelCoord: "x",
	_startingPixelCount: "l",
	_handleOffsetCoord: "left",
	_progressPixelSize: "width",

	_onKeyUp: function(/*Event*/ e){
		if(this.disabled || this.readOnly || e.altKey || e.ctrlKey || e.metaKey){ return; }
		this._setValueAttr(this.value, true);
	},

	_onKeyPress: function(/*Event*/ e){
		if(this.disabled || this.readOnly || e.altKey || e.ctrlKey || e.metaKey){ return; }
		switch(e.charOrCode){
			case dojo.keys.HOME:
				this._setValueAttr(this.minimum, false);
				break;
			case dojo.keys.END:
				this._setValueAttr(this.maximum, false);
				break;
			// this._descending === false: if ascending vertical (min on top)
			// (this._descending || this.isLeftToRight()): if left-to-right horizontal or descending vertical
			case ((this._descending || this.isLeftToRight()) ? dojo.keys.RIGHT_ARROW : dojo.keys.LEFT_ARROW):
			case (this._descending === false ? dojo.keys.DOWN_ARROW : dojo.keys.UP_ARROW):
			case (this._descending === false ? dojo.keys.PAGE_DOWN : dojo.keys.PAGE_UP):
				this.increment(e);
				break;
			case ((this._descending || this.isLeftToRight()) ? dojo.keys.LEFT_ARROW : dojo.keys.RIGHT_ARROW):
			case (this._descending === false ? dojo.keys.UP_ARROW : dojo.keys.DOWN_ARROW):
			case (this._descending === false ? dojo.keys.PAGE_UP : dojo.keys.PAGE_DOWN):
				this.decrement(e);
				break;
			default:
				return;
		}
		dojo.stopEvent(e);
	},

	_onHandleClick: function(e){
		if(this.disabled || this.readOnly){ return; }
		if(!dojo.isIE){
			// make sure you get focus when dragging the handle
			// (but don't do on IE because it causes a flicker on mouse up (due to blur then focus)
			dijit.focus(this.sliderHandle);
		}
		dojo.stopEvent(e);
	},

	_isReversed: function(){
		// summary:
		//		Returns true if direction is from right to left
		// tags:
		//		protected extension
		return !this.isLeftToRight();
	},

	_onBarClick: function(e){
		if(this.disabled || this.readOnly || !this.clickSelect){ return; }
		dijit.focus(this.sliderHandle);
		dojo.stopEvent(e);
		var abspos = dojo.position(this.sliderBarContainer, true);
		var pixelValue = e[this._mousePixelCoord] - abspos[this._startingPixelCoord];
		this._setPixelValue(this._isReversed() ? (abspos[this._pixelCount] - pixelValue) : pixelValue, abspos[this._pixelCount], true);
		this._movable.onMouseDown(e);
	},

	_setPixelValue: function(/*Number*/ pixelValue, /*Number*/ maxPixels, /*Boolean?*/ priorityChange){
		if(this.disabled || this.readOnly){ return; }
		pixelValue = pixelValue < 0 ? 0 : maxPixels < pixelValue ? maxPixels : pixelValue;
		var count = this.discreteValues;
		if(count <= 1 || count == Infinity){ count = maxPixels; }
		count--;
		var pixelsPerValue = maxPixels / count;
		var wholeIncrements = Math.round(pixelValue / pixelsPerValue);
		this._setValueAttr((this.maximum-this.minimum)*wholeIncrements/count + this.minimum, priorityChange);
	},

	_setValueAttr: function(/*Number*/ value, /*Boolean?*/ priorityChange){
		// summary:
		//		Hook so set('value', value) works.
		this._set("value", value);
		this.valueNode.value = value;
		dijit.setWaiState(this.focusNode, "valuenow", value);
		this.inherited(arguments);
		var percent = (value - this.minimum) / (this.maximum - this.minimum);
		var progressBar = (this._descending === false) ? this.remainingBar : this.progressBar;
		var remainingBar = (this._descending === false) ? this.progressBar : this.remainingBar;
		if(this._inProgressAnim && this._inProgressAnim.status != "stopped"){
			this._inProgressAnim.stop(true);
		}
		if(priorityChange && this.slideDuration > 0 && progressBar.style[this._progressPixelSize]){
			// animate the slider
			var _this = this;
			var props = {};
			var start = parseFloat(progressBar.style[this._progressPixelSize]);
			var duration = this.slideDuration * (percent-start/100);
			if(duration == 0){ return; }
			if(duration < 0){ duration = 0 - duration; }
			props[this._progressPixelSize] = { start: start, end: percent*100, units:"%" };
			this._inProgressAnim = dojo.animateProperty({ node: progressBar, duration: duration,
				onAnimate: function(v){ remainingBar.style[_this._progressPixelSize] = (100-parseFloat(v[_this._progressPixelSize])) + "%"; },
				onEnd: function(){ delete _this._inProgressAnim; },
				properties: props
			})
			this._inProgressAnim.play();
		}else{
			progressBar.style[this._progressPixelSize] = (percent*100) + "%";
			remainingBar.style[this._progressPixelSize] = ((1-percent)*100) + "%";
		}
	},

	_bumpValue: function(signedChange, /*Boolean?*/ priorityChange){
		if(this.disabled || this.readOnly){ return; }
		var s = dojo.getComputedStyle(this.sliderBarContainer);
		var c = dojo._getContentBox(this.sliderBarContainer, s);
		var count = this.discreteValues;
		if(count <= 1 || count == Infinity){ count = c[this._pixelCount]; }
		count--;
		var value = (this.value - this.minimum) * count / (this.maximum - this.minimum) + signedChange;
		if(value < 0){ value = 0; }
		if(value > count){ value = count; }
		value = value * (this.maximum - this.minimum) / count + this.minimum;
		this._setValueAttr(value, priorityChange);
	},

	_onClkBumper: function(val){
		if(this.disabled || this.readOnly || !this.clickSelect){ return; }
		this._setValueAttr(val, true);
	},

	_onClkIncBumper: function(){
		this._onClkBumper(this._descending === false ? this.minimum : this.maximum);
	},

	_onClkDecBumper: function(){
		this._onClkBumper(this._descending === false ? this.maximum : this.minimum);
	},

	decrement: function(/*Event*/ e){
		// summary:
		//		Decrement slider
		// tags:
		//		private
		this._bumpValue(e.charOrCode == dojo.keys.PAGE_DOWN ? -this.pageIncrement : -1);
	},

	increment: function(/*Event*/ e){
		// summary:
		//		Increment slider
		// tags:
		//		private
		this._bumpValue(e.charOrCode == dojo.keys.PAGE_UP ? this.pageIncrement : 1);
	},

	_mouseWheeled: function(/*Event*/ evt){
		// summary:
		//		Event handler for mousewheel where supported
		dojo.stopEvent(evt);
		var janky = !dojo.isMozilla;
		var scroll = evt[(janky ? "wheelDelta" : "detail")] * (janky ? 1 : -1);
		this._bumpValue(scroll < 0 ? -1 : 1, true); // negative scroll acts like a decrement
	},

	startup: function(){
		if(this._started){ return; }

		dojo.forEach(this.getChildren(), function(child){
			if(this[child.container] != this.containerNode){
				this[child.container].appendChild(child.domNode);
			}
		}, this);

		this.inherited(arguments);
	},

	_typematicCallback: function(/*Number*/ count, /*Object*/ button, /*Event*/ e){
		if(count == -1){
			this._setValueAttr(this.value, true);
		}else{
			this[(button == (this._descending? this.incrementButton : this.decrementButton)) ? "decrement" : "increment"](e);
		}
	},

	buildRendering: function(){
		this.inherited(arguments);
		if(this.showButtons){
			this.incrementButton.style.display="";
			this.decrementButton.style.display="";
		}

		// find any associated label element and add to slider focusnode.
		var label = dojo.query('label[for="'+this.id+'"]');
		if(label.length){
			label[0].id = (this.id+"_label");
			dijit.setWaiState(this.focusNode, "labelledby", label[0].id);
		}

		dijit.setWaiState(this.focusNode, "valuemin", this.minimum);
		dijit.setWaiState(this.focusNode, "valuemax", this.maximum);
	},

	postCreate: function(){
		this.inherited(arguments);

		if(this.showButtons){
			this._connects.push(dijit.typematic.addMouseListener(
				this.decrementButton, this, "_typematicCallback", 25, 500));
			this._connects.push(dijit.typematic.addMouseListener(
				this.incrementButton, this, "_typematicCallback", 25, 500));
		}
		this.connect(this.domNode, !dojo.isMozilla ? "onmousewheel" : "DOMMouseScroll", "_mouseWheeled");

		// define a custom constructor for a SliderMover that points back to me
		var mover = dojo.declare(dijit.form._SliderMover, {
			widget: this
		});
		this._movable = new dojo.dnd.Moveable(this.sliderHandle, {mover: mover});

		this._layoutHackIE7();
	},

	destroy: function(){
		this._movable.destroy();
		if(this._inProgressAnim && this._inProgressAnim.status != "stopped"){
			this._inProgressAnim.stop(true);
		}
		this._supportingWidgets = dijit.findWidgets(this.domNode); // tells destroy about pseudo-child widgets (ruler/labels)
		this.inherited(arguments);
	}
});

dojo.declare("dijit.form._SliderMover",
	dojo.dnd.Mover,
{
	onMouseMove: function(e){
		var widget = this.widget;
		var abspos = widget._abspos;
		if(!abspos){
			abspos = widget._abspos = dojo.position(widget.sliderBarContainer, true);
			widget._setPixelValue_ = dojo.hitch(widget, "_setPixelValue");
			widget._isReversed_ = widget._isReversed();
		}
		var coordEvent = e.touches ? e.touches[0] : e, // if multitouch take first touch for coords
			pixelValue = coordEvent[widget._mousePixelCoord] - abspos[widget._startingPixelCoord];
		widget._setPixelValue_(widget._isReversed_ ? (abspos[widget._pixelCount]-pixelValue) : pixelValue, abspos[widget._pixelCount], false);
	},

	destroy: function(e){
		dojo.dnd.Mover.prototype.destroy.apply(this, arguments);
		var widget = this.widget;
		widget._abspos = null;
		widget._setValueAttr(widget.value, true);
	}
});

}

if(!dojo._hasResource["dojox.collections._base"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.collections._base"] = true;
dojo.provide("dojox.collections._base");

dojox.collections.DictionaryEntry=function(/* string */k, /* object */v){
	//	summary
	//	return an object of type dojox.collections.DictionaryEntry
	this.key=k;
	this.value=v;
	this.valueOf=function(){
		return this.value; 	//	object
	};
	this.toString=function(){
		return String(this.value);	//	string
	};
}

/*	Iterators
 *	The collections.Iterators (Iterator and DictionaryIterator) are built to
 *	work with the Collections included in this module.  However, they *can*
 *	be used with arrays and objects, respectively, should one choose to do so.
 */
dojox.collections.Iterator=function(/* array */arr){
	//	summary
	//	return an object of type dojox.collections.Iterator
	var a=arr;
	var position=0;
	this.element=a[position]||null;
	this.atEnd=function(){
		//	summary
		//	Test to see if the internal cursor has reached the end of the internal collection.
		return (position>=a.length);	//	bool
	};
	this.get=function(){
		//	summary
		//	Get the next member in the collection.
		if(this.atEnd()){
			return null;		//	object
		}
		this.element=a[position++];
		return this.element;	//	object
	};
	this.map=function(/* function */fn, /* object? */scope){
		//	summary
		//	Functional iteration with optional scope.
		return dojo.map(a, fn, scope);
	};
	this.reset=function(){
		//	summary
		//	reset the internal cursor.
		position=0;
		this.element=a[position];
	};
}

/*	Notes:
 *	The DictionaryIterator no longer supports a key and value property;
 *	the reality is that you can use this to iterate over a JS object
 *	being used as a hashtable.
 */
dojox.collections.DictionaryIterator=function(/* object */obj){
	//	summary
	//	return an object of type dojox.collections.DictionaryIterator
	var a=[];	//	Create an indexing array
	var testObject={};
	for(var p in obj){
		if(!testObject[p]){
			a.push(obj[p]);	//	fill it up
		}
	}
	var position=0;
	this.element=a[position]||null;
	this.atEnd=function(){
		//	summary
		//	Test to see if the internal cursor has reached the end of the internal collection.
		return (position>=a.length);	//	bool
	};
	this.get=function(){
		//	summary
		//	Get the next member in the collection.
		if(this.atEnd()){
			return null;		//	object
		}
		this.element=a[position++];
		return this.element;	//	object
	};
	this.map=function(/* function */fn, /* object? */scope){
		//	summary
		//	Functional iteration with optional scope.
		return dojo.map(a, fn, scope);
	};
	this.reset=function() {
		//	summary
		//	reset the internal cursor.
		position=0;
		this.element=a[position];
	};
};

}

if(!dojo._hasResource["dojox.collections.Dictionary"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.collections.Dictionary"] = true;
dojo.provide("dojox.collections.Dictionary");


dojox.collections.Dictionary=function(/* dojox.collections.Dictionary? */dictionary){
	//	summary
	//	Returns an object of type dojox.collections.Dictionary
	var items={};
	this.count=0;

	//	comparator for property addition and access.
	var testObject={};

	this.add=function(/* string */k, /* object */v){
		//	summary
		//	Add a new item to the Dictionary.
		var b=(k in items);
		items[k]=new dojox.collections.DictionaryEntry(k,v);
		if(!b){
			this.count++;
		}
	};
	this.clear=function(){
		//	summary
		//	Clears the internal dictionary.
		items={};
		this.count=0;
	};
	this.clone=function(){
		//	summary
		//	Returns a new instance of dojox.collections.Dictionary; note the the dictionary is a clone but items might not be.
		return new dojox.collections.Dictionary(this);	//	dojox.collections.Dictionary
	};
	this.contains=this.containsKey=function(/* string */k){
		//	summary
		//	Check to see if the dictionary has an entry at key "k".
		if(testObject[k]){
			return false;			// bool
		}
		return (items[k]!=null);	//	bool
	};
	this.containsValue=function(/* object */v){
		//	summary
		//	Check to see if the dictionary has an entry with value "v".
		var e=this.getIterator();
		while(e.get()){
			if(e.element.value==v){
				return true;	//	bool
			}
		}
		return false;	//	bool
	};
	this.entry=function(/* string */k){
		//	summary
		//	Accessor method; similar to dojox.collections.Dictionary.item but returns the actual Entry object.
		return items[k];	//	dojox.collections.DictionaryEntry
	};
	this.forEach=function(/* function */ fn, /* object? */ scope){
		//	summary
		//	functional iterator, following the mozilla spec.
		var a=[];	//	Create an indexing array
		for(var p in items) {
			if(!testObject[p]){
				a.push(items[p]);	//	fill it up
			}
		}
		dojo.forEach(a, fn, scope);
	};
	this.getKeyList=function(){
		//	summary
		//	Returns an array of the keys in the dictionary.
		return (this.getIterator()).map(function(entry){
			return entry.key;
		});	//	array
	};
	this.getValueList=function(){
		//	summary
		//	Returns an array of the values in the dictionary.
		return (this.getIterator()).map(function(entry){
			return entry.value;
		});	//	array
	};
	this.item=function(/* string */k){
		//	summary
		//	Accessor method.
		if(k in items){
			return items[k].valueOf();	//	object
		}
		return undefined;	//	object
	};
	this.getIterator=function(){
		//	summary
		//	Gets a dojox.collections.DictionaryIterator for iteration purposes.
		return new dojox.collections.DictionaryIterator(items);	//	dojox.collections.DictionaryIterator
	};
	this.remove=function(/* string */k){
		//	summary
		//	Removes the item at k from the internal collection.
		if(k in items && !testObject[k]){
			delete items[k];
			this.count--;
			return true;	//	bool
		}
		return false;	//	bool
	};

	if (dictionary){
		var e=dictionary.getIterator();
		while(e.get()) {
			 this.add(e.element.key, e.element.value);
		}
	}
};

}

if(!dojo._hasResource["dojox.gfx.matrix"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.gfx.matrix"] = true;
dojo.provide("dojox.gfx.matrix");

(function(){
	var m = dojox.gfx.matrix;

	// candidates for dojox.math:
	var _degToRadCache = {};
	m._degToRad = function(degree){
		return _degToRadCache[degree] || (_degToRadCache[degree] = (Math.PI * degree / 180));
	};
	m._radToDeg = function(radian){ return radian / Math.PI * 180; };

	m.Matrix2D = function(arg){
		// summary: a 2D matrix object
		// description: Normalizes a 2D matrix-like object. If arrays is passed,
		//		all objects of the array are normalized and multiplied sequentially.
		// arg: Object
		//		a 2D matrix-like object, a number, or an array of such objects
		if(arg){
			if(typeof arg == "number"){
				this.xx = this.yy = arg;
			}else if(arg instanceof Array){
				if(arg.length > 0){
					var matrix = m.normalize(arg[0]);
					// combine matrices
					for(var i = 1; i < arg.length; ++i){
						var l = matrix, r = dojox.gfx.matrix.normalize(arg[i]);
						matrix = new m.Matrix2D();
						matrix.xx = l.xx * r.xx + l.xy * r.yx;
						matrix.xy = l.xx * r.xy + l.xy * r.yy;
						matrix.yx = l.yx * r.xx + l.yy * r.yx;
						matrix.yy = l.yx * r.xy + l.yy * r.yy;
						matrix.dx = l.xx * r.dx + l.xy * r.dy + l.dx;
						matrix.dy = l.yx * r.dx + l.yy * r.dy + l.dy;
					}
					dojo.mixin(this, matrix);
				}
			}else{
				dojo.mixin(this, arg);
			}
		}
	};

	// the default (identity) matrix, which is used to fill in missing values
	dojo.extend(m.Matrix2D, {xx: 1, xy: 0, yx: 0, yy: 1, dx: 0, dy: 0});

	dojo.mixin(m, {
		// summary: class constants, and methods of dojox.gfx.matrix

		// matrix constants

		// identity: dojox.gfx.matrix.Matrix2D
		//		an identity matrix constant: identity * (x, y) == (x, y)
		identity: new m.Matrix2D(),

		// flipX: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at x = 0 line: flipX * (x, y) == (-x, y)
		flipX:    new m.Matrix2D({xx: -1}),

		// flipY: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at y = 0 line: flipY * (x, y) == (x, -y)
		flipY:    new m.Matrix2D({yy: -1}),

		// flipXY: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at the origin of coordinates: flipXY * (x, y) == (-x, -y)
		flipXY:   new m.Matrix2D({xx: -1, yy: -1}),

		// matrix creators

		translate: function(a, b){
			// summary: forms a translation matrix
			// description: The resulting matrix is used to translate (move) points by specified offsets.
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value
			if(arguments.length > 1){
				return new m.Matrix2D({dx: a, dy: b}); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: dojox.gfx.Point: a point-like object, which specifies offsets for both dimensions
			// b: null
			return new m.Matrix2D({dx: a.x, dy: a.y}); // dojox.gfx.matrix.Matrix2D
		},
		scale: function(a, b){
			// summary: forms a scaling matrix
			// description: The resulting matrix is used to scale (magnify) points by specified offsets.
			// a: Number: a scaling factor used for the x coordinate
			// b: Number: a scaling factor used for the y coordinate
			if(arguments.length > 1){
				return new m.Matrix2D({xx: a, yy: b}); // dojox.gfx.matrix.Matrix2D
			}
			if(typeof a == "number"){
				// branch
				// a: Number: a uniform scaling factor used for the both coordinates
				// b: null
				return new m.Matrix2D({xx: a, yy: a}); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: dojox.gfx.Point: a point-like object, which specifies scale factors for both dimensions
			// b: null
			return new m.Matrix2D({xx: a.x, yy: a.y}); // dojox.gfx.matrix.Matrix2D
		},
		rotate: function(angle){
			// summary: forms a rotating matrix
			// description: The resulting matrix is used to rotate points
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an angle of rotation in radians (>0 for CW)
			var c = Math.cos(angle);
			var s = Math.sin(angle);
			return new m.Matrix2D({xx: c, xy: -s, yx: s, yy: c}); // dojox.gfx.matrix.Matrix2D
		},
		rotateg: function(degree){
			// summary: forms a rotating matrix
			// description: The resulting matrix is used to rotate points
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.rotate() for comparison.
			// degree: Number: an angle of rotation in degrees (>0 for CW)
			return m.rotate(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		skewX: function(angle) {
			// summary: forms an x skewing matrix
			// description: The resulting matrix is used to skew points in the x dimension
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an skewing angle in radians
			return new m.Matrix2D({xy: Math.tan(angle)}); // dojox.gfx.matrix.Matrix2D
		},
		skewXg: function(degree){
			// summary: forms an x skewing matrix
			// description: The resulting matrix is used to skew points in the x dimension
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.skewX() for comparison.
			// degree: Number: an skewing angle in degrees
			return m.skewX(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		skewY: function(angle){
			// summary: forms a y skewing matrix
			// description: The resulting matrix is used to skew points in the y dimension
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an skewing angle in radians
			return new m.Matrix2D({yx: Math.tan(angle)}); // dojox.gfx.matrix.Matrix2D
		},
		skewYg: function(degree){
			// summary: forms a y skewing matrix
			// description: The resulting matrix is used to skew points in the y dimension
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.skewY() for comparison.
			// degree: Number: an skewing angle in degrees
			return m.skewY(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		reflect: function(a, b){
			// summary: forms a reflection matrix
			// description: The resulting matrix is used to reflect points around a vector,
			//		which goes through the origin.
			// a: dojox.gfx.Point: a point-like object, which specifies a vector of reflection
			// b: null
			if(arguments.length == 1){
				b = a.y;
				a = a.x;
			}
			// branch
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value

			// make a unit vector
			var a2 = a * a, b2 = b * b, n2 = a2 + b2, xy = 2 * a * b / n2;
			return new m.Matrix2D({xx: 2 * a2 / n2 - 1, xy: xy, yx: xy, yy: 2 * b2 / n2 - 1}); // dojox.gfx.matrix.Matrix2D
		},
		project: function(a, b){
			// summary: forms an orthogonal projection matrix
			// description: The resulting matrix is used to project points orthogonally on a vector,
			//		which goes through the origin.
			// a: dojox.gfx.Point: a point-like object, which specifies a vector of projection
			// b: null
			if(arguments.length == 1){
				b = a.y;
				a = a.x;
			}
			// branch
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value

			// make a unit vector
			var a2 = a * a, b2 = b * b, n2 = a2 + b2, xy = a * b / n2;
			return new m.Matrix2D({xx: a2 / n2, xy: xy, yx: xy, yy: b2 / n2}); // dojox.gfx.matrix.Matrix2D
		},

		// ensure matrix 2D conformance
		normalize: function(matrix){
			// summary: converts an object to a matrix, if necessary
			// description: Converts any 2D matrix-like object or an array of
			//		such objects to a valid dojox.gfx.matrix.Matrix2D object.
			// matrix: Object: an object, which is converted to a matrix, if necessary
			return (matrix instanceof m.Matrix2D) ? matrix : new m.Matrix2D(matrix); // dojox.gfx.matrix.Matrix2D
		},

		// common operations

		clone: function(matrix){
			// summary: creates a copy of a 2D matrix
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object to be cloned
			var obj = new m.Matrix2D();
			for(var i in matrix){
				if(typeof(matrix[i]) == "number" && typeof(obj[i]) == "number" && obj[i] != matrix[i]) obj[i] = matrix[i];
			}
			return obj; // dojox.gfx.matrix.Matrix2D
		},
		invert: function(matrix){
			// summary: inverts a 2D matrix
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object to be inverted
			var M = m.normalize(matrix),
				D = M.xx * M.yy - M.xy * M.yx,
				M = new m.Matrix2D({
					xx: M.yy/D, xy: -M.xy/D,
					yx: -M.yx/D, yy: M.xx/D,
					dx: (M.xy * M.dy - M.yy * M.dx) / D,
					dy: (M.yx * M.dx - M.xx * M.dy) / D
				});
			return M; // dojox.gfx.matrix.Matrix2D
		},
		_multiplyPoint: function(matrix, x, y){
			// summary: applies a matrix to a point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// x: Number: an x coordinate of a point
			// y: Number: a y coordinate of a point
			return {x: matrix.xx * x + matrix.xy * y + matrix.dx, y: matrix.yx * x + matrix.yy * y + matrix.dy}; // dojox.gfx.Point
		},
		multiplyPoint: function(matrix, /* Number||Point */ a, /* Number, optional */ b){
			// summary: applies a matrix to a point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// a: Number: an x coordinate of a point
			// b: Number: a y coordinate of a point
			var M = m.normalize(matrix);
			if(typeof a == "number" && typeof b == "number"){
				return m._multiplyPoint(M, a, b); // dojox.gfx.Point
			}
			// branch
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// a: dojox.gfx.Point: a point
			// b: null
			return m._multiplyPoint(M, a.x, a.y); // dojox.gfx.Point
		},
		multiply: function(matrix){
			// summary: combines matrices by multiplying them sequentially in the given order
			// matrix: dojox.gfx.matrix.Matrix2D...: a 2D matrix-like object,
			//		all subsequent arguments are matrix-like objects too
			var M = m.normalize(matrix);
			// combine matrices
			for(var i = 1; i < arguments.length; ++i){
				var l = M, r = m.normalize(arguments[i]);
				M = new m.Matrix2D();
				M.xx = l.xx * r.xx + l.xy * r.yx;
				M.xy = l.xx * r.xy + l.xy * r.yy;
				M.yx = l.yx * r.xx + l.yy * r.yx;
				M.yy = l.yx * r.xy + l.yy * r.yy;
				M.dx = l.xx * r.dx + l.xy * r.dy + l.dx;
				M.dy = l.yx * r.dx + l.yy * r.dy + l.dy;
			}
			return M; // dojox.gfx.matrix.Matrix2D
		},

		// high level operations

		_sandwich: function(matrix, x, y){
			// summary: applies a matrix at a centrtal point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object, which is applied at a central point
			// x: Number: an x component of the central point
			// y: Number: a y component of the central point
			return m.multiply(m.translate(x, y), matrix, m.translate(-x, -y)); // dojox.gfx.matrix.Matrix2D
		},
		scaleAt: function(a, b, c, d){
			// summary: scales a picture using a specified point as a center of scaling
			// description: Compare with dojox.gfx.matrix.scale().
			// a: Number: a scaling factor used for the x coordinate
			// b: Number: a scaling factor used for the y coordinate
			// c: Number: an x component of a central point
			// d: Number: a y component of a central point

			// accepts several signatures:
			//	1) uniform scale factor, Point
			//	2) uniform scale factor, x, y
			//	3) x scale, y scale, Point
			//	4) x scale, y scale, x, y

			switch(arguments.length){
				case 4:
					// a and b are scale factor components, c and d are components of a point
					return m._sandwich(m.scale(a, b), c, d); // dojox.gfx.matrix.Matrix2D
				case 3:
					if(typeof c == "number"){
						// branch
						// a: Number: a uniform scaling factor used for both coordinates
						// b: Number: an x component of a central point
						// c: Number: a y component of a central point
						// d: null
						return m._sandwich(m.scale(a), b, c); // dojox.gfx.matrix.Matrix2D
					}
					// branch
					// a: Number: a scaling factor used for the x coordinate
					// b: Number: a scaling factor used for the y coordinate
					// c: dojox.gfx.Point: a central point
					// d: null
					return m._sandwich(m.scale(a, b), c.x, c.y); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: Number: a uniform scaling factor used for both coordinates
			// b: dojox.gfx.Point: a central point
			// c: null
			// d: null
			return m._sandwich(m.scale(a), b.x, b.y); // dojox.gfx.matrix.Matrix2D
		},
		rotateAt: function(angle, a, b){
			// summary: rotates a picture using a specified point as a center of rotation
			// description: Compare with dojox.gfx.matrix.rotate().
			// angle: Number: an angle of rotation in radians (>0 for CW)
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) rotation angle in radians, Point
			//	2) rotation angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.rotate(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an angle of rotation in radians (>0 for CCW)
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.rotate(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		rotategAt: function(degree, a, b){
			// summary: rotates a picture using a specified point as a center of rotation
			// description: Compare with dojox.gfx.matrix.rotateg().
			// degree: Number: an angle of rotation in degrees (>0 for CW)
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) rotation angle in degrees, Point
			//	2) rotation angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.rotateg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an angle of rotation in degrees (>0 for CCW)
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.rotateg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewXAt: function(angle, a, b){
			// summary: skews a picture along the x axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewX().
			// angle: Number: an skewing angle in radians
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in radians, Point
			//	2) skew angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewX(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an skewing angle in radians
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewX(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewXgAt: function(degree, a, b){
			// summary: skews a picture along the x axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewXg().
			// degree: Number: an skewing angle in degrees
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in degrees, Point
			//	2) skew angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewXg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an skewing angle in degrees
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewXg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewYAt: function(angle, a, b){
			// summary: skews a picture along the y axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewY().
			// angle: Number: an skewing angle in radians
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in radians, Point
			//	2) skew angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewY(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an skewing angle in radians
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewY(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewYgAt: function(/* Number */ degree, /* Number||Point */ a, /* Number, optional */ b){
			// summary: skews a picture along the y axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewYg().
			// degree: Number: an skewing angle in degrees
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in degrees, Point
			//	2) skew angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewYg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an skewing angle in degrees
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewYg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		}

		//TODO: rect-to-rect mapping, scale-to-fit (isotropic and anisotropic versions)

	});
})();

// propagate Matrix2D up
dojox.gfx.Matrix2D = dojox.gfx.matrix.Matrix2D;

}

if(!dojo._hasResource["dojox.gfx._base"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.gfx._base"] = true;
dojo.provide("dojox.gfx._base");

(function(){
	var g = dojox.gfx, b = g._base;

	// candidates for dojox.style (work on VML and SVG nodes)
	g._hasClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary:
		//		Returns whether or not the specified classes are a portion of the
		//		class list currently applied to the node.
		// return (new RegExp('(^|\\s+)'+classStr+'(\\s+|$)')).test(node.className)	// Boolean
		var cls = node.getAttribute("className");
		return cls && (" " + cls + " ").indexOf(" " + classStr + " ") >= 0;  // Boolean
	};
	g._addClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary:
		//		Adds the specified classes to the end of the class list on the
		//		passed node.
		var cls = node.getAttribute("className") || "";
		if(!cls || (" " + cls + " ").indexOf(" " + classStr + " ") < 0){
			node.setAttribute("className", cls + (cls ? " " : "") + classStr);
		}
	};
	g._removeClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary: Removes classes from node.
		var cls = node.getAttribute("className");
		if(cls){
			node.setAttribute(
				"className",
				cls.replace(new RegExp('(^|\\s+)' + classStr + '(\\s+|$)'), "$1$2")
			);
		}
	};

	// candidate for dojox.html.metrics (dynamic font resize handler is not implemented here)

	//	derived from Morris John's emResized measurer
	b._getFontMeasurements = function(){
		//	summary:
		//		Returns an object that has pixel equivilents of standard font
		//		size values.
		var heights = {
			'1em': 0, '1ex': 0, '100%': 0, '12pt': 0, '16px': 0, 'xx-small': 0,
			'x-small': 0, 'small': 0, 'medium': 0, 'large': 0, 'x-large': 0,
			'xx-large': 0
		};

		if(dojo.isIE){
			//	we do a font-size fix if and only if one isn't applied already.
			//	NOTE: If someone set the fontSize on the HTML Element, this will kill it.
			dojo.doc.documentElement.style.fontSize="100%";
		}

		//	set up the measuring node.
		var div = dojo.create("div", {style: {
				position: "absolute",
				left: "0",
				top: "-100px",
				width: "30px",
				height: "1000em",
				borderWidth: "0",
				margin: "0",
				padding: "0",
				outline: "none",
				lineHeight: "1",
				overflow: "hidden"
			}}, dojo.body());

		//	do the measurements.
		for(var p in heights){
			div.style.fontSize = p;
			heights[p] = Math.round(div.offsetHeight * 12/16) * 16/12 / 1000;
		}

		dojo.body().removeChild(div);
		return heights; 	//	object
	};

	var fontMeasurements = null;

	b._getCachedFontMeasurements = function(recalculate){
		if(recalculate || !fontMeasurements){
			fontMeasurements = b._getFontMeasurements();
		}
		return fontMeasurements;
	};

	// candidate for dojox.html.metrics

	var measuringNode = null, empty = {};
	b._getTextBox = function(	/*String*/ text,
								/*Object*/ style,
								/*String?*/ className){
		var m, s, al = arguments.length;
		if(!measuringNode){
			measuringNode = dojo.create("div", {style: {
				position: "absolute",
				top: "-10000px",
				left: "0"
			}}, dojo.body());
		}
		m = measuringNode;
		// reset styles
		m.className = "";
		s = m.style;
		s.borderWidth = "0";
		s.margin = "0";
		s.padding = "0";
		s.outline = "0";
		// set new style
		if(al > 1 && style){
			for(var i in style){
				if(i in empty){ continue; }
				s[i] = style[i];
			}
		}
		// set classes
		if(al > 2 && className){
			m.className = className;
		}
		// take a measure
		m.innerHTML = text;

		if(m["getBoundingClientRect"]){
			var bcr = m.getBoundingClientRect();
			return {l: bcr.left, t: bcr.top, w: bcr.width || (bcr.right - bcr.left), h: bcr.height || (bcr.bottom - bcr.top)};
		}else{
			return dojo.marginBox(m);
		}
	};

	// candidate for dojo.dom

	var uniqueId = 0;
	b._getUniqueId = function(){
		// summary: returns a unique string for use with any DOM element
		var id;
		do{
			id = dojo._scopeName + "Unique" + (++uniqueId);
		}while(dojo.byId(id));
		return id;
	};
})();

dojo.mixin(dojox.gfx, {
	//	summary:
	// 		defines constants, prototypes, and utility functions

	// default shapes, which are used to fill in missing parameters
	defaultPath: {
		type: "path", path: ""
	},
	defaultPolyline: {
		type: "polyline", points: []
	},
	defaultRect: {
		type: "rect", x: 0, y: 0, width: 100, height: 100, r: 0
	},
	defaultEllipse: {
		type: "ellipse", cx: 0, cy: 0, rx: 200, ry: 100
	},
	defaultCircle: {
		type: "circle", cx: 0, cy: 0, r: 100
	},
	defaultLine: {
		type: "line", x1: 0, y1: 0, x2: 100, y2: 100
	},
	defaultImage: {
		type: "image", x: 0, y: 0, width: 0, height: 0, src: ""
	},
	defaultText: {
		type: "text", x: 0, y: 0, text: "", align: "start",
		decoration: "none", rotated: false, kerning: true
	},
	defaultTextPath: {
		type: "textpath", text: "", align: "start",
		decoration: "none", rotated: false, kerning: true
	},

	// default geometric attributes
	defaultStroke: {
		type: "stroke", color: "black", style: "solid", width: 1,
		cap: "butt", join: 4
	},
	defaultLinearGradient: {
		type: "linear", x1: 0, y1: 0, x2: 100, y2: 100,
		colors: [
			{ offset: 0, color: "black" }, { offset: 1, color: "white" }
		]
	},
	defaultRadialGradient: {
		type: "radial", cx: 0, cy: 0, r: 100,
		colors: [
			{ offset: 0, color: "black" }, { offset: 1, color: "white" }
		]
	},
	defaultPattern: {
		type: "pattern", x: 0, y: 0, width: 0, height: 0, src: ""
	},
	defaultFont: {
		type: "font", style: "normal", variant: "normal",
		weight: "normal", size: "10pt", family: "serif"
	},

	getDefault: (function(){
		var typeCtorCache = {};
		// a memoized delegate()
		return function(/*String*/ type){
			var t = typeCtorCache[type];
			if(t){
				return new t();
			}
			t = typeCtorCache[type] = new Function;
			t.prototype = dojox.gfx[ "default" + type ];
			return new t();
		}
	})(),

	normalizeColor: function(/*Color*/ color){
		//	summary:
		// 		converts any legal color representation to normalized
		// 		dojo.Color object
		return (color instanceof dojo.Color) ? color : new dojo.Color(color); // dojo.Color
	},
	normalizeParameters: function(existed, update){
		//	summary:
		// 		updates an existing object with properties from an "update"
		// 		object
		//	existed: Object
		//		the "target" object to be updated
		//	update:  Object
		//		the "update" object, whose properties will be used to update
		//		the existed object
		if(update){
			var empty = {};
			for(var x in existed){
				if(x in update && !(x in empty)){
					existed[x] = update[x];
				}
			}
		}
		return existed;	// Object
	},
	makeParameters: function(defaults, update){
		//	summary:
		// 		copies the original object, and all copied properties from the
		// 		"update" object
		//	defaults: Object
		//		the object to be cloned before updating
		//	update:   Object
		//		the object, which properties are to be cloned during updating
		if(!update){
			// return dojo.clone(defaults);
			return dojo.delegate(defaults);
		}
		var result = {};
		for(var i in defaults){
			if(!(i in result)){
				result[i] = dojo.clone((i in update) ? update[i] : defaults[i]);
			}
		}
		return result; // Object
	},
	formatNumber: function(x, addSpace){
		// summary: converts a number to a string using a fixed notation
		// x:			Number:		number to be converted
		// addSpace:	Boolean?:	if it is true, add a space before a positive number
		var val = x.toString();
		if(val.indexOf("e") >= 0){
			val = x.toFixed(4);
		}else{
			var point = val.indexOf(".");
			if(point >= 0 && val.length - point > 5){
				val = x.toFixed(4);
			}
		}
		if(x < 0){
			return val; // String
		}
		return addSpace ? " " + val : val; // String
	},
	// font operations
	makeFontString: function(font){
		// summary: converts a font object to a CSS font string
		// font:	Object:	font object (see dojox.gfx.defaultFont)
		return font.style + " " + font.variant + " " + font.weight + " " + font.size + " " + font.family; // Object
	},
	splitFontString: function(str){
		// summary:
		//		converts a CSS font string to a font object
		// description:
		//		Converts a CSS font string to a gfx font object. The CSS font
		//		string components should follow the W3C specified order
		//		(see http://www.w3.org/TR/CSS2/fonts.html#font-shorthand):
		//		style, variant, weight, size, optional line height (will be
		//		ignored), and family.
		// str: String
		//		a CSS font string
		var font = dojox.gfx.getDefault("Font");
		var t = str.split(/\s+/);
		do{
			if(t.length < 5){ break; }
			font.style   = t[0];
			font.variant = t[1];
			font.weight  = t[2];
			var i = t[3].indexOf("/");
			font.size = i < 0 ? t[3] : t[3].substring(0, i);
			var j = 4;
			if(i < 0){
				if(t[4] == "/"){
					j = 6;
				}else if(t[4].charAt(0) == "/"){
					j = 5;
				}
			}
			if(j < t.length){
				font.family = t.slice(j).join(" ");
			}
		}while(false);
		return font;	// Object
	},
	// length operations
	cm_in_pt: 72 / 2.54,	// Number: points per centimeter
	mm_in_pt: 7.2 / 2.54,	// Number: points per millimeter
	px_in_pt: function(){
		// summary: returns a number of pixels per point
		return dojox.gfx._base._getCachedFontMeasurements()["12pt"] / 12;	// Number
	},
	pt2px: function(len){
		// summary: converts points to pixels
		// len: Number: a value in points
		return len * dojox.gfx.px_in_pt();	// Number
	},
	px2pt: function(len){
		// summary: converts pixels to points
		// len: Number: a value in pixels
		return len / dojox.gfx.px_in_pt();	// Number
	},
	normalizedLength: function(len) {
		// summary: converts any length value to pixels
		// len: String: a length, e.g., "12pc"
		if(len.length == 0) return 0;
		if(len.length > 2){
			var px_in_pt = dojox.gfx.px_in_pt();
			var val = parseFloat(len);
			switch(len.slice(-2)){
				case "px": return val;
				case "pt": return val * px_in_pt;
				case "in": return val * 72 * px_in_pt;
				case "pc": return val * 12 * px_in_pt;
				case "mm": return val * dojox.gfx.mm_in_pt * px_in_pt;
				case "cm": return val * dojox.gfx.cm_in_pt * px_in_pt;
			}
		}
		return parseFloat(len);	// Number
	},

	// a constant used to split a SVG/VML path into primitive components
	pathVmlRegExp: /([A-Za-z]+)|(\d+(\.\d+)?)|(\.\d+)|(-\d+(\.\d+)?)|(-\.\d+)/g,
	pathSvgRegExp: /([A-Za-z])|(\d+(\.\d+)?)|(\.\d+)|(-\d+(\.\d+)?)|(-\.\d+)/g,

	equalSources: function(a, b){
		// summary: compares event sources, returns true if they are equal
		return a && b && a == b;
	},
	
	switchTo: function(renderer){
		var ns = dojox.gfx[renderer];
		if(ns){
			dojo.forEach(["Group", "Rect", "Ellipse", "Circle", "Line",
					"Polyline", "Image", "Text", "Path", "TextPath",
					"Surface", "createSurface"], function(name){
				dojox.gfx[name] = ns[name];
			});
		}
	}
});

}

if(!dojo._hasResource["dojox.gfx"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.gfx"] = true;
dojo.provide("dojox.gfx");




dojo.loadInit(function(){
	// Since loaderInit can be fired before any dojo.provide/require calls,
	// make sure the dojox.gfx object exists and only run this logic if dojox.gfx.renderer
	// has not been defined yet.
	var gfx = dojo.getObject("dojox.gfx", true), sl, flag, match;
	while(!gfx.renderer){
		// Have a way to force a GFX renderer, if so desired.
		// Useful for being able to serialize GFX data in a particular format.
		if(dojo.config.forceGfxRenderer){
			dojox.gfx.renderer = dojo.config.forceGfxRenderer;
			break;
		}
		var renderers = (typeof dojo.config.gfxRenderer == "string" ?
			dojo.config.gfxRenderer : "svg,vml,canvas,silverlight").split(",");
		for(var i = 0; i < renderers.length; ++i){
			switch(renderers[i]){
				case "svg":
					// the next test is from https://github.com/phiggins42/has.js
					if("SVGAngle" in dojo.global){
						dojox.gfx.renderer = "svg";
					}
					break;
				case "vml":
					if(dojo.isIE){
						dojox.gfx.renderer = "vml";
					}
					break;
				case "silverlight":
					try{
						if(dojo.isIE){
							sl = new ActiveXObject("AgControl.AgControl");
							if(sl && sl.IsVersionSupported("1.0")){
								flag = true;
							}
						}else{
							if(navigator.plugins["Silverlight Plug-In"]){
								flag = true;
							}
						}
					}catch(e){
						flag = false;
					}finally{
						sl = null;
					}
					if(flag){
						dojox.gfx.renderer = "silverlight";
					}
					break;
				case "canvas":
					if(dojo.global.CanvasRenderingContext2D){
						dojox.gfx.renderer = "canvas";
					}
					break;
			}
			if(gfx.renderer){
				break;
			}
		}
		break;
	}
	
	if(dojo.config.isDebug){
		console.log("gfx renderer = " + gfx.renderer);
	}

	// load & initialize renderer
	if(gfx[gfx.renderer]){
		// already loaded
		gfx.switchTo(gfx.renderer);
	}else{
		// load
		gfx.loadAndSwitch = gfx.renderer;
		dojo["require"]("dojox.gfx." + gfx.renderer);
	}
});

}

if(!dojo._hasResource["dojox.gfx.utils"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.gfx.utils"] = true;
dojo.provide("dojox.gfx.utils");



(function(){
	var d = dojo, g = dojox.gfx, gu = g.utils;

	dojo.mixin(gu, {
		forEach: function(
			/* dojox.gfx.Surface || dojox.gfx.Shape */ object,
			/*Function|String|Array*/ f, /*Object?*/ o
		){
			o = o || d.global;
			f.call(o, object);
			if(object instanceof g.Surface || object instanceof g.Group){
				d.forEach(object.children, function(shape){
					gu.forEach(shape, f, o);
				});
			}
		},

		serialize: function(
			/* dojox.gfx.Surface || dojox.gfx.Shape */ object
		){
			var t = {}, v, isSurface = object instanceof g.Surface;
			if(isSurface || object instanceof g.Group){
				t.children = d.map(object.children, gu.serialize);
				if(isSurface){
					return t.children;	// Array
				}
			}else{
				t.shape = object.getShape();
			}
			if(object.getTransform){
				v = object.getTransform();
				if(v){ t.transform = v; }
			}
			if(object.getStroke){
				v = object.getStroke();
				if(v){ t.stroke = v; }
			}
			if(object.getFill){
				v = object.getFill();
				if(v){ t.fill = v; }
			}
			if(object.getFont){
				v = object.getFont();
				if(v){ t.font = v; }
			}
			return t;	// Object
		},

		toJson: function(
			/* dojox.gfx.Surface || dojox.gfx.Shape */ object,
			/* Boolean? */ prettyPrint
		){
			return d.toJson(gu.serialize(object), prettyPrint);	// String
		},

		deserialize: function(
			/* dojox.gfx.Surface || dojox.gfx.Shape */ parent,
			/* dojox.gfx.Shape || Array */ object
		){
			if(object instanceof Array){
				return d.map(object, d.hitch(null, gu.deserialize, parent));	// Array
			}
			var shape = ("shape" in object) ? parent.createShape(object.shape) : parent.createGroup();
			if("transform" in object){
				shape.setTransform(object.transform);
			}
			if("stroke" in object){
				shape.setStroke(object.stroke);
			}
			if("fill" in object){
				shape.setFill(object.fill);
			}
			if("font" in object){
				shape.setFont(object.font);
			}
			if("children" in object){
				d.forEach(object.children, d.hitch(null, gu.deserialize, shape));
			}
			return shape;	// dojox.gfx.Shape
		},

		fromJson: function(
			/* dojox.gfx.Surface || dojox.gfx.Shape */ parent,
			/* String */ json){
			return gu.deserialize(parent, d.fromJson(json));	// Array || dojox.gfx.Shape
		},

		toSvg: function(/*GFX object*/surface){
			// summary:
			//		Function to serialize a GFX surface to SVG text.
			// description:
			//		Function to serialize a GFX surface to SVG text.  The value of this output
			//		is that there are numerous serverside parser libraries that can render
			//		SVG into images in various formats.  This provides a way that GFX objects
			//		can be captured in a known format and sent serverside for serialization
			//		into an image.
			// surface:
			//		The GFX surface to serialize.
			// returns:
			//		Deferred object that will be called when SVG serialization is complete.
		
			//Since the init and even surface creation can be async, we need to
			//return a deferred that will be called when content has serialized.
			var deferred = new dojo.Deferred();
		
			if(dojox.gfx.renderer === "svg"){
				//If we're already in SVG mode, this is easy and quick.
				try{
					var svg = gu._cleanSvg(gu._innerXML(surface.rawNode));
					deferred.callback(svg);
				}catch(e){
					deferred.errback(e);
				}
			}else{
				//Okay, now we have to get creative with hidden iframes and the like to
				//serialize SVG.
				if (!gu._initSvgSerializerDeferred) {
					gu._initSvgSerializer();
				}
				var jsonForm = dojox.gfx.utils.toJson(surface);
				var serializer = function(){
					try{
						var sDim = surface.getDimensions();
						var width = sDim.width;
						var	height = sDim.height;

						//Create an attach point in the iframe for the contents.
						var node = gu._gfxSvgProxy.document.createElement("div");
						gu._gfxSvgProxy.document.body.appendChild(node);
						//Set the node scaling.
						dojo.withDoc(gu._gfxSvgProxy.document, function() {
							dojo.style(node, "width", width);
							dojo.style(node, "height", height);
						}, this);

						//Create temp surface to render object to and render.
						var ts = gu._gfxSvgProxy[dojox._scopeName].gfx.createSurface(node, width, height);

						//It's apparently possible that a suface creation is async, so we need to use
						//the whenLoaded function.  Probably not needed for SVG, but making it common
						var draw = function(surface) {
							try{
								gu._gfxSvgProxy[dojox._scopeName].gfx.utils.fromJson(surface, jsonForm);

								//Get contents and remove temp surface.
								var svg = gu._cleanSvg(node.innerHTML);
								surface.clear();
								surface.destroy();
								gu._gfxSvgProxy.document.body.removeChild(node);
								deferred.callback(svg);
							}catch(e){
								deferred.errback(e);
							}
						};
						ts.whenLoaded(null,draw);
					 }catch (ex) {
						deferred.errback(ex);
					}
				};
				//See if we can call it directly or pass it to the deferred to be
				//called on initialization.
				if(gu._initSvgSerializerDeferred.fired > 0){
					serializer();
				}else{
					gu._initSvgSerializerDeferred.addCallback(serializer);
				}
			}
			return deferred; //dojo.Deferred that will be called when serialization finishes.
		},

		//iFrame document used for handling SVG serialization.
		_gfxSvgProxy: null,

		//Serializer loaded.
		_initSvgSerializerDeferred: null,

		_svgSerializerInitialized: function() {
			// summary:
			//		Internal function to call when the serializer init completed.
			// tags:
			//		private
			gu._initSvgSerializerDeferred.callback(true);
		},

		_initSvgSerializer: function(){
			// summary:
			//		Internal function to initialize the hidden iframe where SVG rendering
			//		will occur.
			// tags:
			//		private
			if(!gu._initSvgSerializerDeferred){
				gu._initSvgSerializerDeferred = new dojo.Deferred();
				var f = dojo.doc.createElement("iframe");
				dojo.style(f, {
					display: "none",
					position: "absolute",
					width: "1em",
					height: "1em",
					top: "-10000px"
				});
				var intv;
				if(dojo.isIE){
					f.onreadystatechange = function(){
						if(f.contentWindow.document.readyState == "complete"){
							f.onreadystatechange = function() {};
							intv = setInterval(function() {
								if(f.contentWindow[dojo._scopeName] &&
								   f.contentWindow[dojox._scopeName].gfx &&
								   f.contentWindow[dojox._scopeName].gfx.utils){
									clearInterval(intv);
									f.contentWindow.parent[dojox._scopeName].gfx.utils._gfxSvgProxy = f.contentWindow;
									f.contentWindow.parent[dojox._scopeName].gfx.utils._svgSerializerInitialized();
								}
							}, 50);
						}
					};
				}else{
					f.onload = function(){
						f.onload = function() {};
						intv = setInterval(function() {
							if(f.contentWindow[dojo._scopeName] &&
							   f.contentWindow[dojox._scopeName].gfx &&
							   f.contentWindow[dojox._scopeName].gfx.utils){
								clearInterval(intv);
								f.contentWindow.parent[dojox._scopeName].gfx.utils._gfxSvgProxy = f.contentWindow;
								f.contentWindow.parent[dojox._scopeName].gfx.utils._svgSerializerInitialized();
							}
						}, 50);
					};
				}
				//We have to load the GFX SVG proxy frame.  Default is to use the one packaged in dojox.
				var uri = (dojo.config["dojoxGfxSvgProxyFrameUrl"]||dojo.moduleUrl("dojox", "gfx/resources/gfxSvgProxyFrame.html"));
				f.setAttribute("src", uri);
				dojo.body().appendChild(f);
			}
		},

		_innerXML: function(/*Node*/node){
			// summary:
			//		Implementation of MS's innerXML function, borrowed from dojox.xml.parser.
			// node:
			//		The node from which to generate the XML text representation.
			// tags:
			//		private
			if(node.innerXML){
				return node.innerXML;	//String
			}else if(node.xml){
				return node.xml;		//String
			}else if(typeof XMLSerializer != "undefined"){
				return (new XMLSerializer()).serializeToString(node);	//String
			}
			return null;
		},

		_cleanSvg: function(svg) {
			// summary:
			//		Internal function that cleans up artifacts in extracted SVG content.
			// tags:
			//		private
			if(svg){
				//Make sure the namespace is set.
				if(svg.indexOf("xmlns=\"http://www.w3.org/2000/svg\"") == -1){
					svg = svg.substring(4, svg.length);
					svg = "<svg xmlns=\"http://www.w3.org/2000/svg\"" + svg;
				}
				//Do some other cleanup, like stripping out the
				//dojoGfx attributes.
				svg = svg.replace(/\bdojoGfx\w*\s*=\s*(['"])\w*\1/g, "");
			}
			return svg;  //Cleaned SVG text.
		}
	});
})();

}

if(!dojo._hasResource["ibm_ilog.diagram.util.PrintUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm_ilog.diagram.util.PrintUtil"] = true;
dojo.provide("ibm_ilog.diagram.util.PrintUtil");

}

if(!dojo._hasResource["ibm_ilog.diagram.widget.Diagram"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm_ilog.diagram.widget.Diagram"] = true;
dojo.provide("ibm_ilog.diagram.widget.Diagram");

}

if(!dojo._hasResource["ibm_ilog.diagram.SwimLane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm_ilog.diagram.SwimLane"] = true;
dojo.provide("ibm_ilog.diagram.SwimLane");

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.Templates"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.Templates"] = true;
/**
 * @author jdbennet
 */
/*
 * Defect 157214:  When running Process Diagram from Outlook,
 * bpm_endpoint_urls was undefined.  The window.parent variable
 * is defined in processInstanceDiagram2.jsp.
 *  */
var bpm_endpoint_urls = 
            !bpm_endpoint_urls && 
            !!window.parent.bpm_endpoint_urls 
            ? window.parent.bpm_endpoint_urls : bpm_endpoint_urls;

dojo.provide("com.ibm.bpm.wpd.document.bpd.view.Templates");

dojo.declare("com.ibm.bpm.wpd.document.bpd.view.Templates", null, {


complexEventTemplate: {
    layout: {
        type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
    },

    children: [
        {
            dojoAttachPoint: 'counter',
            halign: 'center',
            shape: {
                align: 'middle',
                text: '{{data.counter}}',
                type: 'text',
                width: 80
                },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        },


    {
      layout: {
        type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
    },
        children: [{
            dojoAttachPoint: 'baseShape',
            valign: 'center',
            halign: 'center',
            shape: {
                width: 24,
                height: 24,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }

      ]


    }, {
      dojoAttachPoint: 'textShape',
      shape: {
                align: 'middle',
                text: '{{label|safe}}',
                type: 'mltext',
                width: 90,
                wrap: false
            },
        fill: {
            r: 0,
            g: 0,
            b: 0,
            a: 1
        },
        font: {
            type: 'font',
            weight: 'normal',
            size: '11.5pt',
            family: 'arial'
        }
    }]
},



complexVMLTemplate: {
    layout: {
        type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
    },

    children: [
        {
            halign: 'center',
            shape: {
                align: 'middle',
                text: '{{data.counter}}',
                type: 'text',
                width: 80
                },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        },


    {
      layout: {
        type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
    },
        children: [{
            dojoAttachPoint: 'baseShape',
            valign: 'center',
            halign: 'center',
            shape: {
                width: 24,
                height: 24,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }

      ]


    }, {
            
            valign: 'center',
            halign: 'center',
            shape: {
                width: 72,
                height: 50,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }]
},


    linkTemplate: [{
        dojoAttachPoint: '_path',
        shape: {
            type: 'polyline',
            points: [{
                x: 0,
                y: 0
            }, {
                x: 100,
                y: 100
            }]
        },
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    },

    {
        dojoAttachPoint: '_endArrow',
        shape: {
            type: 'polyline',
            points: [{
                x: -8,
                y: 4
            }, {
                x: 0,
                y: 0
            }, {
                x: -8,
                y: -4
            }, {
                x: -8,
                y: 4
            }]
        },
        fill: 'gray',
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
                 
    }],

    linkDiamondTemplate: [{
        dojoAttachPoint: '_path',
        shape: {
            type: 'polyline',
            points: [{
                x: 0,
                y: 0
            }, {
                x: 100,
                y: 100
            }]
        },
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    },
    {
        dojoAttachPoint: '_startArrow',
           shape: {
                    path: 'M -12 0 l 7 -4 l 7 4 l -7 4 z',
                    type: 'path'
                 },
            fill: 'white',
            stroke: {
                type: 'stroke',
               color: 'gray',
                width: 1
        }
      },
      

    {
        dojoAttachPoint: '_endArrow',
        shape: {
            type: 'polyline',
            points: [{
                x: -8,
                y: 4
            }, {
                x: 0,
                y: 0
            }, {
                x: -8,
                y: -4
            }, {
                x: -8,
                y: 4
            }]
        },
        fill: 'gray',
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    }],

    linkConditionTemplate: [{
        dojoAttachPoint: '_path',
        shape: {
            type: 'polyline',
            points: [{
                x: 0,
                y: 0
            }, {
                x: 100,
                y: 100
            }]
        },
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    },
    {
        dojoAttachPoint: '_startArrow',
           shape: {
                    path: 'M -4 8 L -8 -8',
                    type: 'path'
                 },
            fill: 'gray',
            stroke: {
                type: 'stroke',
                color: 'gray',
                width: 1
        }
      },
      

    {
        dojoAttachPoint: '_endArrow',
        shape: {
            type: 'polyline',
            points: [{
                x: -8,
                y: 4
            }, {
                x: 0,
                y: 0
            }, {
                x: -8,
                y: -4
            }, {
                x: -8,
                y: 4
            }]
        },
        fill: 'gray',
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    }],

    assignmentEventMarker: {
            valign: 'center',
            halign: 'center',
            margins: [3, 3, 17, 3 ],
            shape: {
                width: 7,
                height: 7,
                src: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER)
                		+ '/widgets/com/ibm/bpm/wpd/images/BPD/Pre-Post-assignment_marker_7x7.png',
                type: 'image'
            },
            stroke: 'black'
     
        },


 groupTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            dojoAttachPoint: 'baseShape',
            shape: {
                x: 0,
                y: 0,
                width: 95,
                height: 20,
                type: 'rect',
                r: 5
            },
            stroke: {
                color: 'black',
                width: 1,
                style: 'LongDashDot'
            },
            fill: "#F8F3F7"
        }

        
       

        ]
    },

    noteTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            dojoAttachPoint: 'baseShape',
            shape: {
                x: 0,
                y: 0,
                width: 95,
                height: 20,
                type: 'rect'
            },
            fill: "#FFFFCC"
        },

        {
            dojoAttachPoint: 'textShape',
            halign: 'left',
            valign: 'top',
            margins: [10, 5, 0, 0 ],
            shape: {
                x: 15,
                y: 5,
                align: 'start',
                text: '{{label|safe}}',
                width: 80,
                type: 'mltext',
                wrap: false
            },
            
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'Arial'
            }
        },
        {
            halign: 'left',
            valign: 'center',
            shape: {
                type: 'line',
                x1: 0,
                y1: 0,
                x2: 0,
                y2: 70
            },
            stroke: 'black'
        },
        {
            halign: 'left',
            valign: 'top',
            shape: {
                type: 'line',
                x1: 0,
                y1: 0,
                x2: 18,
                y2: 0
            },
            stroke: 'black'
        },
        {
            halign: 'left',
            valign: 'bottom',
            shape: {
                type: 'line',
                x1: 0,
                y1: 0,
                x2: 18,
                y2: 0
            },
            stroke: 'black'
        }

        ]
    },

    activityTemplate: {
        
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [
            {
                dojoAttachPoint: 'counter',
                shape: {
                        align: 'middle',
                        text: '{{data.counter}}',
                        type: 'text',
                        width: 80
                    },
                    fill: {
                        r: 0,
                        g: 0,
                        b: 0,
                        a: 1
                    },
                    font: {
                        type: 'font',
                        weight: 'normal',
                        size: '11.5pt',
                        family: 'arial'
                    }
            },
            {
                halign: 'center',
                valign: 'center',
                layout: {
                    type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
                },
                children: [{
                    halign: 'center',
                    valign: 'center',
                    dojoAttachPoint: 'baseShape',
                    shape: {
                        width: 95,
                        height: 70,
                        src: './images/bwGateway.png',
                        type: 'image'
                    }
                },
        
                {
                    dojoAttachPoint: 'textShape',
                    halign: 'center',
                    valign: 'center',
                    shape: {
                        align: 'middle',
                        text: '{{label|safe}}',
                        y: 15,
                        x: 15,
                        type: 'mltext',
                        wrap: false,
                        width: 80
                    },
                    fill: {
                        r: 0,
                        g: 0,
                        b: 0,
                        a: 1
                    },
                    font: {
                        type: 'font',
                        weight: 'normal',
                        size: '11.5pt',
                        family: 'arial'
                    }
                }]
            }
        ]
    },

/**
    Template used to create a decorator for the iBPM work. 
    A picture of a person with a green or red dot in the upper right corner and the name on top.
 **/
 iBPMTemplate: {
        
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [
            {
                shape: {
                        align: 'middle',
                        text: '{{data.label|safe}}',
                        type: 'text',
                        width: 42
                    },
                    fill: {
                        r: 0,
                        g: 0,
                        b: 0,
                        a: 1
                    },
                    font: {
                        type: 'font',
                        weight: 'normal',
                        size: '11.5pt',
                        family: 'arial'
                    }
            },
            {
                halign: 'center',
                layout: {
                    type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
                },
                children: [{
                    dojoAttachPoint: 'baseShape',
                    shape: {
                        width: 42,
                        height: 42,
                        src: './images/bwGateway.png',
                        type: 'image'
                    }
                },
        
                {
                    dojoAttachPoint: 'status',
                    valign: 'top',
                    halign: 'right',
                    margins: [5,5, 5, 5],
                    shape: {
                        type: 'circle',
                        r: 5
                        
                    },
                    stroke: 'black',
                    fill: 'green'
                }]
            }
        ]
    },
 
  borderTemplate:  {
           
            valign: 'center',
            halign: 'right',
            dojoAttachPoint: '_border',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                shape: {
                   width: 95,
                   height: 70,
                   src: '/BPMN/com/ibm/bpm/wpd/images/BPD/EVSP_-_Default_Outline_95x70.gif',
                   type: 'image'
                },
                stroke: 'black'

            }]
        },




    milestoneTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [{
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                dojoAttachPoint: 'baseShape',
                shape: {
                    x: 0,
                    y: 0,
                    width: 250,
                    height: 25,
                    r: 1,
                    type: 'rect'
                },
                stroke: {
                    type: 'stroke',
                    color: 'black',
                    width: 1
                },
                fill: '#e0e0e0'
            },

            {
                dojoAttachPoint: 'textShape',
                halign: 'center',
                valign: 'center',
                shape: {
                    align: 'middle',
                    text: '{{label|safe}}',
                    y: 10,
                    x: 10,
                    type: 'text',
                    wrap: false,
                    width: 80
                },
                fill: {
                    r: 0,
                    g: 0,
                    b: 0,
                    a: 1
                },
                font: {
                    type: 'font',
                    weight: 'normal',
                    size: '9pt',
                    family: 'sans-serif'
                }
            }]
        },

        {
            shape: {
                type: 'rect',
                width: 140,
                height: 275
            },
            
            stroke: {
                type: 'stroke',
                color: '#E0E3E7',
                width: 0.5

            },
            border: 1
        }

        ]
    },


    HPoolTemplate: [{
        dojoAttachPoint: '_expandedGroup',
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
            cols: [{
                width: -1
            }, {}]
        },
        children: [{
            dojoAttachPoint: '_expandedBaseShape',
            column: 0,
            colspan: 2,
            shape: {
                type: 'rect',
                width: 0,
                height: 0
            },
            fill: '#e0e0e0',
            selectedStyle: {
                fill: '#9dbde4'
            },
            stroke: {
                type: 'stroke',
                color: 'black',
                width: 1
            },
            border: 1
        }, {
            dojoAttachPoint: '_header',
            column: 0,
            margins: [0, 2, 2, 2],
            minimumSize: {
                width: 22,
                height: -1
            },
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
                rows: [{
                    height: -1
                }, {}]
            },
            stroke: {
                type: 'stroke',
                color: 'black',
                width: 1
            },
            children: [{
                dojoAttachPoint: '_collapseButton',
                row: 0,
                column: 0,
                halign: 'center',
                valign: 'center',
                layout: {
                    type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
                },
                children: [{
                    shape: {
                        type: 'rect',
                        x: 0,
                        y: 0,
                        width: 12,
                        height: 12
                    }
                }]
            }, {
                row: 1,
                dojoAttachPoint: 'titleShape',
                halign: 'center',
                valign: 'stretch',
                transform: {
                    xx: 0,
                    xy: 1,
                    yx: -1,
                    yy: 0
                },
                shape: {
                    type: 'text',
                    text: '{{label|safe}}',
                    align: 'middle'
                },
                fill: 'black',
                font: {
                    type: 'font',
                    size: '10pt',
                    family: 'sans-serif'
                }
            }]
        }, {
            dojoAttachPoint: '_graphRect',
            column: 1,
            shape: {
                type: 'rect',
                width: 0,
                height: 0
            }
        }, {
            dojoAttachPoint: '_graphBackground',
            column: 1,
            margins: 1,
            shape: {
                type: 'rect',
                width: 0,
                height: 0
            },
            fill: '#f8f8f8'
        }, {
            column: 1,
            row: 0,
            margins: 0,
            halign: 'left',
            valign: 'top',
            children: [{
                shape: {
                    type: 'rect',
                    x: 0,
                    y: 0,
                    width: 0,
                    height: 0
                }
            }, {
                dojoAttachPoint: '_graph',
                shape: {
                    type: 'graph'
                }
            }]
        }]
    }],


   eventTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [{
            dojoAttachPoint: 'baseShape',
            transform: {
                dx: 1,
                dy: 1
            },
            halign: 'center',
            shape: {
                width: 24,
                height: 24,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }, {
            dojoAttachPoint: 'textShape',
            shape: {
                align: 'middle',
                text: '{{label|safe}}',
                type: 'mltext',
                width: 90,
                wrap: false
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11pt',
                family: 'Arial'
            }
        }]
    },




 activityEventTemplate: {

        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [
        {
            dojoAttachPoint: 'counter',
            shape: {
                    align: 'middle',
                    text: '{{data.counter}}',
                    type: 'text',
                    width: 80
                },
                fill: {
                    r: 0,
                    g: 0,
                    b: 0,
                    a: 1
                },
                font: {
                    type: 'font',
                    weight: 'normal',
                    size: '11.5pt',
                    family: 'arial'
                }
        },

        {
            dojoAttachPoint: 'baseShape',
            transform: {
                dx: 1,
                dy: 1
            },
            halign: 'center',
            shape: {
                width: 24,
                height: 24,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }]
    },

    activityHalo: {
      
        valign: 'center',
        halign: 'center',
        shape : {
            type: 'rect',
            width: 95,
            height: 70,
            r: 3
        },
        stroke: {
            color: 'yellow',
            width: 6
        }
        
    },

  eventHalo: {
      
        valign: 'center',
        halign: 'center',
        shape : {
            type: 'circle',
            r: 13
        },
        stroke: {
            color: 'yellow',
            width: 6
        }
        
    },


  expandButton:  {
            margins: 8,
            valign: 'bottom',
            halign: 'right',
            dojoAttachPoint: '_expandButton',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                shape: {
                    width: 7,
                    height: 7,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/sub_bpd_7x7.png',
                    type: 'image'
                },
                stroke: 'black'

            }]
        },


  activityIcon:  {
            margins: [2, 2, 2, 2],
            valign: 'center',
            halign: 'right',
            
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                halign: 'left',
                valign: 'center',

                shape: {
                    width: 12,
                    height: 12,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                    type: 'image'
                },
                stroke: 'black'

            }

            ]
        },

        decoratorIcon:  {
            margins: 4,
            valign: 'center',
            halign: 'right',
            
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                halign: 'left',
                valign: 'center',

                shape: {
                    width: 12,
                    height: 12,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                    type: 'image'
                },
                stroke: 'black'

            },
            {
	    	dojoAttachPoint: 'decoratorCount',
                halign: 'right',
                valign: 'center',
               margins: [20, 0, 0, 0],
                shape: {
                    type: 'text',
                    text: '{{data.decoratorCount}}',
                    align: 'middle'
                },
                fill: 'black',
                font: {
                    type: 'font',
                    size: '9pt',
                    family: 'arial'
                }            
            }

            ]
        },


 swimlaneTemplate : [{
    dojoAttachPoint: '_expandedGroup',
    layout: {
        type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
        cols: [{
            width: 25
        }, {}]
    },
    children: [{
        dojoAttachPoint: '_expandedBaseShape',
        column: 0,
        colspan: 2,
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        fill: '#e0e0e0',
        selectedStyle: {
            fill: '{{selectedHeaderColor}}'
        },
        stroke: '#404040'
    }, {
        dojoAttachPoint: '_header',
        column: 0,
        margins: [0, 2, 2, 2],
        minimumSize: {
            width: 22,
            height: -1
        },
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
            horizontalFlow: false,
            rows: [{
                height: -1
            }, {}]
        },
        children: [{
            dojoAttachPoint: '_collapseButton',
            halign: 'center',
            valign: 'top',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                shape: {
                    type: 'rect',
                    x: 0,
                    y: 0,
                    width: 1,
                    height: 1
                },
                fill: '#808080'
            }]
        }, {layout: {type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                dojoAttachPoint: 'titleShape',
                halign: 'center',
                valign: 'stretch',
                transform: {
                    xx: 0,
                    xy: 1,
                    yx: -1,
                    yy: 0
                },
                shape: {
                    type: 'text',
                    text: '{{label|safe}}',
                    align: 'middle'
                },
                fill: '{{textColor}}',
                font: {
                    type: 'font',
                    size: '10pt',
                    family: 'sans-serif'
                },
                
                selectedStyle: {
                    fill: '{{selectedTextColor}}'
                }
            }]
        }]
    }, {
        dojoAttachPoint: '_graphRect',
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        border: 1,
        stroke: 'black'
    }, {
        dojoAttachPoint: '_graphBackground',
        column: 1,
        margins: 1,
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        fill: '{{graphBackgroundColor}}'
    }, {
        column: 1,
        row: 0,
        margins: 0,
        halign: 'left',
        valign: 'top',
        children: [{
            shape: {
                type: 'rect',
                x: 0,
                y: 0,
                width: 0,
                height: 0
            }
        }, {
            dojoAttachPoint: '_graph',
            shape: {
                type: 'graph'
            }
        }]
    }]
}],


flashSwimlaneTemplate : [{
    dojoAttachPoint: '_expandedGroup',
    layout: {
        type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
        cols: [{
            width: -1
        }, {}]
    },
    children: [{
        dojoAttachPoint: '_expandedBaseShape',
        column: 0,
        colspan: 2,
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        fill: '#e0e0e0',
        selectedStyle: {
            fill: '{{selectedHeaderColor}}'
        },
        stroke: '#404040'
    }, {
        dojoAttachPoint: '_header',
        column: 0,
        margins: [0, 2, 2, 2],
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
            horizontalFlow: false,
            rows: [{
                height: -1
            }, {}]
        },
        children: [{
            dojoAttachPoint: '_collapseButton',
            halign: 'center',
            valign: 'top',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                shape: {
                    type: 'rect',
                    x: 0,
                    y: 0,
                    width: 1,
                    height: 1
                },
                fill: '#808080'
            }]
        }, {layout: {type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                dojoAttachPoint: 'titleShape',
                halign: 'center',
                valign: 'center',
                margins: [2,2,2,2],
                shape: {
                    
                    width: 25,
                    height: 150,
                    
                    src: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER)
                    + '/widgets/com/ibm/bpm/wpd/images/BPD/SLHeader.gif',
                    type: 'image'
                },
                fill: '{{textColor}}',
             
                
                selectedStyle: {
                    fill: '{{selectedTextColor}}'
                }
            }]
        }]
    }, {
        dojoAttachPoint: '_graphRect',
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        }
    }, {
        dojoAttachPoint: '_graphBackground',
        column: 1,
        margins: 1,
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        fill: '{{graphBackgroundColor}}'
    }, {
        column: 1,
        row: 0,
        margins: 0,
        halign: 'left',
        valign: 'top',
        children: [{
            shape: {
                type: 'rect',
                x: 0,
                y: 0,
                width: 0,
                height: 0
            }
        }, {
            dojoAttachPoint: '_graph',
            shape: {
                type: 'graph'
            }
        }]
    }]
}]
        
        

});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.BPDViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.BPDViewer"] = true;

dojo.provide("com.ibm.bpm.wpd.document.bpd.view.BPDViewer");

dojo.require( "dojo.parser" ); 





dojo.require( "dijit._WidgetBase" );

dojo.require( "dojo.data.ItemFileWriteStore" );


dojo.require( "dijit.MenuItem" );




dojo.require( "ibm_ilog.diagram.util.PrintUtil" );
dojo.require( "dijit.Dialog" );

// Diagram requires


dojo.require( "com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent" );
dojo.require( "com.ibm.bpm.wpd.util.BidiUtils" );

dojo.require ("com.ibm.bpm.wpd.document.bpd.view.Templates");

/**
 *  Process Documentation widget for the BPD editor.
 */
dojo.declare("com.ibm.bpm.wpd.document.bpd.view.BPDViewer", [ dijit._WidgetBase, dijit._Templated,com.ibm.bpm.wpd.core.view.BaseViewer], {
	
	// Path to the template
	templateString : dojo.cache("com.ibm.bpm.wpd.document.bpd.view", "templates/BPDViewer.html", "<div dojoattachpoint=\"bpmnInspector\" style=\"width: 100%; height: 100%; position:relative\">\n\n\t<div dojoattachpoint=\"zoomSliderContainer\" style=\"position:absolute; width:150px; height:35px; right:20px; top: 10px; z-index: 99; -webkit-border-radius: 10px; -moz-border-radius: 10px; background-color: white; border: 2px solid black;\" >\n\n\t\t<table  style=\"width:100%;height:30px;border-spacing: 0px\" >\n\t\t\t<tbody>\n\t\t\t\t<tr >\n\t\t\t\t\t\n\t\t\t\t\t<td style=\"width:32px\">\n\t\t\t\t\t\t<button dojoType=\"dijit.form.Button\" type=\"button\" dojoattachpoint=\"printButton\" iconClass='dijitEditorIcon dijitEditorIconPrint' showLabel='false' label=\"Print Diagram\"></button>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td style=\"width:120px\">\n\t\t\t\t\t\t<div dojoattachpoint=\"zoomSlider\" dojoType=\"dijit.form.HorizontalSlider\" value=\"10\" minimum=\"1\" maximum=\"10\" discretevalues=\"20\"  intermediatechanges=\"false\"  style=\"width:100%\" ></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t</tbody>\n\t\t</table>\n\t\n\t</div>\n\t\n\t<div id=\"gwtBPDProperties\" class=\"summaryPopup\" style=\"position: absolute; top: 10px; right: 60px; z-index: 95\">\t\n\t</div>\n\t\n\t<div dojoattachpoint=\"editorPane\"></div>\n\t\t\t\n</div>\n"),
	
	widgetsInTemplate : true,
	
	// Seem to need this when adding to diagram after it's been zoomed;
	zoomLevel: 1,
	
//	breadcrumb : null,
	pane: null,
	
	//Access to the print button (TODO: Remove later...)
	printBtn: null,

	//ILog Diagrammer object
	diagram: null,

	//Context (Right-click) menu for nodes. Pass in a dijit.Menu item to add a new option to the diagram.
	nodeMenu: null,

	//Hide the properties pane and the controls area if the widget is being used outside of the Process Documentation widget.
	viewerOnly: false,

	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Allow diagram editing. Mostly for demonstration purposes.
	enableEditing: false,

	//Location of icons on the server. 
	iconURL: null,

	//Pre-defined templates
	templates: null,

	//Location of REST data interface
	restURL: "HRSample4.json",
	
	//Diagram object
	ilogDiagram: null,

	//Keep track of when we're using silverlight. It requires .png icons
	iconSuffix: '.gif',

	onDiagramLoad : undefined,

	serverSideTextRendering: false,

	serverSideImageRendering: (dojo.isIE < 10 || navigator.userAgent.toLowerCase().indexOf('ipad') >= 0),

	//Data being rendered
	data: null,	
	//map contains eventKey and list of handlers, currently it takes one handler function
	//we may change to take an array of handlers if needed
	//events: onNodeContextMenu, onNodeMouseEnter, onNodeMouseLeave, onNodeClick
	config: null,     
	_connectionHandles : null,
	/**
	 *  Constructor. Called after the widget is instantiated, but before any child dijits are displayed.
	 *	Use this code to mix in the template files for later use.
	 */
	constructor : function() {

		
		this._connectionHandles = [];
		//Load the template files.
		var templates = this.templates = new com.ibm.bpm.wpd.document.bpd.view.Templates();

		//Template graphics may have different server URLs depending on how the widget is packaged. 
		//Fix this here.
		var url =  this.iconURL = dojo.moduleUrl("com.ibm.bpm.wpd").path + "images/BPD/";

		//Check for older versions of IE. The templates need to be modified so we're doing server side rendering of their images.
		var isLegacyBrowser = (dojo.isIE <= 8);

		//Older versions of IE may require special handling when we're rendering. 
		//Make a note of what we're targeting
		var iid = ibm_ilog.diagram;
		if ( iid.isSvgWeb )
			this.renderingEngine = 'svgWeb';
		else if ( iid.isVml )
			this.renderingEngine = 'VML';
		else if ( iid.isSilverlight )
			this.renderingEngine = 'Silverlight';
		//Note: Once we move to Dojo 1.7 we should look into supporting canvas as well.
		else 
			this.renderingEngine = 'svg';

		//svgWeb (Flash) requires that the fonts be made bigger. Undo that for other browsers.
		if ( !iid.isSvgWeb ){
			templates.activityTemplate.children[0].font.size='9pt';
			templates.activityTemplate.children[1].children[1].font.size = '9pt';
			templates.noteTemplate.children[1].font.size = '9pt';
			templates.complexEventTemplate.children[2].font.size = '9pt';
			templates.complexEventTemplate.children[0].font.size = '9pt';
		}	

		if ( iid.isSilverlight ){
			this.iconSuffix = '.png';
		}

		if ( iid.isVml ){
			templates.noteTemplate.children[1].shape.x = 0;
			templates.noteTemplate.children[1].shape.y = 10;
			templates.activityTemplate.children[1].children[1].shape.x = 45;

		}

		//Disable touch support when using Flash. We don't support Flash on tablets.
		if ( iid.isSvgWeb ){
			ibm_ilog.diagram.mobileEnabled = false;
		}
		
	},
	
	startup: function(){
		this.inherited(arguments);
		//TODO: Does it make sense for Victor's code to call onShow here?
	
	},
	
	/**
	 * Function called after the pane has been rendered. Dynamically create the view area, but not the vierwport.
	 */
	postCreate : function() {
		
		this.displayAll();
		this.inherited(arguments);
	},


	/**
	 Adapter function to ensure that BPMNView and BPDViewer share the same set of interfaces
	 **/
	displayAll: function(){
		this.getData();
		
		if ( this.serverSideImageRendering ){
			this.displayImage();
			this.connectImageZoomControl();
			this.connectPrintButton();
		}
		
		else
			this.displayEditor();
	},







	/*
		svgWeb (Using the Flash Player as an SVG rendering engine) has issues when destroyRecursive() is used to 
		dispose of the current stack container. Destroying the flash (ILog) diagrammer first ensures proper disposal 
		all connection handlers.
	 */
	destroyFlashPlayer: function() {

		//Flash player disabled for the moment. Just return;
		return;


		//Sanity check. Don't bother with this code if we're not running svgWeb
		if ( ! dojo.isIE  ||  !this.renderingEngine == 'svgWeb')
			return;	

		//Remove all dojo.connect() event handlers
		try{
			this._disconnectEventHandlers();
		}catch( err ){
			console.debug( "Error disconnecting event handlers: " + err.message );
		}

		//Remove the diagrammer
		this.ilogDiagrammer.destroy();

	},

	/**
	 Load the data, either from the enclosing framework or from the server.
	 **/
	getData: function(){
		//JSON data from the server
		var processData;


		if ( this.debug && this.restURL ){
			//Get all the dat from the server (Direct file read in this case).
			processData = this.getLocalData();
		}else {
			//Get the server side data
			processData = this.viewStateModel.getDocumentModel();
		}

		//Save  pointer to the data for later use
		//this.data = processData;
		this.data = dojo.clone( processData );
	},
	
	/**
	 * Display the editor contents
	 * Note: The viewport requires a parent widget with non-zero width and height when it's instantiated. 
	 		 Wait until the widget has been dynamically added to the parent ContentPane and brought to the front before
	 		 instantiating this code.
	 */
	displayEditor : function() {
		

		var processData = this.data;


		var dictionary = this.dictionary =  new dojox.collections.Dictionary();

			//Load text positions for VML and Flash on IE 6 - 8
			if ( processData.textPositions ){

				var co_ords = processData.textPositions;
				for ( var i = 0 ; i < co_ords.length; i++ ){
					var item = co_ords[i];
					for(var propertyName in item) {
						var value = item[propertyName];

						//Add the entry to the dictionary if it's not already there.
						//If it's there, then we've got duplicate, possibly conflicting info. Toss the bad entry.
						if ( dictionary.contains(propertyName) ){
							dictionary.remove( propertyName );
							
						}
						else{
							
							dictionary.add( propertyName, value );
						}
					}
				}
			}

		if ( this.renderingEngine == 'VML' && this.serverSideTextRendering )
			this.tweakXandYAttributes_SVG_VML( processData.items, dictionary );
		else if ( this.renderingEngine == 'svg' || this.renderingEngine == 'Silverlight' || this.renderingEngine == 'VML'  )
			this.tweakXandYAttributes_SVG( processData.items, dictionary );
		else if ( this.renderingEngine == 'svgWeb' )
			this.tweakXandYAttributes_svgWeb( processData.items, dictionary );

		 if ( this.renderingEngine == 'svgWeb' || this.renderingEngine == 'VML' && this.serverSideTextRendering == false ){
		 	dojox.gfx.Text.textDictionary = dictionary;
		 }



		//Pre-processing. Add 'highlight links' when critical path data exists
		this.genCriticalPathLinks( processData.links );

		//Seperate out the node data
		var nodesJSON = new Object();
			nodesJSON.label = 'label';
			nodesJSON.identifier = 'id';
			nodesJSON.items = processData.items;
		
		
		//And the links
		var linksJSON = new Object(); 
			linksJSON.items = processData.links;
			linksJSON.identifier = 'id';
			
		
		var linkStore = new dojo.data.ItemFileWriteStore({
			data: linksJSON
		});
			

		//Load it into memory.
		var store = new dojo.data.ItemFileWriteStore({
					data: nodesJSON
		});

		
		//Only display the overview for chrome and FF. Too slow for legacy IE.
		//
		// take out the pan/scan box
//		var overviewEnabled = !dojo.isIE;    
		var overviewEnabled = false;

		
         //Instantiate the viewer.
    	var params = this._getEditorParams(store, linkStore, overviewEnabled);
	
    	//Turn off link rendering until it's ready.
    	if ( !linkStore  ){
    		delete params.linkLayoutActive;
    		delete params.linksStore;
    		delete params.linksQuery;
    		delete params.linksGraphProperties;
    		delete params.linksGraphBinding;
    		delete params.startNodeBinding;
    		delete params.endNodeBinding;
    	}
    	
    	
       if ( this.ilogDiagrammer ){

			var diagram = this.ilogDiagrammer;

			diagram.set("nodesStore", store);
			diagram.set("linksStore", linkStore);
			
			diagram.load();       		
       	
       }else{	

	       var bpmnEditor = this.ilogDiagrammer = this.createILogWidget( params );

	       if ( this.zoomSlider ){
	       		this.connectZoomControl();
	       }

	       if ( this.printButton ){
	       	this.connectPrintButton();
	       }

	       
	       //Force svgWeb to repaint the screen every time the window is resized.
	       //This eliminates a class of bugs where resize changes the client area, but doesn't
	       //seem to cause the diagram to repaint properly.
			dojo.connect(window,"resize",function(n){
		
	  			window.setTimeout(function() {
	  				if ( ibm_ilog.diagram.isSvgWeb ){
		            		svgweb._onWindowResize();
		            	}
	                },1);
			});
			

       
   		}
 	  
		this._connectEventHandlers();

	},
	
	/**
	 * Provide the params when creating the widget. This allows for subclasses to customize the parameters without having to rewrite the
	 * displayEditor function.
	 * @param store
	 * @param linkStore
	 * @param overviewEnabled
	 * @returns {___anonymous11047_12514}
	 */
	_getEditorParams: function(store, linkStore, overviewEnabled) {
		var params =
		{
            nodesStore: store,
            nodesQuery:{id:'*'},
            nodesQueryOptions: {
                deep: true
            },
			childBinding: "children",
			successorsBinding: "successors",
			xBinding: "x",
			yBinding: "y",
			createLinksForHierarchy: false,
			createSubgraphFunction: dojo.hitch( this, 'createSwimLane' ),
			createNodeFunction: dojo.hitch( this, 'createNode' ),
			
			linkLayoutActive: false,
			linksStore:linkStore,
			linksQuery:{id:'*'},
            linksGraphBinding: "gfx",
            linksGraphProperties: "intermediatePoints",
            startNodeBinding: "start",
            endNodeBinding: "end",
            selectionMode: ibm_ilog.diagram.Selection.dataStore_multi,
  			nodeMenu: null,
				
			linkStyle: {shapeType: ibm_ilog.diagram.LinkShapeType.OrthogonalEditable, strokeWidth:1, strokeColor: 'gray' },
			onLinkCreated: dojo.hitch( this, 'onLinkCreated' ),
			onNodeCreated: dojo.hitch( this, 'onNodeCreated' ),
			
			linkTemplateFunction: dojo.hitch( this, "getLinkTemplate" ),
			
			nodeTemplateFunction: dojo.hitch( this, 'getNodeTemplate' ),
			onLoaded: function() { 
				ibm_ilog.diagram.util.Batch.endBatch();
				try{  
					//BPM Social 'Coach Toolbar Preview' requires it's owning window to be notified of document loading
					dojo.publish("com.ibm.bpm.social.Participants.loaded");
				} catch (e) {}
			},
			overview : overviewEnabled,
			move: false
		};
		
		return params;
	},

	/**
	 * Set the viewStateModel for this viewer
	 * @param viewStateModel
	 */
	setViewStateModel : function(viewStateModel) {
		this.viewStateModel = viewStateModel;
	},

	reset: function(){
		var diagram = this.ilogDiagrammer;
		diagram.reset();
	},

	_connectEventHandlers: function(){

		if(!!this.config)	{

			if (!!this.config["onMouseMove"]){
				this._connectionHandles.push(dojo.connect(this.ilogDiagrammer, "onMouseMove", null, this.config["onMouseMove"]));  
			}

			if (!!this.config["onNodeContextMenu"]){
				this._connectionHandles.push(dojo.connect(this.ilogDiagrammer, "onNodeContextMenu", null, this.config["onNodeContextMenu"]));  
			}
	 	   
			if (!!this.config["onNodeMouseLeave"]){
				this._connectionHandles.push(dojo.connect(this.ilogDiagrammer, "onNodeMouseLeave", null, this.config["onNodeMouseLeave"]));  
			}
		 
			if (!!this.config["onNodeMouseEnter"]){
				this._connectionHandles.push(dojo.connect(this.ilogDiagrammer, "onNodeMouseEnter", null, this.config["onNodeMouseEnter"]));  
			}
		 
			if (!!this.config["onNodeClick"]){
				this._connectionHandles.push(dojo.connect(this.ilogDiagrammer, "onNodeClick", null, this.config["onNodeClick"]));  
			}
			
		}
		
		// Remove when scrolling is fixed by iLog
		if (dojo.isChrome) {
			this._connectionHandles.push(dojo.connect(this.ilogDiagrammer.getViewport(), "onViewRectChanged", this, "scrollbarFix"));
		}
	},

	/**
	 Remove all registered event handlers.
	 **/
	_disconnectEventHandlers: function(){
		
		for ( var i = 0; i < this._connectionHandles.length; i++) {
			if(!!this._connectionHandles[i]){
				dojo.disconnect(this._connectionHandles[i]);
			}
		}

		this._connectionHandles = [];

	},
	
	destroy: function(){

		//No tear down necessary for IE. We're using images. 
		//Standard JavaScript collection will fix them.
		if (! this.serverSideImageRendering  ){
		
			try{
				this._disconnectEventHandlers();
			}catch( err ){}
	
			if( this.ilogDiagrammer )
				this.ilogDiagrammer.destroy();

		}
		
		this.inherited(arguments);
	
	},

	/**
	 Hook up print functionality
	 **/
	 connectPrintButton: function(){
		 // APAR JR45864
		 // When using Internet Explorer, the diagram does not print correctly
		 // because of transparency/opacity settings in the diagram.  We work
		 // around this by hiding all divs under the body and then moving our 
		 // diagram to be a child of the body.  We also need to hide all the 
		 // divs that are generated on top of the div because they cause blank
		 // areas in the diagram when printed.  After printing, the diagram is
		 // moved back to it's original position and all hidden divs are restored
  		 if (dojo.isIE) {
			 dojo.connect( this.printButton, 'onClick', this, function(e) { 
				var hideList = new Array();
			var c = document.body.firstChild;
			while (c) {
				if (c.nodeName && (c.nodeName.toLowerCase() == 'div')) {
					hideList.push({div:c, display:c.style.display});
					c.style.display = 'none';
				}
				c = c.nextSibling;
			}
			var c = this.editorPane.firstChild;
			while (c) {
				if (c.nodeName && (c.nodeName.toLowerCase() == 'div')) {
					hideList.push({div:c, display:c.style.display});
					c.style.display = 'none';
				}
				c = c.nextSibling;
			}
			var p = this.domNode.parentNode;
			var n = this.domNode.nextSibling;
			p.removeChild(this.domNode);
			document.body.appendChild(this.domNode);
				window.print(); 
				document.body.removeChild(this.domNode);
				p.insertBefore(this.domNode,n);
			while (hideList.length > 0) {
				var h = hideList.pop();
				h.div.style.display = h.display;
			}
			 });
		} else {
			dojo.connect( this.printButton, 'onClick', function(e) { window.print(); });
		}
	 },

	 /**
	 	Hook up the zoom control when there's an image used to display the process data.
	  **/
	 connectImageZoomControl: function(){
	 
	 	   this.zoomSlider.viewer =  this;
 	   	   var handle = dojo.connect( this.zoomSlider, "onChange", function(evt){
			
			//Find the image
			var editor = this.viewer.editorPane;
			var image = dojo.query( 'img', editor )[0];

			//Work out the scaling factor. Zooming goes in a straight line from 25% to 100%

		   	//Figure out what the zoom level is for 'shrink to fit'
		   	if ( this.viewer.editorContainer ) {
		   		var scalingFactor = Math.min( 
		   				(this.viewer.editorContainer.h - 20) / this.viewer.data.height, 
		   				(this.viewer.editorContainer.w - 20) / this.viewer.data.width,
		   				this.viewer.data.height / (this.viewer.editorContainer.h - 20), 
		   				this.viewer.data.width / (this.viewer.editorContainer.w - 20));
 	   	   } 
		   	else {
		   		var scalingFactor = Math.min( 
		   				(this.viewer.bpmnInspector.offsetHeight - 20) / this.viewer.data.height, 
		   				(this.viewer.bpmnInspector.offsetWidth - 20) / this.viewer.data.width ,
		   				this.viewer.data.height / (this.viewer.bpmnInspector.offsetHeight - 20), 
		   				this.viewer.data.width / (this.viewer.bpmnInspector.offsetWidth - 20) );
		   	}
		   		
		   	var scaling =  ((1-scalingFactor)/9) * evt + (1-10*scalingFactor)/(-9);

			//var scaling = .075 * evt + .25;
				
			//Original width 
			var h = image.offsetHeight;
			var w = image.offsetWidth;

			//Translate that into pixels
			var width = Math.round( this.viewer.data.width * scaling ) + "px";
			var height = Math.round( this.viewer.data.height * scaling ) + "px";

			image.style.height  = height;
			image.style.width = 'auto';			//There seems to be a bug with image width from the server. Let the browser do the math.

			var events=['start', 'adhocStartEvent', 'timerStartEventInterrupting', 'timerStartEventNonInterrupting', 'msgStartEventNonInterrupting', 'errorStartEvent', 'intermediateEvent', 'intermedCatchMsgEventNonBoundary', 'intermediateMessage', 'intermedCatchMsgEventNonBoundary', 'intermedCatchTrackingEventNonBoundary' , 'intermediateThrowMsgEvent', 'stop', 'end', 'endException', 'errorEndEvent', 'timer' , 'intermedCatchTimerEventNonBoundary' ,  'terminate', 'messageEndEvent', 'gateway', 'gatewayEvent' , 'gatewayAnd' ,  'gatewayOr'];

			//Speculative... 
			var divs = dojo.query( 'div', editor );
			for ( var i = 0; i < divs.length; i++ ){
			
				var div = divs[i];
				var id = div.getAttribute( 'name');

				var item = this.viewer.IDtoItemMap.item( id );

				var location = this.viewer.getActivityLocation( id );
				console.debug( "Node: " + item.label + " is at: " + location.x + "/" + location.y );
				
				if ( dojo.indexOf(events, item.type) ==  -1  ){
					//Handle activities
					div.style.top = Math.round( location.y * scaling ) + "px";
					div.style.left = Math.round( location.x * scaling ) + "px";
					div.style.width = Math.round( 95 * scaling ) + "px";
					div.style.height = Math.round( 70 * scaling ) + "px";
				}else{
					//Handle gateways and events
					div.style.top = Math.round( location.y * scaling ) + "px";
					div.style.left = Math.round( ( location.x + 15 ) * scaling ) + "px";
					div.style.width = Math.round( 32 * scaling ) + "px";
					div.style.height = Math.round( 32 * scaling ) + "px";
				}
			}
			
			var imgs = dojo.query( 'img', editor );
			for ( var j = 0; j < imgs.length; j++ ){
				var img = imgs[j];
				var id = img.getAttribute( 'name');
				if (id) {
					var item = this.viewer.IDtoItemMap.item( id );
					var location = this.viewer.getActivityLocation( id );
					img.style.top = Math.round( (location.y + 4) * scaling ) + "px";
					img.style.left = Math.round( (location.x + 7)* scaling ) + "px";
					img.style.width = Math.round( 16 * scaling ) + "px";
					img.style.height = Math.round( 16 * scaling ) + "px";
					img.width = Math.round( 16 * scaling ) + "";
					img.height = Math.round( 16 * scaling ) + "";
				}
			}
 	   		
 	   	   });

	 },
	 
	 
	 zoomTriggered: function() {
		 //To be subclassed. Do nothing here, probably will remove after I1
	 },
	 

	//Hook up the zoom control so it can resize the editor
	 connectZoomControl: function(){
		 this.zoomSlider.diagram =  this.ilogDiagrammer;
		 var viewer = this;
		 var handle = dojo.connect( this.zoomSlider, "onChange", function(evt){

			 //Find the active diagram
			 var diagram = this.diagram;

			 //The slider should allow the user to toggle between 100% zoom and 'shrink to fit'
			 var graph = diagram.getGraph();
			 var box = graph.getBoundingBox();

			 var vSize = diagram.getViewport().getClientSize();

			 //Figure out what the zoom level is for 'shrink to fit' 
			 var scalingFactor = Math.min( 
					 vSize.height / box.height, 
					 vSize.width / box.width, 
					 box.height / vSize.height, 
					 box.width / vSize.width );

			 //For now, assume that the horizontal slider goes from 1 to 10
			 //Do some math to ensure that maps to the correct zoom range
			 var zoomFactor =  ((1-scalingFactor)/9) * evt + (1-10*scalingFactor)/(-9);

			 console.debug( "Zoom to: " + zoomFactor );
			 
			 viewer.zoomLevel = zoomFactor;

			 var V = diagram.getViewport();
			 var currentZoom = V.getZoom();
			 console.debug( "Current Zoom is: " + currentZoom );

			 V.setAnimated(true);

			 var __set = ibm_ilog.diagram._base.dojoext.SetAttrName;

			 diagram[__set]('overviewSize', {
				 width: 120,
				 height: 70
			 });
			 V.setHudEnabled(true);

			 V.setZoom(zoomFactor, {});
			 viewer.zoomTriggered();

		 }
		 );

		 this._connectionHandles.push( handle );
	 },


	

	/**
		The server assumes that items are places with the x & y co-ordinates representing the upper left location of the base shape.
		ILog uses the entire graph, which for events can shrink or expand as text is added to the node.
		Walk the list of items tweaking the x & y co-ordinates to accomodate this.
	 **/ 
	tweakXandYAttributes_SVG: function( items, dictionary ){

		for ( var i = 0; i < items.length; i++ ){
			var item = items[i];

			var type = item.type;
			var label = item.label;
			//

			//Co-ordinate transformation is only necessary for events. Ignore everything else
			if (  item.type == 'note' || item.type == 'milestone'  || item.type == 'group'){
				continue;
			}
			else if ( item.type == 'swimlane'){
				this.dictionary.remove( label );
			
			}
						
			else if (item.category == 'BoundaryIntermediateEvent' ){
				if ( item.counter )
					item.y = item.y -15;

				delete item.label;
			}
			else if ( item.type == 'activity' ){
				//Move the node up to compensate for the text being added to the top of the node
				if ( item.counter && this.renderingEngine == 'Silverlight'){
					item.y = item.y - 21;
				}
				else if ( item.counter && this.renderingEngine == 'VML' )
					item.y = item.y - 10;
				else if ( item.counter ){
					item.y = item.y - 17.3;
				}
				
			}
			else if ( type == 'gateway' || type == 'gatewayOr' || type == 'gatewayAnd'  || type == 'gatewayEvent'){
				item.x = item.x+13;
				item.y = item.y;
			}
			else{
				var x = item.x;
				var y = item.y;
				
				//console.warn("item.label(1): ",item.label);
				
				var labels = dojo.isArray(item.label) ? item.label : item.label.split( "\n");

				//Add offset for counter labels
				if ( item.counter ){
					item.y = item.y -15;
				}

				//Assume each line of text is fifteen pixels tall and adjust the y value
				var yDelta = 15 * (labels.length  / 2);
				//item.y = item.y - yDelta;
				//item.y = item.y +3;

				var node_width = 24;

				//Assume each node is 24 pixels wide and check for labels that are larger than that.
				for ( var i2 = 0; i2 < labels.length; i2++ ){
					var text = labels[i2];
					var bounds = dictionary.item( text );

					//Sanity check...
					if ( !bounds )
						continue;

					node_width = Math.max( bounds.width, node_width );
				}

				var xDelta = (node_width - 24 ) / 2;
				item.x = item.x - xDelta +22;

				//console.debug( "Setting " + item.label + ", of type " + item.type + ", to be (" + item.x + "/" + item.y +") with deltas of (" + xDelta + "/" + yDelta +")" );
				//
			}

		}
				
	},


	/**
		Same logic as the SVG transform code but take into condsideration the new graphic labels.
	 **/ 
	tweakXandYAttributes_SVG_VML: function( items, dictionary ){

		for ( var i = 0; i < items.length; i++ ){
			var item = items[i];

			var type = item.type;
			var label = item.label;

			//Co-ordinate transformation is only necessary for events. Ignore everything else
			if (  item.type == 'note' || item.type == 'milestone'  || item.type == 'group'){
				continue;
			}
			else if ( item.type == 'swimlane'){
				this.dictionary.remove( label );
			
			}
			else if (item.category == 'BoundaryIntermediateEvent' ){
				if ( item.counter )
					item.y = item.y -15;

				delete item.label;
			}
			else if ( item.type == 'activity' ){
				//Move the node up to compensate for the text being added to the top of the node
				 if ( item.counter )
					item.y = item.y - 10;
							
			}
			else if ( type == 'gateway' || type == 'gatewayOr' || type == 'gatewayAnd'  || type == 'gatewayEvent'){
				item.x = item.x+3;
			//	item.y = item.y;
			}
			else{
				// var x = item.x;
				// var y = item.y;
				// var labels = item.label.split( "\n");

				// //Add offset for counter labels
				// if ( item.counter ){
				// 	item.y = item.y -15;
				// }

				

				// //Assume each line of text is fifteen pixels tall and adjust the y value
				// var yDelta = 15 * (labels.length  / 2);
				// //item.y = item.y - yDelta;
				// //item.y = item.y +3;

				// var node_width = 24;

				// //Assume each node is 24 pixels wide and check for labels that are larger than that.
				// for ( var i2 = 0; i2 < labels.length; i2++ ){
				// 	var text = labels[i2];
				// 	var bounds = dictionary.item( text );

				// 	//Sanity check...
				// 	if ( !bounds )
				// 		continue;

				// 	node_width = Math.max( bounds.width, node_width );
				// }

				// var xDelta = (node_width - 24 ) / 2;
				// item.x = item.x - xDelta +22;

				// //console.debug( "Setting " + item.label + ", of type " + item.type + ", to be (" + item.x + "/" + item.y +") with deltas of (" + xDelta + "/" + yDelta +")" );
				// //
			}

		}
				
	},

	/**
		The server assumes that items are places with the x & y co-ordinates representing the upper left location of the base shape.
		ILog uses the entire graph, which for events can shrink or expand as text is added to the node.
		Walk the list of items tweaking the x & y co-ordinates to accomodate this.
	 **/ 
	tweakXandYAttributes_svgWeb: function( items, dictionary ){
		
		for ( var iCtr = 0; iCtr < items.length; iCtr++ ){

			var item = items[iCtr];

			var type = item.type;
			//Gateway icons never seem to be in the right place. Tweak the placement for better graph layout.

	
			if ( item.type == 'note' || item.type == 'milestone' || item.type == 'swimlane' || item.type == 'group' ){
				//Do nothing...
			}else if (  item.category == 'BoundaryIntermediateEvent' ){
				if ( item.counter ){
					item.y = item.y -15;
					item.x = item.x -20;
				}

				delete item.label;
			}
			
			else if ( item.type == 'activity' ){
				if ( item.counter )
					item.y = item.y - 15;
			}
			else if ( type == 'gateway' || type == 'gatewayOr' || type == 'gatewayAnd' || type == 'gatewayEvent'){
				item.x = item.x + 5;
				//item.y = item.y +4;
			}else{
				//Event icons. 
				if ( item.counter )
					item.y = item.y - 16;
			}
						

			if ( !item.label )
				continue;
			
			var labels = item.label.split( "\n");
			
			
			for ( var i = 0 ; i < labels.length; i++ ){

				var text = labels[i];


				if ( !text || text.length == 0 )
					continue;

				var bounds = dictionary.item( text );

				if ( !bounds )
					continue;

				if ( item.type == 'activity' ){


					bounds.x = -19;
					bounds.y = -2 + (i * 15.33);

					bounds.width = 68;
					bounds.height = 15.33;
				}
				else if ( item.type == 'note' ){

					bounds.x = 20;
					bounds.y = -3 + ( i * 15.33);
					bounds.width = 68;
					bounds.height = 15.3;
					console.debug( "Setting note text: '" + text + "' to be: " + dojo.toJson( bounds) );
				}
				else if ( item.type == 'milestone' || item.type == 'swimlane' || item.category ==  'BoundaryIntermediateEvent' ){
					//No processing needed. (TODO: double check that for milestones)
					continue;
				}
				else{
					//Events..
					bounds.x = -34;
					bounds.y = -13 + ( i* 15.3 );
					bounds.width = 68;
					bounds.height = 15.3;
				}

				dictionary.add( text, bounds );
			}
			
		}
				
	},

	/**
	 Critical path links are supposed to be rendered as a blue link with a blue 'halo' behind them. 
	 There's no easy way to do this on ILog, go find the affected links and generate a second link for the halo
	 effect.
	 **/
	genCriticalPathLinks: function( links ){

		var updates = [];
		
		if ( !links || links.length == 0 )
			return;

		for ( var i = 0; i < links.length; i++ ){
			var link = links[i];
			
			if ( link.inCriticalPath ){
				var hLink = dojo.clone( link );
				hLink.highlight = true;
				hLink.id = link.id + "_highlight";
				delete hLink.inCriticalPath;
				updates.push( hLink );
			}

		}


		for ( i = 0; i < updates.length; i++ ){
			links.splice( 0, 0, updates[i] );
		}

	},


	/**
	 Instantiate the ILog widget to displayt the graph contents
	 **/
	createILogWidget: function(params){
		
		var widget = this.ilogDiagrammer = new ibm_ilog.diagram.widget.Diagram( params, this.editorPane );	
        widget.startup();
		
		//Event hook. Allow external callers to register a callback that will be invoked
		//Once the diagram is fully loaded into memory.
		//Note: This routine works well with svgWeb, but doesn't usually fire with svg.
		//		Modern browsers are simply to fast. Rendering completes before this line is 
		//		executed.
		dojo.connect( widget, "onLoaded", dojo.hitch( this, function(){
			
			if ( this.onDiagramLoad )
				this.onDiagramLoad(this.viewStateModel.type);


			if ( this.mainBC )
				this.mainBC.resize();

			if ( ibm_ilog.diagram.isSvgWeb ){

				window.setTimeout(function() {
	  			   		svgweb._onWindowResize();
		         },1);
			
			}
		}));

		//Force a resize event once the window has finished rendering. Required to get scrollbars to show up properly.
		window.setTimeout( dojo.hitch( this, function(){
			this.ilogDiagrammer.resize();
		}), 1);
		
		this.a11y();
		return widget;
	},

    a11y: function() {//Accessibility - Fix RPT violation
        if (this.zoomSliderContainer && this.zoomSliderContainer.firstChild && this.zoomSliderContainer.firstChild.nextSibling) {
            if (this.zoomSliderContainer.firstChild.nextSibling.nodeName.toUpperCase() == 'TABLE') {
                dijit.setWaiRole(this.zoomSliderContainer.firstChild.nextSibling,"presentation");
            }
        }
        dojo.query(".dijitSlider").forEach(function(node, index, arr){
              if (node.nodeName && node.nodeName.toUpperCase() === 'TABLE') {
                  dijit.setWaiRole(node,"presentation");
              }
          });
    },

	/**
	 * Debug: Load the input data from a file on the server.
	 */
	getLocalData: function(){
		
		var nodes;

		var url = "HRSample2.json";
		if ( this.restURL )
			url = this.restURL;

		
		var xhrArgs = {
                url: url,
                handleAs: "json",
                sync: true,
                load: function(data) {
                	
                	if ( data.data )
                		nodes = data.data;
                	else
                		nodes = data;
                
                },
                error: function(error) {
                    alert( error );
                }
            }

            //Call the asynchronous xhrGet
            var deferred = dojo.xhrGet(xhrArgs);
            return nodes;
		
		
	},
	
	
	
	/**
	 Code to create a swim lane.
	 @param: item - Dojo data item with key / value pairs describing the location and size of the lane.
	 @param: template - Location of code to use when generating the shape of the swim lane.
	 @param: graph: Drawing surface.
	 @param: diagram - DiagramEditor object
	 **/
	 createSwimLane: function(item, template, graph, diagram) {


	 	//var t = ibm_ilog.diagram.templates.defaultSwimLaneTemplate;
	 	var t = this.templates.swimlaneTemplate;

	 	//Flash can't, currently, handle rotated text. Replace the swimlane header with a graphic from the server.
	 if ( this.renderingEngine == 'svgWeb' || ( this.renderingEngine =='VML' && this.serverSideTextRendering)){
	 		t = this.templates.flashSwimlaneTemplate;
	 			
	 		//Walk the template to find where the header contents are defined.
	 		var titleShape = t[0].children[1].children[1].children[0];

	 		var poId = this.data.poId;
	 		var poVersionId = this.data.poVersionId;
	 		var flowObjId = item.id[0];
	 		var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST) + "/v1/diagramImage?poId=" + poId + "&poVersionId=" + poVersionId + "&flowObjId=" +  flowObjId;
	 		titleShape.shape.src = url;
	 		titleShape.shape.height = item.height[0];
	 	}
	
	   //Set swimlane background color to white by default
	   t[0].children[3].fill = '#FBFAFF';

	   //Override the default, if necessary
	   if ( item.color ){
			var code = this.getHTMLColorCode( item );
			t[0].children[3].fill = code;
	   }
		 
	 	var swimlane = diagram.createTemplatedShape(ibm_ilog.diagram.SwimLane, t, graph, {
			vertical: false,
			rightToLeft: false
		}, diagram.nodesStore, item);
		
	

	 	var width = item.width[0];
	 	var height = item.height[0];
		swimlane.setExplicitSize({
			width: width,
			height: height
		});
		
		/*
		var x = diagram.nodesStore.getValue(item, "x");
		var y = diagram.nodesStore.getValue(item, "y");
	    swimlane.move(x, y);
	    */
	    
		// modify text direction
		var label = item.label[0];
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(label);
		if (dir=="rtl") {
			if (swimlane.titleShape) {
				if (swimlane.titleShape.rawNode && "text"==swimlane.titleShape.rawNode.tagName) {
					// find the text node
					var textNode = swimlane.titleShape.rawNode;
					if (dojo.isIE) {
						textNode.setAttribute("dir", "rtl");
					}
					else
						textNode.setAttribute("direction", "rtl");
				}
			}
	 	}
		
		return swimlane;
	},

	/**
	 *  Translate an item's WLE color code into HTML
	 */
	getHTMLColorCode: function( item ){
			var code = '#FBFAFF';		//default white

			var color = item.color[0];

	   		if ( color == 'Green')
	   			code = '#DCF6DE';
	   		else if ( color == 'Blue')
	   			code = '#D6E5FC';
	   		else if ( color == 'Purple' )
	   			code = '#EADAF8';
	   		else if  ( color == 'Red' )
	   			code = '#F7DBDB';
	   		else if ( color == 'Orange' )
	   			code = '#FFEAD3';
	   		else if ( color == 'Yellow' )
	   			code = '#FFFDD3';
	   		else if ( color == 'Gray' )
	   			code = '#C4C7B9';
	   		else if ( color = 'Default' && item.isSystem && item.isSystem[0] ){
	   			code = "#F6F6F6";
	   		}

	   		return code;
	},
	
	
	 /**
	  * Call back function invoked when a new node is created to return the correct templated shape.
	  * 
	  * @param item
	  * @param template
	  * @param graph
	  * @param diagram
	  * @returns The correct templated shape.
	  */
	createNode: function(item, template, graph, diagram){
		
		var shape;

			//Special handling for empty swim lanes. 
			//ILog assumes they're nodes. We need to specify otherwise.
			if ( item.type[0] == 'swimlane' ){
				shape = this.createSwimLane(item, template, graph, diagram);
			}
			else{
				shape =  diagram.createTemplatedShape(ibm_ilog.diagram.Node, template, graph, diagram.nodeStyle, diagram.nodesStore, item);
			}

			return shape;
	},


	/**
	 * Function callback for when a node is created.
	 * Perform processing that requires the node exist, but not necessarily be visible just yet.
	 * @param node
	 */
	 onNodeCreated: function( node ){

	 	var item = node._data.item;
	 	
	 	//Node id
		var id = item.id[0];

		//Add event handler for drill down
	 	try{

	 		//If there's extra 'config' handlers then we're iBPM or Process Portal. Only drill down for Event Subprocess or Linked Sub-Process nodes
			var implType = item.bpmn2TaskType ? item.bpmn2TaskType[0] : "n/a";
			var isPortalNode  = (( implType == 'Event_SubProcess' || implType == 'CalledProcess' ||  implType == 'SubProcess'  ) && this.config && item.poId );
			var isViewerNode = ( item.poId && !this.config );

			var label = item.label[0];
			
			if(dojo.isIE && this.config && this.config["onNodeContextMenu"]){
				/*
				 * IE9 does not handle events as expected in normal SVG viewing.  We need
				 * to hook into these event handlers to pass up the correct Node information
				 * to display the correct context-menu.  Left-click events bubble up fine, however
				 * by default, right-click events still show the page level browser-provided context menu.
				 * In Particpants (a process diagram consumer), we look for this window variable, and if set,
				 * use it's values to simulate the expected right-click event supported in other browsers.
				 */
				
				this._connectionHandles.push( node.connect("onmouseover", this, function(){
					//console.warn("setting window.currentDiagrammerNode");
		 			window.currentDiagrammerNode = node;
				}));
		 		
		 		this._connectionHandles.push( node.connect("onmouseout", this, function(){
		 			//console.warn("clearing window.currentDiagrammerNode");
	 				window.currentDiagrammerNode = null;
		 		}));
			}
			
		 	if ( isViewerNode || isPortalNode ){

		 		this._connectionHandles.push( node.connect("onclick", node, this.drillDown) );

		 		var viewer = this;
		 		// Add a keyboard event to listen for the enter key to allow drill down. I'm guessing this could be doen with
		 		// an interactor, I'm just not sure hot to use them. As well I'd like to trigger the even for the node only (no global)
		 		// but that doesn't appear to be working
		 		this._connectionHandles.push(dojo.connect("onkeypress", node, function(e){
		 			if (e.type == "keypress") {
		 				var keyPressedValue = e.which ? e.which : e.keyCode;
		 				if (keyPressedValue != dojo.keys.ENTER) {
		 	 				return;
		 	 			}
		 				var tData = this.viewer.ilogDiagrammer.getFocusedElement()._data;
		 				if (tData.item.id[0] != this._data.item.id[0])
		 					return;
		 			}
		 			viewer._data = this._data;
		 			viewer.drillDown(e);
		 		}) );
		 		
		 		//this._connectionHandles.push( node.connect("onkeyup", node, this.drillDown) );
		 		//this._connectionHandles.push( node.connect("onkeydown", node, this.drillDown) );

		 		//if (  this.renderingEngine  != 'svgWeb'){
			 		
			 		this._connectionHandles.push( node.connect("onmouseover", this, function(){
			 			document.body.style.cursor = 'pointer';
			 		}));
			 		
			 		this._connectionHandles.push( node.connect("onmouseout", this, function(){
			 			document.body.style.cursor = 'default';
			 		}));

		 		//}

		 	}else if ( this.config && item.counter ){
		 		//Active node for Process Portal. Update the cursor to make it clear
					this._connectionHandles.push( node.connect("onmouseover", this, function(){
			 			document.body.style.cursor = 'pointer';
			 		}));
			 		
			 		this._connectionHandles.push( node.connect("onmouseout", this, function(){
			 			document.body.style.cursor = 'default';
			 			
			 		}));		 		
		 	}
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(label);
			if (dir=="rtl") {
				this.modifyTextDir(node);
			}

		}catch( err ){
			console.debug( "Exception (" + err.message + ") connecting to node ("  + node._label + ") for drill down.");
		}
		
		/**
		 Silverlight doesn't offer a context menu hook for the diagram, but it does have one for individual node GEs. 
		 Register that here for active nodes, when necessary. 
		 **/
		if ( this.config && this.config["onNodeContextMenu"] && item.counter && this.renderingEngine == 'Silverlight'){
			console.debug( "Connecting RC handler to node: " + item.label[0] );
			node.connect(  "MouseRightButtonDown", node, this.config["onNodeContextMenu"] );
		}

		//Event group images are always at the back. Make sure this happens.
		var type = item.type[0];
		if ( type == 'group'){
			node.moveToBack();
		}
		
		//If this is an active task, then save a flag for further reference.
		if ( this.data.activeTasks && this.data.activeTasks[id] ){
			node.isActive = true;
		}

		//Save a backpointer to the BPDViewer code so event handlers can get access to the diagram and/or data
		node.viewer = this;

	},
	
	/**
	 * Modify the text direction given a node.
	 * @param node
	 */
	modifyTextDir: function(node) {
		if (node.textShape) {
			if (node.textShape.children) {
				for (var i=0; i<node.textShape.children.length; i++) {
					if (node.textShape.children[i].rawNode) {
						if ("text"==node.textShape.children[i].rawNode.tagName) {
							// find the text node
							var textNode = node.textShape.children[i].rawNode;
							if (dojo.isIE) {
								textNode.setAttribute("dir", "rtl");
							}
							else
								textNode.setAttribute("direction", "rtl");
						}
					}
				}
			}
		}
	},

	/**
	  iBPM support.
	  Add a status icon to the upper right of an existing icon.
	  @param: id - id of node to decorate
	  @param: online - boolean value representing if the user is online or not
	  @param: name - User name to add to the top of the decoration
	 **/
	decorate: function( id ){
		
		
		var diagram = this.ilogDiagrammer;
		var graph = diagram.getGraph();

		//Get the data item
		var item = this.getNode( id );



		//And the graph item
		var node = diagram.getGraphElementFromDataItem(item);

		//Where's the original node?
		var x = item.x[0];
		var y = item.y[0];

	
		//All nodes that we care about have a parent.
		var sw = node.getParent()._owningSubgraph;
		var swData = sw.getData().item;
		
		//var sg = node.getParent().getOwningSubgraph();
		

		var newItemCounter = 1;

		var template = this.templates.iBPMTemplate;
		template.children[1].children[0].shape.src = this.iconURL + "collaborate_blog.gif";

		//Create the new node (this will cause createNode to fire as well.)
	    var newItem = diagram.nodesStore.newItem({
	        id: "Item " + newItemCounter++,
	        label: "Jon Bennett",
	        x: x + 70,
	        y: y -30,
	        type: 'iBPM'
	    },{
	        parent: swData,
	        attribute: "children"
	    });
				


	},


	/**
		getNode
		Return a node that correponds to a given id value
	 **/
	 getNode: function( id ){
	 	
	 	//Get the iLog diagram widget
  		var diagram = this.ilogDiagrammer;

  		//All nodes in the diagram
  		var nodes = diagram.nodesStore;


	  	//Query the store for a given link
	  	var node;
	  	nodes.fetchItemByIdentity({
	  		identity: id,
	  		onItem : function( item, request) {
	  			node = item;
	  		}
	  	})

	  	return node;

	 },


	/**
	Implement drill down logic.
	params:  e 		- mouse event object
			 this 	- GE node object
	 **/
	drillDown: function(e) {

		var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();

		//User clicked on a node. Pull information from the diagram.
		if ( this._data )		
			var data = this._data.item;
		else{
			//Each transparent <div> keeps its originating item in the name field
			var id = e.target.getAttribute( 'name' );
			var data = this.IDtoItemMap.item( id );
		}
		
		var params = {};
	
		if ( data.poId )
	    	params.documentId = dojo.isArray(data.poId) ? data.poId[0] : data.poId;
	
	    if ( data.snapshotId )
	    	params.snapshotId = dojo.isArray(data.snapshotId) ? data.snapshotId[0] : data.snapshotId;
	    
	    if ( data.branchId )
	    	params.branchId = dojo.isArray(data.branchId) ? data.branchId[0] : data.branchId;

	    if ( data.poType && data.poType == 'Service' ){
	    	params.assetType  = data.serviceType;
	    }
	    
	    /* Check to see if we're navigating into a local subprocess, if so record the rootId (either pass it through if
	    it's already set or I am the root and take my id.
	    */
	    var bpmn2TaskType;
	    if (data.bpmn2TaskType)
	    	bpmn2TaskType = dojo.isArray(data.bpmn2TaskType) ? data.bpmn2TaskType[0] : data.bpmn2TaskType;
	    	
	    if (bpmn2TaskType && bpmn2TaskType =="SubProcess") {
	    	
	    	// Interesting situation depending on the browser being used and the path taken to get here the viewStateModel might exist in
	    	// two different location, directly on the this or in an attribute viewer.params
	    	if (this.viewer) {
		    	if (this.viewer.params.viewStateModel.rootId)
		    		params.rootId = this.viewer.params.viewStateModel.rootId;
		    	else
		    		params.rootId = this.viewer.params.viewStateModel.documentId;
	    	}
	    	else {
	    		if (this.viewStateModel.rootId)
		    		params.rootId = this.viewStateModel.rootId;
		    	else
		    		params.rootId = this.viewStateModel.documentId;
	    	}
	    }
	    
	    if(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().state == com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().STATE_PORTAL){
	    	params.type = "ProcessInstanceType";
	    	if (data.bpmn2TaskType) {
	    		var bpmnTaskType = dojo.isArray(data.bpmn2TaskType) ? data.bpmn2TaskType[0] : data.bpmn2TaskType;
	    		if (bpmnTaskType == 'SubProcess' || bpmnTaskType == 'Event_SubProcess' || bpmnTaskType == 'CalledProcess') {
		    		params.subProcParentId = dojo.isArray(data.id) ? data.id[0] : data.id;
		    	}
	    	}
	    }
	    params.documentName = dojo.isArray(data.label) ? data.label[0] : data.label;
	    openDocEvent.params = params;
	    openDocEvent.dispatch();
		
		
	},
	
	/**
		Define the appearance of different types of links.
	 **/
	getLinkTemplate: function( item, store, diagram ){
		
		var template;

		
		if ( item.needDefaultMarker && item.needDiamondMarker[0] == true )
			template = this.templates.linkDiamondTemplate;
		else if ( item.needDefaultMarker && item.needDefaultMarker[0] == true )
			template =  this.templates.linkConditionTemplate;
		else
			template = this.templates.linkTemplate;

		/**
			 Process Portal support. 
			 If this link is designated as 'critical path'
			 then we need to visually change the line's appearance.
		 **/
		if ( item.inCriticalPath && item.inCriticalPath[0] == true ){
			template = dojo.clone( template );
			template[0].stroke.color = '#000081';
			
			template[1].stroke.color = "#000081";
			template[1].fill = "#000081";
			if ( template.length == 3 ){
				template[2].stroke = "#000081";
			}
		}else if ( item.highlight ){
			template = dojo.clone( template );
			template[0].stroke.color = '#EBF3FD';
			template[0].stroke.width = 6;
			template.splice( 1, 2 );
		}


		return template;
	},
	
	/**
		This the heart of the viewer code. 
		It will inspect an items' type information and generate 
		Return the appropriate node template (GFX diagram) for a given type of node.
	 **/
  getNodeTemplate: function(item, store, diagram) {
 	var type = item.type[0]; 

 	var label = item.label ? item.label[0] : 'n/a';
 	 	
 	var id = item.id ? item.id[0] : 'n/a';

 	var eventTemplate = this.templates.complexEventTemplate;
 

 	/**
 		VML has astonishingly slow text rendering. 
 		Make sure we don't actually display text labels underneath the nodes. 
 		Use server side generated images for text instead. 
 	 **/
 	if (this.renderingEngine == 'VML' && this.serverSideTextRendering == true){
 		eventTemplate = dojo.clone( this.templates.complexVMLTemplate );

 		//Magic URL to specify where the label text has been generated. 
 		var poVersionId = this.data.poVersionId;
 		var flowObjId = item.id[0];
		var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST) + "/v1/diagramImage?poVersionId=" + poVersionId + "&flowObjId=" +  flowObjId;

 		var lblImage = eventTemplate.children[2].shape;
 		lblImage.src = url;
 		
 	}else{
		eventTemplate = dojo.clone( this.templates.complexEventTemplate ); 		
 	}
 
 	var eventBaseShape = eventTemplate.children[1].children[0];
 
 	
 	/*******************************************************************************
 	 							Events
 	********************************************************************************/

 		/********************* Start Events *********************/

 	if ( type == 'start' ){
 		//Blue circle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "None_Start_Event_24x24.png";

 	}
 	else if ( type == 'adhocStartEvent'){
 		//Blue circle with white flag in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Ad_Hoc_Start_Event_24x24.png";
 	}
 	else if ( type == 'startMessage'  || type == 'msgStartEventInterrupting' )
 	{
 		//Blue circle with white envelope in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Message_Start_Event_24x24.png";
 	}
 	else if ( type == 'contentMessage'  || type == 'contentStartEventInterrupting' )
 	{
 		//Blue circle with white envelope in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Content_Start_Event_24x24.png";
 	}
 	else if ( type == 'timerStartEventInterrupting'){
 		
 		//Blue circle with clock  in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Timer_Start_Event_24x24.png";
 	}
 	else if ( type == 'timerStartEventNonInterrupting' ){
 		
 		//Blue circle with dotted border clock  in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "NI_Timer_Start_Event_24x24.png";
 
 	}
 	else if ( type == 'msgStartEventNonInterrupting' ){
 		//Blue circle with dotted border clock  in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "NI_Message_Start_Event_24x24.png";
 	
 	}
 	else if ( type == 'contentStartEventNonInterrupting' ){
 		//Blue circle with dotted border clock  in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Content_Start_Event_-_NI_24x24.png";
 	
 	}
 	else if ( type == 'errorStartEvent'){
 				//Blue circle with dotted border clock  in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Error_Start_Event_24x24.png";
 
 	}


 	/********************* Intermediate Events *********************/
 	// (All Intemediate Events have a blue circle and a double border)

 	 else if ( type == 'intermediateEvent'  || type == 'intermedCatchMsgEventNonBoundary'){
 	 	//Blue circle with double (white) border and envelope
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Receive_Message_Event_24x24.png";
 	}

 	else if ( type == 'intermediateMessage' || type == 'intermedCatchMsgEventNonBoundary' )
 	{
 		//White envelope in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Receive_Message_Event_24x24.png";
 	}
 	
 	else if ( type == 'intermediateContent' || type == 'intermedCatchContentEventNonBoundary' )
 	{
 		//White envelope in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Content_Intermediate_Event_-_Catching_24x24.png";
 	}

 	else if ( type == 'intermedCatchTrackingEventNonBoundary' ){
 		//Black flag in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Tracking_Intermediate_Event_24x24.png";
 	}

 	else if ( type == 'intermediateThrowMsgEvent'){
 		//Black envelope in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Send_Message_Event_24x24.png";
 	}

 	//TODO: IS this still in the model?
 	else if ( type == 'intermediateException'  || type == 'intermedCatchMsgEventNonBoundary'){
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Error_Boundary_Event_24x24.png"
 	}


	/********************* Intermediate Events *********************/
 	// (All Intemediate Events have a blue circle and a thick black border)

 	else if ( type == 'stop'|| type == 'end' )
 	{
 		//Blue circle with black border
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "None_End_Event_24x24.png";
 	}
 	else if ( type == 'endException' || type == 'errorEndEvent' ){
 		//Black lightning bolt
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Error_End_Event_24x24.png";
 	}
 	else if ( type == 'timer' || type == 'intermedCatchTimerEventNonBoundary' ){
 		//Deprecated?
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Timer_Intermediate_Event_24x24.png";
 	}
 	else if ( type == 'terminate' ){
 		//Black circle in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Terminate_End_Event_24x24.png";
 	}
 	else if ( type == 'messageEndEvent' ){
 		//Thick black border and black envelope in middle
		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Message_End_Event_24x24.png";
 	}

	/*******************************************************************************
 	 							iBPM
 	********************************************************************************/

 	else if ( type == 'iBPM' ){
		var template = this.templates.iBPMTemplate;
		template.children[1].children[0].shape.src = this.iconURL + "collaborate_blog.gif";
		return template;

 	}

	/*******************************************************************************
 	 							Gateways
 	********************************************************************************/
 	/*
	else if ( (type == 'gateway' || type == 'gatewayEvent' || type == 'gatewayAnd' || type == 'gatewayOr'  ) && this.renderingEngine == 'VML'){


		console.debug( "VML image for Gateway: " + item.label[0] );
		
		//Special handling for Gateway Events with VML. Text labels (underneath the diamond image) are rendered as 
		//images on the server.		
		var template =  dojo.clone( this.templates.complexVMLTemplate );

 		if ( type == 'gateway' )
			template.children[1].children[0].shape.src = this.iconURL + "Exclusive_Gateway_32x32.png"; 		
		else if ( type == 'gatewayEvent')
			template.children[1].children[0].shape.src = this.iconURL + "Event_Gateway_32x32.png";	
		else if ( type == 'gatewayAnd')
			template.children[1].children[0].shape.src = this.iconURL + "Parallel_Gateway_32x32.png";
		else if ( type == 'gatewayOr' )
			template.children[1].children[0].shape.src = this.iconURL + "Inclusive_Gateway_32x32.png";

		template.children[1].children[0].shape.width = 32;
 		template.children[1].children[0].shape.height = 32;

 		//specify the gateway label using an image from the server
		var poVersionId = this.data.poVersionId;
 		var flowObjId = item.id[0];
		var url = "/rest/bpm/wle/v1/diagramImage?poVersionId=" + poVersionId + "&flowObjId=" +  flowObjId;

 		var lblImage = template.children[2].shape;
 		lblImage.src = url;

 	}
 	*/
 	else if ( type == 'gateway' )
 	{
 		//Exclusive gateway - Blue diamond
 		var template =  eventTemplate;
 		template.children[1].children[0].shape.src = this.iconURL + "Exclusive_Gateway_32x32.png";
 		template.children[1].children[0].shape.width = 32;
 		template.children[1].children[0].shape.height = 32;
 	}
 	else if ( type == 'gatewayEvent' ){
 		//Blue diamond with circle and pentagon
 		var template =  eventTemplate;
 		template.children[1].children[0].shape.src = this.iconURL + "Event_Gateway_32x32.png";	
 		template.children[1].children[0].shape.width = 32;
 		template.children[1].children[0].shape.height = 32;
 	}
 	 else if ( type == 'gatewayAnd' ){
 	 	//Parallel gateway - diamond with cross in middle
		var template =  eventTemplate;
 		template.children[1].children[0].shape.src = this.iconURL + "Parallel_Gateway_32x32.png";
 		template.children[1].children[0].shape.width = 32;
 		template.children[1].children[0].shape.height = 32;

 	}
 	else if ( type == 'gatewayOr')
 	{
 		//Blue diamond with circle in middle
 		var template =  eventTemplate;
		template.children[1].children[0].shape.src = this.iconURL + "Inclusive_Gateway_32x32.png";
		template.children[1].children[0].shape.width = 32;
 		template.children[1].children[0].shape.height = 32;
 	}
 	else if ( type == 'group' ){
 		var response = dojo.clone( this.templates.groupTemplate );
		response.children[0].shape.width = item.width[0];
		response.children[0].shape.height = item.height[0];;
		return response;
 	}


	/*******************************************************************************
 	 							Attached Events
 	********************************************************************************/
 	else if ( type == 'intermedCatchErrorEventBoundary' ){
  		var template =  eventTemplate;
 		eventBaseShape.shape.src= this.iconURL + "Error_Boundary_Event_24x24.png";
 	
 	}
 	else if ( type == 'intermedCatchMsgEventBoundaryInterrupting' ){
 		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Receive_Message_Event_24x24.png";
 	
  	}
  	else if ( type == 'intermedCatchMsgEventBoundaryNonInterrupting' ){
  		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "NI_Receive_Message_Event_24x24.png";
 	
  	}
  	else if ( type == 'intermedCatchContentEventBoundaryInterrupting' ){
 		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Content_Intermediate_Event_-_Catching_24x24.png";
 	
  	}
  	else if ( type == 'intermedCatchContentEventBoundaryNonInterrupting' ){
  		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Content_Intermediate_Event_-_NI_Catching_24x24.png";
 	
  	}
  	else if ( type == 'intermedCatchTimerEventBoundaryInterrupting' ){
  		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "Timer_Intermediate_Event_24x24.png";
 	
  	}
  	//TODO: This icons should have a dotted edge too.
  	else if ( type == 'intermedCatchTimerEventBoundaryNonInterrupting' ){
  		var template =  eventTemplate;
 		eventBaseShape.shape.src = this.iconURL + "NI_Timer_Intermediate_Event_24x24.png";
 	
  	}

 	/*******************************************************************************
 	 							Milestone
 	********************************************************************************/

 	else if ( type == 'milestone' ){
 		
 		//Dynamically, set the milestone width.
 		var width = item.width[0];
 		var height = item.height[0];
 		var template = this.templates.milestoneTemplate;
 		//Set the width of the text box on top of the swimlane
 		template.children[0].children[0].shape.width = width;

 		//make sure the text has as much room as possible to prevent wrapping
 		template.children[0].children[1].shape.width = width;

 

 		//Set the width and height of the rectangle underneath the text box. 
 		//Subtract 25 (height of the text box) to get the height correct.
 		
 		template.children[1].shape.width = width;
 		template.children[1].shape.height = height;	

	}

 	/*******************************************************************************
 	 							Note
 	********************************************************************************/

	else if ( type == 'note'){
			var response = dojo.clone( this.templates.noteTemplate );

			var height = item.height[0];
			
			//Set the width and height of the yellow background box
			response.children[0].shape.width = item.width[0]+6;
			response.children[0].shape.height = height;

			//Set the width of the text field (Probably shouldn't be necesary.)
			response.children[1].shape.width = item.width[0];

			//For performance reasons, we're using images to 
			if ( this.renderingEngine == 'VML' && this.serverSideTextRendering ){
			
				var poVersionId = this.data.poVersionId;
		 		var flowObjId = item.id[0];
				var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST) + "/v1/diagramImage?poVersionId=" + poVersionId + "&flowObjId=" +  flowObjId;


				var image = {
					halign: 'center',
					valign: 'center',
					shape: {
						width: item.width[0],
						height: item.height[0],
						src: url,
						type: 'image'
					}
				};

				response.children.splice( 1, 1, image );
			
		}

		
			//Set length of black border on left side of node
			response.children[2].shape.y2 = height;

			return response;	

 	}
	/*******************************************************************************
 	 							Activity (Deprecated edit support)
 	********************************************************************************/


 	else if ( type == 'activity' && this.enableEditing ){
 		
 		var response = this.templates.vectorActivityTemplate;

 		response.children[0].fill.colors[0].color = "#EAF3FF";
		response.children[0].fill.colors[1].color = "#75AFFF";

 		try{
 			var icon = item.colorIcon[0];
 			if ( icon.indexOf('purple') != -1 )
 			{
 				response.children[0].fill.colors[0].color = "#FCEAFB";
				response.children[0].fill.colors[1].color = "#CFA4CD";
 			}
 			else if (  icon.indexOf('yellow') != -1  ){
				response.children[0].fill.colors[0].color = "#FFFEE4";
				response.children[0].fill.colors[1].color = "#FEEF77";

 			}
 			else if (  icon.indexOf('orange') != -1  ){
				response.children[0].fill.colors[0].color = "#FFF7E5";
				response.children[0].fill.colors[1].color = "#FFC876";

 			}
 

 		}catch( err ){
 			console.debug( err );
 		}
 		return response;

 	} 

	/*******************************************************************************
 	 							Activity 
 	********************************************************************************/

 	else if ( type == 'activity' ){
 
 		var template = dojo.clone(this.templates.activityTemplate);

 
 		//The server can specify a specific icon for an activity. 
 		//Parse the correct field, map it to our deployment strategy and use the new icon. 
 		var icon =  item.colorIcon ? item.colorIcon[0] : "default";

 		var implType = item.bpmn2TaskType ? item.bpmn2TaskType[0] : "n/a";

 		//The activity template is getting complex. Let's set up reference to the main parts of the node
 		//
 		var baseShape = template.children[1].children;
 		var baseIcon = baseShape[0];
 		var baseText = baseShape[1];
 		
 		
 		//Three line labels need to be positioned higher up on the activity. 
		if ( item.label && item.label[0].split('\n').length == 3 ){
			baseText.shape.y = -5;
			baseText.shape.x = 10; 			
 		}
		
		// IE seems to ignore the vertical alignment of the text for some reason. If it's only one line bump it down a little
		if ( item.label && item.label[0].split('\n').length == 1 && dojo.isIE ){
			baseText.shape.y = 25; 			
 		}

 		if ( this.renderingEngine == 'VML' && this.serverSideTextRendering){
 			//VML Images are rendered on the server. Load them here.
 			var poVersionId = this.data.poVersionId;
	 		var flowObjId = item.id[0];

 			var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST) + "/v1/diagramImage?poVersionId=" + poVersionId + "&flowObjId=" +  flowObjId;
 			baseIcon.shape.src = url;

 			//Turn off the label data by removing baseText from the template.
 			baseShape.splice(1,1);
 		}
 		else if ( implType == 'Event_SubProcess'){

 			if ( icon.indexOf('blue') > 0 )
 				baseIcon.shape.src = this.iconURL + "EVSP_-_Blue_95x70.png";
 			else if ( icon.indexOf( 'gray' ) > 0 )
 				baseIcon.shape.src = this.iconURL + "EVSP_-_Gray_95x70.png";
 			else if ( icon.indexOf('green') > 0 )
 				baseIcon.shape.src = this.iconURL + "EVSP_-_Green_95x70.png";
 			else if ( icon.indexOf('orange') > 0 )
 				baseIcon.shape.src = this.iconURL + "EVSP_-_Orange_95x70.png";
 			else if ( icon.indexOf('purple') > 0 )
 				baseIcon.shape.src = this.iconURL + "EVSP_-_Purple_95x70.png";
 			else if ( icon.indexOf( 'red') > 0 )
 				baseIcon.shape.src = this.iconURL + "EVSP_-_Red_95x70.png";
 			else if ( icon.indexOf( 'yellow') > 0 )
 				baseIcon.shape.src = this.iconURL + "EVSP_-_Yellow_95x70.png";
 			else
 				baseIcon.shape.src = this.iconURL +	"EVSP_-_Default_95x70.png";
 			
 		}else if ( implType == 'CalledProcess' ){

 			if ( icon.indexOf('blue') > 0 )
 				baseIcon.shape.src = this.iconURL + "Call_Activity_-_Blue_95x70.png";
 			else if ( icon.indexOf( 'gray' ) > 0 )
 				baseIcon.shape.src = this.iconURL + "Call_Activity_-_Gray_95x70.png";
 			else if ( icon.indexOf('green') > 0 )
 				baseIcon.shape.src = this.iconURL + "Call_Activity_-_Green_95x70.png";
 			else if ( icon.indexOf('orange') > 0 )
 				baseIcon.shape.src = this.iconURL + "Call_Activity_-_Orange_95x70.png";
 			else if ( icon.indexOf('purple') > 0 )
 				baseIcon.shape.src = this.iconURL + "Call_Activity_-_Purple_95x70.png";
 			else if ( icon.indexOf( 'red') > 0 )
 				baseIcon.shape.src = this.iconURL + "Call_Activity_-_Red_95x70.png";
 			else if ( icon.indexOf( 'yellow') > 0 )
 				baseIcon.shape.src = this.iconURL + "Call_Activity_-_Yellow_95x70.png";
 			else
 				baseIcon.shape.src = this.iconURL +	"Call_Activity_-_Default_95x70.png";
 			
 		}
 		else if ( icon == 'default' ){
 			baseIcon.shape.src = this.iconURL + "activity_75x55.gif";
 		}else{
 			icon = icon.replace( 'bpd/color/', '' );
 			icon = icon.replace( 'bpd/', '' );
 			icon = icon.replace( '.gif', '.png' );
 			var activityIconURL = this.iconURL + icon;
 			baseIcon.shape.src =  activityIconURL;
 		}

 		//If this is a service with drill down enabled then we need to add a button to the bottom left corner.
 		if ( implType && this.drillableType(implType) ){
 			var gfxButton = this.templates.expandButton;
 			gfxButton.children[0].shape.src = this.iconURL + "sub_bpd_7x7.png"
 			baseShape.push( gfxButton );
 		}
 		
 		//Pre-post assignment. Small circle, verticallly centered on activity.
 		if ( item.preAssignment && item.preAssignment[0] == true ){
 			
 			var icon = dojo.clone( this.templates.activityIcon );
 			icon.children[0].shape.src = this.iconURL + "Pre-Post-assignment_marker_7x7.png";
 			icon.children[0].shape.width = 7;
 			icon.children[0].shape.height = 7;
 			icon.halign = 'left'; 
 			baseShape.push( icon );
 		}

		//TODO: Right equals sign on the activity icon
 		if ( item.postAssignment && item.postAssignment[0] == true ){

 			var icon = dojo.clone( this.templates.activityIcon );
 			icon.children[0].shape.src = this.iconURL + "Pre-Post-assignment_marker_7x7.png";
 			icon.children[0].shape.width = 7;
 			icon.children[0].shape.height = 7;
 			icon.halign = 'right'; 
 			baseShape.push( icon );
 		}


 		 if ( item.decorator){
 		 	var decorator = item.decorator[0];
 		 	var icon = dojo.clone( this.templates.decoratorIcon );
 		 	icon.dojoAttachPoint = 'decorator';
			icon.children[0].shape.src = decorator;
			icon.halign = 'left'; 
 			icon.valign = 'top';
			icon.children[0].shape.width = 16;
			icon.children[0].shape.height = 16;
			baseShape.push( icon );
 		 }

 		/*
 			Icons for the upper left corner of an activity
 		 */
 		if ( item.bpmn2TaskType  && !item.decorator ){
 			var icon = dojo.clone( this.templates.activityIcon );
 			var bpmnType = item.bpmn2TaskType[0];
 			icon.halign = 'left'; 
 			icon.valign = 'top';

 			var eventSubProcType = item.eventSubProcType ? item.eventSubProcType[0] : "n/a";
 			var interrupting = item.interrupting ? item.interrupting[0] : false;

 			//User task = small torso
 			if ( bpmnType == 'UserTask'){
 				//TODO: Use coach icon
 				 icon.children[0].shape.src = this.iconURL + "User_Task_Marker_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
 			else if ( bpmnType == 'ServiceTask'){
 				//TODO: Use gears icon
 				icon.children[0].shape.src = this.iconURL + "Service_Task_Marker_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
 			else if ( bpmnType == 'DecisionTask' ){
 				//TODO: Decision table
 				icon.children[0].shape.src = this.iconURL + "Decision_Task_Marker_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
 			else if ( bpmnType == 'ScriptTask' ){
 				icon.children[0].shape.src = this.iconURL + "Script_Task_Marker_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
 			//Error marker, lightning bolt with thin border
 			else if ( bpmnType == 'Event_SubProcess' && (eventSubProcType == 'error' || eventSubProcType == 'n/a')){
 				icon.children[0].shape.src = this.iconURL + "Error_Start_Event_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
 			//Interrupting timer, clock with thin border
			else if ( bpmnType == 'Event_SubProcess' && eventSubProcType == 'timer' && interrupting ){
 				icon.children[0].shape.src =  this.iconURL + "Timer_Start_Event_24x24.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
 			//Non-interrupting time, clock with dotted border
			else if ( bpmnType == 'Event_SubProcess' && eventSubProcType == 'timer' && !interrupting ){
 				icon.children[0].shape.src =  this.iconURL + "NI_Timer_Start_Event_24x24.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
 			//Interrupting message, envelope with thin border
			else if ( bpmnType == 'Event_SubProcess' && eventSubProcType == 'message' && interrupting ){
 				icon.children[0].shape.src =  this.iconURL + "Message_Start_Event_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
			//non-interrupting message, envelope with dotted border
			else if ( bpmnType == 'Event_SubProcess' && eventSubProcType == 'message' && !interrupting ){
				icon.children[0].shape.src =  this.iconURL + "NI_Receive_Message_Event_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
 			//Interrupting content, folder with thin border
			else if ( bpmnType == 'Event_SubProcess' && eventSubProcType == 'content' && interrupting ){
 				icon.children[0].shape.src =  this.iconURL + "Content_Start_Event_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}
			//non-interrupting content, folder with dotted border
			else if ( bpmnType == 'Event_SubProcess' && eventSubProcType == 'content' && !interrupting ){
				icon.children[0].shape.src =  this.iconURL + "Content_Start_Event_-_NI_16x16.png";
 				icon.children[0].shape.width = 16;
 				icon.children[0].shape.height = 16;
 				baseShape.push( icon );
 			}

 		}

 		//Small diamond at top of shape
 		if ( item.conditional && item.conditional[0] == true){
 			var icon = dojo.clone( this.templates.activityIcon );
 			var bpmnType = item.bpmn2TaskType[0];
 			icon.halign = 'center'; 
 			icon.valign = 'top';
 			icon.children[0].shape.src = this.iconURL + "conditional_7x7.gif";
 			icon.children[0].shape.width = 7;
 			icon.children[0].shape.height = 7;
 			baseShape.push( icon );
 		}

 		if ( item.loopType ){

 			var loop = item.loopType[0];

 			var icon = dojo.clone( this.templates.activityIcon );
			icon.halign = 'left'; 
 			icon.valign = 'bottom';
 			var MIOrdering = item.MIOrdering ? item.MIOrdering[0] : 'parallel';

 			if ( loop == 'MultiInstanceLoop' && MIOrdering == 'sequential' ){
 				//Three horizontal lines
 				icon.children[0].shape.src = this.iconURL + "Sequential_MI_marker_7x7.png";
 				icon.children[0].shape.width = 7;
 				icon.children[0].shape.height = 7;
 				baseShape.push( icon );
 			}
 			else if ( loop == 'MultiInstanceLoop' ){
 				//Three vertical lines
 				icon.children[0].shape.src = this.iconURL + "Parallel_MI_marker_7x7.png";
 				icon.children[0].shape.width = 7;
 				icon.children[0].shape.height = 7;
 				baseShape.push( icon );
 				
 			}
 			else if ( loop == 'simpleLoop' ){
 				//TODO: Single loop icon
 				icon.children[0].shape.src = this.iconURL + "loop_7x7.gif";
 				icon.children[0].shape.width = 7;
 				icon.children[0].shape.height = 7;
 				baseShape.push( icon );
 			}

 		}
		
		var isActive = item.counter ? item.counter[0] : undefined;
		
		//If this is an active node then highlight it.
		if(isActive){
			var halo = this.templates.activityHalo;
			halo.shape.width = 100;
			halo.shape.height = 75;
 			baseShape.splice( 0, 0, halo );
		}

 		return template;
 		
 	}

 	//Add pre & post assignment markers to gateways and events
 	if ( item.type != 'activity' ){

 		var postAssignment = item.postAssignment && item.postAssignment[0] == true;
 		var preAssignment = item.preAssignment && item.preAssignment[0] == true;

 		if ( preAssignment || postAssignment ){
 			template = dojo.clone( template );

  		
	 		if ( preAssignment ){
				var marker = dojo.clone( this.templates.assignmentEventMarker );
				marker.shape.src =  this.iconURL + 'Pre-Post-assignment_marker_7x7.png';
 	 			marker.margins = [3, 3, 17, 3 ];
	 			template.children[1].children.push( marker );
	 		}
	 			
	 		if( postAssignment ){
				var marker = dojo.clone( this.templates.assignmentEventMarker );
	 			marker.shape.src =  this.iconURL + 'Pre-Post-assignment_marker_7x7.png';
 				marker.margins = [17, 3, 3, 3 ];
	 			template.children[1].children.push( marker );
	 		}
 	
 		}
 	}

 	//Highlight events with counters on top of them. (Portal requirement)
	var isActive = item.counter ? item.counter[0] : undefined;
	var itemCategory = item.category ? item.category[0] : undefined;
	
	if ( item.type != 'activity' && isActive ){
		
		template = dojo.clone( template);
		var base = template.children[1].children;
		var halo = this.templates.eventHalo;
		base.splice( 0, 0, halo );

	}


 	return template;
 
  },
  
  drillableType: function(implType) {
	  return( implType == 'SubProcess' || implType == 'Event_SubProcess' || implType == 'CalledProcess');
  },

  /**
	 * The viewer become invisible
	 */
	onHide: function(){
		//this.breadcrumb.onHide();
	},

 
 	/**
 		Call back function. Invoked when a new link is created to allow us to style the links appearance.
 	**/
	onLinkCreated: function(link, start, end, diagram){
		
		if ( ! link._data ){
			//User creted link
			return;
		}

		var hexColor = new dojo.Color("#000081");

		var startPort = this.getPort( link._data.item.startPosition[0] );
		start.addPort( startPort );

		var endPort = this.getPort( link._data.item.endPosition[0] );
    	end.addPort( endPort );

		link.setStartPort( startPort );
		link.setEndPort( endPort );

		var position = link._data.item.linkLabelPosition ? link._data.item.linkLabelPosition[0]: 0.5;
	
		this.addDecoration(link, "Middle Center", 
				position,
				ibm_ilog.diagram.LinkDecorationPositionType.Relative,
				ibm_ilog.diagram.LinkDecorationOrthogonalAlignment.Center,
				ibm_ilog.diagram.LinkDecorationParallelAlignment.Middle);
				

		/*		
		var startBounds = start.getBounds( link.getParent() );
		console.debug( "Start node is: " + dojo.toJson( startBounds ) );
		
		var endBounds = end.getBounds( link.getParent() );
		console.debug( "End node is: " + dojo.toJson( endBounds ) );
		*/
	
	},


	/**
		Code to add a decoration (text label) to the middle of a given link.
		See the link decorations sample for more details.
	 **/
	addDecoration : function(link, text, position, type, orthogonal, parallel) {
			

			try{
				var showName = link._data.item.showName[0];

				if ( showName == false )
					return;

				
				text = link._data.item.name[0];

			}catch(err){
				return;
			}

			this.addTextDecoration( link, text, position, type, orthogonal, parallel );
			
		},

	/**
		Code to add a decoration (text label) to the middle of a given link.
		See the link decorations sample for more details.
	 **/
	addTextDecoration : function(link, text, position, type, orthogonal, parallel) {
			var deco = link.createGroup();
			deco.isDecoration = true;
			


			var label = deco.createText({text: text, y:0, align: 'middle'});
			label.setFill('gray');
			label.setFont({family:'sans-serif', size:11});
			
			var textWidth;
			if ( this.dictionary && this.dictionary.contains(text) ){
				textWidth = this.dictionary.item(text).width;
			}
			else{
				textWidth = label.getTextWidth();
			}

			
			label.setShape({x:textWidth/2+3});
			
			deco.positionType = type;
			deco.position = position
			deco.orthogonalAlignment = orthogonal;
			deco.parallelAlignment = parallel;
			
			deco.distance = 10;
			
			// modify text dir if needed
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(text);
			if (dir="rtl") {
				if (label.rawNode) {
					if ("text"==label.rawNode.tagName) {
						label.rawNode.setAttribute("direction", "rtl");
					}
				}
			}
	
	},

	/**
	 * Generate a port (link connection point) for a specific location on a node.
	 **/
	getPort: function( location ){
		 
		 var position;
		 var port;

		 if ( location == "topLeft" )
		 	position = {x: 0.25, y: 0.0 };
		 else if ( location == "topCenter")
		 	position = {x: 0.5, y: 0.0 };
		 else if ( location == "topRight")
		 	position = {x: .75, y: 0.0 };
		 else if ( location == "leftTop")
		 	position = {x: 0.0, y: 0.25 };
		 else if ( location == "leftCenter")
		 	position = {x: 0.0, y: 0.5 };
		 else if ( location == "leftBottom")
		 	position = {x: 0.0, y: 0.75 };
		 else if ( location == "bottomLeft")
		 	position = {x: 0.25, y: 1.0 };
		 else if ( location == "bottomCenter")
		 	position = {x: 0.5, y: 1.0 };
		 else if ( location == "bottomRight") 
		 	position = {x: .75, y: 1.0 };
		 else if ( location == "rightTop")
		 	position = {x: 1.0, y: 0.25 };
		 else if ( location == "rightCenter")
		 	position = {x: 1.0, y: 0.5 };
		 else if ( location == "rightBottom")
		 	position = {x: 1.0, y: 0.75 };
		 
		 if ( position ){
		 	port = new ibm_ilog.diagram.BasicPort();
		 	port.setPosition( position );
		 }
		 else{
		 	port = new ibm_ilog.diagram.AutomaticPort();
		 }

		 return port;

	},

	actionPrint: function () {
		//

		var printPageNumber = 0;
		var vSize = this.ilogDiagrammer.getViewport().getClientSize();

		var dimy = 600;
		var dimx = 800;

		if ( vSize.height > vSize.width ){
			dimy = 800;
			dimx = 600;
		}


		//console.log(args);
		var h = 1;
		var w = 1;

		//var printAirContent = args.air[0]?args.air[0]=="on":false;
		//    var other = window.open("","wildebeast","width=300,height=300,scrollbars=1,resizable=1")
		var printPages = [];
		var printDivNames = [];
		
		if(dojo.isIE){
			//Workaround to show the print preview in individual containers but in the same document 
			for (var p = 1, r = 0; r < h; r++) {
				printPages.push([]);
				printDivNames.push([]);
				for (var c = 0; c < w; c++, p++) {
					printPageNumber++;
					var html = "";
					var title = "Print preview: " + this.data.name;
					var printDlg = new dijit.Dialog({
				        
						title: title
					});
					var auxClass = "";
					html += "<div id=\"div_" + printPageNumber + "\"></div>";
					printPages[r].push(document);
					printDivNames[r].push(printPageNumber);
					printDlg.attr("content", html);
					printDlg.show();
				}
			}

		}else{
		   	var r = 0;
		   	var c = 1;
		   	var p = 1;
		  //for (var p = 1, r = 0; r < h; r++) {
			printPages.push([]);
			printDivNames.push([]);
			for (var c = 0; c < w; c++, p++) {
				printPageNumber++;
				var other = window.open("", "printPage_"+ p);
				st = "h2.breakhere { page-break-before: always; }";
				var html = "<html><head><style type=\"text/css\">" + st + "</style></head><body>";
				var auxClass = "";
				html += "<h3>" + this.data.name + "</h3>";
				html += "<div id=\"div_" + printPageNumber + "\"></div>";
				auxClass = ' class="breakhere"';
				html += "</body></html>";
				other.document.open();
				other.document.write(html);
				other.document.close();
				printPages[r].push(other);
				printDivNames[r].push(printPageNumber);
			}
		  //}
		}
		
	
		var D = this.ilogDiagrammer;
		var	myPrintUtil = new ibm_ilog.diagram.util.PrintUtil({
				pagesToPrint : printPages,
				divNames: printDivNames,
				getTargetSurfaceDiv: function(r,c) {
					var doc = this.pagesToPrint[r][c].document;	
					return dojo.byId("div_"+this.divNames[r][c],doc);
				},
				postProcessing: function(r,c,surf,group){
					dojo.style(surf.rawNode,{backgroundColor: '#888888'});
				}
			});

		
			myPrintUtil.printGraph(D.getGraph(),null,dimx,dimy,w,h,'#888888');
		
	
},

	/**
		IE Performance issue have caused performance problems. 
		Detect when we're looking at a legacy browser and pop up an image with several <div> overlays instead.
	 **/
	displayImage: function(){
		

		//Find the main editor pane
		var editor = this.editorPane;

		//Generate a REST call to pull the image back from the server
//		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
//		var activeModel = ssm.getActiveViewStateModel();


		var url;
		var webAppName = com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER;
		var webviewerContextRoot = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER);
		var portalContextRoot = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_PROCESSPORTALSUPPORT);
		
		if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId) {
			webviewerContextRoot = "";
			portalContextRoot = "";
		}

//		var keyId = activeModel.branchOrSnapshotId;
		var keyId = this.viewStateModel.branchOrSnapshotId;


		if ( this instanceof com.ibm.bpm.wpd.document.bpd.view.BPMNViewer ){
			
			if ( this instanceof com.ibm.bpm.wpd.document.bpd.view.ServiceViewer )
				url = webviewerContextRoot + "/image/v1/serviceModel/" + this.data.poId;
			else
				url = webviewerContextRoot + "/image/v1/processModel/" + this.data.poId;

			if (keyId.indexOf("2063.") >= 0) {
				url += "?branchId=" + keyId;
			} else {
				url += "?snapshotId=" + keyId;
			}
		} else if ( this instanceof com.ibm.bpm.wpd.document.bpd.view.BPDViewer  && this.viewStateModel.subProcParentId ){
			//Sample URL

			//If we're in a sub process then Alice's framework will pass in the ID of the calling process. 
			var parentId = this.viewStateModel.subProcParentId ;

			//Base URL for Process Instance graphics
			var instanceIds =  this.config.instanceIds;
			webAppName = com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_PROCESSPORTALSUPPORT;
			url = portalContextRoot + "/diagramImage/v1/processModel/instances?instanceIds=[" + instanceIds.toString() + "]";

			//and the snapshot id
			if (keyId.indexOf("2063.") >= 0) {
				url += "&branchId=" + keyId;
			} else {
				url += "&snapshotId=" + keyId;
			}

			//Need to know the parent
			url += "&parentId=" + parentId;  

			var bpdId = this.viewStateModel.documentId;
			url += "&bpdId=" + bpdId;
			
			if (this.config.criticalPathFlowIds.length==0) {
				url += "&hasCriticalPath=no";
			}			

		}
		else if ( this instanceof com.ibm.bpm.wpd.document.bpd.view.BPDViewer ){
			webAppName = com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_PROCESSPORTALSUPPORT;
			var instanceIds =  this.config.instanceIds;			
			url = portalContextRoot + "/diagramImage/v1/processModel/instances?instanceIds=[" + instanceIds.toString() + "]";
			if (this.config.criticalPathFlowIds.length==0) {
				url += "&hasCriticalPath=no";
			}
		
		}

		if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId) {
			url = com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().calculateRemoteRequestURL(url, null, webAppName);
		}
		//Add an image underneath it.
		var img  = document.createElement( 'img' );
		img.setAttribute( 'src', url  );
		img.style.zIndex = 99;
		editor.appendChild( img );

		//Explicitly set the image height and width
		img.style.width = this.data.width ;
		img.style.height = this.data.height ;

		//Build a one-time lookup table of actitities to swimlanes
		var swimlaneMap = this.IDtoSwimlaneMap = this.getSwimlaneMap(this.data.items);
		var idMap = this.IDtoItemMap = this.getActivityIDMap(this.data.items);		

		//Add event handlers to each of the nodes
		for ( var i = 0; i < this.data.items.length; i++ ){
			var item = this.data.items[i];
			this.imgAddEventHandlers( item, swimlaneMap.item( item.id ) );
		}

	},



	/**
	 Generate a map of activity id - parent swimlane.
	 **/
	getSwimlaneMap: function (items){

		var dictionary =  new dojox.collections.Dictionary();

		var swimlanes = this.getAllSwimlanes(items);
		

		for ( var i = 0; i < swimlanes.length; i++ ){
			var swimlane = swimlanes[i];
			var children = swimlane.children;
			for ( var a = 0; a < children.length; a++ ){
				var child = children[a];
				var reference = child["_reference"];
				dictionary.add( reference, swimlane );
			}
		}

		return dictionary;

	},

	/**
		Generate a map of activity id - item defintions 
	 **/
	 getActivityIDMap: function( items ){
	 	
		var dictionary =  new dojox.collections.Dictionary();

		for ( var i = 0; i < items.length; i++ ){
			var item = items[i];
			dictionary.add( item.id, item );
		}

		return dictionary;
	 },

	/**
	 Returns a list of all swimlanes on the diagram
	 **/
	getAllSwimlanes: function( items ){
	
		var swimlanes = [];
		
		for ( var i = 0; i < this.data.items.length; i++ ){
				var item = this.data.items[i];
				if  ( item.type == 'swimlane' )
					swimlanes.push( item );
		}

		return swimlanes;
	},

	/**
		Connect up an event handler for the given node, iff it's necessary.
	 **/
	imgAddEventHandlers: function( item, parent ){

	 var tasks = [ 'Coach','Script', 'Scriptlet', 'ILOGDecision',  'TaskAction', 'SubProcess', 'Step', 'PostponeAction', 'TaskSender', 'InvokeUca', 'WSConnector', 'JavaConnector', 'SCAConnector', 'ILOGConnector', 'activity' ];
	 var events=['start', 'adhocStartEvent', 'timerStartEventInterrupting', 'timerStartEventNonInterrupting', 'msgStartEventNonInterrupting', 'errorStartEvent', 'intermediateEvent', 'intermedCatchMsgEventNonBoundary', 'intermediateMessage', 'intermedCatchMsgEventNonBoundary', 'intermedCatchTrackingEventNonBoundary' , 'intermediateThrowMsgEvent', 'stop', 'end', 'endException', 'errorEndEvent', 'timer' , 'intermedCatchTimerEventNonBoundary' ,  'terminate', 'messageEndEvent', 'gateway', 'gatewayEvent' , 'gatewayAnd' ,  'gatewayOr'];

		//Sanity check, do we want to connect to this?
		if (  dojo.indexOf(tasks, item.type) ==  -1 &&  dojo.indexOf(events, item.type) ==  -1 ){
			return;
		}
		
		//Find the location of the item	
		var location = this.getActivityLocation( item.id );
		//Hack, event location data from the server is incorrect
		if (  dojo.indexOf( events, item.type) != -1 )
			location.x = location.x + 15;

		//Create the new div
		var main = this.editorPane;
			
		var div = document.createElement( 'div' );
		div.style.borderWidth = "2px";
		div.style.borderStyle = "solid";
		div.style.borderColor = 'black';
		
		div.style.position = "absolute";
		div.style.top = location.y + "px";
		div.style.left = location.x + "px";
		if ( dojo.isIE )
			div.style.backgroundColor = 'red';
		div.style.filter = "alpha(opacity=0)";

		if ( dojo.indexOf( tasks, item.type) != -1 ){		
			div.style.width = "90px";
			div.style.height = "70px";
		}else if (  dojo.indexOf( events, item.type) != -1 ){
			div.style.width = "32px";
			div.style.height = "32px";
		}
		
   		div.style.opacity = "0.0"; 

		div.setAttribute('name', item.id );
	
		div.style.zIndex = 90;
			
		main.appendChild( div );

		//TODO If item is a user-based activity, create a placeholder for the user avatar
		if(item.type=="activity" && item.bpmn2TaskType=="UserTask" && this.serverSideImageRendering && typeof(window.SocialPortalUserAvatars)!="undefined"){
			this.imgAddAvatarHandlers(item, div);
		}
		
		//Classify nodes. Differentiate between interesting ones for Viewer and Portal
		var implType = item.bpmn2TaskType;
		var isPortalNode  = (( implType == 'Event_SubProcess' || implType == 'CalledProcess' || implType == 'SubProcess'  ) && this.config && item.poId );
		var isViewerNode = ( item.poId && !this.config );
		var isPortal = this.config ? true : false;		//Are we running in process portal?

		var label = item.label;

		//if( ( isPortal && (isPortalNode || item.counter ) ) || ( !isPortal && isViewerNode )){
		if(isViewerNode){
			
			//Connect the event handlers for drill down
			dojo.connect( div, "onmouseenter", function(){
				document.body.style.cursor = 'pointer';
			});
			

			dojo.connect( div, "onmouseout", function(){
				document.body.style.cursor = 'default';
			});

		}

		//Event trigger for the Coach diagram in the service viewer
		if ( item.type == 'Coach' ){
		
			dojo.connect( div, "onclick", this, function(evt, tgt){

				this.displayCoach(evt);
			});
		//Event trigger for drill down in Process viewer		
		}else if ( ( isPortal && isPortalNode ) || ( !isPortal && isViewerNode )) {
			dojo.connect( div, "onclick", this, function(evt, tgt){
				this.drillDown(evt);
			});
		}

		/**************************************************************************
			Process Portal Events
		 **************************************************************************/
		//Click on a node.  Previous function limited to clicking on an active node.
		//if ( isPortal && this.config["onNodeClick"] /*&& item.counter*/ ){  //7.5 functionality
		if ( isPortal && this.config["onNodeClick"] ){ //8.0 functionality
			dojo.connect( div, "onclick", this, this.config["onNodeClick"] );
			div.setAttribute("counter", "true");
		}
		
		//Context menus
		if ( isPortal && this.config['onNodeContextMenu']){
			dojo.connect( div, "oncontextmenu", this, this.config["onNodeContextMenu"] );
		} 

		if ( isPortal && this.config['onMouseMove']){
			dojo.connect( div, "onmouseout", this, this.config["onMouseMove"] );
		} 
		
		if(this.config && this.config["onNodeContextMenu"]){
			dojo.connect(div, "onmouseover", this, function(){
				//console.warn("setting window.currentDiagrammerNode");
	 			window.currentDiagrammerNode = item;
			});
	 		
	 		dojo.connect(div, "onmouseout", this, function(){
	 			//console.warn("clearing window.currentDiagrammerNode");
 				window.currentDiagrammerNode = null;
	 		});
		}


	},

	/**
	Connect up an event handler for the given node's associated owner's avatar, iff it's necessary (only applies to acitivities).
	 **/
	imgAddAvatarHandlers: function(item, parent){
			//console.log("**** imgAddAvatarHandlers::item.type:", item.type);
			//console.log("**** imgAddAvatarHandlers::item.id:", item.id);
			
			//Find the location of the item	
			var location = this.getActivityLocation( item.id );

			//Create the new div
			//var main = this.editorPane;
				
			var img = document.createElement( 'img' );
			img.style.borderWidth = "0px";
			img.style.borderStyle = "solid";
			
			img.style.position = "absolute";
			img.style.top = (location.y+4) + "px";
			img.style.left = (location.x+7) + "px";

			img.style.width = "16px";
			img.style.height = "16px";
			
			img.style.backgroundColor = 'transparent';

			img.setAttribute('name', item.id );
		
			img.style.zIndex = 95;
			
			img.src = dojo.moduleUrl("dojo", "resources/blank.gif");
			for(var x = 0; x < window.SocialPortalUserAvatars.length; x++){
				if(window.SocialPortalUserAvatars[x].activityId==item.id){
					img.src = window.SocialPortalUserAvatars[x].imagePath;
					break;
				}
			}
			
			img.setAttribute('width', 16);
			img.setAttribute('height', 16);

			parent.parentNode.appendChild( img );
			
			//Connect the event handlers for hover
			dojo.connect( img, "onmouseenter", function(){
				document.body.style.cursor = 'pointer';
			});
				
			dojo.connect( img, "onmouseout", function(){
				document.body.style.cursor = 'default';
			});

			img.setAttribute("clickTargetImage", "true");
			
			//Click on an avatar
			if ( this.config["onNodeClick"] ){
				if(item.counter){
					img.setAttribute("counter", "true");
				}
				dojo.connect( img, "onclick", this, this.config["onNodeClick"] );
			}
			
			//Context menus
			if ( this.config['onNodeContextMenu'] ){ // && isPortal
				dojo.connect( img, "oncontextmenu", this, this.config["onNodeContextMenu"] );
			} 
			/*
			if ( isPortal && this.config['onMouseMove']){
				dojo.connect( div, "onmouseout", this, this.config["onMouseMove"] );
			} 
			*/
		
	},

	/**
 	Calculate the x & y co-ordinates for a given activity.
 	PreCondition: The map of activity id / swimlanes has 
 				  already been generated.
	 **/
	getActivityLocation: function(id){
		
		var swimlaneMap = this.IDtoSwimlaneMap;
		var IDtoActivityMap = this.IDtoItemMap;

		var item = IDtoActivityMap.item( id );

		var parent = swimlaneMap.item( item.id );

		var x = item.x;
		var y = item.y;

		//BPD Nodes will have a parent swimlane, Service viewer ones will not.
		if ( parent ){
			 x = item.x + parent.x + 25;	//Account for the swimlane header width
			 y = item.y + parent.y 
		}

		var location = { x: x, y: y };

		return location;

			
	},

	/**
		Implement zoom functionality for  an image
	 **/
	zoomImage: function(evt){

	

	},

/**
	 Generate an aria label for a node. Node labels are used for the default WAI support in ILog,
	 but we want to add adorner information.
	**/
	setNodeWAILabel: function( ge ){
		var aria = ge.toString();

		if ( ge.getLabel ){
			aria = ge.getLabel();
		}

		if ( ge.counter && ge.counter.getShape().text.length > 0 ){
			aria += ", instances: " + ge.counter.getShape().text;
		}

		if ( ge.decoratorCount && ge.decoratorCount.getShape().text.length > 0 ){
			aria += ", Loop activity number: " + ge.decoratorCount.getShape().text;
		}

		return aria;

	},

	/**
	 Generate an ARIA label for a link with a label (stored as a 'name' attribute. )
	 Default to ge.toString() if the link is not present.
	 **/
	setLinkWAILabel: function( ge ){
		try{
			var name = ge._data.item.name[0];
			if ( name && name.length > 0 )
				return name;
			else
				return ge.toString();
		}catch( err ){
			return ge.toString();
		}
	},
	
	/**
	 * Used to fix a vertical scrollbar issue in Chrome. The canvas node is too large and overlays the scrollbars preventing us from using the
	 * vertical scrollbars. Create this little workaround until iLog can address in a future release
	 */
	scrollbarFix: function(){
		if (this.ilogDiagrammer.getViewport()._vScrollbarVisible)
			this.ilogDiagrammer.canvasNode.style.right= this.ilogDiagrammer.getViewport().getScrollbarWidth() + "px";
		else
			this.ilogDiagrammer.canvasNode.style.right= "0px";
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.BPMNViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.BPMNViewer"] = true;

// dojo.provide allows pages to use all of the types declared in this resource.
dojo.provide("com.ibm.bpm.wpd.document.bpd.view.BPMNViewer");

//dojo.require the necessary dijit hierarchy






dojo.require( "dojox.layout.ExpandoPane" );





dojo.declare("com.ibm.bpm.wpd.document.bpd.view.BPMNViewer", [ com.ibm.bpm.wpd.document.bpd.view.BPDViewer ], {
	
	// Path to the template
	templateString : dojo.cache("com.ibm.bpm.wpd.document.bpd.view", "templates/BPMNViewer.html", "<div style=\"width: 100%; height: 100%;\">\n\n\t<div dojoType=\"dijit.layout.BorderContainer\" design=\"headline\"  dojoattachpoint=\"mainBC\" style=\"width: 100%; height: 100%; position:relative\" >\n\n\t\t<div style=\"position:absolute; top: 50%;  left: 35%; width: 200px;  z-index: 99;\" dojoattachpoint=\"loadingDiv\" >\n\t\t\t<h2 dojoAttachPoint=\"loadingMessage\"></h2>\n\t\t</div>\n\n\t\t<div dojoType=\"dijit.layout.ContentPane\" region=\"center\"  >\n\n\t\t\t<div dojoType=\"dijit.layout.BorderContainer\" design=\"headline\"  style=\"width:100%;height:100%;border:0\" >\n\n\t\t\t<div dojoType=\"dijit.layout.ContentPane\" style=\"height:70px;border:0\" region=\"top\" >\n\n\t\t\t\t<div dojoType=\"dijit.layout.BorderContainer\" design=\"headline\" region=\"top\" style=\"border:0\" >\n\t\t\n\t\t\t\t\t<div class=\"richTextFormat\" dojoType=\"dijit.layout.ContentPane\"  dojoAttachPoint=\"topControlsContainer\" region=\"top\" style=\"border:0\">\n\n\t\t\t\t\t\t<!-- Title area on top of the diagram. List the description and add the zoom control here -->\n\t\t\t\t\t\t<div dojoType=\"dijit.layout.BorderContainer\"  style=\"height:60px; padding:0px;\" dojoAttachPoint=\"infoPane\" design=\"sidebar\" >\n\n\t\t\t\t\t\t\t<div dojoType=\"dijit.layout.ContentPane\" style=\"border:0\"  region=\"center\">\n\t\t\t\t\t\t\t\t<div><span dojoAttachPoint=\"spanDescription\" style=\"font-size:1.15em;font-weight:bold\">Description:</span></div>\n\t\t\t\t\t\t\t\t<div  class=\"dojoxEllipsis\" dojoAttachPoint='processDescription'></div>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\n\t\t\t\t\t\t\t<div dojoType=\"dijit.layout.ContentPane\"  region=\"right\" style=\"width:125px; border:0\" >\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width:100%\">\n\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t  <td class=\"shareLinkClass\" style=\"text-align: right;white-space: nowrap\"><a dojoAttachPoint='bpmCopyLinkHref' href=\"#\">${messages.BPD_COPY_LINK_LABEL}</a>\n\t\t\t\t\t\t\t\t  </td>\n\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t                <td>\n\t\t\t\t\t\t                <div style=\"width:.5em\"> &nbsp; </div>\n\t\t\t\t\t\t\t\t        <div style=\"width:120px; vertical-align: middle\" dojoattachpoint=\"zoomSlider\" dojoType=\"dijit.form.HorizontalSlider\" value=\"10\" minimum=\"1\" maximum=\"10\" discretevalues=\"20\"  intermediatechanges=\"false\"  ></div>\n\t\t\t\t\t\t\t\t    </td>\n\t\t\t\t                </tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\n\t\t\t\t\t\t</div>\n\t\t\t\t\t</div>\n\n\t\t\t\t</div>\n\n\t\t\t</div>\n\n\t\t\t<div dojoType=\"dijit.layout.ContentPane\" dojoattachpoint=\"editorContainer\" region=\"center\" splitter=\"true\" style=\"border-left:0; border-right:0; border-bottom:0\" >\n\t\t\t\t\n\t\t\t\t<div dojoattachpoint=\"editorPane\" style=\"position:relative;\" >\n\t\t\t\t\t\n\t\t\t\t</div>\n\t\t\t</div>\n\n\t\t</div>\n\n\t\t</div>\n\n<div dojoType=\"dojox.layout.ExpandoPane\"  dojoattachpoint=\"propertiesPane\" region=\"right\" splitter=\"true\" style=\"width:250px\" >\n\t\t<div  class=\"variableBox\" dojoattachpoint=\"variableBox\"  style=\"overflow:auto\" >\n\n\t\t\t\t\t\t\t<div class=\"variableBoxTitle\" dojoattachpoint=\"variableBoxTitle\" >Variables</div>\n\n\t\t\t\t\t\t\t<table class=\"variableBox\" dojoattachpoint=\"variableTable\" >\n\t\t\t\t\t\t\t\t<tbody dojoattachpoint=\"variableTableBody\">\n\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"varTitleName\" class=\"variableBox\" align=\"left\" >Name</th>\n\t\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"varTitleType\" class=\"variableBox\" align=\"left\" >Type</th>\n\t\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"varTitleIn\" class=\"variableBox\" align=\"left\" style=\"width:3em\">In</th>\n\t\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"varTitleOut\" class=\"variableBox\" align=\"left\" style=\"width:3em\">Out</th>\n\t\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"varTitlePrivate\" class=\"variableBox\" align=\"left\" style=\"width:3em\">Private</th>\n\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t</tbody>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\n\t\t\t\t\t\t\n\t\t\t\t\t\t<p></p>\n\t\t\t\t\t\t\n\n\t\t\t\t\t\t<div class=\"variableBoxTitle\" dojoattachpoint=\"workScheduleTitle\" >Work Schedule</div>\n\t\t\t\t\t\t<table dojoattachpoint=\"workTable\" class=\"variableBox\" >\n\t\t\t\t\t\t\t<tbody dojoattachpoint=\"workTableBody\"> \n\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"wsTimeSchedule\" class=\"variableBox\"  style=\"min-width: 115px\" align=\"left\" >Time Schedule</th>\n\t\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"wsTimeZone\" class=\"variableBox\" align=\"left\" style=\"min-width: 100px\" >Time Zone</th>\n\t\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"wsHolidaySchedule\" class=\"variableBox\" style=\"min-width: 125px\" >Holiday Schedule</th>\n\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</tbody>\n\t\t\t\t\t\t</table>\n\n\t\t\t\t\t\t<p></p>\n\n\t\t\t\t\t\t\n\t\t\t\t\t\t<div class=\"variableBoxTitle\" dojoattachpoint=\"kpiTitle\" >Process KPIs</div>\n\t\t\t\t\t\t<table dojoattachpoint=\"kpiTable\" class=\"variableBox\" >\n\t\t\t\t\t\t\t<tbody dojoattachpoint=\"kpiTableBody\">\n\t\t\t\t\t\t\t<!--\n\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t<th dojoattachpoint=\"kpiNameTitle\" class=\"variableBox\" align=\"left\">Name</th>\n\t\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t<th dojoAttachPoint=\"kpiTypeTitle\" class=\"variableBox\" align=\"left\">Type</th>\n\n\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t-->\n\t\t\t\t\t\t\t</tbody>\n\t\t\t\t\t\t</table>\n\n\t\t\t\t\t</div>\n</div>\n</div>\n\n</div>\n"),
	
	widgetsInTemplate : true,

	data: null, 	

	serverSideImageRendering: ( dojo.isIE < 10 || navigator.userAgent.toLowerCase().indexOf( 'ipad') >= 0 ), 

	constructor: function(){
	},


	postMixInProperties : function() {
		
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.bpd.view", "BPDViewerResources");

	
	},

	postCreate: function(){

		if ( this.viewStateModel.openSideBySide && this.propertiesPane ){
			this.propertiesPane.startExpanded = false;
		}
		//I18N Work

		try{
			//Update description field
			this.spanDescription.innerHTML = this.messages.BPD_DESC_HEADER;


			//Variables area
			this.variableBoxTitle.innerHTML = this.messages.BPD_VAR_TITLE;
			this.varTitleName.innerHTML = this.messages.BPD_NAME;
			this.varTitleType.innerHTML = this.messages.BPD_TYPE;
			this.varTitleIn.innerHTML = this.messages.BPD_VAR_IN;
			this.varTitleOut.innerHTML = this.messages.BPD_VAR_OUT;
			this.varTitlePrivate.innerHTML = this.messages.BPD_LIST;

			//Work description
			this.workScheduleTitle.innerHTML = this.messages.BPD_WORK_TITLE;

			this.wsTimeSchedule.innerHTML = this.messages.TIME_SCHEDULE;
			this.wsTimeZone.innerHTML = this.messages.TIME_ZONE;
			this.wsHolidaySchedule.innerHTML = this.messages.HOLIDAY_SCHEDULE;


			//KPI table
			this.kpiTitle.innerHTML = this.messages.BPD_PROCESS_KPIS;
			this.loadingMessaage = this.messages.BPD_LOADING;
			
		}catch( err ){
			console.debug( err.message );
		}
		
		

		this.displayAll();

		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.bpmCopyLinkHref, this.viewStateModel.rootId);
		

	},


	/**
		Display all data about a given process, graphical and property.
	 **/
	displayAll: function(){

		//Load the data
		this.getData();

		//Pull out the process data
		var properties = this.data.properties;

		//Display the process properties pane first. That way if it's empty we can dispose of it before sizing
		//The main view area.
		if ( this.data.items.length > 0 ){
			//Display the properties data first
			var varPaneVisible = this.displayProcessProperties(properties);

			//Display the proecess property
			this.displayDescription(com.ibm.bpm.wpd.util.Helper.richTextFilter(this.data.richDesc));
		}

		//Tell the widget layout containers to size and display themselves.
		
	  				 
		this.mainBC.startup();

		if ( this.serverSideImageRendering ){
			this.displayImage();
			this.hideLoadingDiv();
			this.connectImageZoomControl();
			this.connectPrintButton();
				
		}else{
			this.displayEditor();
			this.hideLoadingDiv();
			this.connectZoomControl();
		}

		
		//Bug: WLE-6606 Moving the splitter in the main border container does not always force a refresh for svgWeb.
		//Capture the event and force a repaint.

		// if ( varPaneVisible ){
		// 	var bc = this.mainBC;
		// 	var pane = this.propertiesPane;
		// 	var splitter = bc.getSplitter('right');

		// 	if ( ibm_ilog.diagram.isSvgWeb ){
		// 		dojo.connect( splitter, "_stopDrag", function(){
		// 			svgweb._onWindowResize();
		// 		});
		// 	}
		// }


		


	},

	/**
		There may be a loading graphic on the middle of the screen. 
		Find and hide it, if it's there.
	 **/
	 hideLoadingDiv: function(){
	 	var div = this.loadingDiv;
	 	if ( div )
	 		div.style.visibility = 'hidden'; 
	 },

	/**
	 Display the process description at the top of the diagram.
	 **/
	displayDescription: function( description ){
		
		//

		if ( !description )
			return;

		var div = this.processDescription;

//		var nameText = document.createTextNode( description );
//		div.appendChild( nameText );
		var spanEle = document.createElement("span");
		div.appendChild(spanEle);
		spanEle.innerHTML = description;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.data.desc);
		if (dir=="rtl") {
			spanEle.setAttribute("dir","rtl");
			spanEle.setAttribute("style","direction:rtl; text-align:left;");
		}

		var container = this.topControlsContainer.domNode;

//		new dijit.Tooltip({ connectId: [div, container],  
////			label: "<span dir = '" + dir + "'>" + description + "</span>", // Bidi Support
//			label: description, 
//			position: ['below'] });



	},


	/**
	 * Display the process properties in the right hand pane.
	    @return: true if the pane was displayed, false if no data was available and the component was removed.
	 */
	displayProcessProperties: function( properties ){
		
		//Sanity check...
		if ( !properties ){
			this.mainBC.removeChild( this.propertiesPane );
			return false;
		}
		
		//Display each table of data in its appropriate place

		var successVaribles = this.displayVariables(this._cleanUneededVariables(properties.variables));
		var successWork = this.displayWorkSchedule( properties.workSchedule );
		var successKPIs = this.displayKPIs( properties.KPIs );
		
		//Remove the properties pane if there's nothing to show
		if ( (!successKPIs && !successWork && !successVaribles)){
			this.mainBC.removeChild( this.propertiesPane );
			return false;
		}else{
			
			//
			 
			//Tweak the expando pane so it has the title bar on the bottom (looks better)
			var expandoPane = this.propertiesPane;
			var expandoTitle = expandoPane.titleWrapper;
			var expandoContents = expandoPane.cwrapper;
			expandoPane.domNode.insertBefore( expandoContents, expandoTitle );
			
			//Set the properties width wide enough that the scroll bar goes away, iff the screen is wide enough.
			if (  this.mainBC.domNode.offsetWidth > 1024 ){
				this.propertiesPane.domNode.style.width = "425px";
			}
			
		}

		return true;
	},
	
	_cleanUneededVariables: function(variables) {
		// return a list minus the unwanted variables
		var cleanedVars = [];
		for (var i =0;i<variables.length;i++) {
			
			/* Check variable type, if an error end event is added it adds a variable to type fault (why???). This gives us an unknown
			 * variable with no labels showing up
			 */
			if ("fault" == variables[i].type)
				continue;
			
			cleanedVars[cleanedVars.length] = variables[i];
		}
		
		return cleanedVars;
	},
	
	/**
	 * Display the variables in the property pane.
	 * 
	 * @param variables: An array of JSON data
	 * @return false if no data was displayed, true if anything was put up.
	 */
	displayVariables: function( variables ){
		
		//Hide the variables area if there's no content
		if ( !variables || variables.length == 0 ){
			this.variableBox.removeChild( this.variableTable );
			this.variableBox.removeChild( this.variableBoxTitle );

			return false;
		}
			
		
		for ( var i = 0; i < variables.length; i++ ){
			var variable = variables[i];
			var row = this.displayVariable( variable, (i%2 == 0) );

			//Alternating highlighting for even and odd rows
			if ( i % 2 == 0 ){
				//Even row
				row.setAttribute("style","background-color:#F0F0F0");
			}
		}

		return true;
		
	},
	
	
	//I see the main logic is in super class: bpdviewer, but here, no call to supers destroy
//	destroy: function(){
//		this.mainBC.destroyRecursive();
//	},
//	
	/**
	 * Add a table row to display information about a single variable
	 */
	displayVariable: function( variable){
		
		var table = this.variableTableBody;
		var row = document.createElement( 'tr' );
		
		
		var nameCell = document.createElement( 'td' );
		var nameText = document.createTextNode( variable.name );
		nameCell.appendChild( nameText );
		row.appendChild( nameCell );
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(variable.name);
		if (dir=="rtl")
			nameCell.setAttribute("style","direction:rtl; text-align:left");
		
//		


		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(variable.poName);
		if ( !variable.poId ){
			var typeCell = document.createElement( 'td' );
			var typeText = document.createTextNode( variable.poName );
			typeCell.appendChild( typeText );
			row.appendChild( typeCell );
			if (dir=="rtl")
				typeCell.setAttribute("style","direction:rtl; text-align:left");

		}else{

			var typeCell = document.createElement( 'td' );
			var anchor = document.createElement('a'); 
			var typeText = document.createTextNode( variable.poName );
			anchor.appendChild( typeText );
			anchor.setAttribute('href', '#');
			typeCell.appendChild( anchor );
			row.appendChild( typeCell );
			if (dir=="rtl")
				typeCell.setAttribute("style","direction:rtl;");

			//Variable drill-down code
			dojo.connect( anchor, "onclick", this, function(evt){
				

				//Type name
				var variableType = evt.target.innerHTML;

				//Find Walk the variable array to find information associated with this type.
				var vars = this.data.properties.variables;
				var variable_info = undefined;
				for ( var i = 0; i < vars.length; i++ ){
					variable_info = vars[i];
					if ( variable_info.poName && variable_info.poName == variableType )
						break;
				}

				var branchId = variable_info.branchId ? variable_info.branchId : null;
				var snapshotId = variable_info.snapshotId ? variable_info.snapshotId : null;
				var poId = variable_info.poId ? variable_info.poId : undefined;
				
				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
					
					//Process ID
			    	params.documentId = poId;
			    	
			    	//Type name
			    	params.documentName = variableType;
			    	
			    	if ( snapshotId ){
			    		params.snapshotId = snapshotId;
			    	}

					// If branch is set, but snapshot isn't then pass branch along
			    	if ( branchId && !snapshotId){
			    		params.branchId=branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();
			});


		}

		
		var inCell = document.createElement( 'td' );

			if ( variable.type == 'input'){
				var img = document.createElement( 'img');
				img.setAttribute('src', com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + '/widgets/com/ibm/bpm/wpd/images/BPD/graycheck.png');
				img.setAttribute( 'alt', 'true');			
				inCell.appendChild( img );
				inCell.setAttribute("style","text-align:center");
			}

		row.appendChild( inCell );
		var outCell = document.createElement( 'td' );


		if ( variable.type == 'output'){
			var img = document.createElement( 'img');
			img.setAttribute('src', com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + '/widgets/com/ibm/bpm/wpd/images/BPD/graycheck.png');
			img.setAttribute( 'alt', 'true');	
			outCell.appendChild( img );
			outCell.setAttribute("style","text-align:center");
		}
	
		row.appendChild( outCell );
		
		var privCell = document.createElement( 'td' );

		// change third column to be a list indicator - JS
		if ( variable.isList){
			var img = document.createElement( 'img');
			img.setAttribute('src', com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + '/widgets/com/ibm/bpm/wpd/images/BPD/graycheck.png');
			img.setAttribute( 'alt', 'true');			
			privCell.appendChild( img );
			privCell.setAttribute("style","text-align:center");
		}
		
		 
		//td.setAttribute( 'style' : 'text-align:center');
		row.appendChild( privCell );
		
		table.appendChild( row );	
		 return row;
		
		
	},

	/* Display work schedule data.
	 *
	 * @return: false if no data was displayed, true if anything was put up.
	 */

	displayWorkSchedule: function(workSchedule){
	
		if ( !workSchedule  || (dojo.isArray(workSchedule )  && workSchedule.length == 0)){
			this.variableBox.removeChild( this.workScheduleTitle );
			this.variableBox.removeChild( this.workTable );
			return false;
			
		}
			


		if ( dojo.isArray(workSchedule ) ){
			for ( var i = 0 ;i < workSchedule.length; i++ ){
				var item = workSchedule[i];
				this.displayWorkScheduleItem(item);
			}
			
		}
		else{
			this.displayWorkScheduleItem( workSchedule );
		}

		return true;

	},

	displayWorkScheduleItem: function(item){
	
			var scheduleTable = this.workTableBody;

			var scheduleRow = document.createElement( 'tr' );
			scheduleTable.appendChild( scheduleRow );

			var scheduleCell = document.createElement( 'td' );
			
			var str_timeScheduleName = item.timeScheduleName;
			if (item.timeScheduleType==1) {
				str_timeScheduleName = item.timeScheduleExpression;
			} else {
				if ('(use default)'==item.timeScheduleName) {
					try{
						str_timeScheduleName = this.messages.USE_DEFAULT;		
					}catch( err ){			
					}					
				}
			}
			
			var scheduleText = document.createTextNode(str_timeScheduleName);
			scheduleCell.appendChild( scheduleText );
			scheduleRow.appendChild( scheduleCell );

			var timeZoneCell = document.createElement('td');
			
			var str_timezoneName = item.timezone;
			if (item.timezoneType==1) {
				str_timezoneName = item.timezoneExpression;
			} else {
				if ('(use default)'==item.timezone) {
					try{
						str_timezoneName = this.messages.USE_DEFAULT;		
					}catch( err ){			
					}					
				}
			}
			
						
			var timeZoneText = document.createTextNode( str_timezoneName );
			timeZoneCell.appendChild( timeZoneText );
			scheduleRow.appendChild( timeZoneCell );

			var holidayCell = document.createElement( 'td' );
			
			var str_holidayScheduleName = item.holidayScheduleName;
			if (item.holidayScheduleType==1) {
				str_holidayScheduleName = item.holidayScheduleExpression;
			} else {
				if ('(use default)'==item.holidayScheduleName) {
					try{
						str_holidayScheduleName = this.messages.USE_DEFAULT;		
					}catch( err ){			
					}					
				}
			}
						
			var holidayText = document.createTextNode( str_holidayScheduleName );
			holidayCell.appendChild( holidayText );
			scheduleRow.appendChild( holidayCell );
		
	},

	displayKPIs: function( KPIs ){
		if ( !KPIs ||KPIs.length == 0 ){
			this.variableBox.removeChild( this.kpiTitle );
			this.variableBox.removeChild( this.kpiTable );
			return false;
		}
			

		for ( var i = 0; i < KPIs.length; i++ ){
			var kpi = KPIs[i]; 
			this.displayKPI( kpi );		
		}
		

		return true;
		
	},

	displayKPI: function( KPI ){

		
		var kpiTable = this.kpiTableBody;

		var kpiRow = document.createElement( 'tr' );
		kpiTable.appendChild( kpiRow );

		var kpiNameCell = document.createElement( 'td' );
		var kpiNameText = document.createTextNode( KPI.name );
		kpiNameCell.appendChild( kpiNameText );
		kpiRow.appendChild( kpiNameCell );
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(KPI.name);
		if (dir=="rtl"){
			kpiNameCell.innerHTML = com.ibm.bpm.wpd.util.BidiUtils.getRTLTextWithBracket(KPI.name);
			kpiNameCell.setAttribute("style","direction:rtl; text-align:left");
		}

		/*
		var kpiTypeCell = document.createElement( 'td' );
		var kpiTypeText = document.createTextNode( KPI.SettingsType );
		kpiTypeCell.appendChild( kpiTypeText );
		kpiRow.appendChild( kpiTypeCell );
		*/
	}




});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bpd.model.BPDDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bpd.model.BPDDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.bpd.model.BPDDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.bpd.model.BPDDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "BPDDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.bpd.view.BPMNViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/visual/processModel/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/processes-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates"] = true;
// dojo.provide allows pages to use all of the types declared in this resource.
dojo.provide("com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates");

dojo.declare("com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates", [], {
    // Place comma-separated class attributes here. Note, instance attributes 
    // should be initialized in the constructor. Variables initialized here
    // will be treated as 'static' class variables.

    ServiceViewerEventTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [
        {
            svgType: 'eventTemplate',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children:[
            {
                svgType: 'eventTemplate',
                dojoAttachPoint: 'baseShape',
                transform: {
                    dx: 1,
                    dy: 1
                },
                halign: 'center',
                shape: {
                    width: 24,
                    height: 24,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.gif',
                    type: 'image'
                }
            }]
        }, 
        {
            dojoAttachPoint: 'textShape',
            shape: {
                align: 'middle',
                text: '{{label}}',
                type: 'mltext',
                width: 90,
                wrap: false
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        }]
    },

  StepTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            svgType: 'stepTemplate',
            dojoAttachPoint: 'baseShape',
            transform: {
                dx: 1,
                dy: 1
            },
            halign: 'center',
            valign: 'center',
            shape: {
                width: 95,
                height: 70,
                src: '/BPMN/com/ibm/bpm/wpd/images/ServiceViewer/step_75x55.gif',
                type: 'image'
            }
        }, 
       
             {
            dojoAttachPoint: 'textShape',
            halign: 'center',
            valign: 'center',
            
            shape: {
                align: 'bottom',
                text: '{{label}}',
                y: 15,
                x: 15,
                type: 'mltext',
                wrap: false,
                width: 80
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }},
             {
            halign: 'left', valign: 'top',
            padding: [10,10,10,10],
            margins: [2,2,2,2],
            shape: {
                width: 18,
                height: 18,
                src: '/BPMN/com/ibm/bpm/wpd/images/ServiceViewer/coach_32x32.gif',
                type: 'image'
            }
        
        }]
    },

   NoteTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            svgType: 'noteTemplate',
            dojoAttachPoint: 'baseShape',
            shape: {
                x: 0,
                y: 0,
                width: 95,
                height: 70,
                type: 'rect'
            },

                
            stroke: {
                type: 'stroke',
                color: 'black',
                width: 1
            },

            fill: "#FFFFCC"

        },

        {
            dojoAttachPoint: 'textShape',
            halign: 'left',
            valign: 'top',
            margins: [5, 5, 0, 0 ],
            shape: {
                x: 5,
                y: 5,
                align: 'start',
                text: '{{label}}',
                type: 'mltext',
                wrap: false,
                width: 200
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        }
        ]
    },


    
    activityTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            dojoAttachPoint: 'baseShape',
            shape: {
                width: 95,
                height: 70,
                src: './images/activity_75x55.gif',
                type: 'image'
            }
        },

        {
            dojoAttachPoint: 'textShape',
            halign: 'center',
            valign: 'center',
            shape: {
                align: 'middle',
                text: '{{label}}',
                y: 15,
                x: 15,
                type: 'mltext',
                wrap: false,
                width: 80
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        }]
    },
    
      activityIcon:  {
            margins: [4, 4, 4, 4],
            valign: 'center',
            halign: 'right',
            
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                halign: 'left',
                valign: 'center',

                shape: {
                    width: 12,
                    height: 12,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                    type: 'image'
                },
                stroke: 'black'

            }

            ]
        },
    
    
    assignmentEventMarker: {
            valign: 'center',
            halign: 'center',
            margins: [3, 3, 17, 3 ],
            shape: {
                width: 7,
                height: 7,
                src: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER)
                	+ '/widgets/com/ibm/bpm/wpd/images/BPD/Pre-Post-assignment_marker_7x7.png',
                type: 'image'
            },
            stroke: 'black'
     
        },
    
    // Constructor function. Called when instance of this class is created
    constructor : function() {
        
    }


//, 
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.           
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.ServiceViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bpd.view.ServiceViewer"] = true;

// dojo.provide allows pages to use all of the types declared in this resource.
dojo.provide("com.ibm.bpm.wpd.document.bpd.view.ServiceViewer");

//dojo.require the necessary dijit hierarchy



dojo.require( "com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates" );
dojo.require( "com.ibm.bpm.wpd.util.BidiUtils" );


dojo.declare("com.ibm.bpm.wpd.document.bpd.view.ServiceViewer", [  com.ibm.bpm.wpd.document.bpd.view.BPMNViewer ], {
	

	// Set this to true if your widget contains other widgets
	widgetsInTemplate : true,


	constructor: function(){
	
		//

		var templates = this.templates = new com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates();	

		//Template graphics may have different server URLs depending on how the widget is packaged. 
		//Fix this here.
		var url =  this.iconURL = dojo.moduleUrl("com.ibm.bpm.wpd").path + "images/ServiceViewer/";

		//Older versions of IE may require special handling when we're rendering. 
		//Make a note of what we're targeting
		var iid = ibm_ilog.diagram;
		if ( iid.isSvgWeb )
			this.renderingEngine = 'svgWeb';
		else if ( iid.isVml )
			this.renderingEngine = 'VML';
		else if ( iid.isSilverlight )
			this.renderingEngine = 'Silverlight';
		//Note: Once we move to Dojo 1.7 we should look into supporting canvas as well.
		else 
			this.renderingEngine = 'svg';

		if ( iid.isSilverlight ){
			this.iconSuffix = '.png';
		}


		//svgWeb (Flash) requires that the fonts be made bigger. Undo that for other browsers.
		if ( !iid.isSvgWeb ){
			templates.ServiceViewerEventTemplate.children[1].font.size = '9pt';
			templates.StepTemplate.children[1].font.size = '9pt';
			templates.NoteTemplate.children[1].font.size = '9pt';
			//templates.activityTemplate.children[1].font.size = '9pt';
		}	

	},



	tweakXandYAttributes_SVG: function( items, dictionary ){

		 //Standard events, all with 32*32 pixel icons.
		 var events = [ 'ExitPoint', 'TrackingPoint', 'Exception']
		 var tasks = [ 'Coach','Script', 'Scriptlet', 'ILOGDecision',  'TaskAction', 'SubProcess', 'Step', 'PostponeAction', 'TaskSender', 'InvokeUca', 'WSConnector', 'JavaConnector', 'SCAConnector', 'ILOGConnector' ];

		 //
		 for ( var i = 0; i < items.length; i++ ){
		 	var item = items[i];
		 	var type = item.type;
	
		 	//Smaller events
		 	if ( type == 'StartPoint' || type == 'CatchException' ){
		 		item.y = item.y + 8;
		 	}
		 	//Gateway (decision) nodes
		 	else if ( type == 'Switch' ){
		 		
			 		var width = this.nodeAdjustedWidth( item.label, dictionary, 54 );

		 		if ( width > 54 )
				 		item.x = item.x + 12 - (width - 54)/2;
			
		 		item.y = item.y +4;
		 	}

		 	//Regular sized events
		 	else if ( dojo.indexOf( events, type) != -1 ){
		 		
				var width = this.nodeAdjustedWidth( item.label, dictionary, 32 );

				item.x = item.x + 16 - (width - 32) /2;
				item.y = item.y +4;
		 	}

		 	//Tasks
		 	else if ( dojo.indexOf(tasks, type) != -1 ){
		 		//item.x = item.x + 11;	
		 	}

		 }
		 
	},


	/**
		A node has a minimum width, but it may grow if a text (label) field is longer than that.
		Walk the labels and find the width of the node.
		@param: item label(s)
		@param: dictionary - Server generated lookup table of text / width information
		@param: width - width of node, assuming not text differences
	 **/
	nodeAdjustedWidth: function(label, dictionary, width ){

		//Sanity check. Handle case where there is no label
		if ( !label )
			return width;

		//Break the labels apart into lines, each line containing a seperate string.
		var labels = label.split( "\n");
	
		for ( var i = 0 ; i < labels.length; i++ ){
			
			var text = labels[i];
			var bounds = dictionary.item( text );

			if ( !bounds )
				continue;

			if ( bounds.width > width ){
				width = bounds.width;
			}

		}

		return width;
	},

	tweakXandYAttributes_svgWeb: function( items, dictionary ){
		
		 //Standard events, all with 32*32 pixel icons.
		 var events = [ 'ExitPoint', 'TrackingPoint', 'Exception']
		 var tasks = [ 'Coach','Script', 'Scriptlet', 'ILOGDecision',  'TaskAction', 'SubProcess', 'Step', 'PostponeAction', 'TaskSender', 'InvokeUca', 'WSConnector', 'JavaConnector', 'SCAConnector', 'ILOGConnector' ];

		 for ( var i = 0; i < items.length; i++ ){
		 	var item = items[i];
		 	var type = item.type;
		 	var label = item.label;
		 	

	
		 	//Smaller events
		 	if ( type == 'StartPoint' || type == 'CatchException' ){
		 		
		 		item.y = item.y + 8;
		 	}
		 	//Gateway (decision) nodes
		 	else if ( type == 'Switch' ){
		 		
		 		var elementWidth = 42;
		 		var width = this.nodeAdjustedWidth( item.label, dictionary, elementWidth );

		 		item.x = item.x + 18 - (width - elementWidth)/2;

		 		item.y = item.y +4;
		 	}

		 	//Regular sized events
		 	else if ( dojo.indexOf( events, type) != -1 ){
		 		
				var width = this.nodeAdjustedWidth( item.label, dictionary, 32 );

				item.x = item.x + 21 - (width - 32) /2;
				item.y = item.y +4;
		 	}

		 	//Tasks
		 	else if ( dojo.indexOf(tasks, type) != -1 ){
		 		//item.x = item.x -5;
		 		//item.y = item.y +1;
		 	}


		 }

		 this.setTextAdjustedWidth(items, dictionary);

	},

	/**
	  Walk the dictionary ensuring that each entry is exactly 68 pixels in length.
	  Flash bug.
	 **/
	 setTextAdjustedWidth: function( items, dictionary ){
	 		for ( var i = 0; i < items.length; i++){
	 			var item = items[i];

	 			if ( !items.label)
	 				continue;

	 			var labels = item.label.split('\n');

	 			for ( var j = 0; j < labels.length; j++ ){
	 				var text = labels[j];
	 				var bounds = dictionary.item( text );
	 				bounds.width = 68;
	 			}

	 		}
	 },

	/**
		Return the appropriate node template (GFX diagram) for a given type of node.
	 **/
  	getNodeTemplate: function(item, store, diagram) {

  		
  		
		var type = item.type[0]; 
		var template;
		
		var label = item.label ? item.label[0] : 'n/a';
//		

		 if ( type == 'ExitPoint'){
		 	template = this.templates.ServiceViewerEventTemplate;
		 	var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "end_event_32x32" + this.iconSuffix;
		 	image.shape.width = 32;
		 	image.shape.height = 32;  
		 			 }
		 else if ( type == 'TrackingPoint'){
		 	template = this.templates.ServiceViewerEventTemplate;
		 	var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "tracking_point_32x32" + this.iconSuffix;
		 	image.shape.width = 32;
		 	image.shape.height = 32;  
		 	var isEvent = true;
		 }
		 else if ( type == 'Exception'){
		 	template = this.templates.ServiceViewerEventTemplate;
		 	var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "Error_End_Event_32x32.png";
		 	image.shape.width = 32;
		 	image.shape.height = 32;  
		 }
		 else if ( type == 'Coach' ){
		 	template = this.templates.StepTemplate;
		 	template.children[0].shape.src = this.iconURL + "step_yellow_75x55" + this.iconSuffix;
		 	template.children[2].shape.src = this.iconURL + "coach_32x32" + this.iconSuffix;
		 }
		//Defect 62705
		 else if ( type == 'ECMConnector' ){
		 	template = this.templates.StepTemplate;
		 	template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
		 	template.children[2].shape.src = this.iconURL + "content_integration_service_32x.png";
		 }
		 else if ( type =='CoachNG' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_yellow_75x55" + this.iconSuffix;
 			//TODO: This icon is incorrect. Copy the right one from sm16 on the server.
 			template.children[2].shape.src = this.iconURL + "CoachNG_25x30.png";
 		}
 		//End defect 62705
		 else if ( type == 'note'){
			var template = this.templates.NoteTemplate;	
			template.children[0].shape.width = item.width[0];
			template.children[0].shape.height = item.height[0];
			template.children[1].shape.width = item.width[0] + 6;

			//response.children[2].shape.y2 = item.height[0];
			
 		}
 		else if ( type =='Script' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "server_script_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'Scriptlet'){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "server_phscript_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'Switch' ){
 			template = this.templates.ServiceViewerEventTemplate;
 			var image = template.children[0].children[0];
  	 		image.shape.src = this.iconURL + "decision_gateway_32x32" + this.iconSuffix;
  	 		image.shape.width = 32;
		    image.shape.height = 32; 
 		}
 		else if ( type == 'ILOGDecision' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "wle_rule_bal32-01.png";
 		}
 		 else if ( type == 'TaskAction' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "modify_task_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'SubProcess' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "service_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'Step' ){
 			template = dojo.clone( this.templates.StepTemplate );
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children.splice(2,1);			//remove small icon from node
 		}
 		else if ( type == 'PostponeAction' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "postpone_task_32x32.png";
 		}
 		 else if ( type == 'TaskSender' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "send_alert_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'InvokeUca' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "undercover_agent_32x32" + this.iconSuffix;
 		}
 		 else if ( type == 'WSConnector' || type == 'JavaConnector' || type == 'SCAConnector'){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "integration_definition_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'ILOGConnector'){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "wle_rule_jrule32-01.png";
 		}
 		else if ( type == "AttachedErrorEvent" ){ 
 			template = this.templates.ServiceViewerEventTemplate;
 			var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "Error_Boundary_Event_24x24.png";
		 	image.shape.width = 24;
		 	image.shape.height = 24;  
  		}
 		else if ( type == "CatchException" ){ 
 			template = this.templates.ServiceViewerEventTemplate;
 			var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "Error_Boundary_Event_24x24.png";
		 	image.shape.width = 24;
		 	image.shape.height = 24;  
  		}
 		else if ( type == 'StayOnPage' ){
 			template = this.templates.ServiceViewerEventTemplate;
 			var image = template.children[0].children[0];
  	 		image.shape.src = this.iconURL + "stay_on_page_32x32.png";
  	 		image.shape.width = 32;
		    image.shape.height = 32; 
 		}
   		else {
  			template = this.templates.ServiceViewerEventTemplate;
  			var image = template.children[0].children[0];
  	 		image.shape.src = this.iconURL + "start_event_32x32" + this.iconSuffix;
  	 		image.shape.width = 24;
			image.shape.height = 24; 
  		}


  		//Handle pre and post conditions for activities
  		if ( template.children[0].svgType == 'stepTemplate' ){

  			var template = dojo.clone( template );
  			var baseShape = template.children;

  			//Note: Gif images aren't allowed if we re-enable Silverlight.
  			//		Translate to PNG

			//Pre-post assignment. Small circle, verticallly centered on activity.
	 		if ( item.preAssignment && item.preAssignment[0] == true ){
	 			
	 			var icon = dojo.clone( this.templates.activityIcon );
	 			icon.children[0].shape.src = this.iconURL + "conditional_7x7.gif";
	 			icon.children[0].shape.width = 7;
	 			icon.children[0].shape.height = 7;
	 			icon.halign = 'left'; 
	 			icon.valign = 'top'; 
	 			baseShape.push( icon );
	 		}

			//TODO: Right equals sign on the activity icon
	 		if ( item.postAssignment && item.postAssignment[0] == true ){

	 			var icon = dojo.clone( this.templates.activityIcon );
	 			icon.children[0].shape.src = this.iconURL + "conditional_7x7.gif";
	 			icon.children[0].shape.width = 7;
	 			icon.children[0].shape.height = 7;
	 			icon.halign = 'right';
	 			icon.valign = 'top';  
	 			baseShape.push( icon );
 			}

  		}

  		//Handle pre & post conditions for gateways and events
  		if ( template.children[0].svgType == 'eventTemplate' ){
  			var postAssignment = item.postAssignment && item.postAssignment[0] == true;
 			var preAssignment = item.preAssignment && item.preAssignment[0] == true;
 	
	 		if ( preAssignment || postAssignment ){
	 			template = dojo.clone( template );
	 		}

			var baseShape = template.children[0].children;

	  		
	 		if ( preAssignment ){
				var marker = dojo.clone( this.templates.assignmentEventMarker );
				marker.shape.src =  this.iconURL + 'Pre-Post-assignment_marker_7x7.png';
 	 			marker.margins = [3, 3, 17, 3 ];
	 			baseShape.push( marker );
	 		}
	 			
	 		if( postAssignment ){
				var marker = dojo.clone( this.templates.assignmentEventMarker );
	 			marker.shape.src =  this.iconURL + 'Pre-Post-assignment_marker_7x7.png';
 				marker.margins = [17, 3, 3, 3 ];
	 			baseShape.push( marker );
	 		}
	 	
	 		
	 		
  		}

  		return template;
  		
  	},


  	onNodeCreated: function( node ){
		
		var type = node._data.item.type[0];

		var item = node._data.item;
	
		if ( type == 'Coach' ){
			this._connectionHandles.push( node.connect("onclick", node, this.displayCoach) );
			if( this.renderingEngine != 'Silverlight' )
				this._connectionHandles.push( node.connect("onDblclick", node, this.displayCoach) );

	 		if (  this.renderingEngine  != 'svgWeb'){
			 		
			 		this._connectionHandles.push( node.connect("onmouseover", this, function(){
			 			document.body.style.cursor = 'pointer';
			 		}));
			 		
			 		this._connectionHandles.push( node.connect("onmouseout", this, function(){
			 			document.body.style.cursor = 'default';
			 			
			 		}));

		 		}
		}

		else if ( item.poId ){

		 		this._connectionHandles.push( node.connect("onclick", node, this.drillDown) );

		 		if (  this.renderingEngine  != 'svgWeb'){
			 		
			 		this._connectionHandles.push( node.connect("onmouseover", this, function(){
			 			document.body.style.cursor = 'pointer';
			 		}));
			 		
			 		this._connectionHandles.push( node.connect("onmouseout", this, function(){
			 			document.body.style.cursor = 'default';
			 			
			 		}));

		 		}

		 	}

		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(node._label);
		if (dir=="rtl") {
			this.modifyTextDir(node);
		}

		//Save a backpointer to the viewer, just in case.
		node.viewer = this;

	},
		
	/**
	 * Modify the text direction given a node.
	 * @param node
	 */
	modifyTextDir: function(node) {
		if (node.textShape) {
			if (node.textShape.children) {
				for (var i=0; i<node.textShape.children.length; i++) {
					if (node.textShape.children[i].rawNode) {
						if ("text"==node.textShape.children[i].rawNode.tagName) {
							// find the text node
							var textNode = node.textShape.children[i].rawNode;
							textNode.setAttribute("direction", "rtl");
						}
					}
				}
			}
		}
	},

		/**
		Pop up the coach viewer for a user task.
	 **/
	displayCoach: function( e ){

		var viewer = this.viewer ? this.viewer : this;

		if (!!this.displayCoachHit) {
			return;
		}
		this.displayCoachHit = true;
		var _self = this;
		setTimeout(function() {_self.displayCoachHit = false;}, 1000);
		
		//User clicked on a node. Pull information from the diagram.
		if ( this._data )		
			var item = this._data.item;
		else{
			//Each transparent <div> keeps its originating item in the name field
			var id = e.target.getAttribute( 'name' );
				
			//User clicked on a div overlaying an image. Pull information from the incoming data
			for ( var i = 0; i < this.data.items.length; i++ ){
				
				var activity =  this.data.items[i];
				if ( activity.id == id ){
					item = activity;
					break;
				}
			}
		}

		//Get the various IDs from the data item
		if ( item.snapshotId )
			var snapshot = dojo.isArray( item.snapshotId ) ? item.snapshotId[0] : item.snapshotId;

		if ( item.poId )
			var coachId = dojo.isArray( item.poId ) ? item.poId[0] : item.poId;

		var poId = viewer.data.poId;

		//Sanity check, ensure that the id values are present.
		if ( !snapshot || !coachId || !poId )
			return;

		try{
			//Instantiate a CoachPreview object to get information about this Coach.
			//var coachPreviewObject = new com.ibm.bpm.wpd.document.coach.view.CoachPreviewViewer( {snapshotId: snapshot, coachId: coachId, twProcessId: poId});
			var url;
			if (viewer.isInAE()) {
				url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/redirect-login.jsp";
			} else {
				url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST) + "/v1/coachpreview/" +  coachId;
			}
			
			url += "?snapshotId=" + snapshot + "&twProcessId=" +poId;
			
			var jsessionId = dojo.cookie("JSESSIONID");
			if (viewer.isInAE()) {
				url += "&jsessionId=" + encodeURIComponent(jsessionId);
				url += "&credentials=" + viewer.getCredentials();
				url += "&redirect=" + encodeURIComponent(com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST) + "/v1/coachpreview/" +  coachId);
			}
			
			var coachWindow = window.open (url,"CoachPreviewWindow","resizable=1,location=0,menubar=0,status=0,dialog=1,toolbar=0,width=640, titlebar=0, height=480");
			coachWindow.moveTo( 100, 100 );


	  	}catch( err ){
	  		console.debug( err.message );
	  	}

	},

	coachWindow: function( url ){
		window.open (url,"mywindow","menubar=1,resizable=1,width=350,height=250");
	},

	/**
		Code to add a decoration (text label) to the middle of a given link.
		See the link decorations sample for more details.
	 **/
	addDecoration : function(link, text, position, type, orthogonal, parallel) {
			
			//Sanity check. Make sure we're looking at valid data
			if ( !link._data || !link._data.item ){
					return;
			}

			//TODO: I2 issue. Link icons not showing up properly with svgWeb. Track down why.
			if ( this.renderingEngine && this.renderingEngine != 'svgWeb' ){
				if ( link._data.item.showEndState &&  (link._data.item.showEndState[0] == true )  ){
					this.addLinkLabel( link, link._data.item.endState[0], position, type, orthogonal, parallel );	
				}
			}

			if ( link._data.item.showName[0] && (link._data.item.showName[0] == true) ){
				this.addTextDecoration(link, link._data.item.name[0], position, type, orthogonal, parallel);	
			}


	},

	addLinkLabel : function(link, text, position, type, orthogonal, parallel) {
			//
			var deco = link.createGroup();
			deco.isDecoration = true;
			
			var bg = deco.createRect({width: 50, height: 16});
			bg.setFill('white');
			

			var label = deco.createText({text: text, y:10, align: 'middle'});
			label.setFill('black');
			label.setFont({family:'sans-serif', size:10});
			
			var textWidth = label.getTextWidth();
			bg.setShape({width: textWidth+6});
			label.setShape({x:textWidth/2+3});
			
			deco.positionType = type;
			deco.position = position
			deco.orthogonalAlignment = orthogonal;
			deco.parallelAlignment = parallel;

			var item = link._data.item;
			if ( item.endStateType && item.endStateType[0] == "SubProcess")
				var image = deco.createImage({width: 16, height: 16, y:0, x:-16, src : this.iconURL + "line_end_marker_16x16.gif"});
			else
				var image = deco.createImage({width: 16, height: 16, y:0, x:-16, src : this.iconURL + "tag_button" + this.iconSuffix});
			
			deco.distance = 10;
		},
		
		isInAE : function() {
	        try{
	            if (typeof isRunningInAE == 'function') {
	                return true;
	            }
	
	            return false;
	        } catch(e) {
	            return false;
	        }	
		},	
		
		getCredentials : function() {
	        try{
	            if (typeof getCredentials == 'function') {
	                return getCredentials();
	            }
	
	            return null;
	        } catch(e) {
	            return null;
	        }	
		}
		
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bpd.model.ServiceTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bpd.model.ServiceTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.bpd.model.ServiceTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.bpd.model.ServiceTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "Service";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.bpd.view.ServiceViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/visual/serviceModel/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/processes-16.png";
		}
	},
	
	getServiceIconPath : function(size, serviceType){
		if(size == 16){
			if (serviceType == "Rule Service") {
				return "images/assetview/rule-service-16.png";
			} else if (serviceType == "Integration Service") {
				return "images/assetview/integration-service-16.png";
			} else if (serviceType == "Human Service") {
				return "images/assetview/human-service-16.png";
			} else if (serviceType == "General System Service") {
				return "images/assetview/general_service_16x16.png";
			} else if (serviceType == "Ajax Service") {
				return "images/assetview/ajax-service-16.png";
			}
			
			return "images/processes-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bo.view.BOViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bo.view.BOViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.bo.view.BOViewer");









/**
 * BaseViewer
 */
dojo.declare("com.ibm.bpm.wpd.document.bo.view.BOViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\" >\n<div class=\"viewerHeading\"  >\n<!--style=\"margin-top:0px; margin-bottom:0px; margin-left:3px;\"-->\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='boName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n<div>\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><h4>${messages.BO_DESC_HEADER}</h4></td>\n<td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='boCopyLinkHref' href=\"#\"> \n${messages.BO_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n\n<div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='boDescription'></div>\n</div>\n\n<table dojoAttachPoint=boTableHeader style='width:100%; border:1px solid black' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=25% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${messages.BO_PARM_COLHEADER}</th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\">${messages.BO_TYPE_COLHEADER}</th>\n<th width=55% style=\"background-color:#e2e2e2;  text-align: left;\">${messages.BO_DESC_COLHEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n<div dojoAttachPoint=\"boDialogBody\" class='bspace-style' style='height:400px;width:895px;padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=boTable style='width:895px;table-layout: fixed;' cellpadding=\"0\" cellspacing=\"4\">\n<thead>\n<tr>\n<th width=25% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n<th width=55% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=boTableBody style='valign:top'>\n</tbody>\n</table>\n</div>\n</div>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	boModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 
	
	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.getboData();
		}else {
			//Get the server side data
			boModel = this.viewStateModel.getDocumentModel();;
		}
		
		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(boModel.richDescription) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(boModel.richDescription));
			this.boDescription.innerHTML = str;
			var dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(boModel.description);
			if (dir=="rtl")
				this.boDescription.setAttribute("style","direction:rtl; text-align:left;");
		} else { 
//			this.boDescription.innerHTML = this.messages.BO_NO_DESC;
			this.boDescription.innerHTML = "&nbsp;";
		}

		this.boName.innerHTML = boModel.name;
		var dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(boModel.name);
		if (dir=="rtl")
			this.boName.setAttribute("style","direction:rtl; text-align:left;");
		
		var m = boModel;
		if (boModel.isComplex){
			this.fillInTable();
		} else {
			this.boTableHeader.style.display = "none";
			newRow = this.insertRow();
			this.addTextCellToRow( newRow, "<b>" + this.messages.BO_SIMPLE_TYPE_LABEL + "</b>" + boModel.type, this.bidiLeft, null, null );
//			this.addTextCellToRow( newRow, boModel.type, this.bidiLeft, null, null);
		}
		
	
		
		/*
		 *  Create Share link href Document
		 */
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.boCopyLinkHref);
		
	},	
	
	
	postMixInProperties: function()
	{

        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.bo.view", "BOViewerResources");


	},

	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},
	

	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	fillInTable: function()
	{
		
		var newRow = null;
		var m = boModel;
		
		for (var i=0; i<boModel.properties.length; i++) {
			newRow = this.insertRow();
			var modelName = boModel.properties[i].name;
			if (boModel.properties[i].isArray) {
				this.addTextCellToRow( newRow, boModel.properties[i].name + this.messages.BO_LIST, this.bidiLeft, null, null );
				modelName = boModel.properties[i].name + this.messages.BO_LIST;
			} else {
				this.addTextCellToRow( newRow, boModel.properties[i].name, this.bidiLeft, null, null );
			}
			var dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(modelName);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}

			this.addTextCellToRow( newRow, boModel.properties[i].typeClass, this.bidiLeft, null, boModel.properties[i] );
			dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(boModel.properties[i].typeClass);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
			
			if (typeof(boModel.properties[i].richDescription) !== "undefined") {
				var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(boModel.properties[i].richDescription));
				dojo.addClass(newRow, "richTextFormat");
				this.addTextCellToRow( newRow, str, this.bidiLeft, null, null );
				dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(boModel.properties[i].description);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
			} else {
				this.addTextCellToRow( newRow, "", this.bidiLeft, null, null );
			}

	
		}
	},
	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function()
	{
		var tbodyElem = this.boTableBody;
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);

		return trElem;
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//		modelProperty
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname, modelProperty)
	{
//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), Started : " + value);
		var tdElem = trElem.insertCell(trElem.cells.length);
//		tdElem.style.whiteSpace="nowrap";
//
//		tdElem.align=align;
		
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		    

		if ((modelProperty != null) && (modelProperty.typeClassRef != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = modelProperty;
			dojo.connect( tdElem, "onclick", function(){
//				alert("click!");
				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.typeClassRef;
			    	params.documentName = tdElem.modelProp.typeClass;
			    	
			    	if (tdElem.modelProp.typeClassSnapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.typeClassSnapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.typeClassBranchId != null ) {
			    		params.branchId = tdElem.modelProp.typeClassBranchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}

//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), ended");
	},

	getboData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	boModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bo.model.BODocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bo.model.BODocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.bo.model.BODocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.bo.model.BODocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

    boModel: {},  // used to save off the model
	
	contructor : function () {
	},
	
	getDocType: function(){
		return "BODocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.bo.view.BOViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/businessobject/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
        //alert(JSON.stringify(this.boModel.getDocumentModel(), null, 4));
	
		if(size == 16){
		    if (this.viewStateModel != null && this.viewStateModel.getDocumentModel() != null && this.viewStateModel.getDocumentModel().isShared) {
			    return "images/assetview/variable-type-shared-16.png";
			} else {
                return "images/assetview/variable-type-16.png";
            }
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.epv.view.EPVViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.epv.view.EPVViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.epv.view.EPVViewer");









dojo.declare("com.ibm.bpm.wpd.document.epv.view.EPVViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\">\n\t<div class=\"viewerHeading\">\n\t\t<h4 class=\"viewerHeadingText\" dojoAttachPoint='epvName'></h4>\n\t</div>\n\t<div style=\"margin-left:5px;\">\n\t\t<div>\n\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n        <tr>\n           <td><h4>${messages.EPV_DESC_HEADER}</h4></td>\n           <td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='evpCopyLinkHref' href=\"#\"> \n               ${messages.EPV_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n        </tr>\n        </table>\n \t\t\t\n \t\t\t<div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='epvDescription'></div>\n\t\t</div>\n\t\t<div>\n\t\t\t<h4>${messages.EPV_EXPOSED_TO}</h4>\n\t\t\t<div class=\"viewerDescriptionText\" dojoAttachPoint='epvExposedTo'></div>\n\t\t</div>\n\n\t\t<table dojoAttachPoint=\"epvTableHeader\" style='width: 875px;table-layout: fixed; border:1px solid black' cellpadding=\"0\" cellspacing=\"0\">\n\t\t\t<thead>\n\t\t\t\t<tr>\n\t\t\t\t\t<th style=\"width=15%;background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${messages.EPV_NAME_COLHEADER}</th>\n\t\t\t\t\t<th style=\"width=15%;background-color:#e2e2e2; text-align: left;\">${messages.EPV_VAR_NAME_COLHEADER}</th>\n\t\t\t\t\t<th style=\"width=35%;background-color:#e2e2e2;  text-align: left;\">${messages.EPV_DESC_HEADER}</th>\n\t\t\t\t\t<th style=\"width=15%;background-color:#e2e2e2; text-align: left;\">${messages.EPV_DEFAULT_VALUE_COLHEADER}</th>\n\t\t\t\t\t<th style=\"width=10%;background-color:#e2e2e2;  text-align: left;\">${messages.EPV_PROGRESS_COLHEADER}</th>\n\t\t\t\t\t<th style=\"width=10%;background-color:#e2e2e2;  text-align: left;\">${messages.EPV_VAR_TYPE_COLHEADER}</th>\n\t\t\t\t</tr>\n\t\t\t</thead>\n\t\t\t<tbody dojoAttachPoint=\"epvTableBody\" style='valign:top'>\n\t\t\t</tbody>\n\t\t</table>\n\t</div>\n</div>\n",

	epvModel: {},

	constructor : function() { 	
	},
	
	postCreate : function() {

		epvModel = this.viewStateModel.getDocumentModel();

		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (epvModel.richDesc) {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(epvModel.richDesc));
			this.epvDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(epvModel.desc);
			if (dir=="rtl")
				this.epvDescription.setAttribute("style","direction:rtl; text-align:left;");

		} else { 
			this.epvDescription.innerHTML = "&nbsp;";
		}
		
		if (epvModel.participantId && (epvModel.participantRefSnapshotId || epvModel.participantClassBranchId) && !!epvModel.participantName) {
			this.epvExposedTo.innerHTML = "<u>"+epvModel.participantName+"</u>";
			this.epvExposedTo.style.cursor="pointer";
			dojo.addClass(this.epvExposedTo, "linkFieldFont");	    
	
			dojo.connect( this.epvExposedTo, "onclick", function(){
				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = epvModel.participantId;
			    	params.documentName = epvModel.participantName;
			    	
			    	if (epvModel.participantRefSnapshotId) {
			    		params.snapshotId = epvModel.participantRefSnapshotId;
			    	}
			    	
			    	if (epvModel.participantClassBranchId) {
			    		params.branchId = epvModel.participantClassBranchId;
			    	}
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		}
		else {
			if (!!epvModel.participantName) {
				this.epvExposedTo.innerHTML = epvModel.participantName;
			}
		}
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(epvModel.participantName);
		if (dir=="rtl")
			this.epvExposedTo.setAttribute("style","direction:rtl; text-align:left;");

		this.epvName.innerHTML = epvModel.name;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(epvModel.name);
		if (dir=="rtl")
			this.epvName.setAttribute("style","direction:rtl; text-align:left;");
		
		this.fillInTable();
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.evpCopyLinkHref);
	},
	
	postMixInProperties: function()
	{
        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.epv.view", "EPVViewerResources");
	},
	
	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},

	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	fillInTable: function()
	{
		
		var newRow = null;
		
		for (var i=0; i<epvModel.vars.length; i++) {
			newRow = this.insertRow();
			var epvVar = epvModel.vars[i];
			this.addTextCellToRow( newRow, epvVar.name, "15%", this.bidiLeft, null, null );
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(epvVar.name);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
			this.addTextCellToRow( newRow, epvVar.varname,"15%", this.bidiLeft, null, null );
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(epvVar.varname);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
			if (epvVar.extDesc) {
				var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(epvVar.extDesc));
				this.addTextCellToRow( newRow, str, "35%",this.bidiLeft, null, null );
				dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(epvVar.plainExtDesc);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
			} else {
				this.addTextCellToRow( newRow, "", "35%", this.bidiLeft, null, null );
			}
			if (epvVar.defaultValue) {
				this.addTextCellToRow( newRow, epvVar.defaultValue, "15%", this.bidiLeft, null, null );
				dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(epvVar.defaultValue);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
			} else {
				this.addTextCellToRow( newRow, "", "15%", this.bidiLeft, null, null );
			}
			
			if (epvVar.isChgActiveProc)
				this.addTextCellToRow( newRow, this.messages.EPV_TRUE, "10%", this.bidiLeft, null, null );
			else
				this.addTextCellToRow( newRow, this.messages.EPV_FALSE, "10%", this.bidiLeft, null, null );

			if (epvVar.typeClassRef)
				this.addTextCellToRow( newRow, epvVar.typeClass, "10%", this.bidiLeft, null, epvVar );
			else
				this.addTextCellToRow( newRow, epvVar.typeClass, "10%", this.bidiLeft, null, null);
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(epvVar.typeClass);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}

		}
	},
	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function()
	{
		var tbodyElem = this.epvTableBody;
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);

		return trElem;
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, columnWidth, align, classname, modelProperty)
	{
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";

		tdElem.width = columnWidth;
		tdElem.style.whiteSpace="normal";
		tdElem.style.verticalAlign="top";
		if (modelProperty) {
			tdElem.innerHTML = "<u>"+value+"</u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = modelProperty;
			dojo.connect( tdElem, "onclick", function(){
				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.typeClassRef;
			    	params.documentName = tdElem.modelProp.typeClass;
			    	if (tdElem.modelProp.typeClassSnapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.typeClassSnapshotId;
			    	}

			    	if (tdElem.modelProp.typeClassBranchId != null ) {
			    		params.branchId = tdElem.modelProp.typeClassBranchId;
			    	}
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}
	}
}
		
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.epv.model.EPVDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.epv.model.EPVDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.epv.model.EPVDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.epv.model.EPVDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "EPVDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.epv.view.EPVViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/epv/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/assetview/epv-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.ParticipantGrp.view.ParticipantGrpViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.ParticipantGrp.view.ParticipantGrpViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.ParticipantGrp.view.ParticipantGrpViewer");











/**
 * Participant Group viewer
 * 
 * 		Participant group has a couple of different types of data
 * 			- lists of users and groups
 *          - expression
 *      This implementation has a couple of different types of table to reflect the different types of data to show. We
 *      hide the one that is not needed and show the the one that is.
 */
dojo.declare("com.ibm.bpm.wpd.document.ParticipantGrp.view.ParticipantGrpViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\" >\n<div class=\"viewerHeading\"  >\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='pgName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><div>\n <h4>${messages.PG_DESC_HEADER}</h4>\n <div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='pgDescription'></div>\n</div></td>\n<td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='paCopyLinkHref' href=\"#\"> \n${messages.PG_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n\n<table dojoAttachPoint=pgStandardTableHeader style='width: 875px;table-layout: fixed; border:1px solid black;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${messages.PG_MEMBER_COLHEADER}</th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\">${messages.PG_TYPE_COLHEADER}</th>\n<th width=50% style=\"background-color:#e2e2e2;  text-align: left;\">${messages.PG_DESC_COLHEADER}</th>\n</tr>\n</thead>\n<tbody >\n</tbody>\n</table>\n\n<table dojoAttachPoint=pgExpressionTableHeader style='width: 875px;table-layout: fixed; border:1px solid black;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=90% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${messages.PG_EXP_COLHEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n\n<div dojoAttachPoint=\"pgDialogBody\" class='bspace-style' style='height:400px;padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=pgTable style='width: 875px;table-layout: fixed;' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n<th width=50% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=pgTableBody style='valign:top'>\n</tbody>\n</table>\n</div>\n\n<div dojoAttachPoint=\"pgExDialogBody\" class='bspace-style' style='height:400px;padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=pgExTable style='width: 875px;table-layout: fixed;' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=90% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=pgExTableBody style='valign:top'>\n</tbody>\n</table>\n</div>\n</div>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	pgModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 
	
	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.getpgData();
		}else {
			//Get the server side data
			pgModel = this.viewStateModel.getDocumentModel();;
		}
		
		

		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(pgModel.richDesc) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(pgModel.richDesc));
			this.pgDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(pgModel.desc);
			if (dir=="rtl")
				this.pgDescription.setAttribute("style","direction:rtl; text-align:left;");

		} else { 
			this.pgDescription.innerHTML = "&nbsp;";
		}

		this.pgName.innerHTML = pgModel.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(pgModel.name);
		if (dir=="rtl")
			this.pgName.setAttribute("style","direction:rtl; text-align:left;");
		
		if (pgModel.type == "Expression") {
			this.pgStandardTableHeader.style.display = "none";
			this.pgDialogBody.style.display="none";
			this.fillInExpressionData();
		} else {
			this.pgExpressionTableHeader.style.display = "none";
			this.pgExDialogBody.style.display="none";
			this.fillInStandardTable();
		}
		
		/*
		 *  Create Copy link href Document 
		 */
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.paCopyLinkHref);
		
	},
	
	postMixInProperties: function()
	{

        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.ParticipantGrp.view", "ParticipantGrpViewerResources");


	},
	
	
	
	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},

	

	//*****
	//Insert a new row into the table
	//		In this case it is a list of users and groups
	//
	//Returns: reference to the new row
	//*****
	fillInStandardTable: function()
	{
		
		var newRow = null;
		var m = pgModel;
		
		if (m.members != null) {
			
			var memLen = m.members.length;
			for (var i=0; i<memLen; i++) {
				newRow = this.insertRow(this.pgTableBody);
				this.addTextCellToRow( newRow, pgModel.members[i].name, this.bidiLeft, null);
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(pgModel.members[i].name);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
				this.addTextCellToRow( newRow, pgModel.members[i].type, this.bidiLeft, null);
				dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(pgModel.members[i].type);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
				if (typeof(pgModel.members[i].desc) !== "undefined") {
					this.addTextCellToRow( newRow, pgModel.members[i].desc, this.bidiLeft, null);
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(pgModel.members[i].desc);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
				} else {
					this.addTextCellToRow( newRow, "", this.bidiLeft, null);
				}
			}
			
		} else if (m.type == "System") {
			newRow = this.insertRow(this.pgTableBody);
			this.addTextCellToRow( newRow, m.name, this.bidiLeft, null);
			this.addTextCellToRow( newRow, m.type, this.bidiLeft, null);
			this.addTextCellToRow( newRow, m.desc, this.bidiLeft, null);

		}
	
	},
	//*****
	//Insert a new row into the table
	//   	In this case this is an expression type of participant group
	//
	//Returns: reference to the new row
	//*****
	fillInExpressionData: function()
	{
		
		var newRow = null;
		
		newRow = this.insertRow(this.pgExTableBody);


		if (pgModel.orgExpression.ruleSetOperator == "Or") {
			this.addTextCellToRow( newRow, this.messages.PG_EXPRESSION_ORS, this.bidiLeft, null);
		} else {
			this.addTextCellToRow( newRow, this.messages.PG_EXPRESSION_ANDS, this.bidiLeft, null);
		}
        
		if (pgModel.orgExpression.rules != null) {
			var numRules = pgModel.orgExpression.rules.length;
			var str = null;
			var parms = [];
			var m = pgModel;
				
			// for all rules in the expression - there can be any number
			for (var i=0; i<numRules; i++) {
				newRow = this.insertRow(this.pgExTableBody);
				
				//*****
				//There are three types of rules, participant, expression, user attribute
				//*****
				if (pgModel.orgExpression.rules[i].ruleType == "Participant") {
					
					switch (pgModel.orgExpression.rules[i].matchType) {
					case "belong":
						parms[0] = this.messages.PG_EXP_PARTCIPANT_BELONG; 
						break;
					case "notBelong":
						parms[0] = this.messages.PG_EXP_PARTCIPANT_NOT_BELONG;
						break;
					}
					parms[1] = pgModel.orgExpression.rules[i].participantName;
					str = dojo.string.substitute(this.messages.PG_EXP_PARTICIPANT_STRING, parms);
					this.addBulletTextCellToRow( newRow, str, this.bidiLeft, null, pgModel.orgExpression.rules[i]);
				} 
				else if (pgModel.orgExpression.rules[i].ruleType == "Expression") {	
					
					switch (pgModel.orgExpression.rules[i].matchType) {
					case "match":
						parms[0] = this.messages.PG_EXP_EXPRESSION_MATCH; 
						break;
					case "notMatch":
						parms[0] = this.messages.PG_EXP_EXPRESSION_NOT_MATCH;
						break;
					}
					
					parms[1] = pgModel.orgExpression.rules[i].value;
					str = dojo.string.substitute(this.messages.PG_EXP_EXPRESSION_STRING, parms);
					this.addBulletTextCellToRow( newRow, str, this.bidiLeft, null, null);
				} 
				else if (pgModel.orgExpression.rules[i].ruleType == "UserAttribute") {
					
//					PG_EXP_USERATTRIBUTE_EQUAL: "equal to",
//					PG_EXP_USERATTRIBUTE_NOT_EQUAL: "not equal to",
//					PG_EXP_USERATTRIBUTE_LESS: "less than",
//					PG_EXP_USERATTRIBUTE_LESS_OR_EQUAL: "less than or equal to",
//					PG_EXP_USERATTRIBUTE_GREATER: "greater than",
//					PG_EXP_USERATTRIBUTE_GREATER_OR_EQUAL: "greater than or equal to"
					parms[0] = com.ibm.bpm.wpd.util.Helper.text2htmlText_1(pgModel.orgExpression.rules[i].userAttributeName);
					
					switch (pgModel.orgExpression.rules[i].comparator) {
					case "Equal":
						parms[1] = this.messages.PG_EXP_USERATTRIBUTE_EQUAL; 
						break;
					case "NotEqual":
						parms[1] = this.messages.PG_EXP_USERATTRIBUTE_NOT_EQUAL;
						break;
					case "LessThan":
						parms[1] = this.messages.PG_EXP_USERATTRIBUTE_LESS;
						break;
					case "LessThanEqual":
						parms[1] = this.messages.PG_EXP_USERATTRIBUTE_LESS_OR_EQUAL;
						break;
					case "GreaterThan":
						parms[1] = this.messages.PG_EXP_USERATTRIBUTE_GREATER;
						break;
					case "GreaterThanEqual":
						parms[1] = this.messages.PG_EXP_USERATTRIBUTE_GREATER_OR_EQUAL;
						break;
					}
					
					parms[2] = pgModel.orgExpression.rules[i].userAttributeValue;
					str = dojo.string.substitute(this.messages.PG_EXP_USERATTRIBUTE_STRING, parms);
					this.addBulletTextCellToRow( newRow, str, this.bidiLeft, null, null);
				} else {
					alert("Invalid rule type in Team expression.");
				}
				
			}
		}
	},
	
	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function(pgTable)
	{
		var tbodyElem = pgTable;
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);

		return trElem;
	},
	//*****
	// Add a Bullet text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addBulletTextCellToRow: function(trElem, value, align, classname, modelProperty)
	{
//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), Started : " + value);
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		
		// if this is a participant we want to enable drillin on the particpant
		if ((modelProperty != null) && (modelProperty.ParticipantId != null)) {

			//add the participant onto the end and give it an id so we can connect to it later
			tdElem.innerHTML = "<ul style='margin-top:0px;margin-bottom:0px;'><li>"
										+ value
										+ "<u id ="
										+modelProperty.ParticipantId
										+ "><b>"
										+ com.ibm.bpm.wpd.util.Helper.text2htmlText_1(modelProperty.participantName)
										+ "</b></u>";
										+"</li></ul>";  
			
			// style the participant as a link
			var l = dojo.byId(modelProperty.ParticipantId);
			l.style.cursor="pointer";
			dojo.addClass(l, "linkFieldFontDrillin");

			tdElem.modelProp = modelProperty;
			
			// connect to the participant for drillin
			dojo.connect( l, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.ParticipantId;
			    	params.documentName = tdElem.modelProp.participantName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.sranchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<ul style='margin-top:0px;margin-bottom:0px;'><li>"+value+"</li></ul>"; 
		}
		    

 


//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), ended");
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		    

		tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  


	},

	getpgData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	pgModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.ParticipantGrp.model.ParticipantGrpDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.ParticipantGrp.model.ParticipantGrpDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.ParticipantGrp.model.ParticipantGrpDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.ParticipantGrp.model.ParticipantGrpDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "ParticipantGrpDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.ParticipantGrp.view.ParticipantGrpViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/participantGroup/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/assetview/user-group-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.webservice.view.webserviceViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.webservice.view.webserviceViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.webservice.view.webserviceViewer");








/**
 * webservice viewer
 */
dojo.declare("com.ibm.bpm.wpd.document.webservice.view.webserviceViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\" >\n<div class=\"viewerHeading\"  >\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='webserviceName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n<div>\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><h4>${messages.WEBSERVICE_DESC_HEADER}</h4></td>\n<td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='webserviceCopyLinkHref' href=\"#\"> \n${messages.WEBSERVICE_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n <div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='webserviceDescription'></div>\n</div>\n<div style='border:1px solid black;width:888px;'>\n<table dojoAttachPoint=webserviceTableHeader style='width:875px;' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=20% style=\"text-align: left;\"><b>${messages.WEBSERVICE_OPNAME_COLHEADER}</b></th>\n<th width=20% style=\"text-align: left;\"><b>${messages.WEBSERVICE_ASSOC_SERVICE_COLHEADER}</b></th>\n<th width=60% style=\"text-align: left;\"><b>${messages.WEBSERVICE_DESC_COLHEADER}</b></th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n<div dojoAttachPoint=\"webserviceDialogBody\" class='bspace-style' style='height:375px;padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=webserviceTable style='width: 875px;table-layout: fixed;' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left; margin-left:100px;\"></th>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=60% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=webserviceTableBody style='valign:top'>\n</tbody>\n</table>\n</div>\n</div>\n<table style='width: 875px;table-layout: fixed;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=85% style=\"text-align: left;\"><a dojoAttachPoint=webserviceWSDLLink target=\"_blank\">${messages.WEBSERVICE_WSDL_LABEL}</a></th>\n<th width=15% style=\"text-align: left;\"><div dojoAttachPoint=webserviceProtectedInd></div></th>\n</tr>\n</thead>\n<br>\n</div>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	wsModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 

	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.getboData();
		}else {
			//Get the server side data
			wsModel = this.viewStateModel.getDocumentModel();;
		}
		
		
		console.log("in postCreate: " + wsModel.name);
		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(wsModel.richDesc) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(wsModel.richDesc));
			this.webserviceDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(wsModel.desc);
			if (dir=="rtl")
				this.webserviceDescription.setAttribute("style","direction:rtl; text-align:left;");
		} else { 
			this.webserviceDescription.innerHTML = "&nbsp;";
		}

		this.webserviceName.innerHTML = wsModel.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(wsModel.name);
		if (dir=="rtl") {
			this.webserviceName.setAttribute("style","direction:rtl; text-align:left;");
		}
		
		this.fillInTable();
		
		this.webserviceWSDLLink.href = wsModel.wsdlUrl;
		
		var parms = [];
		parms[0] = wsModel["protected"];
		var str = dojo.string.substitute(this.messages.WEBSERVICE_PROTECTED_LABEL, parms);
		this.webserviceProtectedInd.innerHTML = str;
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.webserviceCopyLinkHref);
	},
	
	postMixInProperties: function()
	{

        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.webservice.view", "webserviceViewerResources");
		


	},

	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},
	

	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	fillInTable: function()
	{
		
		var newRow = null;
		
		if (wsModel.operations != null) {
			var numOps = wsModel.operations.length;
			
			for (var i=0; i<numOps; i++) {
				newRow = this.insertRow();
				this.addTextCellToRow( newRow, wsModel.operations[i].name, this.bidiLeft, null, null );
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(wsModel.operations[i].name);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
				this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(wsModel.operations[i].serviceName), this.bidiLeft, null, wsModel.operations[i] );
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(wsModel.operations[i].serviceName);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
				if (typeof(wsModel.operations[i].richDesc) !== "undefined") {
					var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(wsModel.operations[i].richDesc));
					dojo.addClass(newRow, "richTextFormat");
					this.addTextCellToRow( newRow, str, this.bidiLeft, null, null );
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(wsModel.operations[i].desc);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
				} else {
					this.addTextCellToRow( newRow, "", this.bidiLeft, null, null );
				}
			}
		}
	},
	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function()
	{
		var tbodyElem = this.webserviceTableBody;
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);

		return trElem;
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname, modelOp)
	{
//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), Started : " + value);
		var tdElem = trElem.insertCell(trElem.cells.length);
//		tdElem.style.whiteSpace="nowrap";
//		tdElem.style.whiteSpace="normal";
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		    

		if ((modelOp != null) && (modelOp.serviceId != null)) {
			tdElem.innerHTML = "<u>"+value+"</u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = modelOp;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.serviceId;
			    	params.documentName = tdElem.modelProp.serviceName;
			    	
			    	if (tdElem.modelProp.serviceSnapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.serviceSnapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.serviceBranchId != null ) {
			    		params.branchId = tdElem.modelProp.serviceBranchId;
			    	}

			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  

		}

//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), ended");
	},

	getboData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	wsModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.webservice.model.webserviceDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.webservice.model.webserviceDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.webservice.model.webserviceDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.webservice.model.webserviceDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "webserviceDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.webservice.view.webserviceViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/webservice/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/assetview/web-service-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.uca.view.ucaViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.uca.view.ucaViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.uca.view.ucaViewer");










/**
 * UCA viewer
 * 
 * 		
 */
dojo.declare("com.ibm.bpm.wpd.document.uca.view.ucaViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\" >\n<div class=\"viewerHeading\"  >\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='ucaName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n<div>\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><h4>${messages.UCA_DESC_HEADER}</h4></td>\n<td class=\"shareLinkClass\" style= \"text-align: right\"><a dojoAttachPoint='ucaCopyLinkHref' href=\"#\"> \n${messages.UCA_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n <div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='ucaDescription'></div>\n</div>\n<table dojoAttachPoint=ucaExpressionTableHeader style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th dojoAttachPoint=ucaNameHeader width=100% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\"></th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n\n<div dojoAttachPoint=\"ucaDialogBody\" class='bspace-style' style='height:160px;padding-top:0px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=ucaTable style='width:100%; margin-left:5px;margin-bottom:0px;' cellpadding=\"0\" cellspacing=\"10\">\n<thead>\n<tr>\n<th width=10% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n<th width=90% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=ucaTableBody>\n</tbody>\n</table>\n</div>\n\n<table style='width:100%;margin-top:0px;;margin-left:20px' cellspacing=\"0\" cellpadding=\"0\">\n\n<td valign=\"top\" width=20%>\n<table dojoAttachPoint=ucaMonthTable style='width:100%;margin-top:0px;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=ucaMonthTableBody>\n</tbody>\n</table>\n</td>\n\n\n<td valign=\"top\" width=20%>\n<table dojoAttachPoint=ucaFreqTable style='width:100%; margin-left:5px;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=ucaFreqTableBody>\n</tbody>\n</table>\n</td>\n\n<td valign=\"top\", width=20%; >\n<table dojoAttachPoint=ucaDaysTable style='width:100%; margin-left:5px;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=ucaDaysTableBody>\n</tbody>\n</table>\n</td>\n\n\n<td valign=\"top\", width=20%>\n\n<table dojoAttachPoint=ucaHoursTable style='width:100%;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=ucaHoursTableBody>\n</tbody>\n</table>\n\n</td>\n\n\n<td valign=\"top\" width=20%>\n<table dojoAttachPoint=ucaMinsTable style='width:100%; margin-left:5px;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=ucaMinsTableBody>\n</tbody>\n</table>\n</td>\n\n\n</table>\n\n</div>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	ucaModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 
	
	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.getpgData();
		}else {
			//Get the server side data
			ucaModel = this.viewStateModel.getDocumentModel();;
		}
		
		
		console.log("in postCreate: " + ucaModel.name);
		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(ucaModel.richDesc) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(ucaModel.richDesc));
			this.ucaDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(ucaModel.desc);
			if (dir=="rtl")
				this.ucaDescription.setAttribute("style","direction:rtl; text-align:left;");

		} else { 
			this.ucaDescription.innerHTML = "&nbsp;";
		}

		this.ucaName.innerHTML = com.ibm.bpm.wpd.util.Helper.text2htmlText(ucaModel.name);
		this.ucaNameHeader.innerHTML = com.ibm.bpm.wpd.util.Helper.text2htmlText(ucaModel.name);
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(ucaModel.name);
		if (dir=="rtl") {
			this.ucaName.setAttribute("style","direction:rtl; text-align:left;");
			this.ucaNameHeader.setAttribute("style","direction:rtl; text-align:left;");
		}
		this.fillInUcaData();
        
		/*
		 *  Create Share link href Document
		 */
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.ucaCopyLinkHref);
		
	},
	
	postMixInProperties: function()
	{

        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.uca.view", "ucaViewerResources");


	},
	
	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},

	
	//*****
	//Insert a new row into the table
	//   	In this case this is an expression type of participant group
	//
	//Returns: reference to the new row
	//*****
	fillInUcaData: function()
	{
		
		var newRow = null;
		var m = ucaModel;
		
		
		// Service row
		newRow = this.insertRow(this.ucaTableBody);
		this.addTextCellToRow( newRow, this.messages.UCA_ATTACHED_SERVICE, this.bidiLeft, null);
		this.addLinkCellToRow( newRow, m.serviceName, this.bidiLeft, null, m); 
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.serviceName);
		if (dir=="rtl") {
			if (newRow.cells[newRow.cells.length-1])
				newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
		}
		
		// Associated queue row
		newRow = this.insertRow(this.ucaTableBody);
		this.addTextCellToRow( newRow, this.messages.UCA_ASSOCIATED_QUEUE, this.bidiLeft, null);
		this.addTextCellToRow( newRow, m.queue, this.bidiLeft, null);
		
		
		if (m.schedType == "OnEvent") {
			// Event Message row
			newRow = this.insertRow(this.ucaTableBody);
			this.addTextCellToRow( newRow, this.messages.UCA_EVENT_MESSAGE, this.bidiLeft, null);
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlText(this.replaceNewLines(m.eventMessage));
			this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			
			// Enabled row
			newRow = this.insertRow(this.ucaTableBody);
			this.addTextCellToRow( newRow, this.messages.UCA_ENABLED, this.bidiLeft, null);
			this.addTextCellToRow( newRow, m.enabled, this.bidiLeft, null);
			
			
		} else {
			
			// Enabled row
			newRow = this.insertRow(this.ucaTableBody);
			this.addTextCellToRow( newRow, this.messages.UCA_ENABLED, this.bidiLeft, null);
			this.addTextCellToRow( newRow, m.enabled, this.bidiLeft, null);
			
			
			// Schedule header
			newRow = this.insertRow(this.ucaTableBody);
			this.addTextCellToRow( newRow, "", this.bidiLeft, null);
			newRow = this.insertRow(this.ucaTableBody);
			this.addTextCellToRow( newRow, "", this.bidiLeft, null);

			newRow = this.insertRow(this.ucaTableBody);
			this.addTextCellToRow( newRow, this.messages.UCA_SCHEDULE_HEADER, this.bidiLeft, null);

			
			
			// Create Month Table
			
			var i = 1;
			var numMons = m.timeSchedule.month.length;
			for (i=0;i<numMons;i++)
			{
				newRow = this.insertRow(this.ucaMonthTableBody);
				this.addTextCellToRow( newRow, this.getMonthString(m.timeSchedule.month[i]), this.bidiLeft, null);
			}

			
			// Create Freq Table
			
			if (m.timeSchedule.freqType != null) {
				newRow = this.insertRow(this.ucaFreqTableBody);
				var freq = null;
				
				switch (m.timeSchedule.freqType) {
				case "First":
					freq = this.messages.UCA_FREQ_FIRST;
					break;
				case "Last":
					freq = this.messages.UCA_FREQ_LAST;
					break;
				case "Every":
					freq = this.messages.UCA_FREQ_EVERY;
					break;					
				}
				this.addTextCellToRow( newRow, freq, this.bidiLeft, null);
			}
			
			


			
			
			// Create Days Table
			var i = 1;
			var numDays = m.timeSchedule.weekDay.length;
			for (i=0;i<numDays;i++)
			{
				newRow = this.insertRow(this.ucaDaysTableBody);
				this.addTextCellToRow( newRow, this.getDayString(m.timeSchedule.weekDay[i]), this.bidiLeft, null);
			}
			
			
		
			// Create Hours Table
			var i=0;
			var numHours = m.timeSchedule.hours.length;
			for (i=0;i<numHours;i++)
			{
				newRow = this.insertRow(this.ucaHoursTableBody);
				this.addTextCellToRow( newRow, m.timeSchedule.hours[i] + ":00", this.bidiLeft, null);
			}


			
			// Create the Minutes table
			
			var i=0;
			var parms = [];
			var str = null;
			var numMins = m.timeSchedule.minutes.length;
			for (i=0;i<numMins;i++)
			{
				newRow = this.insertRow(this.ucaMinsTableBody);
				if (m.timeSchedule.minutes[i] == "0") {
					this.addTextCellToRow( newRow, this.messages.UCA_MINS_ONTHEHOUR, this.bidiLeft, null);
				} else {
					parms[0] = m.timeSchedule.minutes[i];
					str = dojo.string.substitute(this.messages.UCA_MINS_PASTHOUR, parms);
					this.addTextCellToRow( newRow, str, this.bidiLeft, null);
				}
				
			}
			
			
			
			
//			this.addTextCellToRow( newRow, m.eventMessage, this.bidiLeft, null);
			
		}
			

		


	},
	
	
	//*****
	//Convert from a day  to a day string
	//
	//Returns: month day of week
	//*****
	getDayString: function(dayParm)
	{


		var dayString = null;
		switch(dayParm) {
		case "MONDAY":
			dayString = this.messages.UCA_DAYS_MON;
			break;
		case "TUESDAY":
			dayString = this.messages.UCA_DAYS_TUES;
			break;		
		case "WEDNESDAY":
			dayString = this.messages.UCA_DAYS_WED;
			break;
		case "THURSDAY":
			dayString = this.messages.UCA_DAYS_THURS;
			break;
		case "FRIDAY":
			dayString = this.messages.UCA_DAYS_FRI;
			break;	
		case "SATURDAY":
			dayString = this.messages.UCA_DAYS_SAT;
			break;
		case "SUNDAY":
			dayString = this.messages.UCA_DAYS_SUN;
			break;			
			
		default:
			throw new Error("not a valid day");
	
		}
		return dayString;
	},
	
	//*****
	//Convert from a number to a month
	//
	//Returns: month string
	//*****
	getMonthString: function(monthNum)
	{

		
		var monString = null;
		switch(monthNum) {
		case 1:
			monString = this.messages.UCA_JAN;
			break;
		case 2:
			monString = this.messages.UCA_FEB;
			break;		
		case 3:
			monString = this.messages.UCA_MAR;
			break;
		case 4:
			monString = this.messages.UCA_APR;
			break;
		case 5:
			monString = this.messages.UCA_MAY;
			break;	
		case 6:
			monString = this.messages.UCA_JUNE;
			break;
		case 7:
			monString = this.messages.UCA_JULY;
			break;			
		case 8:
			monString = this.messages.UCA_AUG;
			break;		
		case 9:
			monString = this.messages.UCA_SEPT;
			break;
		case 10:
			monString = this.messages.UCA_OCT;
			break;			
		case 11:
			monString = this.messages.UCA_NOV;
			break;		
		case 12:
			monString = this.messages.UCA_DEC;
			break;		
			
		default:
			throw new Error("Invalid month!");
	
		}
		return monString;
	},
	

	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function(tbodyElem)
	{
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		return trElem;
	},

	//*****
	// Add a Link cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addLinkCellToRow: function(trElem, value, align, classname, modelProperty)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		    

//        "serviceId":"1.30397b90-a06d-4970-8f0c-ba8058c1271b",
//        "serviceName":" Installation Service",
//        "serviceSnapshotId":null,
//        "serviceBranchId":"2063.1a52abd6-b068-4f9e-91a9-ded9793eb34e",		
		if ((modelProperty != null) && (modelProperty.serviceId != null)) {
			tdElem.innerHTML = "<u><b>"+com.ibm.bpm.wpd.util.Helper.text2htmlText(value)+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = modelProperty;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.serviceId;
			    	params.documentName = tdElem.modelProp.serviceName;
			    	
			    	if (tdElem.modelProp.serviceSnapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.serviceSnapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.serviceBranchId != null ) {
			    		params.branchId = tdElem.modelProp.serviceBranchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+com.ibm.bpm.wpd.util.Helper.text2htmlText(value)+"</font>";  
		}


	},
	
	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname)
	{
//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), Started : " + value);
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";

		tdElem.align=align;

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		    

		tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
//		tdElem.innerHTML = "<font\">"+value+"</font>";  


//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), ended");
	},
	

	getpgData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	ucaModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.uca.model.ucaDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.uca.model.ucaDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.uca.model.ucaDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.uca.model.ucaDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "ucaDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.uca.view.ucaViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/uca/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			if (this.viewStateModel != null && this.viewStateModel.getDocumentModel() != null) {
				if(this.viewStateModel.getDocumentModel().schedType == "OnEvent") {
					if(this.viewStateModel.getDocumentModel().eventType == "Message") {
						return "images/assetview/message_undercover_agent_16x16.png";
					}
					else if(this.viewStateModel.getDocumentModel().eventType == "Content") {
						return "images/assetview/content_undercover_agent_16x16.png";
					}
				}
				if (this.viewStateModel.getDocumentModel().schedType == "TimeElapsed") {
					if(this.viewStateModel.getDocumentModel().eventType == "Timer") {
						return "images/assetview/timer_undercover_agent_16x16.png";
					}
				}
			}
			return "images/assetview/undercover-agent-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.ea.view.eaViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.ea.view.eaViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.ea.view.eaViewer");








/**
 * eaViewer
 */
dojo.declare("com.ibm.bpm.wpd.document.ea.view.eaViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\" >\n<div class=\"viewerHeading\"  >\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='eaName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n<div>\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><h4>${messages.EA_DESC_HEADER}</h4></td>\n<td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='eaCopyLinkHref' href=\"#\"> \n${messages.EA_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n <div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='eaDescription'></div>\n</div>\n\n<h4>${messages.EA_CUSTOMATTR_HEADER}</h4>\n<table dojoAttachPoint=eaCustomPTableHeader style='width:450px;table-layout: fixed; border:1px solid black' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=25% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${messages.EA_NAME}</th>\n<th width=25% style=\"background-color:#e2e2e2; text-align: left;\">${messages.EA_VALUE}</th>\n</tr>\n</thead>\n<tbody style='valign:top'>\n</tbody>\n</table>\n<div dojoAttachPoint=\"eaCustomPDialogBody\" class='bspace-style' style=';padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=eaCustomPTable style='width:450px;table-layout: fixed' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=25% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=25% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=eaCustomPTableBody>\n</tbody>\n</table>\n\n<br>\n <h4>${messages.EA_INPUTS_HEADER}</h4>\n<table dojoAttachPoint=eaInputTableHeader style='width:100%; border:1px solid black' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=25% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${messages.EA_PARM_COLHEADER}</th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\">${messages.EA_TYPE_COLHEADER}</th>\n<th width=55% style=\"background-color:#e2e2e2;  text-align: left;\">${messages.EA_DESC_COLHEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n<div dojoAttachPoint=\"eaInputDialogBody\" class='bspace-style' style='padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=eaInputTable style='width:895px;table-layout: fixed' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=25% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n<th width=55% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=eaInputTableBody style='valign:top'>\n</tbody>\n</table>\n\n<br>\n <h4>${messages.EA_OUTPUTS_HEADER}</h4>\n<table dojoAttachPoint=eaOutputTableHeader style='width:100%; border:1px solid black' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=25% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${messages.EA_PARM_COLHEADER}</th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\">${messages.EA_TYPE_COLHEADER}</th>\n<th width=55% style=\"background-color:#e2e2e2;  text-align: left;\">${messages.EA_DESC_COLHEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n<div dojoAttachPoint=\"eaOutputDialogBody\" class='bspace-style' style='height:200px;padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=eaOutputTable style='width:895px;table-layout: fixed' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=25% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n<th width=55% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=eaOutputTableBody style='valign:top'>\n</tbody>\n</table>\n\n\n</div>\n</div>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	eaModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 

		

	
	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.geteaData();
		}else {
			//Get the server side data
			eaModel = this.viewStateModel.getDocumentModel();;
		}
		
		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(eaModel.richDescription) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(this.replaceNewLines(eaModel.richDescription)));
			this.eaDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(eaModel.desc);
			if (dir=="rtl")
				this.eaDescription.setAttribute("style","direction:rtl; text-align:left;");

		} else { 
			this.eaDescription.innerHTML = "&nbsp;";
		}

		this.eaName.innerHTML = eaModel.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(eaModel.name);
		if (dir=="rtl")
			this.eaName.setAttribute("style","direction:rtl; text-align:left;");
		
		var m = eaModel;
	
		this.fillInInputsTable();
		this.fillInOutputsTable();
		this.fillInCustomProperties();

		/*
		 *  Create Share link href Document
		 */
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.eaCopyLinkHref);

	},
	
	postMixInProperties: function()
	{

        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.ea.view", "eaViewerResources");


	},
	
	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},

	//*****
	//Insert inputs into the input table
	//
	//Returns: reference to the new row
	//*****
	fillInCustomProperties: function()
	{
		
		var newRow = null;
		var m = eaModel;
		
		var cps = eaModel.customProperties;
		for (var cp in cps)
		{
			newRow = this.insertRow(this.eaCustomPTableBody);
			this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(cp), this.bidiLeft, null, null );
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(cp);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
			
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlText(this.replaceNewLines(this.replaceNewLines(cps[cp])));
			this.addTextCellToRow( newRow, str, this.bidiLeft, null, null);
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(cps[cp]);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
		}
		
		newRow = this.insertRow(this.eaCustomPTableBody);
		this.addTextCellToRow( newRow, "", this.bidiLeft, null, null );

	},
	

	//*****
	//Insert inputs into the input table
	//
	//Returns: reference to the new row
	//*****
	fillInInputsTable: function()
	{
		
		var newRow = null;
		var m = eaModel;
		
		var inputs = eaModel.inputs;
		for (var inputName in inputs)
		{
			
			newRow = this.insertRow(this.eaInputTableBody);
			var inputStr = inputName;
			if (inputs[inputName].isList) {
				this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(inputName) + this.messages.EA_LIST, this.bidiLeft, null, null );
				inputStr = inputName + this.messages.EA_LIST;
			} else {
				this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(inputName), this.bidiLeft, null, null );
			}
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(inputStr);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}

			this.addTextCellToRow( newRow, inputs[inputName].type, this.bidiLeft, null, inputs[inputName]);
			dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(inputs[inputName].type);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
			if ((typeof(inputs[inputName].richDesc) !== "undefined") && (inputs[inputName].richDesc != null)) {
				var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(inputs[inputName].richDesc));
				dojo.addClass(newRow, "richTextFormat");
				this.addTextCellToRow( newRow, str, this.bidiLeft, null, null );
				dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(inputs[inputName].desc);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
			} else {
				this.addTextCellToRow( newRow, "", this.bidiLeft, null, null );
			}

		}
		newRow = this.insertRow(this.eaInputTableBody);
		this.addTextCellToRow( newRow, "", this.bidiLeft, null, null );

	},
	
	//*****
	//Insert outputs into the output table
	//
	//Returns: reference to the new row
	//*****
	fillInOutputsTable: function()
	{
		
		var newRow = null;
		var m = eaModel;
		
		var outputs = eaModel.outputs;
		for (var outputName in outputs)
		{
			
			newRow = this.insertRow(this.eaOutputTableBody);
			var outputStr = outputName;
			if (outputs[outputName].isList) {
				this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(outputName) + this.messages.EA_LIST, this.bidiLeft, null, null );
				outputStr = outputName + this.messages.EA_LIST;
			} else {
				this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(outputName), this.bidiLeft, null, null );
			}
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(outputStr);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}

			this.addTextCellToRow( newRow, outputs[outputName].type, this.bidiLeft, null, outputs[outputName]);
			dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(outputs[outputName].type);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
			if ((typeof(outputs[outputName].richDesc) !== "undefined") && (outputs[outputName].richDesc != null)) {
				var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(outputs[outputName].richDesc));
				dojo.addClass(newRow, "richTextFormat");
				this.addTextCellToRow( newRow, str, this.bidiLeft, null, null );
				dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(outputs[outputName].desc);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
			} else {
				this.addTextCellToRow( newRow, "", this.bidiLeft, null, null );
			}

		}	
		newRow = this.insertRow(this.eaOutputTableBody);
		this.addTextCellToRow( newRow, "", this.bidiLeft, null, null );

	},
	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function(tbodyElem)
	{
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);

		return trElem;
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname, modelProperty)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		    
		if ((modelProperty != null) && (modelProperty.classId != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = modelProperty;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.classId;
			    	params.documentName = tdElem.modelProp.type;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    	
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}


	},

	geteaData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	boModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.ea.model.eaDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.ea.model.eaDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.ea.model.eaDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.ea.model.eaDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "eaDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.ea.view.eaViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/externalactivity/" + docId + "/model/?authoring=true&";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/assetview/external_activity_16x16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.tg.view.tgViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.tg.view.tgViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.tg.view.tgViewer");









/**
 * tgViewer
 */
dojo.declare("com.ibm.bpm.wpd.document.tg.view.tgViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\" >\n<div class=\"viewerHeading\"  >\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='tgName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><div><h4>${messages.TG_DESC_HEADER}</h4>\n<div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='tgDescription'></div>\n</div></h4></td>\n<td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='tgCopyLinkHref' href=\"#\"> \n${messages.TG_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n\n<h4>${messages.TG_TRACKEDFIELDS_HEADER}</h4>\n<div class=\"viewerDescriptionText\">${messages.TG_FIELD_DESCRIPTION}</div>\n\n\n<table dojoAttachPoint=tgFieldsTableHeader style='width: 890px;table-layout: fixed; border:1px solid black' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${messages.TG_NAME_COLHEADER}</th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\">${messages.TG_TYPE_COLHEADER}</th>\n<th width=50% style=\"background-color:#e2e2e2;  text-align: left;\">${messages.TG_DESC_COLHEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n<div dojoAttachPoint=\"tgFieldsDialogBody\" class='bspace-style' style='padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=tgFieldsTable style='width: 890px;table-layout: fixed;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n<th width=50% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=tgFieldsTableBody style='valign:top'>\n</tbody>\n</table>\n<br>\n\n</div>\n</div>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	tgModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 

	
	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.geteaData();
		}else {
			//Get the server side data
			tgModel = this.viewStateModel.getDocumentModel();;
		}
		
		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(tgModel.richDesc) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(tgModel.richDesc));
			this.tgDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tgModel.desc);
			if (dir=="rtl")
				this.tgDescription.setAttribute("style","direction:rtl; text-align:left;");
		} else { 
			this.tgDescription.innerHTML = "&nbsp;";
		}

		this.tgName.innerHTML = tgModel.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tgModel.name);
		if (dir=="rtl")
			this.tgName.setAttribute("style","direction:rtl; text-align:left;");
		
		var m = tgModel;
		
		this.fillInFieldsTable();
		
		/*
		 *  Create Copy link href Document
		 */
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.tgCopyLinkHref);
		

	},
	
	postMixInProperties: function()
	{

        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.tg.view", "tgViewerResources");


	},

	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},
	

	//*****
	//Insert fields into the tracking group fields table
	//
	//Returns: reference to the new row
	//*****
	fillInFieldsTable: function()
	{
	
		var newRow = null;
		
		if (tgModel.variables != null) {
		
			var numFields = tgModel.variables.length;
			
			for (var i=0; i<numFields; i++) {
				newRow = this.insertRow(this.tgFieldsTableBody);
				this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(tgModel.variables[i].name), this.bidiLeft, null, null );
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tgModel.variables[i].name);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
				this.addTextCellToRow( newRow, tgModel.variables[i].type, this.bidiLeft, null, tgModel.variables[i]);
				dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tgModel.variables[i].type);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
				if ((typeof(tgModel.variables[i].richDesc) !== "undefined")&&(tgModel.variables[i].richDesc != null)) {
					var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(tgModel.variables[i].richDesc));
					dojo.addClass(newRow, "richTextFormat");
					this.addTextCellToRow( newRow, str, this.bidiLeft, null, null );
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tgModel.variables[i].desc);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
				} else {
					this.addTextCellToRow( newRow, "", this.bidiLeft, null, null );
				}
			}
		}

	},
	

	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function(tbodyElem)
	{
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);

		return trElem;
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname, modelProperty)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";


		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";

		tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  


//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), ended");
	},

	geteaData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	boModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.tg.model.tgDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.tg.model.tgDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.tg.model.tgDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.tg.model.tgDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "tgDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.tg.view.tgViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		var url = "/v1/trackinggroup/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/assetview/tracking-group-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.timingInt.view.timingIntViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.timingInt.view.timingIntViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.timingInt.view.timingIntViewer");








/**
 * timingInt viewer
 * 
 * 		
 */
dojo.declare("com.ibm.bpm.wpd.document.timingInt.view.timingIntViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\">\n<div class=\"viewerHeading\">\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='timingIntName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><div>\n <h4>${messages.TI_DESC_HEADER}</h4>\n <div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='timingIntDescription'></div>\n </div></td>\n<td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='tiCopyLinkHref' href=\"#\"> \n${messages.TI_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n\n<table dojoAttachPoint=timingIntStartTableHeader style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=50% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\"><b>${messages.TI_START_HEADER}</b></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=timingIntStartTableBody>\n</tbody>\n</table>\n<table dojoAttachPoint=timingIntStartBoundHeader style='width:100%;'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n</tr>\n</thead>\n<tbody dojoAttachPoint=timingIntStartBoundBody>\n</tbody>\n</table>\n\n<br>\n\n\n<table dojoAttachPoint=timingIntStartPointsTable style='width: 700px;table-layout: fixed; margin-left:15px;' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=20%  style=\"background-color:#e2e2e2; text-align: left;\"><b>${messages.TI_PROCESS_HEADER}</b></th>\n<th width=20%  style=\"background-color:#e2e2e2; text-align: left;\"><b>${messages.TI_TRACKINGP_HEADER}</b></th>\n<th width=20%  style=\"background-color:#e2e2e2; text-align: left;\"><b>${messages.TI_TRACKINGG_HEADER}</b></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=timingIntStartTableBody style='valign:top'>\n</tbody>\n</table>\n</td>\n\n<br><br>\n\n<table style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=50% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\"><b>${messages.TI_END_HEADER}</b></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=timingIntEndTableBody>\n</tbody>\n</table>\n<table dojoAttachPoint=timingIntEndBoundHeader style='width:100%;'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n</tr>\n</thead>\n<tbody dojoAttachPoint=timingIntEndBoundBody>\n</tbody>\n</table>\n\n<br>\n\n<td valign=\"top\" width=50%>\n<table dojoAttachPoint=timingIntEndPointsTable style='width: 700px;table-layout: fixed; margin-left:15px; ' cellpadding=\"0\" cellspacing=\"2\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;text-align: left;\"><b>${messages.TI_PROCESS_HEADER}</b></th>\n<th width=20% style=\"background-color:#e2e2e2;text-align: left;\"><b>${messages.TI_TRACKINGP_HEADER}</b></th>\n<th width=20% style=\"background-color:#e2e2e2;text-align: left;\"><b>${messages.TI_TRACKINGG_HEADER}</b></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=timingIntEndTableBody style='valign:top'>\n</tbody>\n</table>\n\n<br>\n\n</div>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	timingIntModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 
	
	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.getpgData();
		}else {
			//Get the server side data
			timingIntModel = this.viewStateModel.getDocumentModel();;
		}

		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(timingIntModel.richDesc) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(timingIntModel.richDesc));
			this.timingIntDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(timingIntModel.desc);
			if (dir=="rtl")
				this.timingIntDescription.setAttribute("style","direction:rtl; text-align:left;");

		} else { 
			this.timingIntDescription.innerHTML = "&nbsp;";
		}

		this.timingIntName.innerHTML = timingIntModel.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(timingIntModel.name);
		if (dir=="rtl")
			this.timingIntName.setAttribute("style","direction:rtl; text-align:left;");

	
		this.fillInTimingIntData();
		
		/*
		 *  Create Copy link href Document
		 */
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.tiCopyLinkHref);

		
	},
	
	postMixInProperties: function()
	{
        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.timingInt.view", "timingIntViewerResources");
	},

	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},
	
	//*****
	//Insert a new rows into the tables
	//   	In this case there are is one table containing two tables
	//			- one for timer start and one for timer end
	//*****
	fillInTimingIntData: function()
	{
		
		var newRow = null;
		var m = timingIntModel;
		
		//create labels for calculation start bound
		newRow = this.insertRow(this.timingIntStartBoundBody);
		if (m.intervalStart == "latest") {
			this.addTextCellToRow( newRow, this.messages.TI_CALC_BOUND_LATEST, this.bidiLeft, null);
		} else {
			this.addTextCellToRow( newRow, this.messages.TI_CALC_BOUND_EARLIEST, this.bidiLeft, null);	
		}
	
		//create labels for calculation end bound
		newRow = this.insertRow(this.timingIntEndBoundBody);		
		if (m.intervalEnd == "latest") {
			this.addTextCellToRow( newRow, this.messages.TI_CALC_BOUND_LATEST, this.bidiLeft, null);
		} else {
			this.addTextCellToRow( newRow, this.messages.TI_CALC_BOUND_EARLIEST, this.bidiLeft, null);
			
		}
		
		
		// create start/end point rows
		var i = 1;
		
		if (m.timeIntervalBounds != null) {
			var numTimeIntervals = m.timeIntervalBounds.length;
			for (i=0;i<numTimeIntervals;i++)
			{
				if (m.timeIntervalBounds[i].type == "start") {
					newRow = this.insertRow(this.timingIntStartTableBody);
				} else {
					newRow = this.insertRow(this.timingIntEndTableBody);
				}
				
				if (m.timeIntervalBounds[i].bpdRef != null) {
					this.addBpdLinkCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(m.timeIntervalBounds[i].bpdRef.bpdName), this.bidiLeft, null, m.timeIntervalBounds[i].bpdRef);
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.timeIntervalBounds[i].bpdRef.bpdName);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
				} else {
					this.addServiceLinkCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(m.timeIntervalBounds[i].serviceRef.serviceName), this.bidiLeft, null, m.timeIntervalBounds[i].serviceRef);
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.timeIntervalBounds[i].serviceRef.serviceName);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
				}
				
				this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(m.timeIntervalBounds[i].trackingPointName), this.bidiLeft, null, null);
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.timeIntervalBounds[i].trackingPointName);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
				this.addTrackingGLinkCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(m.timeIntervalBounds[i].trackingGroupRef.trackingGroupName), this.bidiLeft, null, m.timeIntervalBounds[i].trackingGroupRef);
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.timeIntervalBounds[i].trackingGroupRef.trackingGroupName);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
			}
		}


	},
	
	


	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function(tbodyElem)
	{
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		return trElem;
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
	

		tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  

	},
	//*****
	// Add a link to a process as text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//		bpd - the process to link to
	//	
	//
	//*****
	addTrackingGLinkCellToRow: function(trElem, value, align, classname, trackingGroup)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";
		
		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
	
		// should this be a link for drill down
		if ((trackingGroup != null) && (trackingGroup.trackingGroupId != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = trackingGroup;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.trackingGroupId;
			    	params.documentName = tdElem.modelProp.trackingGroupName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}
  

	},
	//*****
	// Add a link to a process as text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//		bpd - the process to link to
	//	
	//
	//*****
	addBpdLinkCellToRow: function(trElem, value, align, classname, bpd)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";
		
		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
	
		// should this be a link for drill down
		if ((bpd != null) && (bpd.bpdId != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = bpd;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.bpdId;
			    	params.documentName = tdElem.modelProp.bpdName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}
  

	},
	//*****
	// Add a link to a service as text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//		bpd - the process to link to
	//	
	//
	//*****
	addServiceLinkCellToRow: function(trElem, value, align, classname, service)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";
		
		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
	
		// should this be a link for drill down
		if ((service != null) && (service.serviceId != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = service;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.serviceId;
			    	params.documentName = tdElem.modelProp.serviceName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}
  

	},

	getpgData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	timingIntModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.timingInt.model.timingIntDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.timingInt.model.timingIntDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.timingInt.model.timingIntDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.timingInt.model.timingIntDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "timingIntDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.timingInt.view.timingIntViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/timinginterval/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/assetview/timing-interval-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.ais.view.aisViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.ais.view.aisViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.ais.view.aisViewer");








/**
 * BaseViewer
 */
dojo.declare("com.ibm.bpm.wpd.document.ais.view.aisViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"aisVewerOutline\" >\n<div class=\"viewerHeading\"  >\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='aisName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n<div>\n <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><h4>${messages.AIS_DESC_HEADER}</h4></td>\n<td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='aisCopyLinkHref' href=\"#\"> \n${messages.AIS_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n\n<div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='aisDescription'></div>\n</div>\n\n\n\n<table style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th dojoAttachPoint=aisNameHeader width=100% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\"></th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n\n<br>\n\n<table style='width:970px;margin-top:0px;;margin-left:5px' cellspacing=\"0\" cellpadding=\"0\">\n\n<td>\n<table dojoAttachPoint=aisSummaryTable style='width:400px;margin-top:0px;' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=aisSummaryTableBody style='valign:top'>\n</tbody>\n</table>\n</td>\n\n\n<td valign=\"top\">\n<table dojoAttachPoint=aisVariablesTable style='width: 500px;table-layout: fixed;margin-left:75px;' cellpadding=\"0\" cellspacing=\"4\">\n<thead>\n<tr>\n<th width=25% style=\"text-align: left;\"><b>${messages.AIS_VARIABLES_HEADER}</b></th>\n<th width=25% style=\"text-align: left;\"><b>${messages.AIS_TYPE_HEADER}</b></th>\n<th width=14% style=\"text-align: center;\"><b>${messages.AIS_IN_HEADER}</b></th>\n<th width=14% style=\"text-align: center;\"><b>${messages.AIS_OUT_HEADER}</b></th>\n<th width=14% style=\"text-align: center;\"><b>${messages.AIS_ERROR_HEADER}</b></th>\n<th width=14% style=\"text-align: center;\"><b>${messages.AIS_ISLIST}</b></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=aisVariablesTableBody style='valign:top'>\n</tbody>\n</table>\n</td>\n\n</table>\n\n\n</div>\n<br>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	aisModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 
	
	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.getaisData();
		}else {
			//Get the server side data
			aisModel = this.viewStateModel.getDocumentModel();;
		}
		
		var m = aisModel;
		this.bidiLeft = "left";
		this.bidiRight = "right";
		this.bidiCenter = "center";

		if (typeof(m.richDesc) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(m.richDesc));
			this.aisDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.desc);
			if (dir=="rtl")
				this.aisDescription.setAttribute("style","direction:rtl; text-align:left;");
		} else { 
			this.aisDescription.innerHTML = "&nbsp;";
		}

		this.aisName.innerHTML = m.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.name);
		if (dir=="rtl")
			this.aisName.setAttribute("style","direction:rtl; text-align:left;");
		this.aisNameHeader.innerHTML = this.messages.AIS_DETAILS;
		

		
		this.fillInSummaryTable();
		this.fillInVariablesTable();
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.aisCopyLinkHref);

	},
	
	postMixInProperties: function()
	{

        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.ais.view", "aisViewerResources");


	},

	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},
	

	//*****
	//Fill in the summary table
	//
	//Returns: reference to the new row
	//*****
	fillInSummaryTable: function()
	{
		
		var newRow = null;
		var m = aisModel;
		
		newRow = this.insertRow(this.aisSummaryTableBody);
		
		var value = null;
		if (m.item.moduleName == null) {
			value = "";
		} else {
			value = m.item.moduleName;
		}
		var wholeString = "<b>" + this.messages.AIS_MODULE_NAME + "</b>" + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +value;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(value);
		if (dir=="rtl") {
			wholeString = "<b>" + this.messages.AIS_MODULE_NAME + "</b>" + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
						"<span dir='rtl'>" + value + "</span>";
		}
		this.addTextCellToRow(newRow, wholeString, this.bidiLeft, null, null);
		
		newRow = this.insertRow(this.aisSummaryTableBody);
		if (m.item.exportName == null) {
			value = "";
		} else {
			value = m.item.exportName;
		}
		wholeString = "<b>" + this.messages.AIS_EXPORT_NAME + "</b>" + "&nbsp;&nbsp;&nbsp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +value;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(value);
		if (dir=="rtl") {
			wholeString = "<b>" + this.messages.AIS_EXPORT_NAME + "</b>" + "&nbsp;&nbsp;&nbsp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
						"<span dir='rtl'>" + value + "</span>";		
		}
		this.addTextCellToRow(newRow, wholeString, this.bidiLeft, null, null);
		
		newRow = this.insertRow(this.aisSummaryTableBody);
		if (m.item.operationName == null) {
			value = "";
		} else {
			value = m.item.operationName;
		}
		wholeString = "<b>" + this.messages.AIS_OPERATION_NAME + "</b>" + "&nbsp;&nbsp;" +value;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(value);
		if (dir=="rtl") {
			wholeString = "<b>" + this.messages.AIS_OPERATION_NAME + "</b>" + "&nbsp;&nbsp;" +
						"<span dir='rtl'>" + value + "</span>";		
		}
		this.addTextCellToRow(newRow, wholeString, this.bidiLeft, null, null);
		
		newRow = this.insertRow(this.aisSummaryTableBody);
		
		
		// Logic from the client side - we replicate the logic here
		//
		//                    response = !getIsAsyncInvocation() || process.getAllOutputParameters().isEmpty() ?
		//                            UIMessages.getMessage("SCAConnectorTest_canBeUsedInService_yes", LocaleUtils.getCurrentUserLocale()):
		//                            UIMessages.getMessage("SCAConnectorTest_canBeUsedInService_no", LocaleUtils.getCurrentUserLocale());                                        

		
		if (m.item.isAsyncInvocation) {
			
			var numVars = m.variables.length;
			var areOutputs = false;
			for (var i=0; i<numVars; i++) {
				if (m.variables[i].type == "output"){
					areOutputs = true;
					break;
				}
			}
			
			if (!areOutputs) {
				value = this.messages.AIS_SYNCH_YES;
			} else {
				value = this.messages.AIS_SYNCH_NO;
			}

		} else {
			value = this.messages.AIS_SYNCH_YES;
		}
		this.addTextCellToRow(newRow, "<b>" + this.messages.AIS_ASYNCH_INVOKE+ "</b>" + "&nbsp;&nbsp;&nbsp;" +value, this.bidiLeft, null, null);	
		
	},
	
	//*****
	//Fill in the Variables table
	//
	//Returns: reference to the new row
	//*****
	fillInVariablesTable: function()
	{
		
		var newRow = null;
		var m = aisModel;
		

		if (m.variables != null) {
			var numVars = m.variables.length;
			for (var i=0; i<numVars; i++) {
				if (m.variables[i].type != "private") {
					
					newRow = this.insertRow(this.aisVariablesTableBody);
					
					// add name
					this.addTextCellToRow( newRow, m.variables[i].name, this.bidiLeft, null, null );
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.variables[i].name);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
					
					//add type
					this.addTextCellToRow( newRow, m.variables[i].poName, this.bidiLeft, null, m.variables[i] );
					dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.variables[i].poName);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
					
					// add check boxes (input)
					if (m.variables[i].type == "input") {
						this.addTextCellToRow( newRow, "<input type='checkbox' checked='checked' disabled='disabled' />", this.bidiCenter , null, null );
					} else {
						this.addTextCellToRow( newRow, "<input type='checkbox' id='checkin' disabled='disabled' />", this.bidiCenter, null, null );
					}
					
					// add check boxes (output)
					if (m.variables[i].type == "output") {
						this.addTextCellToRow( newRow, "<input type='checkbox' checked='checked' disabled='disabled' />", this.bidiCenter, null, null );
					} else {
						this.addTextCellToRow( newRow, "<input type='checkbox' id='checkin' disabled='disabled' />",this.bidiCenter, null, null );
					}
					
					// add check boxes (error)
					if (m.variables[i].type == "fault") {
						this.addTextCellToRow( newRow, "<input type='checkbox' checked='checked' disabled='disabled' />", this.bidiCenter, null, null );
					} else {
						this.addTextCellToRow( newRow, "<input type='checkbox' id='checkin' disabled='disabled' />",this.bidiCenter, null, null );
					}
					
					// add check boxes (List ?)
					if (m.variables[i].isList) {
						this.addTextCellToRow( newRow, "<input type='checkbox' checked='checked' disabled='disabled' />", this.bidiCenter, null, null );
					} else {
						this.addTextCellToRow( newRow, "<input type='checkbox' id='checkin' disabled='disabled' />",this.bidiCenter, null, null );
					}
				}

			}
		}

	},
	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function(tbodyElem)
	{
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		return trElem;
	},
	
	
	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname, modelProperty)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		
		tdElem.style.wordWrap="break-word";
		tdElem.align=align;

		tdElem.vAlign="top";

//		tdElem.style.whiteSpace="nowrap";
//
//		tdElem.align=align;

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		    
//		tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  

		if ((modelProperty != null) && (modelProperty.poId != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = modelProperty;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.poId;
			    	params.documentName = tdElem.modelProp.poName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}


	},

	getboData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	boModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.ais.model.aisDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.ais.model.aisDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.ais.model.aisDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.ais.model.aisDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "aisDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.ais.view.aisViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/SCAServiceModel/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/assetview/ais16_wle.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.compare.view.CompareAssetContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.compare.view.CompareAssetContainer"] = true;
dojo.provide("com.ibm.bpm.wpd.compare.view.CompareAssetContainer");



/**
 * Subclass of the AssetListAccordianContainer to customize it for our purpose
 */
dojo.declare("com.ibm.bpm.wpd.compare.view.CompareAssetContainer",
		[com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer],
		{
	
	historyRevisions: function(node,level) {
		// Don't really like this, maybe see if I can set a size back on revisions at the start
		var returnValue = 0;
		
		if (level == 4) {
			
			if (node.childNodes.length > 0 && node.childNodes[0].childNodes.length > 0) {
				return node.childNodes.length;
			}
		}

		for (var i=0;i<node.childNodes.length; i++) {
			//alert(node.childNodes[0].childNodes[i].childNodes.length);
			returnValue = this.historyRevisions(node.childNodes[i], (level  +1));
			if (returnValue > 0) {
				return returnValue;
			}
		}
		return returnValue;
		
	},
	
	/**
	 * Overwrite the superclass implementation to customize for ourselves. Compute the value based on the number of assets within the section.
	 * We could potentially cap this to a max size in the future.
	 * The reason for overwritng is the susperclass behaves differently depending on the browser we are viewing from. In the case of IE
	 * it appears to always come back with a height of around 200 px. In FF it's appears to be based on the size of the smallest section
	 * in the accordion. So if we have one small section and numerous large sections it'll always allocate based ont he smallest (which is
	 * kind of useless)
	 */
	_getTargetHeight: function(/* Node */ node){
		// Slight difference in IE as we have to use images to create the rounded corners so the height per
		// section is a little more
		
		if (dojo.isIE == 6)
			return 300;
		if (node.childNodes.length == 0)
			return 300;
		
		if (this.expandedSections) {
			var assetItems = 0;
			var assetItemsRevisions = 0;
						
			if (node.childNodes.length == 1) {
				if (dojo.isIE) {
					if (dojo.isIE < 8)
						assetItems = node.childNodes[0].childNodes.length * 73;
					else
						assetItems = node.childNodes[0].childNodes.length * 53;
					
					for (var i=0;i<node.childNodes[0].childNodes.length; i++) {
						var revisionCount = this.historyRevisions(node.childNodes[0].childNodes[i],1);
						assetItemsRevisions = assetItemsRevisions + revisionCount*18;
					}
					return assetItems+assetItemsRevisions;
				}

				assetItems = node.childNodes[0].childNodes.length * 38;
				for (var i=0;i<node.childNodes[0].childNodes.length; i++) {
					assetItemsRevisions = assetItemsRevisions + (node.childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[1].childNodes.length * 17);
				}
				return assetItems+assetItemsRevisions;
			}
			
			assetItems = node.childNodes.length * 36.5;
			for (var i=0;i<node.childNodes.length; i++) {
				assetItemsRevisions = assetItemsRevisions + (node.childNodes[i].childNodes.length * 30);
			}
			return assetItems+assetItemsRevisions;
		}
		else {
			// Will do this for now, what I'd like to do is separates section to there own widget and set a size
			if (node.childNodes.length == 1) {
				if (dojo.isIE)
					return node.childNodes[0].childNodes.length * 50;
				
				return node.childNodes[0].childNodes.length * 35;
			}
			
			return node.childNodes.length * 35;
		}
	},
	
	/**
	 * Overwrite the supserclass to provide the correct size on the default section
	 */
	layout: function(){
		this.inherited(arguments);

		// Overwrite the initial size of the default pane to prevent cutoff, for some reason it wasn't
		// resize the default section.
		var openPane = this.selectedChildWidget;
		if(openPane){
			var mySize = this._contentBox;

			var newHeight = this._getTargetHeight(openPane.domNode) + 10;
			
			if (!dojo.isIE) {
				newHeight = (this._getTargetHeight(openPane.domNode)*1.1) + 20;
			}
				
			this._containerContentBox = {
					h: newHeight,
					w: mySize.w
			};
			openPane.resize(this._containerContentBox);
		}			
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.compare.view.CompareListAssetSection"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.compare.view.CompareListAssetSection"] = true;
dojo.provide("com.ibm.bpm.wpd.compare.view.CompareListAssetSection");





dojo.declare("com.ibm.bpm.wpd.compare.view.CompareListAssetSection", [ com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection ], {
	
	templateString : "<div>" +
	"<div dojoAttachPoint='mainCompareAssetDiv' >" +
	"<span>" +
	  //"<div dojoAttachPoint='iefixDiv' style='width:1%;background-color:rgb(247, 247, 247);'></div>" +
	"<div dojoAttachPoint='iefixDiv' style='width:1%;background-color:white;'></div>" +
	  "<img style=\"float: left; padding: 3px;\" dojoAttachPoint='assetIconDiv' src=''>" +
	  "<div class='compareAssetListName' dojoAttachPoint='assetNameDiv' dojoAttachEvent=\"onclick: openAsset\"\>" +
         "<div class='dojoxEllipsis' dojoAttachPoint='assetNameDivInner'></div>" +
      "</div>" +
	  "<div class=\"compareAssetListModifiedBy\" dojoAttachPoint='assetModifiedByDiv'></div>" +
	  "<div class=\"compareAssetListModifiedDate\"  dojoAttachPoint='assetModifiedDateDiv'></div>" +
	"</span>" +
	"<div class=\"compareAssetListRevisionSection\" dojoAttachPoint='assetRevisionDiv'>" +
	"</div>" +
	"</div>" +
	"</div>",

	widgetsInTemplate : true,

	constructor: function() {
	},

	postMixInProperties: function()
	{
		this.inherited(arguments);
        
		this.compareMessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
	},
	
	postCreate: function() {
		
		if (dojo.isIE == 6)
			this.iefixDiv.style.width = '100%';
		
//		if (dojo.isIE) {
//			this.mainCompareAssetDiv.className = "compareListSectionItemIE";
//		}
//		else {
			if (this.leftSide) {
				this.mainCompareAssetDiv.className = "compareListSectionItemLS";
			}
			else {
				this.mainCompareAssetDiv.className = "compareListSectionItemRS";
			}
//		}

		var formattedName = com.ibm.bpm.wpd.util.Helper.text2htmlText(this.assetName);
		
		this.assetNameDivInner.innerHTML = formattedName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedName);
		if (dir=="rtl")
			this.assetNameDivInner.setAttribute("style","direction:rtl; text-align:left;");
		
		if (this.assetName.length > 30) {			
			new dijit.Tooltip ({
	      	      connectId: [this.assetNameDiv],
//	            	label: "<span dir = '" + dir + "'>" + formattedName + "</span>", // Bidi Support
	      	        label: formattedName,
		            position: ["above","below"]	
	      	  	});
		}

		this.assetIconDiv.src = this.assetIcon;
		this.assetModifiedByDiv.innerHTML = this.assetOwner;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.assetOwner);
		if (dir=="rtl")
			this.assetModifiedByDiv.setAttribute("style","direction:rtl;");
		this.assetModifiedDateDiv.innerHTML = this.formatDate(this.assetModifiedAt);
//		
		this.attachRevisions();
	},
	
	attachRevisions: function(){
		// Ideally I'd like to do this on first expand

		var sectionDiv = this.assetRevisionDiv;

//		if (dojo.isIE) {
//			this.assetRevisionDiv.className ='assetListRevisionSectionIE';
//			// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//			// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//			// To make this slight tricky is we need to be able to grow the container
//			
//			// First define a growable container which will set the top left icon
//			var mainDiv = document.createElement("div");
//			mainDiv.className="revgrowablecontainer";
//			this.assetRevisionDiv.appendChild(mainDiv);
//			// Add the top right image
//			var topDiv = document.createElement("div");
//			topDiv.className="revtop";
//			var topSpan = document.createElement("span");
//			topDiv.appendChild(topSpan);
//			mainDiv.appendChild(topDiv);
//			// Create the inner portion, we are in effect just wrapping our asset list section here
//			sectionDiv = document.createElement("div");
//			sectionDiv.className = "revright";
//			mainDiv.appendChild(sectionDiv);
//
//			// Finally add the bottom image, starting at the left, then continue to the right
//			var bottomDiv = document.createElement("div");
//			bottomDiv.className="revbottom";
//			var bottomSpan = document.createElement("span");
//			bottomDiv.appendChild(bottomSpan);
//			mainDiv.appendChild(bottomDiv);
//
//			this.assetRevisionDiv.style.visibility = 'visible';
//			this.assetRevisionDiv.style.display = 'block';
//		}

		for (var i = 0;i < this.changes.length;i++) {
        	var aChange = this.changes[i];
        	var revisionDiv = document.createElement("div");
			sectionDiv.appendChild(revisionDiv);
			revisionDiv.className = "compareAssetListRevision";
			if (aChange.actionType == "add")
				revisionDiv.innerHTML =  com.ibm.bpm.wpd.util.Helper.format(this.compareMessages.COMPARE_REV_ADDED,aChange.userName) + "&nbsp;&nbsp;&nbsp;&nbsp;" + dojo.date.locale.format(new Date(aChange.modified_on));
			else if (aChange.actionType == "delete")
				revisionDiv.innerHTML =  com.ibm.bpm.wpd.util.Helper.format(this.compareMessages.COMPARE_REV_DELETED,aChange.userName) + "&nbsp;&nbsp;&nbsp;&nbsp;" + dojo.date.locale.format(new Date(aChange.modified_on));
			else
				revisionDiv.innerHTML =  com.ibm.bpm.wpd.util.Helper.format(this.compareMessages.COMPARE_REV_MODIFIED,aChange.userName) + "&nbsp;&nbsp;&nbsp;&nbsp;" + dojo.date.locale.format(new Date(aChange.modified_on));
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(revisionDiv.innerHTML);
			if (dir=="rtl")
				revisionDiv.setAttribute("style","direction:rtl;");			
        }

	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.compare.view.CompareListView"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.compare.view.CompareListView"] = true;
dojo.provide("com.ibm.bpm.wpd.compare.view.CompareListView");








dojo.declare("com.ibm.bpm.wpd.compare.view.CompareListView", [ com.ibm.bpm.wpd.assetlistview.view.AssetListView ], {
		
	templateString : "<div style='height:100%;min-width:1100px;'>" +
	"<div dojoAttachPoint='compareListMainTrackTitle'>" + "</div>" +
	"<div style='clear:both'>" +
	"<div dojoAttachPoint='compareListSectionTitlesLeft'>" + "</div>" +
	"<div dojoAttachPoint='compareListSectionTitlesRight'>" + "</div>" +
	"</div>"+
//	"<div style='clear:both; width: 98%;margin-left:6px;padding-top:2px;padding-bottom:5px;' dojoAttachPoint='bcDiv' class='bpmnAccordionTitle' dojoAttachEvent='onclick:_onTitleClick'>" +
	"<div style='clear:both; width: 98%;margin-left:6px;padding-top:2px;padding-bottom:5px;' dojoAttachPoint='bcDiv' class='bpmnAccordionTitleBreadcrumb' dojoAttachEvent='onclick:_onTitleClick'>" +
	"<div style='padding-left:15px;padding-top:2px;' dojoAttachPoint='processAppBreadCrumb'></div>" +
	"</div>"+
	"<div dojoAttachPoint=\"assetListAttachPoint\" dojoType='com.ibm.bpm.wpd.compare.view.CompareAssetContainer'" + 
		"style='clear:both;height:100%;border:none;width: 100%;'>" +     						
	"</div>" +
	"</div>",
	
	
	widgetsInTemplate : true,
	trackCompare: true,
	
	constructor : function() {	
		this.reloadAppModel();
	},
	
	postCreate : function() {
		
		if (this.processAppBreadCrumb)
			this.processAppBreadCrumb.innerHTML = "<b>" + this.compareMessages.COMPARE_NAV_TITLE + "</b>";
		if (this.track1Name != this.track2Name) {
			var snapshot1DisplayName = this.snapshot1Name;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshot1DisplayName);
			if (dir=="rtl") {
				snapshot1DisplayName = "<span dir='rtl'>" + snapshot1DisplayName + "</span>";
			}
			var track1DisplayName = this.track1Name;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(track1DisplayName);
			if (dir=="rtl") {
				track1DisplayName = "<span dir='rtl'>" + track1DisplayName + "</span>";
			}
			var snapshot2DisplayName = this.snapshot2Name;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshot2DisplayName);
			if (dir=="rtl") {
				snapshot2DisplayName = "<span dir='rtl'>" + snapshot2DisplayName + "</span>";
			}
			var track2DisplayName = this.track2Name;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(track2DisplayName);
			if (dir=="rtl") {
				track2DisplayName = "<span dir='rtl'>" + track2DisplayName + "</span>";
			}
			this.compareListMainTrackTitle.innerHTML = "<b>" + 
				com.ibm.bpm.wpd.util.Helper.format(this.compareMessages.ACROSS_TRACK_COMPARE_TITLE,
					track1DisplayName + " / " + snapshot1DisplayName,
					track2DisplayName) + "</b>";
			this.compareListMainTrackTitle.className = "compareViewTrackTitle";
			
			this.compareListSectionTitlesLeft.innerHTML = "<b>" + track1DisplayName + " / " + snapshot1DisplayName + "</b>";
			this.compareListSectionTitlesLeft.className = "compareViewTrackLeftTitle";
			this.compareListSectionTitlesRight.innerHTML = "<b>" + track2DisplayName + " / " + snapshot2DisplayName + "</b>";
			this.compareListSectionTitlesRight.className = "compareViewTrackRightTitle";
		}
		this.assetListAttachPoint.expandedSections = true;
		this.inherited(arguments);
	},
	
	postMixInProperties: function()
	{
		this.inherited(arguments);
        
		this.compareMessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
	},
	
	reloadAppModel: function() {
		// Really need a clone of the app model as we'll be modifying it

		this.track1Name = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track1Name;
		this.track2Name = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track2Name;
		this.snapshot1Name = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.snaphost1Name;
		this.snapshot2Name = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.snaphost2Name;
		this.track1Id = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track1Id;
		if (this.track1Id != com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track2Id)
			this.track2Id = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track2Id;
	
		var step1 = dojo.toJson(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel);
		var al = {};
		al._assets = dojo.fromJson(step1)._assets.histories;
		this.setAssetModel(al);
		
	},
	
	/**
	 * Insert an individual section. A section being an asset type. The function performs lazy initialize of the sections
	 * to allow the asset list to display quicker. The section is added on first expansion, for a section that contains
	 * roughly 200 assets this will add an additional 500 ms to expansion
	 * @param parentDiv - The accordion  itself
	 * @param sectionName - The name of the section which is defined in the POType
	 * @param assetsCount - Number of assets in this section
	 * @param includeHeadings - Set to true to include header titles to right of name
	 * @param defaultSection - Default section is initial expanded section
	 * @returns - The dom node for this section
	 */
	insertAssetSection: function(parentDiv, sectionName, assetValue, assetInfo, assetsCount, includeHeadings, defaultSection) {
		
		var appModel = this.appModel;
		var ds = this;
		var sectionDiv = new dijit.layout.ContentPane( {
            onShow:function(){ 
            	if (!defaultSection && includeHeadings && sectionDiv.domNode.childNodes.length == 0) {            		
            		var newDiv = document.createElement("div");
            		sectionDiv.domNode.appendChild(newDiv);

            		if (assetInfo.compound) {
            			for (var asset in assetInfo.compound) {

            				var assetTrackValue = ds.appModel._assets[asset];
            				
            				// Doesn't exist
            				if (!assetTrackValue)
            					continue;
            				
            				var localAssetValue = ds.mergeData(assetTrackValue);
            				
	            			if(localAssetValue) {
			            		for (var i=0;i< localAssetValue.length; i++) {
				     				ds.insertAsset(localAssetValue[i],newDiv,assetInfo.compound[asset].icon);
			            		}
	            			}
            			}
            		}
            		else {
                		//var assetValue = appModel._assets[sectionName];
	            		for (var asset in assetValue) {
		     				ds.insertAsset(assetValue[asset],newDiv,assetInfo.icon);
	            		}
            		}
	            }
            } 
        }); 
		
		

		sectionDiv.className = "assistListSection";
		if (dojo.isIE < 8) {
			if (includeHeadings) {
				var titleSpan = "<span class='titleNameIE'>" +
				"<span style='float:left'>" + assetInfo.key + "</span>" +
				this.getCounterSpan(assetsCount) +
				"</span>";
				
				sectionDiv.title = titleSpan;

			}
			else {
				sectionDiv.title = "<span class='titleNameIE'>" + assetInfo.key + "</span>";
			}
		}
		else {
			// Kind of a weird way of doing this. Create spans to respresent the title. The title is a title on a button
			if (includeHeadings) {
				
				var titleSpan = "<span class='titleName'>" +
				"<span style='float:left'>" + assetInfo.key + "</span>" +
				this.getCounterSpan(assetsCount) +
				"</span>";
				
				sectionDiv.title = titleSpan;
			}
			else {
				sectionDiv.title = "<span class='titleName'>" + assetInfo.key + "</span>";
			}
		}
		
		if (defaultSection)
			sectionDiv.selected = true;

		parentDiv.addChild(sectionDiv);
		
		return sectionDiv.domNode;

	},
	
	_onTitleClick: function() {
		var assetListId;
		if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId){
			assetListId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
		}
		else{
			assetListId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
		}

		var params = {documentId:"assetListModel", branchOrSnapshotId: assetListId};
		(new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent(params)).dispatch();
	},
	
	/**
	 * Populate the widget's contents
	 */
	populateContent: function() {	
		var accordionWidget;

		accordionWidget = this.assetListAttachPoint;
		this.usePrimaryAccoridion = false;
		
		//accordionWidget.style.overflow = 'scroll';
		
		
		// Default the first one
		var defaultSection = true;
		for (var asset in this.orderedSections) {
			var assetName = asset;

			// Determine is it's a composite section
			if (assetName == "Performance tracking") {
				this.insertAssetSectionForComposite(accordionWidget,assetName,this.orderedSections[assetName]);
				continue;
			}

			var assetTrackValue = this.appModel._assets[assetName];
			
			// Doesn't exist
			if (!assetTrackValue)
				continue;
			
			var assetValue = this.mergeData(assetTrackValue);
			
			var assetLength = 0;
			for(var prop in assetValue) {
				assetLength++;
			}
			
			// Create the section
			var accordianSection = this.insertAssetSection(accordionWidget, assetName, assetValue, this.orderedSections[assetName], assetLength, true, defaultSection);
			if (defaultSection) {
				var newDiv = document.createElement("div");
				accordianSection.appendChild(newDiv);
        		for (var asset in assetValue) {
     				this.insertAsset(assetValue[asset],newDiv,this.orderedSections[assetName].icon);
        		}
			}
			
			defaultSection = false;
		}
		return accordionWidget;
	},
	
	insertAssetSectionForComposite: function(parentDiv, sectionName, assetInfo) {
		// this one is a little unique as we have to first see anything exists in the children
		var assetLength = 0;
		for (var asset in assetInfo.compound) {
			var t = this.appModel._assets[asset];
			if (t) {
				for (var side in t) {
					var sideData = t[side];
					for (var innerAsset in sideData) {
						var innerAssetData = sideData[innerAsset];
						//assetLength = assetLength + innerAssetData.changes.length;
						assetLength = assetLength + 1;
					}
				}
			}
		}
		
		if (assetLength > 0)
			this.insertAssetSection(parentDiv, sectionName, null,assetInfo, assetLength, true, false);
		
	},
	
	mergeData: function(data) {
		
		var tempLS = data[this.track1Id];
		
		var tempRS = null;
		if(this.track2Id && data[this.track2Id])
			tempRS = data[this.track2Id];
		
		var formatedData = [];
		var count = 0;
		
		// First add the left side
		for (var asset in tempLS) {
			var formattedLineItem = {};
			var subItem = {};
			subItem[asset] = tempLS[asset];
			formattedLineItem.left = subItem;			
			formatedData[count] = formattedLineItem;
			count++;
		}
		
		if (!tempRS)
			return formatedData;
		// Now if there any right side data that doesn't exist on the left
		var sortedFormatedData = [];
		count = 0;

		for (var asset in tempRS) {

			var formattedLineItem = {};
			var subItem = {};
			subItem[asset] = tempRS[asset];
			formattedLineItem.right = subItem;
			
			var rightSideDate = this.getLastModifiedDate(formattedLineItem.right);
					
			// Now we need to merge into 1 list
			for (var i =0;i<formatedData.length;i++) {
				
				if (!formatedData[i])
					continue;
				
				var leftSideDate = this.getLastModifiedDate(formatedData[i].left);
				if (leftSideDate<rightSideDate) {
					sortedFormatedData[count] = formatedData[i];
					formatedData[i] = null;
				}
				else {
					break;
				}
				count++;
			}
			
			sortedFormatedData[count] = formattedLineItem;
			count++;
		}
		
		// Add any remaining items
		for (var i =0;i<formatedData.length;i++) {
			if (!formatedData[i])
				continue;
			
			sortedFormatedData[sortedFormatedData.length] = formatedData[i];
		}
		
		return sortedFormatedData;
	},
	
	getLastModifiedDate: function(item) {
		for (var asset in item) {
			var changes = item[asset].changes;
			return changes[changes.length - 1].modified_on;
		}
		return 0;
	},
	
	insertAsset: function(asset, parentDiv, imageName) {
		
		//if (dojo.isIE > 6) {
//		if (dojo.isIE) {
//			// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//			// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//			// To make this slight tricky is we need to be able to grow the container
//			
//			// Due to IE being the worst browser on the market and having it that they are unable to even be consistent between versons
//			// need to set an outer div
//			var mainDivOuter = document.createElement("div");
//			parentDiv.appendChild(mainDivOuter);
//			mainDivOuter.style.width = '100%';
//			
//			
//			// First define a growable container which will set the top left icon
//			var mainDiv = document.createElement("div");
//			//parentDiv.appendChild(mainDiv);
//			mainDivOuter.appendChild(mainDiv);
//			
//			// Add the top right image
//			var topDiv = document.createElement("div");
//			topDiv.className="alstop";
//			var topSpan = document.createElement("span");
//			topDiv.appendChild(topSpan);
//			mainDiv.appendChild(topDiv);
//			
//			// Create the inner portion, we are in effect just wrapping our asset list section here
//			var innerDiv = document.createElement("div");
//			innerDiv.className = "alsright";
//			mainDiv.appendChild(innerDiv);
//
//			var assetValue;
//			if (asset.left) {
//				for (var assetId in asset.left)
//					assetValue = asset.left[assetId];
//				mainDiv.className="clsleftgrowablecontainer";
//			}
//			else {
//				for (var assetId in asset.right)
//					assetValue = asset.right[assetId];
//				mainDiv.className="clsrightgrowablecontainer";
//			}
//			
//			var additionInfo = assetValue.changes[assetValue.changes.length - 1];
//			var al = {
//					parent: this,
//					assetName:assetValue.name,
//					assetOwner:additionInfo.userName,
//					assetModifiedAt:additionInfo.modified_on,
//					changes:assetValue.changes,
//					leftSide:true,
//					assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
//					};
//			var as = new com.ibm.bpm.wpd.compare.view.CompareListAssetSection(al);
//			innerDiv.appendChild(as.domNode);
//			
//			// Finally add the bottom image, starting at the left, then continue to the right
//			var bottomDiv = document.createElement("div");
//			bottomDiv.className="alsbottom";
//			var bottomSpan = document.createElement("span");
//			bottomDiv.appendChild(bottomSpan);
//			mainDiv.appendChild(bottomDiv);
//		}
//		else {
			this.insertAssetInner(asset, parentDiv, imageName);
//		}
	},
	
	insertAssetInner: function(asset, parentDiv, imageName) {
		
		var leftSide = asset.left;
		var rightSide = asset.right;
		var lineDiv = document.createElement("div");
		
		if (leftSide) {
			
			var assetValue;
			for (var assetId in leftSide)
				assetValue = leftSide[assetId];
			
			if (assetValue) {
				var additionInfo = assetValue.changes[assetValue.changes.length - 1];
				var al = {
						parent: this,
						assetName:assetValue.name,
						assetOwner:additionInfo.userName,
						assetModifiedAt:additionInfo.modified_on,
						changes:assetValue.changes,
						leftSide:true,
						assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
						};
				var as = new com.ibm.bpm.wpd.compare.view.CompareListAssetSection(al);
				lineDiv.appendChild(as.domNode);
			}
		}
		if (rightSide) {
			var assetValue;
			
			for (var assetId in rightSide)
				assetValue = rightSide[assetId];

			if (assetValue) {
				var additionInfo = assetValue.changes[assetValue.changes.length - 1];
				var al = {
						parent: this,
						assetName:assetValue.name,
						assetOwner:additionInfo.userName,
						assetModifiedAt:additionInfo.modified_on,
						changes:assetValue.changes,
						leftSide:false,
						assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
						};
				var as = new com.ibm.bpm.wpd.compare.view.CompareListAssetSection(al);
				lineDiv.appendChild(as.domNode);
			}
		}
		
		parentDiv.appendChild(lineDiv);
		
	},
	
	queryRevisions : function(){
		//do nothing
	},
	
	queryProcessAppSettings : function(){
		//do nothing
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.compare.model.ProcessAppCompareModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.compare.model.ProcessAppCompareModel"] = true;
dojo.provide("com.ibm.bpm.wpd.compare.model.ProcessAppCompareModel");




/**
 *
 */
dojo.declare("com.ibm.bpm.wpd.compare.model.ProcessAppCompareModel", [com.ibm.bpm.wpd.core.model.MObject], {
				
	_assets : null,
 
    constructor: function() {
	},
	
	setModel : function(data){
		this._assets = data;
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.compare.model.CompareModelTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.compare.model.CompareModelTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.compare.model.CompareModelTypeProvider");


dojo.declare("com.ibm.bpm.wpd.compare.model.CompareModelTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "compareListModel";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.compare.view.CompareListView({}, parent);
	},
	
	createDataModel : function(data){
		var model = new com.ibm.bpm.wpd.compare.model.ProcessAppCompareModel();
		model.setModel(data);
		return model;
	},
	
	getPORestPath: function(docId){
	},
	
	reuseViewer : function(){
		return false;
	},
	
	getIconPath : function(size){
//		if(size == 16){
//			return "images/snapshot-16.png";
//		}
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyAssetContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyAssetContainer"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.view.CopyAssetContainer");



/**
 * Subclass of the AssetListAccordianContainer to customize it for our purpose
 */
dojo.declare("com.ibm.bpm.wpd.copy.view.CopyAssetContainer",
		[com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer],
		{
	
	// Temp variable to store the section size, this is used by IE as there seems to be a bug in dojo that it doesn't recognize when
	// the side by side has been expanded
	rsp: {},
	
	historyRevisions: function(node,level) {
		// Don't really like this, maybe see if I can set a size back on revisions at the start
		var returnValue = 0;
		
		if (level == 8) {
			
			if (node.childNodes.length > 0 && node.childNodes[0].childNodes.length > 0)
				return node.childNodes.length;
		}

		for (var i=0;i<node.childNodes.length; i++) {
			//alert(node.childNodes[0].childNodes[i].childNodes.length);
			returnValue = this.historyRevisions(node.childNodes[i], (level  +1));
			if (returnValue > 0)
				return returnValue;
		}

		return returnValue;
		
	},
	
	resizeSelectedPane: function(size) {
		// set a variable for resizing
		this.inherited(arguments);
		
		this._setRSPValue(size);
	},
	
	layout: function(){
		
		this.inherited(arguments);

		// Overwrite the initial size of the default pane to prevent cutoff
		var openPane = this.selectedChildWidget;
		if(openPane){
			
			// In this case if the side by side comparison is open and the user resizes the browser we need to take that into account of the overall height
			var mySize = this._contentBox;
			this._containerContentBox = {
					h: this._getTargetHeight(openPane.domNode) + 10 + this._getRSPValue(),
					w: mySize.w
			};
			openPane.resize(this._containerContentBox);
		}			
	},
	
	/**
	 * In IE it doesn't remember the accordionj section size between opens and closes, store it in a temp variable based on the widget id 
	 */
	_setRSPValue: function(size) {
		this.rsp[this.selectedChildWidget.id] = size;
	},
	
	_getRSPValue: function() {
		
		if (this.rsp[this.selectedChildWidget.id])
			return this.rsp[this.selectedChildWidget.id];
		return 0;
	},
	
	/**
	 * Overwrite the superclass implementation to customize for ourselves. Compute the value based on the number of assets within the section.
	 * We could potentially cap this to a max size in the future.
	 * The reason for overwritng is the susperclass behaves differently depending on the browser we are viewing from. In the case of IE
	 * it appears to always come back with a height of around 200 px. In FF it's appears to be based on the size of the smallest section
	 * in the accordion. So if we have one small section and numerous large sections it'll always allocate based ont he smallest (which is
	 * kind of useless)
	 */
	_getTargetHeight: function(/* Node */ node){
		return this.inherited(arguments);
//		// Slight difference in IE as we have to use images to create the rounded corners so the height per
//		// section is a little more
//		
//		if (dojo.isIE == 6)
//			return 300;
//		if (node.childNodes.length == 0)
//			return 300;
//		
//		if (this.expandedSections) {
//			var assetItems = 0;
//			var assetItemsRevisions = 0;
//						
//			if (node.childNodes.length == 1) {
//				if (dojo.isIE) {
//					if (dojo.isIE < 8)
//						assetItems = node.childNodes[0].childNodes.length * 73;
//					else
//						assetItems = node.childNodes[0].childNodes.length * 53;
//					for (var i=0;i<node.childNodes[0].childNodes.length; i++) {
//						var revisionCount = this.historyRevisions(node.childNodes[0].childNodes[i],1);
//						assetItemsRevisions = assetItemsRevisions + revisionCount*18;
//					}
//					return assetItems+assetItemsRevisions;
//				}
//
//				assetItems = node.childNodes[0].childNodes.length * 38;
//				for (var i=0;i<node.childNodes[0].childNodes.length; i++) {
//					assetItemsRevisions = assetItemsRevisions + (node.childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[1].childNodes.length * 17);
//				}
//				return assetItems+assetItemsRevisions;
//			}
//			
//			assetItems = node.childNodes.length * 36.5;
//			for (var i=0;i<node.childNodes.length; i++) {
//				assetItemsRevisions = assetItemsRevisions + (node.childNodes[i].childNodes.length * 30);
//			}
//			return assetItems+assetItemsRevisions;
//		}
//		else {
//			// Will do this for now, what I'd like to do is separates section to there own widget and set a size
//			if (node.childNodes.length == 1) {
//				if (dojo.isIE)
//					return node.childNodes[0].childNodes.length * 50;
//				
//				return node.childNodes[0].childNodes.length * 35;
//			}
//			
//			return node.childNodes.length * 35;
//		}
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.control.commands.BaseCommand"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.control.commands.BaseCommand"] = true;
dojo.provide("com.ibm.bpm.wpd.core.control.commands.BaseCommand");

dojo.declare("com.ibm.bpm.wpd.core.control.commands.BaseCommand", null, {
	
	event : null,
	
	constructor : function (pEvent) {
		this.event = pEvent;
	},
	
	/**
	 * Execute the command
	 */
	execute : function(){
		
	}

});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.control.commands.RestCommand"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.control.commands.RestCommand"] = true;
dojo.provide("com.ibm.bpm.wpd.core.control.commands.RestCommand");


dojo.declare("com.ibm.bpm.wpd.core.control.commands.RestCommand", [com.ibm.bpm.wpd.core.control.commands.BaseCommand], {
	
	url: null,
	constructor : function (pEvent) {		
	},
	
	sendRequest : function(){
		var params = this.getRequestParams();
		this.url = params.url;
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest(params.action, params.url, dojo.hitch(this, this.onSuccess), dojo.hitch(this, this.onError),
				null, null, null, null, null,null,this.preventCache());
	},

	onError : function (response){
		var className = this.declaredClass;
		var methodName = "onError";
		var status = response.status;
		var message = "Error on url: " + this.url +
		'\nMessage: ' + status + ": " + response.message;
		
		var loadingImg = dojo.byId("wpdLoadingImag");
		if (!!loadingImg) {
			loadingImg.style.display = "none";
		}
						
		//log into server and show a dialog if fatal
		com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError(className, methodName, message, 'severe');

	},
	
	onSuccess : function (response){
		//m.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().removeUrl(this.url);
	},
	
	/*
	 * Prevent cache on dojo rest call, overwrite.
	 */
	preventCache: function() {
		return false;
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand");

dojo.declare("com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand", [com.ibm.bpm.wpd.core.control.commands.RestCommand], {
	/**
	 * Open a document/po in the compare and copy context
	 */
	
	docTypeProvider : null, // a instance of BaseDocTypeProvider


	//Requires the following data to be passed as parameters.
	//
	//	- type                - the document type to open
	//  - branchId
	//	- snapshotId
	//  - documentName        - name of the document
	//  - documentId          - uuid of document
	//  - fromOrTo            - is this going into the from or to pane?
	constructor : function (pEvent) {
		
		this.copymessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	
	/**
	 * Request data from the server, then create a ViewStateModel using the response data
	 */
	execute : function () {
		
		// make the rest call to get the data to display
		if (dojo.global.BPM.WPD_useWLEServer){
			
			if ( (this.event.fromOrTo == "from") ||
				 ((this.event.existsInTarget)&&(this.event.fromOrTo == "to")) ) {
				
				this.sendRequest();
				/*
				 * Do some work wile waiting for respond,
				 * Check how many I have cached, if reach 20, then remove the old ones
				 * Actually, the vsm is not that heavy
				 */
			
			} else {
				
				// create the new doc
				var viewerAttachPoint = document.createElement("div");

				viewerAttachPoint.style.height = "600px";
				viewerAttachPoint.style.width = "500px";
				
				viewerAttachPoint.style.overflowX = "hidden"; 
				viewerAttachPoint.style.overflowY = "hidden"; 
			

			
				// create sub div for the document to get added to
				//    - seems that a fixed div directly in the table cell cannot be made to scroll
				var inDiv = document.createElement("div");
				viewerAttachPoint.appendChild(inDiv);
				var txt = document.createTextNode(this.copymessages.COPY_SIDE_BY_SIDE_MISSING_TARGET);
				inDiv.appendChild(txt);
				inDiv.style.margin = "25% 25%";
				
				
				// populate the right pane with message that asset doesn't exist in target
				this.event.view.copyToSectionBody.appendChild(viewerAttachPoint);
			}
		}
		else {	
			// should never get here
		}	

	},
		
	getRequestParams:function(){		
		//This assumes that the docType is always carried in the event for drill in at process instance view
		var docType = this._getDocType();
		this.docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
		
		var parms = this.docTypeProvider.getRequestParams(this.event);
		return parms;
	},
	

	
	onSuccess : function (response){
		
		//console.debug( "onSuccess open: " + new Date().getTime());
		
		var documentObj;		
		if(!!this.docTypeProvider.processResponseData){
			documentObj = this.docTypeProvider.processResponseData(response.data, this.event);		
		}
		else{
			documentObj = response.data;
		}
		
		// create the view state model
		var documentName = this._getDocumentName(documentObj);
		var documentId = this._getDocumentId();
		var documentType = this._getDocType();		
		var vsmObj = {documentName: documentName, documentType:documentType, documentId:documentId, document:documentObj};
		
		vsmObj.branchOrSnapshotId = this._getBranchOrSnapshotId();
		var vsm = this.createViewStateModel(vsmObj);
		
		// create the new doc
		var viewerAttachPoint = document.createElement("div");
		viewerAttachPoint.style.height = "600px";
		viewerAttachPoint.style.width = "500px";
		
		// check to see if this is a graphical diagram
		if ((this.docTypeProvider.getDocType() == "BPDDocType")||(this.docTypeProvider.getDocType() == "Service")) {
			viewerAttachPoint.style.overflowX = "hidden"; 
			viewerAttachPoint.style.overflowY = "hidden"; 
		} else {
			viewerAttachPoint.style.overflowX = "scroll";  
			viewerAttachPoint.style.overflowY = "scroll"; 
		}

	
		// create sub div for the document to get added to
		//    - seems that a fixed div directly in the table cell cannot be made to scroll
		var inDiv = document.createElement("div");
		viewerAttachPoint.appendChild(inDiv);
		
		
		// populate the right pane in the view depending on whether this is a from or to document.
		if (this.event.fromOrTo == "from") {
			this.event.view.copyFromSectionBody.appendChild(viewerAttachPoint);
		}else {
			this.event.view.copyToSectionBody.appendChild(viewerAttachPoint);
		}

		var viewer = this.docTypeProvider.createViewer(vsm, inDiv);	

		viewer.onShow();
		
	},
	
	/**
	 * Create and returns ViewStateModel
	 * @param data
	 * @returns a ViewStateModel for the data
	 */
	createViewStateModel : function (data){
		
		var vsm;
		
		//find docTypeProvider
		//var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(data.documentType);
		if (!!this.docTypeProvider){
			vsm = this.docTypeProvider.createViewStateModel(data);
		} else{
			vsm = new com.ibm.bcompass.core.model.viewstate.ViewStateModel();
		}
		
		//ViewStateModel has a name, type and documentId, branchOrSanpshotId and subProcParentId
		//Keep the information needed by ViewStateModel in vsm, because the json object format are controlled by each DocumentViewer
		vsm.name = data.documentName;
		vsm.documentId = data.documentId;
		vsm.type = data.documentType;
		vsm.branchOrSnapshotId = data.branchOrSnapshotId;
		vsm.openSideBySide = true;

				
		//documentModel. No need to ask the docType provider to do this for the webviewer
		var dm = data.document; //this.createDocumentModel(documentObj);
		vsm.setDocumentModel(dm);	
			
		return vsm;
	},
	
	_getDocumentId:function(){
		if(!!this.event.documentId){
			return this.event.documentId;
		}		
		var docType = this._getDocType();
		this.docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
	   
		var docId = this.docTypeProvider.getDocumentId(this.event);
		if(!docId){
			throw new Error("No Unique document Id is provided");
		}
		return docId;
	},
	
	_getDocumentName:function(documentObj){
		if(!!this.event.documentName){
			return this.event.documentName;
		}
		else if( !!documentObj && !!documentObj.name){
			return documentObj.name;
		}
		//for process instance view
		var docType = this._getDocType();
		//var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
		return this.docTypeProvider.getDisplayName(this.event);		
	},
	
	_getBranchOrSnapshotId:function(){
		var branchOrSnapshotId = this.event.branchOrSnapshotId;
		if(!branchOrSnapshotId){
			// see if this is to populate the compare/copy 'from' pane or 'to' pane
			if (this.event.fromOrTo == "from") {
				branchOrSnapshotId = !!this.event.branchId ? this.event.branchId : this.event.snapshotId;		
			} else {
				branchOrSnapshotId = this.event.branchId;
			}
		}
		return branchOrSnapshotId;
	},
	
	_getDocType: function(){
		var documentType;
		if (!!this.event.type){
			documentType = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocumentTypeByPO(this.event.documentId, this.event.type);
		}
		return documentType;
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.view.CompareSectionView"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.view.CompareSectionView"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.view.CompareSectionView");






dojo.declare("com.ibm.bpm.wpd.copy.view.CompareSectionView", [ dijit._Widget, dijit._Templated ], {
	
	templateString:"<div style='height:200px;width:98%;margin-left:10px;margin-right:10px;'>\n\t<div dojoAttachPoint='messageHeader' style='width:100%;height:20px;margin-top:20px;'>\n\t</div>\n\t<div style='height:160px;width:100%;margin-top:20px;'>\n\t\t<table dojoAttachPoint='compareViewHeader' style='table-layout:fixed' cellpadding=\"0\" cellspacing=\"0\">\n\t\t\t<thead>\n\t\t\t\t<tr>\n\t\t\t\t\t<th dojoAttachPoint='copyFromSection' width='465' style=\"background-color:white;text-align: center;\"></th>\n\t\t\t\t\t<th width='35' style=\"background-color:white;text-align: right;\"><span dojoAttachPoint='divFromDrillIn'> </span></th>\n\t\t\t\t\t<th width='21' dojoAttachPoint='spacer' style=\"background-color:white;\"></th>\n\t\t\t\t\t<th dojoAttachPoint='copyToSection' width='465' style=\"background-color:white;text-align: center;\"></th>\n\t\t\t\t\t<th width='35' style=\"background-color:white;text-align: right;\"><span dojoAttachPoint='divToDrillIn'> </span></th>\n\t\t\t\t</tr>\n\t\t\t</thead>\n\t\t\t<tbody>\n\t\t\t <tr> </tr>\n\t\t\t</tbody>\n\t\t</table>\n\t\t<table dojoAttachPoint='compareViewSection' style='width:100%;' cellpadding=\"0\" cellspacing=\"0\">\n\t\t\t<tbody dojoAttachPoint='copyTableBodySection'>\n\t\t\t\t<tr>\n\t\t\t\t\t<td dojoAttachPoint='copyFromSectionBody'></td>\n\t\t\t\t\t<td> </td>\n\t\t\t\t\t<td dojoAttachPoint='copyToSectionBody'> </td>\n\t\t\t\t</tr>\n\t\t\t</tbody>\n\t\t</table>\n\t</div>\n</div>\n",
		
	widgetsInTemplate : true,
	params: null,
	
	/**
	 * Construct something
	 */
	constructor : function(parms) {
		this.params = parms;
		this.params.view = this;
	},
	
	postMixInProperties: function()
	{
		
		this.copymessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	/**
	 * Create something
	 */
	postCreate : function() {
		var documentDisplayName = this.params.documentName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(documentDisplayName);
		if (dir=="rtl") {
			documentDisplayName = "<span dir='rtl'>" + documentDisplayName + "</span>";
		}
		if (this.assetStatus == "New") {
			this.messageHeader.style.border = "solid thin green";
			this.messageHeader.innerHTML = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_CCSECTION_NEW,documentDisplayName);
			this.displayFromAsset();
		}
		else if (this.assetStatus == "Updated"){
			this.messageHeader.style.border = "solid thin orange";
			this.messageHeader.innerHTML = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_CCSECTION_UPDATED_NEWER,documentDisplayName);
			this.displayBothAssets();
		}
		else if (this.assetStatus == "Conflict") {
			this.messageHeader.style.border = "solid thin red";
			this.messageHeader.innerHTML = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_CCSECTION_CONFLICT,documentDisplayName);
			this.displayBothAssets();
		}
		else {
			this.messageHeader.innerHTML = "This should never happen!!!!!";
		}
		
	},
	
	displayFromAsset: function()
	{
		
		//add branch to copy from
		var fromBranchDisplayName = this.fromBranchName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(fromBranchDisplayName);
		if (dir=="rtl") {
			fromBranchDisplayName = "<span dir='rtl'>" + fromBranchDisplayName + "</span>";
		}
		var fromTrackDisplayName = this.fromTrackName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(fromTrackDisplayName);
		if (dir=="rtl") {
			fromTrackDisplayName = "<span dir='rtl'>" + fromTrackDisplayName + "</span>";
		}
		this.copyFromSection.innerHTML = this.copymessages.CL_SBS_FROM + " " + fromBranchDisplayName + " " + "/" + " " + fromTrackDisplayName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.copyFromSection.innerHTML);
		if (dir=="rtl")
			this.copyFromSection.setAttribute("style","direction:rtl; text-align: center;");
		
		//add branch to copy to
		var toBranchDisplayName = this.toBranchName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(toBranchDisplayName);
		if (dir=="rtl") {
			toBranchDisplayName = "<span dir='rtl'>" + toBranchDisplayName + "</span>";
		}
		this.copyToSection.innerHTML = this.copymessages.CL_SBS_TO + " " + toBranchDisplayName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.copyToSection.innerHTML);
		if (dir=="rtl")
			this.copyToSection.setAttribute("style","direction:rtl; text-align: center;");

		
		// create the view drillin for the from asset
		//{type:this.sectionName, branchId:tbranchId, snapshotId:tsnapshotId, 
		//  toBranchId: toTrackId, documentName:this.assetName , documentId: this.assetpoId, assetStatus:this.assetStatus};

		var elem = this.divFromDrillIn;
		
		elem.innerHTML = "<u><b>"+this.copymessages.COPY_SIDE_BY_SIDE_DRILLIN+"</b></u>";  
		elem.style.cursor="pointer";
		dojo.addClass(elem, "linkFieldFontCopyDrillin");	    

		
		var parmsfrom = {type:this.params.type, snapshotId:this.params.snapshotId, documentName:this.params.documentName,  documentId:this.params.documentId, assetStatus:this.params.assetStatus,fromOrTo: "from" };
        parmsfrom.view = this;
        
		elem.parms = parmsfrom;
		this.connectForDrillIn(elem);
        
		var copyOpenCmd = new com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand(parmsfrom);
		copyOpenCmd.execute();
	},
	displayBothAssets: function()
	{
		
		//add branch to copy from
		var fromBranchDisplayName = this.fromBranchName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(fromBranchDisplayName);
		if (dir=="rtl") {
			fromBranchDisplayName = "<span dir='rtl'>" + fromBranchDisplayName + "</span>";
		}
		var fromTrackDisplayName = this.fromTrackName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(fromTrackDisplayName);
		if (dir=="rtl") {
			fromTrackDisplayName = "<span dir='rtl'>" + fromTrackDisplayName + "</span>";
		}
		this.copyFromSection.innerHTML = this.copymessages.CL_SBS_FROM + " " + fromBranchDisplayName + " " + "/" + " " + fromTrackDisplayName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.copyFromSection.innerHTML);
		if (dir=="rtl")
			this.copyFromSection.setAttribute("style","direction:rtl; text-align: center;");
		
		//add branch to copy to
		var toBranchDisplayName = this.toBranchName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(toBranchDisplayName);
		if (dir=="rtl") {
			toBranchDisplayName = "<span dir='rtl'>" + toBranchDisplayName + "</span>";
		}
		this.copyToSection.innerHTML = this.copymessages.CL_SBS_TO + " " + toBranchDisplayName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.copyToSection.innerHTML);
		if (dir=="rtl")
			this.copyToSection.setAttribute("style","direction:rtl; text-align: center;");

		
		
		// add drill down into from asset
		var elem = this.divFromDrillIn;
		
		elem.innerHTML = "<u><b>"+this.copymessages.COPY_SIDE_BY_SIDE_DRILLIN+"</b></u>";  
		elem.style.cursor="pointer";
		dojo.addClass(elem, "linkFieldFontCopyDrillin");	    


		// show the 'from' pane
		var parmsfrom = {type:this.params.type, snapshotId:this.params.snapshotId, documentName:this.params.documentName,  documentId:this.params.documentId, assetStatus:this.params.assetStatus,fromOrTo: "from" };
        parmsfrom.view = this; 
        
        elem.parms = parmsfrom;
		this.connectForDrillIn(elem);
        
        
		var copyOpenCmdFrom = new com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand(parmsfrom);
		copyOpenCmdFrom.execute();
		
		// add drill down into to asset
		var elem = this.divToDrillIn;
		
		//make sure asset exists in the target branch
		if (this.params.existsInTarget) {
			elem.innerHTML = "<u><b>"+this.copymessages.COPY_SIDE_BY_SIDE_DRILLIN+"</b></u>";  
			elem.style.cursor="pointer";
			dojo.addClass(elem, "linkFieldFontCopyDrillin");	 
		}


		// show the 'to' pane
		var parmsTo = {type:this.params.type, 
						branchId:this.params.toBranchId, 
						//snapshotId:this.params.snapshotId, 
						documentName:this.params.documentName,  
						documentId:this.params.documentId, 
						assetStatus:this.params.assetStatus,
						fromOrTo: "to", 
						existsInTarget: this.params.existsInTarget};
		parmsTo.view=this;
		
		elem.parms = parmsTo;
		//make sure asset exists in the target branch
		if (this.params.existsInTarget) {
			this.connectForDrillIn(elem);
		}
		
		
		var copyOpenCmdTo =  new com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand(parmsTo);		
		copyOpenCmdTo.execute();
	},
	
	connectForDrillIn: function(elem)
	{
		dojo.connect( elem, "onclick", function(){

			var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
			var parms = {};
		    	parms.documentId = elem.parms.documentId;
		    	parms.documentName = elem.parms.documentName;
		    	parms.assetType = elem.parms.type;
		    	
		    	if (elem.parms.snapshotId != null) {
		    		parms.snapshotId = elem.parms.snapshotId;
		    	}
		    	
		    	if (elem.parms.branchId != null ) {
		    		parms.branchId = elem.parms.branchId;
		    	}
		    		
		    	openDocEvent.params = parms;
		    	openDocEvent.dispatch();				
		});
		
	}
	
});
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyListAssetSection"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyListAssetSection"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.view.CopyListAssetSection");







dojo.declare("com.ibm.bpm.wpd.copy.view.CopyListAssetSection", [ com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection ], {
	
	templateString : "<div>" +
	  "<div class='assetListSectionItem' dojoAttachPoint='mainAssetDiv' >" +
	    "<div>" +
	        "<img style='float: left; padding: 3px;' dojoAttachPoint='assetTwistyDiv' dojoAttachEvent='onclick: assetTwistyClicked' src=" +  dojo.moduleUrl('com.ibm.bpm.wpd', 'images/assetview/als_collapsed.gif') + ">" +
	    "</div>" +
	   // "<input dojoType='dijit.form.CheckBox' style='width:16px; float:left;padding-top:4px;' dojoAttachEvent='onChange: assetChecked' dojoAttachPoint='copyAssetCheckbox'></input>" +
	    "<input dojoType='dijit.form.CheckBox' style='width:16px; margin-left:4px; float:left;margin-top:4px;' dojoAttachEvent='onClick: assetChecked' dojoAttachPoint='copyAssetCheckbox'></input>" +
	    "<div>" +
	        "<img style='float: left; padding: 4px 3px; margin-left:4px;' dojoAttachPoint='assetIconDiv' src=''>" +
	    "</div>" +
	    "<div class='copyListName' style='width:194px;' dojoAttachPoint='assetNameDiv'\>" +
	       "<div class='dojoxEllipsis' dojoAttachPoint='assetNameDivInner'></div>" +
	    "</div>" +
	    "<div class='assetListDescription' dojoAttachPoint='assetDescriptionDiv'>" +
	       "<div class='dojoxEllipsis' dojoAttachPoint='assetDescriptionDivInner'></div>" +
	    "</div>" +
	    "<div class='assetListModifiedBy' dojoAttachPoint='assetModifiedDiv'>" +
	       "<div class='dojoxEllipsis' dojoAttachPoint='assetModifiedDivInner'></div>" +
	    "</div>" +
	    "<div class='copyStatusTag' dojoAttachPoint='assetTagsDiv'>" +
	    "</div>" +
	    "<div style='clear:both;background:white;border:none;top-margin:2px;bottom-margin:5px;visibility:hidden;display:none;' dojoAttachPoint='compareSectionDiv'>" +
	    //"<div class='assetListRevisionSection' dojoAttachPoint='compareSectionDiv'>" +
	  "</div>" +
	"</div>",


	widgetsInTemplate : true,
	compSection: null,

	constructor: function() {
	},

	postMixInProperties: function()
	{
		this.inherited(arguments);
		
		this.copymessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	assetChecked: function(b) {
		var newValue = this.copyAssetCheckbox.get('checked');
		this.parent.copyItems.checkAsset(this.assetpoId,newValue,"new");
	},
	
	postCreate: function() {
		
//		if (dojo.isIE) {
//			this.mainAssetDiv.className = 'assetListSectionItemIE';
//		}
		
		var formattedName = com.ibm.bpm.wpd.util.Helper.text2htmlText(this.assetName);
		this.assetNameDivInner.innerHTML = formattedName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedName);
		if (dir=="rtl")
			this.assetNameDivInner.setAttribute("style","direction:rtl; text-align:left;");
		
		if (this.assetName.length > 30) {			
			new dijit.Tooltip ({
	      	      connectId: [this.assetNameDiv],
//	            	label:  "<span dir = '" + dir + "'>" + formattedName + "</span>", // Bidi support
	            	label:  formattedName,
		            position: ["above","below"]	
	      	  	});
		}
		
		var isChecked = this.assetStatus == "New";
		
		this.copyAssetCheckbox.setChecked(isChecked);
		
		this.parent.copyItems.registerInterestIn(this.assetpoId,this.copyAssetCheckbox);

		if (this.assetDescription) {
			var formattedDescription = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.assetDescription);
			this.assetDescriptionDivInner.innerHTML = formattedDescription;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedDescription);
			if (dir=="rtl")
				this.assetDescriptionDivInner.setAttribute("style","direction:rtl; text-align:left;");
		
			new dijit.Tooltip ({
      	      connectId: [this.assetDescriptionDiv],
//            	label:  "<span dir = '" + dir + "'>" + formattedDescription + "</span>",  // Bidi support
            	label:  formattedDescription,
	            position: ["above","below"]	
      	  	});
		}
		
		
		if (this.sectionName=="Others" || this.sectionName=="AdvancedContent")
			this.assetIconDiv.src = this.getOtherIcons();
		else
			this.assetIconDiv.src = this.assetIcon;
		
		this.assetModifiedDivInner.innerHTML = this.assetOwner + " " + this.formatDate(this.assetModifiedAt);
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.assetModifiedDivInner.innerHTML);
		if (dir=="rtl")
			this.assetModifiedDivInner.setAttribute("style","direction:rtl; text-align:left;");
		
		
		if (this.assetStatus == "New") {
			this.assetTagsDiv.innerHTML=this.copymessages.CL_NEW;
			//this.assetTagsDiv.style.backgroundColor = "green";
			this.assetTagsDiv.style.color = "green";
			this.assetTagsDiv.style.borderTop = "solid medium green";
			this.assetTagsDiv.style.fontWeight = "bold";
			this.assetTagsDiv.style.textAlign = "right";
		}
		else if (this.assetStatus == "Updated"){
			this.assetTagsDiv.innerHTML=this.copymessages.CL_UPDATED;
			//this.assetTagsDiv.style.backgroundColor = "orange";
			this.assetTagsDiv.style.color = "orange";
			this.assetTagsDiv.style.borderTop = "solid medium orange";
			this.assetTagsDiv.style.fontWeight = "bold";
			this.assetTagsDiv.style.textAlign = "right";
		}
		else if (this.assetStatus == "Conflict") {
			if (this.sameVersionId) {
				this.assetTwistyDiv.style.visibility = 'hidden';
				this.assetTagsDiv.style.visibility = "hidden";
				this.copyAssetCheckbox.domNode.style.visibility = 'hidden';
			}
			else {
				this.assetTagsDiv.innerHTML=this.copymessages.CL_CONFLICT;
				//this.assetTagsDiv.style.backgroundColor = "red";
				this.assetTagsDiv.style.color = "red";
				this.assetTagsDiv.style.borderTop = "solid medium red";
				this.assetTagsDiv.style.fontWeight = "bold";
				this.assetTagsDiv.style.textAlign = "right";
			}
		}
		else {
			this.assetTagsDiv.innerHTML=this.copymessages.CL_NO_CHANGE;
			//this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_spacer.gif");
			this.assetTwistyDiv.style.visibility = 'hidden';
			//this.assetTagsDiv.style.backgroundColor = "black";
			this.assetTagsDiv.style.visibility = "hidden";
			this.copyAssetCheckbox.domNode.style.visibility = 'hidden';
		}
		
		// Hide the compare section
		if (this.sectionName == "Others" || this.sectionName == "ProcessAppSettings" || this.sectionName=="AdvancedContent")
			this.assetTwistyDiv.style.visibility = 'hidden';
	},
	
	assetTwistyClicked: function() {
			
//		if (!this.compareInitialized) {
//			this.attachComparison();
//			//this.compareInitialized = true;
//		}

		if (this.compareSectionDiv.style.visibility == 'visible') {
			this.parent.closeSection();
			this.closeSection();
		}
		else {
			this.attachComparison();
			this.parent.expandSection(this);
			this.parent.selectedAccoridion.resizeSelectedPane(700);
			this.compareSectionDiv.style.height = '670px';
			this.compareSectionDiv.style.visibility = 'visible';
			this.compareSectionDiv.style.display = 'block';
			this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_expanded.gif");
		}
	},
	
	closeSection: function() {
		this.parent.selectedAccoridion.resizeSelectedPane(0);
		this.parent.selectedAccoridion.layout();
		this.compSection.destroy();
		this.compareSectionDiv.style.visibility = 'hidden';
		this.compareSectionDiv.style.display = 'none';
		this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_collapsed.gif");
	},
	
	attachComparison: function() {
		//var params = {assetStatus:this.assetStatus, assetName:this.assetName};
		
//		var fromId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
//		if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId)
//			fromId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
		
		var tsnapshotId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
		var tbranchId = null;
		if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId)
			tbranchId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
		
		var fromBranchName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().brachName;
		var fromTrackName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName;
		var toBranchName = this.parent.appModel.copyToTrack;

		var toTrackId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel.copyToTrackId;
		var params = {
				type:this.sectionName, 
				branchId:tbranchId, 
				snapshotId:tsnapshotId, 
				toBranchId: toTrackId, 
				documentName:this.assetName , 
				documentId: this.assetpoId, 
				assetStatus:this.assetStatus, 
				fromBranchName: fromBranchName,
				fromTrackName: fromTrackName,
				existsInTarget: this.existsInTarget,
				toBranchName: toBranchName};
		this.compSection = com.ibm.bpm.wpd.copy.view.CompareSectionView(params);
		this.compareSectionDiv.appendChild(this.compSection.domNode);
	},
	
	getOtherIcons: function() {
		// We need to base this section on the poid or maybe a new field in the json
//		var type = this.assetpoId.substring(0,this.assetpoId.indexOf("."));
//		
//		if (type == "64")
//			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Coach_16x16.gif");
//		
//		if (type == "1")
//			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/ais16_wle.png");
//		
//		if (type == "53")
//			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/historical-analysis-scenario-16.png");
//		
//		if (type == "52")
//			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/simulation-analysis-scenario-16.png");
		
		return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Other.png");
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.model.CopyModelCoordinator"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.model.CopyModelCoordinator"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.model.CopyModelCoordinator");





/**
 * Will use this to sync up the assets and their states (checked or unchecked). As well coordinate a check in
 * one accordion with another.
 * Note: this is a first crack. I'm leary about using events do to the amount of events and listeners I'd have to
 * create. As well the framework does not destroy the widget when it closes it (tries to cache it for speed).
 */
dojo.declare("com.ibm.bpm.wpd.copy.model.CopyModelCoordinator", [ com.ibm.bpm.wpd.core.model.MObject ], {
	
	assets: [],
	registeredInterests: {},

	/**
	 * Insert asset into the coordinator. Ignore if the asset has already been added
	 */
	insertAsset: function(assetValue) {
		if (!this._exists(assetValue))
			this.assets[this.assets.length] = assetValue;
	},
	
	/**
	 * The asset has been either checked or unchecked for copy. Update the asset as to it new state. As well update any checkboxes that
	 * have associated themselves to the asset
	 * @param id
	 * @param newValue
	 * @param fromWidget
	 */
	checkAsset: function(id, newValue, fromWidget) {
		for (var i=0; i<this.assets.length;i++) {
			if (this.assets[i].assetId == id)
				this.assets[i].assetChecked = newValue;
		}
		
		// Now check all of them that are registered
		var registeredCheckboxes = this.registeredInterests[id];
		for (var i=0;i<registeredCheckboxes.length;i++) {
			registeredCheckboxes[i].setChecked(newValue);
		}
	},
	
	/**
	 * Return an array of the uids of the checked assets
	 * @returns {String}
	 */
	getCheckedAssets: function() {
		var assetids = "";
		for (var i=0; i<this.assets.length;i++) {
			if (this.assets[i].assetChecked == true)
				assetids = assetids + this.assets[i].assetId + " ";
		}
		
		return assetids;
	},
	
	/**
	 * Return an array of the uids of the checked assets
	 * @returns {String}
	 */
	getCheckedAssetsAsArray: function() {
		var assetids = [];
		for (var i=0; i<this.assets.length;i++) {
			if (this.assets[i].assetChecked == true) {
				var tempAsset = {};
				tempAsset.id = this.assets[i].assetId;
				tempAsset.name = this.assets[i].assetName;
				tempAsset.imageLocation = this.assets[i].imageLocation;
				assetids[assetids.length] = tempAsset;
			}
		}
		
		return assetids;
	},
	
	_getAssetValue: function(id) {
		for (var i=0; i<this.assets.length;i++) {
			if (this.assets[i].assetId == id)
				return this.assets[i].assetChecked;
		}
		
		return false;
	},
	
	_exists: function(newValue) {
		for (var i=0; i<this.assets.length;i++) {
			if (this.assets[i].assetId == newValue.assetId)
				return true;
		}
		
		return false;
	},
	
	/**
	 * Register interest in an asset. When that asset is updated I will as well be updated
	 * @param id
	 * @param button
	 */
	registerInterestIn: function(id, button) {
		if (!this.registeredInterests[id])
			this.registeredInterests[id] = [];
		else {
			button.setChecked(this._getAssetValue(id));
		}
		
		this.registeredInterests[id][this.registeredInterests[id].length] = button;
	},
	
	reset: function() {
		this.assets=[];
		this.registeredInterests={};
	}

});


dojo.declare("com.ibm.bpm.wpd.copy.model.AssetValue", [ com.ibm.bpm.wpd.core.model.MObject ], {
	
	assetId:'',
	assetName:'',
	assetChecked:false,
	newAsset:false,
	changedAsset:false,
	conflictAsset:false,
	imageLocation:'',
	
	constructor : function(id, checked, na, ca, cona,name, imageLocation) {
		this.assetId = id;
		this.assetChecked = checked;
		this.newAsset = na;
		this.changedAsset = ca;
		this.conflictAsset = cona;
		this.assetName = name;
		this.imageLocation = imageLocation;
	}

});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.base.dialog.Dialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.base.dialog.Dialog"] = true;
dojo.provide("com.ibm.bpm.wpd.base.dialog.Dialog");



dojo.declare("com.ibm.bpm.wpd.base.dialog.Dialog",[ dijit.Dialog ], {
	
	//templatePath : dojo.cache("com.ibm.bpm.wpd.base.dialog", "templates/Dialog.html", "<div class=\"pdDialog\" role=\"dialog\" aria-labelledby=\"${id}_title\">\n\t<div dojoAttachPoint=\"titleBar\" class=\"pdDialogTitleBar\">\n\t<span dojoAttachPoint=\"titleNode\" class=\"pdDialogTitle\" id=\"${id}_title\"></span>\n\t<span dojoAttachPoint=\"closeButtonNode\" class=\"pdDialogCloseIcon\" dojoAttachEvent=\"ondijitclick: onCancel\" title=\"${buttonCancel}\" role=\"button\" tabIndex=\"-1\">\n\t\t<span dojoAttachPoint=\"closeText\" class=\"closeText\" title=\"${buttonCancel}\">x</span>\n\t</span>\n\t</div>\n\t<div dojoAttachPoint=\"containerNode\" class=\"pdDialogPaneContent\"></div>\n</div>\n"),
	//templatePath : null,
	
	baseClass: "pdDialog",

	postCreate: function(){
		this.inherited(arguments);
		this.titleBar.className = "pdDialogTitleBar";
		this.titleNode.className =  "pdDialogTitle";
	},
	
	show: function() {
		this.inherited(arguments);
		
		// Prevent dialog titles that are too long. shorten them and add a ...
		// hover help will display the whole title
		var temp = this.titleNode.innerHTML;

		while (this.titleNode.offsetWidth > 480) {
			temp = temp.substring(0,temp.length - 5);
			this.titleNode.innerHTML = temp + "...";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.control.events.QueryCopyEvent"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.control.events.QueryCopyEvent"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.control.events.QueryCopyEvent");



/**
 * Fire the event to kick of the copy process. To be called by the copy dialog
 */
dojo.declare("com.ibm.bpm.wpd.copy.control.events.QueryCopyEvent", [com.ibm.bpm.wpd.core.control.events.BaseEvent], {
	//public variable
	params : null,	
	constructor : function (parameters) {
		this.params = parameters;
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyToRow"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyToRow"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.view.CopyToRow");







dojo.declare("com.ibm.bpm.wpd.copy.view.CopyToRow",[ dijit._Widget, dijit._Templated ], {
	
	templateString:"<div>\n   <div dojoAttachPoint='copyRowDiv' style='clear:both;'>\n\t\t<div style='height:22px;padding-top:3px;'>\n\t      <img style='float:left;margin-left:10px;width:16px;height:16px;width:16px;' dojoAttachPoint='assetImageDiv'></img>\n\t      <div style='float:left;width:370px;height:16px;padding-left:10px;vertical-align:bottom;font-weight:bold;' dojoAttachPoint='assetNameDiv'></div>\n\t      <img style='float:right;width:16px;height:16px;padding-right:10px;' dojoAttachPoint='removeImageDiv' dojoAttachEvent='onclick: removemyself'></img>\n\t\t</div>\n\t  <div style='clear:both;width:100%' dojoAttachPoint='dependenciesDiv'></div>\n         <table dojoAttachPoint='copyTableSection' style='width:95%;margin-left:20px;' cellpadding=\"0\" cellspacing=\"0\">\n            <tbody dojoAttachPoint='copyTableBodySection' style='overflow:auto'>\n            </tbody>\n         </table>\n   </div>\n</div>\n",

	widgetsInTemplate : true,
      checkboxes:{},
	
	constructor : function() {
		this.checkboxes = {};
	},
	
	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	postCreate : function() {
		this.assetImageDiv.src = this.assetImage.path;
		this.assetNameDiv.innerHTML=this.assetName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.assetName);
		if (dir=="rtl") {
			this.assetNameDiv.innerHTML="<span dir='rtl'>" + this.assetName + "</span>";
		}
		this.removeImageDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/delete.png");
		this.insertDependencies(this.assetId);
	},
	
	removemyself: function() {
		// first clean up my dependencies
		for (cb in this.checkboxes) {
			this.parent.removeCheckbox(this.checkboxes[cb], cb);
		}
		this.parent.removeRow(this.assetId);
	},
	
	insertDependencies: function(assetId) {
		
		//var dependencies = this.dependencyCalculator.findStructureFor(assetId);
		var dependencies = this.flattenedStructure[assetId].dependencies;
		var addedDep = {};
		
		
		// First look for my direct dependencies.
		for (var i=0; i<dependencies.length;i++) {
			var aDependency = dependencies[i];
			// Don't add those with no changes
			this.insertDependency(aDependency, addedDep);
		}
		
		// Now loop through the all dep list. In theory even though I'm not checking myself (allDeps[j]) somebody will have it
		// as a dependency. As usually when we come to a dup we kick out.
		var allDeps = this.flattenedStructure[assetId].fullDepIds;
		
		if (allDeps) {
			for (var j=0;j<allDeps.length;j++) {
				// might be in a situation where the dependency doesn't exist
				if (!this.flattenedStructure[allDeps[j]])
					continue;
				
				dependencies = this.flattenedStructure[allDeps[j]].dependencies;
				for (var i=0; i<dependencies.length;i++) {
					var aDependency = dependencies[i];
					// Don't add those with no changes
					this.insertDependency(aDependency, addedDep);
				}
			}
		}
	},
	
	insertDependency: function(aDependency, addedDep) {

		// Don't add those with no changes
		if (aDependency.status == "NoChange")
			return;
		
		if(aDependency.status == "Updated" && this.isDependencyUpdated(aDependency.poId))
			return;
		
		// Already added
		if (addedDep[aDependency.poId])
			return;
		
		addedDep[aDependency.poId] = "placeholder";
		
		var toolkitDep = aDependency.isExternal;
		
		var isContributor = (aDependency.poType == "Contribution");
		
		if (toolkitDep && aDependency.status != "Conflict")
			return;
		
		if (aDependency.isBrokenDep)
			return;
		
		var tbodyElem = this.copyTableBodySection;
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		trElem.style.height="20px";
		
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.width="14px";
		var checkbox = new dijit.form.CheckBox({
            name: "selectDependency",
            checked: true
		});
		
		var dependencyId = aDependency.poId;
		
		
		if (!toolkitDep) {
			this.parent.registerCheckbox(checkbox,dependencyId);
			
			//local copy
			this.checkboxes[dependencyId] = checkbox;
			
			if (isContributor) {
				//checkbox.set("checked",false);
				checkbox.set("disabled",true);
			}
			else {
				this.connect(checkbox, "onChange", dojo.hitch(this, function(){
					this.parent.updateCheckboxes(checkbox,dependencyId,checkbox.get("checked"));
				}));
			}
		}
		else {
			checkbox.set("checked",false);
			checkbox.set("disabled",true);
			checkbox.domNode.style.visibility='hidden';
		}
		
		
		tdElem.appendChild(checkbox.domNode);
		
		
		tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.width="16px";
		var imageCell=document.createElement("img");
		imageCell.src = this.determineIcon(dependencyId,aDependency.poId);
		tdElem.appendChild(imageCell);
		
		
		tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.width="200px";
		var innerName = "";
		var dependencyDisplayName = aDependency.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(aDependency.name);
		if (dir=="rtl") {
			dependencyDisplayName = "<span dir='rtl'>" + dependencyDisplayName + "</span>";
		}
		if (isContributor)
			innerName = dependencyDisplayName + " (" + this.messages.CL_ADVANCED_CONTENT_SECTION + ")";
		else
			innerName = dependencyDisplayName + " (" + this.determineType(dependencyId, toolkitDep) + ")";

		if (toolkitDep) {
			if (aDependency.status == "Conflict")
				tdElem.innerHTML=innerName + "<b style='color:red'> " + this.messages.CL_CONFLICT + "</b>";
		}
		else
			tdElem.innerHTML=innerName;
		
	
		
	},
	
	determineIcon: function(type,poId) {
		
		var index = type.indexOf(".");
		var type = type.substring(0,index);

		if (type == "25") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/processes-16.png").path;
		if (type == "2") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/integration-service-16.png").path;
		if (type == "12") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/variable-type-16.png").path;
		if (type == "24") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/user-group-16.png").path;
		if (type == "21") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/epv-16.png").path;
		if (type == "15") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/timing-interval-16.png").path;
		if (type == "14") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/tracking-group-16.png").path;
		if (type == "47") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/service-level-agreement-16.png").path;
		if (type == "4") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/undercover-agent-16.png").path;
		if (type == "7") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/web-service-16.png").path;
		if (type == "64") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Coach_16x16.gif").path;
		if (type == "53") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/historical-analysis-scenario-16.png").path;
		if (type == "52") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/simulation-analysis-scenario-16.png").path;
		if (type == "1") return this.getServiceIcon(poId);
		
		return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Other.png").path;
	},
	
	getServiceIcon: function(poId) {
		var tempAssets = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
		
		for(assetSection in tempAssets) {
			var assetArray = tempAssets[assetSection];
			for (var i=0;i<assetArray.length;i++) {
				if (assetArray[i].poId == poId)
					return this.getServiceIconByName(assetSection);
			}
		}
		
		return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Other.png").path;
	},
	
	getServiceIconByName: function(name) {
		if (name == "Human Service") 
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/human-service-16.png").path;
		if (name == "SCA Service")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/ais16_wle.png").path;
		if (name == "Integration Service")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/integration-service-16.png").path;
		if (name == "Rule Service")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/rule-service-16.png").path;
		if (name == "General System Service")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/general_service_16x16.png").path;
		if (name == "SLA")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/service-level-agreement-16.png").path;
		if (name == "WebService")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/web-service-16.png").path;
		
		return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Other.png").path;
	},
	
	getServiceNameBySection: function(sectionName) {
		if (sectionName == "Human Service") return this.messages.CL_HUMAN_SERVICES;
		if (sectionName == "SCA Service")return this.messages.CL_ADVANCED_INTEGERATION_SERVICE;
		if (sectionName == "Integration Service") return this.messages.CL_INTEGRATION_SERVICES;
		if (sectionName == "Rule Service") return this.messages.CL_SERVICES;
		if (sectionName == "General System Service") return this.messages.CL_GENERAL_SYSTEM_SERVICES;
		if (sectionName == "SLA") return this.messages.CL_SERVICE_LEVEL_AGREEMENT;
		if (sectionName == "WebService") return this.messages.CL_WEB_SERVICES;
		
		return this.messages.CL_SERVICES;
	},
	
	isDependencyUpdated: function(poid) {
		
		var tempAssets = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
		
		for(assetSection in tempAssets) {
			var assetArray = tempAssets[assetSection];
			for (var i=0;i<assetArray.length;i++) {
				if (assetArray[i].poId == poid)
					return assetArray[i].sameVersionId;
			}
		}
	},
	
	determineType: function(type,external) {
		
		var poid = type;
		
		if (external)
			return this.messages.CL_TOOLKIT;
		
		var index = type.indexOf(".");
		var type = type.substring(0,index);
		
		if (type == "25") return this.messages.CL_BPD;
		if (type == "2") return this.messages.CL_ADVANCED_INTEGERATION_SERVICE;
		if (type == "12") return this.messages.CL_BUSINESS_OBJECTS;
		if (type == "24") return this.messages.CL_PARTICIPANT_GROUP;
		if (type == "21") return this.messages.CL_EPV;
		if (type == "15") return this.messages.CL_TIMING_INTERVALS;
		if (type == "14") return this.messages.CL_TRACKING_GROUPS;
		if (type == "47") return this.messages.CL_SERVICE_LEVEL_AGREEMENT;
		if (type == "4") return this.messages.CL_UNDERCOVER_AGENTS;
		if (type == "7") return this.messages.CL_WEB_SERVICES;
		if (type == "64") return this.messages.CL_COACH_VIEW;
		if (type == "1") {
			var tempAssets = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
			
			for(assetSection in tempAssets) {
				var assetArray = tempAssets[assetSection];
				for (var i=0;i<assetArray.length;i++) {
					if (assetArray[i].poId == poid)
						return this.getServiceNameBySection(assetSection);
				}
			}
			
			return this.messages.CL_SERVICES;
		}
		
		return this.messages.CL_OTHER;
	}
			
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.model.RecursiveDependency"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.model.RecursiveDependency"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.model.RecursiveDependency");




/**
 * Collect all the direct and indirect dependencies for a given poId. Cached currently searched paths for improved performance.
 * NOTE: This is not the way to do this. There are implications when trying to resolve these on the client. The browser
 * will detect that a recursion is going on and will trigger an exception along the lines on an unresponsive script. The number
 * of recursions allows is dependant on the browser and what is currently loaded into the browser. As large project with a semi-deep
 * tree will trigger the error.
 * For now a try..catch will be placed around the code to prevent deep dependencies from crashing.
 * This needs to be reinvestigated bewfore the release
 * @deprecaited No longer in use
 */
dojo.declare("com.ibm.bpm.wpd.copy.model.RecursiveDependency", [com.ibm.bpm.wpd.core.model.MObject], {
	
	flattenedStructure: {},
	alreadyVisited: {},
	
	constructor: function(listToParse) {
		for (asset in listToParse) {
			var assets = listToParse[asset];
			for (var i=0;i<assets.length;i++) {
				this.flattenedStructure[assets[i].poId] = assets[i].dependencies;
			}
		}
	},
	
	findStructureFor: function(poId) {
		// First off check if we already visited it. Might already have it calculated.
		if (this.alreadyVisited[poId])
			return this.alreadyVisited[poId];
		
		// Get the dependencies from the flattened file
		var dep = this.flattenedStructure[poId];
		if (dep.length == 0) {
			var emp = [];
			this.alreadyVisited[poId] = emp;
			return emp;
		}
		
		var internalVisisted = {};
		internalVisisted[poId] = "placeholder";
		
		var allDeps = this.findDependenciesFor(poId,internalVisisted);
		this.alreadyVisited[poId] = allDeps;
		return allDeps;
	},
	
	findDependenciesFor: function(poId, internalVisited) {
		var depsForLevel = [];
		try {
			var dep = this.flattenedStructure[poId];
			
			if (!dep)
				return depsForLevel;
			
			for (var i=0; i<dep.length;i++) {
				var depPoId = dep[i].poId;
				if (internalVisited[depPoId])
					continue;
				
				
				depsForLevel[depsForLevel.length] = dep[i];
				
				internalVisited[depPoId] = "placeholder";
				
				var subDeps = this.findDependenciesFor(depPoId, internalVisited);
				depsForLevel = depsForLevel.concat(subDeps);
			}
		}
		catch(ex) {
			console.debug("Hit a recursion limit error. JSON design issue");
		}
		
		return depsForLevel;
	},
	
	destroy: function() {
		flattenedStructure = null;
		alreadyVisited = null;
	}
	
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyToDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyToDialog"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.view.CopyToDialog");

//












dojo.declare("com.ibm.bpm.wpd.copy.view.CopyToDialog",[ dijit._Widget, dijit._Templated ], {
//dojo.declare("com.ibm.bpm.wpd.compare.view.CompareDialog",[ dijit.Dialog ], {
	
	templateString:"<div>\n   <div dojoAttachPoint='copySectionDiv'>\n      <div style='width:490px;margin-top:2px;margin-bottom:5px;height:15px;vertical-align: middle;padding-top:4px;padding-left:10px' dojoAttachPoint='copyHeaderDiv'>\n      </div>\n      <div style='width:490px;margin-top:2px;margin-bottom:5px;height:20px;vertical-align: middle;vertical-align:top;padding-top:4px;padding-left:10px' dojoAttachPoint='copyHeaderDescriptionDiv'>\n      </div>\n      <br/>\n      <br/>\n      <div style='margin-left:10px;margin-right:10px;border:thin solid black;height:230px;overflow:auto'>\n      \t<div dojoAttachPoint='copyTableBodySection' style='overflow:auto'>\n      \t</div>\n      </div>\n      <div style='width:100%; height:40px;vertical-align: bottom;'> \n      \t<button style='float:right;margin-right:10px;vertical-align: bottom;margin-top:20px' dojoAttachPoint='copyButton' dojoAttachEvent='onclick: invokecopy' type='button'>\n\t\t\t${copymessages.CL_COPY_DIALOG_BUTTON}\n\t\t</button>\n      </div>\n   </div>\n</div>\n",

	widgetsInTemplate : true,
	dependenciesCheckboxes:{},
	updateCopyList: "com.ibm.bpm.wpd.copy.view.updateList",
	dependencyCalculator:null,
	flattenedStructure: [],

	
	constructor : function() {
		//this.dependencyCalculator = new com.ibm.bpm.wpd.copy.model.RecursiveDependency(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets);
		this.flattenStructure();
		this.dependenciesCheckboxes = {};
	},
	
	flattenStructure: function() {
		var listToParse = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets
		for (asset in listToParse) {
			var assets = listToParse[asset];
			for (var i=0;i<assets.length;i++) {
				this.flattenedStructure[assets[i].poId] = assets[i];
			}
		}
	},
	
	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
		
		this.copymessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	_show: function() {
		//var dialogTitle = "Copy Items from track1/sn1 to main";
		
		var branchFromDisplayName = this.brachFromName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(branchFromDisplayName);
		if (dir=="rtl") {
			branchFromDisplayName = "<span dir='rtl'>" + branchFromDisplayName + "</span>";
		}
		var snapshotDisplayName = this.snapshotName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshotDisplayName);
		if (dir=="rtl") {
			snapshotDisplayName = "<span dir='rtl'>" + snapshotDisplayName + "</span>";
		}
		var branchToDisplayName = this.branchToName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(branchToDisplayName);
		if (dir=="rtl") {
			branchToDisplayName = "<span dir='rtl'>" + branchToDisplayName + "</span>";
		}
		var dialogTitle = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_COPY_TITLE,
				branchFromDisplayName,
				snapshotDisplayName,
				branchToDisplayName);

		var dialogStyle = "width:500px;height:400px;";
		
		this.copyDialog = new com.ibm.bpm.wpd.base.dialog.Dialog({title:dialogTitle, truncateTitleLength:70, content:this.copySectionDiv, style:dialogStyle});
		
		this.copyDialog.containerNode.className="";

		
		this.copyHeaderDiv.innerHTML = "<b>" + this.copymessages.CL_COPY_HEADER + "</b>"; 
		this.copyHeaderDescriptionDiv.innerHTML = this.copymessages.CL_COPY_DESC; 

		for(var i=0; i<this.assetArray.length;i++) {
			var aCopyAsset = this.assetArray[i];
			this.insertRow(aCopyAsset.name, aCopyAsset.id, aCopyAsset.imageLocation);
		}
		
		var dd = this.dependenciesCheckboxes;
		this.copyDialog.show(); 
		
	},
	
	
	insertRow: function(name, id,image) {
		//var al={assetName:name,assetImage:image, assetId: id, parent:this, dependencyCalculator:this.dependencyCalculator, flattenedStructure: this.flattenedStructure};
		var al={assetName:name,assetImage:image, assetId: id, parent:this, flattenedStructure: this.flattenedStructure};
		var row = new com.ibm.bpm.wpd.copy.view.CopyToRow(al);
		row.domNode.id = id;
		this.copyTableBodySection.appendChild(row.domNode);
		


	},
	
	registerCheckbox: function(checkbox, assetId) {
		var tv = this.dependenciesCheckboxes[assetId];
		
		if (!tv)
			tv = [];
		
		tv[tv.length] = checkbox;
		
		this.dependenciesCheckboxes[assetId] = tv;
		
	},
	
	updateCheckboxes: function(checkbox, assetId, newCheckboxValue) {
		var tv = this.dependenciesCheckboxes[assetId];
		for (var i=0; i<tv.length;i++) {
			tv[i].set("checked",newCheckboxValue);
		}
	},
	
	removeCheckbox: function(checkbox, assetId) {

		var tv = this.dependenciesCheckboxes[assetId];
		var newtv = [];

		for (var i=0; i<tv.length;i++) {
			if (tv[i].id != checkbox.id)
				newtv[newtv.length] = tv[i];
		}
		
		if (newtv.length == 0)
			delete this.dependenciesCheckboxes[assetId]; 
		else
			this.dependenciesCheckboxes[assetId] = newtv;
	},
	
	removeRow: function(rowId) {
		var olddiv = document.getElementById(rowId);
		this.copyTableBodySection.removeChild(olddiv);
	},
	
	invokecopy: function() {
		var assetsToCopy = {};
		var rma = this.copyTableBodySection.childNodes;
		
		// First the nodes
		for (var i=0;i<rma.length;i++) {
			if (rma[i].id && this.hasChanged(rma[i].id))
				assetsToCopy[rma[i].id] = "place holder";
			
		}
		
		// then the dependencies
		for (dep in this.dependenciesCheckboxes) {
			var cbs = this.dependenciesCheckboxes[dep];
			if (cbs[0].get("checked"))
				assetsToCopy[dep] = "place holder";
		}

		var assetToCopyArray=[];
		for (assetId in assetsToCopy)
			assetToCopyArray[assetToCopyArray.length] = assetId;
		this.copyDialog.destroyRecursive();
		this.sendToServer(assetToCopyArray);
		
	},
	
//	pruneAssetList: function(assets) {
//		var step1 = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
//		var step2 = {};	
//		for (assetType in step1) {
//			var tempArray = step1[assetType];
//			var newtempArray = [];
//			for (var i=0;i<tempArray.length;i++) {
//				var tempAsset = tempArray[i];
//				var t = assets[tempAsset.poId];
//				if (!assets[tempAsset.poId])
//					newtempArray[newtempArray.length] = tempAsset;
//			}
//			if (newtempArray.length > 0)
//				step2[assetType] = newtempArray;
//		}
//		
//		step2.destTipSeqNum = step1.destTipSeqNum;
//		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets = step2;
//		
//		this.copyDialog.destroyRecursive();
//		
//		dojo.publish(this.updateCopyList);
//	},
	
	sendToServer: function(idArray) {
		var tsnapshotId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;

		var toBranchId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel.copyToTrackId;
		
		var restCall = "/v1/assets/copy?destBranchId=" + toBranchId + "&srcSnapshotId=" + tsnapshotId + "&destTipSeqNum=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets.destTipSeqNum;

		var headers = { "Content-Type": "application/json"};
		
		var message = {};
		message.ids = idArray;
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("post", 
				restCall, dojo.hitch(this, function(response) {
//					if (response.status == "409") {
//						// the track already exists. Pop a message to the user
//						alert(this.copymessages.CONCURRENT_COPY_ISSUE);
//					}
					this.displayError(response);
					this.triggerModelReload();
					
				}), dojo.hitch(this, function(response) {
					alert(response);
				}),headers, true, dojo.toJson(message) , null, null,null,true);
		
	},
	
	displayError: function(response) {
		if (response.status == "409") {
			// Let's determine what it is
			if (response.data.errorCode == "E01") {
				// Duplicate Name
				if (response.data.POType != "Contribution") {
					var errMess = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.DUPLICATE_NAME_ERROR,
							response.data.name);
					alert(errMess);
				}
				else if (response.data.toolkitName) {
					var errMess = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.DUPLICATE_CONTRIBUTION_TOOLKIT_NAME_ERROR,
							response.data.name,
							response.data.toolkitName);
					alert(errMess);
				}
				else {
					var errMess = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.DUPLICATE_CONTRIBUTION_NAME_ERROR,
							response.data.name);
					alert(errMess);
				}
			}
			else if (response.data.errorCode == "E02") {
				// Track already exists
				alert(this.copymessages.CONCURRENT_COPY_ISSUE);
			}
			else if (response.data.errorCode == "E03") {
				// Need to prime??? Some weird WID concept
				alert(this.copymessages.WID_PRIMED_ISSUE);
			}
		}
		if (response.status == "400") {

			var errMess = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.ADDITIONAL_MODULES_NEEDED,
					dojo.toJson(response.data.contributionNames));
			alert(errMess);
			
		}
	},
	
	hasChanged: function(poid) {
		var tempAssets = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
		
		for(assetSection in tempAssets) {
			var assetArray = tempAssets[assetSection];
			for (var i=0;i<assetArray.length;i++) {
				if (assetArray[i].poId == poid)
					return !(assetArray[i].sameVersionId);
			}
		}
	},

	triggerModelReload: function() {
		
		var restCall = "/v1/assets/compare?destBranchId=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel.copyToTrackId + "&srcSnapshotId=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
		
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", 
			restCall, dojo.hitch(this, function(response) {
				com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets = response.data;
				dojo.publish(this.updateCopyList);
			}), dojo.hitch(this, function(response) {
			}),null, null, null, null, null,null,true);
		
		
	},
	
	postCreate : function() {
		this._show();
	}	
			
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyListView"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.view.CopyListView"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.view.CopyListView");











dojo.declare("com.ibm.bpm.wpd.copy.view.CopyListView", [ com.ibm.bpm.wpd.assetlistview.view.AssetListView ], {
		
	//templateString:"<div style='height:100%;width:1100px;'>\n\t<div dojoAttachPoint='headerDiv' style='width:98%;height:20px;'>\n\t\t<div style='float:left; width:700px;'>\n\t\t\tAll | <u>New</u> | <u>Updated</u> | <u>Conflict</u>\n\t\t</div>\n\t\t<div style='float:right; width:390px;'>\n\t\t\t<button dojoType='dijit.form.Button' dojoAttachPoint='copyButton' type='button'>\n\t\t\t\tCopy from track 1/snp1 to Main\n\t\t\t</button>\n\t\t</div>\n\t</div>\n</div>\n",
	
	templateString : "<div style='height:100%;min-width:1120px;'>" +
		//"<div dojoAttachPoint='headerDiv' style='background-color:rgb(202,224,255);width:100%;height:25px;border-bottom:solid lightgray;'>" +
		//"<div dojoAttachPoint='headerDiv' style='background-color:rgb(202,224,255);width:100%;height:25px;'>" +
	"<div dojoAttachPoint='headerDiv' class='bcTag'>" +
			"<div style='padding-left:30px;padding-top:5px;float:left; width:600px;'>" +
			"<div style='float:left;font-weight:bold;' dojoAttachPoint='allFilterButton' dojoAttachEvent='onclick: filterAllClicked'>${copymessages.CL_ALL}</div>"+
			"<div style='float:left'>&nbsp;&nbsp|&nbsp;&nbsp</div>"+
			"<div style='float:left;text-decoration:underline;cursor:pointer' dojoAttachPoint='newFilterButton' dojoAttachEvent='onclick: filterNewClicked'>${copymessages.CL_NEW}</div>"+
			"<div style='float:left'>&nbsp;&nbsp|&nbsp;&nbsp</div>"+
			"<div style='float:left;text-decoration:underline;cursor:pointer' dojoAttachPoint='updateFilterButton' dojoAttachEvent='onclick: filterUpdateClicked'>${copymessages.CL_UPDATED}</div>"+
			"<div style='float:left'>&nbsp;&nbsp|&nbsp;&nbsp</div>"+
			"<div style='float:left;text-decoration:underline;cursor:pointer' dojoAttachPoint='conflictFilterButton' dojoAttachEvent='onclick: filterConflictClicked'>${copymessages.CL_CONFLICT}</div>"+
			"</div>" +
			//"<button style='float:right; padding-top:3px; padding-right:10px;background-color:red;' baseClass='' dojoAttachEvent='onClick: copyClicked' dojoType='dijit.form.Button' dojoAttachPoint='copyButton' type='button'>" +
			//"<button style='background-color:rgb(202,224,255);float:right;margin-top:2px; margin-right:10px;border:thin solid black;' dojoAttachEvent='onclick: copyClicked' dojoAttachPoint='copyButton' type='button'>" +
			"<button style='float:right;margin-top:2px; margin-right:10px;border:thin solid black;' dojoAttachEvent='onclick: copyClicked' dojoAttachPoint='copyButton' type='button'>" +
			"</button>" +
		"</div>" +
//		"<br><hr style='color:#D3D3D3;background-color:#D3D3D3;' size='3'>" +
		"<div dojoAttachPoint='allCopyElementsDiv' dojoType='com.ibm.bpm.wpd.copy.view.CopyAssetContainer' style='border:none'></div>" +
//		"<div dojoAttachPoint='newCopyElementsDiv' style='display:none' dojoType='com.ibm.bpm.wpd.copy.view.CopyAssetContainer'></div>" +
//		"<div dojoAttachPoint='conflictCopyElementsDiv' style='display:none' dojoType='com.ibm.bpm.wpd.copy.view.CopyAssetContainer'></div>" +
//		"<div dojoAttachPoint='updatedCopyElementsDiv' style='display:none' dojoType='com.ibm.bpm.wpd.copy.view.CopyAssetContainer'></div>" +
		"<div dojoAttachPoint='newCopyElementsDiv' style='display:none' dojoType='com.ibm.bpm.wpd.copy.view.CopyAssetContainer' style='border:none'><b>${copymessages.CL_NEW_NONE}</b></div>" +
		"<div dojoAttachPoint='conflictCopyElementsDiv' style='display:none' dojoType='com.ibm.bpm.wpd.copy.view.CopyAssetContainer' style='border:none'><b>${copymessages.CL_CONFLICT_NONE}</b></div>" +
		"<div dojoAttachPoint='updatedCopyElementsDiv' style='display:none' dojoType='com.ibm.bpm.wpd.copy.view.CopyAssetContainer' style='border:none'><b>${copymessages.CL_UPDATED_NONE}</b></div>" +
	"</div>",
		
	widgetsInTemplate : true,
	trackCompare: true,
	lastSelectedFilter: null,
	copyItems: null,
	selectedAccoridion: null,
	updateCopyList: "com.ibm.bpm.wpd.copy.view.updateList",
	filterCount:{},
	expandedSection: null,
	
	constructor : function() {
		
		this.reloadAppModel();
		
		this.copyItems = new com.ibm.bpm.wpd.copy.model.CopyModelCoordinator();
		this.copyItems.reset();
	},
	
	postCreate: function() {
		
		var jss = this;
		this.updateListener = dojo.subscribe(this.updateCopyList, function() {
			jss.updateList();
		});
		
		
		//this.assetListAttachPoint.expandedSections = true;
		this.lastSelectedFilter = this.allFilterButton;
		
		this.selectedAccoridion = this.allCopyElementsDiv; 

		var branchDisplayName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().brachName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(branchDisplayName);
		if (dir=="rtl") {
			branchDisplayName = "<span dir='rtl'>" + branchDisplayName + "</span>";
		}
		var snapshotDisplayName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshotDisplayName);
		if (dir=="rtl") {
			snapshotDisplayName = "<span dir='rtl'>" + snapshotDisplayName + "</span>";
		}
		var trackDisplayName = this.appModel.copyToTrack;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(trackDisplayName);
		if (dir=="rtl") {
			trackDisplayName = "<span dir='rtl'>" + trackDisplayName + "</span>";
		}
		var copyButtontitle = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_COPY_BUTTON,
				branchDisplayName,
				snapshotDisplayName,
				trackDisplayName);
		
		this.copyButton.title = copyButtontitle;
		
		var extractFirst40 = this.extractPrefix(copyButtontitle, 40);
//		if (copyButtontitle.length > 40)
//			copyButtontitle = copyButtontitle.substring(0,40) + "...";
		copyButtontitle = extractFirst40 + "...";
		
		this.copyButton.innerHTML = copyButtontitle;
		
		this.populateContent(this.allCopyElementsDiv,"A");
		this.populateContent(this.newCopyElementsDiv,"N");
		this.populateContent(this.conflictCopyElementsDiv,"C");
		this.populateContent(this.updatedCopyElementsDiv,"U");
		
		this.allCopyElementsDiv.startup();
		this.newCopyElementsDiv.startup();
		this.conflictCopyElementsDiv.startup();
		this.updatedCopyElementsDiv.startup();
		
		this.allCopyElementsDiv.defaultSectionSize = 50;
		
	},
	
	extractPrefix: function(text, limit) {
		var result = "";
		var remaining = text;
		var count=0;
		var needClosingSpan = false;
		while (count<limit && remaining.length>0) {
			if (remaining.indexOf("<span dir='rtl'>")==0) {
				if (remaining.length>16) {
					result += "<span dir='rtl'>";
					remaining = remaining.substring(16);
					needClosingSpan = true;
				}
				else {
					result += "<span dir='rtl'></span>";
					remaining = "";
				}
			}
			else
			if (remaining.indexOf("</span>")==0) {
				result += "</span>";
				if (remaining.length>7) {
					remaining = remaining.substring(7);
				}
				else {
					remaining = "";
				}
				needClosingSpan = false;
			}
				
			else {
				result += remaining[0];
				remaining = remaining.substring(1);
				count+=1;
			}			
		};
		if (needClosingSpan)
			result += "</span>";
		
		return result;
	},

	
	reloadAppModel: function() {
		// Really need a clone of the app model as we'll be modifying it
		var step1 = dojo.toJson(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel);
		var beforeCleanup = dojo.fromJson(step1);
		for (var asset in beforeCleanup._assets) {
		//for (var i=0;i<beforeCleanup._assets.length;i++) {
			var hasNew = 0;
			var hasModified = 0;
			var hasConflict = 0;
			
			var asset = beforeCleanup._assets[asset];
			for (var j=0;j<asset.length;j++) {
				if (asset[j].status == "New")
					hasNew++;
				
				if (asset[j].status == "Updated")
					hasModified++;
				
				if (asset[j].status == "Conflict" && !asset[j].sameVersionId)
					hasConflict++;
			}
			
			// Add an attribute for our filter types
			//var filterAssetCount = {};
			asset.filterTypesNew = hasNew;
			asset.filterTypesModified = hasModified;
			asset.filterTypesConflict = hasConflict;
		}
		
		this.setAssetModel(beforeCleanup);
	},
	
	filterAllClicked: function() {
		
		//this.allFilterButton.style.color = "black";
		//this.lastSelectedFilter.style.color = "blue";
		this.allFilterButton.style.fontWeight = "bold";
		this.lastSelectedFilter.style.fontWeight = "normal";
		
		this.allFilterButton.style.textDecoration = "none";
		this.newFilterButton.style.textDecoration = "underline";
		this.updateFilterButton.style.textDecoration = "underline";
		this.conflictFilterButton.style.textDecoration = "underline";
		
		this.allFilterButton.style.cursor = "default";
		this.newFilterButton.style.cursor = "pointer";
		this.updateFilterButton.style.cursor = "pointer";
		this.conflictFilterButton.style.cursor = "pointer";
		
		this.lastSelectedFilter = this.allFilterButton;
		
		this.allCopyElementsDiv.domNode.style.display="block";
		this.selectedAccoridion.domNode.style.display = "none";
		this.selectedAccoridion.domNode.style.visibility = "hidden";
		this.allCopyElementsDiv.domNode.style.visibility = "visible";
		this.selectedAccoridion = this.allCopyElementsDiv;

	},
	
	filterNewClicked: function() {
		
		//this.newFilterButton.style.color = "black";
		//this.lastSelectedFilter.style.color = "blue";
		this.newFilterButton.style.fontWeight = "bold";
		this.lastSelectedFilter.style.fontWeight = "normal";
		
		this.allFilterButton.style.textDecoration = "underline";
		this.newFilterButton.style.textDecoration = "none";
		this.updateFilterButton.style.textDecoration = "underline";
		this.conflictFilterButton.style.textDecoration = "underline";
		
		this.allFilterButton.style.cursor = "pointer";
		this.newFilterButton.style.cursor = "default";
		this.updateFilterButton.style.cursor = "pointer";
		this.conflictFilterButton.style.cursor = "pointer";
		
		this.lastSelectedFilter = this.newFilterButton;
		
		this.newCopyElementsDiv.domNode.style.display="block";
		this.selectedAccoridion.domNode.style.display = "none";
		this.selectedAccoridion.domNode.style.visibility = "hidden";
		this.newCopyElementsDiv.domNode.style.visibility = "visible";
		this.selectedAccoridion = this.newCopyElementsDiv;
	},
	
	filterUpdateClicked: function() {
		
		//this.updateFilterButton.style.color = "black";
		//this.lastSelectedFilter.style.color = "blue";
		this.updateFilterButton.style.fontWeight = "bold";
		this.lastSelectedFilter.style.fontWeight = "normal";
		
		this.allFilterButton.style.textDecoration = "underline";
		this.newFilterButton.style.textDecoration = "underline";
		this.updateFilterButton.style.textDecoration = "none";
		this.conflictFilterButton.style.textDecoration = "underline";
		
		this.allFilterButton.style.cursor = "pointer";
		this.newFilterButton.style.cursor = "pointer";
		this.updateFilterButton.style.cursor = "default";
		this.conflictFilterButton.style.cursor = "pointer";
		
		this.lastSelectedFilter = this.updateFilterButton;
		
		this.updatedCopyElementsDiv.domNode.style.display="block";
		this.selectedAccoridion.domNode.style.display="none";
		this.selectedAccoridion.domNode.style.visibility = "hidden";
		this.updatedCopyElementsDiv.domNode.style.visibility = "visible";
		this.selectedAccoridion = this.updatedCopyElementsDiv;
	},
	
	filterConflictClicked: function() {
		
		//this.conflictFilterButton.style.color = "black";
		//this.lastSelectedFilter.style.color = "blue";
		this.conflictFilterButton.style.fontWeight = "bold";
		this.lastSelectedFilter.style.fontWeight = "normal";
		
		this.allFilterButton.style.textDecoration = "underline";
		this.newFilterButton.style.textDecoration = "underline";
		this.updateFilterButton.style.textDecoration = "underline";
		this.conflictFilterButton.style.textDecoration = "none";
		
		this.allFilterButton.style.cursor = "pointer";
		this.newFilterButton.style.cursor = "pointer";
		this.updateFilterButton.style.cursor = "pointer";
		this.conflictFilterButton.style.cursor = "default";
		
		this.lastSelectedFilter = this.conflictFilterButton;
		
		this.conflictCopyElementsDiv.domNode.style.display="block";
		this.selectedAccoridion.domNode.style.display="none";
		this.selectedAccoridion.domNode.style.visibility = "hidden";
		this.conflictCopyElementsDiv.domNode.style.visibility = "visible";
		this.selectedAccoridion = this.conflictCopyElementsDiv;
	},
	
	copyClicked: function() {
		//alert(this.copyItems.getCheckedAssets());
		
		var array = this.copyItems.getCheckedAssetsAsArray();

		var params = {assetArray:array, 
			brachFromName: com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().brachName,
			snapshotName:com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName,
			branchToName:this.appModel.copyToTrack};
		
		new com.ibm.bpm.wpd.copy.view.CopyToDialog(params);
	},
	
	postMixInProperties: function()
	{
		
		this.copymessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
		
		this.inherited(arguments);
	},
	
	/**
	 * Populate the widget's contents
	 */
	populateContent: function(accordianWidgetToBuild, accordionType) {
		
		var accordionWidget = accordianWidgetToBuild;
		
		var defaultSection = true;
		
		var shouldHide = true;
		for (var asset in this.orderedSections) {
			var assetName = asset;

			// Determine is it's a composite section
			if (assetName == "Performance tracking") {
				this.insertAssetSectionForComposite(accordionWidget,assetName,this.orderedSections[assetName], accordionType);
				continue;
			}

			var assetValue = this.appModel._assets[assetName];
			
			// Doesn't exist
			if (!assetValue)
				continue;
			
			var assetCount = assetValue.length;
			
			if (accordionType == "N") {
				if (assetValue.filterTypesNew==0)
					continue;
				else
					assetCount = assetValue.filterTypesNew;
			}			
			else if (accordionType == "U") {
				if(assetValue.filterTypesModified==0)
					continue;
				else
					assetCount = assetValue.filterTypesModified;
			}
			else if (accordionType == "C") {
				if (assetValue.filterTypesConflict==0)
					continue;
				else
					assetCount = assetValue.filterTypesConflict;
			}
			
			// Set the no asset message to an empty string
			if (shouldHide) {
			accordianWidgetToBuild.domNode.innerHTML = "";
			shouldHide = false;
			}
			
			// Create the section
			var accordianSection = this.insertAssetSection(accordionWidget, assetName, this.orderedSections[assetName], assetCount, true, defaultSection, accordionType);
			defaultSection =false;
		}
		
		defaultSection =false;
		
		return accordionWidget;
	},
	
	insertAssetSection: function(parentDiv, sectionName, assetInfo, assetsCount, includeHeadings, defaultSection, status) {
		var sectionDiv = this.inherited(arguments);
		
		if (status == "N") {
			// There appears to be an issue when building the dojo accoridions. The second accordion occasionally gets the on
			// show, but sometime it never does. Check to see if it get the on show and if not populate it
			if (sectionDiv.childNodes.length == 0) {
				var newDiv = document.createElement("div");
		   		sectionDiv.appendChild(newDiv);
	
		   		if (assetInfo.compound) {
		   			for (var asset in assetInfo.compound) {
		       			var assetValue = this.appModel._assets[asset];
		       			if(assetValue) {
		            		for (var i=0;i< assetValue.length; i++) {
			     				this.insertAsset(assetValue[i],newDiv,assetInfo.compound[asset].icon,sectionName, status);
		            		}
		       			}
		   			}
		   		}
		   		else {
		       		var assetValue = this.appModel._assets[sectionName];
		       		for (var i=0;i< assetValue.length; i++) {
		    				this.insertAsset(assetValue[i],newDiv,assetInfo.icon,sectionName, status);
		       		}
		   		}
			}
		}
		
		return sectionDiv;
	},
	
	insertAsset: function(asset, parentDiv, imageName, aSectionName, accoridionType) {
				
		var nat = false;
		var cat = false;
		var conat = false;
		var assetIsChecked = false;
		if (asset.status == "New") {
			if (accoridionType == "N" || accoridionType == "A")
				nat=true;
			else
				return;
			
			assetIsChecked = true;
		}
		
		if (asset.status == "Conflict") {
			if ((accoridionType == "C" && !asset.sameVersionId) || accoridionType == "A")
				cat=true;
			else
				return;
		}
			
		if (asset.status == "NoChange" && !(accoridionType == "A")){
			return;
		}
		
		if (asset.status == "Updated"){
			if (accoridionType == "U" || accoridionType == "A")
				conat=true;
			else
				return;
		}
		
		// Special case handling for VariableType because icon changes with shared state
        var icon = imageName;
        if (aSectionName == "VariableType") {
            icon = this.getBOIcon(imageName, asset);
        }
		
		var copyAsset = new com.ibm.bpm.wpd.copy.model.AssetValue(asset.poId, assetIsChecked, nat, cat, conat, asset.name, dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + icon));

		this.copyItems.insertAsset(copyAsset);

//		if (dojo.isIE) {
//			// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//			// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//			// To make this slight tricky is we need to be able to grow the container
//			
//			// First define a growable container which will set the top left icon
//			var mainDiv = document.createElement("div");
//			mainDiv.className="alsgrowablecontainer";
//			parentDiv.appendChild(mainDiv);
//			
//			// Add the top right image
//			var topDiv = document.createElement("div");
//			topDiv.className="alstop";
//			var topSpan = document.createElement("span");
//			topDiv.appendChild(topSpan);
//			mainDiv.appendChild(topDiv);
//			// Create the inner portion, we are in effect just wrapping our asset list section here
//			var innerDiv = document.createElement("div");
//			innerDiv.className = "alsright";
//			mainDiv.appendChild(innerDiv);
//			
//			var al = {
//					parent: this,
//					assetName:asset.name,
//					assetDescription:asset.description,
//					assetOwner:asset.last_modified_by_userName,
//					assetModifiedAt:asset.last_modified, 
//					assetStatus:asset.status,
//					assetpoId:asset.poId,
//					sectionName:aSectionName,
//					copyAsset:copyAsset,
//					assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
//					};
//			var as = new com.ibm.bpm.wpd.copy.view.CopyListAssetSection(al);
//			innerDiv.appendChild(as.domNode);
//			
//			var bottomDiv = document.createElement("div");
//			bottomDiv.className="alsbottom";
//			var bottomSpan = document.createElement("span");
//			bottomDiv.appendChild(bottomSpan);
//			mainDiv.appendChild(bottomDiv);
//		}
//		else {
			var al = {
					parent: this,
					assetName:asset.name,
					assetDescription:asset.description,
					assetOwner:asset.last_modified_by_userName,
					assetModifiedAt:asset.last_modified, 
					assetStatus:asset.status,
					sameVersionId:asset.sameVersionId,
					assetpoId:asset.poId,
					existsInTarget: asset.existsInTarget,
					sectionName:aSectionName,
					copyAsset:copyAsset,
					assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + icon)
					};
			var as = new com.ibm.bpm.wpd.copy.view.CopyListAssetSection(al);
			parentDiv.appendChild(as.domNode);
//		}
	},
	
	getCompositeAssetLength: function(assetInfo, accordionType) {
		var assetLength = 0;
		
		for (var asset in assetInfo.compound) {
			var t = this.appModel._assets[asset];
			if (t)
				assetLength = assetLength + this.getAssetCountForFilter(t, accordionType);
		}
		
		return assetLength;
	},
	
	getAssetCountForFilter: function(assetValue,accordionType) {
		
		if (accordionType == "N") {
			return assetValue.filterTypesNew;
		}			
		else if (accordionType == "U") {
			return assetValue.filterTypesModified;
		}
		else if (accordionType == "C") {
			return assetValue.filterTypesConflict;
		}
		
		return assetValue.length;
		
	},
	
	destroy: function(){
		this.inherited(arguments);
		dojo.unsubscribe(this.updateListener);
	},
	
	expandSection: function(section) {
		//first close the old one
		if (this.expandedSection)
			this.expandedSection.closeSection();
		
		this.expandedSection = section;
	},
	
	closeSection: function() {
		this.expandedSection = null;
	},
	
	updateList: function() {
		// Reload the app model
		this.reloadAppModel();
		
		// Clear out the old accordions
		var children = this.allCopyElementsDiv.getChildren();
		for (var i=0;i<children.length; i++) {
			this.allCopyElementsDiv.removeChild(children[i]);
		}
		children = this.newCopyElementsDiv.getChildren();
		for (var i=0;i<children.length; i++) {
			this.newCopyElementsDiv.removeChild(children[i]);
		}
		children = this.conflictCopyElementsDiv.getChildren();
		for (var i=0;i<children.length; i++) {
			this.conflictCopyElementsDiv.removeChild(children[i]);
		}
		children = this.updatedCopyElementsDiv.getChildren();
		for (var i=0;i<children.length; i++) {
			this.updatedCopyElementsDiv.removeChild(children[i]);
		}
		
		// Reset the coordinator
		this.copyItems.reset();
		
		this.newCopyElementsDiv.domNode.innerHTML = "<b>" + this.copymessages.CL_NEW_NONE + "</b>";
		this.conflictCopyElementsDiv.domNode.innerHTML = "<b>" + this.copymessages.CL_CONFLICT_NONE + "</b>";
		this.updatedCopyElementsDiv.domNode.innerHTML = "<b>" + this.copymessages.CL_UPDATED_NONE + "</b>";

		// Repopulate the accordions
		this.populateContent(this.allCopyElementsDiv,"A");
		this.populateContent(this.newCopyElementsDiv,"N");
		this.populateContent(this.conflictCopyElementsDiv,"C");
		this.populateContent(this.updatedCopyElementsDiv,"U");

	},
	
	queryRevisions : function(){
		//do nothing
	},
	
	queryProcessAppSettings : function(){
		//do nothing
	},
	
	getBOIcon : function(imageName, asset){
	    return this.inherited(arguments);
	},
	
	setupSectionArray: function() {
		this.inherited(arguments);
		//this.orderedSections["Others"] = {key:this.copymessages.CL_OTHERS_SECTION,icon:"processes-16.png"};
		this.orderedSections["Others"] = {key:this.copymessages.CL_OTHERS_SECTION,icon:"Other.png"};
		this.orderedSections["AdvancedContent"] = {key:this.copymessages.CL_ADVANCED_CONTENT_SECTION,icon:"Other.png"};
		this.orderedSections["ProcessAppSettings"] = {key:this.messages.AL_PROCESS_APPS_SETTINGS,icon:"Other.png"};
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.model.CopyModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.model.CopyModel"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.model.CopyModel");




/**
 *
 */
dojo.declare("com.ibm.bpm.wpd.copy.model.CopyModel", [com.ibm.bpm.wpd.core.model.MObject], {
				
	_assets : null,
 
    constructor: function() {
	},
	
	setModel : function(data){
		this._assets = data;
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.copy.model.CopyModelTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.copy.model.CopyModelTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.copy.model.CopyModelTypeProvider");



/**
 * Copy provider to control the copy model, view and icon.
 */
dojo.declare("com.ibm.bpm.wpd.copy.model.CopyModelTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "copyListModel";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.copy.view.CopyListView({}, parent);
	},
	
	createDataModel : function(data){
		var model = new com.ibm.bpm.wpd.copy.model.CopyModel();
		model.setModel(data);
		return model;
	},
	
	getPORestPath: function(docId){
	},
	
	reuseViewer : function(){
		return false;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/Copy_icon_14_x_14.png";
		}
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.sla.view.slaViewer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.sla.view.slaViewer"] = true;
dojo.provide("com.ibm.bpm.wpd.document.sla.view.slaViewer");









/**
 * Participant Group viewer
 * 
 * 		Participant group has a couple of different types of data
 * 			- lists of users and groups
 *          - expression
 *      This implementation has a couple of different types of table to reflect the different types of data to show. We
 *      hide the one that is not needed and show the the one that is.
 */
dojo.declare("com.ibm.bpm.wpd.document.sla.view.slaViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templateString:"<div class=\"viewerOutline\" >\n<div class=\"viewerHeading\"  >\n<h4 class=\"viewerHeadingText\" dojoAttachPoint='slaName'></h4>\n</div>\n<div style=\"margin-left:5px;\">\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"width: 100%\">\n<tr>\n<td><div><h4>${eclMessages.SLA_DESC_HEADER}</h4><div class=\"viewerDescriptionText richTextFormat\" dojoAttachPoint='slaDescription'></div></div></td>\n<td class=\"shareLinkClass\" style=\"text-align: right\"><a dojoAttachPoint='slaCopyLinkHref' href=\"#\"> \n${eclMessages.SLA_COPY_LINK_LABEL}</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n</tr>\n</table>\n\n<!--This is the section to handle Details of sla-->\n\n<table dojoAttachPoint=slaDetailsTableHeader style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${eclMessages.SLA_DETAILS_HEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n\n<div dojoAttachPoint=\"slaDetailsDialogBody\" class='bspace-style' style='padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=Table style='width:100%' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=20% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n<th width=50% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=slaDetailsTableBody>\n</tbody>\n</table>\n</div>\n\n<br>\n\n<!--This is the section to handle Trigger of sla-->\n\n<table dojoAttachPoint=slaTriggerTableHeader style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${eclMessages.SLA_TRIGGER_HEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n\n<div dojoAttachPoint=\"slaTriggerDialogBody\" class='bspace-style' style='padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=Table style='width:100%' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=80% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=slaTriggerTableBody>\n</tbody>\n</table>\n</div>\n\n<br>\n\n<!--This is the section to handle Condition of sla-->\n\n<table dojoAttachPoint=slaConditionTableHeader style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${eclMessages.SLA_CONDITION_HEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n\n<div dojoAttachPoint=\"slaConditionDialogBody\" class='bspace-style' style='padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=Table style='width:100%' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=80% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=slaConditionTableBody>\n</tbody>\n</table>\n</div>\n<br>\n\n<!--This is the section to handle Consequence of sla-->\n\n<table dojoAttachPoint=slaConsequenceTableHeader style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${eclMessages.SLA_CONSEQUENCE_HEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n\n<div dojoAttachPoint=\"slaConsequenceDialogBody\" class='bspace-style' style='padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=Table style='width:100%' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=80% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=slaConsequenceTableBody>\n</tbody>\n</table>\n</div>\n<br>\n\n<!--This is the section to handle Exposing section of sla -->\n\n<table dojoAttachPoint=slaExposingTableHeader style='width:100%; border:1px solid black'; cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=100% style=\"background-color:#e2e2e2;  text-align: left; margin-left:3px;\">${eclMessages.SLA_EXPOSING_HEADER}</th>\n</tr>\n</thead>\n<tbody>\n</tbody>\n</table>\n\n<div dojoAttachPoint=\"slaExposingDialogBody\" class='bspace-style' style='padding-top:5px;overflow-x:hidden;overflow-y:auto;'>\n<table dojoAttachPoint=Table style='width:100%' cellpadding=\"0\" cellspacing=\"0\">\n<thead>\n<tr>\n<th width=20% style=\"background-color:#e2e2e2;  text-align: left;\"></th>\n<th width=80% style=\"background-color:#e2e2e2; text-align: left;\"></th>\n</tr>\n</thead>\n<tbody dojoAttachPoint=slaExposingTableBody>\n</tbody>\n</table>\n</div>\n\n\n<br>\n\n</div>\n</div>\n",
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	slaModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 
	
	},

	
	postCreate : function() {
		
		

		//Get the server side data
		slaModel = this.viewStateModel.getDocumentModel();

		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(slaModel.richDesc) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(slaModel.richDesc));
			this.slaDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(slaModel.desc);
			if (dir=="rtl")
				this.slaDescription.setAttribute("style","direction:rtl; text-align:left;");
		} else { 
			this.slaDescription.innerHTML = "&nbsp;";
		}

		this.slaName.innerHTML = slaModel.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(slaModel.name);
		if (dir=="rtl")
			this.slaName.setAttribute("style","direction:rtl; text-align:left;");
		
		this.fillInDetailsData();
		this.fillInExposingData();
		this.fillInTriggerData();
		this.fillInConditionData();
		this.fillInConsequenceData();

		/*
		 *  Create Copy link href Document
		 */
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.slaCopyLinkHref);
		
	},
	
	postMixInProperties: function()
	{

        
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.sla.view", "slaViewerResources");
		
		
		this.eclMessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.sla.view", "slaEclViewerResources");


	},
	
	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},

	//*****
	//Insert a new row into the table
	//   	In this case these are the sla details
	//
	//Returns: reference to the new row
	//*****
	fillInDetailsData: function()
	{
		
		var newRow = null;
		
		newRow = this.insertRow(this.slaDetailsTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_TARGET_TYPE + this.eclMessages.SLA_ACTIVITY_TYPE, this.bidiLeft, null);

	},
	
	//*****
	//Insert a new row into the table
	//   	In this case these are the sla condition details
	//
	//Returns: reference to the new row
	//*****
	fillInConditionData: function()
	{
		
		var newRow = null;
		var tmodel = slaModel;
		
		// if this is a BOOLEAN type KPI
		
		if (tmodel.conditions[0].kpiUnit == this.messages.SLA_CONDITION_KPIUNIT_KEY_BOOLEAN) {
			// few fields to display
			this.fillInConditionKPI(tmodel);
			this.fillInConditionActivities(tmodel);
			this.fillInConditionBoolean(tmodel);
			
		} else {
			// larger number of fields
			this.fillInConditionScope(tmodel);
			this.fillInConditionKPI(tmodel);
			this.fillInConditionActivities(tmodel);
			this.fillInStartTime(tmodel);
			this.fillInConditionRelation(tmodel);
			this.fillInConditionCompareWith(tmodel);
			if (tmodel.conditions[0].compareTarget.type != this.messages.SLA_CONDITION_COMPARE_WITH_KEY_VALUE) {
				this.fillInConditionKindOfThreshold(tmodel);
			}
		}
		
		

	
	},
	
	//*****
	//Insert a new row into the table
	//   	In this case these are the sla start time in the condition
	//
	//Returns: reference to the new row
	//*****
	fillInConditionBoolean: function(tmodel)
	{
		
		var newRow = null;
		var tmodel = slaModel;
		

			newRow = this.insertRow(this.slaConditionTableBody);
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_TRUE_OR_FALSE, this.bidiLeft, null);
			if (tmodel.conditions[0].trueOrfalse) {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_TRUE, this.bidiLeft, null);
			} else {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_FALSE, this.bidiLeft, null);
			}

	},
	
	
	//*****
	//Insert a new row into the table
	//   	In this case these are the sla start time in the condition
	//
	//Returns: reference to the new row
	//*****
	fillInStartTime: function(tmodel)
	{
		
		var newRow = null;
		var tmodel = slaModel;
		
		if (tmodel.conditions[0].startTime != null) {
			newRow = this.insertRow(this.slaConditionTableBody);
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_START_TIME_LABEL, this.bidiLeft, null);
			
			if (tmodel.conditions[0].startTime.rollingTime) {
				// this is N hours, days, ...
	
				var str = null;
				var parms = [];
				switch (tmodel.conditions[0].startTime.unitType) {
					case this.messages.SLA_TIME_PERIOD_HOURS:
						if (tmodel.conditions[0].startTime.timeCount == 1) {
							this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_START_TIME_LAST_HOUR, this.bidiLeft, null);
						} else {
							parms[0] = tmodel.conditions[0].startTime.timeCount;
							str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_START_TIME_LAST_HOURS, parms);
							this.addTextCellToRow( newRow, str, this.bidiLeft, null);
						}
						break;
					case this.messages.SLA_TIME_PERIOD_DAYS:
						if (tmodel.conditions[0].startTime.timeCount == 1) {
							this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_START_TIME_LAST_DAY, this.bidiLeft, null);
						} else {
							parms[0] = tmodel.conditions[0].startTime.timeCount;
							str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_START_TIME_LAST_DAYS, parms);
							this.addTextCellToRow( newRow, str, this.bidiLeft, null);
						}
						break;	
					case this.messages.SLA_TIME_PERIOD_WEEKS:
						if (tmodel.conditions[0].startTime.timeCount == 1) {
							this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_START_TIME_LAST_WEEK, this.bidiLeft, null);
						} else {
							parms[0] = tmodel.conditions[0].startTime.timeCount;
							str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_START_TIME_LAST_WEEKS, parms);
							this.addTextCellToRow( newRow, str, this.bidiLeft, null);
						}						

						break;	
					case this.messages.SLA_TIME_PERIOD_MONTHS:			
						if (tmodel.conditions[0].startTime.timeCount == 1) {
							this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_START_TIME_LAST_MONTH, this.bidiLeft, null);
						} else {
							parms[0] = tmodel.conditions[0].startTime.timeCount;
							str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_START_TIME_LAST_MONTHS, parms);
							this.addTextCellToRow( newRow, str, this.bidiLeft, null);
						}												
						break;
				}
				
			} else {
				// this is a single hour, day, ...	
							
				switch (tmodel.conditions[0].startTime.unitType) {
					case this.messages.SLA_TIME_PERIOD_HOURS:
						this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_HOUR, this.bidiLeft, null);
						break;
					case this.messages.SLA_TIME_PERIOD_DAYS:
						this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_TODAY, this.bidiLeft, null);
						break;	
					case this.messages.SLA_TIME_PERIOD_WEEKS:
						this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_WEEK, this.bidiLeft, null);
						break;	
					case this.messages.SLA_TIME_PERIOD_MONTHS:
						this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_MONTH, this.bidiLeft, null);
						break;
					}
				
			}
//		} else {
//			newRow = this.insertRow(this.slaConditionTableBody);
//			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_START_TIME_LABEL, this.bidiLeft, null);
//			this.addTextCellToRow( newRow, this.eclMessages.SLA_NONE, this.bidiLeft, null);
		}
		
	},
	
	//*****
	//Insert a new row into the table
	//   	In this case these are the sla condition compare with
	//
	//Returns: reference to the new row
	//*****
	fillInConditionCompareWith: function(tmodel)
	{
		
		var newRow = null;
		var tmodel = slaModel;
		var str = null;
		var parms = [];

		
		newRow = this.insertRow(this.slaConditionTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_COMPARE_WITH_LABEL, this.bidiLeft, null);
		
		switch (tmodel.conditions[0].compareTarget.type) {
		case this.messages.SLA_CONDITION_COMPARE_WITH_KEY_THRESH:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_COMPARE_WITH_THRESH, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_COMPARE_WITH_KEY_PERCENT_ABOVE:
			parms[0] = tmodel.conditions[0].compareTarget.percent;
			str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_WITH_PERCENT_ABOVE, parms);
			this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_COMPARE_WITH_KEY_PERCENT_BELOW:
			parms[0] = tmodel.conditions[0].compareTarget.percent;
			str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_WITH_PERCENT_BELOW, parms);
			this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_COMPARE_WITH_KEY_VALUE_ABOVE:
			if (tmodel.conditions[0].kpiUnit == this.messages.SLA_CONDITION_KPIUNIT_KEY_TIME) {
				parms[0] = this.createTimeStringFromSecs(tmodel.conditions[0].compareTarget.value);
				str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_WITH_VALUE_MORE_THAN, parms);
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			} else {
				parms[0] = tmodel.conditions[0].compareTarget.value;
				str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_WITH_VALUE_ABOVE, parms);
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			}
			break;
		case this.messages.SLA_CONDITION_COMPARE_WITH_KEY_VALUE_BELOW:
			if (tmodel.conditions[0].kpiUnit == this.messages.SLA_CONDITION_KPIUNIT_KEY_TIME) {
				parms[0] = this.createTimeStringFromSecs(tmodel.conditions[0].compareTarget.value);
				str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_WITH_VALUE_LESS_THAN, parms);
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			} else {
				parms[0] =  tmodel.conditions[0].compareTarget.value;
				str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_WITH_VALUE_BELOW, parms);
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			}
			break;
		case this.messages.SLA_CONDITION_COMPARE_WITH_KEY_VALUE:
			
			if (tmodel.conditions[0].kpiUnit == this.messages.SLA_CONDITION_KPIUNIT_KEY_TIME) {
				this.addTextCellToRow( newRow, this.createTimeStringFromSecs(tmodel.conditions[0].compareTarget.value), this.bidiLeft, null);
			} else {
				this.addTextCellToRow( newRow, tmodel.conditions[0].compareTarget.value, this.bidiLeft, null);

			}
		
			break;			
		default:
			throw new Error("Not a valid threshold");
		
		}
		
	},
	
	//*****
	// create time string for time values in time target
	//   	
	//
	//Returns: the time value string
	//*****
	createTimeStringFromSecs: function(numSecs)
	{
		
		var secsInDay = 60*60*24;
		var secsInHour = 60*60;
		var secsInMin = 60;
		var str = null;
		var parms = [];


		
		// find the number of days
		

		var numDays = Math.floor(numSecs/secsInDay);
		
		// find the number of hours
		
		var leftOverFromDays = numSecs - (numDays*secsInDay);
		var numHours = Math.floor(leftOverFromDays/secsInHour);
		
		// find the number of minutes
		var leftOverFromHours = leftOverFromDays - (numHours*secsInHour);
		var numMins = leftOverFromHours/secsInMin;
		var timeStr = "";
		
		if (numDays != 0) {
			//there are days
			if (numHours != 0) {
				if (numMins != 0) {
					// there are days, hours and minutes
					parms[0] =  numDays;
					parms[1] =  numHours;
					parms[2] =  numMins;
					if (numDays == 1) {
						str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_DAY_HOURS_MINUTES, parms);
					} else {
						str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_DAYS_HOURS_MINUTES, parms);
					}
				} else {
					//there are days and hours
					parms[0] =  numDays;
					parms[1] =  numHours;
					if (numDays == 1) {
						str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_DAY_HOURS, parms);
					} else {
						str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_DAYS_HOURS, parms);
					}		
				}	
			} else {
				if (numMins != 0) {
					// there are days, and minutes
					parms[0] =  numDays;
					parms[1] =  numMins;
					if (numDays == 1) {
						str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_DAY_MINUTES, parms);
					} else {
						str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_DAYS_MINUTES, parms);
					}
				} else {
					//there are days 
					parms[0] =  numDays;
					if (numDays == 1) {
						str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_DAY, parms);
					} else {
						str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_DAYS, parms);
					}
				}
			}
		}else {
			//there are no days
			if (numHours != 0) {
				if (numMins != 0) {
					// there are hours and minutes
					parms[0] =  numHours;
					parms[1] =  numMins;
					str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_HOURS_MINUTES, parms);
				} else {
					//there are hours
					parms[0] =  numHours;
					str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_HOURS, parms);
				}
			} else {
				parms[0] =  numMins;
				str = dojo.string.substitute(this.eclMessages.SLA_CONDITION_COMPARE_MINUTES, parms);
			}
		}
		
		return str;
	},
	
	
	
	//*****
	//Insert a new row into the table
	//   	In this case these are the sla condition threshold kind
	//
	//Returns: reference to the new row
	//*****
	fillInConditionKindOfThreshold: function(tmodel)
	{
		
		var newRow = null;
		var tmodel = slaModel;
		
		newRow = this.insertRow(this.slaConditionTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_KIND_OF_THRESHOLD_LABEL, this.bidiLeft, null);
		

		switch (tmodel.conditions[0].compareTarget.thresholdType) {
		case this.messages.SLA_CONDITION_THRESHOLD_TYPE_KEY_MIN:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_THRESHOLD_TYPE_MIN, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_THRESHOLD_TYPE_KEY_MAX:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_THRESHOLD_TYPE_MAX, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_THRESHOLD_TYPE_KEY_EXP:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_THRESHOLD_TYPE_EXP, this.bidiLeft, null);
			break;
		default:
			throw new Error("Not a valid threshold");
		
		}
		
	},
	
	//*****
	//Insert a new row into the table
	//   	In this case these are the sla condition relation type
	//
	//Returns: reference to the new row
	//*****
	fillInConditionRelation: function(tmodel)
	{
		
		var newRow = null;
		var tmodel = slaModel;
		
		newRow = this.insertRow(this.slaConditionTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_RELATION_LABEL, this.bidiLeft, null);
		
		
		switch (tmodel.conditions[0].relation) {
		case this.messages.SLA_CONDITION_RELATION_KEY_EQUALTO:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_RELATION_EQUALTO, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_RELATION_KEY_LESSTHAN:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_RELATION_LESSTHAN, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_RELATION_KEY_GREATERTHAN:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_RELATION_GREATERTHAN, this.bidiLeft, null);
			break;
		default:
			throw new Error("Not a valid condition");
		
		}
		
	},
	
	//*****
	//Insert a new row into the table
	//   	In this case these are the sla condition KPIs
	//
	//Returns: reference to the new row
	//*****
	fillInConditionActivities: function(tmodel)
	{
		
		var newRow = null;
		var tmodel = slaModel;
		
		newRow = this.insertRow(this.slaConditionTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_ACTIVITIES_LABEL, this.bidiLeft, null);
		
		// add the activities
		var numActs = tmodel.conditions[0].activities.length;
		for (var i=0; i<numActs; i++) {
			this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(tmodel.conditions[0].activities[i].activityName), this.bidiLeft, null);
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tmodel.conditions[0].activities[i].activityName);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}

			newRow = this.insertRow(this.slaConditionTableBody);
			this.addTextCellToRow( newRow, "", this.bidiLeft, null);
		}
		
		
	},
	
	//*****
	//Insert a new row into the table
	//   	In this case these are the sla condition KPIs
	//
	//Returns: reference to the new row
	//*****
	fillInConditionKPI: function(tmodel)
	{
		
		var newRow = null;
		var tmodel = slaModel;
		
		newRow = this.insertRow(this.slaConditionTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_KPI_LABEL, this.bidiLeft, null);
		this.addTextCellToRow( newRow, tmodel.conditions[0].kpi.kpiName, this.bidiLeft, null);
		var kpiName = tmodel.conditions[0].kpi.kpiName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(kpiName);
		if (dir=="rtl") {
			if (newRow.cells[newRow.cells.length-1]) {
				newRow.cells[newRow.cells.length-1].innerHTML = com.ibm.bpm.wpd.util.BidiUtils.getRTLTextWithBracket(newRow.cells[newRow.cells.length-1].innerHTML );
				newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
		}
		
	},
	
	
	//*****
	//Insert a new row into the table
	//   	In this case this is the condition scope data
	//
	//Returns: reference to the new row
	//*****
	fillInConditionScope: function(tmodel)
	{
		
		var newRow = null;

		
		newRow = this.insertRow(this.slaConditionTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_SCOPE_LABEL, this.bidiLeft, null);
		
		switch (tmodel.conditions[0].scope) {
		case this.messages.SLA_CONDITION_SCOPE_KEY_SINGLEVALUE:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_SCOPE_SINGLEVALUE, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_SCOPE_KEY_SUMOFVALUES:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_SCOPE_SUMOFVALUE, this.bidiLeft, null);
			break;
		case this.messages.SLA_CONDITION_SCOPE_KEY_AVERAGE:
			this.addTextCellToRow( newRow, this.eclMessages.SLA_CONDITION_SCOPE_AVERAGE, this.bidiLeft, null);
			break;
		default:
			throw new Error("Not a valid condition");
		
		}
	
	},
	
	
	//*****
	//Insert a new row into the table
	//   	In this case this is who the sla is exposed to
	//
	//Returns: reference to the new row
	//*****
	fillInExposingData: function()
	{
		
		var newRow = null;
		var tmodel = slaModel;
		
		newRow = this.insertRow(this.slaExposingTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_EXPOSE_TO, this.bidiLeft, null);
		if (tmodel.exposedTo != null) {
			this.addParticipantGrpCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(tmodel.exposedTo.participantGroupName), this.bidiLeft, null, tmodel.exposedTo);
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tmodel.exposedTo.participantGroupName);
			if (dir=="rtl") {
				if (newRow.cells[newRow.cells.length-1])
					newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
			}
		} else {
			this.addTextCellToRow( newRow, this.eclMessages.SLA_NONE, this.bidiLeft, null);		
		}
	
	},
	
	//*****
	//Insert a new row into the table
	//   	In this case this is the consequence of the SLA
	//
	//Returns: reference to the new row
	//*****
	fillInConsequenceData: function()
	{
		
		var newRow = null;
		var tmodel = slaModel;
		
		//fill in consequence email
		var emailStr = null;
		
		newRow = this.insertRow(this.slaConsequenceTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_SEND_TO, this.bidiLeft, null);
		if (tmodel.consequence.sendEmail) {
			emailStr = tmodel.consequence.emailAddress;
		} else {
			emailStr = this.eclMessages.SLA_NONE;
		}
		this.addTextCellToRow( newRow, emailStr, this.bidiLeft, null);
	
		// fill in consequence process fired
		var processStr = null;
		
		newRow = this.insertRow(this.slaConsequenceTableBody);
		this.addTextCellToRow( newRow, this.eclMessages.SLA_INITIATE_PROCESS, this.bidiLeft, null);
		if (tmodel.consequence.fireBPD) {
			if (tmodel.consequence.bpdRefInfo) {
			   processStr = tmodel.consequence.bpdRefInfo.bpdName;
			   this.addProcessRefCellToRow( newRow, processStr, this.bidiLeft, null, tmodel.consequence.bpdRefInfo);
			}
		} else {
			processStr = this.eclMessages.SLA_NONE;
			this.addTextCellToRow( newRow, processStr, this.bidiLeft, null);
		}
		
	},
	
	//*****
	//Insert a new row into the table
	//   	In this case this is the trigger for the sla
	//
	//Returns: reference to the new row
	//*****
	fillInTriggerData: function()
	{
		
		var newRow = null;
		var tmodel = slaModel;
		var str = null;
		var parms = [];
		
		switch(tmodel.trigger.occurrenceType){
		
			case this.messages.SLA_WHENEVER_VIOLATED:
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_LABEL, this.bidiLeft, null);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_WHENEVER_VIOLATED_MSG, this.bidiLeft, null);
				break;
			case this.messages.SLA_VIOLATED_A_OF_LAST_B_TIMES:
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_LABEL, this.bidiLeft, null);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_VIOLATED_A_OF_LAST_B_TIMES_MSG, this.bidiLeft, null);
				
				//add count A row
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_COUNTA, this.bidiLeft, null);
				
				parms[0] = tmodel.trigger.countA ;
				str = dojo.string.substitute(this.eclMessages.SLA_TIMES, parms);
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
				
				//add count B row
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_COUNTB, this.bidiLeft, null);
				parms[0] = tmodel.trigger.countB ;
				str = dojo.string.substitute(this.eclMessages.SLA_TIMES, parms);
				
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);

				break;				
			case this.messages.SLA_VIOLATED_N_TIMES_OVER_PERIOD:
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_LABEL, this.bidiLeft, null);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_VIOLATED_N_TIMES_OVER_PERIOD_MSG, this.bidiLeft, null);
				
				//add count N row
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_COUNTN, this.bidiLeft, null);
				parms[0] =  tmodel.trigger.countN ;
				str = dojo.string.substitute(this.eclMessages.SLA_TIMES, parms);
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
				
				//add over period row
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_OVER_PERIOD_LABEL, this.bidiLeft, null);
				
				this.fillInTriggerPeriod(tmodel, newRow, false);
				
				break;					
			case this.messages.SLA_VIOLATED_PERCENT_OF_TIME_OVER_PERIOD:
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_LABEL, this.bidiLeft, null);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_VIOLATED_PERCENT_OF_TIME_OVER_PERIOD_MSG, this.bidiLeft, null);
				
				//add percentage
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_PERCENTAGE_LABEL, this.bidiLeft, null);
				
				parms[0] =  tmodel.trigger.percent ;
				str = dojo.string.substitute(this.eclMessages.SLA_TRIGGER_PERCENTAGE_OF_TIME, parms);
				
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
				
				//add over period row
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_OVER_PERIOD_LABEL, this.bidiLeft, null);
				
				this.fillInTriggerPeriod(tmodel, newRow, false);
				break;				
			case this.messages.SLA_VIOLATED_PERCENT_MORE_OF_TIME_OVER_PERIOD:
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_LABEL, this.bidiLeft, null);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_VIOLATED_PERCENT_MORE_OF_TIME_OVER_PERIOD_MSG, this.bidiLeft, null);
				
				//add percentage
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_PERCENTAGE_LABEL, this.bidiLeft, null);
				
				parms[0] =  tmodel.trigger.percent ;
				str = dojo.string.substitute(this.eclMessages.SLA_TRIGGER_PERCENTAGE_MORE_OF_TIME, parms);
				
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
				
				//add over period row
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_OVER_PERIOD_LABEL, this.bidiLeft, null);
					
				this.fillInTriggerPeriod(tmodel, newRow, true);
				
				break;				
			case this.messages.SLA_VIOLATED_PERCENT_LESS_OF_TIME_OVER_PERIOD:
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_LABEL, this.bidiLeft, null);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_VIOLATED_PERCENT_LESS_OF_TIME_OVER_PERIOD_MSG, this.bidiLeft, null);
				
				//add percentage
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_PERCENTAGE_LABEL, this.bidiLeft, null);
				
				parms[0] =  tmodel.trigger.percent ;
				str = dojo.string.substitute(this.eclMessages.SLA_TRIGGER_PERCENTAGE_LESS_OF_TIME, parms);
				this.addTextCellToRow( newRow, str, this.bidiLeft, null);
				
				//add less period row
				newRow = this.insertRow(this.slaTriggerTableBody);
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TRIGGER_OVER_PERIOD_LABEL, this.bidiLeft, null);
					
				this.fillInTriggerPeriod(tmodel, newRow, true);
				break;				
					
			default:
				throw new Error("Not a valid occurenceType");
		}
	},
	
	//*****
	//Fill in the trigger period 
	//
	//Returns: reference to the new row
	//*****
	fillInTriggerPeriod: function(tmodel, newRow, percentLessOrEq)
	{
		switch (tmodel.trigger.timeUnit.unitType) {
		case this.messages.SLA_TIME_PERIOD_HOURS:
			this.handleHoursTimePeriod(tmodel, newRow, percentLessOrEq);
			break;
		case this.messages.SLA_TIME_PERIOD_DAYS:
			this.handleDaysTimePeriod(tmodel, newRow, percentLessOrEq);
			break;
		case this.messages.SLA_TIME_PERIOD_WEEKS:
			this.handleWeeksTimePeriod(tmodel, newRow, percentLessOrEq);
			break;
		case this.messages.SLA_TIME_PERIOD_MONTHS:
			this.handleMonthsTimePeriod(tmodel, newRow, percentLessOrEq);
			break;
		case this.messages.SLA_TIME_PERIOD_YEARS:
			this.handleYearsTimePeriod(tmodel, newRow, percentLessOrEq);
			break;
		default:
			throw new Error("Invalid time period.");	
		}			
	
	},


	//*****
	//If the time unit of the time period is hours, output proper thing here by adding 
	// proper text to row.
	//
	//Returns: reference to the new row
	//*****
	handleHoursTimePeriod: function(tmodel, newRow, percentLessOrEq)
	{
		if (tmodel.trigger.timeUnit.rollingTime) {
			// this the the last n hours
			var str = null;
			var parms = [];
			parms[0] = tmodel.trigger.timeUnit.timeCount;
			if (percentLessOrEq) {
				str = dojo.string.substitute(this.eclMessages.SLA_TIME_PERIOD_N_HOURS_PLUS, parms);
			} else {
				str = dojo.string.substitute(this.eclMessages.SLA_TIME_PERIOD_N_HOURS, parms);
			}
			this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			
		} else {
			//this is just the current hour 	SLA_TIME_PERIOD_THIS_HOUR
			if (percentLessOrEq) {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_HOUR_PLUS, this.bidiLeft, null);
			} else {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_HOUR, this.bidiLeft, null);
			}
		
		}
	},
	
	//*****
	//If the time unit of the time period is days, output proper thing here by adding 
	// proper text to row.
	//
	//Returns: reference to the new row
	//*****
	handleDaysTimePeriod: function(tmodel, newRow, percentLessOrEq)
	{
		if (tmodel.trigger.timeUnit.rollingTime) {
			// this the the last n days
			var str = null;
			var parms = [];
			parms[0] = tmodel.trigger.timeUnit.timeCount;
			if (percentLessOrEq) {
				str = dojo.string.substitute(this.eclMessages.SLA_TIME_PERIOD_N_DAYS_PLUS, parms);
			} else {
				str = dojo.string.substitute(this.eclMessages.SLA_TIME_PERIOD_N_DAYS, parms);
			}
			this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			
		} else {
			//this is just the current days
			if (percentLessOrEq) {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_DAY_PLUS, this.bidiLeft, null);
			} else {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_DAY, this.bidiLeft, null);
			}
			
		}
	},
	
	//*****
	//If the time unit of the time period is weeks, output proper thing here by adding 
	// proper text to row.
	//
	//Returns: reference to the new row
	//*****
	handleWeeksTimePeriod: function(tmodel, newRow, percentLessOrEq)
	{
		if (tmodel.trigger.timeUnit.rollingTime) {
			// this the the last n weeks
			var str = null;
			var parms = [];
			parms[0] = tmodel.trigger.timeUnit.timeCount;
			if (percentLessOrEq) {
				str = dojo.string.substitute(this.eclMessages.SLA_TIME_PERIOD_N_WEEKS_PLUS, parms);
			} else {
				str = dojo.string.substitute(this.eclMessages.SLA_TIME_PERIOD_N_WEEKS, parms);
			}
			this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			
		} else {
			//this is just the current week
			if (percentLessOrEq) {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_WEEK_PLUS, this.bidiLeft, null);
			} else {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_WEEK, this.bidiLeft, null);
			}
			
		}
	},
	
	//*****
	//If the time unit of the time period is weeks, output proper thing here by adding 
	// proper text to row.
	//
	//Returns: reference to the new row
	//*****
	handleMonthsTimePeriod: function(tmodel, newRow, percentLessOrEq)
	{
		if (tmodel.trigger.timeUnit.rollingTime) {
			// this the the last n months
			var str = null;
			var parms = [];
			parms[0] = tmodel.trigger.timeUnit.timeCount;
			if (percentLessOrEq) {
				str = dojo.string.substitute(this.eclMessages.SLA_TIME_PERIOD_N_MONTHS_PLUS, parms);
			} else {
				str = dojo.string.substitute(this.eclMessages.SLA_TIME_PERIOD_N_MONTHS, parms);
			}
			this.addTextCellToRow( newRow, str, this.bidiLeft, null);
			
		} else {
			//this is just the current month 	
			if (percentLessOrEq) {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_MONTH_PLUS, this.bidiLeft, null);

			} else {
				this.addTextCellToRow( newRow, this.eclMessages.SLA_TIME_PERIOD_THIS_MONTH, this.bidiLeft, null);

			}
		}
	},
	
	
	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function(tbodyElem)
	{
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		return trElem;
	},
	

	//*****
	// Add a Bullet text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addBulletTextCellToRow: function(trElem, value, align, classname)
	{
//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), Started : " + value);
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";

		tdElem.align=align;

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		
		
		    

		tdElem.innerHTML = "<ul style='margin-top:0px;margin-bottom:0px;'><li>"+value+"</li></ul>";  


//		console.debug("JobStatus Widget, addTextCellToRow: funtion(), ended");
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";

		tdElem.align=align;

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		
		tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  


	},
	//*****
	// Add a process reference link cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addProcessRefCellToRow: function(trElem, value, align, classname, modelProperty)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";

		tdElem.align=align;

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		

		tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
		tdElem.style.cursor="pointer";
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(value);
		if (dir=="rtl")
			tdElem.style.direction="rtl";

		dojo.addClass(tdElem, "linkFieldFont");	    

		tdElem.modelProp = modelProperty;
		dojo.connect( tdElem, "onclick", function(){
//				alert("click!");
			var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
			var params = {};
		    	params.documentId = tdElem.modelProp.bpdId;
		    	params.documentName = tdElem.modelProp.bpdName;
		    	
		    	if (tdElem.modelProp.snapshotId != null) {
		    		params.snapshotId = tdElem.modelProp.snapshotId;
		    	}
		    	
		    	if (tdElem.modelProp.branchId != null ) {
		    		params.branchId = tdElem.modelProp.branchId;
		    	}
		    		
		    	openDocEvent.params = params;
		    	openDocEvent.dispatch();				
		});

	},
	
	//*****
	// Add a particpant group link cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addParticipantGrpCellToRow: function(trElem, value, align, classname, modelProperty)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";

		tdElem.align=align;

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
		
		if (modelProperty.snapshotId || modelProperty.branchId) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    
	
			tdElem.modelProp = modelProperty;
			dojo.connect( tdElem, "onclick", function(){
	//				alert("click!");
				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.participantGroupId;
			    	params.documentName = tdElem.modelProp.participantGroupName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		
	  } else {
	  	tdElem.innerHTML = value;  
	  }

	},



	getpgData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	pgModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.sla.model.slaDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.sla.model.slaDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.sla.model.slaDocTypeProvider");



dojo.declare("com.ibm.bpm.wpd.document.sla.model.slaDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	
	contructor : function () {
	},
	
	getDocType: function(){
		return "slaDocType";
	},
	
	createViewer : function(model, parent){
		return new com.ibm.bpm.wpd.document.sla.view.slaViewer({viewStateModel:model}, parent);
	},

	reuseViewer : function(){
		return false;
	},
	
	cleanup: function(){
		
	},
	
	getPORestPath: function(docId){
		
		var url = "/v1/sla/" + docId + "?";
		return url;
	},
	
	getIconPath : function(size){
		if(size == 16){
			return "images/assetview/service-level-agreement-16.png";
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry"] = true;
dojo.provide("com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry");

//
//dojo.require("com.ibm.bpm.wpd.sample.model.SampleDocTypeProvider");
//dojo.require("com.ibm.bpm.wpd.core.model.documenttype.providers.SampleDiagramDocTypeProvider");

















//TODO remove the dojo.require here and do the require upon registration

dojo.declare("com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry", null, {
	
	_docTypeProviderMap: null,
	
	//_baseDocTypeProvider:null,
	
	constructor : function () {
		this._docTypeProviderMap = {};
		
		//TODO remove the dojo.require here and do the require upon registration
		/* Initialize the registry by looking up the document types
		 *  that are registered via the ExtensionRegistry or register it here programmatically
		 */
		
		//var sampleDocTypeProvider = new com.ibm.bpm.wpd.sample.model.SampleDocTypeProvider();
		//this.registerDocTypeProvider(sampleDocTypeProvider);	
		
		//var diagramDocTypeProviRder = new com.ibm.bpm.wpd.core.model.documenttype.providers.SampleDiagramDocTypeProvider();
		//this.registerDocTypeProvider(diagramDocTypeProvider);
		
		//TO Think ? instantiate here, or instantiate when needed
		var bpdDocTypeProvider = new com.ibm.bpm.wpd.document.bpd.model.BPDDocTypeProvider();
		this.registerDocTypeProvider(bpdDocTypeProvider);
		
		//Register the business object doc type provider
		var boDocTypeProvider = new com.ibm.bpm.wpd.document.bo.model.BODocTypeProvider();
		this.registerDocTypeProvider(boDocTypeProvider);

		if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().state == com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().STATE_PROCESS_CENTER){
			var assetListModelTypeProvider = new com.ibm.bpm.wpd.assetlistview.model.AssetListModelTypeProvider();
			this.registerDocTypeProvider(assetListModelTypeProvider);
			
			var compareAssetListModelTypeProvider = new com.ibm.bpm.wpd.compare.model.CompareModelTypeProvider();
			this.registerDocTypeProvider(compareAssetListModelTypeProvider);
			
			var copyModelTypeProvider = com.ibm.bpm.wpd.copy.model.CopyModelTypeProvider();
			this.registerDocTypeProvider(copyModelTypeProvider);
		
			//Register the participant group doc type provider
			var participantGrpDocTypeProvider = new com.ibm.bpm.wpd.document.ParticipantGrp.model.ParticipantGrpDocTypeProvider();
			this.registerDocTypeProvider(participantGrpDocTypeProvider);
		
			//Register the webservice doc type provider
			var wsDocTypeProvider = new com.ibm.bpm.wpd.document.webservice.model.webserviceDocTypeProvider();
			this.registerDocTypeProvider(wsDocTypeProvider);
			
			var epvDocTypeProvider = new com.ibm.bpm.wpd.document.epv.model.EPVDocTypeProvider();
			this.registerDocTypeProvider(epvDocTypeProvider);
			
			//Register the external activity doc type provider
			var eaDocTypeProvider = new com.ibm.bpm.wpd.document.ea.model.eaDocTypeProvider();
			this.registerDocTypeProvider(eaDocTypeProvider);
			
			//Register the uca doc type provider
			var ucaDocTypeProvider = new com.ibm.bpm.wpd.document.uca.model.ucaDocTypeProvider();
			this.registerDocTypeProvider(ucaDocTypeProvider);
			
			//Register the tracking group doc type provider
			var tgDocTypeProvider = new com.ibm.bpm.wpd.document.tg.model.tgDocTypeProvider();
			this.registerDocTypeProvider(tgDocTypeProvider);
			
			//Register the tracking group doc type provider
			var serviceProvider = new com.ibm.bpm.wpd.document.bpd.model.ServiceTypeProvider();
			this.registerDocTypeProvider(serviceProvider);
			
			//Register the tracking group doc type provider
			var timingIntDocTypeProvider = new com.ibm.bpm.wpd.document.timingInt.model.timingIntDocTypeProvider();
			this.registerDocTypeProvider(timingIntDocTypeProvider);
			
			//Register the ais doc type provider
			var aisDocTypeProvider = new com.ibm.bpm.wpd.document.ais.model.aisDocTypeProvider();
			this.registerDocTypeProvider(aisDocTypeProvider);
			
			//Register the sla doc type provider
			var slaDocTypeProvider = new com.ibm.bpm.wpd.document.sla.model.slaDocTypeProvider();
			this.registerDocTypeProvider(slaDocTypeProvider);
			
	
		}
		
	},
		
	getDocumentTypeByPO : function(poId, assetType){
		if(!dojo.global.BPM.WPD_useWLEServer){
			return "BPDDocType";
		}
		var index = poId.indexOf(".");
		if (index <= 0){
			throw new Error("Unexpected PO id format");
		}
		var poType = poId.substring(0, index);
		//We may want to store this as a map in DocumentTypeRegistry
		var docType;
		switch(poType){
			case "25":
				docType = "BPDDocType";
				break;
			case "12":
				docType = "BODocType";
				break;				
			case "1":
				if(assetType == "SCA Service"){
					docType = "aisDocType";
				}
				else{
					docType = "Service";
				}
				break;	
			case "24":
				docType = "ParticipantGrpDocType";
				break;					
			case "7":
				docType = "webserviceDocType";
				break;
			case "21":
				docType = "EPVDocType";
				break;
			case "4":
				docType = "ucaDocType";
				break;				
			case "60":
				docType = "eaDocType";
				break;			
			case "14":
				docType = "tgDocType";
				break;	
			case "15":
				docType = "timingIntDocType";
				break;	
			case "47":
				docType = "slaDocType";
				break;	
			default:
				throw new Error("poType is not registered");
		}
		return docType;
	},
	
	getDocTypeProvider: function(documentType){

		var docTypeProvider = this._docTypeProviderMap[documentType];
		if (!docTypeProvider){
			throw new Error("No DocTypeProvider is registered for " + documentType);
			//if(!this._baseDocTypeProvider){
				//this._baseDocTypeProvider = new com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider();		
			//}
			//docTypeProvider = this._baseDocTypeProvider;
		}
		return docTypeProvider;
		
	},
	
	registerDocTypeProvider : function(docTypeProvider){
		 this._docTypeProviderMap[docTypeProvider.getDocType()] = docTypeProvider;
	}
	
});

com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance = function() {
	// summary: 
	//	retrieve the singleton DocumentTypeRegistry instance 
	//  It is initialized in bootstrap.js during start up 
    return dojo.global.BPM.WPD_ModelTypeProviderRegistry;
};

}

if(!dojo._hasResource["com.ibm.bpm.wpd.base.bootstrap"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.base.bootstrap"] = true;
/* Contains the functions for initialization and clean up for the BPM Web Viewer*/
dojo.provide("com.ibm.bpm.wpd.base.bootstrap");







dojo.global.BPM = {};

//function to initialize the global variables for Web viewer
com.ibm.bpm.wpd.base.initializeWebViewer = function(state, providers){

	dojo.global.BPM.WPD_RestHandler 			= new com.ibm.bpm.wpd.core.control.WpdRestHandler(null, com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST));
	
	dojo.global.BPM.WPD_ShellStateModel 		= new com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel(state);
	//dojo.global.BPM.WPD_NotificationManager		= new com.ibm.bpm.wpd.core.control.notification.NotificationManager();

	dojo.global.BPM.WPD_ModelTypeProviderRegistry 	= new com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry();
	
	dojo.global.BPM.WPD_useWLEServer = true;
	
	if (!!providers){
		
		//Register additional docTypeProvider
		for (var i = 0; i < providers.length; i++ ){
			dojo.global.BPM.WPD_ModelTypeProviderRegistry.registerDocTypeProvider(providers[i]);
		}
	}
};

com.ibm.bpm.wpd.base.launchHighlight = function(params){
		var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/jsp/visualization/visualization.jsp?newWindow=true";
		url = url + "&documentId=" + params.documentId;
		url = url + "&documentName=" + params.documentName;
		url = url + "&assetType=" + params.assetType;
		url = url + "&branchId=" + params.branchId;
		url = url + "&snapshotId=" + params.snapshotId;
		
		//var windowParams = "location=1,width=850,height=650,top=50,left=50,scrollbars=yes,status=no,resizable=yes,toolbar=no,location=no";
		var windowParams = "location=1,width=850,height=650,top=50,left=50";
		var WindowObject = window.open(url, "Visualization", windowParams);
		WindowObject.focus();
};

//function to clear all the global variables for the Web viewer
com.ibm.bpm.wpd.base.cleanUpWebViewerGlobal = function(){

	if(dojo.global.BPM.WPD_ShellStateModel){
		dojo.global.BPM.WPD_RestHandler 			=  null;
		delete dojo.global.BPM.WPD_RestHandler;
	
		//dojo.global.BPM.WPD_DocumentTypeRegistry 	=  null;
		//delete dojo.global.BPM.WPD_DocumentTypeRegistry;
	
		dojo.global.BPM.WPD_ShellStateModel 		=  null;
		delete dojo.global.BPM.WPD_ShellStateModel;
	
		//dojo.global.BPM.WPD_NotificationManager		=  null;
		//delete dojo.global.BPM.WPD_NotificationManager;
	
		dojo.global.BPM.WPD_ModelTypeProviderRegistry 	=  null;
		delete dojo.global.BPM.WPD_ModelTypeProviderRegistry;
	}
	
};

/**
 * Initializes global variables, loads style sheets and creates the component to be used
 *@param componentClassName The class name of the component to be created. It can be the following 3 classes
 *		com.ibm.bpm.wpd.base.DocumentationViewer It displays the breadcrumb, document detains view and the action panel
 *		com.ibm.bpm.wpd.core.view.BreadcrumbView It displays the breadcrumb and  document details view. NO action panel
 *      com.ibm.bpm.wpd.core.view.ViewManager It displays document details view. No breadcrumb
 *@param project Information properties
 *		projectName
 *		projectId
 *		snapshotName or branchName
 *		snapshotId or branchId
 *@param style
 *@param parentDiv
 *@param state in which the component is used. 
 *		processCenter
 *		Portal
 *		Inspector
 *@param providers List of additional BaseDocTypeProvider
 *@param breadcrumbDiv Not decided yet whether we would create breadcrumb this way
 *@param btdPreference
 *			
 */
com.ibm.bpm.wpd.base.createWebViewerComponenet = function(componentClassName, project, style, parentDiv, state, providers, breadcrumbDiv, btdPreference){
	
	//initialize global variables
	com.ibm.bpm.wpd.base.initializeWebViewer(state, providers);
	com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setProjectInfor(project);
	com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setBTDPreference(btdPreference);
	
	//load css file
	com.ibm.bpm.wpd.base.loadStyleSheet(com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_PROCESSPORTALSUPPORT) + "/js/dojo/1.6.1/dijit/themes/tundra/tundra_optimized.css", "tundraCSS");
	com.ibm.bpm.wpd.base.loadStyleSheet(com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_PROCESSPORTALSUPPORT) + "/js/dojo/1.6.1/dojox/layout/resources/ExpandoPane.css", "expandoCSS");
	com.ibm.bpm.wpd.base.loadStyleSheet(com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/widgets/themes/webviewer.css", "webviewerCSS");
	com.ibm.bpm.wpd.base.loadStyleSheet(dojo.moduleUrl("com.ibm.bpm.wpd", "css/breadcrumb.css"), "breadcrumbCSS");
	
	//instantiate the component
	dojo["require"](componentClassName);
	var compClass = dojo.getObject(componentClassName);
	var viewer = new compClass({style: style},parentDiv);
	
	//TODO: we may need to do sth about the breadcrumb	
	
	//sample for how to open a po/document, remove the comment for this line(openDocEvent.dispatch();)in your code
	//
	//var openDocClass = dojo.getObject("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");
	//var params = {};
	//params.documentId = "25.c904b3b1-afc1-4698-bf5a-a20892c20275";
	//params.documentName = "name"; 
	//var openDocEvent = new openDocClass(params);
	//openDocEvent.dispatch(); //un comment this in your code
	return viewer;
};

com.ibm.bpm.wpd.base.loadStyleSheet = function(url, cssID) {
	// summary: 
	//	Loads a stylesheet if not already loaded
	// 
	// description:
	//  This function loads the style sheet if not already loaded.
	//  If no url is specified, the style sheet for the Business Space
	//  common look and feel is used.
	//

	var loaded = false;
	
//		// create a link element to fully resolve the url
//		var link = document.createElement('link');
//		link.rel = 'stylesheet';
//		link.href = url;
//		link.type = 'text/css';
//		link.media = 'screen';
//		link.charset = 'utf-8';var loaded = false;
//		url = link.href;
//		loaded = com.ibm.bspace.common.util.ui.Helper.isStyleSheetLoaded(url);
//		//console.debug('Helper.loadStyleSheet: stylesheet '+url+' loaded='+loaded);
	
	if(document.getElementById(cssID)) {
		loaded = true;
	}
	
	if (!loaded) {

		if (dojo.isIE)
		{
			// IE has a limit of 31 style sheets at the document
			// level and also allows a style sheet to import up
			// to 31 additional style sheets.  IE only allows a
			// depth of 3 for the import tree.
			//
			// This logic will first check if we have a created a
			// dynamic style object, and if not then it creates the
			// object and adds it to the head element.  This style
			// object will be used to import all of the style sheets
			// that are loaded by this function.
			//
			// If there is room to add an import to our dynamic
			// style object, the style sheet is imported there.
			// If there is not room, each of the child objects is
			// checked and the style sheet is imported by the first
			// child that has room.  If no child stylesheets have
			// room, then the first grandchild style sheet that has
			// room is used for the import.
			//
			// These allows up to 29791 style sheets to be loaded
			// on IE.
			
			var s = document.createElement('style');
			s.id = cssID;
			document.getElementsByTagName('head')[0].appendChild(s);

			var sheet = null;
			for (var i=0; !sheet && (i<document.styleSheets.length); i++)
			{
				if (document.styleSheets[i].id == cssID)
				{
					sheet = document.styleSheets[i];
				}
			}
			if (sheet)
			{
				// check if room at depth of 1
				if (sheet.imports.length < 31)
				{
					sheet.addImport(url);
					loaded = true;
				}
				// check if room at depth of 2 (if not loaded yet)
				for (var j=0; !loaded && (j<sheet.imports.length); j++)
				{
					var child = sheet.imports[j];
					if (child.imports.length < 31)
					{
						child.addImport(url);
						loaded = true;
					}
				}
				// check if room at depth of 3 (if not loaded yet)
				for (var j=0; !loaded && (j<sheet.imports.length); j++)
				{
					var child = sheet.imports[j];
					for (var k=0; !loaded && (k<child.imports.length); k++)
					{
						var grandchild = child.imports[k];
						if (grandchild.imports.length < 31)
						{
							grandchild.addImport(url);
							loaded = true;
						}
					}
				}
			}
		} else {
			var link = document.createElement('link');
			link.rel = 'stylesheet';
			link.href = url;
			link.type = 'text/css';
			link.media = 'screen';
			link.charset = 'utf-8';
			link.id = cssID;
			document.getElementsByTagName('head')[0].appendChild(link);
			loaded = true;
		}
	}
	return loaded;
};

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.control.commands.OpenDocumentCommand"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.control.commands.OpenDocumentCommand"] = true;
dojo.provide("com.ibm.bpm.wpd.core.control.commands.OpenDocumentCommand");

dojo.declare("com.ibm.bpm.wpd.core.control.commands.OpenDocumentCommand", [com.ibm.bpm.wpd.core.control.commands.RestCommand], {
	/**
	 * Open a document/po.
	 */
	
	docTypeProvider : null, // a instance of BaseDocTypeProvider
	constructor : function (pEvent) {		
	},
	
	/**
	 * If a ViewStateModel for the requested po is found, set it as the ActiveViewStateModel
	 * Otherwise request it from the server, then create a ViewStateModel using the response data
	 */
	execute : function () {
		
		var documentId = this._getDocumentId();	
		var branchOrSnapshotId = this._getBranchOrSnapshotId();
		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();		
		
		//first try to find it in the list of openViewStateModels, ie, in the breadcrum
		var vsm = ssm.findOpenViewStateModelForDocId(documentId, branchOrSnapshotId);		
		if (!!vsm){
			if( vsm != ssm.getActiveViewStateModel()){
				
				//TODO move the non active vsm in a list and move it back when needed (do it in shellstatemodel)
				//Or do not remove the vsm for updating breadcrum, instead, ask teh breadcrumb do it
				ssm.removeTrailingViewStateModel(vsm);	
				
				ssm.setActiveViewStateModel(vsm);
			}
			return;
		}
		else{	
			/*
			 * The requested document is not in the list of vsms that are in the breadcrumb list
			 * now try to find it in the cached list
			*/
			vsm = null; // ssm.findCachedViewStateModelForDocId(documentId, branchOrSnapshotId);
			if(!!vsm){
				ssm.addOpenViewStateModel(vsm);	
				ssm.setActiveViewStateModel(vsm);
			}
			else{
				if (dojo.global.BPM.WPD_useWLEServer){
					this.sendRequest();
					/*
					 * Do some work wile waiting for respond,
					 * Check how many I have cached, if reach 20, then remove the old ones
					 * Actually, the vsm is not that heavy
					 */
				
				}
				else {	
					this.onSuccessOldWay();
				}	
			}
		}
	},
		
	getRequestParams:function(){		
		//This assume that the docType is always carried in the event for drill in at process instance view
		var docType = this._getDocType();
		this.docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
		
		var params = this.docTypeProvider.getRequestParams(this.event.params);
		return params;
	},
	
//getRequestParams:function(){
//		
//		var params = {};
//		params.action = "get";
//		
//		var docId = this.event.params.documentId;
//		
//		var branchId = this.event.params.branchId;
//		var snapshotId = !!this.event.params.snapshotId;
//		if (!this.event.params.branchId && !this.event.params.snapshotId && !this.event.params.instanceId ){
//			throw new Error("Neither branchId nor snapshot is provided");
//		}
//		
//		//This assume that the docType is always carried in the event for drill in at process instance view
//		var docType = this._getDocType();
//		var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
//		
//		//check this for now, will remove this hard coded checking later
//		if(docType == "ProcessInstanceType"){
//			params.url = docTypeProvider.getPORestPath(this.event.params);
//		}
//		else{
//			params.url = docTypeProvider.getPORestPath(docId);
//			if (!!branchId){
//				params.url = params.url + "branchId=" + branchId;
//			}
//			else{
//				params.url = params.url + "snapshotId=" + snapshotId;
//			}
//		}
//		return params;
//	},
	
//	getRequestUrlForInstance : function(){
//		var branchId = this.event.params.branchId;
//		var snapshotId = this.event.params.snapshotId;
//		var instanceId = this.event.params.instanceId;
//		var docId = this.event.params.documentId;
//		
//		
//		if(!!instanceId){
//			com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().instanceId = instanceId;
//		}
//		
//		//for drill in case: instanceId is not provided in the event
//		else if(!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().instanceId){
//			instanceId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().instanceId;
//		}
//		else{
//			//Should never happen:  change this to an error log later
//			("instanceId is not set");
//		}
//		var docType = this.event.params.type;
//		var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
//	    var url = docTypeProvider.getPORestPath(instanceId, branchId, snapshotId, docId);
//	    return url;
//	   
//	},
	
	/**
	 * This function is for off server testing
	 */
	onSuccessOldWay : function (){
		
		//get a response from star 4 server", Ask Yi to clean up the response even more
		var tempresponse = '{"status":"200","data":{"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ffc","label":"BPD1","items":[{"type":"start","successors":[{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff4"}],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff6","label":"Start","x":50,"y":50},{"type":"end","successors":[],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff5","label":"End","x":350,"y":50},{"type":"activity","successors":[{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff5"}],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff4","label":"Task1","x":211,"y":73},{"width":3000,"height":150,"type":"swimlane","children":[{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff6"},{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff5"},{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff4"}],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff8","label":"Participant","x":0,"y":0},{"width":3000,"height":150,"type":"swimlane","children":[],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff7","label":"System","x":0,"y":150}]}}';
		var tempResponseObj = dojo.fromJson(tempresponse);	
	
		//get the document part
		var documentObj = tempResponseObj.data;
				
		var documentName = this.event.params.documentName;
		var documentType = "BPDDocType";
		var documentId = this.event.params.documentId;
				
		var vsmObj = {};
		var vsmObj = {documentName: documentName, documentType:documentType, documentId:documentId, document:documentObj};
		var vsm = this.createViewStateModel(vsmObj);

		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
		ssm.addOpenViewStateModel(vsm);	
		ssm.setActiveViewStateModel(vsm);
	},
	
	onSuccess : function (response){
		
		//console.debug( "onSuccess open: " + new Date().getTime());
		
		var documentObj;		
		if(!!this.docTypeProvider.processResponseData){
			documentObj = this.docTypeProvider.processResponseData(response.data, this.event.params);		
		}
		else{
			documentObj = response.data;
		}
		
		var documentName = this._getDocumentName(documentObj);
		var documentId = this._getDocumentId();
		var documentType = this._getDocType(documentObj.serviceType);

		var rootId = this.event.params.rootId;
		
		var vsmObj = {documentName: documentName, documentType:documentType, documentId:documentId, document:documentObj};
		
		vsmObj.branchOrSnapshotId = this._getBranchOrSnapshotId();
		
		if (rootId)
			vsmObj.rootId = rootId;
		
		var vsm = this.createViewStateModel(vsmObj);
		
		//add the newly created vsm to the list of open view state models and set it to the current active one
		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
		ssm.addOpenViewStateModel(vsm);	
		ssm.setActiveViewStateModel(vsm);
		//always cache, because we know that it is not cached before
		ssm.addCachedViewStateModel(vsm);
	},
	
	/**
	 * Create and returns ViewStateModel
	 * @param data
	 * @returns a ViewStateModel for the data
	 */
	createViewStateModel : function (data){
		
		var vsm;
		
		//find docTypeProvider
		//var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(data.documentType);
		if (!!this.docTypeProvider){
			vsm = this.docTypeProvider.createViewStateModel(data);
		}
		else{
			vsm = new com.ibm.bcompass.core.model.viewstate.ViewStateModel();
		}
		
		//ViewStateModel has a name, type and documentId, branchOrSanpshotId and subProcParentId
		//Keep the information needed by ViewStateModel in vsm, because the json object format are controlled by each DocumentViewer
		vsm.name = data.documentName;
		vsm.documentId = data.documentId;
		vsm.type = data.documentType;
		vsm.branchOrSnapshotId = data.branchOrSnapshotId;
		vsm.subProcParentId = this.event.params.subProcParentId;
		
		if (data.rootId)
			vsm.rootId = data.rootId;
				
		//documentModel. No need to ask the docType provider to do this for the webviewer
		var dm = data.document; //this.createDocumentModel(documentObj);
		vsm.setDocumentModel(dm);	
			
		return vsm;
	},
	
	_getDocumentId:function(){
		if(!!this.event.params.documentId){
			return this.event.params.documentId;
		}		
		var docType = this._getDocType();
		this.docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
	   
		var docId = this.docTypeProvider.getDocumentId(this.event.params);
		if(!docId){
			throw new Error("No Unique document Id is provided");
		}
		return docId;
	},
	
	_getDocumentName:function(documentObj){
		if(!!this.event.params.documentName){
			return this.event.params.documentName;
		}
		else if( !!documentObj && !!documentObj.name){
			return documentObj.name;
		}
		//for process instance view
		var docType = this._getDocType();
		//var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
		return this.docTypeProvider.getDisplayName(this.event.params);		
	},
	
	_getBranchOrSnapshotId:function(){
		var branchOrSnapshotId = this.event.params.branchOrSnapshotId;
		if(!branchOrSnapshotId){
			branchOrSnapshotId = !!this.event.params.branchId ? this.event.params.branchId : this.event.params.snapshotId;
		}
		return branchOrSnapshotId;
	},
	
	_getDocType: function(assetType){
		var documentType;
		if (!!this.event.params.type){
			documentType = this.event.params.type;
		}
		else if (!this.event.params.assetType){
			documentType = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocumentTypeByPO(this.event.params.documentId, assetType);
		}
		else {
			documentType = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocumentTypeByPO(this.event.params.documentId, this.event.params.assetType);
		}
		return documentType;
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.breadcrumb.view.WebViewerBreadcrumb"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.breadcrumb.view.WebViewerBreadcrumb"] = true;
dojo.provide("com.ibm.bpm.wpd.core.breadcrumb.view.WebViewerBreadcrumb");







/**
 * Breadcrumb for the WebViewer
 */
dojo.declare("com.ibm.bpm.wpd.core.breadcrumb.view.WebViewerBreadcrumb",[ dijit._Widget, dijit._Templated ], {
	templateString : "<div dojoAttachPoint=\"breadcrumbEntryAttachPoint\"></div>",
	
	_connectionHandles : null,
	_subscriptionHandles : null,
	//view types that this breadcrumb displays
    //typesToDisplay:null,
 
	//For breadcrumb entry, we can choose to use a dojo cleass for breadcrumb entry too if we want
	_divToModel:null,
	_modelToDiv:null,
	_isBidiLang:null,
	
	/**
	 * 
	 * @param params properties
	 * 		className css class name to be used for this breadcrumb
	 */
	constructor : function(params) {
		this._connectionHandles = [];
		this._subscriptionHandles = [];
		this._divToModel = {};
		this._modelToDiv = {};
		var locale = dojo.locale;
		if (locale === "ar" || locale === "he") {
			this._isBidiLang = true;
		} else {
			this._isBidiLang = false;
		}
		//this.typesToDisplay = params.displayTypes;
	},
	
	postCreate : function() {
		this.domNode.className = this.className;
		this.addListeners();
	},
	
	addListeners : function(){
		this._subscriptionHandles.push(dojo.subscribe("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel" + "::" + "_openViewStateModels", this, this.openVsmChanged));
		this._subscriptionHandles.push(dojo.subscribe(
				"com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel" + "::" + "_activeViewStateModel",
				this,
				this.activeVsmChanged));
	},
	
	/**
	 * Receives notifications via dojo publish and subscription
	 * Removes a breadcrumb entry upon view state model change
	 */
	openVsmChanged : function(notification){
		if (notification.changeType == 3){
			//remove the corresponding breadcrumb
			this.removeBreadcrumbEntry(notification.oldValue);
		}
	},
	
	/**
	 * Receives notifications via dojo publish and subscription
	 * Adds a breadcrumb entry upon view state model change
	 */
	activeVsmChanged : function(notification){
		
		if(!!notification.newValue){
			//if(this._isDisplayable(vsm)){
			if (!this.breadCrumbSwap(notification)) {
				this.addBreadcrumbEntry(notification.newValue, dojo.hitch(this, this._breadcrumbEntryClicked));
			}
		}
	},
	
	/**
	 * In the case of a comparison the assetListView is removed from the trail and replaced by the comparison
	 * entry
	 */
	breadCrumbSwap: function(notification) {
		
		// check to see if there exists an new on old value
		if (!!notification.newValue && !!notification.oldValue) {
			if (notification.newValue.documentId == "compareListModel") {
				this.removeBreadcrumbEntry(notification.oldValue);
				this.addBreadcrumbEntry(notification.newValue, dojo.hitch(this, this._breadcrumbEntryClicked));
				return true;
			}
		}
		
		return false;
	},
	
	/**
	 * Receives notifications via dojo publish and subscription
	 * Adds or removes a breadcrumb entry upon view state model change
	 */
//	modelChanged : function(notification) {
//		
//		if (notification.attributeName == "_openViewStateModels" && notification.changeType == 3){
//			//remove the corresponding breadcrumb
//			this.removeBreadcrumbEntry(notification.oldValue);
//		}
//		
//		else if (notification.attributeName == "_activeViewStateModel"){		
//			if(!!notification.newValue){
//				//if(this._isDisplayable(vsm)){
//					this.addBreadcrumbEntry(notification.newValue, dojo.hitch(this, this._breadcrumbEntryClicked));
//				//}
//			}
//		}
//	},
	
	_isDisplayable: function(vsm){
		//check if the type is in the list of displayble ones
	},
	
	/**
	 * Adds an entry
	 * @param vsm the model associate with the breadcrumb entry to be created
	 * 			properties
	 * 				type: the type of the po
	 * 				name: name to be displayed
	 * 				id : an unique id for this breadcrumb entry, ie, po id
	 * @param onClick handler for the onClick event
	 * @param noSeparator whether the entry start with an separator
	 * @param imagePath   the image file path for the icon to be used. If not provided, the value provided by the 
	 * 					  doc type provider will be used	 * 	
	 * @param keyboardClick handler for the onkeypress event				 
	 */
	addBreadcrumbEntry : function(vsm, onClick, noSeparator, imagePath/*Optional*/, keyboardClick /*Optional*/){

		var noSeparator = true;
		for(var pro in this._modelToDiv){
			noSeparator = false;
		}
		this._addBreadcrumbEntry(this.breadcrumbEntryAttachPoint, vsm, onClick, noSeparator, imagePath, keyboardClick);
	},
	
	_addBreadcrumbEntry:function(parentDiv, viewModel, onClick, noSeparator, imagePath, keyboardClick){
		var sectionDiv;
		//check if an entry for the model exists already
		//This happens when click on an entry for a document which is not the current open one
		if (!!this._modelToDiv[viewModel.id]){
			sectionDiv = !!this._modelToDiv[viewModel.id];
		}
		else{
			var divId = "breadcrumbEntryDiv" + viewModel.id;
			var sectionDiv = dojo.create("div", {
				id: divId
			}, parentDiv, this._getAttachPosition());
		
			var type = viewModel.type;
			var id = viewModel.id;
			var name = viewModel.name;
			if (type == "Service") {
				var serviceType = viewModel.getDocumentModel().serviceType;
			}

						
			if(!noSeparator){
				this.attachSeparator(sectionDiv);
			}
			this.attachIcon(sectionDiv, type, imagePath, serviceType);
			this.attachName(sectionDiv, name, onClick, keyboardClick);
	
			this._modelToDiv[id] = sectionDiv;
			this._divToModel[divId] = viewModel;
		}
		this._setStyleForSelectedBreadcrumb(viewModel);
	},

	/*
	* Returns whether to attach a new node last (for LTR)
	* or first (for RTL)
	*/
	_getAttachPosition: function() {
		if (this._isBidiLang) {
			return "first";
		}
		return "last";
	},
	
	
	attachIcon: function(sectionDiv, itemType, imagePath, serviceType) {		
		var src = imagePath;
		if(!imagePath){		
			var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(itemType);
			if (itemType == "Service") {
				src = docTypeProvider.getServiceIconPath(16, serviceType);
			} else {
				src = docTypeProvider.getIconPath(16);
			}	
		}

		if(!!src){
			var imageDiv = document.createElement("div");
			sectionDiv.appendChild(imageDiv);
			imageDiv.className = "viewerBreadcrumbEntryItem";
			imageDiv.innerHTML = "<img style='' src='" + dojo.moduleUrl("com.ibm.bpm.wpd", src) + "'/>";
		}
	},
	
	attachName: function(sectionDiv,name, onClick, keyboardClick) {
		var displayName = name;
		if (displayName.indexOf("<span ")==-1)
			displayName = com.ibm.bpm.wpd.util.Helper.text2htmlText_1(name);
		
		var nameDiv = dojo.create("div", {
			style: {
				cursor: "pointer"
			},
			className: "viewerBreadcrumbEntryItem",
			innerHTML: displayName
		}, sectionDiv, this._getAttachPosition());		

		var dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(name);
		if (dir=="rtl") {
			// consider breadcrumb has ()
			nameDiv.innerHTML = com.ibm.bpm.wpd.util.BidiUtils.getRTLTextWithBracket(nameDiv.innerHTML);
			nameDiv.setAttribute("dir","rtl");
		}

		this._connectionHandles.push(dojo.connect(nameDiv, "onclick", null, onClick));

		if (keyboardClick){
			nameDiv.setAttribute("tabIndex",0);
			this._connectionHandles.push(dojo.connect(nameDiv, "onkeypress", null, keyboardClick));
		}				
	},
	
	attachSeparator: function (sectionDiv) {
		var contents = "     &gt;";
		dojo.create("div", {
			innerHTML: contents,
			className: "viewerBreadcrumbEntryItem"
		}, sectionDiv, this._getAttachPosition());
	},
	
	_breadcrumbEntryClicked:function(event){		
		var div = event.currentTarget;
		div = div.parentNode;
		var model = this._divToModel[div.id];		
	
		//dispatch event, the open doc command will find the cached vsm and set it as active and return, 
		//No need to go to the server
		var params = {documentId:model.documentId, branchOrSnapshotId: model.branchOrSnapshotId};
		(new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent(params)).dispatch();
		
	},
	/**
	 * Remove the breadcrumb entry associated with vsm
	 * @param vsm the model associated with the entry to be removed
	 */
	removeBreadcrumbEntry: function(vsm){
		var div = this._modelToDiv[vsm.id];
		delete this._divToModel[div.id];
		
		div.parentNode.removeChild(div); 
		delete this._modelToDiv[vsm.id];
	},
	
	_setStyleForSelectedBreadcrumb:function(cvsm){
		
		//go through all divs, if its model is the same as cvsm, then set as selected
		var div;		
		for (var modelId in this._modelToDiv) {
			div = this._modelToDiv[modelId];
			if((!!div)){
				if(cvsm.id == modelId){				
					div.className = "viewerBreadcrumbEntrySelected";
				}
				else{
					div.className = "viewerBreadcrumbEntry";
				}
			}
		}
	},

	/**
	 * Clean up stored data
	 */
	removeListeners:function(){
	
		for ( var i = 0; i < this._connectionHandles.length; i++) {
			if(!!this._connectionHandles[i]){
				dojo.disconnect(this._connectionHandles[i]);
			}
		}

		for ( var i = 0; i < this._subscriptionHandles.length; i++) {
			if(!!this._subscriptionHandles[i]){
				dojo.unsubscribe(this._subscriptionHandles[i]);
			}
		}
	},
	
	/**
	 * Destroy the widget
	 */
	destroy : function() {
		this.inherited(arguments);
		this.removeListeners();
		this._divToModel = null;
		this._modelToDiv = null;
		
	}
});

/**
 * BreadcrumbEntry
 * Currently there is no benefit from having this class
 */
//dojo.declare("com.ibm.bpm.wpd.core.breadcrumb.view.WebViewerBreadcrumb",[ dijit._Widget, dijit._Templated ], {
//	vsm:null,
//	
//	
//	modelChanged : function(){
//		
//	},
//	
//	entryClicked : function(){
//		
//	}
//	
//});

}

if(!dojo._hasResource["dijit.form.TextBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.TextBox"] = true;
dojo.provide("dijit.form.TextBox");



dojo.declare(
	"dijit.form.TextBox",
	dijit.form._FormValueWidget,
	{
		// summary:
		//		A base class for textbox form inputs

		// trim: Boolean
		//		Removes leading and trailing whitespace if true.  Default is false.
		trim: false,

		// uppercase: Boolean
		//		Converts all characters to uppercase if true.  Default is false.
		uppercase: false,

		// lowercase: Boolean
		//		Converts all characters to lowercase if true.  Default is false.
		lowercase: false,

		// propercase: Boolean
		//		Converts the first character of each word to uppercase if true.
		propercase: false,

		// maxLength: String
		//		HTML INPUT tag maxLength declaration.
		maxLength: "",

		// selectOnClick: [const] Boolean
		//		If true, all text will be selected when focused with mouse
		selectOnClick: false,

		// placeHolder: String
		//		Defines a hint to help users fill out the input field (as defined in HTML 5).
		//		This should only contain plain text (no html markup).
		placeHolder: "",
		
		templateString: dojo.cache("dijit.form", "templates/TextBox.html", "<div class=\"dijit dijitReset dijitInline dijitLeft\" id=\"widget_${id}\" role=\"presentation\"\n\t><div class=\"dijitReset dijitInputField dijitInputContainer\"\n\t\t><input class=\"dijitReset dijitInputInner\" dojoAttachPoint='textbox,focusNode' autocomplete=\"off\"\n\t\t\t${!nameAttrSetting} type='${type}'\n\t/></div\n></div>\n"),
		_singleNodeTemplate: '<input class="dijit dijitReset dijitLeft dijitInputField" dojoAttachPoint="textbox,focusNode" autocomplete="off" type="${type}" ${!nameAttrSetting} />',

		_buttonInputDisabled: dojo.isIE ? "disabled" : "", // allows IE to disallow focus, but Firefox cannot be disabled for mousedown events

		baseClass: "dijitTextBox",

		attributeMap: dojo.delegate(dijit.form._FormValueWidget.prototype.attributeMap, {
			maxLength: "focusNode"
		}),
		
		postMixInProperties: function(){
			var type = this.type.toLowerCase();
			if(this.templateString && this.templateString.toLowerCase() == "input" || ((type == "hidden" || type == "file") && this.templateString == dijit.form.TextBox.prototype.templateString)){
				this.templateString = this._singleNodeTemplate;
			}
			this.inherited(arguments);
		},

		_setPlaceHolderAttr: function(v){
			this._set("placeHolder", v);
			if(!this._phspan){
				this._attachPoints.push('_phspan');
				/* dijitInputField class gives placeHolder same padding as the input field
				 * parent node already has dijitInputField class but it doesn't affect this <span>
				 * since it's position: absolute.
				 */
				this._phspan = dojo.create('span',{className:'dijitPlaceHolder dijitInputField'},this.textbox,'after');
			}
			this._phspan.innerHTML="";
			this._phspan.appendChild(document.createTextNode(v));
			
			this._updatePlaceHolder();
		},
		
		_updatePlaceHolder: function(){
			if(this._phspan){
				this._phspan.style.display=(this.placeHolder&&!this._focused&&!this.textbox.value)?"":"none";
			}
		},

		_getValueAttr: function(){
			// summary:
			//		Hook so get('value') works as we like.
			// description:
			//		For `dijit.form.TextBox` this basically returns the value of the <input>.
			//
			//		For `dijit.form.MappedTextBox` subclasses, which have both
			//		a "displayed value" and a separate "submit value",
			//		This treats the "displayed value" as the master value, computing the
			//		submit value from it via this.parse().
			return this.parse(this.get('displayedValue'), this.constraints);
		},

		_setValueAttr: function(value, /*Boolean?*/ priorityChange, /*String?*/ formattedValue){
			// summary:
			//		Hook so set('value', ...) works.
			//
			// description:
			//		Sets the value of the widget to "value" which can be of
			//		any type as determined by the widget.
			//
			// value:
			//		The visual element value is also set to a corresponding,
			//		but not necessarily the same, value.
			//
			// formattedValue:
			//		If specified, used to set the visual element value,
			//		otherwise a computed visual value is used.
			//
			// priorityChange:
			//		If true, an onChange event is fired immediately instead of
			//		waiting for the next blur event.

			var filteredValue;
			if(value !== undefined){
				// TODO: this is calling filter() on both the display value and the actual value.
				// I added a comment to the filter() definition about this, but it should be changed.
				filteredValue = this.filter(value);
				if(typeof formattedValue != "string"){
					if(filteredValue !== null && ((typeof filteredValue != "number") || !isNaN(filteredValue))){
						formattedValue = this.filter(this.format(filteredValue, this.constraints));
					}else{ formattedValue = ''; }
				}
			}
			if(formattedValue != null && formattedValue != undefined && ((typeof formattedValue) != "number" || !isNaN(formattedValue)) && this.textbox.value != formattedValue){
				this.textbox.value = formattedValue;
				this._set("displayedValue", this.get("displayedValue"));
			}

			this._updatePlaceHolder();

			this.inherited(arguments, [filteredValue, priorityChange]);
		},

		// displayedValue: String
		//		For subclasses like ComboBox where the displayed value
		//		(ex: Kentucky) and the serialized value (ex: KY) are different,
		//		this represents the displayed value.
		//
		//		Setting 'displayedValue' through set('displayedValue', ...)
		//		updates 'value', and vice-versa.  Otherwise 'value' is updated
		//		from 'displayedValue' periodically, like onBlur etc.
		//
		//		TODO: move declaration to MappedTextBox?
		//		Problem is that ComboBox references displayedValue,
		//		for benefit of FilteringSelect.
		displayedValue: "",

		getDisplayedValue: function(){
			// summary:
			//		Deprecated.  Use get('displayedValue') instead.
			// tags:
			//		deprecated
			dojo.deprecated(this.declaredClass+"::getDisplayedValue() is deprecated. Use set('displayedValue') instead.", "", "2.0");
			return this.get('displayedValue');
		},

		_getDisplayedValueAttr: function(){
			// summary:
			//		Hook so get('displayedValue') works.
			// description:
			//		Returns the displayed value (what the user sees on the screen),
			// 		after filtering (ie, trimming spaces etc.).
			//
			//		For some subclasses of TextBox (like ComboBox), the displayed value
			//		is different from the serialized value that's actually
			//		sent to the server (see dijit.form.ValidationTextBox.serialize)

			// TODO: maybe we should update this.displayedValue on every keystroke so that we don't need
			// this method
			// TODO: this isn't really the displayed value when the user is typing
			return this.filter(this.textbox.value);
		},

		setDisplayedValue: function(/*String*/ value){
			// summary:
			//		Deprecated.  Use set('displayedValue', ...) instead.
			// tags:
			//		deprecated
			dojo.deprecated(this.declaredClass+"::setDisplayedValue() is deprecated. Use set('displayedValue', ...) instead.", "", "2.0");
			this.set('displayedValue', value);
		},

		_setDisplayedValueAttr: function(/*String*/ value){
			// summary:
			//		Hook so set('displayedValue', ...) works.
			// description:
			//		Sets the value of the visual element to the string "value".
			//		The widget value is also set to a corresponding,
			//		but not necessarily the same, value.

			if(value === null || value === undefined){ value = '' }
			else if(typeof value != "string"){ value = String(value) }

			this.textbox.value = value;

			// sets the serialized value to something corresponding to specified displayedValue
			// (if possible), and also updates the textbox.value, for example converting "123"
			// to "123.00"
			this._setValueAttr(this.get('value'), undefined);

			this._set("displayedValue", this.get('displayedValue'));
		},

		format: function(/*String*/ value, /*Object*/ constraints){
			// summary:
			//		Replacable function to convert a value to a properly formatted string.
			// tags:
			//		protected extension
			return ((value == null || value == undefined) ? "" : (value.toString ? value.toString() : value));
		},

		parse: function(/*String*/ value, /*Object*/ constraints){
			// summary:
			//		Replacable function to convert a formatted string to a value
			// tags:
			//		protected extension

			return value;	// String
		},

		_refreshState: function(){
			// summary:
			//		After the user types some characters, etc., this method is
			//		called to check the field for validity etc.  The base method
			//		in `dijit.form.TextBox` does nothing, but subclasses override.
			// tags:
			//		protected
		},

		_onInput: function(e){
			if(e && e.type && /key/i.test(e.type) && e.keyCode){
				switch(e.keyCode){
					case dojo.keys.SHIFT:
					case dojo.keys.ALT:
					case dojo.keys.CTRL:
					case dojo.keys.TAB:
						return;
				}
			}
			if(this.intermediateChanges){
				var _this = this;
				// the setTimeout allows the key to post to the widget input box
				setTimeout(function(){ _this._handleOnChange(_this.get('value'), false); }, 0);
			}
			this._refreshState();

			// In case someone is watch()'ing for changes to displayedValue
			this._set("displayedValue", this.get("displayedValue"));
		},

		postCreate: function(){
			if(dojo.isIE){ // IE INPUT tag fontFamily has to be set directly using STYLE
				// the setTimeout gives IE a chance to render the TextBox and to deal with font inheritance
				setTimeout(dojo.hitch(this, function(){
				var s = dojo.getComputedStyle(this.domNode);
				if(s){
					var ff = s.fontFamily;
					if(ff){
						var inputs = this.domNode.getElementsByTagName("INPUT");
						if(inputs){
							for(var i=0; i < inputs.length; i++){
								inputs[i].style.fontFamily = ff;
							}
						}
					}
				}
				}), 0);
			}

			// setting the value here is needed since value="" in the template causes "undefined"
			// and setting in the DOM (instead of the JS object) helps with form reset actions
			this.textbox.setAttribute("value", this.textbox.value); // DOM and JS values should be the same

			this.inherited(arguments);

			if(dojo.isMoz || dojo.isOpera){
				this.connect(this.textbox, "oninput", "_onInput");
			}else{
				this.connect(this.textbox, "onkeydown", "_onInput");
				this.connect(this.textbox, "onkeyup", "_onInput");
				this.connect(this.textbox, "onpaste", "_onInput");
				this.connect(this.textbox, "oncut", "_onInput");
			}
		},

		_blankValue: '', // if the textbox is blank, what value should be reported
		filter: function(val){
			// summary:
			//		Auto-corrections (such as trimming) that are applied to textbox
			//		value on blur or form submit.
			// description:
			//		For MappedTextBox subclasses, this is called twice
			// 			- once with the display value
			//			- once the value as set/returned by set('value', ...)
			//		and get('value'), ex: a Number for NumberTextBox.
			//
			//		In the latter case it does corrections like converting null to NaN.  In
			//		the former case the NumberTextBox.filter() method calls this.inherited()
			//		to execute standard trimming code in TextBox.filter().
			//
			//		TODO: break this into two methods in 2.0
			//
			// tags:
			//		protected extension
			if(val === null){ return this._blankValue; }
			if(typeof val != "string"){ return val; }
			if(this.trim){
				val = dojo.trim(val);
			}
			if(this.uppercase){
				val = val.toUpperCase();
			}
			if(this.lowercase){
				val = val.toLowerCase();
			}
			if(this.propercase){
				val = val.replace(/[^\s]+/g, function(word){
					return word.substring(0,1).toUpperCase() + word.substring(1);
				});
			}
			return val;
		},

		_setBlurValue: function(){
			this._setValueAttr(this.get('value'), true);
		},

		_onBlur: function(e){
			if(this.disabled){ return; }
			this._setBlurValue();
			this.inherited(arguments);

			if(this._selectOnClickHandle){
				this.disconnect(this._selectOnClickHandle);
			}
			if(this.selectOnClick && dojo.isMoz){
				this.textbox.selectionStart = this.textbox.selectionEnd = undefined; // clear selection so that the next mouse click doesn't reselect
			}
			
			this._updatePlaceHolder();
		},

		_onFocus: function(/*String*/ by){
			if(this.disabled || this.readOnly){ return; }

			// Select all text on focus via click if nothing already selected.
			// Since mouse-up will clear the selection need to defer selection until after mouse-up.
			// Don't do anything on focus by tabbing into the widget since there's no associated mouse-up event.
			if(this.selectOnClick && by == "mouse"){
				this._selectOnClickHandle = this.connect(this.domNode, "onmouseup", function(){
					// Only select all text on first click; otherwise users would have no way to clear
					// the selection.
					this.disconnect(this._selectOnClickHandle);

					// Check if the user selected some text manually (mouse-down, mouse-move, mouse-up)
					// and if not, then select all the text
					var textIsNotSelected;
					if(dojo.isIE){
						var range = dojo.doc.selection.createRange();
						var parent = range.parentElement();
						textIsNotSelected = parent == this.textbox && range.text.length == 0;
					}else{
						textIsNotSelected = this.textbox.selectionStart == this.textbox.selectionEnd;
					}
					if(textIsNotSelected){
						dijit.selectInputText(this.textbox);
					}
				});
			}

			this._updatePlaceHolder();
			
			// call this.inherited() before refreshState(), since this.inherited() will possibly scroll the viewport
			// (to scroll the TextBox into view), which will affect how _refreshState() positions the tooltip
			this.inherited(arguments);

			this._refreshState();
		},

		reset: function(){
			// Overrides dijit._FormWidget.reset().
			// Additionally resets the displayed textbox value to ''
			this.textbox.value = '';
			this.inherited(arguments);
		}
	}
);

dijit.selectInputText = function(/*DomNode*/ element, /*Number?*/ start, /*Number?*/ stop){
	// summary:
	//		Select text in the input element argument, from start (default 0), to stop (default end).

	// TODO: use functions in _editor/selection.js?
	var _window = dojo.global;
	var _document = dojo.doc;
	element = dojo.byId(element);
	if(isNaN(start)){ start = 0; }
	if(isNaN(stop)){ stop = element.value ? element.value.length : 0; }
	dijit.focus(element);
	if(_document["selection"] && dojo.body()["createTextRange"]){ // IE
		if(element.createTextRange){
			var r = element.createTextRange();
			r.collapse(true);
			r.moveStart("character", -99999); // move to 0
			r.moveStart("character", start); // delta from 0 is the correct position
			r.moveEnd("character", stop-start);
			r.select();
		}
	}else if(_window["getSelection"]){
		if(element.setSelectionRange){
			element.setSelectionRange(start, stop);
		}
	}
};

}

if(!dojo._hasResource["com.ibm.bpm.wpd.search.view.Search"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.search.view.Search"] = true;
dojo.provide("com.ibm.bpm.wpd.search.view.Search");





dojo.declare("com.ibm.bpm.wpd.search.view.Search",[ dijit._Widget, dijit._Templated ], {
	
	
	templateString:"<div style=\"top:0px; width:20%; height:25px;\">\n\t<table style='width:100%;' cellpadding=\"0\" cellspacing=\"0\">\n\t\t<thead>\n\t\t\t<tr height=26px style=\"\">\n<!--\t\t\t\t<th width=10% style=\"\"><img src=\"\" dojoAttachPoint=\"searchButton\" dojoAttachEvent='onclick:searchClick' style=\"vertical-align:top;\"></img></th>-->\n\t\t\t\t<th width=85% style=\"\">\n                   <div class='roundedSearch' dojoAttachPoint=\"searchBoxDiv\">\n                      <input style='border:none;width:165px;height:10px;margin-top:-4px;' dojoType='dijit.form.TextBox' dojoAttachEvent='onKeyPress:_onKeyPress, onFocus:_onFocus, onBlur:_onBlur' dojoAttachPoint=\"searchBox\"></input>\n                   </div>\n\t\t\t\t</th>\n\t\t\t</tr>\n\t\t</thead>\n\t</table>\n</div>\n\n",
	
	widgetsInTemplate : true,
	eventSearchString : "com.ibm.bpm.wpd.search.view.search.performSearch",
	WAIT_TIME:500,
	TIME_OUT_TIME:600,
	searchSet: false,
	defaultSearchString: true,
	
	constructor : function(params) {
		
	},
	
	postCreate : function() {
		//this.searchButton.src = dojo.moduleUrl('com.ibm.bpm.wpd', 'images/search.png');
		this.addHint();
	},
	
	postMixInProperties: function()
	{
		
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.search.view", "SearchResources");
	},
	
	addHint: function(){
		//this.searchBox.set('displayValue','search');
		this.searchBox.setValue(this.messages.SEARCH_HINT);
		this.searchBox.domNode.style.fontStyle='italic';
		this.searchBox.domNode.style.color='lightgray';
	},
	
	removeHint: function() {
		this.searchBox.setValue('');
		this.searchBox.domNode.style.fontStyle='normal';
		this.searchBox.domNode.style.color='black';
	},
	
	searchClick: function(evt) {
		this.wait = null;
		var searchValue = this.searchBox.get('displayedValue');
		dojo.publish(this.eventSearchString, [{searchString:searchValue}]);

	},
	
	_onKeyPress: function(e) {
		
		var keyPressedValue = e.which ? e.which : e.keyCode;
		
		if (keyPressedValue == 13) {
			this.wait = null;
			var searchValue = this.searchBox.get('displayedValue');
			dojo.publish(this.eventSearchString, [{searchString:searchValue}]);
		}
		
		this.delayFire(new Date().getTime());
	},
	
	_onFocus: function(e) {
		if (!this.searchSet) {
			this.defaultSearchString = false;
			this.removeHint();
		}
	},
	
	_onBlur: function(e) {
		if (this.searchBox.get('displayedValue') && this.searchBox.get('displayedValue').length>0 && !this.defaultSearchString) {
			this.searchSet = true;
		}
		else {
			this.defaultSearchString = true;
			this.searchSet = false;
			this.addHint();
		}
			
	},
	
	delayFire: function(time) {
		// Check to see if the wait has been set, if not set it, otherwise update it (will delay 500 ms)
		if (!this.wait) {
			this.wait = time + this.WAIT_TIME;
			var t = setTimeout(dojo.hitch(this, this.emptyMethod), this.TIME_OUT_TIME);
		}
		else {
			this.wait = time + this.WAIT_TIME;
		}
	},
	
	emptyMethod: function() {
		if(!(new Date().getTime() > this.wait)) {
			var t = setTimeout(dojo.hitch(this, this.emptyMethod), this.TIME_OUT_TIME);
			return;
		}
		this.wait = null;
		var searchValue = this.searchBox.get('displayedValue');
		dojo.publish(this.eventSearchString, [{searchString:searchValue}]);
	},
	
	toggleShow: function(value) {
		if (value) {
//			this.searchButton.style.visibility = 'visible';
//			this.searchButton.style.display = 'block';
			
			this.searchBoxDiv.style.visibility = 'visible';
			this.searchBoxDiv.style.display = 'block';
		}
		else {
//			this.searchButton.style.visibility = 'hidden';
//			this.searchButton.style.display = 'none';

			this.searchBoxDiv.style.visibility = 'hidden';
			this.searchBoxDiv.style.display = 'none';
		}
	}
	
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.view.ViewerContentPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.view.ViewerContentPane"] = true;
dojo.provide("com.ibm.bpm.wpd.core.view.ViewerContentPane");




dojo.declare("com.ibm.bpm.wpd.core.view.ViewerContentPane", [dijit.layout.ContentPane], {
	
	viewStateModel:null,
	viewer: null,
	constructor : function() {
	},

	destroyRecursive : function(){
		console.debug ("destroyrecursive in viewerContentPane");
		this.viewStateModel = null;
		this.viewer.destroyRecursive();
		this.viewer = null;
		this.inherited(arguments);
	}
});
		
		
		
		
		
		

}

if(!dojo._hasResource["dijit.layout.BorderContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.BorderContainer"] = true;
dojo.provide("dijit.layout.BorderContainer");





dojo.declare(
	"dijit.layout.BorderContainer",
	dijit.layout._LayoutWidget,
{
	// summary:
	//		Provides layout in up to 5 regions, a mandatory center with optional borders along its 4 sides.
	//
	// description:
	//		A BorderContainer is a box with a specified size, such as style="width: 500px; height: 500px;",
	//		that contains a child widget marked region="center" and optionally children widgets marked
	//		region equal to "top", "bottom", "leading", "trailing", "left" or "right".
	//		Children along the edges will be laid out according to width or height dimensions and may
	//		include optional splitters (splitter="true") to make them resizable by the user.  The remaining
	//		space is designated for the center region.
	//
	//		The outer size must be specified on the BorderContainer node.  Width must be specified for the sides
	//		and height for the top and bottom, respectively.  No dimensions should be specified on the center;
	//		it will fill the remaining space.  Regions named "leading" and "trailing" may be used just like
	//		"left" and "right" except that they will be reversed in right-to-left environments.
	//
	//		For complex layouts, multiple children can be specified for a single region.   In this case, the
	//		layoutPriority flag on the children determines which child is closer to the edge (low layoutPriority)
	//		and which child is closer to the center (high layoutPriority).   layoutPriority can also be used
	//		instead of the design attribute to conrol layout precedence of horizontal vs. vertical panes.
	// example:
	// |	<div dojoType="dijit.layout.BorderContainer" design="sidebar" gutters="false"
	// |            style="width: 400px; height: 300px;">
	// |		<div dojoType="dijit.layout.ContentPane" region="top">header text</div>
	// |		<div dojoType="dijit.layout.ContentPane" region="right" splitter="true" style="width: 200px;">table of contents</div>
	// |		<div dojoType="dijit.layout.ContentPane" region="center">client area</div>
	// |	</div>

	// design: String
	//		Which design is used for the layout:
	//			- "headline" (default) where the top and bottom extend
	//				the full width of the container
	//			- "sidebar" where the left and right sides extend from top to bottom.
	design: "headline",

	// gutters: [const] Boolean
	//		Give each pane a border and margin.
	//		Margin determined by domNode.paddingLeft.
	//		When false, only resizable panes have a gutter (i.e. draggable splitter) for resizing.
	gutters: true,

	// liveSplitters: [const] Boolean
	//		Specifies whether splitters resize as you drag (true) or only upon mouseup (false)
	liveSplitters: true,

	// persist: Boolean
	//		Save splitter positions in a cookie.
	persist: false,

	baseClass: "dijitBorderContainer",

	// _splitterClass: String
	// 		Optional hook to override the default Splitter widget used by BorderContainer
	_splitterClass: "dijit.layout._Splitter",

	postMixInProperties: function(){
		// change class name to indicate that BorderContainer is being used purely for
		// layout (like LayoutContainer) rather than for pretty formatting.
		if(!this.gutters){
			this.baseClass += "NoGutter";
		}
		this.inherited(arguments);
	},

	startup: function(){
		if(this._started){ return; }
		dojo.forEach(this.getChildren(), this._setupChild, this);
		this.inherited(arguments);
	},

	_setupChild: function(/*dijit._Widget*/ child){
		// Override _LayoutWidget._setupChild().

		var region = child.region;
		if(region){
			this.inherited(arguments);

			dojo.addClass(child.domNode, this.baseClass+"Pane");

			var ltr = this.isLeftToRight();
			if(region == "leading"){ region = ltr ? "left" : "right"; }
			if(region == "trailing"){ region = ltr ? "right" : "left"; }

			// Create draggable splitter for resizing pane,
			// or alternately if splitter=false but BorderContainer.gutters=true then
			// insert dummy div just for spacing
			if(region != "center" && (child.splitter || this.gutters) && !child._splitterWidget){
				var _Splitter = dojo.getObject(child.splitter ? this._splitterClass : "dijit.layout._Gutter");
				var splitter = new _Splitter({
					id: child.id + "_splitter",
					container: this,
					child: child,
					region: region,
					live: this.liveSplitters
				});
				splitter.isSplitter = true;
				child._splitterWidget = splitter;

				dojo.place(splitter.domNode, child.domNode, "after");

				// Splitters aren't added as Contained children, so we need to call startup explicitly
				splitter.startup();
			}
			child.region = region;	// TODO: technically wrong since it overwrites "trailing" with "left" etc.
		}
	},

	layout: function(){
		// Implement _LayoutWidget.layout() virtual method.
		this._layoutChildren();
	},

	addChild: function(/*dijit._Widget*/ child, /*Integer?*/ insertIndex){
		// Override _LayoutWidget.addChild().
		this.inherited(arguments);
		if(this._started){
			this.layout(); //OPT
		}
	},

	removeChild: function(/*dijit._Widget*/ child){
		// Override _LayoutWidget.removeChild().

		var region = child.region;
		var splitter = child._splitterWidget
		if(splitter){
			splitter.destroy();
			delete child._splitterWidget;
		}
		this.inherited(arguments);
		
		if(this._started){
			this._layoutChildren();
		}
		// Clean up whatever style changes we made to the child pane.
		// Unclear how height and width should be handled.
		dojo.removeClass(child.domNode, this.baseClass+"Pane");
		dojo.style(child.domNode, {
			top: "auto",
			bottom: "auto",
			left: "auto",
			right: "auto",
			position: "static"
		});
		dojo.style(child.domNode, region == "top" || region == "bottom" ? "width" : "height", "auto");
	},

	getChildren: function(){
		// Override _LayoutWidget.getChildren() to only return real children, not the splitters.
		return dojo.filter(this.inherited(arguments), function(widget){
			return !widget.isSplitter;
		});
	},

	// TODO: remove in 2.0
	getSplitter: function(/*String*/region){
		// summary:
		//		Returns the widget responsible for rendering the splitter associated with region
		// tags:
		//		deprecated
		return dojo.filter(this.getChildren(), function(child){
			return child.region == region;
		})[0]._splitterWidget;
	},

	resize: function(newSize, currentSize){
		// Overrides _LayoutWidget.resize().

		// resetting potential padding to 0px to provide support for 100% width/height + padding
		// TODO: this hack doesn't respect the box model and is a temporary fix
		if(!this.cs || !this.pe){
			var node = this.domNode;
			this.cs = dojo.getComputedStyle(node);
			this.pe = dojo._getPadExtents(node, this.cs);
			this.pe.r = dojo._toPixelValue(node, this.cs.paddingRight);
			this.pe.b = dojo._toPixelValue(node, this.cs.paddingBottom);

			dojo.style(node, "padding", "0px");
		}

		this.inherited(arguments);
	},

	_layoutChildren: function(/*String?*/ changedChildId, /*Number?*/ changedChildSize){
		// summary:
		//		This is the main routine for setting size/position of each child.
		// description:
		//		With no arguments, measures the height of top/bottom panes, the width
		//		of left/right panes, and then sizes all panes accordingly.
		//
		//		With changedRegion specified (as "left", "top", "bottom", or "right"),
		//		it changes that region's width/height to changedRegionSize and
		//		then resizes other regions that were affected.
		// changedChildId:
		//		Id of the child which should be resized because splitter was dragged.
		// changedChildSize:
		//		The new width/height (in pixels) to make specified child

		if(!this._borderBox || !this._borderBox.h){
			// We are currently hidden, or we haven't been sized by our parent yet.
			// Abort.   Someone will resize us later.
			return;
		}

		// Generate list of wrappers of my children in the order that I want layoutChildren()
		// to process them (i.e. from the outside to the inside)
		var wrappers = dojo.map(this.getChildren(), function(child, idx){
			return {
				pane: child,
				weight: [
					child.region == "center" ? Infinity : 0,
					child.layoutPriority,
					(this.design == "sidebar" ? 1 : -1) * (/top|bottom/.test(child.region) ? 1 : -1),
					idx
				]
			};
		}, this);
		wrappers.sort(function(a, b){
			var aw = a.weight, bw = b.weight;
			for(var i=0; i<aw.length; i++){
				if(aw[i] != bw[i]){
					return aw[i] - bw[i];
				}
			}
			return 0;
		});

		// Make new list, combining the externally specified children with splitters and gutters
		var childrenAndSplitters = [];
		dojo.forEach(wrappers, function(wrapper){
			var pane = wrapper.pane;
			childrenAndSplitters.push(pane);
			if(pane._splitterWidget){
				childrenAndSplitters.push(pane._splitterWidget);
			}
		});

		// Compute the box in which to lay out my children
		var dim = {
			l: this.pe.l,
			t: this.pe.t,
			w: this._borderBox.w - this.pe.w,
			h: this._borderBox.h - this.pe.h
		};

		// Layout the children, possibly changing size due to a splitter drag
		dijit.layout.layoutChildren(this.domNode, dim, childrenAndSplitters,
			changedChildId, changedChildSize);
	},

	destroyRecursive: function(){
		// Destroy splitters first, while getChildren() still works
		dojo.forEach(this.getChildren(), function(child){
			var splitter = child._splitterWidget;
			if(splitter){
				splitter.destroy();
			}
			delete child._splitterWidget;
		});

		// Then destroy the real children, and myself
		this.inherited(arguments);
	}
});

// This argument can be specified for the children of a BorderContainer.
// Since any widget can be specified as a LayoutContainer child, mix it
// into the base widget class.  (This is a hack, but it's effective.)
dojo.extend(dijit._Widget, {
	// region: [const] String
	//		Parameter for children of `dijit.layout.BorderContainer`.
	//		Values: "top", "bottom", "leading", "trailing", "left", "right", "center".
	//		See the `dijit.layout.BorderContainer` description for details.
	region: '',

	// layoutPriority: [const] Number
	//		Parameter for children of `dijit.layout.BorderContainer`.
	//		Children with a higher layoutPriority will be placed closer to the BorderContainer center,
	//		between children with a lower layoutPriority.
	layoutPriority: 0,

	// splitter: [const] Boolean
	//		Parameter for child of `dijit.layout.BorderContainer` where region != "center".
	//		If true, enables user to resize the widget by putting a draggable splitter between
	//		this widget and the region=center widget.
	splitter: false,

	// minSize: [const] Number
	//		Parameter for children of `dijit.layout.BorderContainer`.
	//		Specifies a minimum size (in pixels) for this widget when resized by a splitter.
	minSize: 0,

	// maxSize: [const] Number
	//		Parameter for children of `dijit.layout.BorderContainer`.
	//		Specifies a maximum size (in pixels) for this widget when resized by a splitter.
	maxSize: Infinity
});

dojo.declare("dijit.layout._Splitter", [ dijit._Widget, dijit._Templated ],
{
	// summary:
	//		A draggable spacer between two items in a `dijit.layout.BorderContainer`.
	// description:
	//		This is instantiated by `dijit.layout.BorderContainer`.  Users should not
	//		create it directly.
	// tags:
	//		private

/*=====
 	// container: [const] dijit.layout.BorderContainer
 	//		Pointer to the parent BorderContainer
	container: null,

	// child: [const] dijit.layout._LayoutWidget
	//		Pointer to the pane associated with this splitter
	child: null,

	// region: [const] String
	//		Region of pane associated with this splitter.
	//		"top", "bottom", "left", "right".
	region: null,
=====*/

	// live: [const] Boolean
	//		If true, the child's size changes and the child widget is redrawn as you drag the splitter;
	//		otherwise, the size doesn't change until you drop the splitter (by mouse-up)
	live: true,

	templateString: '<div class="dijitSplitter" dojoAttachEvent="onkeypress:_onKeyPress,onmousedown:_startDrag,onmouseenter:_onMouse,onmouseleave:_onMouse" tabIndex="0" role="separator"><div class="dijitSplitterThumb"></div></div>',

	postMixInProperties: function(){
		this.inherited(arguments);

		this.horizontal = /top|bottom/.test(this.region);
		this._factor = /top|left/.test(this.region) ? 1 : -1;
		this._cookieName = this.container.id + "_" + this.region;
	},

	buildRendering: function(){
		this.inherited(arguments);

		dojo.addClass(this.domNode, "dijitSplitter" + (this.horizontal ? "H" : "V"));

		if(this.container.persist){
			// restore old size
			var persistSize = dojo.cookie(this._cookieName);
			if(persistSize){
				this.child.domNode.style[this.horizontal ? "height" : "width"] = persistSize;
			}
		}
	},

	_computeMaxSize: function(){
		// summary:
		//		Return the maximum size that my corresponding pane can be set to

		var dim = this.horizontal ? 'h' : 'w',
			childSize = dojo.marginBox(this.child.domNode)[dim],
			center = dojo.filter(this.container.getChildren(), function(child){ return child.region == "center";})[0],
			spaceAvailable = dojo.marginBox(center.domNode)[dim];	// can expand until center is crushed to 0

		return Math.min(this.child.maxSize, childSize + spaceAvailable);
	},

	_startDrag: function(e){
		if(!this.cover){
			this.cover = dojo.doc.createElement('div');
			dojo.addClass(this.cover, "dijitSplitterCover");
			dojo.place(this.cover, this.child.domNode, "after");
		}
		dojo.addClass(this.cover, "dijitSplitterCoverActive");

		// Safeguard in case the stop event was missed.  Shouldn't be necessary if we always get the mouse up.
		if(this.fake){ dojo.destroy(this.fake); }
		if(!(this._resize = this.live)){ //TODO: disable live for IE6?
			// create fake splitter to display at old position while we drag
			(this.fake = this.domNode.cloneNode(true)).removeAttribute("id");
			dojo.addClass(this.domNode, "dijitSplitterShadow");
			dojo.place(this.fake, this.domNode, "after");
		}
		dojo.addClass(this.domNode, "dijitSplitterActive dijitSplitter" + (this.horizontal ? "H" : "V") + "Active");
		if(this.fake){
			dojo.removeClass(this.fake, "dijitSplitterHover dijitSplitter" + (this.horizontal ? "H" : "V") + "Hover");
		}

		//Performance: load data info local vars for onmousevent function closure
		var factor = this._factor,
			isHorizontal = this.horizontal,
			axis = isHorizontal ? "pageY" : "pageX",
			pageStart = e[axis],
			splitterStyle = this.domNode.style,
			dim = isHorizontal ? 'h' : 'w',
			childStart = dojo.marginBox(this.child.domNode)[dim],
			max = this._computeMaxSize(),
			min = this.child.minSize || 20,
			region = this.region,
			splitterAttr = region == "top" || region == "bottom" ? "top" : "left",	// style attribute of splitter to adjust
			splitterStart = parseInt(splitterStyle[splitterAttr], 10),
			resize = this._resize,
			layoutFunc = dojo.hitch(this.container, "_layoutChildren", this.child.id),
			de = dojo.doc;

		this._handlers = (this._handlers || []).concat([
			dojo.connect(de, "onmousemove", this._drag = function(e, forceResize){
				var delta = e[axis] - pageStart,
					childSize = factor * delta + childStart,
					boundChildSize = Math.max(Math.min(childSize, max), min);

				if(resize || forceResize){
					layoutFunc(boundChildSize);
				}
				// TODO: setting style directly (usually) sets content box size, need to set margin box size
				splitterStyle[splitterAttr] = delta + splitterStart + factor*(boundChildSize - childSize) + "px";
			}),
			dojo.connect(de, "ondragstart", dojo.stopEvent),
			dojo.connect(dojo.body(), "onselectstart", dojo.stopEvent),
			dojo.connect(de, "onmouseup", this, "_stopDrag")
		]);
		dojo.stopEvent(e);
	},

	_onMouse: function(e){
		var o = (e.type == "mouseover" || e.type == "mouseenter");
		dojo.toggleClass(this.domNode, "dijitSplitterHover", o);
		dojo.toggleClass(this.domNode, "dijitSplitter" + (this.horizontal ? "H" : "V") + "Hover", o);
	},

	_stopDrag: function(e){
		try{
			if(this.cover){
				dojo.removeClass(this.cover, "dijitSplitterCoverActive");
			}
			if(this.fake){ dojo.destroy(this.fake); }
			dojo.removeClass(this.domNode, "dijitSplitterActive dijitSplitter"
				+ (this.horizontal ? "H" : "V") + "Active dijitSplitterShadow");
			this._drag(e); //TODO: redundant with onmousemove?
			this._drag(e, true);
		}finally{
			this._cleanupHandlers();
			delete this._drag;
		}

		if(this.container.persist){
			dojo.cookie(this._cookieName, this.child.domNode.style[this.horizontal ? "height" : "width"], {expires:365});
		}
	},

	_cleanupHandlers: function(){
		dojo.forEach(this._handlers, dojo.disconnect);
		delete this._handlers;
	},

	_onKeyPress: function(/*Event*/ e){
		// should we apply typematic to this?
		this._resize = true;
		var horizontal = this.horizontal;
		var tick = 1;
		var dk = dojo.keys;
		switch(e.charOrCode){
			case horizontal ? dk.UP_ARROW : dk.LEFT_ARROW:
				tick *= -1;
//				break;
			case horizontal ? dk.DOWN_ARROW : dk.RIGHT_ARROW:
				break;
			default:
//				this.inherited(arguments);
				return;
		}
		var childSize = dojo._getMarginSize(this.child.domNode)[ horizontal ? 'h' : 'w' ] + this._factor * tick;
		this.container._layoutChildren(this.child.id, Math.max(Math.min(childSize, this._computeMaxSize()), this.child.minSize));
		dojo.stopEvent(e);
	},

	destroy: function(){
		this._cleanupHandlers();
		delete this.child;
		delete this.container;
		delete this.cover;
		delete this.fake;
		this.inherited(arguments);
	}
});

dojo.declare("dijit.layout._Gutter", [dijit._Widget, dijit._Templated],
{
	// summary:
	// 		Just a spacer div to separate side pane from center pane.
	//		Basically a trick to lookup the gutter/splitter width from the theme.
	// description:
	//		Instantiated by `dijit.layout.BorderContainer`.  Users should not
	//		create directly.
	// tags:
	//		private

	templateString: '<div class="dijitGutter" role="presentation"></div>',

	postMixInProperties: function(){
		this.inherited(arguments);
		this.horizontal = /top|bottom/.test(this.region);
	},

	buildRendering: function(){
		this.inherited(arguments);
		dojo.addClass(this.domNode, "dijitGutter" + (this.horizontal ? "H" : "V"));
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.view.ViewManager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.view.ViewManager"] = true;

dojo.provide("com.ibm.bpm.wpd.core.view.ViewManager");







/**
 * ViewManager is used to control the open/close/show/hide/setModel for all viewers 
 */
dojo.declare("com.ibm.bpm.wpd.core.view.ViewManager",[ dijit._Widget, dijit._Templated, dijit.layout.StackContainer], {
	widgetsInTemplate : true,
	_subscriptionHandles : null,

	constructor : function(params) {		
		this._subscriptionHandles = [];
	},
	
	postCreate : function() {		
		this._subscriptionHandles.push(dojo.subscribe("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel" + "::" + "_openViewStateModels", this, this.modelChanged));
		this._subscriptionHandles.push(dojo.subscribe("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel" + "::" + "_activeViewStateModel", this, this.modelChanged));
	},
	
	/**
	 * Receives notifications, either via dojo subscription or direct listening at the instance level
	 */
	modelChanged : function(notification) {
	
		if (notification.attributeName == "_openViewStateModels" && notification.changeType == 3){
			//do we want to remove the content pane for it? it is cached now for fast response time
			//TODO Remove some cached content pane (with editor) based on  based on some performance measurement
		}
		else if (notification.attributeName == "_activeViewStateModel"){		
			if(!!notification.newValue){
				try{ 
					this._openViewer(notification.newValue);
				}
				catch(err){
					//1. log error to server, log into debug console,  and show error dialog if it is severe					
					var className = this.declaredClass;
					var methodName = "_openViewer";
					var message = " Catch error when opening viewer of type (" + notification.newValue.type + ")" +
					    ' \n Error Type: ' + err.name +
						' \n Error Message: ' + err.message;
						
					var loadingImg = dojo.byId("wpdLoadingImag");
					if (!!loadingImg) {
						loadingImg.style.display = "none";
					}
										
					com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError(className, methodName, message, err.level);
				}
			}
		}
	},

    /**
     * Finds/Creates and shows a viewer for the viewStateModel
     * @param viewStateModel It contains the information to be displayed by the viewer
     */
    _openViewer : function(viewStateModel /* IViewStateModel */) {

		// 1. Hide the current viewer
		var cpToHide = this.selectedChildWidget;					
		if (!!cpToHide && !!cpToHide.viewer) {	
			if(!!dojo.hasClass(cpToHide.domNode, "bpmPrintShow")){
				 dojo.removeClass(cpToHide.domNode, "bpmPrintShow");
			}

			cpToHide.viewer.onHide();
		}
			
		// 2. find whether an viewer for this ViewStateModel already exists. This depends on the implementation
		var viewer, viewerCp;
		var viewerCps = this.getChildren();
		var i;
		for (i=0; i<viewerCps.length; i++){
			viewerCp = viewerCps[i];
			//note that the branchOrSnapshotId maybe null when view the top level process instance
			if (!!viewerCp.viewStateModel && viewerCp.viewStateModel.type == viewStateModel.type 
					&& viewerCp.viewStateModel.documentId == viewStateModel.documentId 
					&& viewerCp.viewStateModel.branchOrSnapshotId == viewStateModel.branchOrSnapshotId){
				viewer = viewerCp.viewer;
				console.debug("found for vsm: " + viewStateModel.type + " " + viewStateModel.name);
				
				//we found the cached pane, so the response time here is good. let us use this time for some cleaning up work
				this._removeCachedPanes();
				break;
			}
		}
		
		var newlyCreated = false;
		var docType = viewStateModel.type;		
		var provider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
		provider.setViewStateModel(viewStateModel);
		/*3. if a viewer for this ViewStateModel does not exist,  
		 */
		if (!viewer) {			
			
			//if reuse, then find the viewer for this doctype and reuse it if one exist
			if (provider.reuseViewer()){
				for (i=0; i<viewerCps.length; i++){
					viewerCp = viewerCps[i];
					if (!!viewerCp.viewStateModel && viewerCp.viewStateModel.type == viewStateModel.type){
						viewer = viewerCp.viewer;
						break;
					}
				}
			}
			
			if(!!viewer ){			
				viewer.setViewStateModel(viewStateModel);
				viewerCp.viewStateModel = viewStateModel;
			}
			//if not reuse or no existing one, then create one
			else{							
				viewerCp = new com.ibm.bpm.wpd.core.view.ViewerContentPane({ parseOnLoad: false, style: "height:98%;width:900px;"});
				newlyCreated = true;
				var viewerAttachPoint = document.createElement("div");
				viewerAttachPoint.style.height = "100%";
				viewerAttachPoint.style.width = "100%";
				if ( dojo.version.minor < 5 )
					viewerCp.attr("content", viewerAttachPoint);
				else
					viewerCp.set("content", viewerAttachPoint);
				this.addChild(viewerCp);
				this.selectChild(viewerCp);
				this.resize();	
				viewer = provider.createViewer(viewStateModel, viewerAttachPoint);	
			
				if (viewStateModel.type == 'assetListModel'){
					var self = this;				
					window.setTimeout(function() {
						dojo.byId("wpdLoadingImag").style.display = "none";
					},0);
				}
					
				viewerCp.viewStateModel = viewStateModel;
				viewerCp.viewer = viewer;								
			}
		}
		
		// 4 show it in the pane // select the pane for the viewer just opened.		
		if(!newlyCreated){
			this.selectChild(viewerCp);
			this.resize();	
		}

		// 5. ask viewer to show itself
		viewer.onShow();
		if(!dojo.hasClass(viewerCp.domNode, "bpmPrintShow")){
			dojo.addClass(viewerCp.domNode, "bpmPrintShow");
		}
	
	},

	_removeCachedPanes : function(){
		try{
			//
			var viewers =  dijit.registry.byClass("com.ibm.bpm.wpd.document.bpd.view.BPMNViewer");		
			var panes =  dijit.registry.byClass("com.ibm.bpm.wpd.core.view.ViewerContentPane");			
			console.debug("before: " + viewers.length + " panes: " + panes.length);
			
			 	var viewerCps = this.getChildren();			
				var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();	
				var nodesNumber = this._countNotesNumber(ssm);
				
				//TODO: need to do some performance measurement to get more reasonable numbers
				if (viewerCps.length > 20 ||  nodesNumber > 1000){	
					console.debug("measurement: " + viewerCps.length  + " " + nodesNumber);
					var vsm, i;					
					/*remove one cached pane, using oldest out algorithm. 
					 *of course, not asset list view, nor remove the ones on breadcrumb path
					 */
					for (i=0; i < viewerCps.length; i++){
						vsm = viewerCps[i].viewStateModel;
						if(vsm.type != 'assetListModel'){				
							//first try to find it in the list of openViewStateModels, ie, in the breadcrum
							if(! ssm.findOpenViewStateModelForDocId(vsm.documentId, vsm.branchOrSnapshotId)){							
								viewerCp = viewerCps[i];	
								console.debug("remove pane for vsm: " + vsm.type + " " + vsm.name);
								this._removeViewerAndCp(viewerCp);
								ssm.removeCachedViewStateModel(vsm);
							    break;  //remove 1
							}				
						}			
					}
			    }		
				viewers =  dijit.registry.byClass("com.ibm.bpm.wpd.document.bpd.view.BPMNViewer");		
				panes =  dijit.registry.byClass("com.ibm.bpm.wpd.core.view.ViewerContentPane");
				console.debug("after: " + viewers.length + " panes: " + panes.length);	
		}
		catch(err){
			var className = this.declaredClass;
			var methodName = "_removeCachedPanes";
			var message = " Catch error when remove cached viewers" +
			    ' \n Error Type: ' + err.name +
				' \n Error Message: ' + err.message;
			com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError(className, methodName, message, err.level);
		}	
	},
	
	_countNotesNumber : function(ssm){
		var i;
		var count=0;
		var dm;
		var vm;
		for (i=0; i<ssm._cachedViewStateModels.length; i++){
			if( !!ssm._cachedViewStateModels[i].getDocumentModel && !! ssm._cachedViewStateModels[i].getDocumentModel() &&  !!ssm._cachedViewStateModels[i].getDocumentModel()["items"]){
				count += ssm._cachedViewStateModels[i].getDocumentModel()["items"].length;
			}
		}
		return count;
	},
	
	_removeViewerAndCp : function (cp){
		var viewer = cp.viewer;
		//
		try{
			this.removeChild(cp);
			cp.destroyRecursive();			
		}
		catch(err){
		    throw {
		    		name : err.name,
		    		message: "Error when destroy viewer and its content pane: " + viewer.declaredClass
		    };
		}
	},
	
	destroyFlashPlayer : function (){
		var viewerCps = this.getChildren();
		for (i=0; i<viewerCps.length; i++){
			viewerCp = viewerCps[i];	
			viewer = viewerCp.viewer;
			if (!! viewer && viewer["destroyFlashPlayer"]){
				viewer.destroyFlashPlayer();
			}
		}
	}, 
	
	
	/**
	 * Destroy the widget
	 */
	destroy : function() {
		for ( var i = 0; i < this._subscriptionHandles.length; i++) {
			if(!!this._subscriptionHandles[i]){
				dojo.unsubscribe(this._subscriptionHandles[i]);
			}
		}
		this.inherited(arguments);
		com.ibm.bpm.wpd.base.cleanUpWebViewerGlobal();
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.core.view.BreadcrumbView"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.core.view.BreadcrumbView"] = true;
dojo.provide("com.ibm.bpm.wpd.core.view.BreadcrumbView");








/**
 * Breadcrumb and the ViewManager
 */
dojo.declare("com.ibm.bpm.wpd.core.view.BreadcrumbView",[ dijit._Widget, dijit._Templated ], {
	templateString:"<div style=\"font-family: Arial; font-size: 12px; width:100%;height: 100%;\"  dojoattachpoint=\"containerNode\">\n<!--\t<div dojoType=\"dijit.layout.BorderContainer\" dojoAttachPoint=\"outerBC\" design=\"headline\" style=\"height: 100%;\">-->\n\t<div dojoType=\"dijit.layout.BorderContainer\" dojoAttachPoint=\"outerBC\" gutters=\"false\" design=\"headline\" style=\"height: 100%;\">\n\t\t<div dojoType=\"dijit.layout.ContentPane\" region=\"top\" style=\"border:0px; padding:0px; min-height:30px; width:100%\">\n\t\t\t<table style='width:100%;' cellpadding=\"0\" cellspacing=\"0\">\n\t\t\t\t<thead>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<!-- Remove width from style and use actualy attribute as the css doesn't appear to be supported in version.-->\n\t\t\t\t\t\t<!-- The two fields are butted up to one another -->\n\t\t\t\t\t\t<th width='80%' height='30px' style=\"background-color:rgb(231,239,255);\" dojoAttachPoint=\"breadcrumbCell\"><div dojoAttachPoint=\"breadcrumbAttachPoint\"></div></th>\n\t\t\t\t\t\t<th width='20%' height='30px' style=\"background-color:rgb(231,239,255);\" dojoAttachPoint=\"searchViewCell\"><div dojoAttachPoint=\"searchViewAttachPoint\"></div></th>\n\t\t\t\t\t</tr>\n\t\t\t\t</thead>\n\t\t\t</table>\n\t\t\t\t<!--  <div>\n\t\t\t\t\t<div dojoAttachPoint=\"breadcrumbAttachPoint\" style=\"float:left;width:80%\"></div>\n\t\t\t\t\t<div dojoType=\"com.ibm.bpm.wpd.search.view.Search\" dojoAttachPoint=\"searchView\" style=\"float:right;width:20%;\"></div>\n\t\t\t\t\t<div style=\"clear:both\"></div>\n\t\t\t\t</div>-->\n      \t</div>\n\t \t<div dojoType=\"dijit.layout.ContentPane\" region=\"center\" style=\"border:0px; padding: 0px;\">\n\t\t\t<div dojoType=\"com.ibm.bpm.wpd.core.view.ViewManager\" dojoAttachPoint=\"viewersContainer\" style=\"width:100%;height:100%\">\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div class=\"iconLoading\";\">\n\t <img id=\"wpdLoadingImag\" src=\"${contextRootForWebViewer}/widgets/com/ibm/bpm/wpd/images/spinner.gif\" dojoAttachPoint='iconLoading' style=\"width:16px; height:16px; display:none;\"/>\n\t<!--   <label id=\"wpdLoadingImag\" dojoAttachPoint='iconLoading'  style=\"width:200px; height:50px display:none; border: solid dotted red;\" > Opening viewer ...</label> -->\n\t</div>\t\n</div>\n",
	
	widgetsInTemplate : true,
	_subscriptionHandles : null,
	searchView: null,
	contextRootForWebViewer: null,
	
	constructor : function(params) {
		//if (!!params.initializeNeeded){
			//com.ibm.bpm.wpd.base.initializeWebViewerGlobal();		
			//flag for developing using wle server or sandbox server
		//	if(!!dojo.global.BPM.WPD_useWLEServer)
			//	com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setSnapshotInfor(params);
			//else
				//com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setSnapshotInfor({projectId: "app", projectName: "app", snapshotId: "snapshot", snapshotName :"snapshot"});
		//}		
		this._subscriptionHandles = [];
		this.contextRootForWebViewer = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER);
		
	},
	
	postCreate : function() {
		this._instantiateBreadcrum();
		if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().state == com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().STATE_PROCESS_CENTER){
			this.searchView = new com.ibm.bpm.wpd.search.view.Search({}, this.searchViewAttachPoint);
		} else {
			this.searchViewCell.style.display = "none";
			this.breadcrumbCell.removeAttribute("width");
			this.breadcrumbCell.style.width = "100%";
		}
		
		this.outerBC.startup();
		this._subscriptionHandles.push(dojo.subscribe("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel" + "::" + "_activeViewStateModel", this, this.modelChanged));
	},
	

	/**
	 * breadcrumb instantiation
	 */
	_instantiateBreadcrum:function(){		
		
		//var filterTypes = ["bpdDocType", "assetListView"];
		var breadcrumb = new com.ibm.bpm.wpd.core.breadcrumb.view.WebViewerBreadcrumb({className:"viewerBreadcrumbBar"}, this.breadcrumbAttachPoint);
		
		if(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().state == com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().STATE_PROCESS_CENTER){
			var displayName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().projectName;
			var iconPath = "images/process-app-16.png";
			if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadCrumbName) {
				displayName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadCrumbName;
				iconPath = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadCrumbImage;
			}		
			var viewModel = {name : displayName, type:"app", id: "app"};

			if(!!displayName){
			    breadcrumb.addBreadcrumbEntry(viewModel, this._backToPC, true,  iconPath);
			}
		}
		
		// Store the breadcrumb so we can query it to determine path in other views
		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadcrumb = breadcrumb;
		
		//breadcrumb.onShow();
	},
	
	_backToPC:function(){
		cleanupWebViewer();
	},
	
	/**
	 * Receives notifications, either via dojo subscription or direct listening at the instance level
	 */
	modelChanged : function(notification) {
		
		this.toggleSearch(notification);
		
		if (notification.attributeName == "_activeViewStateModel"){
			if(!!notification.newValue){	
				this.outerBC.resize();
			}
		}
	},
	
	/**
	 * Determine whether the search field should be hidden or shown
	 * @param notification
	 */
	toggleSearch: function(notification) {
		if (notification.newValue.documentId == "assetListModel") {
			if (!!this.searchView){
				this.searchView.toggleShow(true);
			}
		}
		//Defect 68873
		//else if (notification.oldValue && notification.oldValue.documentId == "assetListModel") {
		else {
			if (!!this.searchView){
				this.searchView.toggleShow(false);
			}
		}
		
	},

	resize : function(){
		//have to explicilty call this otherwise the pane does not resize on browser resize
		this.outerBC.resize();
		this.inherited(arguments);
		//console.debug("after breadcrumbview" + arguments[0].h + " " + arguments[0].w);
	},
	
	/**
	 * Clean up stored data
	 */
	cleanup:function(){	
		for ( var i = 0; i < this._subscriptionHandles.length; i++) {
			if(!!this._subscriptionHandles[i]){
				dojo.unsubscribe(this._subscriptionHandles[i]);
			}
		}
	},
	
	destroyFlashPlayer : function (){
		this.viewersContainer.destroyFlashPlayer();
	}, 
	
	/**
	 * Destroy the widget
	 */
	destroy : function() {
		this.cleanup();
		this.inherited(arguments);
		com.ibm.bpm.wpd.base.cleanUpWebViewerGlobal();
	}
});

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.model.VisualModelHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.model.VisualModelHelper"] = true;
dojo.provide("com.ibm.bpm.wpd.document.model.VisualModelHelper");


com.ibm.bpm.wpd.document.model.VisualModelHelper.decorateNodesWithImage = function(model, params){
	var userCounts = {};
	var activityIds = [];

	for (var i=0; i< params.length; i++) {	
		
		com.ibm.bpm.wpd.document.model.VisualModelHelper.addPropertyToNode(model, params[i].activityId, 'decorator', params[i].imagePath, "UserTask");
		
		if(userCounts[params[i].activityId]){
            userCounts[params[i].activityId]++;
        } else {
			userCounts[params[i].activityId] = 1;
			activityIds.push(params[i].activityId);
        }
	}
	
	var str;
	for(var i=0; i<activityIds.length; i++){
		if(userCounts[params[i].activityId]>1){
			str = ['(', userCounts[params[i].activityId],')'].join('');
			com.ibm.bpm.wpd.document.model.VisualModelHelper.addPropertyToNode(model, params[i].activityId, 'decoratorCount', str);
		}
	}
};

com.ibm.bpm.wpd.document.model.VisualModelHelper.addPropertyToNode = function(model, nodeId, propertyName, value, bpmn2TaskTypeFilter ){
	//traverse the model to find the nodes
	var node;
	for (var i=0; i<model["items"].length; i++) {
		node = model["items"][i];		
		if(node.id == nodeId && (typeof(bpmn2TaskTypeFilter)=="undefined" || (bpmn2TaskTypeFilter==node.bpmn2TaskType) ) ){
			node[propertyName] = value;
		}
	}		
};

}

if(!dojo._hasResource["com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider"] = true;
dojo.provide("com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider");




dojo.declare("com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider", [com.ibm.bpm.wpd.core.model.documenttype.providers.BaseDocTypeProvider], {

	config : null,

	contructor : function () {
		this.config = {};
		this.config.additionalDataHandlers = [];
	},
	
	getDocType: function(){
	
		return "ProcessInstanceType";
	},
	
	createViewer : function(model, parent){
		var params = {viewStateModel:model};
		params.config = this.config;
		params.type = this.getDocType();
		var viewer = new com.ibm.bpm.wpd.document.bpd.view.BPDViewer(params, parent);	
		return viewer;
	},
	
	reuseViewer : function(){
		return false;
	},
	
	getDocumentId: function (properties){
		var documentId = !!properties.documentId ? properties.documentId: properties.bpdId;
		return documentId;	
	},
	
	getInstanceIds: function(){
		return this.config.instanceIds;
	},
	
	getDisplayName: function (properties){
		return properties.instanceName;
	},
	
	getRequestParams:function(properties){		
		var params = {};
		params.action = "get";				
		params.url = this.getPORestPath(properties);
		return params;
	},
	
	getPORestPath: function(properties){
		var instanceIds;
		if(!!properties.instanceIds){
			instanceIds = properties.instanceIds;
			this.config.instanceIds = instanceIds;
		}
		else{
			instanceIds = this.config.instanceIds;
		}
		var branchId = properties.branchId;
		var snapshotId = properties.snapshotId;
		var documentId = properties.documentId;
		
		// /rest/bpm/wle/v1/visual/processModel/instances?instanceIds=[53,54,55]
		// /rest/bpm/wle/v1/visual/processModel/instance/{instanceId}
		var instanceIdsStr = "[" + instanceIds.toString() + "]";
		var url = "/v1/visual/processModel/instances" + "?instanceIds=" + instanceIdsStr;
		//params.showExecutionPath = true;
		//params.showCurrentActivites = true;
		//params.showNote = false;
		//params.showColor= false,
		var showExecutionPath = !!this.config.showExecutionPath ? this.config.showExecutionPath: true;
		var showCurrentActivites = !!this.config.showCurrentActivites ? this.config.showCurrentActivites: true;
		var showNote = !!this.config.showNote ? this.config.showNote: false;
		var showColor = !!this.config.showColor ? this.config.showColor: false;
		
		if (!!documentId){
			url = url + "&bpdId=" + documentId;
		}
		if (!!branchId){
			url = url + "&branchId=" + branchId;
		}
		else if(snapshotId){
			url = url + "&snapshotId=" + snapshotId;
		}
		url = url + "&showCurrentActivites=" + showCurrentActivites
						+ "&showExecutionPath="   + showExecutionPath
						+ "&showNote=" 			+ showNote
						+ "&showColor=" 		+ showColor; 
		return url;
	},

	/**
	 * Make more rest call or function call to retrive additional data and update the model
	 * @param model the data model 
	 * @param params, params passed in from event
	 */
	processResponseData : function(model, params) {
		this.updateModelForCriticalPath(model, params);
		if (!!this.config.additionalDataHandlers){
			for (var i=0; i<this.config.additionalDataHandlers.length; i++) {
				this.config.additionalDataHandlers[i](model, params.instanceIds, this.getDocumentId(params));
			}
		}
		return model;
	},
	
	updateModelForCriticalPath: function(data, params){
		//this.config.criticalPathFlowIds is set in the generateProcessInstanceIlog.jsp
		if (this.config.criticalPathFlowIds.length==0) {
			return data;
		}
		
		if (params.subProcParentId) {		
																
				com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance()._performRequest(
						"get", 
						com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_PROCESSPORTALSUPPORT) + "/jsp/criticalPath?action=GET_FLOWS&parentId=" + params.subProcParentId, 
						dojo.hitch(this, function(response) {
							this.updateLink(data, response);	
						}),
						null, 
						null, 
						true);
		} else {
			this.updateLink(data, this.config.criticalPathFlowIds);	
		} 

		return data; 
	},
	
	updateLink : function(data, flowIds) {
			for (var i=0; i<data["links"].length; i++) {
				var mylink = data["links"][i];
				if (this.isLinkInCriticalPath(flowIds, mylink.id)) {
					mylink["inCriticalPath"]=true;
				}
			}
	},
	
	isLinkInCriticalPath : function(criticalPathFlowIds, linkId) {
		for (var i=0; i<criticalPathFlowIds.length; i++) {
			if (linkId==criticalPathFlowIds[i]) {
				return true;
			}		
		}		
		return false;
	},

	getIconPath : function(size){
		//if(size == 16){
			//return "images/processes-16.png";
		//}
	},
		
	/**
	 * 
	 * @param model
	 * @param updateType the function supported by VisualModelHelper
	 * @param params
	 */
	updateModel: function(model, updateType, params){
		if (updateType == "decorateNodeWithImage"){		 
			com.ibm.bpm.wpd.document.model.VisualModelHelper.decorateNodesWithImage(model, params);
		}
	}
});

}


dojo.i18n._preloadLocalizations("com.ibm.bpm.nls.wpd_base", ["ROOT","ar","cs","da","de","el","en","es","fi","fr","he","he-il","hu","it","iw","iw-il","ja","ko","nb","nl","no","pl","pt","pt-br","ro","ru","sk","sv","tr","xx","zh","zh-tw"]);
